'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _backbone = require('backbone');

var _Follower = require('../models/Follower');

var _Follower2 = _interopRequireDefault(_Follower);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* Used for lists of followers and following */

var _class = function (_Collection) {
  _inherits(_class, _Collection);

  function _class() {
    var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, models, options));

    var types = ['followers', 'following'];
    if (types.indexOf(options.type) === -1) {
      throw new Error('Please provide a type as one of ' + types.join(', '));
    }

    if (!options.peerId) {
      throw new Error('Please provide a peerId');
    }

    _this.options = options;
    return _this;
  }

  _createClass(_class, [{
    key: 'model',
    value: function model(attrs, options) {
      return new _Follower2.default(attrs, options);
    }
  }, {
    key: 'modelId',
    value: function modelId(attrs) {
      return attrs.peerId;
    }
  }, {
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/' + (this.options.type === 'followers' ? 'followers' : 'following') + ('' + (_app2.default.profile.id === this.options.peerId ? '' : '/' + this.options.peerId)));
    }
  }, {
    key: 'parse',
    value: function parse(response) {
      return response.map(function (peerId) {
        return { peerId: peerId };
      });
    }
  }]);

  return _class;
}(_backbone.Collection);

exports.default = _class;