'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _backbone = require('backbone');

var _ListingShort = require('../models/listing/ListingShort');

var _ListingShort2 = _interopRequireDefault(_ListingShort);

var _Profile = require('../models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_Collection) {
  _inherits(_class, _Collection);

  function _class() {
    var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, models, options));
  }

  _createClass(_class, [{
    key: 'model',
    value: function model(attrs, options) {
      // models may be listings or profiles, use the appropriate one
      if (attrs.type === 'profile') {
        delete attrs.type;
        return new _Profile2.default(attrs, options);
      }
      delete attrs.type;
      return new _ListingShort2.default(attrs, _extends({}, options, {
        parse: true
      }));
    }
  }, {
    key: 'parse',
    value: function parse(response) {
      var parsedResponse = [];
      var resultsParent = response.results || {};
      var results = resultsParent.results || [];
      this.morePages = !!resultsParent.morePages;
      this.total = resultsParent.total || 0;

      results.forEach(function (result) {
        var updatedResult = result.data;
        updatedResult.type = result.type;
        var relationships = result.relationships || {};

        if (updatedResult.type === 'listing') {
          var vendor = relationships.vendor ? relationships.vendor.data : {};
          if (vendor) {
            vendor.guid = vendor.id;
            delete vendor.id;
          }
          updatedResult.vendor = vendor;
          updatedResult.moderators = relationships.moderators || [];
          parsedResponse.push(updatedResult);
        } else if (result.type === 'profile') {
          // only add if the results have a valid peerID
          if (updatedResult.peerID) {
            parsedResponse.push(updatedResult);
          }
        }
      });

      return parsedResponse;
    }
  }]);

  return _class;
}(_backbone.Collection);

exports.default = _class;