'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _backbone = require('backbone');

var _Transaction = require('../models/transaction/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _Case = require('../models/transaction/Case');

var _Case2 = _interopRequireDefault(_Case);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // used for sales, purchases and cases


var _class = function (_Collection) {
  _inherits(_class, _Collection);

  function _class() {
    var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      type: 'sales'
    }, options);

    var types = ['sales', 'purchases', 'cases'];

    if (types.indexOf(opts.type) === -1) {
      throw new Error('Type needs to be one of ' + types + '.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, models, opts));

    _this.type = opts.type;
    return _this;
  }

  _createClass(_class, [{
    key: 'model',
    value: function model(attrs) {
      var Md = attrs.caseId ? _Case2.default : _Transaction2.default;
      return new Md(attrs, { parse: true });
    }
  }, {
    key: 'modelId',
    value: function modelId(attrs) {
      return this.type === 'cases' ? attrs.caseId : attrs.orderId;
    }
  }, {
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/' + this.type);
    }
  }, {
    key: 'fetch',
    value: function fetch() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'fetch', this).call(this, _extends({
        type: 'POST',
        dataType: 'json',
        contentType: 'application/json'
      }, options, {
        data: JSON.stringify(options.data || {})
      }));
    }
  }, {
    key: 'parse',
    value: function parse(response) {
      return response[this.type] || [];
    }
  }]);

  return _class;
}(_backbone.Collection);

exports.default = _class;