'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _countries = require('../../data/countries');

var _2 = require('./');

var _currency = require('../../utils/currency');

var _cryptoListingCurrencies = require('../../data/cryptoListingCurrencies');

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

var _Metadata = require('./Metadata');

var _Metadata2 = _interopRequireDefault(_Metadata);

var _ShippingOptions = require('../../collections/listing/ShippingOptions.js');

var _ShippingOptions2 = _interopRequireDefault(_ShippingOptions);

var _Coupons = require('../../collections/listing/Coupons.js');

var _Coupons2 = _interopRequireDefault(_Coupons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class(attrs) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, attrs, options));

    _this.guid = options.guid;
    return _this;
  }

  _createClass(_class, [{
    key: 'url',
    value: function url() {
      // url is handled by sync, but backbone bombs if I don't have
      // something explicitly set
      return 'use-sync';
    }
  }, {
    key: 'defaults',
    value: function defaults() {
      return {
        termsAndConditions: '',
        refundPolicy: '',
        item: new _Item2.default(),
        metadata: new _Metadata2.default(),
        shippingOptions: new _ShippingOptions2.default(),
        coupons: new _Coupons2.default()
      };
    }
  }, {
    key: 'isNew',
    value: function isNew() {
      return !this.get('slug');
    }
  }, {
    key: 'cloneListing',


    /**
     * Returns a new instance of the listing with mostly identical attributes. Certain
     * attributes like slug and hash will be stripped since they are not appropriate
     * if this listing is being used as a template for a new listing. This differs from
     * clone() which will maintain identical attributes.
     */
    value: function cloneListing() {
      var clone = this.clone();
      clone.unset('slug');
      clone.unset('hash');
      clone.guid = this.guid;
      clone.lastSyncedAttrs = {};
      return clone;
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };
      var metadata = _extends({}, this.get('metadata').toJSON(), attrs.metadata);
      var contractType = metadata.contractType;
      var item = _extends({}, this.get('item').toJSON(), attrs.item);

      if (attrs.refundPolicy) {
        if (_is_js2.default.not.string(attrs.refundPolicy)) {
          addError('refundPolicy', 'The return policy must be of type string.');
        } else if (attrs.refundPolicy.length > this.max.refundPolicyLength) {
          addError('refundPolicy', _app2.default.polyglot.t('listingModelErrors.returnPolicyTooLong'));
        }
      }

      if (attrs.termsAndConditions) {
        if (_is_js2.default.not.string(attrs.termsAndConditions)) {
          addError('termsAndConditions', 'The terms and conditions must be of type string.');
        } else if (attrs.termsAndConditions.length > this.max.termsAndConditionsLength) {
          addError('termsAndConditions', _app2.default.polyglot.t('listingModelErrors.termsAndConditionsTooLong'));
        }
      }

      if (contractType === 'PHYSICAL_GOOD') {
        if (!attrs.shippingOptions.length) {
          addError('shippingOptions', _app2.default.polyglot.t('listingModelErrors.provideShippingOption'));
        }
      }

      if (contractType === 'CRYPTOCURRENCY') {
        if (!metadata || !metadata.coinType || typeof metadata.coinType !== 'string') {
          addError('metadata.coinType', 'The coin type must be provided as a string.');
        }

        if (metadata && typeof metadata.pricingCurrency !== 'undefined') {
          addError('metadata.pricingCurrency', 'The pricing currency should not be set on ' + 'cryptocurrency listings.');
        }

        if (item && typeof item.price !== 'undefined') {
          addError('item.price', 'The price should not be set on cryptocurrency ' + 'listings.');
        }

        if (item && typeof item.condition !== 'undefined') {
          addError('item.condition', 'The condition should not be set on cryptocurrency ' + 'listings.');
        }

        if (item && typeof item.quantity !== 'undefined') {
          addError('item.quantity', 'The quantity should not be set on cryptocurrency ' + 'listings.');
        }
      } else {
        if (item && typeof item.cryptoQuantity !== 'undefined') {
          addError('item.cryptoQuantity', 'The cryptoQuantity should only be set on cryptocurrency ' + 'listings.');
        }
      }

      if (attrs.coupons.length > this.max.couponCount) {
        addError('coupons', _app2.default.polyglot.t('listingModelErrors.tooManyCoupons', { maxCouponCount: this.max.couponCount }));
      }

      errObj = this.mergeInNestedErrors(errObj);

      if (contractType === 'CRYPTOCURRENCY') {
        // Remove the validation of certain fields that should not be set for
        // cryptocurrency listings.
        delete errObj['metadata.pricingCurrency'];
        delete errObj['item.price'];
        delete errObj['item.condition'];
        delete errObj['item.quantity'];
      } else {
        delete errObj['item.cryptoQuantity'];
      }

      // Coupon price discount cannot exceed the item price.
      attrs.coupons.forEach(function (coupon) {
        var priceDiscount = coupon.get('priceDiscount');

        if (typeof priceDiscount !== 'undefined' && priceDiscount >= attrs.item.get('price')) {
          addError('coupons[' + coupon.cid + '].priceDiscount', _app2.default.polyglot.t('listingModelErrors.couponsPriceTooLarge'));
        }
      });

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'sync',
    value: function sync(method, model, options) {
      var _this2 = this;

      var returnSync = 'will-set-later';

      if (method === 'read') {
        if (!this.guid) {
          throw new Error('In order to fetch a listing, a guid must be set on the model instance.');
        }

        var slug = this.get('slug');

        if (!slug) {
          throw new Error('In order to fetch a listing, a slug must be set as a model attribute.');
        }

        if (this.isOwnListing) {
          options.url = options.url || _app2.default.getServerUrl('ob/listing/' + slug);
        } else {
          options.url = options.url || _app2.default.getServerUrl('ob/listing/' + this.guid + '/' + slug);
        }
      } else {
        if (method !== 'delete') {
          options.url = options.url || _app2.default.getServerUrl('ob/listing/');
          // it's a create or update
          options.attrs = options.attrs || this.toJSON();

          // convert price fields
          if (options.attrs.item.price) {
            var price = options.attrs.item.price;
            options.attrs.item.price = (0, _currency.decimalToInteger)(price, options.attrs.metadata.pricingCurrency);
          }

          options.attrs.shippingOptions.forEach(function (shipOpt) {
            shipOpt.services.forEach(function (service) {
              if (typeof service.price === 'number') {
                service.price = (0, _currency.decimalToInteger)(service.price, options.attrs.metadata.pricingCurrency);
              }

              if (typeof service.additionalItemPrice === 'number') {
                service.additionalItemPrice = (0, _currency.decimalToInteger)(service.additionalItemPrice, options.attrs.metadata.pricingCurrency);
              }
            });
          });

          options.attrs.coupons.forEach(function (coupon) {
            if (typeof coupon.priceDiscount === 'number') {
              coupon.priceDiscount = (0, _currency.decimalToInteger)(coupon.priceDiscount, options.attrs.metadata.pricingCurrency);
            }
          });

          var baseUnit = options.attrs.metadata.coinDivisibility = options.attrs.metadata.coinDivisibility || _cryptoListingCurrencies.defaultQuantityBaseUnit;

          if (options.attrs.metadata.contractType === 'CRYPTOCURRENCY') {
            // round to ensure integer
            options.attrs.item.cryptoQuantity = Math.round(options.attrs.item.cryptoQuantity * baseUnit);

            // Don't send over the price on crypto listings.
            delete options.attrs.price;
          }
          // END - convert price fields

          // If providing a quanitity and / or productID on the Item and not
          // providing any SKUs, then we'll send item.quantity and item.productID
          // in as a "dummy" SKU (as the server expects). If you are providing any
          // SKUs, then item.quantity and item.productID will be ignored.
          if (!options.attrs.item.skus.length) {
            var dummySku = {};

            if (options.attrs.metadata.contractType === 'CRYPTOCURRENCY') {
              dummySku.quantity = options.attrs.item.cryptoQuantity;
            } else if (typeof options.attrs.item.quantity === 'number') {
              dummySku.quantity = options.attrs.item.quantity;
            }

            if (typeof options.attrs.item.productID === 'string' && options.attrs.item.productID.length) {
              dummySku.productID = options.attrs.item.productID;
            }

            if (Object.keys(dummySku).length) {
              options.attrs.item.skus = [dummySku];
            }
          } else {
            options.attrs.item.skus.forEach(function (sku) {
              if (typeof sku.surcharge === 'number') {
                sku.surcharge = (0, _currency.decimalToInteger)(sku.surcharge, options.attrs.metadata.pricingCurrency);
              }
            });
          }

          delete options.attrs.item.productID;
          delete options.attrs.item.quantity;

          // Our Sku has an infinteInventory boolean attribute, but the server
          // is expecting a quantity negative quantity in that case.
          options.attrs.item.skus.forEach(function (sku) {
            if (sku.infiniteInventory) {
              sku.quantity = -1;
            }

            delete sku.infiniteInventory;
          });

          // remove the hash
          delete options.attrs.hash;

          // If all countries are individually provided as shipping regions, we'll send
          // 'ALL' to the server.
          options.attrs.shippingOptions.forEach(function (shipOpt) {
            if (_underscore2.default.isEqual(Object.keys((0, _countries.getIndexedCountries)()), shipOpt.regions)) {
              shipOpt.regions = ['ALL'];
            }
          });
        } else {
          options.url = options.url || _app2.default.getServerUrl('ob/listing/' + this.get('slug'));
        }
      }

      returnSync = _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'sync', this).call(this, method, model, options);

      var eventOpts = {
        xhr: returnSync,
        url: options.url
      };

      if (method === 'create' || method === 'update') {
        var attrsBeforeSync = this.lastSyncedAttrs;

        returnSync.done(function (data) {
          var hasChanged = function hasChanged() {
            return !_underscore2.default.isEqual(attrsBeforeSync, _this2.toJSON());
          };

          if (data.slug) {
            _this2.set('slug', data.slug);
          }

          _2.events.trigger('saved', _this2, _extends({}, eventOpts, {
            created: method === 'create',
            slug: _this2.get('slug'),
            prev: attrsBeforeSync,
            hasChanged: hasChanged
          }));
        });
      } else if (method === 'delete') {
        _2.events.trigger('destroying', this, _extends({}, eventOpts, {
          slug: this.get('slug')
        }));

        returnSync.done(function () {
          _2.events.trigger('destroy', _this2, _extends({}, eventOpts, {
            slug: _this2.get('slug')
          }));
        });
      }

      return returnSync;
    }
  }, {
    key: 'parse',
    value: function parse(response) {
      this.unparsedResponse = JSON.parse(JSON.stringify(response)); // deep clone
      var parsedResponse = response.listing;

      if (parsedResponse) {
        var isCrypto = parsedResponse.metadata && parsedResponse.metadata.contractType === 'CRYPTOCURRENCY';

        // set the hash
        parsedResponse.hash = response.hash;

        // convert price fields
        if (parsedResponse.item) {
          var price = parsedResponse.item.price;
          var cur = parsedResponse.metadata && parsedResponse.metadata.pricingCurrency;

          if (price) {
            parsedResponse.item.price = (0, _currency.integerToDecimal)(price, cur);
          }
        }

        if (parsedResponse.shippingOptions && parsedResponse.shippingOptions.length) {
          parsedResponse.shippingOptions.forEach(function (shipOpt, shipOptIndex) {
            if (shipOpt.services && shipOpt.services.length) {
              shipOpt.services.forEach(function (service, serviceIndex) {
                var price = service.price;
                var cur = parsedResponse.metadata && parsedResponse.metadata.pricingCurrency;

                if (typeof price === 'number') {
                  parsedResponse.shippingOptions[shipOptIndex].services[serviceIndex].price = (0, _currency.integerToDecimal)(price, cur);
                } else {
                  // This is necessary because of this bug:
                  // https://github.com/OpenBazaar/openbazaar-go/issues/178
                  parsedResponse.shippingOptions[shipOptIndex].services[serviceIndex].price = 0;
                }

                var price2 = service.additionalItemPrice;
                if (typeof price2 === 'number') {
                  parsedResponse.shippingOptions[shipOptIndex].services[serviceIndex].additionalItemPrice = (0, _currency.integerToDecimal)(price2, cur);
                } else {
                  // This is necessary because of this bug:
                  // https://github.com/OpenBazaar/openbazaar-go/issues/178
                  parsedResponse.shippingOptions[shipOptIndex].services[serviceIndex].additionalItemPrice = 0;
                }
              });
            }

            // If the shipping regions are set to 'ALL', we'll replace with a list of individual
            // countries, which is what our UI is designed to work with.
            if (shipOpt.regions && shipOpt.regions.length && shipOpt.regions[0] === 'ALL') {
              parsedResponse.shippingOptions[shipOptIndex].regions = Object.keys((0, _countries.getIndexedCountries)());
            }
          });
        }

        if (parsedResponse.coupons && parsedResponse.coupons.length) {
          parsedResponse.coupons.forEach(function (coupon, couponIndex) {
            if (typeof coupon.priceDiscount === 'number') {
              var _price = parsedResponse.coupons[couponIndex].priceDiscount;
              var _cur = parsedResponse.metadata && parsedResponse.metadata.pricingCurrency;

              parsedResponse.coupons[couponIndex].priceDiscount = (0, _currency.integerToDecimal)(_price, _cur);
            }
          });
        }

        // Re-organize variant structure so a "dummy" SKU (if present) has its quanitity
        // and productID moved to be attributes of the Item model
        if (parsedResponse.item && parsedResponse.item.skus && parsedResponse.item.skus.length === 1 && typeof parsedResponse.item.skus[0].variantCombo === 'undefined') {
          var dummySku = parsedResponse.item.skus[0];

          if (isCrypto) {
            parsedResponse.item.cryptoQuantity = dummySku.quantity / parsedResponse.metadata.coinDivisibility;
          } else {
            parsedResponse.item.quantity = dummySku.quantity;
          }

          parsedResponse.item.productID = dummySku.productID;
        }

        if (parsedResponse.item && parsedResponse.item.skus) {
          parsedResponse.item.skus.forEach(function (sku) {
            // If a sku quantity is set to less than 0, we'll set the
            // infinite inventory flag.
            if (sku.quantity < 0) {
              sku.infiniteInventory = true;
            } else {
              sku.infiniteInventory = false;
            }
            // convert the surcharge
            var surcharge = sku.surcharge;
            var cur = parsedResponse.metadata && parsedResponse.metadata.pricingCurrency;

            if (surcharge) {
              sku.surcharge = (0, _currency.integerToDecimal)(surcharge, cur);
            }
          });
          // END - convert price fields
        }
      }

      return parsedResponse;
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        item: _Item2.default,
        metadata: _Metadata2.default,
        shippingOptions: _ShippingOptions2.default,
        coupons: _Coupons2.default
      };
    }
  }, {
    key: 'shipsFreeToMe',
    get: function get() {
      return (0, _2.shipsFreeToMe)(this);
    }
  }, {
    key: 'max',
    get: function get() {
      return {
        refundPolicyLength: 10000,
        termsAndConditionsLength: 10000,
        couponCount: 30
      };
    }
  }, {
    key: 'isOwnListing',
    get: function get() {
      if (this.guid === undefined) {
        throw new Error('Unable to determine ownListing ' + 'because a guid has not been set on this model.');
      }

      return _app2.default.profile.id === this.guid;
    }
  }, {
    key: 'isCrypto',
    get: function get() {
      return this.get('metadata').get('contractType') === 'CRYPTOCURRENCY';
    }
  }, {
    key: 'price',
    get: function get() {
      if (this.isCrypto) {
        return {
          amount: 1,
          currencyCode: this.get('metadata').get('coinType')
        };
      }

      return {
        amount: this.get('item').get('price'),
        currencyCode: this.get('metadata').get('pricingCurrency')
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;