'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _ = require('./');

var _currency = require('../../utils/currency');

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        freeShipping: []
      };
    }

    // Needed so this.destroy() will work, since it's
    // a no-op on new models.

  }, {
    key: 'isNew',
    value: function isNew() {
      return false;
    }
  }, {
    key: 'shipsTo',
    value: function shipsTo(country) {
      if (!country) {
        throw new Error('Please provide a country.');
      }

      return this.get('shipsTo').indexOf(country) !== -1;
    }
  }, {
    key: 'parse',
    value: function parse(response) {
      var parsedResponse = _extends({}, response);

      parsedResponse.categories = Array.isArray(parsedResponse.categories) ? parsedResponse.categories : [];

      if (parsedResponse.contractType === 'CRYPTOCURRENCY') {
        parsedResponse.price = _extends({}, parsedResponse.price, {
          amount: 1,
          currencyCode: parsedResponse.coinType
        });

        if (parsedResponse.totalInventoryQuantity >= 0 && parsedResponse.coinDivisibility > 0) {
          parsedResponse.totalInventoryQuantity = parsedResponse.totalInventoryQuantity / parsedResponse.coinDivisibility;
        } else {
          // If they're not providing a inventory of 0 or more or a coinDivisibility > 0,
          // we won't display the inventory since it's an invalid value or one we can't
          // represent properly.
          delete parsedResponse.totalInventoryQuantity;
        }
      } else {
        var priceObj = parsedResponse.price;
        parsedResponse.price = _extends({}, priceObj, {
          amount: (0, _currency.integerToDecimal)(priceObj.amount, priceObj.currencyCode)
        });
      }

      return parsedResponse;
    }
  }, {
    key: 'sync',
    value: function sync(method, model, options) {
      var _this2 = this;

      var returnSync = 'will-set-later';

      if (method === 'delete') {
        options.url = options.url || _app2.default.getServerUrl('ob/listing/' + this.get('slug'));
      }

      returnSync = _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'sync', this).call(this, method, model, options);

      var eventOpts = {
        xhr: returnSync,
        url: options.url,
        slug: this.get('slug')
      };

      if (method === 'delete') {
        _.events.trigger('destroying', this, eventOpts);

        returnSync.done(function () {
          _.events.trigger('destroy', _this2, eventOpts);
        });
      }

      return returnSync;
    }
  }, {
    key: 'shipsFreeToMe',
    get: function get() {
      return (0, _.shipsFreeToMe)(this);
    }
  }, {
    key: 'isCrypto',
    get: function get() {
      return this.get('contractType') === 'CRYPTOCURRENCY';
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;