'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        productID: '',
        infiniteInventory: false,
        quantity: 0,
        surcharge: 0
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};

      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (attrs.productID.length > this.max.productIdLength) {
        addError('productID', 'The productID cannot exceed ' + this.max.productIdLength + ' characters.');
      }

      if (attrs.quantity === '' && !attrs.infiniteInventory) {
        addError('quantity', _app2.default.polyglot.t('skuModelErrors.provideQuantity'));
      }

      if (typeof attrs.infiniteInventory !== 'undefined' && typeof attrs.infiniteInventory !== 'boolean') {
        addError('infiniteInventory', 'If provided, infiniteInventory should be a boolean.');
      }

      if (attrs.quantity !== '') {
        if (typeof attrs.quantity !== 'number') {
          addError('quantity', _app2.default.polyglot.t('skuModelErrors.provideNumericQuantity'));
        } else if (!attrs.infiniteInventory && attrs.quantity < 0) {
          // The listing API allows the quantity to be set to < 0, which indicates an unlimited
          // supply. This model does not allow that, but does have an infiniteInventory flag.
          // The expectation is that sync / parse of the listing model will send the quantity
          // over as -1 if the infiniteInventory flag is set to true. Also the infiniteInventory
          // flag should not be sent to the server.

          addError('quantity', _app2.default.polyglot.t('skuModelErrors.providePositiveQuantity'));
        }
      }

      if (attrs.surcharge === '') {
        addError('surcharge', _app2.default.polyglot.t('skuModelErrors.provideSurcharge'));
      } else if (typeof attrs.surcharge !== 'number') {
        addError('surcharge', _app2.default.polyglot.t('skuModelErrors.provideNumericSurcharge'));
      }

      // The listing API does not require a variantCombo field, since if you have no options and
      // want to assign a quantity and / or productId to an Item you would create a "dummy" Sku object
      // and set the values there. That seems like a bit of a klunky way to do it, so the client will
      // not allow such a dummy SKU. Instead, the Item model will allow quantity and productId fields
      // and convert them to / from a dummy SKU in sync / parse.
      if (!_is_js2.default.array(attrs.variantCombo)) {
        addError('variantCombo', 'A variantCombo field must be provided and must be an array.');
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'max',
    get: function get() {
      return {
        productIdLength: 40
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;