'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('../../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        review: ''
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};

      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      var constraints = this.constraints;

      if (typeof attrs.anonymous !== 'boolean') {
        addError('anonymous', 'anonymous must be a boolean.');
      }

      if (typeof attrs.review !== 'string') {
        addError('review', 'A review must be provided as a string.');
      } else if (!attrs.review) {
        addError('review', _app2.default.polyglot.t('orderCompletionModelErrors.provideReview'));
      } else if (attrs.review.length > constraints.maxReviewCharacters) {
        addError('review', 'The review exceeds the maximum length of ' + constraints.maxReviewCharacters + ' characters.');
      }

      var ratingFields = ['overall', 'quality', 'description', 'deliverySpeed', 'customerService'];

      ratingFields.forEach(function (ratingField) {
        if (typeof attrs[ratingField] === 'undefined') {
          addError(ratingField, _app2.default.polyglot.t('orderCompletionModelErrors.provideRating'));
        } else if (typeof attrs[ratingField] !== 'number') {
          addError(ratingField, ratingField + ' must be provided as a number.');
        } else if (attrs[ratingField] < constraints.minRatingValue || attrs[ratingField] > constraints.maxRatingValue) {
          addError(ratingField, ratingField + ' must be a number between ' + constraints.minRatingValue + ' ' + ('and ' + constraints.maxRatingValue + '.'));
        }
      });

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'constraints',
    get: function get() {
      return {
        minRatingValue: 1,
        maxRatingValue: 5,
        maxReviewCharacters: 3000
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;