'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _Fee = require('./Fee');

var _Fee2 = _interopRequireDefault(_Fee);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        fee: new _Fee2.default(),
        description: '',
        termsAndConditions: '',
        languages: []
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var opts = _extends({
        validateRequiredFields: true
      }, options || {});
      var errObj = this.mergeInNestedErrors({});
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };
      var max = this.max;

      if (!attrs.description) {
        if (opts.validateRequiredFields) {
          addError('description', _app2.default.polyglot.t('moderatorModelErrors.noDescription'));
        }
      } else if (attrs.description.length > max.descriptionLength) {
        addError('description', _app2.default.polyglot.t('moderatorModelErrors.descriptionLength'));
      }

      if (!attrs.termsAndConditions) {
        if (opts.validateRequiredFields) {
          addError('termsAndConditions', _app2.default.polyglot.t('moderatorModelErrors.noTerms'));
        }
      } else if (attrs.termsAndConditions.length > max.termsLength) {
        addError('termsAndConditions', _app2.default.polyglot.t('moderatorModelErrors.termsLength'));
      }

      if (!Array.isArray(attrs.languages)) {
        addError('languages', 'Languages must be provided as an array.');
      } else if (!attrs.languages.length) {
        if (opts.validateRequiredFields) {
          addError('languages', _app2.default.polyglot.t('moderatorModelErrors.noLanguages'));
        }
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        fee: _Fee2.default
      };
    }
  }, {
    key: 'max',
    get: function get() {
      return {
        descriptionLength: 300,
        termsLength: 10000
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;