'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.getCachedProfiles = getCachedProfiles;

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _serverConnect = require('../../utils/serverConnect');

var _currency = require('../../utils/currency');

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

var _Moderator = require('./Moderator');

var _Moderator2 = _interopRequireDefault(_Moderator);

var _Colors = require('./Colors');

var _Colors2 = _interopRequireDefault(_Colors);

var _Contact = require('./Contact');

var _Contact2 = _interopRequireDefault(_Contact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Profile = function (_BaseModel) {
  _inherits(Profile, _BaseModel);

  function Profile() {
    _classCallCheck(this, Profile);

    return _possibleConstructorReturn(this, (Profile.__proto__ || Object.getPrototypeOf(Profile)).apply(this, arguments));
  }

  _createClass(Profile, [{
    key: 'defaults',
    value: function defaults() {
      return {
        about: '',
        handle: '',
        location: '',
        moderator: false,
        name: 'OB ' + (Math.floor(Math.random() * 2116316159) + 60466176).toString(36),
        nsfw: false,
        shortDescription: '',
        avatarHashes: new _Image2.default(),
        headerHashes: new _Image2.default(),
        vendor: true,
        colors: new _Colors2.default(),
        contactInfo: new _Contact2.default(),
        stats: new _BaseModel3.default()
      };
    }
  }, {
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/profile/' + this.id);
    }

    // todo: set peerId instead of ID when setting ID.

  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = this.mergeInNestedErrors();
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (!attrs.name) {
        addError('name', _app2.default.polyglot.t('profileModelErrors.provideName'));
      }

      if (attrs.handle && attrs.handle.charAt(0) === '@') {
        addError('handle', 'The handle should not start with a leading @.');
      }

      if (attrs.location && attrs.location.length > this.max.locationLength) {
        addError('location', _app2.default.polyglot.t('profileModelErrors.locationTooLong'));
      }

      if (typeof attrs.vendor !== 'boolean') {
        // this error should never be visible to the user
        addError('vendor', 'The vendor value is not a boolean: ' + attrs.vendor);
      }

      if (typeof attrs.shortDescription !== 'string') {
        addError('shortDescription', 'The shortDescription must be provided as a string.');
      } else if (attrs.shortDescription > this.max.shortDescriptionLength) {
        addError('shortDescription', _app2.default.polyglot.t('profileModelErrors.shortDescriptionTooLong', { count: this.max.shortDescriptionLength }));
      }

      // We'll delete the moderatorInfo errors, because we'll revalidate below passing
      // in the appropriate flag on whether required fields should be validated.
      Object.keys(errObj).forEach(function (key) {
        if (key.startsWith('moderatorInfo')) delete errObj[key];
      });

      if (attrs.moderatorInfo instanceof _Moderator2.default) {
        var validateRequiredFields = !!this.get('moderator');
        var errs = attrs.moderatorInfo.isValid({ validateRequiredFields: validateRequiredFields }) ? {} : attrs.moderatorInfo.validationError;
        Object.keys(errs).forEach(function (key) {
          return errObj['moderatorInfo.' + key] = errs[key];
        });
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }

    // Ensure any colors are strings and have a leading hash.

  }, {
    key: 'standardizeColorFields',
    value: function standardizeColorFields() {
      var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var updatedAttrs = _extends({}, attrs);

      Object.keys(attrs).forEach(function (field) {
        if (typeof attrs[field] !== 'undefined') {
          updatedAttrs[field] = updatedAttrs[field].toString();
          updatedAttrs[field] = updatedAttrs[field].charAt(0) !== '#' ? '#' + updatedAttrs[field] : updatedAttrs[field];
        }
      });

      return updatedAttrs;
    }
  }, {
    key: 'parse',
    value: function parse(resp) {
      var response = _extends({}, resp);

      if (response.moderatorInfo && response.moderatorInfo.fee && response.moderatorInfo.fee.fixedFee) {
        var amount = response.moderatorInfo.fee.fixedFee.amount;
        var cur = response.moderatorInfo.fee.fixedFee.currencyCode;

        response.moderatorInfo.fee.fixedFee.amount = (0, _currency.integerToDecimal)(amount, cur);
      }

      if (response.handle && response.handle.startsWith('@')) {
        response.handle = response.handle.slice(1);
      }

      if (response.colors) {
        response.colors = this.standardizeColorFields(response.colors);
      }

      if (response.avatarHashes === null) {
        delete response.avatarHashes;
      }

      if (response.headerHashes === null) {
        delete response.headerHashes;
      }

      return response;
    }
  }, {
    key: 'sync',
    value: function sync(method, model, options) {
      // the server doesn't want the id field
      options.attrs = options.attrs || model.toJSON(options);
      delete options.attrs.id;

      // ensure certain fields that shouldn't be updated don't go
      // to the server
      if (method !== 'read') {
        delete options.attrs.lastModified;

        if (options.attrs.stats) delete options.attrs.stats;

        var images = [options.attrs.avatarHashes, options.attrs.headerHashes];
        images.forEach(function (imageHashes) {
          if ((typeof imageHashes === 'undefined' ? 'undefined' : _typeof(imageHashes)) === 'object') {
            // If the image models are still in their default state (all images hashes as empty
            // strings), we won't send over the image to the server, since it will fail validation.
            if (Object.keys(imageHashes).filter(function (key) {
              return imageHashes[key] === '';
            }).length === Object.keys(imageHashes).length) {
              if (imageHashes === options.attrs.avatarHashes) {
                delete options.attrs.avatarHashes;
              } else {
                delete options.attrs.headerHashes;
              }
            }
          }
        });

        if (method !== 'delete') {
          // convert the amount field
          if (options.attrs.moderatorInfo && options.attrs.moderatorInfo.fee && options.attrs.moderatorInfo.fee.fixedFee && options.attrs.moderatorInfo.fee.fixedFee.amount) {
            var amount = options.attrs.moderatorInfo.fee.fixedFee.amount;
            var cur = options.attrs.moderatorInfo.fee.fixedFee.currencyCode;
            options.attrs.moderatorInfo.fee.fixedFee.amount = (0, _currency.decimalToInteger)(amount, cur);
          }
        }
      }

      if (method !== 'create' && !this.get('peerID')) {
        throw new Error('I am unable to fetch, save or delete because the model does not' + ' have a peerID set.');
      }

      return _get(Profile.prototype.__proto__ || Object.getPrototypeOf(Profile.prototype), 'sync', this).call(this, method, model, options);
    }
  }, {
    key: 'idAttribute',
    get: function get() {
      return 'peerID';
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        avatarHashes: _Image2.default,
        headerHashes: _Image2.default,
        moderatorInfo: _Moderator2.default,
        colors: _Colors2.default,
        contactInfo: _Contact2.default,
        stats: _BaseModel3.default
      };
    }
  }, {
    key: 'isModerator',
    get: function get() {
      return this.get('moderator') && !!this.get('moderatorInfo');
    }
  }, {
    key: 'max',
    get: function get() {
      return {
        locationLength: 100,
        shortDescriptionLength: 160
      };
    }
  }]);

  return Profile;
}(_BaseModel3.default);

exports.default = Profile;


var maxCachedProfiles = 500;
var profileCacheExpires = 1000 * 60 * 60;
var profileCache = new Map();
var profileCacheExpiredInterval = void 0;

function expireCachedProfile(peerId) {
  if (!peerId) {
    throw new Error('Please provide a peerId');
  }

  var cached = profileCache.get(peerId);

  if (cached) {
    cached.deferred.reject({
      errCode: 'TIMED_OUT',
      error: 'The profile fetch timed out.'
    });
  }

  profileCache.delete(peerId);
}

/**
 * This function will fetch a list of profiles via the profiles api utilizing
 * the async and usecache flags. It will return a list of promises that will
 * each resolve when their respective profile arrives via socket.
 * @param {Array} peerIds List of peerId for whose profiles to fetch.
 * @returns {Array} An array of promises corresponding to the array of passed
 * in peerIds. Each promise will resolve when it's respective profile is received
 * via the socket. A profile model will be passed in the resolve handler.
 */
function getCachedProfiles() {
  var peerIds = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  if (!Array.isArray(peerIds)) {
    throw new Error('Please provide a list of peerIds.');
  }

  if (!peerIds.length) {
    throw new Error('Please provide at least one peerId.');
  }

  peerIds.forEach(function (id) {
    if (typeof id !== 'string') {
      throw new Error('One or more of the provided peerIds are not strings.');
    }
  });

  var promises = [];
  var profilesToFetch = [];
  var socket = void 0;

  if (!profileCacheExpiredInterval) {
    // Check every few minutes and clean up any expired cached profiles
    profileCacheExpiredInterval = setInterval(function () {
      profileCache.forEach(function (cached, key) {
        if (Date.now() - cached.createdAt >= profileCacheExpires) {
          expireCachedProfile(key);
        }
      });
    }, 1000 * 60 * 5);
  }

  peerIds.forEach(function (id) {
    var cached = profileCache.get(id);

    // make sure it's not expired
    if (cached && Date.now() - cached.createdAt >= profileCacheExpires) {
      expireCachedProfile(id);
      cached = null;
    }

    if (!cached) {
      // if cache is full, remove the oldest entry to make room for the new one
      var keys = Array.from(profileCache.keys());
      if (keys.length >= maxCachedProfiles) {
        var cachedItemToRemove = profileCache.get(keys[0]);
        // The deferred has almost certainly long been resolved, but just in case
        // it's still pending, we'll reject it.
        cachedItemToRemove.deferred.reject({
          errCode: 'CACHE_FULL',
          error: 'Entry removed because cache was full.'
        });
        profileCache.delete(keys[0]);
      }

      var deferred = _jquery2.default.Deferred();
      profileCache.set(id, {
        deferred: deferred,
        createdAt: Date.now()
      });
      profilesToFetch.push(id);
    }

    var promise = profileCache.get(id).deferred.promise();

    promise.fail(function () {
      // If the promise fails for any reason, remove it from the cache.
      profileCache.delete(id);
    });

    promises.push(promise);
  });

  if (profilesToFetch.length) {
    _jquery2.default.post({
      url: _app2.default.getServerUrl('ob/fetchprofiles?async=true&usecache=true'),
      data: JSON.stringify(profilesToFetch),
      dataType: 'json',
      contentType: 'application/json'
    }).done(function () {
      socket = (0, _serverConnect.getSocket)();

      if (!socket) {
        promises.forEach(function (promise) {
          promise.reject({
            errCode: 'NO_SERVER_CONNECTION',
            error: 'There is no server connection.'
          });
        });

        return;
      }

      var onSocketMessage = function onSocketMessage(e) {
        if (!(e.jsonData.peerId && (e.jsonData.profile || e.jsonData.error))) return;

        if (profileCache.get(e.jsonData.peerId)) {
          if (e.jsonData.error) {
            profileCache.get(e.jsonData.peerId).deferred.reject({
              errCode: 'SERVER_ERROR',
              error: e.jsonData.error
            });
          } else {
            profileCache.get(e.jsonData.peerId).deferred.resolve(new Profile(e.jsonData.profile, { parse: true }));
          }
        }
      };

      socket.on('message', onSocketMessage);
    }).fail(function (jqXhr) {
      promises.forEach(function (promise) {
        promise.reject({
          errCode: 'SERVER_ERROR',
          error: jqXhr.responseJSON && jqXhr.responseJSON.reason || ''
        });
      });
    });
  }

  return promises;
}