'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _Items = require('../../collections/purchase/Items');

var _Items2 = _interopRequireDefault(_Items);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class(attrs) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, attrs, options));

    _this.shippable = options.shippable || false;
    _this.moderated = options.moderated || false;
    return _this;
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        // if the listing is not physical, the address and shipping attributes should be blank
        shipTo: '',
        address: '',
        city: '',
        state: '',
        postalCode: '',
        countryCode: '',
        addressNotes: '',
        moderator: '',
        items: new _Items2.default(),
        alternateContactInfo: ''
      };
    }
  }, {
    key: 'addAddress',


    // this will convert and set an address from the settings
    value: function addAddress(sAddr) {
      if (!sAddr) throw new Error('You must provide a valid address object.');

      var company = sAddr.get('company');
      var shipTo = '' + sAddr.get('name') + (company ? ', ' + company : '');
      var address = sAddr.get('addressLineOne') + ' ' + sAddr.get('addressLineTwo');
      var city = sAddr.get('city');
      var state = sAddr.get('state');
      var postalCode = sAddr.get('postalCode');
      var countryCode = sAddr.get('country');
      var addressNotes = sAddr.get('addressNotes');
      this.set({ shipTo: shipTo, address: address, city: city, state: state, postalCode: postalCode, countryCode: countryCode, addressNotes: addressNotes });
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = this.mergeInNestedErrors({});
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (!attrs.items.length) {
        addError('items', 'At least one item is required.');
      }

      if (this.shippable && !attrs.shipTo && !attrs.countryCode) {
        addError('shipping', _app2.default.polyglot.t('orderModelErrors.missingAddress'));
      }

      if (this.moderated && !attrs.moderator && attrs.moderator !== undefined) {
        addError('moderated', _app2.default.polyglot.t('orderModelErrors.needsModerator'));
      }

      if (!this.moderated && attrs.moderator) {
        // this should only happen if there is a developer error
        addError('moderated', _app2.default.polyglot.t('orderModelErrors.removeModerator'));
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        items: _Items2.default
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;