'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _currency = require('../../utils/currency');

var _cryptoCurrencies = require('../../data/cryptoCurrencies');

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        confirmations: 0,
        height: 0,
        feeBumped: false,
        allowFeeBump: false,
        memo: ''
      };
    }
  }, {
    key: 'set',
    value: function set(key, val) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      // Handle both `"key", value` and `{key: value}` -style arguments.
      var attrs = void 0;
      var opts = options;

      if ((typeof key === 'undefined' ? 'undefined' : _typeof(key)) === 'object') {
        attrs = key;
        opts = val;
      } else {
        (attrs = {})[key] = val;
      }

      if (attrs.confirmations !== this.attributes.confirmations || attrs.timestamp !== this.attributes.timestamp || attrs.height !== this.attributes.height) {
        var confirmations = attrs.confirmations === undefined ? this.attributes.confirmations : attrs.confirmations;
        var timestamp = attrs.timestamp === undefined ? this.attributes.timestamp : attrs.timestamp;
        var height = attrs.height === undefined ? this.attributes.height : attrs.height;
        var stuckTime = 1000 * 60 * 60 * 6; // 6 hours

        if (height === -1) {
          attrs.status = 'DEAD';
        } else if (confirmations === 0 && Date.now() - new Date(timestamp).getTime() <= stuckTime) {
          attrs.status = 'UNCONFIRMED';
        } else if (confirmations === 0 && Date.now() - new Date(timestamp).getTime() > stuckTime) {
          attrs.status = 'STUCK';
          attrs.allowFeeBump = !attrs.feeBumped && attrs.value > 0 && typeof (0, _cryptoCurrencies.getServerCurrency)().feeBumpTransactionSize === 'number';
        } else if (confirmations > 0 && confirmations <= 5) {
          attrs.status = 'PENDING';
        } else if (confirmations > 5) {
          attrs.status = 'CONFIRMED';
        }
      }

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'set', this).call(this, attrs, opts);
    }
  }, {
    key: 'parse',
    value: function parse() {
      var response = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var returnVal = _extends({}, response);

      // The client will in set() manage the status attribute. The reason is that
      // this is dependant on the confirmation count which is
      // updated on the client side based on block height obtained from the walletUpdate
      // socket. This allows us to centralize the logic and avoid having the client match
      // the logic of the server (which is relatively arbitrary).
      delete returnVal.status;

      if (returnVal.transactions) {
        // this response is coming from the collection, we'll
        // do nothing and let the collection handle it.
      } else {
        if (returnVal.memo && returnVal.memo.startsWith('Fee bump of ')) {
          returnVal.translatedMemo = _app2.default.polyglot.t('wallet.transactions.transaction.feeBumpOf', { address: returnVal.memo.slice(12) });
        }

        // The UI has more stringent logic to determine when fee bumping is possible. This model will
        // provide a allowFeeBump flag to indicate when it's allowed. The canBumpFee flag from the
        // server is just used to determine whether the fee was already bumped or not.
        returnVal.feeBumped = returnVal.value > 0 && !returnVal.canBumpFee;
        delete returnVal.canBumpFee;

        returnVal = _extends({}, returnVal, {
          // Convert from base units
          value: (0, _currency.integerToDecimal)(returnVal.value, _app2.default.serverConfig.cryptoCurrency)
        });
      }

      return returnVal;
    }
  }, {
    key: 'idAttribute',
    get: function get() {
      return 'txid';
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;