'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _electron = require('electron');

var _backbone = require('backbone');

var _utils = require('./utils');

var _selectors = require('./utils/selectors');

var _object = require('./utils/object');

require('./lib/whenAll.jquery');

var _app = require('./app');

var _app2 = _interopRequireDefault(_app);

var _BaseModal = require('./views/modals/BaseModal');

var _block = require('./utils/block');

var _UserPage = require('./views/userPage/UserPage');

var _UserPage2 = _interopRequireDefault(_UserPage);

var _Search = require('./views/search/Search');

var _Search2 = _interopRequireDefault(_Search);

var _Transactions = require('./views/transactions/Transactions');

var _Transactions2 = _interopRequireDefault(_Transactions);

var _ConnectedPeersPage = require('./views/ConnectedPeersPage');

var _ConnectedPeersPage2 = _interopRequireDefault(_ConnectedPeersPage);

var _TemplateOnly = require('./views/TemplateOnly');

var _TemplateOnly2 = _interopRequireDefault(_TemplateOnly);

var _Profile = require('./models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

var _Listing = require('./models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _BlockedWarning = require('./views/modals/BlockedWarning');

var _BlockedWarning2 = _interopRequireDefault(_BlockedWarning);

var _metrics = require('./utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObRouter = function (_Router) {
  _inherits(ObRouter, _Router);

  function ObRouter() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, ObRouter);

    var _this = _possibleConstructorReturn(this, (ObRouter.__proto__ || Object.getPrototypeOf(ObRouter)).call(this, options));

    _this.options = options;

    // This is a mapping of guids to handles. It is currently updated any time
    // a profile is fetched via this.user() and anytime a user route is navigated to
    // via this.navigateUser(). The main purpose of this cache is to avoid the flicker
    // in the address bar that would be present due to the fact that we are storing user
    // routes with guids in the history, but diplaying a version with the handle in the
    // address bar.
    _this.guidHandleMap = new Map();

    var routes = [[/^(?:ob:\/\/)@([^\/]+)[\/]?([^\/]*)[\/]?([^\/]*)[\/]?([^\/]*)\/?$/, 'userViaHandle'], [/^@([^\/]+)[\/]?([^\/]*)[\/]?([^\/]*)[\/]?([^\/]*)\/?$/, 'userViaHandle'], [/^(?:ob:\/\/)(Qm[a-zA-Z0-9]+)[\/]?([^\/]*)[\/]?([^\/]*)[\/]?([^\/]*)\/?$/, 'user'], [/^(Qm[a-zA-Z0-9]+)[\/]?([^\/]*)[\/]?([^\/]*)[\/]?([^\/]*)\/?$/, 'user'], ['(ob://)transactions(/)', 'transactions'], ['(ob://)transactions/:tab(/)', 'transactions'], ['(ob://)connected-peers(/)', 'connectedPeers'], ['(ob://)search(?query)', 'search'], ['(ob://)*path', 'pageNotFound']];

    routes.slice(0).reverse().forEach(function (route) {
      return _this.route.apply(_this, route);
    });

    _this.setAddressBarText();
    _this._curHash = location.hash;

    (0, _jquery2.default)(window).on('hashchange', function () {
      _this.setAddressBarText();
      if (window.Countly) {
        window.Countly.q.push(['track_pageview', location.hash]);
      }
    });

    _electron.ipcRenderer.on('external-route', function (e, route) {
      if (_app2.default.pageNav.navigable) {
        _this.navigate(route, { trigger: true });
      }
    });
    return _this;
  }

  _createClass(ObRouter, [{
    key: 'setPrevHash',


    // FYI - There is a scenario where the prevHash will be inaccurate. More details in
    // the confirmPromises when() fail handler in execute().
    value: function setPrevHash() {
      var prevHash = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this._curHash;

      this._prevHash = prevHash;
      this._curHash = location.hash;
    }
  }, {
    key: 'onProfileSet',


    /**
     * Our own profile is not available when the router is constructed, so please call this method
     * when it is.
     */
    value: function onProfileSet() {
      this.stopListening(_app2.default.profile, null, this.onOwnHandleChange);
      this.listenTo(_app2.default.profile, 'change:handle', this.onOwnHandleChange);
    }
  }, {
    key: 'onOwnHandleChange',
    value: function onOwnHandleChange() {
      this.cacheGuidHandle(_app2.default.profile.id, _app2.default.profile.get('handle'));

      // If we're on our own user page, we'll call router.setAddressBarText, which
      // will ensure the updated handle is reflected in the address bar.
      if (location.hash.slice(1).startsWith(_app2.default.profile.id)) {
        this.setAddressBarText();
      }
    }

    /**
     * Updates our this.guidHandleMap which is an in-memory mapping of a guid to handle.
     */

  }, {
    key: 'cacheGuidHandle',
    value: function cacheGuidHandle(guid, handle) {
      if (typeof guid !== 'string') {
        throw new Error('Please provide a guid as a string.');
      }

      if (typeof handle !== 'string') {
        throw new Error('Please provide a handle as a string.');
      }

      if (!handle) {
        this.guidHandleMap.delete(guid);
        return;
      }

      var keys = Array.from(this.guidHandleMap.keys());
      if (!this.guidHandleMap.get(guid) && keys.length >= this.maxCachedHandles) {
        // We're already at or over the limit, so we need to remove one from the cache to
        // make room for the new one.
        this.guidHandleMap.delete(keys[0]);
      }

      this.guidHandleMap.set(guid, handle);
    }
  }, {
    key: 'standardizedRoute',
    value: function standardizedRoute() {
      var route = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : location.hash;

      var standardized = route;

      if (standardized.startsWith('#')) {
        standardized = standardized.slice(1);
      }

      if (standardized.startsWith('/')) {
        standardized = standardized.slice(1);
      }

      if (standardized.startsWith('ob://')) {
        standardized = standardized.slice(5);
      }

      if (standardized.endsWith('/')) {
        standardized = standardized.slice(0, standardized.length - 1);
      }

      return standardized;
    }
  }, {
    key: 'setAddressBarText',
    value: function setAddressBarText() {
      var route = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.standardizedRoute();

      var displayRoute = route;

      if (!route) {
        displayRoute = '';
      } else {
        var split = route.split('/');

        // If the route starts with a guid and we have a cached handle
        // for that guid, we'll put the handle in.
        if ((0, _utils.isMultihash)(split[0])) {
          var handle = this.guidHandleMap.get(split[0]);

          if (handle) {
            displayRoute = '@' + handle + (split.length > 1 ? '/' + split.slice(1).join('/') : '');
          }
        }

        displayRoute = 'ob://' + displayRoute;
      }

      _app2.default.pageNav.setAddressBar(displayRoute);
    }
  }, {
    key: 'execute',
    value: function execute(callback, args, name) {
      var _this2 = this;

      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      if (this.closeUnconfirmedRollBack) {
        this.closeUnconfirmedRollBack = false;
        return false;
      }

      this.navigate(this.standardizedRoute(), { replace: true });

      // We'll iterate through any open modal which have a confirmClose method
      // implemented. We'll call the method and only proceed with the route
      // if every method confirms that the close is ok. If not, we'll cancel
      // the route and roll back the hash.
      if (!options.confirmedClose) {
        var confirmPromises = [];
        (0, _BaseModal.getOpenModals)().forEach(function (modal) {
          if (typeof modal.confirmClose !== 'function') return;
          var closeConfirmed = modal.confirmClose.call(modal);

          if ((0, _object.isPromise)(closeConfirmed)) {
            confirmPromises.push(closeConfirmed);
          } else if (closeConfirmed) {
            confirmPromises.push(_jquery2.default.Deferred().resolve().promise());
          }
        });

        if (confirmPromises.length) {
          // Routing to a new page while the confirm close process is active could produce
          // weird things, so we'll block page navigation.
          _app2.default.pageNav.navigable = false;
          _jquery2.default.when.apply(_jquery2.default, confirmPromises).done(function () {
            _this2.execute(callback, args, name, { confirmedClose: true });
          }).fail(function () {
            // If any of the closeConfirm promises are rejected, it indicates that
            // the close of at least one modal was not confirmed and we won't proceed
            // with the new route. We need to rollback the location hash.

            if (location.hash !== _this2._prevHash) {
              // When we roll back, it will trigger a new route. We want that route to be
              // ignored and not reload a new page since we never unloaded the page. It's not
              // pretty, but the following flag will be used for execute() to opt-out of reloading
              // the page.
              _this2.closeUnconfirmedRollBack = true;
              location.hash = _this2._prevHash;

              // FYI - at this point, since we've rolled back one level but never rolled back
              // _prevHash one level, _prevHash is not accurate. To do that, we would need to track
              // more than the previous hash, but also track all previous hashes. It's beyond the
              // scope of what is necessary here. As long as prev hash is used only when the
              // location hash changes to a new one and you want to cancel that route, we're good.
            }
          }).always(function () {
            return _app2.default.pageNav.navigable = true;
          });

          return false;
        }
      }

      _app2.default.loadingModal.open();

      // This block is intentionally duplicated here and in loadPage. It's
      // here because we want to remove any current views (and have them
      // do their remove cleanup) as soon as we know we're matching a new
      // route. Based on some subsequent async fecthes, it may be a little
      // bit of time before loadPage is called.
      if (this.currentPage) {
        this.currentPage.remove();
        this.currentPage = null;
      }

      if (callback) {
        this.trigger('will-route');
        callback.apply(this, args);
      }

      return undefined;
    }
  }, {
    key: 'loadPage',
    value: function loadPage(vw) {
      // This block is intentionally duplicated here in case a route
      // method was called directly on the app.router instance therefore
      // bypassing execute.
      if (this.currentPage) {
        this.currentPage.remove();
        this.currentPage = null;
      }

      this.currentPage = vw;
      (0, _selectors.getPageContainer)().append(vw.el);
      _app2.default.loadingModal.close();
    }

    /**
     * If you need to navigate to a user page via a handle and you have the user's guid, use
     * this method which is mostly a wrapper around the standard Router.navigate. The addition
     * is that this will make sure to store a version of the given fragment in history with the
     * guid in place of the handle. It will make sure that the given version (with handle)
     * will be shown in the address bar. It will also update the guidHandleMap caching.
     *
     * It's essentially a way to ensure that behind the scenes navigation is being done via
     * guids (not dependant on the 3rd party resolver), but visually in the address bar, the
     * user is seeing the handle (when available).
     *
     * @param {string} fragment - The user route you want stored. If the handle is available,
     *   provide it in this parameter (e.g. '@themes/store')
     * @param {guid} string - The guid of the user corresponding to the given fragment.
     * @param {object} [options={}] - Options that will be passed to Router.navigate.
     */

  }, {
    key: 'navigateUser',
    value: function navigateUser(fragment, guid) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      if (typeof fragment !== 'string') {
        throw new Error('Please provide a fragment as a string.');
      }

      if (!guid) {
        throw new Error('Please provide a guid.');
      }

      var guidRoute = fragment;
      var split = fragment.split('/');

      if (split[0].startsWith('@')) {
        this.cacheGuidHandle(guid, split[0].slice(1));
        guidRoute = [guid].concat(split.slice(1)).join('/');
      }

      return this.navigate(guidRoute, options);
    }
  }, {
    key: 'navigate',
    value: function navigate(fragment) {
      var _this3 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      // Navigate is often times called in quick succession with url rewrites, so to
      // properly capture the previous hash we'll just base it off the final call when
      // they're called in such a burst fashion.
      if (typeof fragment === 'string') {
        clearTimeout(this.navigateSetPrevHash);
        this.navigateSetPrevHash = setTimeout(function () {
          _this3.setPrevHash();
        });
      }

      return _get(ObRouter.prototype.__proto__ || Object.getPrototypeOf(ObRouter.prototype), 'navigate', this).call(this, fragment, options);
    }
  }, {
    key: 'userViaHandle',
    value: function userViaHandle(handle) {
      var _this4 = this;

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      (0, _utils.getGuid)(handle).done(function (guid) {
        _this4.user.apply(_this4, [guid].concat(args));
      }).fail(function () {
        _this4.userNotFound(handle);
      });
    }
  }, {
    key: 'isValidUserRoute',


    /**
     * Based on the route arguments, determine whether we
     * have a valid user route.
     */
    value: function isValidUserRoute(guid, state) {
      if (!guid || this.userStates.indexOf(state) === -1) {
        return false;
      }

      if (state === 'store') {
        // so far store is the only state that could have
        // route parts beyond the state, e.g @themes/store/<slug>
        if ((arguments.length <= 2 ? 0 : arguments.length - 2) > 1) {
          return false;
        }
      } else if (arguments.length <= 2 ? 0 : arguments.length - 2) {
        return false;
      }

      return true;
    }
  }, {
    key: 'user',
    value: function user(guid, state) {
      for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
        args[_key2 - 2] = arguments[_key2];
      }

      var _this5 = this;

      var pageState = state || 'store';
      var deepRouteParts = args.filter(function (arg) {
        return arg !== null;
      });

      if (!this.isValidUserRoute.apply(this, [guid, pageState].concat(_toConsumableArray(deepRouteParts)))) {
        this.pageNotFound();
        return;
      }

      if ((0, _block.isBlocked)(guid) && !(0, _block.isUnblocking)(guid)) {
        _app2.default.loadingModal.close();
        var blockedWarningModal = new _BlockedWarning2.default({ peerId: guid }).render().open();

        var onBlockWarningCanceled = function onBlockWarningCanceled() {
          var prevHash = _this5.prevHash.endsWith('/') ? _this5.prevHash.slice(0, _this5.prevHash.length - 1) : _this5.prevHash;
          var locationHash = location.hash.endsWith('/') ? location.hash.slice(0, location.hash.length - 1) : location.hash;

          if (prevHash === locationHash) {
            // means there is no previous page - will go to our own node page
            _this5.navigate('' + _app2.default.profile.id, {
              replace: true,
              trigger: true
            });
          } else {
            _this5.navigate('' + _this5.prevHash.slice(1), {
              replace: true,
              trigger: true
            });
          }
        };

        var onUnblock = function onUnblock(data) {
          if (data.peerIds.includes(guid)) {
            _app2.default.loadingModal.open();
            _this5.user.apply(_this5, [guid, state].concat(args));
          }
        };

        var cleanUpBlockedModal = function cleanUpBlockedModal() {
          _block.events.off(null, onUnblock);
        };

        blockedWarningModal.on('canceled', onBlockWarningCanceled);
        _block.events.on('unblocking unblocked', onUnblock);
        blockedWarningModal.on('close', cleanUpBlockedModal);
        return;
      }

      var profile = void 0;
      var profileFetch = void 0;
      var listing = void 0;
      var listingFetch = void 0;
      var userPageFetchError = '';

      (0, _metrics.startEvent)('UserPageLoad');

      if (guid === _app2.default.profile.id) {
        // don't fetch our own profile, since we have it already
        profileFetch = _jquery2.default.Deferred().resolve();
        profile = _app2.default.profile;
      } else {
        profile = new _Profile2.default({ peerID: guid });
        profileFetch = profile.fetch();
      }

      if (state === 'store') {
        if (deepRouteParts[0]) {
          listing = new _Listing2.default({
            slug: deepRouteParts[0]
          }, { guid: guid });

          listingFetch = listing.fetch();
        }
      }

      var onWillRoute = function onWillRoute() {
        // The app has been routed to a new route, let's
        // clean up by aborting all fetches
        if (profileFetch.abort) profileFetch.abort();
        if (listingFetch) listingFetch.abort();
      };

      this.once('will-route', onWillRoute);

      _jquery2.default.whenAll(profileFetch, listingFetch).done(function () {
        var handle = profile.get('handle');
        _this5.cacheGuidHandle(guid, handle);

        // Setting the address bar which will ensure the most up to date handle (or none) is
        // shown in the address bar.
        _this5.setAddressBarText();

        if (pageState === 'store' && !profile.get('vendor') && guid !== _app2.default.profile.id) {
          // the user does not have an active store and this is not our own node
          if (state) {
            // You've explicitly tried to navigate to the store tab. Since it's not
            // available, we'll re-route to page-not-found
            _this5.pageNotFound();
            return;
          }

          // You've attempted to find a user with no particular tab. Since store is not available
          // we'll take you to the home tab.
          _this5.navigate(guid + '/home/' + (deepRouteParts ? deepRouteParts.join('/') : ''), {
            replace: true,
            trigger: true
          });
          return;
        }

        if (!state) {
          _this5.navigate(guid + '/store/' + (deepRouteParts ? deepRouteParts.join('/') : ''), {
            replace: true
          });
        }

        _this5.loadPage(new _UserPage2.default({
          model: profile,
          state: pageState,
          listing: listing
        }).render());
      }).fail(function () {
        var jqXhr = arguments.length <= 0 ? undefined : arguments[0];

        if (jqXhr === profileFetch && profileFetch.statusText === 'abort') return;
        if (jqXhr === listingFetch && listingFetch.statusText === 'abort') return;

        // todo: If really not found (404), route to
        // not found page, otherwise display error.
        if (profileFetch.state() === 'rejected') {
          _this5.userNotFound(guid);
          userPageFetchError = 'User Not Found';
        } else if (listingFetch.state() === 'rejected') {
          _this5.listingNotFound(deepRouteParts[0], guid + '/' + pageState);
          userPageFetchError = 'Listing Not Found';
        }
      }).always(function () {
        _this5.off(null, onWillRoute);
        (0, _metrics.endEvent)('UserPageLoad', {
          ownPage: guid === _app2.default.profile.id,
          tab: pageState,
          listing: !!listingFetch,
          errors: userPageFetchError || 'none'
        });
      });
    }
  }, {
    key: 'transactions',
    value: function transactions(tab) {
      if (tab && ['sales', 'cases', 'purchases'].indexOf(tab) === -1) {
        this.pageNotFound();
        return;
      }

      if (!tab) {
        this.navigate('transactions/sales');
      }

      var initialTab = tab || 'sales';

      this.loadPage(new _Transactions2.default({ initialTab: initialTab }).render());

      (0, _metrics.recordEvent)('Transactions_PageLoad', {
        tab: initialTab
      });
    }
  }, {
    key: 'connectedPeers',
    value: function connectedPeers() {
      var _this6 = this;

      var peerFetch = _jquery2.default.get(_app2.default.getServerUrl('ob/peers')).done(function (data) {
        var peersData = data || [];
        var peers = peersData.map(function (peer) {
          return peer.slice(peer.lastIndexOf('/') + 1);
        });

        _this6.loadPage(new _ConnectedPeersPage2.default({ peers: peers }).render());
      }).fail(function (xhr) {
        var content = '<p>There was an error retrieving the connected peers.</p>';

        if (xhr.responseText) {
          content += '<p>' + (xhr.responseJSON && xhr.responseJSON.reason || xhr.responseText) + '</p>';
        }

        _this6.genericError({ content: content });
      });

      this.once('will-route', function () {
        return peerFetch.abort();
      });
    }
  }, {
    key: 'search',
    value: function search(query) {
      this.loadPage(new _Search2.default({ query: query }));
    }
  }, {
    key: 'userNotFound',
    value: function userNotFound(user) {
      this.loadPage(new _TemplateOnly2.default({ template: 'error-pages/userNotFound.html' }).render({ user: user }));
    }
  }, {
    key: 'pageNotFound',
    value: function pageNotFound() {
      this.loadPage(new _TemplateOnly2.default({
        template: 'error-pages/pageNotFound.html'
      }).render());
    }
  }, {
    key: 'listingNotFound',
    value: function listingNotFound(listing, link) {
      this.loadPage(new _TemplateOnly2.default({ template: 'error-pages/listingNotFound.html' }).render({ listing: listing, link: link }));
    }
  }, {
    key: 'listingError',
    value: function listingError(failedXhr, listing, storeUrl) {
      if (!failedXhr) {
        throw new Error('Please provide the failed Xhr request');
      }

      if (failedXhr.status === 404) {
        this.listingNotFound(listing, storeUrl);
      } else {
        var failErr = '';

        if (failedXhr.responseText) {
          var reason = failedXhr.responseJSON && failedXhr.responseJSON.reason || failedXhr.responseText;
          failErr += '\n\n' + reason;
        }

        this.loadPage(new _TemplateOnly2.default({ template: 'error-pages/listingError.html' }).render({
          listing: listing,
          storeUrl: storeUrl,
          failErr: failErr
        }));
      }
    }
  }, {
    key: 'genericError',
    value: function genericError() {
      var context = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      this.loadPage(new _TemplateOnly2.default({ template: 'error-pages/genericError.html' }).render(context));
    }
  }, {
    key: 'maxCachedHandles',
    get: function get() {
      return 1000;
    }
  }, {
    key: 'prevHash',
    get: function get() {
      return this._prevHash;
    }
  }, {
    key: 'userStates',
    get: function get() {
      return ['home', 'store', 'following', 'followers', 'reputation'];
    }
  }]);

  return ObRouter;
}(_backbone.Router);

exports.default = ObRouter;