'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.followedByYou = followedByYou;
exports.followsYou = followsYou;
exports.followUnfollow = followUnfollow;

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _string = require('../utils/string');

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _Dialog = require('../views/modals/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function followedByYou(guid) {
  return !!_app2.default.ownFollowing.get(guid);
}

function followsYou(guid) {
  if (!guid) {
    throw new Error('Please provide a guid');
  }

  return _jquery2.default.get('' + _app2.default.getServerUrl('ob/followsme/' + guid));
}

function followUnfollow(guid) {
  var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'follow';

  if (typeof guid !== 'string' || !guid.toLowerCase().startsWith('qm')) {
    throw new Error('You must provide a valid guid.');
  }

  var types = ['follow', 'unfollow'];
  if (types.indexOf(type) === -1) {
    throw new Error('type must be one of ' + types.join(', '));
  }

  if (guid === _app2.default.profile.id) {
    throw new Error('You can not follow or unfollow your own guid');
  }

  return _jquery2.default.ajax({
    type: 'POST',
    url: _app2.default.getServerUrl('ob/' + type),
    data: JSON.stringify({ id: guid }),
    dataType: 'json'
  }).done(function () {
    // if the call succeeds, add or remove the guid from the collection
    if (type === 'follow') {
      _app2.default.ownFollowing.unshift({ peerId: guid });
    } else {
      _app2.default.ownFollowing.remove(guid);
    }
  }).fail(function (data) {
    new _Dialog2.default({
      title: _app2.default.polyglot.t('follow.followErrorTitle', {
        type: _app2.default.polyglot.t('follow.type' + (0, _string.capitalize)(type)),
        user: guid
      }),
      message: data.responseJSON && data.responseJSON.reason || ''
    }).render().open();
  });
}