'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = loadTemplate;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _templateHelpers = require('./templateHelpers');

var templateHelpers = _interopRequireWildcard(_templateHelpers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var templateCache = {};

function loadTemplate(templateFile, callback) {
  var root = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : __dirname + '/../templates/';

  if (!templateFile) {
    throw new Error('Please provide a path to the template.');
  }

  _underscore2.default.templateSettings.variable = 'ob';

  var template = templateCache[templateFile];

  if (!template) {
    var file = _fs2.default.readFileSync(_path2.default.join(root, templateFile), 'utf8');
    template = _underscore2.default.template(file);
    templateCache[templateFile] = template;
  }

  var sendBackTmpl = function sendBackTmpl() {
    var wrappedTmpl = function wrappedTmpl(context) {
      return template(_extends({}, templateHelpers, context || {}));
    };
    callback(wrappedTmpl);
  };

  if (!templateHelpers.formErrorTmpl) {
    templateHelpers.formErrorTmpl = 'its coming'; // hack to avoid infinite recursion

    loadTemplate('spinner.svg', function (t) {
      templateHelpers.spinner = t;
    });

    loadTemplate('processingButton.html', function (t) {
      templateHelpers.processingButton = t;
    });

    loadTemplate('formError.html', function (t) {
      templateHelpers.formErrorTmpl = t;
      sendBackTmpl();
    });
  } else {
    sendBackTmpl();
  }
}