'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.setDeepValue = setDeepValue;
exports.removeProp = removeProp;
exports.isPromise = isPromise;
// http://stackoverflow.com/a/18937118/632806
// todo: unit test
function setDeepValue(obj, path, value) {
  var schema = obj; // a moving reference to internal objects within obj
  var pList = path.split('.');
  var len = pList.length;

  for (var i = 0; i < len - 1; i++) {
    var elem = pList[i];
    if (!schema[elem]) schema[elem] = {};
    schema = schema[elem];
  }

  schema[pList[len - 1]] = value;
}

// http://stackoverflow.com/a/34607791/632806
// todo: unit test
/*
 * Deletes any property in the object with the name of key at
 * any level of nesting.
 */
function removeProp(obj, key) {
  Object.keys(obj).forEach(function (i) {
    if (_typeof(obj[i]) === 'object') {
      removeProp(obj[i], key);
    } else if (i === key) {
      delete obj[i];
    }
  });

  return obj;
}

// https://stackoverflow.com/a/13075985/632806
/*
 * Return true if obj is a promise.
 */
function isPromise(obj) {
  return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && typeof obj.then === 'function';
}