'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tagsDelimiter = exports.is = exports.splitIntoRows = exports.upToFixed = exports.getListingBgImage = exports.getAvatarBgImage = exports.isSmallHeight = exports.isLargeWidth = exports.isHiRez = exports.currencyMod = exports.getServerUrl = undefined;
exports.polyT = polyT;
exports.parseEmojis = parseEmojis;
exports.formatRating = formatRating;

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _currency = require('./currency');

var _cryptoCurrencies = require('../data/cryptoCurrencies');

var _responsive = require('./responsive');

var _number = require('./number');

var _twemoji = require('twemoji');

var _twemoji2 = _interopRequireDefault(_twemoji);

var _ = require('./');

var _selectize = require('../utils/lib/selectize');

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function polyT() {
  var _app$polyglot;

  return (_app$polyglot = _app2.default.polyglot).t.apply(_app$polyglot, arguments);
}

function parseEmojis(text) {
  var className = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var attrs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var parsed = _twemoji2.default.parse(text, function (icon) {
    return '../imgs/emojis/72X72/' + icon + '.png';
  });
  var $parsed = (0, _jquery2.default)('<div>' + parsed + '</div>');

  $parsed.find('img').each(function (index, img) {
    var $img = (0, _jquery2.default)(img);
    $img.addClass('emoji ' + className);

    Object.keys(attrs).forEach(function (attr) {
      $img.attr(attr, attrs[attr]);
    });
  });

  return $parsed.html();
}

/**
 * If the average is a number, show the last 2 digits and trim any trailing zeroes.
 * @param {number} average - the average rating
 * @param {number} count - the number of ratings
 * @param {boolean) skipCount = a count wasn't sent, don't show it or test it for validity
 */
function formatRating(average, count, skipCount) {
  var avIsNum = typeof average === 'number';
  var countIsNum = typeof count === 'number';
  var ratingAverage = avIsNum ? average.toFixed(1) : '?';
  var ratingCount = countIsNum ? ' (' + (0, _.abbrNum)(count) + ')' : ' (?)';
  if (skipCount) ratingCount = '';
  var error = !avIsNum || !countIsNum && !skipCount ? ' <i class="ion-alert-circled clrTErr"></i>' : '';
  return parseEmojis('⭐') + ' ' + ratingAverage + ratingCount + error;
}

var getServerUrl = exports.getServerUrl = _app2.default.getServerUrl.bind(_app2.default);

var currencyExport = {
  formatPrice: _currency.formatPrice,
  formatCurrency: _currency.formatCurrency,
  convertAndFormatCurrency: _currency.convertAndFormatCurrency,
  convertCurrency: _currency.convertCurrency,
  getCurrencyValidity: _currency.getCurrencyValidity,
  getServerCurrency: _cryptoCurrencies.getServerCurrency,
  getCryptoCurByCode: _cryptoCurrencies.getCurrencyByCode,
  getExchangeRate: _currency.getExchangeRate,
  formattedCurrency: _currency.renderFormattedCurrency,
  pairedCurrency: _currency.renderPairedCurrency,
  cryptoIcon: _cryptoCurrencies.renderCryptoIcon,
  getBlockChainTxUrl: _cryptoCurrencies.getBlockChainTxUrl,
  getBlockChainAddressUrl: _cryptoCurrencies.getBlockChainAddressUrl
};

exports.currencyMod = currencyExport;
exports.isHiRez = _responsive.isHiRez;
exports.isLargeWidth = _responsive.isLargeWidth;
exports.isSmallHeight = _responsive.isSmallHeight;
exports.getAvatarBgImage = _responsive.getAvatarBgImage;
exports.getListingBgImage = _responsive.getListingBgImage;
exports.upToFixed = _number.upToFixed;
exports.splitIntoRows = _.splitIntoRows;
exports.is = _is_js2.default;
exports.tagsDelimiter = _selectize.tagsDelimiter;