'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _loadTemplate = require('../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('./baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _currency = require('../utils/currency');

var _cryptoCurrencies = require('../data/cryptoCurrencies');

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // While this file is named BTCTicker, it is really a widget which will show the exchange
// rate of the server's currency (may be BTC or another crypto) in the user's local currency.


var RATE_EXPIRY_S = '300';

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.listenTo(_app2.default.settings, 'change:localCurrency', _this.updatePrice);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'btcTicker';
    }
  }, {
    key: 'getCurrentPrice',
    value: function getCurrentPrice() {
      return (0, _currency.getExchangeRate)(this.localCurrency);
    }
  }, {
    key: 'updatePrice',
    value: function updatePrice() {
      var latestPrice = this.getCurrentPrice();
      if (latestPrice !== this.currentPrice) {
        this.currentPrice = latestPrice;
        this.render();
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      clearInterval(this.refreshCode);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      if (this.refreshCode == null) {
        this.refreshCode = setInterval(function () {
          return _this2.updatePrice();
        }, RATE_EXPIRY_S * 1000);
      }

      if (this.currentPrice == null) {
        this.currentPrice = this.getCurrentPrice();
      }

      var serverCur = (0, _cryptoCurrencies.getServerCurrency)();
      // We won't show the ticker if their local currency is set to the server currency or if
      // exchange rate data is not available.
      var showTicker = this.localCurrency !== serverCur.code && this.localCurrency !== serverCur.testnetCode && this.currentPrice !== undefined;

      if (showTicker) {
        (0, _loadTemplate2.default)('btcTicker.html', function (t) {
          _this2.$el.html(t({
            currentPrice: _this2.currentPrice,
            localCurrency: _this2.localCurrency
          }));
        });
      } else {
        this.$el.empty();
      }

      return this;
    }
  }, {
    key: 'localCurrency',
    get: function get() {
      return _app2.default.settings.get('localCurrency');
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;