'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _SimpleMessage = require('../views/modals/SimpleMessage');

var _modalManager = require('../utils/modalManager');

var _block = require('../utils/block');

var _responsive = require('../utils/responsive');

var _Listing = require('../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _ListingShort = require('../models/listing/ListingShort');

var _ListingShort2 = _interopRequireDefault(_ListingShort);

var _listing = require('../models/listing/');

var _baseVw2 = require('./baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _Listing3 = require('./modals/listingDetail/Listing');

var _Listing4 = _interopRequireDefault(_Listing3);

var _ReportBtn = require('./components/ReportBtn');

var _ReportBtn2 = _interopRequireDefault(_ReportBtn);

var _Report = require('./modals/Report');

var _Report2 = _interopRequireDefault(_Report);

var _BlockedWarning = require('./modals/BlockedWarning');

var _BlockedWarning2 = _interopRequireDefault(_BlockedWarning);

var _BlockBtn = require('./components/BlockBtn');

var _BlockBtn2 = _interopRequireDefault(_BlockBtn);

var _VerifiedMod = require('./components/VerifiedMod');

var _VerifiedMod2 = _interopRequireDefault(_VerifiedMod);

var _metrics = require('../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      viewType: 'grid',
      reportsUrl: ''
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    if (!_this.model || !(_this.model instanceof _ListingShort2.default)) {
      throw new Error('Please provide a ListingShort model.');
    }

    // Any provided profile model or vendor info object will also be passed into the
    // listing detail modal.
    if (opts.profile) {
      // If a profile model of the listing owner is available, please pass it in.
      _this.ownerGuid = opts.profile.id;
    } else if (_this.model.get('vendor')) {
      // If a vendor object is available (part of proposed search API), please pass it in.
      _this.ownerGuid = _this.model.get('vendor').peerID;
    } else {
      // Otherwise please provide the store owner's guid.
      _this.ownerGuid = opts.ownerGuid;
    }

    if (typeof _this.ownerGuid === 'undefined') {
      throw new Error('Unable to determine ownership of the listing. Please either provide' + ' a profile model or pass in an ownerGuid option.');
    }

    if (!opts.listingBaseUrl) {
      // When the listing card is clicked and the listing detail modal is
      // opened, the slug of the listing is concatenated with the listingBaseUrl
      // and the route is updated (both history & address bar).
      throw new Error('Please provide a listingBaseUrl.');
    }

    if (_this.ownListing) {
      _this.$el.addClass('ownListing');
    }

    if (_this.ownListing) {
      _this.listenTo(_listing.events, 'destroying', function (md, destroyingOpts) {
        if (_this.isRemoved()) return;

        if (destroyingOpts.slug === _this.model.get('slug')) {
          _this.$el.addClass('listingDeleting');
        }

        destroyingOpts.xhr.fail(function () {
          return _this.$el.removeClass('listingDeleting');
        });
      });

      _this.listenTo(_listing.events, 'destroy', function (md, destroyOpts) {
        if (_this.isRemoved()) return;

        if (destroyOpts.slug === _this.model.get('slug')) {
          _this.$el.addClass('listingDeleted');
        }
      });
    }

    _this.viewType = opts.viewType;
    _this.reportsUrl = opts.reportsUrl;
    _this.deleteConfirmOn = false;
    _this.boundDocClick = _this.onDocumentClick.bind(_this);
    // This should be initialized as null, so we could determine whether the user
    // never set this (null), or explicitly clicked to show / hide nsfw (true / false)
    _this._userClickedShowNsfw = null;
    (0, _jquery2.default)(document).on('click', _this.boundDocClick);

    _this.listenTo(_block.events, 'blocked unblocked', function (data) {
      if (data.peerIds.includes(_this.ownerGuid)) {
        _this.setBlockedClass();
      }
    });

    _this.listenTo(_app2.default.settings, 'change:showNsfw', function () {
      _this._userClickedShowNsfw = null;
      _this.setHideNsfwClass();
    });

    _this.verifiedMods = _app2.default.verifiedMods.matched(_this.model.get('moderators'));

    _this.listenTo(_app2.default.verifiedMods, 'update', function () {
      var newVerifiedMods = _app2.default.verifiedMods.matched(_this.model.get('moderators'));
      if (_this.verifiedMods.length && !newVerifiedMods.length || !_this.verifiedMods.length && newVerifiedMods.length) {
        _this.verifiedMods = newVerifiedMods;
        _this.render();
      }
    });

    // load necessary images in a cancelable way
    var thumbnail = _this.model.get('thumbnail');
    var listingImageSrc = _this.viewType === 'grid' ? _app2.default.getServerUrl('ob/images/' + ((0, _responsive.isHiRez)() ? thumbnail.medium : thumbnail.small)) : _app2.default.getServerUrl('ob/images/' + ((0, _responsive.isHiRez)() ? thumbnail.small : thumbnail.tiny));

    _this.listingImage = new Image();
    _this.listingImage.addEventListener('load', function () {
      _this.listingImage.loaded = true;
      _this.$('.js-listingImage').css('backgroundImage', 'url(' + listingImageSrc + ')');
    });
    _this.listingImage.src = listingImageSrc;

    var vendor = _this.model.get('vendor');
    if (vendor && vendor.avatarHashes) {
      var avatarImageSrc = _app2.default.getServerUrl('ob/images/' + ((0, _responsive.isHiRez)() ? vendor.avatarHashes.small : vendor.avatarHashes.tiny));

      _this.avatarImage = new Image();
      _this.avatarImage.addEventListener('load', function () {
        _this.avatarImage.loaded = true;
        _this.$('.js-vendorIcon').css('backgroundImage', 'url(' + avatarImageSrc + ')');
      });
      _this.avatarImage.src = avatarImageSrc;
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'listingCard col clrBr clrHover clrT clrP clrSh2 contentBox';
    }
  }, {
    key: 'attributes',
    value: function attributes() {
      // make it possible to tab to this element
      return { tabIndex: 0 };
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-edit': 'onClickEdit',
        'click .js-delete': 'onClickDelete',
        'click .js-clone': 'onClickClone',
        'click .js-userLink': 'onClickUserLink',
        'click .js-deleteConfirmed': 'onClickConfirmedDelete',
        'click .js-deleteConfirmCancel': 'onClickConfirmCancel',
        'click .js-deleteConfirmedBox': 'onClickDeleteConfirmBox',
        'click .js-showNsfw': 'onClickShowNsfw',
        'click .js-hideNsfw': 'onClickHideNsfw',
        click: 'onClick'
      };
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick() {
      this.getCachedEl('.js-deleteConfirmedBox').addClass('hide');
      this.deleteConfirmOn = false;
    }
  }, {
    key: 'onClickEdit',
    value: function onClickEdit(e) {
      var _this2 = this;

      _app2.default.loadingModal.open();

      this.fetchFullListing().done(function (xhr) {
        if (xhr.statusText === 'abort' || _this2.isRemoved()) return;

        (0, _modalManager.launchEditListingModal)({
          model: _this2.fullListing
        });
      }).always(function () {
        if (_this2.isRemoved()) return;
        _app2.default.loadingModal.close();
      });

      e.stopPropagation();
    }
  }, {
    key: 'onClickDelete',
    value: function onClickDelete(e) {
      this.getCachedEl('.js-deleteConfirmedBox').removeClass('hide');
      this.deleteConfirmOn = true;
      e.stopPropagation();
    }
  }, {
    key: 'onClickClone',
    value: function onClickClone(e) {
      var _this3 = this;

      _app2.default.loadingModal.open();

      this.fetchFullListing().done(function (xhr) {
        if (xhr.statusText === 'abort' || _this3.isRemoved()) return;
        (0, _modalManager.launchEditListingModal)({
          model: _this3.fullListing.cloneListing()
        });
      }).always(function () {
        if (_this3.isRemoved()) return;
        _app2.default.loadingModal.close();
      });

      e.stopPropagation();
    }
  }, {
    key: 'onClickConfirmedDelete',
    value: function onClickConfirmedDelete(e) {
      e.stopPropagation();
      if (this.destroyRequest && this.destroyRequest.state === 'pending') return;
      this.destroyRequest = this.model.destroy({ wait: true });
    }
  }, {
    key: 'onClickConfirmCancel',
    value: function onClickConfirmCancel() {
      this.getCachedEl('.js-deleteConfirmedBox').addClass('hide');
      this.deleteConfirmOn = false;
    }
  }, {
    key: 'onClickDeleteConfirmBox',
    value: function onClickDeleteConfirmBox(e) {
      e.stopPropagation();
    }
  }, {
    key: 'onClickUserLink',
    value: function onClickUserLink(e) {
      e.stopPropagation();
    }
  }, {
    key: 'onClick',
    value: function onClick(e) {
      var _this4 = this;

      if (this.deleteConfirmOn) return;
      if (!this.ownListing || e.target !== this.$btnEdit[0] && e.target !== this.$btnDelete[0] && !_jquery2.default.contains(this.$btnEdit[0], e.target) && !_jquery2.default.contains(this.$btnDelete[0], e.target)) {
        var routeOnOpen = location.hash.slice(1);
        _app2.default.router.navigateUser('' + this.options.listingBaseUrl + this.model.get('slug'), this.ownerGuid);

        (0, _metrics.startEvent)('Listing_LoadFromCard');

        var listingFetch = this.fetchFullListing();
        var loadListing = function loadListing() {
          _app2.default.loadingModal.open();
          listingFetch.done(function (jqXhr) {
            (0, _metrics.endEvent)('Listing_LoadFromCard', {
              ownListing: !!_this4.ownListing,
              errors: 'none'
            });
            if (jqXhr.statusText === 'abort' || _this4.isRemoved()) return;

            var listingDetail = new _Listing4.default({
              model: _this4.fullListing,
              profile: _this4.options.profile,
              vendor: _this4.options.vendor,
              closeButtonClass: 'cornerTR iconBtn clrP clrBr clrSh3 toolTipNoWrap',
              modelContentClass: 'modalContent',
              openedFromStore: !!_this4.options.onStore,
              checkNsfw: !_this4._userClickedShowNsfw
            }).render().open();

            var onListingDetailClose = function onListingDetailClose() {
              return _app2.default.router.navigate(routeOnOpen);
            };

            _this4.listenTo(listingDetail, 'close', onListingDetailClose);
            _this4.listenTo(listingDetail, 'modal-will-remove', function () {
              return _this4.stopListening(null, null, onListingDetailClose);
            });
          }).always(function () {
            if (_this4.isRemoved()) return;
            _app2.default.loadingModal.close();
          }).fail(function (xhr) {
            (0, _metrics.endEvent)('Listing_LoadFromCard', {
              ownListing: !!_this4.ownListing,
              errors: xhr.responseJSON.reason || xhr.statusText || 'unknown error'
            });
            if (xhr.statusText === 'abort') return;
            _app2.default.router.listingError(xhr, _this4.model.get('slug'), '#' + _this4.ownerGuid + '/store');
          });
        };

        if ((0, _block.isBlocked)(this.ownerGuid) && !(0, _block.isUnblocking)(this.ownerGuid)) {
          var blockedWarningModal = new _BlockedWarning2.default({ peerId: this.ownerGuid }).render().open();

          this.listenTo(blockedWarningModal, 'canceled', function () {
            _app2.default.router.navigate(routeOnOpen);
          });

          var onUnblock = function onUnblock() {
            return loadListing();
          };

          this.listenTo(_block.events, 'unblocking unblocked', onUnblock);

          this.listenTo(blockedWarningModal, 'close', function () {
            _this4.stopListening(null, null, onUnblock);
          });
        } else {
          loadListing();
        }
      }
    }
  }, {
    key: 'onClickShowNsfw',
    value: function onClickShowNsfw(e) {
      e.stopPropagation();
      this._userClickedShowNsfw = true;
      this.setHideNsfwClass();
    }
  }, {
    key: 'onClickHideNsfw',
    value: function onClickHideNsfw(e) {
      e.stopPropagation();
      this._userClickedShowNsfw = false;
      this.setHideNsfwClass();
    }
  }, {
    key: 'setBlockedClass',
    value: function setBlockedClass() {
      this.$el.toggleClass('blocked', (0, _block.isBlocked)(this.ownerGuid));
    }
  }, {
    key: 'setHideNsfwClass',
    value: function setHideNsfwClass() {
      this.$el.toggleClass('hideNsfw',
      // explicitly checking for false, since null means something different
      this._userClickedShowNsfw === false || this.model.get('nsfw') && !this._userClickedShowNsfw && !_app2.default.settings.get('showNsfw'));
    }
  }, {
    key: 'fetchFullListing',
    value: function fetchFullListing() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var opts = _extends({
        showErrorOnFetchFail: true
      }, options);

      if (this.fullListingFetch && this.fullListingFetch.state() === 'pending') {
        return this.fullListingFetch;
      }

      this.fullListingFetch = this.fullListing.fetch().fail(function (xhr) {
        if (!opts.showErrorOnFetchFail) return;
        var failReason = xhr.responseJSON && xhr.responseJSON.reason || '';

        if (xhr.status === 404) {
          failReason = _app2.default.polyglot.t('listingCard.editFetchErrorDialog.bodyNotFound');
        }

        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('listingCard.editFetchErrorDialog.title'), failReason);
      });

      return this.fullListingFetch;
    }
  }, {
    key: 'onReportSubmitted',
    value: function onReportSubmitted() {
      this.reportBtn.setState({ reported: true });
    }
  }, {
    key: 'startReport',
    value: function startReport() {
      var _this5 = this;

      if (this.report) this.report.remove();

      this.report = this.createChild(_Report2.default, {
        removeOnClose: true,
        peerID: this.ownerGuid,
        slug: this.model.get('slug'),
        url: this.reportsUrl
      }).render().open();

      this.report.on('modal-will-remove', function () {
        return _this5.report = null;
      });
      this.listenTo(this.report, 'submitted', this.onReportSubmitted);
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.listingImage.src = '';
      if (this.avatarImage) this.avatarImage.src = '';
      if (this.fullListingFetch) this.fullListingFetch.abort();
      if (this.destroyRequest) this.destroyRequest.abort();
      (0, _jquery2.default)(document).off('click', this.boundDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('listingCard.html', function (t) {
        _this6.$el.html(t(_extends({}, _this6.model.toJSON(), {
          ownListing: _this6.ownListing,
          shipsFreeToMe: _this6.model.shipsFreeToMe,
          viewType: _this6.viewType,
          displayCurrency: _app2.default.settings.get('localCurrency'),
          isBlocked: _block.isBlocked,
          isUnblocking: _block.isUnblocking,
          listingImageSrc: _this6.listingImage.loaded && _this6.listingImage.src || '',
          vendorAvatarImageSrc: _this6.avatarImage && _this6.avatarImage.loaded && _this6.avatarImage.src || ''
        })));
      });

      this._$btnEdit = null;
      this._$btnDelete = null;

      this.setBlockedClass();
      this.setHideNsfwClass();
      this.$el.toggleClass('isNsfw', this.model.get('nsfw'));

      if (this.reportBtn) this.reportBtn.remove();
      if (this.reportsUrl) {
        this.reportBtn = this.createChild(_ReportBtn2.default);
        this.listenTo(this.reportBtn, 'startReport', this.startReport);
        this.getCachedEl('.js-reportBtnWrapper').append(this.reportBtn.render().el);
      }

      if (!this.ownListing) {
        this.getCachedEl('.js-blockBtnWrapper').html(new _BlockBtn2.default({
          targetId: this.ownerGuid,
          initialState: { useIcon: true }
        }).render().el);
      }

      var moderators = this.model.get('moderators') || [];
      var verifiedIDs = _app2.default.verifiedMods.matched(moderators);
      var verifiedID = verifiedIDs[0];

      if (this.verifiedMod) this.verifiedMod.remove();
      this.verifiedMod = this.createChild(_VerifiedMod2.default, (0, _VerifiedMod.getListingOptions)({
        model: verifiedID && _app2.default.verifiedMods.get(verifiedID)
      }));
      this.getCachedEl('.js-verifiedMod').append(this.verifiedMod.render().el);

      return this;
    }
  }, {
    key: 'ownListing',
    get: function get() {
      return _app2.default.profile.id === this.ownerGuid;
    }
  }, {
    key: 'fullListing',
    get: function get() {
      if (!this._fullListing) {
        this._fullListing = new _Listing2.default({
          slug: this.model.get('slug')
        }, {
          guid: this.ownerGuid
        });
      }

      return this._fullListing;
    }
  }, {
    key: 'viewType',
    get: function get() {
      return this._viewType;
    },
    set: function set(type) {
      if (['list', 'grid', 'cryptoList'].indexOf(type) === -1) {
        throw new Error('The provided view type is not one of the available types.');
      }

      // This just sets the flag. It's up to you to re-render.
      this._viewType = type;
    }
  }, {
    key: '$btnEdit',
    get: function get() {
      return this._$btnEdit || (this._$btnEdit = this.$('.js-edit'));
    }
  }, {
    key: '$btnDelete',
    get: function get() {
      return this._$btnDelete || (this._$btnDelete = this.$('.js-delete'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;