'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _backbone = require('backbone');

var _baseVw2 = require('./baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _StatusMessage = require('../models/StatusMessage');

var _StatusMessage2 = _interopRequireDefault(_StatusMessage);

var _StatusMessages = require('../collections/StatusMessages');

var _StatusMessages2 = _interopRequireDefault(_StatusMessages);

var _StatusMessage3 = require('./StatusMessage');

var _StatusMessage4 = _interopRequireDefault(_StatusMessage3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this));

    _this.collection = new _StatusMessages2.default();
    _this.vwRemoveTimeouts = [];
    _this.mdRemoveTimeouts = [];
    _this.listenTo(_this.collection, 'remove', _this.onRemoveMessage);
    return _this;
  }

  _createClass(_class, [{
    key: 'onRemoveMessage',
    value: function onRemoveMessage(md, cl, opts) {
      var _this2 = this;

      var vw = this.msgViews.splice(opts.index, 1)[0];

      vw.$el.removeClass('slideUp');

      // give any animations some time to complete and then remove the view
      var timeout = setTimeout(function () {
        vw.remove();
        _this2.vwRemoveTimeouts.splice(timeout, 1);
      }, 50000);

      this.vwRemoveTimeouts.push(timeout);
    }

    /* Internal method used by pushMessage to add a new status message. Use pushMessage publicly. */

  }, {
    key: 'addMessage',
    value: function addMessage(md) {
      var _this3 = this;

      var View = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _StatusMessage4.default;

      if (!md) {
        throw new Error('Please provide a model.');
      }

      var vw = new View({ model: md });

      if (!(vw instanceof _StatusMessage4.default)) {
        throw new Error('The view must be an instance of the StatusMessageVw.');
      }

      var duration = md.get('duration');

      this.collection.add(md);
      this.msgViews = this.msgViews || [];
      this.$el.prepend(vw.render().el);
      this.registerChild(vw);
      this.msgViews.push(vw);

      setTimeout(function () {
        vw.$el.addClass('slideUp');
      }, 100);

      var timeout = setTimeout(function () {
        _this3.collection.remove(md);
        _this3.mdRemoveTimeouts.splice(timeout, 1);
      }, duration);

      this.mdRemoveTimeouts.push(timeout);

      return vw;
    }

    /**
     * Add a new status message.
     * @param {string|Object} msg - The status message to be displayed. Defaults are driven
        by the StatusMessage model.
     * @param {string} msg.msg - The text of the message to be displayed.
     * @param {string} [msg.type=msg] - Type of message. Available types are driven by the
        StatusMessage model.
     * @param {number} [msg.duration=2500] - The length of time before status msg is removed.
        Pass in a really large number if you rather remove the status msg yourself.
     * @return {object} An object with methods that control the the generated status msg.
     */

  }, {
    key: 'pushMessage',
    value: function pushMessage(msg) {
      var _this4 = this;

      if (!msg || typeof msg !== 'string' && (typeof msg === 'undefined' ? 'undefined' : _typeof(msg)) !== 'object') {
        throw new Error('Please provide a msg as a string or an object.');
      }

      var msgObj = typeof msg === 'string' ? { msg: msg } : msg;
      var md = new _StatusMessage2.default();
      md.set(msgObj, { validate: true });

      if (Object.keys(md.validationError || {}).length) {
        throw new Error(md.validationError[Object.keys(md.validationError)[0]]);
      }

      var update = function update(message) {
        if (!message) {
          throw new Error('Please provide a msg.');
        }

        if (typeof message === 'string') {
          md.set('msg', message);
        } else {
          // For now, duration can't be updated. If you desire to control the duration
          // programatically, pass in a really large duration with pushMessage and then
          // call remove() whenever it suits you.
          delete message.duration;
          md.set(message);
        }
      };

      var vw = this.addMessage(md, msgObj.View);

      var returnObj = _extends({
        remove: function remove() {
          return _this4.collection.remove(md);
        },
        update: update
      }, _backbone.Events);

      // Proxy through events so our returned object passes through
      // any click events.
      vw.on('all', function (event) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        return returnObj.trigger.apply(returnObj, [event].concat(args));
      });

      return returnObj;
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.vwRemoveTimeouts.forEach(function (timeout) {
        return clearTimeout(timeout);
      });
      this.mdRemoveTimeouts.forEach(function (timeout) {
        return clearTimeout(timeout);
      });
      this.super();
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;