'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _object = require('../utils/object');

var _backbone = require('backbone');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var baseVw = function (_View) {
  _inherits(baseVw, _View);

  function baseVw() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, baseVw);

    var _this = _possibleConstructorReturn(this, (baseVw.__proto__ || Object.getPrototypeOf(baseVw)).call(this, options));

    _this._childViews = [];
    _this._unregisterFromParent = true;
    _this._removed = false;
    _this._state = _extends({}, options.initialState || {});
    return _this;
  }

  /**
   * This is a way to handle most common scenarios of getting data
   * from your form into a JS object. This function is very much a
   * work in progress. If you have a change that would be appropriate
   * for most forms, feel free to add it here.
   *
   * If you need some custom form parsing that's specific to your form,
   * please override this method in your view.
   * TODO: give example of overriding this function, while still using it
   * for most of your form, but only customizing one field
   *
   * Since form values are pulled in as strings, if you want them to be
   * pulled in as a different type, add a data-var-type attribute to the
   * field, e.g. data-var-type="boolean". As of now, only 'boolean' and
   * 'number' are supported, but feel free to add in more if it makes sense
   * for them to be in such a common function.
   *
   * @param {string or jQuery object} selector - A css selector string used to
   *   obtain the fields to extract data from. The selector will be scoped to
   *   this view (i.e. this.$('<selector>')). The default is
   *   'select[name], input[name], textarea[name]'. Alternatively, you can provide
   *   a jQuery object, which gives you more control (and useful for caching).
   *
   * @return {object} An object created from the data in the form fields
   */


  _createClass(baseVw, [{
    key: 'getFormData',
    value: function getFormData(selector) {
      var $formFields = selector instanceof _jquery2.default ? selector : this.$(selector || 'select[name], input[name],\n        textarea[name]:not([class*="trumbowyg"]),\n        div[contenteditable][name]');
      var data = {};

      $formFields.each(function (index, field) {
        var $field = (0, _jquery2.default)(field);
        var varType = $field.data('var-type');

        var val = $field.val();

        if (field.tagName.toUpperCase() === 'DIV') {
          val = field.innerHTML;
        }

        if (field.type === 'radio' && !field.checked) return;

        if (varType) {
          if (varType === 'number') {
            // If an empty string is provided or if the
            // number evaluates to NaN, we'll leave the value
            // as is, so client side validation can catch it
            // and the user can update it.
            if (val.trim() !== '') {
              var numberFromVal = Number(val);

              if (!isNaN(numberFromVal)) {
                val = numberFromVal;
              }
            }
          } else if (varType === 'boolean') {
            val = val === 'true';
          }
        }

        if (field.type === 'checkbox') {
          val = (0, _jquery2.default)(field).is(':checked');
        }

        var name = $field.attr('name');

        if (name.indexOf('[') !== -1) {
          // handle nested collection
          // for now not handling nested collection, please
          // manage manually
          data[name] = val;
        } else if (name.indexOf('.') !== -1) {
          // handle nested model
          (0, _object.setDeepValue)(data, name, val);
        } else {
          data[name] = val;
        }
      });

      return data;
    }

    /**
     * Will scroll to the given element. The element must be within this view.
     * @param {string|object} selector - A CSS selector or a DOM element or a jQuery object.
     */

  }, {
    key: 'scrollTo',
    value: function scrollTo(selector) {
      if (!selector) {
        throw new Error('Please provide a selector');
      }

      if (!(typeof selector === 'string' || _underscore2.default.isElement(selector) || selector instanceof _jquery2.default)) {
        throw new Error('The selector must be a string, DOM element or jQuery object.');
      }

      var $el = void 0;

      if (typeof selector === 'string') {
        $el = this.getCachedEl(selector);
      } else if (!(selector instanceof _jquery2.default)) {
        $el = (0, _jquery2.default)(selector);
      }

      $el[0].scrollIntoView();
    }

    /**
     * If you are creating child views within your view, call this method
     * to register them. This will ensure that they will have their remove
     * method called if the parent is removed.
     */

  }, {
    key: 'registerChild',
    value: function registerChild(childView) {
      if (this._childViews.indexOf(childView) === -1) {
        this._childViews.push(childView);
        childView._parentView = this;
      }
    }

    /**
     * Opposite of registerChild. This method is automatically
     * called by remove. For all practical purposes, you probably
     * won't need to call this method directly.
     */

  }, {
    key: 'unregisterChild',
    value: function unregisterChild(childView) {
      var index = this._childViews.indexOf(childView);

      if (index !== -1) {
        this._childViews.splice(index, 1);
        childView._parentView = null;
      }
    }

    /**
     * Shortcut method to instantiate a view and register it as a child.
     * @param {function} ChildView - The class of the child view (not instance).
     * @param {...*} args - Remaining arguments will be passed into the constuctor
     *   when instantiating the child view.
     * @return {object} The create child view instance.
     */

  }, {
    key: 'createChild',
    value: function createChild(ChildView) {
      if (typeof ChildView !== 'function') {
        throw new Error('Please provide a ChildView class.');
      }

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var childView = new (Function.prototype.bind.apply(ChildView, [null].concat(args)))();
      this.registerChild(childView);

      return childView;
    }
  }, {
    key: 'delegateEvents',
    value: function delegateEvents() {
      if (this._childViews) {
        this._childViews.forEach(function (view) {
          view.delegateEvents();
        });
      }

      _get(baseVw.prototype.__proto__ || Object.getPrototypeOf(baseVw.prototype), 'delegateEvents', this).call(this);
    }

    /**
     * Returns a given jQuery Element or a locally cached version for optimization.
     * NOTE: Ensure that child views call super.render() in their render function to clear the cache
     *       since the DOM elements in the cache will then be stale references.
     * @param {selector} string - The jQuery selector for the Element.
     *
     * @return {element} JQuery The element(s) found in the View's Dom or the View's Cache
     */

  }, {
    key: 'getCachedEl',
    value: function getCachedEl(selector) {
      var element = void 0;

      // Ensure we have our cached elements map.
      if (!this._cachedElementMap) {
        this._cachedElementMap = new Map();
      }

      // If the cache has the element, we shall use it.
      if (this._cachedElementMap.has(selector)) {
        element = this._cachedElementMap.get(selector);
      } else {
        // The cache does not not have the element, therefore query with jQuery and cache it.
        element = this.$(selector);
        this._cachedElementMap.set(selector, element);
      }

      return element;
    }

    /**
     * Clears the cached elements map.
     */

  }, {
    key: 'clearCachedElementMap',
    value: function clearCachedElementMap() {
      // Clear the cache map.
      if (this._cachedElementMap) {
        this._cachedElementMap.clear();
      }
    }

    /**
     * Returns this view's state object.
     */

  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }

    /**
     * Sets this view's state object.
     * @param {object} state - The new state data. By default, this is merged into
     *   the existing state. To replace the state use the replace option.
     * @param {object} options
     * @param {boolean} [options.renderOnChange = true] - If true, will re-render the view
     *   if the resulting state changes. Setting this to false should be done very judiciously
     *   since it will result in your view not being in sync with its state.
     * @param {boolean} [options.replace = false] - If true, will replace the entire state
     *   with the given state. Otherwise, the given state will be merged in.
     * @return {object} The create child view instance.
     */

  }, {
    key: 'setState',
    value: function setState(state) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var opts = _extends({
        renderOnChange: true,
        replace: false
      }, options);
      var newState = void 0;

      if (opts.replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        if (opts.renderOnChange) this.render();
      }

      return this;
    }

    /** It is necessary to call super.render() in child views' render methods if using
     *  getCachedEl()
     *  @param {this} Render requires this to be returned.
     */

  }, {
    key: 'render',
    value: function render() {
      this.clearCachedElementMap();
      return this;
    }

    // Will call the remove method of any child views.

  }, {
    key: 'remove',
    value: function remove() {
      for (var i = 0; i < this._childViews.length; i++) {
        // no need to unregister child from parent,
        // since the parent is also being removed
        this._childViews[i]._unregisterFromParent = false;
        this._childViews[i].remove();
      }

      if (this._parentView && this._unregisterFromParent) {
        this._parentView.unregisterChild(this);
      }

      _get(baseVw.prototype.__proto__ || Object.getPrototypeOf(baseVw.prototype), 'remove', this).call(this);

      this._removed = true;
    }
  }, {
    key: 'isRemoved',
    value: function isRemoved() {
      return this._removed;
    }
  }]);

  return baseVw;
}(_backbone.View);

exports.default = baseVw;