'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _electron = require('electron');

require('../../utils/lib/velocity');

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _selectors = require('../../utils/selectors');

var _dom = require('../../utils/dom');

var _serverConnect = require('../../utils/serverConnect');

var _notification = require('../../utils/notification');

var _block = require('../../utils/block');

var _responsive = require('../../utils/responsive');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Profile = require('../../models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _ChatHeads = require('./ChatHeads');

var _ChatHeads2 = _interopRequireDefault(_ChatHeads);

var _Conversation = require('./Conversation');

var _Conversation2 = _interopRequireDefault(_Conversation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a chat heads collection.');
    }

    if (!options.$scrollContainer) {
      throw new Error('Please provide a jQuery object containing the scrollable element ' + 'this view is in.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this._isOpen = false;
    _this.$scrollContainer = options.$scrollContainer;
    _this.throttledOnScroll = _underscore2.default.throttle(_this.onScroll, 100).bind(_this);
    _this.debouncedOnProfileFetchScroll = _underscore2.default.debounce(_this.onProfileFetchScroll, 200).bind(_this);
    _this.profileDeferreds = {};
    _this.fetching = false;
    _this.fetchError = false;

    _this.listenTo(_this.collection, 'sync', function () {
      _this.fetching = false;
      _this.fetchError = false;
      _this.render();
    });

    _this.listenTo(_this.collection, 'request', function () {
      clearTimeout(_this.fakeErrorLatencyTimeout);
      _this.fetching = true;
      _this.fetchError = false;
      _this.render();
    });

    _this.listenTo(_this.collection, 'error', function (cl, resp) {
      _this.fakeErrorLatencyTimeout = setTimeout(function () {
        _this.fetching = false;
        _this.fetchError = true;
        _this.fetchErrorMessage = resp.responseJSON && resp.responseJSON.reason || '';
        _this.render();
      }, 300);
    });

    _this.listenTo(_this.collection, 'update change:unread', function () {
      (0, _notification.setUnreadChatMsgCount)(_this.collection.totalUnreadCount);
    });

    _this.socket = (0, _serverConnect.getSocket)();

    if (_this.socket) {
      _this.listenTo(_this.socket, 'message', _this.onSocketMessage);
    }

    _this.listenTo(_block.events, 'blocked', function (data) {
      _this.collection.remove(data.peerIds);
      if (_this.conversation && data.peerIds.includes(_this.conversation.guid)) {
        _this.removeConvo();
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'chat';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-topUnreadBanner': 'onClickTopUnreadBanner',
        'click .js-bottomUnreadBanner': 'onClickBottomUnreadBanner',
        'click .js-fetchStateHead': 'onClickFetchStateHead',
        'click .js-retryFetchConvos': 'onClickRetryConvoFetch'
      };
    }
  }, {
    key: 'onChatHeadClick',
    value: function onChatHeadClick(e) {
      if (!this.isOpen) {
        this.open();
      }

      var profilePromise = this.fetchProfiles([e.view.model.id])[0];
      this._openConversation(e.view.model.id, profilePromise, e.view.model);
    }
  }, {
    key: 'onChatHeadsRendered',
    value: function onChatHeadsRendered() {
      if (this.chatHeads.views.length) {
        this.handleUnreadBadge();
      }
    }
  }, {
    key: 'onScroll',
    value: function onScroll() {
      this.handleUnreadBadge();
    }
  }, {
    key: 'onProfileFetchScroll',
    value: function onProfileFetchScroll() {
      this.fetchProfileOfVisibleChatHeads();
    }
  }, {
    key: 'onClickTopUnreadBanner',
    value: function onClickTopUnreadBanner() {
      // Find the first chat head with unreads that is out of view above
      // the current viewport and scroll to it so it is positioned at the
      // bottom of the viewport.
      var firstChatHeadAbove = this.chatHeads.views.filter(function (chatHead) {
        return chatHead.model.get('unread');
      }).slice().reverse().find(function (chatHead) {
        var position = chatHead.$el.position();

        return position.top <= chatHead.el.offsetHeight * -1;
      });

      if (firstChatHeadAbove) {
        firstChatHeadAbove.$el.velocity('scroll', {
          container: this.$scrollContainer,
          offset: this.$scrollContainer[0].offsetHeight * -1
        });
      }
    }
  }, {
    key: 'onClickBottomUnreadBanner',
    value: function onClickBottomUnreadBanner() {
      var _this2 = this;

      // Find the first chat head with unreads that is out of view below
      // the current viewport and scroll to it.
      var firstChatHeadBelow = this.chatHeads.views.filter(function (chatHead) {
        return chatHead.model.get('unread');
      }).find(function (chatHead) {
        var position = chatHead.$el.position();

        return position.top >= _this2.$scrollContainer[0].offsetHeight;
      });

      if (firstChatHeadBelow) {
        firstChatHeadBelow.$el.velocity('scroll', { container: this.$scrollContainer });
      }
    }
  }, {
    key: 'onSocketMessage',
    value: function onSocketMessage(e) {
      this.onNewChatMessage(e.jsonData.message);
    }
  }, {
    key: 'onNewChatMessage',
    value: function onNewChatMessage(msg) {
      if (msg && !msg.subject) {
        var chatHead = this.collection.get(msg.peerId);
        var chatHeadData = {
          peerId: msg.peerId,
          lastMessage: msg.message,
          timestamp: msg.timestamp,
          outgoing: msg.outgoing || false,
          unread: msg.outgoing ? 0 : 1
        };
        var isConvoOpen = this.conversation && this.conversation.guid === msg.peerId && this.conversation.isOpen;

        if (chatHead) {
          if (!msg.outgoing) {
            chatHeadData.unread = document.hasFocus() && isConvoOpen ? 0 : chatHead.get('unread') + 1;

            if (!document.hasFocus() || !isConvoOpen) {
              var notifOptions = {
                onclick: function onclick() {
                  _electron.remote.getCurrentWindow().restore();
                  location.hash = '#' + msg.peerId;
                },

                body: msg.message
              };
              var handle = '';

              // If the profile is cached, we'll add in some additional data. If it's not,
              // we won't hold up the notification for it to return.
              var profilePromise = (0, _Profile.getCachedProfiles)([msg.peerId])[0];

              if (profilePromise.state() === 'resolved') {
                profilePromise.done(function (profile) {
                  handle = profile.get('handle') || '';
                  var avatarHashes = profile.get('avatarHashes') && profile.get('avatarHashes').toJSON() || {};
                  var imageHash = _responsive.isHiRez ? avatarHashes.medium : avatarHashes.small;

                  if (imageHash) {
                    notifOptions.icon = _app2.default.getServerUrl('ob/images/' + imageHash);
                  }
                });
              }

              (0, _notification.launchNativeNotification)(handle || msg.peerId, notifOptions);
            }

            // Remove any existing chat head so we could put it back in at the top.
            this.collection.remove(chatHead);
          } else {
            chatHeadData.unread = chatHead.get('unread');
          }
        }

        this.collection.add(chatHeadData, {
          at: 0,
          merge: true,
          parse: true
        });
      }
    }
  }, {
    key: 'onConvoMarkedAsRead',
    value: function onConvoMarkedAsRead(guid) {
      if (!guid) {
        throw new Error('Please provide a guid.');
      }

      if (!this.conversation.isOpen) return;

      var chatHead = this.collection.get(guid);

      if (chatHead) chatHead.set('unread', 0);
    }
  }, {
    key: 'onClickFetchStateHead',
    value: function onClickFetchStateHead() {
      if (!this.isOpen) {
        this.open();
      }
    }
  }, {
    key: 'onClickRetryConvoFetch',
    value: function onClickRetryConvoFetch() {
      this.collection.fetch();
    }

    /**
     * Outside of this view, please use the "public" openConversation().
     */

  }, {
    key: '_openConversation',
    value: function _openConversation(guid, profilePromise) {
      var _this3 = this;

      this.open();

      if (this.chatHeads) {
        this.clearActiveChatHead();

        // If there's a chat head, mark it as active
        var chatHeadModel = this.collection.get(guid);

        if (chatHeadModel) {
          this.chatHeads.views[this.collection.indexOf(chatHeadModel)].$el.addClass('active');
        }
      }

      if (this.conversation && this.conversation.guid === guid) {
        // In order for the chat head unread count to update properly, be sure to
        // open before marking convo as read.
        this.conversation.open();
        return;
      }

      var oldConvo = this.conversation;

      this.conversation = this.createChild(_Conversation2.default, {
        guid: guid,
        profile: profilePromise
      });

      this.listenTo(this.conversation, 'clickCloseConvo', function () {
        return _this3.closeConversation();
      });

      this.listenTo(this.conversation, 'newOutgoingMessage', function (e) {
        return _this3.onNewChatMessage(e.model.toJSON());
      });

      this.listenTo(this.conversation, 'convoMarkedAsRead', function () {
        return _this3.onConvoMarkedAsRead(guid);
      });

      this.listenTo(this.conversation, 'deleting', function (e) {
        e.request.done(function () {
          _this3.collection.remove(e.guid);
          if (_this3.conversation && _this3.conversation.guid === e.guid) {
            _this3.removeConvo();
          }
        });
      });

      this.$chatConvoContainer.append(this.conversation.render().el);

      this.conversation.open();

      if (oldConvo) oldConvo.remove();
    }
  }, {
    key: 'openConversation',
    value: function openConversation(guid, profile) {
      if (!guid) {
        throw new Error('Please provide a guid.');
      }

      if (typeof profile !== 'undefined' && !(profile instanceof _Profile2.default)) {
        throw new Error('If providing a profile, it must be an instance of the profile model.');
      }

      var profilePromise = void 0;

      if (profile) {
        // If the profile model is provided, we'll turn it into a deferred.
        var deferred = _jquery2.default.Deferred();
        this.profileDeferreds[guid] = deferred;
        deferred.resolve(profile);
        profilePromise = deferred.promise();
      } else {
        // If not providing the profile, we'll fetch it.
        profilePromise = this.fetchProfiles([guid])[0];
      }

      this._openConversation(guid, profilePromise);
    }
  }, {
    key: 'closeConversation',
    value: function closeConversation() {
      this.clearActiveChatHead();
      if (this.conversation) this.conversation.close();
    }
  }, {
    key: 'removeConvo',
    value: function removeConvo() {
      if (this.conversation) {
        this.conversation.close();
        this.conversation.remove();
        this.conversation = null;

        if (!this.collection.length) {
          this.close();
        }
      }
    }
  }, {
    key: 'clearActiveChatHead',
    value: function clearActiveChatHead() {
      if (this.chatHeads) {
        this.chatHeads.views.forEach(function (chatHead) {
          return chatHead.$el.removeClass('active');
        });
      }
    }
  }, {
    key: 'open',
    value: function open() {
      if (this._isOpen) return;
      this._isOpen = true;
      (0, _selectors.getBody)().addClass('chatOpen');
    }
  }, {
    key: 'close',
    value: function close() {
      if (!this._isOpen) return;
      this._isOpen = false;
      (0, _selectors.getBody)().removeClass('chatOpen');
      this.closeConversation();
    }
  }, {
    key: 'show',


    /**
     * This chat view, may need to know when it becomes visible,
     * so please show it via this method.
     */
    value: function show() {
      this.$el.removeClass('hide');
      return this;
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.$el.addClass('hide');
      return this;
    }

    /**
     * This chat view mey need to know when it is attached to the dom,
     * so please use this method to do so.
     */

  }, {
    key: 'attach',
    value: function attach(container) {
      if (!container || !(container instanceof _jquery2.default && container[0] instanceof HTMLElement)) {
        throw new Error('Please provide a container as a jQuery object or DOM element.');
      }

      (0, _jquery2.default)(container).append(this.el);
      this.fetchProfileOfVisibleChatHeads();

      return this;
    }

    /**
     * Adds css classes to our scroll element indicating whether the unread messages
     * badges (top and / or bottom) need to be shown.
     */

  }, {
    key: 'handleUnreadBadge',
    value: function handleUnreadBadge() {
      if (!this.chatHeads) return;

      var firstUnreadChatHead = this.collection.find(function (chatHead) {
        return chatHead.get('unread');
      });

      // todo: update isScrolledIntoView so that you could pass in an offset to
      // determine if a certain portion of the el is out of view rather than the
      // whole element

      if (firstUnreadChatHead) {
        var firstUnreadIndex = this.collection.indexOf(firstUnreadChatHead);

        if (!(0, _dom.isScrolledIntoView)(this.chatHeads.views[firstUnreadIndex].el)) {
          this.$el.addClass('outOfViewUnreadsAbove');
        } else {
          this.$el.removeClass('outOfViewUnreadsAbove');
        }
      } else {
        this.$el.removeClass('outOfViewUnreadsAbove outOfViewUnreadsBelow');
        return;
      }

      var lastUnreadChatHead = this.collection.slice().reverse().find(function (chatHead) {
        return chatHead.get('unread');
      });

      if (lastUnreadChatHead && lastUnreadChatHead !== firstUnreadChatHead) {
        var lastUnreadIndex = this.collection.indexOf(lastUnreadChatHead);

        if (!(0, _dom.isScrolledIntoView)(this.chatHeads.views[lastUnreadIndex].el)) {
          this.$el.addClass('outOfViewUnreadsBelow');
        } else {
          this.$el.removeClass('outOfViewUnreadsBelow');
        }
      } else {
        this.$el.removeClass('outOfViewUnreadsBelow');
      }
    }
  }, {
    key: 'fetchProfiles',
    value: function fetchProfiles(peerIds) {
      var _this4 = this;

      if (!Array.isArray(peerIds)) {
        throw new Error('Please provide a list of peerIds.');
      }

      if (!peerIds.length) {
        throw new Error('Please provide at least one peerId');
      }

      var profilePromises = (0, _Profile.getCachedProfiles)(peerIds);

      profilePromises.forEach(function (profileFetch) {
        profileFetch.done(function (profile) {
          return _this4.chatHeads.setProfile(profile);
        });
      });

      return profilePromises;
    }
  }, {
    key: 'fetchProfileOfVisibleChatHeads',
    value: function fetchProfileOfVisibleChatHeads() {
      var _this5 = this;

      if (!this.chatHeads || !this.chatHeads.views.length) return;
      this.chatHeadProfilesFetched = this.chatHeadProfilesFetched || [];

      // Find which heads are in the viewport and filter out any that have already
      // had or are having their profiles fetched.
      var profilesToFetch = this.chatHeads.views.filter(function (chatHead) {
        var peerId = chatHead.model.get('peerId');
        var alreadyFetched = _this5.chatHeadProfilesFetched.indexOf(peerId) > -1;
        return !alreadyFetched && (0, _dom.isScrolledIntoView)(chatHead.el);
      }).map(function (chatHead) {
        return chatHead.model.get('peerId');
      });

      if (profilesToFetch.length) {
        this.chatHeadProfilesFetched.concat(profilesToFetch);
        this.fetchProfiles(profilesToFetch);
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      clearTimeout(this.fakeErrorLatencyTimeout);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      (0, _loadTemplate2.default)('chat/chat.html', function (t) {
        _this6.$el.html(t({
          fetching: _this6.fetching,
          fetchError: _this6.fetchError,
          fetchErrorMessage: _this6.fetchErrorMessage
        }));

        if (_this6.chatHeads) _this6.chatHeads.remove();
        _this6.chatHeads = _this6.createChild(_ChatHeads2.default, {
          collection: _this6.collection,
          $scrollContainer: _this6.$scrollContainer
        });

        _this6.listenTo(_this6.chatHeads, 'chatHeadClick', _this6.onChatHeadClick);
        _this6.listenTo(_this6.chatHeads, 'rendered', _this6.onChatHeadsRendered);

        // It is important that both of the following occur before the chatHeads
        // view is rendered:
        // - the 'rendered' event is bound
        // - the chatHeads view's el is added to the DOM
        //
        // This is important because handleUnreadBadge() needs the chatHead elements
        // to be visible in the DOM for it to work properly.
        _this6.listenTo(_this6.chatHeads, 'rendered', _this6.onChatHeadsRendered);
        _this6.$('.js-chatHeadsContainer').html(_this6.chatHeads.el);
        _this6.chatHeads.render();

        _this6.$scrollContainer.off('scroll', _this6.throttledOnScroll).on('scroll', _this6.throttledOnScroll);

        _this6.$scrollContainer.off('scroll', _this6.debouncedOnProfileFetchScroll).on('scroll', _this6.debouncedOnProfileFetchScroll);

        _this6.fetchProfileOfVisibleChatHeads();
      });

      return this;
    }
  }, {
    key: 'isOpen',
    get: function get() {
      return this._isOpen;
    }
  }, {
    key: '$chatConvoContainer',
    get: function get() {
      return this._$chatConvoContainer || (this._$chatConvoContainer = (0, _jquery2.default)('#chatConvoContainer'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;