'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.buildRefreshAlertMessage = buildRefreshAlertMessage;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _string = require('../../utils/string');

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class(options) {
    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    var opts = _extends({
      dismissable: false
    }, options);

    _this.options = opts;

    // Use messageText if you're providing inline content which the template
    // will wrap in a <p>. Otherwise, use messageHTML and provide the full markup.
    if (!options.messageText && !options.messageHTML) {
      throw new Error('Please provide a messageText or messageHTML');
    }

    if (options.messageText && options.messageHTML) {
      throw new Error('Please provide only one of messageText or messageHTML');
    }

    _this._state = _extends({}, opts, opts.initialState || {});
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'popInMessage clrP border clrBrT pad tx5 clrSh1';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click [class^="js-"], [class*=" js-"]': 'onClick'
      };
    }
  }, {
    key: 'onClick',
    value: function onClick(e) {
      var _this2 = this;

      // If the the el has a '.js-<class>' class, we'll trigger a
      // 'click<Class>' event from this view.
      var events = [];

      e.currentTarget.classList.forEach(function (className) {
        if (className.startsWith('js-')) events.push(className.slice(3));
      });

      if (events.length) {
        events.forEach(function (event) {
          _this2.trigger('click' + (0, _string.capitalize)(event), { view: _this2, e: e });
        });
      }
    }
  }, {
    key: 'setState',
    value: function setState() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var newState = _extends({}, this._state, state);

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }
    }
  }, {
    key: 'replaceState',
    value: function replaceState() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!_underscore2.default.isEqual(this._state, state)) {
        this._state = state;
        this.render();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('./components/popInMessage.html', function (tmpl) {
        _this3.$el.html(tmpl(_this3._state));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;
function buildRefreshAlertMessage(text) {
  if (typeof text !== 'string') {
    throw new Error('Please provide text as string.');
  }

  return _app2.default.polyglot.t('refreshAlertPopInMessage.message', {
    icon: '<span class="ion-alert-circled"></span>',
    message: '<b>' + text + '</b>',
    refreshLink: '<a class="clrTEm js-refresh">' + _app2.default.polyglot.t('refreshAlertPopInMessage.refreshLink') + '</a>'
  });
}