'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _inventory = require('../../utils/inventory');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (typeof options.peerId !== 'string' || !options.peerId) {
      throw new Error('Please provide a peerId.');
    }

    if (typeof options.slug !== 'string' || !options.slug) {
      throw new Error('Please provide a slug.');
    }

    var opts = _extends({}, options, {
      initialState: _extends({
        isFetching: (0, _inventory.isFetching)(options.peerId, { slug: options.slug }),
        fetchFailed: false,
        fetchError: '',
        coinType: '',
        coinDivisibility: 100000000,
        contentClass: 'txB',
        spinnerClass: 'spinnerSm',
        tipClass: 'clrT tx5 txCtr',
        localCur: _app2.default.settings.get('localCurrency')
      }, options.initialState)
    });

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = options;

    _this.listenTo(_inventory.events, 'inventory-fetching', function (e) {
      if (e.peerId !== options.peerId || e.slug && e.slug !== options.slug) return;
      _this.setState({
        isFetching: true,
        fetchFailed: false,
        fetchError: ''
      });
    });

    _this.listenTo(_inventory.events, 'inventory-fetch-fail', function (e) {
      if (e.peerId !== options.peerId || e.slug && e.slug !== options.slug) return;
      _this.setState({
        isFetching: false,
        fetchFailed: true,
        fetchError: e.xhr && e.xhr.responseJSON && e.xhr.responseJSON.reason || ''
      });
    });

    _this.listenTo(_inventory.events, 'inventory-fetch-success', function (e) {
      if (e.peerId !== options.peerId || e.slug && e.slug !== options.slug) return;
      _this.setState({ isFetching: false });
    });

    _this.listenTo(_inventory.events, 'inventory-change', function (e) {
      if (e.peerId !== options.peerId || e.slug !== options.slug) return;
      _this.setState({ amount: e.inventory });
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'quantityDisplay';
    }
  }, {
    key: 'tagName',
    value: function tagName() {
      return 'span';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-retry': 'onClickRetry'
      };
    }
  }, {
    key: 'onClickRetry',
    value: function onClickRetry() {
      this.inventoryFetch = (0, _inventory.getInventory)(this.options.peerId, {
        slug: this.options.slug,
        coinDivisibility: this.getState().coinDivisibility
      });
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.inventoryFetch) this.inventoryFetch.abort();
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('components/quantityDisplay.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.getState())));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;