'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _follow = require('../../utils/follow');

var _BlockBtn = require('./BlockBtn');

var _BlockBtn2 = _interopRequireDefault(_BlockBtn);

var _metrics = require('../../utils/metrics');

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.targetID) throw new Error('You must provide a targetID');

    var opts = _extends({}, options, {
      initialState: _extends({
        following: (0, _follow.followedByYou)(options.targetID),
        isFollowing: false,
        stripClasses: 'btnStrip clrSh3',
        btnClasses: 'clrP clrBr'
      }, options.initialState || {})
    });

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this.listenTo(_app2.default.ownFollowing, 'update', function () {
      _this.setState({
        following: (0, _follow.followedByYou)(options.targetID)
      });
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'socialBtns';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-followUnfollowBtn': 'onClickFollow',
        'click .js-messageBtn': 'onClickMessage'
      };
    }
  }, {
    key: 'onClickMessage',
    value: function onClickMessage() {
      // activate the chat message
      _app2.default.chat.openConversation(this.options.targetID);
      (0, _metrics.recordEvent)('Social_OpenChat');
    }
  }, {
    key: 'onClickFollow',
    value: function onClickFollow() {
      var _this2 = this;

      var type = this.getState().following ? 'unfollow' : 'follow';
      this.setState({ isFollowing: true });
      this.folCall = (0, _follow.followUnfollow)(this.options.targetID, type).always(function () {
        if (_this2.isRemoved()) return;
        _this2.setState({ isFollowing: false });
      });
      if (type === 'follow') {
        (0, _metrics.recordEvent)('Social_Follow');
      } else {
        (0, _metrics.recordEvent)('Social_Unfollow');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      var state = this.getState();
      (0, _loadTemplate2.default)('components/socialBtns.html', function (t) {
        _this3.$el.html(t(_extends({}, _this3.options, state)));
      });

      this.getCachedEl('.js-blockBtnContainer').html(new _BlockBtn2.default({ targetId: this.options.targetID }).render().el);

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;