'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.getModeratorOptions = getModeratorOptions;
exports.getListingOptions = getListingOptions;

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _VerifiedMod = require('../../models/VerifiedMod');

var _VerifiedMod2 = _interopRequireDefault(_VerifiedMod);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _responsive = require('../../utils/responsive');

var _dom = require('../../utils/dom');

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({}, options, {
      initialState: _extends({
        verified: false,
        text: '',
        textClass: 'txB tx5b',
        textWrapperClass: 'flexVCent gutterHTn',
        infoIconClass: 'ion-information-circled clrT2',
        tipTitle: options.initialState && typeof options.initialState.tipTitle === 'undefined' && options.initialState.text || '',
        tipTitleClass: 'tx4 txB',
        titleWrapperClass: 'flexCent rowSm gutterHTn',
        tipBody: '',
        tipBodyClass: '',
        arrowClass: 'arrowBoxCenteredTop',
        badgeUrl: '',
        wrapInfoIcon: options.initialState && options.initialState.text || false
      }, options.initialState || {})
    });

    if (!opts.initialState.badgeUrl && _typeof(opts.badge) === 'object') {
      opts.initialState.badgeUrl = _responsive.isHiRez ? opts.badge.small : opts.badge.tiny;
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    (0, _dom.handleLinks)(_this.el);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'verifiedMod';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        click: 'onClick'
      };
    }
  }, {
    key: 'onClick',
    value: function onClick(e) {
      e.stopPropagation();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('/components/verifiedMod.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.getState())));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;


function getBaseOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var opts = _extends({
    shortText: true,
    shortTipTitle: false,
    verified: !!options.model
  }, options);

  if (opts.model && !(opts.model instanceof _VerifiedMod2.default)) {
    throw new Error('If providing a model, it should be an instance of ' + 'a VerifiedMod model.');
  }

  var textKey = opts.shortText ? 'titleShort' : 'titleLong';

  var tipTitleKey = opts.shortTipTitle ? 'titleShort' : 'titleLong';

  return {
    badge: opts.model && opts.model.get('type').badge || undefined,
    initialState: {
      verified: opts.verified,
      text: opts.verified ? _app2.default.polyglot.t('verifiedMod.modVerified.' + textKey) : _app2.default.polyglot.t('verifiedMod.modUnverified.' + textKey),
      tipTitle: opts.verified ? _app2.default.polyglot.t('verifiedMod.modVerified.' + tipTitleKey) : _app2.default.polyglot.t('verifiedMod.modUnverified.' + tipTitleKey)
    }
  };
}

function getModeratorOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var opts = _extends({
    verified: !!options.model
  }, options);

  var baseOptions = getBaseOptions(options);

  return _extends({}, baseOptions, {
    initialState: _extends({}, baseOptions.initialState, {
      tipBody: opts.verified ? _app2.default.polyglot.t('verifiedMod.modVerified.tipBody', {
        name: '<b>' + _app2.default.verifiedMods.data.name + '</b>',
        link: _app2.default.verifiedMods.data.link ? '<a class="txU noWrap" href="' + _app2.default.verifiedMods.data.link + '" data-open-external>' + (_app2.default.polyglot.t('verifiedMod.modVerified.link') + '</a>') : ''
      }) : _app2.default.polyglot.t('verifiedMod.modUnverified.tipBody', {
        name: '<b>' + _app2.default.verifiedMods.data.name + '</b>',
        not: '<b>' + _app2.default.polyglot.t('verifiedMod.modUnverified.not') + '</b>'
      })
    })
  });
}

function getListingOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var opts = _extends({
    verified: !!options.model
  }, options);

  var baseOptions = getBaseOptions(options);

  return _extends({}, baseOptions, {
    initialState: _extends({}, baseOptions.initialState, {
      text: '',
      tipBody: opts.verified ? _app2.default.polyglot.t('verifiedMod.listingVerified.tipBody', {
        name: '<b>' + _app2.default.verifiedMods.data.name + '</b>',
        link: _app2.default.verifiedMods.data.link ? '<a class="txU noWrap" href="' + _app2.default.verifiedMods.data.link + '" data-open-external>' + (_app2.default.polyglot.t('verifiedMod.listingVerified.link') + '</a>') : ''
      }) : _app2.default.polyglot.t('verifiedMod.listingUnverified.tipBody', {
        name: '<b>' + _app2.default.verifiedMods.data.name + '</b>',
        not: '<b>' + _app2.default.polyglot.t('verifiedMod.listingUnverified.not') + '</b>'
      })
    })
  });
}