'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('../modals/BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      removeOnClose: true,
      showCloseButton: false,
      dismissOnEscPress: false
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.listenTo(_app2.default.settings, 'change:showNsfw', _this.onChangeNsfw);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' modalScrollPage modalMedium';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-cancel': 'onCancelClick',
        'click .js-btnProceed': 'onProceedClick'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onCancelClick',
    value: function onCancelClick() {
      this.trigger('canceled');
      this.close();
    }
  }, {
    key: 'onChangeNsfw',
    value: function onChangeNsfw(md, showNsfw) {
      if (showNsfw) this.close();
    }
  }, {
    key: 'onProceedClick',
    value: function onProceedClick() {
      if (this.getCachedEl('.js-checkboxNsfw').is(':checked')) {
        this.stopListening(_app2.default.settings, null, this.onChangeNsfw);
        _app2.default.settings.set('showNsfw', true);
        _jquery2.default.ajax({
          type: 'PATCH',
          url: _app2.default.getServerUrl('ob/settings/'),
          data: JSON.stringify({ showNsfw: true }),
          dataType: 'json'
        });
      }

      this.close();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/nsfwWarning.html', function (t) {
        _this2.$el.html(t({}));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this2).call(_this2);
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;