'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('./BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _SimpleMessage = require('./SimpleMessage');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this._state = _extends({
      reporting: false,
      reported: false
    }, options.initialState || {});

    if (!options.peerID) throw new Error('You must provide a peerID.');
    if (!options.slug) throw new Error('You must provide a slug.');
    if (!options.url) throw new Error('You must provide a url.');

    _this.peerID = options.peerID;
    _this.slug = options.slug;
    _this.url = options.url;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' modalTop modalScrollPage modalNarrow';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'keyup .js-otherInput': 'onKeyupOtherInput',
        'click input[value="Other"]': 'onOtherClick',
        'click .js-submit': 'onClickSubmit',
        'click .js-close': 'onClickClose'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onKeyupOtherInput',
    value: function onKeyupOtherInput() {
      this.getCachedEl('#ReasonOther').prop('checked', true);
    }
  }, {
    key: 'onOtherClick',
    value: function onOtherClick() {
      this.getCachedEl('.js-otherInput').focus();
    }
  }, {
    key: 'onClickSubmit',
    value: function onClickSubmit() {
      var _this2 = this;

      var data = {};
      data.peerID = this.peerID;
      data.slug = this.slug;
      var formData = this.getFormData();
      data.reason = formData.reason === 'Other' ? formData.other : formData.reason;
      this.setState({
        reporting: true
      });
      _jquery2.default.ajax({
        url: this.url,
        data: JSON.stringify(data),
        type: 'POST',
        dataType: 'json',
        contentType: 'application/json'
      }).done(function () {
        _this2.trigger('submitted');
        _this2.setState({
          reporting: false,
          reported: true
        });
      }).fail(function (xhr) {
        var failReason = xhr.responseJSON && xhr.responseJSON.reason || '';
        if (xhr.status === 404) failReason = _app2.default.polyglot.t('listingReport.error404');
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('listingReport.errorTitle'), failReason);
        _this2.setState({
          reporting: false,
          reported: false
        });
      });
    }
  }, {
    key: 'onClickClose',
    value: function onClickClose() {
      this.close();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/report.html', function (t) {
        _this3.$el.html(t(_extends({}, _this3.options, _this3._state)));

        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this3).call(_this3);
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;