'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _SimpleMessage = require('../SimpleMessage');

var _AddressesForm = require('./AddressesForm');

var _AddressesForm2 = _interopRequireDefault(_AddressesForm);

var _AddressesList = require('./AddressesList');

var _AddressesList2 = _interopRequireDefault(_AddressesList);

var _ShippingAddress = require('../../../models/settings/ShippingAddress');

var _ShippingAddress2 = _interopRequireDefault(_ShippingAddress);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, _extends({
      className: 'settingsAddresses'
    }, options)));

    _this.settings = _app2.default.settings.clone();

    // Sync our clone with any changes made to the global settings model.
    _this.listenTo(_app2.default.settings, 'someChange', function (md, opts) {
      return _this.settings.set(opts.setAttrs);
    });

    // Sync the global settings model with any changes we save via our clone.
    _this.listenTo(_this.settings, 'sync', function (md, resp, opts) {
      return _app2.default.settings.set(_this.settings.toJSON(opts.attrs));
    });

    _this.addressForm = _this.createChild(_AddressesForm2.default, { model: new _ShippingAddress2.default() });

    _this.addressList = _this.createChild(_AddressesList2.default, { collection: _this.settings.get('shippingAddresses') });
    _this.listenTo(_this.addressList, 'deleteAddress', _this.onDeleteAddress);
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-addAddress': 'saveNewAddress'
      };
    }
  }, {
    key: 'onDeleteAddress',
    value: function onDeleteAddress(address) {
      var shippingAddresses = this.settings.get('shippingAddresses');
      var removeIndex = shippingAddresses.indexOf(address);

      this.settings.set({}, { validate: true });

      if (!this.settings.validationError) {
        shippingAddresses.remove(address);
      } else {
        this.trigger('unrecognizedModelError', this, [this.settings]);
        return;
      }

      var save = this.settings.save({ shippingAddresses: shippingAddresses.toJSON() }, {
        attrs: { shippingAddresses: shippingAddresses.toJSON() },
        type: 'PATCH'
      });

      if (save) {
        var truncatedName = address.get('name').slice(0, 30);

        var msg = {
          msg: _app2.default.polyglot.t('settings.addressesTab.statusDeletingAddress', { name: '<em>' + truncatedName + '</em>' }),
          type: 'message'
        };

        var statusMessage = _app2.default.statusBar.pushMessage(_extends({}, msg, {
          duration: 9999999999999999
        }));

        save.done(function () {
          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.addressesTab.statusDeleteAddressComplete', { name: '<em>' + truncatedName + '</em>' }),
            type: 'confirmed'
          });
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          // put the address that failed to remove back in
          shippingAddresses.add(address, { at: removeIndex });

          var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';

          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.addressesTab.deleteAddressErrorAlertTitle', { name: '<em>' + truncatedName + '</em>' }), errMsg);

          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.addressesTab.statusDeleteAddressFailed', { name: '<em>' + truncatedName + '</em>' }),
            type: 'warning'
          });
        }).always(function () {
          return setTimeout(function () {
            return statusMessage.remove();
          }, 3000);
        });
      }
    }
  }, {
    key: 'saveNewAddress',
    value: function saveNewAddress() {
      var _this2 = this;

      var model = this.addressForm.model;
      var formData = this.addressForm.getFormData();

      model.set(formData);
      model.set(formData, { validate: true });
      this.settings.set({}, { validate: true });

      if (!this.settings.validationError && !model.validationError) {
        var shippingAddresses = this.settings.get('shippingAddresses');

        shippingAddresses.push(model);

        var save = this.settings.save({ shippingAddresses: shippingAddresses.toJSON() }, {
          attrs: { shippingAddresses: shippingAddresses.toJSON() },
          type: 'PATCH'
        });

        if (save) {
          this.$btnAddAddress.addClass('processing');
          var truncatedName = model.get('name').slice(0, 30);

          var msg = {
            msg: _app2.default.polyglot.t('settings.addressesTab.statusAddingAddress', { name: '<em>' + truncatedName + '</em>' }),
            type: 'message'
          };

          var statusMessage = _app2.default.statusBar.pushMessage(_extends({}, msg, {
            duration: 9999999999999999
          }));

          save.done(function () {
            statusMessage.update({
              msg: _app2.default.polyglot.t('settings.addressesTab.statusAddAddressComplete', { name: '<em>' + truncatedName + '</em>' }),
              type: 'confirmed'
            });

            _this2.addressForm.model = new _ShippingAddress2.default();
            _this2.addressForm.render();
          }).fail(function () {
            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              args[_key2] = arguments[_key2];
            }

            // remove the address that failed to add
            // todo: can't remove by passing in model instance from above because of some
            // weirdness with _clientID... investigate.
            var modelToRemove = shippingAddresses.findWhere({ name: model.get('name') });
            if (modelToRemove) shippingAddresses.remove(modelToRemove);

            var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';

            (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.addressesTab.addAddressErrorAlertTitle', { name: '<em>' + truncatedName + '</em>' }), errMsg);

            statusMessage.update({
              msg: _app2.default.polyglot.t('settings.addressesTab.statusAddAddressFailed', { name: '<em>' + truncatedName + '</em>' }),
              type: 'warning'
            });
          }).always(function () {
            _this2.$btnAddAddress.removeClass('processing');
            setTimeout(function () {
              return statusMessage.remove();
            }, 3000);
          });
        }
      }

      // render so errors are shown / cleared
      this.addressForm.render();

      if (this.settings.validationError || model.validationError) {
        var $firstFormErr = this.$('.js-formContainer .errorList:first');

        if ($firstFormErr.length) {
          $firstFormErr[0].scrollIntoViewIfNeeded();
        } else {
          this.trigger('unrecognizedModelError', this, [this.settings]);
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/settings/addresses.html', function (t) {
        _this3.$el.html(t(_extends({
          errors: {}
        }, _this3.settings.toJSON())));

        _this3.$('.js-formContainer').html(_this3.addressForm.render().el);

        _this3.$('.js-listContainer').html(_this3.addressList.render().el);

        _this3._$btnAddAddress = null;
      });

      return this;
    }
  }, {
    key: '$btnAddAddress',
    get: function get() {
      return this._$btnAddAddress || this.$('.js-addAddress');
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;