'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

require('../../../utils/lib/selectize');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _SimpleMessage = require('../SimpleMessage');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Moderator = require('../../../models/profile/Moderator');

var _Moderator2 = _interopRequireDefault(_Moderator);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _languages = require('../../../data/languages');

var _currencies = require('../../../data/currencies');

var _currency = require('../../../utils/currency');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, _extends({
      className: 'settingsModeration'
    }, options)));

    _this.profile = _app2.default.profile.clone();

    // Sync our clone with any changes made to the global profile.
    _this.listenTo(_app2.default.profile, 'someChange', function (md, opts) {
      return _this.profile.set(opts.setAttrs);
    });

    // Sync the global profile with any changes we save via our clone.
    _this.listenTo(_this.profile, 'sync', function (md, resp, opts) {
      return _app2.default.profile.set(_this.profile.toJSON(opts.attrs));
    });

    if (_this.profile.get('moderatorInfo')) {
      _this.moderator = _this.profile.get('moderatorInfo');
    } else {
      _this.moderator = new _Moderator2.default({
        languages: [_app2.default.localSettings.standardizedTranslatedLang()]
      });
      _this.profile.set('moderatorInfo', _this.moderator);
    }

    // retrieve the moderation default values
    var profileFee = _this.profile.get('moderatorInfo').get('fee');
    _this.defaultPercentage = _underscore2.default.result(profileFee, 'defaults', {}).percentage || 0;
    _this.defaultAmount = _underscore2.default.result(profileFee.get('fixedFee'), 'defaults', {}).amount || 0;

    _this.currencyList = (0, _currencies.getTranslatedCurrencies)();

    _this.listenTo(_this.profile, 'sync', function () {
      _app2.default.profile.set({
        moderator: _this.profile.get('moderator'),
        moderatorInfo: _this.profile.get('moderatorInfo').toJSON()
      });
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-save': 'save',
        'change #moderationFeeType': 'changeFeeType'
      };
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, this.$formFields);
    }
  }, {
    key: 'save',
    value: function save() {
      var _this2 = this;

      /* if the user isn't already a moderator, the status is true, and the confirmation checkboxes
       aren't checked, show an error */

      var confirmChecked = this.$understandRequirements.prop('checked') && this.$acceptGuidelines.prop('checked');

      if (!this.profile.get('moderator') && this.$('input[name=moderator]:checked').val() === 'true' && !confirmChecked) {
        this.$moderationConfirmError.removeClass('hide');
        return;
      }

      var formData = this.getFormData();

      // clear unused values by setting them to the default, if it exists
      if (formData.moderatorInfo.fee.feeType === 'PERCENTAGE') {
        formData.moderatorInfo.fee.fixedFee.amount = this.defaultAmount;
      } else if (formData.moderatorInfo.fee.feeType === 'FIXED') {
        formData.moderatorInfo.fee.percentage = this.defaultPercentage;
      }

      this.profile.set(formData);

      var save = this.profile.save(formData, {
        attrs: formData,
        type: 'PATCH'
      });

      if (save) {
        var msg = {
          msg: _app2.default.polyglot.t('settings.moderationTab.status.saving'),
          type: 'message'
        };

        var statusMessage = _app2.default.statusBar.pushMessage(_extends({}, msg, {
          duration: 9999999999999999
        }));

        save.done(function () {
          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.moderationTab.status.done'),
            type: 'confirmed'
          });
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';

          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.moderationTab.errors.save'), errMsg);

          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.moderationTab.status.fail'),
            type: 'warning'
          });
        }).always(function () {
          _this2.$btnSave.removeClass('processing');
          setTimeout(function () {
            return statusMessage.remove();
          }, 3000);
        });
      }

      // render so errrors are shown / cleared
      this.render();

      if (save) {
        this.$btnSave.addClass('processing');
      } else {
        var $firstErr = this.$('.errorList:first');

        if ($firstErr.length) {
          $firstErr[0].scrollIntoViewIfNeeded();
        } else {
          this.trigger('unrecognizedModelError', this, [this.profile]);
        }
      }
    }
  }, {
    key: 'changeFeeType',
    value: function changeFeeType(e) {
      var feeType = (0, _jquery2.default)(e.target).val();

      this.$feePercentageInput.toggleClass('visuallyHidden', feeType === 'FIXED');
      this.$feeFixedInput.toggleClass('visuallyHidden', feeType === 'PERCENTAGE');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/settings/moderation.html', function (t) {
        var moderator = _this3.profile.get('moderatorInfo');

        _this3.$el.html(t(_extends({
          errors: _this3.profile.validationError || {},
          isModerator: _this3.profile.get('moderator'),
          languageList: (0, _languages.getTranslatedLangs)(),
          defaultCurrency: _app2.default.settings.get('localCurrency'),
          currencyList: _this3.currencyList,
          max: {
            description: _this3.moderator.max.descriptionLength,
            terms: _this3.moderator.max.termsLength
          },
          formatPrice: _currency.formatPrice
        }, moderator.toJSON())));

        _this3.$('#moderationLanguageSelect').selectize({
          maxItems: null,
          valueField: 'code',
          searchField: ['name', 'code'],
          items: moderator.get('languages'),
          options: (0, _languages.getTranslatedLangs)(),
          render: {
            option: function option(data) {
              return '<div>' + data.name + '</div>';
            },
            item: function item(data) {
              return '<div>' + data.name + '</div>';
            }
          }
        });

        _this3.$('#moderationFeeType').select2({
          minimumResultsForSearch: Infinity
        });

        _this3.$('#moderationCurrency').select2();

        _this3.$formFields = _this3.$('select[name], input[name], textarea[name]');
        _this3._$btnSave = null;
        _this3._$feePercentageInput = null;
        _this3._$feeFixedInput = null;
        _this3._$acceptGuidelines = null;
        _this3._$understandRequirements = null;
        _this3._$moderationConfirmError = null;
      });

      return this;
    }
  }, {
    key: '$btnSave',
    get: function get() {
      return this._$btnSave || (this._$btnSave = this.$('.js-save'));
    }
  }, {
    key: '$feePercentageInput',
    get: function get() {
      return this._$feePercentageInput || (this._$feePercentageInput = this.$('.js-feePercentageInput'));
    }
  }, {
    key: '$feeFixedInput',
    get: function get() {
      return this._$feeFixedInput || (this._$feeFixedInput = this.$('.js-feeFixedInput'));
    }
  }, {
    key: '$understandRequirements',
    get: function get() {
      return this._$understandRequirements || (this._$understandRequirements = this.$('#understandRequirements'));
    }
  }, {
    key: '$acceptGuidelines',
    get: function get() {
      return this._$acceptGuidelines || (this._$acceptGuidelines = this.$('#acceptGuidelines'));
    }
  }, {
    key: '$moderationConfirmError',
    get: function get() {
      return this._$moderationConfirmError || (this._$moderationConfirmError = this.$('.js-moderationConfirmError'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;