'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../../../lib/whenAll.jquery');

var _SimpleMessage = require('../SimpleMessage');

require('cropit');

var _trumbowyg = require('../../../utils/lib/trumbowyg');

var _SocialAccounts = require('./SocialAccounts');

var _SocialAccounts2 = _interopRequireDefault(_SocialAccounts);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, _extends({
      className: 'settingsPage'
    }, options)));

    _this.avatarMinWidth = 280;
    _this.avatarMinHeight = 280;
    _this.headerMinWidth = 2450;
    _this.headerMinHeight = 700;

    _this.profile = _app2.default.profile.clone();

    // Sync our clone with any changes made to the global profile.
    _this.listenTo(_app2.default.profile, 'someChange', function (md, opts) {
      return _this.profile.set(opts.setAttrs);
    });

    // Sync the global profile with any changes we save via our clone.
    _this.listenTo(_this.profile, 'sync', function (md, resp, syncOpts) {
      return _app2.default.profile.set(_this.profile.toJSON(syncOpts.attrs));
    });

    _this.socialAccounts = _this.createChild(_SocialAccounts2.default, {
      collection: _this.profile.get('contactInfo').get('social'),
      maxAccounts: _this.profile.get('contactInfo').maxSocialAccounts
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-save': 'save',
        'click .js-avatarLeft': 'avatarLeftClick',
        'click .js-avatarRight': 'avatarRightClick',
        'click .js-headerLeft': 'headerLeftClick',
        'click .js-headerRight': 'headerRightClick',
        'change .js-colorPicker': 'handleColorChosen',
        'change .js-colorCode': 'handleColorCodeEntered'
      };
    }

    /** Handles when a hex color code is entered by updating color picker. */

  }, {
    key: 'handleColorCodeEntered',
    value: function handleColorCodeEntered(event) {
      var colorPickerId = this.$(event.target).data('color-picker-id');
      var $colorPicker = this.getCachedEl(colorPickerId);
      var newHexColorCode = event.target.value;

      // If the text passes a basic RegExp for a valid 6 digit hex value,
      // update the color picker's color.
      if (/^#([0-9a-f]{6})$/i.test(newHexColorCode)) {
        $colorPicker.val(newHexColorCode);
      }
    }

    /** Handles when a color is chosen from the color picker by updating hex color code text. */

  }, {
    key: 'handleColorChosen',
    value: function handleColorChosen(event) {
      var hexInputId = this.$(event.target).data('hex-input-id');
      var $hexInput = this.getCachedEl(hexInputId);
      var newColor = event.target.value;

      $hexInput.val(newColor);
    }
  }, {
    key: 'avatarRotate',
    value: function avatarRotate(direction) {
      if (this.avatarCropper.cropit('imageSrc')) {
        this.avatarCropper.cropit(direction > 0 ? 'rotateCW' : 'rotateCCW');
        this.avatarChanged = true;
      }
    }
  }, {
    key: 'avatarLeftClick',
    value: function avatarLeftClick() {
      this.avatarRotate(-1);
    }
  }, {
    key: 'avatarRightClick',
    value: function avatarRightClick() {
      this.avatarRotate(1);
    }
  }, {
    key: 'headerRotate',
    value: function headerRotate(direction) {
      if (this.headerCropper.cropit('imageSrc')) {
        this.headerCropper.cropit(direction > 0 ? 'rotateCW' : 'rotateCCW');
        this.headerChanged = true;
      }
    }
  }, {
    key: 'headerLeftClick',
    value: function headerLeftClick() {
      this.headerRotate(-1);
    }
  }, {
    key: 'headerRightClick',
    value: function headerRightClick() {
      this.headerRotate(1);
    }
  }, {
    key: 'saveHeader',
    value: function saveHeader() {
      var imageURI = this.headerCropper.cropit('export', {
        type: 'image/jpeg',
        quality: 1,
        originalSize: true
      });
      var headerData = JSON.stringify({ header: imageURI.replace(/^data:image\/(png|jpeg|webp);base64,/, '') });
      return _jquery2.default.ajax({
        type: 'POST',
        url: _app2.default.getServerUrl('ob/header/'),
        contentType: 'application/json; charset=utf-8',
        data: headerData,
        dataType: 'json'
      });
    }
  }, {
    key: 'saveAvatar',
    value: function saveAvatar() {
      var imageURI = this.avatarCropper.cropit('export', {
        type: 'image/jpeg',
        quality: 1,
        originalSize: true
      });
      var avatarData = JSON.stringify({ avatar: imageURI.replace(/^data:image\/(png|jpeg|webp);base64,/, '') });
      return _jquery2.default.ajax({
        type: 'POST',
        url: _app2.default.getServerUrl('ob/avatar/'),
        contentType: 'application/json; charset=utf-8',
        data: avatarData,
        dataType: 'json'
      });
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      var formData = _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, this.$formFields);

      while (formData.handle.startsWith('@')) {
        formData.handle = formData.handle.slice(1);
      }

      if (formData.colors) {
        Object.keys(formData.colors).forEach(function (colorField) {
          if (!formData.colors[colorField].startsWith('#')) {
            formData.colors[colorField] = '#' + formData.colors[colorField];
          }
        });
      }

      return formData;
    }
  }, {
    key: 'save',
    value: function save() {
      var _this2 = this;

      var formData = this.getFormData();

      // set the model data for the social accounts
      this.socialAccounts.setCollectionData();

      this.profile.set(formData);

      var save = this.profile.save();
      var saveAvatar = void 0;
      var saveHeader = void 0;

      if (save) {
        if (this.avatarOffsetOnLoad !== this.avatarCropper.cropit('offset') || this.avatarZoomOnLoad !== this.avatarCropper.cropit('zoom')) {
          this.avatarChanged = true;
        }

        if (this.headerOffsetOnLoad !== this.headerCropper.cropit('offset') || this.headerZoomOnLoad !== this.headerCropper.cropit('zoom')) {
          this.headerChanged = true;
        }

        if (this.avatarChanged && this.avatarCropper.cropit('imageSrc')) {
          saveAvatar = this.saveAvatar();
          saveAvatar.done(function (avatarData) {
            // set hash in profile to mirror the server copy
            _this2.profile.set('avatarHashes', avatarData);
            _app2.default.profile.set('avatarHashes', avatarData);
          });
        }

        if (this.headerChanged && this.headerCropper.cropit('imageSrc')) {
          saveHeader = this.saveHeader();
          saveHeader.done(function (headerData) {
            // set hash in profile to mirror the server copy
            _this2.profile.set('headerHashes', headerData);
            _app2.default.profile.set('headerHashes', headerData);
          });
        }

        var msg = {
          msg: _app2.default.polyglot.t('settings.pageTab.statusSaving'),
          type: 'message'
        };

        var statusMessage = _app2.default.statusBar.pushMessage(_extends({}, msg, {
          duration: 9999999999999999
        }));

        _jquery2.default.whenAll(save, saveAvatar, saveHeader).done(function () {
          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.pageTab.statusSaveComplete'),
            type: 'confirmed'
          });
        }).fail(function (args) {
          var errMsg = args && args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';

          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.pageTab.saveErrorAlertTitle'), errMsg);

          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.pageTab.statusSaveFailed'),
            type: 'warning'
          });
        }).always(function () {
          _this2.$btnSave.removeClass('processing');
          setTimeout(function () {
            return statusMessage.remove();
          }, 3000);
        });
      }

      this.render();

      if (save) {
        this.$btnSave.addClass('processing');
      } else {
        var $firstErr = this.$('.errorList:first');

        if ($firstErr.length) {
          $firstErr[0].scrollIntoViewIfNeeded();
        } else {
          this.trigger('unrecognizedModelError', this, [this.profile]);
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      var avatarURI = false;
      var headerURI = false;

      // if this is a re-render, get the contents of the cropits
      if (this.avatarCropper) {
        avatarURI = this.avatarCropper.cropit('export', {
          type: 'image/jpeg',
          quality: 1,
          originalSize: true
        });
      }

      if (this.headerCropper) {
        headerURI = this.headerCropper.cropit('export', {
          type: 'image/jpeg',
          quality: 1,
          originalSize: true
        });
      }

      (0, _loadTemplate2.default)('modals/settings/page.html', function (t) {
        _this3.$el.html(t(_extends({
          errors: _this3.profile.validationError || {}
        }, _this3.profile.toJSON(), {
          max: _this3.profile.max,
          avatarMinHeight: _this3.avatarMinHeight,
          avatarMinWidth: _this3.avatarMinWidth,
          headerMinHeight: _this3.headerMinHeight,
          headerMinWidth: _this3.headerMinWidth
        })));

        var formFields = 'select[name], input[name], textarea[name], div[contenteditable][name]';
        _this3.$formFields = _this3.$(formFields);
        _this3._$btnSave = null;

        (0, _trumbowyg.installRichEditor)(_this3.$('#settingsAbout'), {
          topLevelClass: 'clrBr'
        });

        var avatarPrev = _this3.$('.js-avatarPreview');
        var avatarInpt = _this3.$('#avatarInput');
        _this3.avatarCropper = _this3.$('#avatarCropper');

        var headerPrev = _this3.$('.js-headerPreview');
        var headerInpt = _this3.$('#headerInput');
        _this3.headerCropper = _this3.$('#headerCropper');

        // if the avatar or header exist, don't count the first load as a change
        _this3.avatarLoadedOnRender = Boolean(avatarURI || _this3.profile.get('avatarHashes').get('original'));
        _this3.headerLoadedOnRender = Boolean(headerURI || _this3.profile.get('headerHashes').get('original'));

        setTimeout(function () {
          _this3.avatarCropper.cropit({
            $preview: avatarPrev,
            $fileInput: avatarInpt,
            smallImage: 'stretch',
            allowDragNDrop: false,
            maxZoom: 2,
            onImageLoaded: function onImageLoaded() {
              _this3.avatarOffsetOnLoad = _this3.avatarCropper.cropit('offset');
              _this3.avatarZoomOnLoad = _this3.avatarCropper.cropit('zoom');
              _this3.$('.js-avatarLeft').removeClass('disabled');
              _this3.$('.js-avatarRight').removeClass('disabled');
              _this3.$('.js-avatarZoom').removeClass('disabled');
              _this3.avatarChanged = !_this3.avatarLoadedOnRender;
              _this3.avatarLoadedOnRender = false;
            },
            onFileReaderError: function onFileReaderError(data) {
              console.log('file reader error');
              console.log(data);
            },
            onImageError: function onImageError(errorObject) {
              console.log(errorObject.code);
              console.log(errorObject.message);
            }
          });

          _this3.headerCropper.cropit({
            $preview: headerPrev,
            $fileInput: headerInpt,
            smallImage: 'stretch',
            allowDragNDrop: false,
            maxZoom: 2,
            onImageLoaded: function onImageLoaded() {
              _this3.headerOffsetOnLoad = _this3.headerCropper.cropit('offset');
              _this3.headerZoomOnLoad = _this3.headerCropper.cropit('zoom');
              _this3.$('.js-headerLeft').removeClass('disabled');
              _this3.$('.js-headerRight').removeClass('disabled');
              _this3.$('.js-headerZoom').removeClass('disabled');
              _this3.headerChanged = !_this3.headerLoadedOnRender;
              _this3.headerLoadedOnRender = false;
            },
            onFileReaderError: function onFileReaderError(data) {
              console.log('file reader error');
              console.log(data);
            },
            onImageError: function onImageError(errorObject) {
              console.log(errorObject.code);
              console.log(errorObject.message);
            }
          });

          if (avatarURI) {
            _this3.avatarCropper.cropit('imageSrc', avatarURI);
          } else if (_this3.profile.get('avatarHashes').get('original')) {
            _this3.avatarCropper.cropit('imageSrc', _app2.default.getServerUrl('ob/images/' + _this3.profile.get('avatarHashes').get('original')));
          }

          if (headerURI) {
            _this3.headerCropper.cropit('imageSrc', headerURI);
          } else if (_this3.profile.get('headerHashes').get('original')) {
            _this3.headerCropper.cropit('imageSrc', _app2.default.getServerUrl('ob/images/' + _this3.profile.get('headerHashes').get('original')));
          }
        }, 0);

        _this3.socialAccounts.delegateEvents();
        _this3.$('.js-socialAccounts').append(_this3.socialAccounts.render().el);
      });

      return this;
    }
  }, {
    key: '$btnSave',
    get: function get() {
      return this._$btnSave || (this._$btnSave = this.$('.js-save'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;