'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _electron = require('electron');

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../../app');

var _app2 = _interopRequireDefault(_app);

var _SimpleMessage = require('../../SimpleMessage');

var _Dialog = require('../../../modals/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _WalletSeed = require('./WalletSeed');

var _WalletSeed2 = _interopRequireDefault(_WalletSeed);

var _SmtpSettings = require('./SmtpSettings');

var _SmtpSettings2 = _interopRequireDefault(_SmtpSettings);

var _ReloadTransactions = require('./ReloadTransactions');

var _ReloadTransactions2 = _interopRequireDefault(_ReloadTransactions);

var _MetricsStatus = require('./MetricsStatus');

var _MetricsStatus2 = _interopRequireDefault(_MetricsStatus);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, _extends({
      className: 'settingsAdvanced'
    }, options)));

    _this.settings = _app2.default.settings.clone();

    // Sync our clone with any changes made to the global settings model.
    _this.listenTo(_app2.default.settings, 'someChange', function (md, opts) {
      return _this.settings.set(opts.setAttrs);
    });

    // Sync the global settings model with any changes we save via our clone.
    _this.listenTo(_this.settings, 'sync', function (md, resp, opts) {
      return _app2.default.settings.set(_this.settings.toJSON(opts.attrs));
    });

    _this.localSettings = _app2.default.localSettings.clone();

    // Sync our clone with any changes made to the global local settings model.
    _this.listenTo(_app2.default.localSettings, 'someChange', function (md, opts) {
      return _this.localSettings.set(opts.setAttrs);
    });

    // Sync the global local settings model with any changes we save via our clone.
    _this.listenTo(_this.localSettings, 'sync', function (md, resp, opts) {
      return _app2.default.localSettings.set(_this.localSettings.toJSON(opts.attrs));
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'onClickShowSeed',
    value: function onClickShowSeed() {
      var _this2 = this;

      if (this.walletSeedFetch && this.walletSeedFetch.state() === 'pending') {
        return this.walletSeedFetch;
      }

      if (this.walletSeed) this.walletSeed.setState({ isFetching: true });

      this.walletSeedFetch = _jquery2.default.get(_app2.default.getServerUrl('wallet/mnemonic')).done(function (data) {
        _this2.mnemonic = data.mnemonic;
        if (_this2.walletSeed) {
          _this2.walletSeed.setState({ seed: data.mnemonic });
        }
      }).always(function () {
        if (_this2.walletSeed) _this2.walletSeed.setState({ isFetching: false });
      }).fail(function (xhr) {
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.advancedTab.server.unableToFetchSeedTitle'), xhr.responseJSON && xhr.responseJSON.reason || '');
      });

      return this.walletSeedFetch;
    }
  }, {
    key: 'showConnectionManagement',
    value: function showConnectionManagement() {
      _app2.default.connectionManagmentModal.open();
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      var subset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.$formFields;

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, subset);
    }
  }, {
    key: 'clickPurge',
    value: function clickPurge() {
      this.purgeCache();
    }

    /**
     * Call to the server to remove cached files that are being shared on IPFS.
     * This call should not be aborted when the view is removed, it's critical the user is informed if
     * the call fails, even if they have navigated away from the view.
     */

  }, {
    key: 'purgeCache',
    value: function purgeCache() {
      var _this3 = this;

      this.getCachedEl('.js-purge').addClass('processing');
      this.getCachedEl('.js-purgeComplete').addClass('hide');

      this.purge = _jquery2.default.post(_app2.default.getServerUrl('ob/purgecache')).always(function () {
        _this3.getCachedEl('.js-purge').removeClass('processing');
      }).fail(function (xhr) {
        var failReason = xhr.responseJSON && xhr.responseJSON.reason || '';
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.advancedTab.server.purgeError'), failReason);
      }).done(function () {
        _this3.getCachedEl('.js-purgeComplete').removeClass('hide');
      });
    }
  }, {
    key: 'clickBlockData',
    value: function clickBlockData() {
      this.showBlockData();
    }

    /**
     * Calls the server to retrieve and display information about the block the transactions are on
     */

  }, {
    key: 'showBlockData',
    value: function showBlockData() {
      var _this4 = this;

      this.getCachedEl('.js-blockData').addClass('processing');

      this.blockData = _jquery2.default.get(_app2.default.getServerUrl('wallet/status')).always(function () {
        _this4.getCachedEl('.js-blockData').removeClass('processing');
      }).fail(function (xhr) {
        var failReason = xhr.responseJSON && xhr.responseJSON.reason || '';
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.advancedTab.server.blockDataError'), failReason);
      }).done(function (data) {
        var buttons = [{
          text: _app2.default.polyglot.t('settings.advancedTab.server.blockDataCopy'),
          fragment: 'copyBlockData'
        }];
        var message = '<p><b>Best Hash:</b><br> ' + data.bestHash + '</p><p><b>Height:</b><br>' + (data.height + '</p>');
        var blockDataDialog = new _Dialog2.default({
          title: _app2.default.polyglot.t('settings.advancedTab.server.blockDataTitle'),
          message: message,
          buttons: buttons,
          showCloseButton: true,
          removeOnClose: true
        }).render().open();
        _this4.listenTo(blockDataDialog, 'click-copyBlockData', function () {
          _electron.clipboard.writeText('Best Hash: ' + data.bestHash + ' Height: ' + data.height);
        });
      });
    }
  }, {
    key: 'save',
    value: function save() {
      var _this5 = this;

      this.localSettings.set(this.getFormData(this.$localFields));
      this.localSettings.set({}, { validate: true });

      this.smtpSettings.setModelData();
      var serverFormData = _extends({}, this.getFormData(), {
        smtpSettings: this.smtpSettings.model.toJSON()
      });
      this.settings.set(serverFormData, { validate: true });

      if (!this.localSettings.validationError && !this.settings.validationError) {
        var msg = {
          msg: _app2.default.polyglot.t('settings.advancedTab.statusSaving'),
          type: 'message'
        };

        var statusMessage = _app2.default.statusBar.pushMessage(_extends({}, msg, {
          duration: 9999999999999999
        }));

        // let's save and monitor both save processes
        var localSave = this.localSettings.save();
        var serverSave = this.settings.save(serverFormData, {
          attrs: serverFormData,
          type: 'PATCH'
        });

        _jquery2.default.when(localSave, serverSave).done(function () {
          // both succeeded!
          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.advancedTab.statusSaveComplete'),
            type: 'confirmed'
          });
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          // One has failed, the other may have also failed or may
          // fail or may succeed. It doesn't matter, for our purposed one
          // failure is enough for us to consider the "save" to have failed
          var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';

          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.advancedTab.saveErrorAlertTitle'), errMsg);

          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.advancedTab.statusSaveFailed'),
            type: 'warning'
          });
        }).always(function () {
          _this5.getCachedEl('.js-save').removeClass('processing');
          setTimeout(function () {
            return statusMessage.remove();
          }, 3000);
        });
      }

      this.render();

      if (!this.localSettings.validationError && !this.settings.validationError) {
        this.getCachedEl('.js-save').addClass('processing');
      } else {
        var $firstErr = this.$('.errorList:first');

        if ($firstErr.length) {
          $firstErr[0].scrollIntoViewIfNeeded();
        } else {
          var models = [];
          if (this.localSettings.validationError) models.push(this.localSettings);
          if (this.settings.validationError) models.push(this.settings);
          this.trigger('unrecognizedModelError', this, models);
        }
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.resync) this.resync.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/settings/advanced/advanced.html', function (t) {
        _this6.$el.html(t(_extends({
          errors: _extends({}, _this6.settings.validationError || {}, _this6.localSettings.validationError || {}),
          isSyncing: _this6.resync && _this6.resync.state() === 'pending',
          isPurging: _this6.purge && _this6.purge.state() === 'pending',
          isGettingBlockData: _this6.blockData && _this6.blockData.state() === 'pending'
        }, _this6.settings.toJSON(), _this6.localSettings.toJSON())));

        var formFieldsSelector = '\n        .contentBox:not(.js-contentBoxEmailIntegration) select[name],\n        .contentBox:not(.js-contentBoxEmailIntegration) input[name],\n        .contentBox:not(.js-contentBoxEmailIntegration) textarea[name]\n      ';
        _this6.$formFields = _this6.$(formFieldsSelector).not('[data-persistence-location="local"]');
        _this6.$localFields = _this6.$('[data-persistence-location="local"]');

        if (_this6.walletSeed) _this6.walletSeed.remove();
        _this6.walletSeed = _this6.createChild(_WalletSeed2.default, {
          initialState: {
            seed: _this6.mnemonic || '',
            isFetching: _this6.walletSeedFetch && _this6.walletSeedFetch.state() === 'pending'
          }
        });
        _this6.listenTo(_this6.walletSeed, 'clickShowSeed', _this6.onClickShowSeed);
        _this6.getCachedEl('.js-walletSeedContainer').append(_this6.walletSeed.render().el);

        if (_this6.smtpSettings) _this6.smtpSettings.remove();
        _this6.smtpSettings = _this6.createChild(_SmtpSettings2.default, {
          model: _this6.settings.get('smtpSettings')
        });
        _this6.getCachedEl('.js-smtpSettingsContainer').html(_this6.smtpSettings.render().el);

        if (_this6.reloadTransactions) _this6.reloadTransactions.delegateEvents();
        _this6.getCachedEl('.js-reloadTransactionsContainer').append(_this6.reloadTransactions.render().el);

        if (_this6.metricsStatus) _this6.metricsStatus.remove();
        _this6.metricsStatus = _this6.createChild(_MetricsStatus2.default);
        _this6.getCachedEl('.js-metricsStatusWrapper').append(_this6.metricsStatus.render().el);
      });

      return this;
    }
  }, {
    key: 'events',
    get: function get() {
      return {
        'click .js-save': 'save',
        'click .js-showConnectionManagement': 'showConnectionManagement',
        'click .js-purge': 'clickPurge',
        'click .js-blockData': 'clickBlockData'
      };
    }
  }, {
    key: 'reloadTransactions',
    get: function get() {
      if (this._reloadTransactions) return this._reloadTransactions;
      this._reloadTransactions = this.createChild(_ReloadTransactions2.default);
      return this._reloadTransactions;
    }
  }, {
    key: '$smtpSettingsFields',
    get: function get() {
      var selector = '.js-smtpSettingsForm select[name], .js-smtpSettingsForm input[name],\n      .js-smtpSettingsForm textarea[name]:not([class*="trumbowyg"]),\n      .js-smtpSettingsForm div[contenteditable][name]';

      return this.getCachedEl(selector);
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;