'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _electron = require('electron');

var _SimpleMessage = require('./SimpleMessage');

var _SimpleMessage2 = _interopRequireDefault(_SimpleMessage);

var _cryptoCurrencies = require('../../data/cryptoCurrencies');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('./BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      dismissOnEscPress: false,
      showCloseButton: false,
      removeOnClose: true
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    if (!_this.model) {
      throw new Error('Please provide a server configuration model.');
    }

    _this.cryptoCurs = (0, _cryptoCurrencies.getTranslatedCurrencies)();
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' modalScrollPage modalMedium';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-browseZcashBinary': 'onClickBrowseZcashBinary',
        'click .js-navNext': 'onClickNext',
        'change [name=walletCurrency]': 'onWalletCurrencyChange'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onClickBrowseZcashBinary',
    value: function onClickBrowseZcashBinary() {
      var _this2 = this;

      _electron.remote.dialog.showOpenDialog({ properties: ['openFile'] }, function (e) {
        if (e) {
          _this2.getCachedEl('.js-inputZcashBinaryPath').val(e[0] || '');
        }
      });
    }
  }, {
    key: 'onClickNext',
    value: function onClickNext() {
      var _this3 = this;

      var formData = this.getFormData(this.$formFields);
      this.model.set(_extends({}, formData));
      this.model.set({}, { validate: true });

      if (this.model.validationError) {
        this.render();

        if (!this.getCachedEl('.js-errorList').length) {
          // This is a developer error.
          var validationErr = this.model.validationError || {};
          throw new Error('There were one or more errors saving the server configuration' + ('' + Object.keys(validationErr).map(function (key) {
            return '\n- ' + validationErr[key];
          })));
        }

        return;
      }

      this.model.save().done(function () {
        _this3.trigger('walletSetupComplete');
        _this3.close();
      }).fail(function () {
        // since we're saving to localStorage this really shouldn't happen
        (0, _SimpleMessage2.default)('Unable to save server configuration');
      });
    }
  }, {
    key: 'onWalletCurrencyChange',
    value: function onWalletCurrencyChange(e) {
      this.getCachedEl('.js-zcashSection').toggleClass('hide', e.target.value !== 'ZEC');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('modals/walletSetup.html', function (t) {
        _this4.$el.html(t(_extends({
          cryptoCurs: _this4.cryptoCurs,
          errors: _this4.model.validationError || {}
        }, _this4.model.toJSON())));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this4).call(_this4);
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;