'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _package = require('../../../../package.json');

var _electron = require('electron');

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _Story = require('./Story');

var _Story2 = _interopRequireDefault(_Story);

var _Contributors = require('./Contributors');

var _Contributors2 = _interopRequireDefault(_Contributors);

var _Donations = require('./Donations');

var _Donations2 = _interopRequireDefault(_Donations);

var _Help = require('./Help');

var _Help2 = _interopRequireDefault(_Help);

var _License = require('./License');

var _License2 = _interopRequireDefault(_License);

var _BTCTicker = require('../../BTCTicker');

var _BTCTicker2 = _interopRequireDefault(_BTCTicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      removeOnClose: true,
      initialTab: 'Story'
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this.tabViewCache = {};
    _this.tabViews = {
      Story: _Story2.default,
      Contributors: _Contributors2.default,
      Donations: _Donations2.default,
      License: _License2.default,
      Help: _Help2.default
    };

    _this.currentTabName = opts.initialTab;
    _this.isBundledApp = _electron.remote.getGlobal('isBundledApp');
    _this.updatesSupported = _electron.remote.getGlobal('updatesSupported');
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' about tabbedModal modalTop modalScrollPage';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-tab': 'tabClick',
        'click .js-checkForUpdate': 'checkForUpdateClick'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'tabClick',
    value: function tabClick(e) {
      var targ = (0, _jquery2.default)(e.target).closest('.js-tab');
      var tabName = targ.data('tab');
      this.selectTab(tabName);
    }
  }, {
    key: 'selectTab',
    value: function selectTab(tabViewName) {
      var tabView = this.tabViewCache[tabViewName];

      if (!tabView && !this.tabViews[tabViewName]) {
        throw new Error('You are attempting to select an invalid tab.');
      }

      this.$('.js-tab.clrT.active').removeClass('clrT active');
      this.$('.js-tab[data-tab="' + tabViewName + '"]').addClass('clrT active');

      if (!this.currentTabView || this.currentTabView !== tabView) {
        if (this.currentTabView) this.currentTabView.$el.detach();

        if (!tabView) {
          tabView = this.createChild(this.tabViews[tabViewName]);
          this.tabViewCache[tabViewName] = tabView;
          tabView.render();
        }

        this.$tabContent.append(tabView.$el);
        this.currentTabView = tabView;
        this.currentTabName = tabViewName;
        this.$('#tabTitle').text(_app2.default.polyglot.t('about.' + this.currentTabName.toLowerCase() + 'Tab.sectionHeader'));
      }
    }
  }, {
    key: 'checkForUpdateClick',
    value: function checkForUpdateClick() {
      _electron.ipcRenderer.send('checkForUpdate');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // remove any existing tickers from previous renders
      if (this.btcTicker) this.btcTicker.remove();

      this.btcTicker = this.createChild(_BTCTicker2.default);
      this.btcTicker.render();

      (0, _loadTemplate2.default)('modals/about/about.html', function (t) {
        (0, _loadTemplate2.default)('brandingBox.html', function (brandingBoxT) {
          _this2.$el.html(t(_extends({
            brandingBoxT: brandingBoxT,
            serverVersion: _app2.default.settings.prettyServerVer
          }, _this2.options, {
            version: _package.version,
            isBundledApp: _this2.isBundledApp,
            updatesSupported: _this2.updatesSupported
          })));
          _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this2).call(_this2);

          _this2.$tabContent = _this2.$('.js-tabContent .contentBox');
          _this2.selectTab(_this2.currentTabName);
          _this2.$('.js-btcTicker').append(_this2.btcTicker.$el);
        });
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;