'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _modalManager = require('../../../utils/modalManager');

var _SimpleMessage = require('../../modals/SimpleMessage');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _electron = require('electron');

var _qrEncode = require('qr-encode');

var _qrEncode2 = _interopRequireDefault(_qrEncode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var obDonationAddress = '3EN8kP3yW9MGvyiRMtGqKavQ9wYg4BspzR';
var qrCodeDataURI = (0, _qrEncode2.default)('bitcoin:' + obDonationAddress, { type: 6, size: 6, level: 'Q' });
var donationCountFloor = 500;
var hiderTimer = void 0;

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, _extends({
      className: 'aboutDonations'
    }, options)));
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-copyAddress': 'copyDonationAddress',
        'click .js-openInWallet': 'openInWalletClick'
      };
    }
  }, {
    key: 'copyDonationAddress',
    value: function copyDonationAddress() {
      var _this2 = this;

      _electron.clipboard.writeText(obDonationAddress);

      this.$copyNotification.addClass('active');
      if (!!hiderTimer) {
        clearTimeout(hiderTimer);
      }
      hiderTimer = setTimeout(function () {
        return _this2.$copyNotification.removeClass('active');
      }, 3000);
    }
  }, {
    key: 'openInWalletClick',
    value: function openInWalletClick() {
      var wallet = (0, _modalManager.getWallet)();

      if (!wallet) {
        (0, _modalManager.launchWallet)().setSendFormData({ address: obDonationAddress });
      } else {
        if (wallet.setSendFormData({ address: obDonationAddress })) {
          wallet.open(false);
        } else {
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('about.donationsTab.unableToOpenInWallet.title'), _app2.default.polyglot.t('about.donationsTab.unableToOpenInWallet.body'));
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/about/donations.html', function (t) {
        _this3.$el.html(t({
          obDonationAddress: obDonationAddress,
          donationCountFloor: donationCountFloor,
          qrCodeDataURI: qrCodeDataURI
        }));
      });

      return this;
    }
  }, {
    key: '$copyNotification',
    get: function get() {
      return this._$copyNotification || (this._$copyNotification = this.$('.js-copyNotification'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;