'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../../../lib/select2');

require('../../../utils/lib/selectize');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _countries = require('../../../data/countries');

var _regions = require('../../../data/regions');

var _regions2 = _interopRequireDefault(_regions);

var _Service = require('../../../models/listing/Service');

var _Service2 = _interopRequireDefault(_Service);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _Service3 = require('./Service');

var _Service4 = _interopRequireDefault(_Service3);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model) {
      throw new Error('Please provide a model.');
    }

    if (typeof options.getCurrency !== 'function') {
      throw new Error('Please provide a function for me to obtain the current currency.');
    }

    var opts = _extends({
      listPosition: 1
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    // get regions
    _this.selectCountryData = (0, _regions.getTranslatedRegions)().map(function (regionObj) {
      return {
        id: regionObj.id,
        text: regionObj.name,
        isRegion: true
      };
    });

    // now, we'll add in the countries
    var selectCountries = (0, _countries.getTranslatedCountries)().map(function (countryObj) {
      return {
        id: countryObj.dataName,
        text: countryObj.name,
        isRegion: false
      };
    });
    _this.selectCountryData = _this.selectCountryData.concat(selectCountries);

    _this.services = _this.model.get('services');
    _this.serviceViews = [];

    _this.listenTo(_this.services, 'add', function (serviceMd) {
      var serviceVw = _this.createServiceView({
        model: serviceMd
      });

      _this.serviceViews.push(serviceVw);
      _this.$servicesWrap.append(serviceVw.render().el);
    });

    _this.listenTo(_this.services, 'remove', function (serviceMd, servicesCl, removeOpts) {
      var _this$serviceViews$sp = _this.serviceViews.splice(removeOpts.index, 1),
          _this$serviceViews$sp2 = _slicedToArray(_this$serviceViews$sp, 1),
          splicedVw = _this$serviceViews$sp2[0];

      splicedVw.remove();
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      var events = {
        'click .js-removeShippingOption': 'onClickRemoveShippingOption',
        'click .js-btnAddService': 'onClickAddService',
        'click .js-clearAllShipDest': 'onClickClearShipDest'
      };

      events['change #shipOptionType_' + this.model.cid] = 'onChangeShippingType';

      return events;
    }
  }, {
    key: 'tagName',
    value: function tagName() {
      return 'section';
    }
  }, {
    key: 'onClickRemoveShippingOption',
    value: function onClickRemoveShippingOption() {
      this.trigger('click-remove', { view: this });
    }
  }, {
    key: 'onClickAddService',
    value: function onClickAddService() {
      this.services.push(new _Service2.default());
    }
  }, {
    key: 'onClickClearShipDest',
    value: function onClickClearShipDest() {
      this.$shipDestinationSelect[0].selectize.clear();
    }
  }, {
    key: 'onChangeShippingType',
    value: function onChangeShippingType(e) {
      var method = void 0;

      if ((0, _jquery2.default)(e.target).val() === 'LOCAL_PICKUP') {
        method = 'addClass';
      } else {
        method = 'removeClass';

        var services = this.model.get('services');

        if (!services.length) services.push(new _Service2.default());
      }

      this.$serviceSection[method]('hide');
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      var fields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.$formFields;

      var formData = _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, fields);
      var indexedRegions = (0, _regions.getIndexedRegions)();

      // Strip out any region elements from shipping destinations
      // drop down. The individual countries will remain.
      formData.regions = formData.regions.filter(function (region) {
        return !indexedRegions[region];
      });

      return formData;
    }

    // Sets the model based on the current data in the UI.

  }, {
    key: 'setModelData',
    value: function setModelData() {
      // set the data for our nested Services views
      this.serviceViews.forEach(function (serviceVw) {
        return serviceVw.setModelData();
      });
      this.model.set(this.getFormData());
    }
  }, {
    key: 'createServiceView',
    value: function createServiceView(opts) {
      var _this2 = this;

      var options = _extends({
        getCurrency: this.options.getCurrency
      }, opts || {});

      var view = this.createChild(_Service4.default, options);

      this.listenTo(view, 'click-remove', function (e) {
        _this2.services.remove(_this2.services.at(_this2.serviceViews.indexOf(e.view)));
      });

      return view;
    }
  }, {
    key: 'representedRegions',


    /**
     * Returns a list of any regions that are fully represented in the provided
     * countries list.
     */
    value: function representedRegions() {
      var countries = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (!Array.isArray(countries)) {
        throw new Error('Please provide an array of country codes.');
      }

      var selectedRegions = [];

      _regions2.default.forEach(function (region) {
        if (region.countries.every(function (elem) {
          return countries.indexOf(elem) > -1;
        })) {
          selectedRegions.push(region.id);
        }
      });

      return selectedRegions;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/editListing/shippingOption.html', function (t) {
        _this3.$el.html(t(_extends({
          // Since multiple instances of this view will be rendered, any id's should
          // include the cid, so they're unique.
          cid: _this3.model.cid,
          listPosition: _this3.options.listPosition,
          shippingTypes: _this3.model.shippingTypes,
          errors: _this3.model.validationError || {}
        }, _this3.model.toJSON())));

        _this3.$('#shipOptionType_' + _this3.model.cid).select2({
          // disables the search box
          minimumResultsForSearch: Infinity
        });

        _this3.$shipDestinationSelect = _this3.getCachedEl('#shipDestinationsSelect_' + _this3.model.cid);
        _this3.$servicesWrap = _this3.$('.js-servicesWrap');

        _this3.$shipDestinationSelect.selectize({
          maxItems: null,
          valueField: 'id',
          searchField: ['text', 'id'],
          items: _this3.model.get('regions'),
          options: _this3.selectCountryData,
          render: {
            option: function option(data) {
              var className = data.isRegion ? 'region' : '';
              return '<div class="' + className + '">' + data.text + '</div>';
            },
            item: function item(data) {
              var className = data.isRegion ? 'region' : '';
              return '<div class="' + className + '">' + data.text + '</div>';
            }
          },
          onItemAdd: function onItemAdd(value) {
            var region = (0, _regions.getIndexedRegions)()[value];
            var selectize = _this3.$shipDestinationSelect[0].selectize;

            if (region) {
              // If adding a region, we'll add in all the countries for that region.
              // selectize.removeItem(value);
              selectize.addItems(region.countries, true);
            } else {
              // Adding a country may cause a region or regions to be represented.
              // We'll add in any full regions so they're not selectable as options.
              // CSS will hide the tag.
              selectize.addItems(_this3.representedRegions(selectize.items), true);
            }
          },
          onItemRemove: function onItemRemove(value) {
            var isRegion = !!(0, _regions.getIndexedRegions)()[value];
            var selectize = _this3.$shipDestinationSelect[0].selectize;
            var representedRegions = _this3.representedRegions(selectize.items);

            if (!isRegion) {
              // Adding a country may cause a regions or regions to be represented.
              // We'll add in any full regions so they're not selectable as options.
              // CSS will hide the tag.
              selectize.items.forEach(function (item) {
                var isItemRegion = (0, _regions.getIndexedRegions)()[item];
                if (isItemRegion && !representedRegions.includes(item)) {
                  selectize.removeItem(item, true);
                }
              });
            }
          }
        });

        _this3.serviceViews.forEach(function (serviceVw) {
          return serviceVw.remove();
        });
        _this3.serviceViews = [];
        var servicesFrag = document.createDocumentFragment();

        _this3.model.get('services').forEach(function (serviceMd) {
          var serviceVw = _this3.createServiceView({ model: serviceMd });

          _this3.serviceViews.push(serviceVw);
          serviceVw.render().$el.appendTo(servicesFrag);
        });

        _this3.$servicesWrap.append(servicesFrag);

        _this3._$headline = null;
        _this3._$shipDestinationDropdown = null;
        _this3._$formFields = null;
        _this3._$serviceSection = null;
        _this3._$shipDestinationsSelect = null;
      });

      return this;
    }
  }, {
    key: 'listPosition',
    set: function set(position) {
      if (typeof position !== 'number') {
        throw new Error('Please provide a position as a number');
      }

      var prevPosition = this.options.listPosition;
      var listPosition = this.options.listPosition = position;

      if (listPosition !== prevPosition) {
        this.$headline.text(_app2.default.polyglot.t('editListing.shippingOptions.optionHeading', { listPosition: listPosition }));
      }
    },
    get: function get() {
      return this.options.listPosition;
    }
  }, {
    key: '$headline',
    get: function get() {
      return this._$headline || (this._$headline = this.$('h1'));
    }
  }, {
    key: '$shipDestinationDropdown',
    get: function get() {
      return this._$shipDestinationDropdown || (this._$shipDestinationDropdown = this.$('#shipDestinationsDropdown_' + this.model.cid));
    }
  }, {
    key: '$serviceSection',
    get: function get() {
      return this._$serviceSection || (this._$serviceSection = this.$('.js-serviceSection'));
    }
  }, {
    key: '$formFields',
    get: function get() {
      return this._$formFields || (this._$formFields = this.$('select[name], input[name], textarea[name]').filter(function (index, el) {
        return !(0, _jquery2.default)(el).parents('.js-serviceSection').length;
      }));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;