'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

require('../../../lib/select2');

var _currencies = require('../../../data/currencies');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      removeOnClose: true,
      dismissOnOverlayClick: false,
      dismissOnEscPress: false,
      showCloseButton: false
    }, options);

    if (typeof opts.unsupportedCurrency !== 'string') {
      throw new Error('Please provide the unsupported currency code as a string.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.unsupportedCurrency = opts.unsupportedCurrency;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' modalTop modalScrollPage modalMedium';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-okCurrencySet': 'onClickOkCurrencySet'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onClickOkCurrencySet',
    value: function onClickOkCurrencySet() {
      this.close();
    }
  }, {
    key: 'getCurrency',
    value: function getCurrency() {
      return this.getCachedEl('.js-currencyList')[0].value;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      this.curList = this.curList || (0, _currencies.getCurrenciesSortedByCode)();

      (0, _loadTemplate2.default)('modals/editListing/unsupportedCurrency.html', function (t) {
        _this2.$el.html(t({
          unsupportedCurrency: _this2.unsupportedCurrency,
          curList: _this2.curList,
          userCurrency: _app2.default.settings.get('localCurrency')
        }));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this2).call(_this2);

        _this2.getCachedEl('.js-currencyList').select2();
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;