'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _VariantOption = require('../../../models/listing/VariantOption');

var _VariantOption2 = _interopRequireDefault(_VariantOption);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _Variant = require('./Variant');

var _Variant2 = _interopRequireDefault(_Variant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// There are some terminology mismatches between the UI and server. When the UI uses the
// term 'variant', it maps to an 'options' list in the listing API.
var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide an VariantOptions collection.');
    }

    if (typeof options.maxVariantCount === 'undefined') {
      throw new Error('Please provide the maximum variant count.');
    }

    // Certain variant validations are not possible to do purely in the model and
    // need to be done by a parent model. In that case higher-level errors can be passed
    // in the following format:
    // options.errors = {
    //   options[<model.cid>].<fieldName> = ['error1', 'error2', ...],
    //   options[<model.cid>].<fieldName2> = ['error1', 'error2', ...],
    //   options[<model2.cid>].<fieldName> = ['error1', 'error2', ...]
    // }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    _this._variantViews = [];

    _this.listenTo(_this.collection, 'add', function (md, cl) {
      var index = cl.indexOf(md);
      var view = _this.createVariantView(md);

      if (index) {
        _this.$variantsWrap.find('> *').eq(index - 1).after(view.render().el);
      } else {
        _this.$variantsWrap.prepend(view.render().el);
      }

      _this._variantViews.splice(index, 0, view);

      if (_this.collection.length >= _this.options.maxVariantCount) {
        _this.$btnAddVariant.addClass('hide');
      }
    });

    _this.listenTo(_this.collection, 'remove', function (md, cl, removeOpts) {
      _this._variantViews.splice(removeOpts.index, 1)[0].remove();

      if (_this.collection.length < _this.options.maxVariantCount) {
        _this.$btnAddVariant.removeClass('hide');
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-btnAddVariant': 'onClickAddVariant'
      };
    }
  }, {
    key: 'onClickAddVariant',
    value: function onClickAddVariant() {
      this.collection.add(new _VariantOption2.default());
      this._variantViews[this._variantViews.length - 1].$('input[name=name]').focus();
    }
  }, {
    key: 'setCollectionData',
    value: function setCollectionData() {
      this._variantViews.forEach(function (variant) {
        return variant.setModelData();
      });
    }
  }, {
    key: 'setModelData',
    value: function setModelData(index) {
      if (typeof index !== 'number') {
        throw new Error('Please provide a numeric index.');
      }

      var view = this._variantViews[index];
      if (view) view.setModelData();
    }
  }, {
    key: 'createVariantView',
    value: function createVariantView(model) {
      var _this2 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var errors = {};

      if (this.options.errors) {
        Object.keys(this.options.errors).forEach(function (errKey) {
          if (errKey.startsWith('options[' + model.cid + ']')) {
            errors[errKey.slice(errKey.indexOf('.') + 1)] = _this2.options.errors[errKey];
          }
        });
      }

      var view = this.createChild(_Variant2.default, _extends({
        model: model,
        errors: errors
      }, options));

      this.listenTo(view, 'removeClick', function (e) {
        return _this2.collection.remove(e.view.model);
      });

      this.listenTo(view, 'choiceChange', function (e) {
        return _this2.trigger('variantChoiceChange', e);
      });

      return view;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/editListing/variants.html', function (t) {
        _this3.$el.html(t({
          variants: _this3.collection.toJSON(),
          maxVariantCount: _this3.options.maxCouponCount
        }));

        _this3.$variantsWrap = _this3.$('.js-variantsWrap');
        _this3._$btnAddVariant = null;

        _this3._variantViews.forEach(function (variant) {
          return variant.remove();
        });
        _this3._variantViews = [];
        var variantsFrag = document.createDocumentFragment();

        _this3.collection.forEach(function (variant) {
          var view = _this3.createVariantView(variant);
          _this3._variantViews.push(view);
          view.render().$el.appendTo(variantsFrag);
        });

        _this3.$variantsWrap.append(variantsFrag);
      });

      return this;
    }
  }, {
    key: 'views',
    get: function get() {
      return this._variantViews;
    }
  }, {
    key: '$btnAddVariant',
    get: function get() {
      return this._$btnAddVariant || (this._$btnAddVariant = this.$('.js-btnAddVariant'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;