'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

require('jquery-zoom');

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

require('../../../lib/select2');

require('../../../utils/lib/velocity');

var _responsive = require('../../../utils/responsive');

var _currency = require('../../../utils/currency');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _modalManager = require('../../../utils/modalManager');

var _inventory = require('../../../utils/inventory');

var _metrics = require('../../../utils/metrics');

var _countries = require('../../../data/countries');

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _Purchase = require('../purchase/Purchase');

var _Purchase2 = _interopRequireDefault(_Purchase);

var _Rating = require('./Rating');

var _Rating2 = _interopRequireDefault(_Rating);

var _Reviews = require('../../reviews/Reviews');

var _Reviews2 = _interopRequireDefault(_Reviews);

var _SocialBtns = require('../../components/SocialBtns');

var _SocialBtns2 = _interopRequireDefault(_SocialBtns);

var _QuantityDisplay = require('../../components/QuantityDisplay');

var _QuantityDisplay2 = _interopRequireDefault(_QuantityDisplay);

var _listing = require('../../../models/listing/');

var _PopInMessage = require('../../components/PopInMessage');

var _PopInMessage2 = _interopRequireDefault(_PopInMessage);

var _SimpleMessage = require('../SimpleMessage');

var _NsfwWarning = require('../NsfwWarning');

var _NsfwWarning2 = _interopRequireDefault(_NsfwWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model) {
      throw new Error('Please provide a model.');
    }

    var opts = _extends({
      checkNsfw: true,
      removeOnClose: true
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this._shipsFreeToMe = _this.model.shipsFreeToMe;
    _this.activePhotoIndex = 0;
    _this.totalPrice = _this.model.get('item').get('price');

    // Sometimes a profile model is available and the vendor info
    // can be obtained from that.
    if (opts.profile) {
      var avatarHashes = opts.profile.get('avatarHashes');

      _this.vendor = {
        peerID: opts.profile.id,
        name: opts.profile.get('name'),
        handle: opts.profile.get('handle'),
        avatar: {
          tiny: avatarHashes.get('tiny'),
          small: avatarHashes.get('small')
        }
      };
    }

    // In most cases the page opening this modal will already have and be able
    // to provide the vendor information. If it cannot, then I suppose we
    // could fetch the profile and lazy load it in, but we can cross that
    // bridge when we get to it.
    _this.vendor = _this.vendor || opts.vendor;

    _this.countryData = (0, _countries.getTranslatedCountries)().map(function (countryObj) {
      return { id: countryObj.dataName, text: countryObj.name };
    });

    _this.defaultCountry = _app2.default.settings.get('shippingAddresses').length ? _app2.default.settings.get('shippingAddresses').at(0).get('country') : _app2.default.settings.get('country');

    _this.listenTo(_app2.default.settings, 'change:country', function () {
      return _this.shipsFreeToMe = _this.model.shipsFreeToMe;
    });

    _this.listenTo(_app2.default.settings.get('shippingAddresses'), 'update', function (cl, updateOpts) {
      if (updateOpts.changes.added.length || updateOpts.changes.removed.length) {
        _this.shipsFreeToMe = _this.model.shipsFreeToMe;
      }
    });

    if (_this.model.isOwnListing) {
      _this.listenTo(_listing.events, 'saved', function (md, e) {
        var slug = _this.model.get('slug');
        if (e.slug === slug) {
          // Factoring out the inventory from the listing data because
          // the inventory will auto-update on a change - no need for a
          // refresh pop-up if that's the only thing that changed.
          var prev = e.prev;
          delete prev.item.cryptoQuantity;
          var cur = _this.model.toJSON();
          delete cur.item.cryptoQuantity;

          if (!_underscore2.default.isEqual(prev, cur)) {
            _this.showDataChangedMessage();
          }
        }
      });

      _this.listenTo(_app2.default.profile.get('avatarHashes'), 'change', function () {
        _this.$storeOwnerAvatar.attr('style', (0, _responsive.getAvatarBgImage)(_app2.default.profile.get('avatarHashes').toJSON()));
      });

      _this.listenTo(_app2.default.settings, 'change:localCurrency', function () {
        return _this.showDataChangedMessage();
      });
      _this.listenTo(_app2.default.localSettings, 'change:bitcoinUnit', function () {
        return _this.showDataChangedMessage();
      });
    }

    _this.hasVerifiedMods = _app2.default.verifiedMods.matched(_this.model.get('moderators')).length > 0;

    _this.listenTo(_app2.default.verifiedMods, 'update', function () {
      var newHasVerifiedMods = _app2.default.verifiedMods.matched(_this.model.get('moderators')).length > 0;
      if (newHasVerifiedMods !== _this.hasVerifiedMods) {
        _this.hasVerifiedMods = newHasVerifiedMods;
        _this.showDataChangedMessage();
      }
    });

    _this.rating = _this.createChild(_Rating2.default);

    // get the ratings data, if any
    _this.ratingsFetch = _jquery2.default.get(_app2.default.getServerUrl('ob/ratings/' + _this.vendor.peerID + '/' + _this.model.get('slug'))).done(function (data) {
      return _this.onRatings(data);
    }).fail(function (jqXhr) {
      if (jqXhr.statusText === 'abort') return;
      var failReason = jqXhr.responseJSON && jqXhr.responseJSON.reason || '';
      (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('listingDetail.errors.fetchRatings'), failReason);
    });

    _this.reviews = _this.createChild(_Reviews2.default, {
      async: true,
      showListingData: true,
      initialState: {
        isFetchingRatings: true
      }
    });

    if (_this.model.isCrypto) {
      (0, _metrics.startEvent)('Listing_InventoryFetch');
      _this.inventoryFetch = (0, _inventory.getInventory)(_this.vendor.peerID, {
        slug: _this.model.get('slug'),
        coinDivisibility: _this.model.get('metadata').get('coinDivisibility')
      }).done(function (e) {
        _this._inventory = e.inventory;
        (0, _metrics.endEvent)('Listing_InventoryFetch', {
          ownListing: !!_this.ownListing,
          errors: 'none'
        });
      }).fail(function (e) {
        (0, _metrics.endEvent)('Listing_InventoryFetch', {
          ownListing: !!_this.ownListing,
          errors: e.error || e.errCode || 'unknown error'
        });
      });
      _this.listenTo(_inventory.events, 'inventory-change', function (e) {
        return _this._inventory = e.inventory;
      });
    }

    _this.boundDocClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundDocClick);

    _this.rendered = false;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' listingDetail modalScrollPage';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-editListing': 'onClickEditListing',
        'click .js-cloneListing': 'onClickCloneListing',
        'click .js-deleteListing': 'onClickDeleteListing',
        'click .js-deleteConfirmed': 'onClickConfirmedDelete',
        'click .js-deleteConfirmCancel': 'onClickConfirmCancel',
        'click .js-deleteConfirmedBox': 'onClickDeleteConfirmBox',
        'click .js-gotoPhotos': 'onClickGotoPhotos',
        'click .js-freeShippingLabel': 'onClickFreeShippingLabel',
        'change #shippingDestinations': 'onSetShippingDestination',
        'click .js-photoSelect': 'onClickPhotoSelect',
        'click .js-photoPrev': 'onClickPhotoPrev',
        'click .js-photoNext': 'onClickPhotoNext',
        'click .js-goToStore': 'onClickGoToStore',
        'click .js-purchaseBtn': 'startPurchase',
        'click .js-rating': 'clickRating',
        'change .js-variantSelect': 'onChangeVariantSelect'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick() {
      this.$deleteConfirmedBox.addClass('hide');
    }
  }, {
    key: 'onRatings',
    value: function onRatings(data) {
      var pData = data || {};
      this.rating.averageRating = pData.average;
      this.rating.ratingCount = pData.count;
      this.rating.fetched = true;
      this.rating.render();
      this.reviews.reviewIDs = pData.ratings || [];
      this.reviews.setState({ isFetchingRatings: false });
    }
  }, {
    key: 'onClickEditListing',
    value: function onClickEditListing() {
      var _this2 = this;

      var onCloseEditModal = function onCloseEditModal() {
        _this2.close();

        if (!_this2.isRemoved()) {
          _this2.$el.removeClass('hide');
        }
      };

      var onEditModalClickReturn = function onEditModalClickReturn() {
        _this2.editModal.confirmClose().done(function () {
          _this2.stopListening(null, null, onCloseEditModal);
          _this2.editModal.remove();
          _this2.$el.removeClass('hide');
        });
      };

      this.editModal = (0, _modalManager.launchEditListingModal)({
        model: this.model,
        returnText: _app2.default.polyglot.t('listingDetail.editListingReturnText'),
        onClickViewListing: onEditModalClickReturn
      });

      this.$el.addClass('hide');
      this.listenTo(this.editModal, 'close', onCloseEditModal);
      this.listenTo(this.editModal, 'click-return', onEditModalClickReturn);
    }
  }, {
    key: 'onClickCloneListing',
    value: function onClickCloneListing() {
      (0, _modalManager.launchEditListingModal)({
        model: this.model.cloneListing()
      });
    }
  }, {
    key: 'onClickDeleteListing',
    value: function onClickDeleteListing() {
      this.$deleteConfirmedBox.removeClass('hide');
      // don't bubble to the document click handler
      return false;
    }
  }, {
    key: 'onClickDeleteConfirmBox',
    value: function onClickDeleteConfirmBox() {
      // don't bubble to the document click handler
      return false;
    }
  }, {
    key: 'onClickConfirmedDelete',
    value: function onClickConfirmedDelete() {
      var _this3 = this;

      if (this.destroyRequest && this.destroyRequest.state === 'pending') return;
      this.destroyRequest = this.model.destroy({ wait: true });

      if (this.destroyRequest) {
        this.$deleteListing.addClass('processing');

        this.destroyRequest.done(function () {
          if (_this3.destroyRequest.statusText === 'abort' || _this3.isRemoved()) return;

          _this3.close();
        }).always(function () {
          if (!_this3.isRemoved()) {
            _this3.$deleteListing.removeClass('processing');
          }
        });
      }
    }
  }, {
    key: 'onClickConfirmCancel',
    value: function onClickConfirmCancel() {
      this.$deleteConfirmedBox.addClass('hide');
    }
  }, {
    key: 'onClickGotoPhotos',
    value: function onClickGotoPhotos() {
      this.gotoPhotos();
    }
  }, {
    key: 'onClickGoToStore',
    value: function onClickGoToStore() {
      if (this.options.openedFromStore) {
        this.close();
      } else {
        var base = this.vendor.handle ? '@' + this.vendor.handle : this.vendor.peerID;
        _app2.default.router.navigateUser(base + '/store', this.vendor.peerID, { trigger: true });
      }
    }
  }, {
    key: 'gotoPhotos',
    value: function gotoPhotos() {
      this.$photoSection.velocity('scroll', {
        duration: 500,
        easing: 'easeOutSine',
        container: this.$el
      });
    }
  }, {
    key: 'clickRating',
    value: function clickRating() {
      this.gotoReviews();
    }
  }, {
    key: 'gotoReviews',
    value: function gotoReviews() {
      this.$reviews.velocity('scroll', {
        duration: 500,
        easing: 'easeOutSine',
        container: this.$el
      });
    }
  }, {
    key: 'onClickPhotoSelect',
    value: function onClickPhotoSelect(e) {
      this.setSelectedPhoto((0, _jquery2.default)(e.target).index('.js-photoSelect'));
    }
  }, {
    key: 'setSelectedPhoto',
    value: function setSelectedPhoto(photoIndex) {
      if (_is_js2.default.not.number(photoIndex)) {
        throw new Error('Please provide an index for the selected photo.');
      }
      if (photoIndex < 0) {
        throw new Error('Please provide a valid index for the selected photo.');
      }
      var photoCol = this.model.toJSON().item.images;
      var photoHash = photoCol[photoIndex].original;
      var phSrc = _app2.default.getServerUrl('ob/images/' + photoHash);

      this.activePhotoIndex = photoIndex;
      this.$photoSelected.trigger('zoom.destroy'); // old zoom must be removed
      this.$photoSelectedInner.attr('src', phSrc);
    }
  }, {
    key: 'activateZoom',
    value: function activateZoom() {
      var _this4 = this;

      if (this.$photoSelectedInner.width() >= this.$photoSelected.width() || this.$photoSelectedInner.height() >= this.$photoSelected.height()) {
        this.$photoSelected.removeClass('unzoomable').zoom({
          url: this.$photoSelectedInner.attr('src'),
          on: 'click',
          onZoomIn: function onZoomIn() {
            _this4.$photoSelected.addClass('open');
          },
          onZoomOut: function onZoomOut() {
            _this4.$photoSelected.removeClass('open');
          }
        });
      } else {
        this.$photoSelected.addClass('unzoomable');
      }
    }
  }, {
    key: 'setActivePhotoThumbnail',
    value: function setActivePhotoThumbnail(thumbIndex) {
      if (_is_js2.default.not.number(thumbIndex)) {
        throw new Error('Please provide an index for the selected photo thumbnail.');
      }
      if (thumbIndex < 0) {
        throw new Error('Please provide a valid index for the selected photo thumbnail.');
      }
      this.$photoRadioBtns.prop('checked', false).eq(thumbIndex).prop('checked', true);
    }
  }, {
    key: 'onClickPhotoPrev',
    value: function onClickPhotoPrev() {
      var targetIndex = this.activePhotoIndex - 1;
      var imagesLength = parseInt(this.model.toJSON().item.images.length, 10);

      targetIndex = targetIndex < 0 ? imagesLength - 1 : targetIndex;
      this.setSelectedPhoto(targetIndex);
      this.setActivePhotoThumbnail(targetIndex);
    }
  }, {
    key: 'onClickPhotoNext',
    value: function onClickPhotoNext() {
      var targetIndex = this.activePhotoIndex + 1;
      var imagesLength = parseInt(this.model.toJSON().item.images.length, 10);

      targetIndex = targetIndex >= imagesLength ? 0 : targetIndex;
      this.setSelectedPhoto(targetIndex);
      this.setActivePhotoThumbnail(targetIndex);
    }
  }, {
    key: 'onClickFreeShippingLabel',
    value: function onClickFreeShippingLabel() {
      this.gotoShippingOptions();
    }
  }, {
    key: 'gotoShippingOptions',
    value: function gotoShippingOptions() {
      this.$shippingSection.velocity('scroll', {
        duration: 500,
        easing: 'easeOutSine',
        container: this.$el
      });
    }
  }, {
    key: 'onChangeVariantSelect',
    value: function onChangeVariantSelect() {
      this.adjustPriceBySku();
    }
  }, {
    key: 'adjustPriceBySku',
    value: function adjustPriceBySku() {
      var variantCombo = [];
      // assemble a combo of the indexes of the selected variants
      this.variantSelects.each(function (i, select) {
        variantCombo.push((0, _jquery2.default)(select).prop('selectedIndex'));
      });
      // each sku has a code that matches the selected variant index combos
      var sku = this.model.get('item').get('skus').find(function (v) {
        return _underscore2.default.isEqual(v.get('variantCombo'), variantCombo);
      });
      var surcharge = sku ? sku.get('surcharge') : 0;
      var _totalPrice = this.model.get('item').get('price') + surcharge;
      if (_totalPrice !== this.totalPrice) {
        this.totalPrice = _totalPrice;
        var adjPrice = (0, _currency.renderFormattedCurrency)(this.totalPrice, this.model.get('metadata').get('pricingCurrency'), _app2.default.settings.get('localCurrency'));
        this.getCachedEl('.js-price').html(adjPrice);
      }
    }
  }, {
    key: 'showDataChangedMessage',
    value: function showDataChangedMessage() {
      var _this5 = this;

      if (this.dataChangePopIn && !this.dataChangePopIn.isRemoved()) {
        this.dataChangePopIn.$el.velocity('callout.shake', { duration: 500 });
      } else {
        this.dataChangePopIn = this.createChild(_PopInMessage2.default, {
          messageText: (0, _PopInMessage.buildRefreshAlertMessage)(_app2.default.polyglot.t('listingDetail.listingDataChangedPopin'))
        });

        this.listenTo(this.dataChangePopIn, 'clickRefresh', function () {
          return _this5.render();
        });

        this.listenTo(this.dataChangePopIn, 'clickDismiss', function () {
          _this5.dataChangePopIn.remove();
          _this5.dataChangePopIn = null;
        });

        this.$popInMessages.append(this.dataChangePopIn.render().el);
      }
    }
  }, {
    key: 'onSetShippingDestination',
    value: function onSetShippingDestination(e) {
      this.renderShippingDestinations((0, _jquery2.default)(e.target).val());
    }
  }, {
    key: 'renderShippingDestinations',
    value: function renderShippingDestinations(destination) {
      var _this6 = this;

      if (!destination) {
        throw new Error('Please provide a destination.');
      }
      var shippingOptions = this.model.get('shippingOptions').toJSON();
      var templateData = shippingOptions.filter(function (option) {
        if (destination === 'ALL') return option.regions;
        return option.regions.includes(destination);
      });
      (0, _loadTemplate2.default)('modals/listingDetail/shippingOptions.html', function (t) {
        _this6.$shippingOptions.html(t({
          templateData: templateData,
          displayCurrency: _app2.default.settings.get('localCurrency'),
          pricingCurrency: _this6.model.get('metadata').get('pricingCurrency')
        }));
      });
    }
  }, {
    key: 'startPurchase',
    value: function startPurchase() {
      var _this7 = this;

      if (!this.model.isCrypto) {
        if (this.totalPrice <= 0) {
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('listingDetail.errors.noPurchaseTitle'), _app2.default.polyglot.t('listingDetail.errors.zeroPriceMsg'));
          return;
        }
      } else {
        if (typeof this._inventory === 'number' && this._inventory <= 0) {
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('listingDetail.errors.noPurchaseTitle'), _app2.default.polyglot.t('listingDetail.errors.outOfStock'));
          return;
        }
      }

      var selectedVariants = [];
      this.variantSelects.each(function (i, select) {
        var variant = {};
        variant.name = (0, _jquery2.default)(select).attr('name');
        variant.value = (0, _jquery2.default)(select).val();
        selectedVariants.push(variant);
      });

      if (this.purchaseModal) this.purchaseModal.remove();

      this.purchaseModal = new _Purchase2.default({
        listing: this.model,
        variants: selectedVariants,
        vendor: this.vendor,
        removeOnClose: true,
        showCloseButton: false,
        phase: 'pay',
        inventory: this._inventory
      }).render().open();

      this.purchaseModal.on('modal-will-remove', function () {
        return _this7.purchaseModal = null;
      });
      this.listenTo(this.purchaseModal, 'closeBtnPressed', function () {
        return _this7.close();
      });
      (0, _metrics.recordEvent)('Purchase_Start');
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.editModal) this.editModal.remove();
      if (this.purchaseModal) this.purchaseModal.remove();
      if (this.destroyRequest) this.destroyRequest.abort();
      if (this.ratingsFetch) this.ratingsFetch.abort();
      if (this.inventoryFetch) this.inventoryFetch.abort();
      (0, _jquery2.default)(document).off('click', this.boundDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this8 = this;

      if (this.dataChangePopIn) this.dataChangePopIn.remove();

      var defaultBadge = _app2.default.verifiedMods.defaultBadge(this.model.get('moderators'));
      var nsfwWarning = void 0;

      if (!this.rendered && this.options.checkNsfw && this.model.get('item').get('nsfw') && !this.model.isOwnListing && !_app2.default.settings.get('showNsfw')) {
        nsfwWarning = new _NsfwWarning2.default().render().open();
        this.listenTo(nsfwWarning, 'canceled', function () {
          return _this8.close();
        });
      }

      (0, _loadTemplate2.default)('modals/listingDetail/listing.html', function (t) {
        var flatModel = _this8.model.toJSON();

        _this8.$el.html(t(_extends({}, flatModel, {
          shipsFreeToMe: _this8.shipsFreeToMe,
          ownListing: _this8.model.isOwnListing,
          price: _this8.model.price,
          displayCurrency: _app2.default.settings.get('localCurrency'),
          // the ships from data doesn't exist yet
          // shipsFromCountry: this.model.get('shipsFrom');
          countryData: _this8.countryData,
          defaultCountry: _this8.defaultCountry,
          vendor: _this8.vendor,
          openedFromStore: _this8.options.openedFromStore,
          currencyValidity: (0, _currency.getCurrencyValidity)(_this8.model.get('metadata').get('pricingCurrency') || 'USD'),
          hasVerifiedMods: _this8.hasVerifiedMods,
          verifiedModsData: _app2.default.verifiedMods.data,
          defaultBadge: defaultBadge,
          isCrypto: _this8.model.isCrypto
        })));

        if (nsfwWarning) _this8.$el.addClass('hide');
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this8).call(_this8);

        _this8.$('.js-rating').append(_this8.rating.render().$el);
        _this8.$reviews = _this8.$('.js-reviews');
        _this8.$reviews.append(_this8.reviews.render().$el);

        if (!_this8.model.isOwnListing) {
          if (_this8.socialBtns) _this8.socialBtns.remove();
          _this8.socialBtns = _this8.createChild(_SocialBtns2.default, {
            targetID: _this8.vendor.peerID
          });
          _this8.$('.js-socialBtns').append(_this8.socialBtns.render().$el);
        }

        _this8.$photoSelectedInner = _this8.$('.js-photoSelectedInner');
        _this8._$deleteListing = null;
        _this8._$shipsFreeBanner = null;
        _this8._$popInMessages = null;
        _this8._$photoSection = null;
        _this8._$photoSelected = null;
        _this8._$shippingOptions = null;
        _this8._$photoRadioBtns = null;
        _this8._$shippingSection = null;
        _this8._$storeOwnerAvatar = null;
        _this8._$deleteConfirmedBox = null;

        _this8.$photoSelectedInner.on('load', function () {
          return _this8.activateZoom();
        });

        _this8.variantSelects = _this8.$('.js-variantSelect');

        _this8.variantSelects.select2({
          // disables the search box
          minimumResultsForSearch: Infinity
        });

        _this8.$('#shippingDestinations').select2();
        _this8.renderShippingDestinations(_this8.defaultCountry);
        _this8.setSelectedPhoto(_this8.activePhotoIndex);
        _this8.setActivePhotoThumbnail(_this8.activePhotoIndex);
        _this8.adjustPriceBySku();

        if (_this8.model.isCrypto) {
          if (_this8.cryptoInventory) _this8.cryptoInventory.remove();
          _this8.cryptoInventory = _this8.createChild(_QuantityDisplay2.default, {
            peerId: _this8.vendor.peerID,
            slug: _this8.model.get('slug'),
            initialState: {
              coinType: _this8.model.get('metadata').get('coinType'),
              amount: _this8._inventory
            }
          });
          _this8.getCachedEl('.js-cryptoInventory').html(_this8.cryptoInventory.render().el);
        }

        if (nsfwWarning) {
          setTimeout(function () {
            nsfwWarning.bringToTop();
            _this8.$el.removeClass('hide');
          });
        }
      });

      this.rendered = true;

      return this;
    }
  }, {
    key: 'shipsFreeToMe',
    get: function get() {
      return this._shipsFreeToMe;
    },
    set: function set(shipsFree) {
      var prevVal = this._shipsFreeToMe;
      this._shipsFreeToMe = !!shipsFree;

      if (prevVal !== this._shipsFreeToMe) {
        this.$shipsFreeBanner[this._shipsFreeToMe ? 'removeClass' : 'addClass']('hide');
      }
    }
  }, {
    key: '$deleteListing',
    get: function get() {
      return this._$deleteListing || this.$('.js-deleteListing');
    }
  }, {
    key: '$shipsFreeBanner',
    get: function get() {
      return this._$shipsFreeBanner || this.$('.js-shipsFreeBanner');
    }
  }, {
    key: '$popInMessages',
    get: function get() {
      return this._$popInMessages || (this._$popInMessages = this.$('.js-popInMessages'));
    }
  }, {
    key: '$photoSection',
    get: function get() {
      return this._$photoSection || (this._$photoSection = this.$('.js-photoSection'));
    }
  }, {
    key: '$photoSelected',
    get: function get() {
      return this._$photoSelected || (this._$photoSelected = this.$('.js-photoSelected'));
    }
  }, {
    key: '$shippingSection',
    get: function get() {
      return this._$shippingSection || (this._$shippingSection = this.$('#shippingSection'));
    }
  }, {
    key: '$shippingOptions',
    get: function get() {
      return this._$shippingOptions || (this._$shippingOptions = this.$('.js-shippingOptions'));
    }
  }, {
    key: '$photoRadioBtns',
    get: function get() {
      return this._$photoRadioBtns || (this._$photoRadioBtns = this.$('.js-photoSelect'));
    }
  }, {
    key: '$storeOwnerAvatar',
    get: function get() {
      return this._$storeOwnerAvatar || (this._$storeOwnerAvatar = this.$('.js-storeOwnerAvatar'));
    }
  }, {
    key: '$deleteConfirmedBox',
    get: function get() {
      return this._$deleteConfirmedBox || (this._$deleteConfirmedBox = this.$('.js-deleteConfirmedBox'));
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;