'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _Profile = require('../../models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

var _SocialBtns = require('../components/SocialBtns');

var _SocialBtns2 = _interopRequireDefault(_SocialBtns);

var _BaseModal2 = require('./BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _languages = require('../../data/languages');

var _VerifiedMod = require('../components/VerifiedMod');

var _VerifiedMod2 = _interopRequireDefault(_VerifiedMod);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      removeOnClose: true
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    if (!_this.model || !(_this.model instanceof _Profile2.default)) {
      throw new Error('Please provide a Profile model.');
    }

    _this.verifiedModModel = _app2.default.verifiedMods.get(_this.model.get('peerID'));

    _this.listenTo(_app2.default.verifiedMods, 'update', function () {
      var newVerifiedModModel = _app2.default.verifiedMods.get(_this.model.get('peerID'));
      if (newVerifiedModModel !== _this.verifiedModModel) {
        _this.verifiedModModel = newVerifiedModModel;
        _this.render();
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' moderatorDetails modalTop modalScrollPage modalNarrow';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-addAsModerator': 'addAsModerator'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'addAsModerator',
    value: function addAsModerator() {
      this.trigger('addAsModerator');
      this.close();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var modLanguages = this.model.get('moderatorInfo').get('languages').map(function (lang) {
        var langData = (0, _languages.getLangByCode)(lang);
        return langData && langData.name || lang;
      });

      (0, _loadTemplate2.default)('modals/moderatorDetails.html', function (t) {
        _this2.$el.html(t(_extends({
          followedByYou: _this2.followedByYou,
          displayCurrency: _app2.default.settings.get('localCurrency'),
          ownMod: _app2.default.settings.get('storeModerators').indexOf(_this2.model.id) !== -1,
          purchase: _this2.options.purchase,
          cardState: _this2.options.cardState,
          modLanguages: modLanguages,
          verifiedMod: _this2.verifiedModModel
        }, _this2.model.toJSON())));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this2).call(_this2);

        _this2.$followBtn = _this2.$('.js-follow');
        _this2.$unFollowBtn = _this2.$('.js-unFollow');

        if (_this2.socialBtns) _this2.socialBtns.remove();
        _this2.socialBtns = _this2.createChild(_SocialBtns2.default, {
          targetID: _this2.model.id,
          initialState: {
            stripClasses: 'flexHCent gutterH',
            btnClasses: 'clrP clrBr clrSh2'
          }
        });
        _this2.$('.js-socialBtns').append(_this2.socialBtns.render().$el);

        if (_this2.verifiedMod) _this2.verifiedMod.remove();
        _this2.verifiedMod = _this2.createChild(_VerifiedMod2.default, (0, _VerifiedMod.getModeratorOptions)({
          model: _this2.verifiedModModel,
          shortText: false
        }));
        _this2.getCachedEl('.js-verifiedMod').append(_this2.verifiedMod.render().el);
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;