'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _responsive = require('../../../utils/responsive');

var _order = require('../../../utils/order');

var _OrderDetail = require('./OrderDetail.js');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!_this.model) {
      throw new Error('Please provide an ResolveDispute model.');
    }

    if (!options.case) {
      throw new Error('Please provide a Case model.');
    }

    _this.case = options.case;

    (0, _OrderDetail.checkValidParticipantObject)(options.buyer, 'buyer');
    (0, _OrderDetail.checkValidParticipantObject)(options.vendor, 'vendor');

    options.buyer.getProfile().done(function (profile) {
      _this.buyerProfile = profile;
      if (_this.rendered) {
        _this.getCachedEl('.js-buyerName').text(_this.buyerProfile.get('name'));
        _this.getCachedEl('.js-buyerAvatar').attr('style', (0, _responsive.getAvatarBgImage)(profile.get('avatarHashes').toJSON()));
      }
    });

    options.vendor.getProfile().done(function (profile) {
      _this.vendorProfile = profile;
      if (_this.rendered) {
        _this.getCachedEl('.js-vendorName').text(_this.vendorProfile.get('name'));
        _this.getCachedEl('.js-vendorAvatar').attr('style', (0, _responsive.getAvatarBgImage)(profile.get('avatarHashes').toJSON()));
      }
    });

    _this.listenTo(_order.events, 'resolvingDispute', _this.onResolvingDispute);
    _this.listenTo(_order.events, 'resolveDisputeComplete resolveDisputeFail', _this.onResolveDisputeAlways);
    _this.listenTo(_this.case, 'otherContractArrived', function (md, data) {
      var type = data.isBuyer ? 'buyer' : 'vendor';
      _this.$el.toggleClass(type + 'ContractUnavailable', !_this.case.get(type + 'Contract'));
    });

    _this.boundOnDocClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundOnDocClick);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'resolveDisputeTab';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-backToSummary': 'onClickBackToSummary',
        'click .js-cancel': 'onClickCancel',
        'click .js-submit': 'onClickSubmit',
        'click .js-resolveConfirmed': 'onClickConfirmedSubmit',
        'click .js-resolveConfirm': 'onClickResolveConfirmBox',
        'click .js-resolveConfirmCancel': 'onClickCancelConfirm'
      };
    }
  }, {
    key: 'onClickResolveConfirmBox',
    value: function onClickResolveConfirmBox() {
      // ensure event doesn't bubble so onDocumentClick doesn't
      // close the confirmBox.
      return false;
    }
  }, {
    key: 'onClickCancelConfirm',
    value: function onClickCancelConfirm() {
      this.getCachedEl('.js-resolveConfirm').addClass('hide');
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick() {
      this.getCachedEl('.js-resolveConfirm').addClass('hide');
    }
  }, {
    key: 'onClickBackToSummary',
    value: function onClickBackToSummary() {
      this.trigger('clickBackToSummary');
    }
  }, {
    key: 'onClickCancel',
    value: function onClickCancel() {
      var id = this.model.id;
      this.model.reset();
      // restore the id reset blew away
      this.model.set({ orderId: id });
      this.render();
      this.trigger('clickCancel');
    }
  }, {
    key: 'onClickSubmit',
    value: function onClickSubmit() {
      this.getCachedEl('.js-resolveConfirm').removeClass('hide');
      return false;
    }
  }, {
    key: 'onClickConfirmedSubmit',
    value: function onClickConfirmedSubmit() {
      var formData = this.getFormData();
      this.model.set(formData);
      this.model.set({
        buyerPercentage: this.case.get('buyerContract') ? formData.buyerPercentage : 0,
        vendorPercentage: this.case.get('vendorContract') ? formData.vendorPercentage : 0
      }, { validate: true });

      if (!this.model.validationError) {
        (0, _order.resolveDispute)(this.model);
      }

      this.render();
      var $firstErr = this.$('.errorList:first');
      if ($firstErr.length) $firstErr[0].scrollIntoViewIfNeeded();
    }
  }, {
    key: 'onResolvingDispute',
    value: function onResolvingDispute(e) {
      if (e.id === this.model.id) {
        this.getCachedEl('.js-submit').addClass('processing');
        this.getCachedEl('.js-cancel').addClass('disabled');
      }
    }
  }, {
    key: 'onResolveDisputeAlways',
    value: function onResolveDisputeAlways(e) {
      if (e.id === this.model.id) {
        this.getCachedEl('.js-submit').removeClass('processing');
        this.getCachedEl('.js-cancel').removeClass('disabled');
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      (0, _jquery2.default)(document).off('click', this.boundOnDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/orderDetail/resolveDispute.html', function (t) {
        var templateData = _extends({}, _this2.model.toJSON(), {
          errors: _this2.model.validationError || {},
          resolvingDispute: (0, _order.resolvingDispute)(_this2.model.id)
        });

        if (_this2.buyerProfile) {
          templateData.buyerAvatarHashes = _this2.buyerProfile.get('avatarHashes').toJSON();
          templateData.buyerName = _this2.buyerProfile.get('name');
        }

        if (_this2.vendorProfile) {
          templateData.vendorAvatarHashes = _this2.vendorProfile.get('avatarHashes').toJSON();
          templateData.vendorName = _this2.vendorProfile.get('name');
        }

        _this2.$el.html(t(templateData));
        _this2.$el.toggleClass('vendorContractUnavailable', !_this2.case.get('vendorContract'));
        _this2.$el.toggleClass('buyerContractUnavailable', !_this2.case.get('buyerContract'));
        _this2.$el.toggleClass('vendorProcessingError', _this2.case.vendorProcessingError);
        _this2.rendered = true;
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;