'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../../../app');

var _app2 = _interopRequireDefault(_app);

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Contract = require('./Contract');

var _Contract2 = _interopRequireDefault(_Contract);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!_this.model) {
      throw new Error('Please provide a model.');
    }

    _this.options = options || {};

    if (_this.isCase && (!_this.model.get('vendorContract') || !_this.model.get('buyerContract'))) {
      _this.listenTo(_this.model, 'otherContractArrived', function (md, data) {
        var rawContract = _this.model.get('raw' + (data.isBuyer ? 'Buyer' : 'Vendor') + 'Contract');

        if (!_this.model.bothContractsValid) _this.renderContract(rawContract);
        _this.renderStatus();

        if (_this.model.bothContractsValid) {
          _this[(data.isBuyer ? 'vendor' : 'buyer') + 'ContractVw'].setState({ heading: '' });
        }
      });
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'contractTab';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-backToSummary': 'onClickBackToSummary',
        'click .renderjson a': 'onClickRenderjsonLink'
      };
    }
  }, {
    key: 'onClickBackToSummary',
    value: function onClickBackToSummary() {
      this.trigger('clickBackToSummary');
    }
  }, {
    key: 'onClickRenderjsonLink',
    value: function onClickRenderjsonLink() {
      return false;
    }
  }, {
    key: 'renderStatus',
    value: function renderStatus() {
      var iconBaseClass = 'margRSm flexNoShrink';
      var msg = '';

      if (this.isCase) {
        // Cut a corner with some html embedded here. If the html get more elaborate than this,
        // we should probably break this out into its own template.
        if (this.model.bothContractsValid) {
          var icon = '<span class="' + iconBaseClass + ' tx1 ion-ios-checkmark-outline"></span>';
          var msgText = !this.model.vendorProcessingError ? _app2.default.polyglot.t('orderDetail.contractTab.bothContractsValid') : _app2.default.polyglot.t('orderDetail.contractTab.validBuyerVendorProcessingError');
          var msgHtml = '<span>' + msgText + '</span>';
          msg = '<p class="clrTEm flexVCent">' + icon + msgHtml + '</p>';
        } else if (!this.model.get('vendorContract')) {
          var _icon = '<span class="' + iconBaseClass + ' clrTAlert ion-android-warning"></span>';
          var processingErrorKey = 'orderDetail.contractTab.vendorContractNotArrivedPotentialProcErr';
          var buyerContract = this.model.get('buyerContract');
          var buyerShowsVendorProcErr = buyerContract && Array.isArray(buyerContract.get('errors'));
          var _msgText = !buyerShowsVendorProcErr ? _app2.default.polyglot.t('orderDetail.contractTab.vendorContractNotArrived') : _app2.default.polyglot.t(processingErrorKey);
          var _msgHtml = '<span>' + _msgText + '</span>';
          msg = '<p class="flexVCent">' + _icon + _msgHtml + '</p>';
        } else if (!this.model.get('buyerContract')) {
          msg = '<p class="flexVCent"><span class="' + iconBaseClass + ' clrTAlert ion-android-warning">' + ('</span>' + _app2.default.polyglot.t('orderDetail.contractTab.buyerContractNotArrived') + '</p>');
        }
      }

      this.getCachedEl('.js-statusContainer').html(msg);
    }
  }, {
    key: 'renderContract',
    value: function renderContract(contract) {
      if (!contract) {
        throw new Error('Please provide a contract.');
      }

      var isBuyerContract = contract === this.model.get('rawBuyerContract');
      var heading = '';

      if (!this.model.bothContractsValid) {
        heading = isBuyerContract ? _app2.default.polyglot.t('orderDetail.contractTab.contractHeadingBuyer') : _app2.default.polyglot.t('orderDetail.contractTab.contractHeadingVendor');
      }

      var view = this[(isBuyerContract ? 'buyer' : 'vendor') + 'ContractVw'] = this.createChild(_Contract2.default, {
        contract: contract,
        initialState: {
          heading: heading,
          errors: isBuyerContract ? this.model.get('buyerContractValidationErrors') || [] : this.model.get('vendorContractValidationErrors') || []
        }
      });

      this.$el.append(view.render().el);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/orderDetail/contractTab/contractTab.html', function (t) {
        _this2.$el.html(t());
        _this2.renderStatus();

        if (!_this2.isCase) {
          _this2.contractVw = _this2.createChild(_Contract2.default, {
            contract: _this2.model.get('rawContract')
          });
          _this2.$el.append(_this2.contractVw.render().el);
        } else {
          var contracts = [_this2.model.get('buyerOpened') ? _this2.model.get('rawBuyerContract') : _this2.model.get('rawVendorContract')];

          if (!_this2.model.bothContractsValid) {
            // If the second contract has arrived, we'll show them individually since one or
            // both have validation errors.
            if (_this2.model.get('buyerOpened')) {
              if (_this2.model.get('vendorContract')) {
                contracts.push(_this2.model.get('rawVendorContract'));
              }
            } else if (_this2.model.get('buyerContract')) {
              contracts.push(_this2.model.get('rawBuyerContract'));
            }
          }

          contracts.forEach(function (contract) {
            return _this2.renderContract(contract);
          });
        }
      });

      return this;
    }
  }, {
    key: 'isCase',
    get: function get() {
      return this.model.get('buyerOpened') !== undefined;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;