'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _electron = require('electron');

require('../../../../utils/lib/velocity');

var _app = require('../../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!options.dataObject) {
      throw new Error('Please provide a vendorOrderFulfillment data object.');
    }

    _this._state = _extends({
      contractType: 'PHYSICAL_GOOD',
      isLocalPickup: false,
      showPassword: false,
      noteFromLabel: _app2.default.polyglot.t('orderDetail.summaryTab.fulfilled.noteFromVendorLabel'),
      coinType: ''
    }, options.initialState || {});

    _this.dataObject = options.dataObject;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'fulfilledEvent rowLg';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-copyText': 'onClickCopyText'
      };
    }
  }, {
    key: 'onClickCopyText',
    value: function onClickCopyText(e) {
      var _this2 = this;

      var $target = (0, _jquery2.default)(e.target);
      _electron.clipboard.writeText($target.attr('data-content'));
      this.getCachedEl($target.attr('data-status-indicator')).velocity('stop').velocity('fadeIn', {
        complete: function complete() {
          _this2.getCachedEl($target.attr('data-status-indicator')).velocity('fadeOut', { delay: 1000 });
        }
      });
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var renderOnChange = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (renderOnChange && !_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/orderDetail/summaryTab/fulfilled.html', function (t) {
        _this3.$el.html(t(_extends({}, _this3._state, _this3.dataObject || {}, {
          moment: _moment2.default
        })));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;