'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _RatingsStrip = require('../../../RatingsStrip');

var _RatingsStrip2 = _interopRequireDefault(_RatingsStrip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!options.dataObject) {
      throw new Error('Please provide a buyerOrderCompletion data object.');
    }

    _this.dataObject = options.dataObject;
    _this.ratingStrips = {};
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'orderCompleteEvent rowLg';
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var renderOnChange = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (renderOnChange && !_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var rating = this.dataObject.ratings[0].ratingData;
      (0, _loadTemplate2.default)('modals/orderDetail/summaryTab/orderComplete.html', function (t) {
        _this2.$el.html(t(_extends({}, rating, _this2._state, {
          timestamp: _this2.dataObject.timestamp,
          moment: _moment2.default
        })));

        _this2.$('.ratingsContainer').each(function (index, element) {
          var $el = (0, _jquery2.default)(element);
          var type = $el.data('ratingType');

          if (!type) {
            throw new Error('Unable to render the ratings strips because it\'s container does not ' + 'specify a type.');
          }

          if (_this2.ratingStrips[type]) _this2.ratingStrips[type].remove();
          _this2.ratingStrips[type] = _this2.createChild(_RatingsStrip2.default, {
            initialState: {
              curRating: rating[type] || 0
            }
          });

          $el.append(_this2.ratingStrips[type].render().el);
        });
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;