'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _currency = require('../../../utils/currency');

var _cryptoCurrencies = require('../../../data/cryptoCurrencies');

var _serverConnect = require('../../../utils/serverConnect');

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _SpendConfirmBox = require('../wallet/SpendConfirmBox');

var _SpendConfirmBox2 = _interopRequireDefault(_SpendConfirmBox);

var _qrEncode = require('qr-encode');

var _qrEncode2 = _interopRequireDefault(_qrEncode);

var _electron = require('electron');

var _Spend = require('../../../models/wallet/Spend');

var _SimpleMessage = require('../../modals/SimpleMessage');

var _modalManager = require('../../../utils/modalManager');

var _metrics = require('../../../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 This view is also used by the Order Detail overlay. If you make any changes, please
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 ensure they are compatible with both the Purchase and Order Detail flows.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (typeof options.balanceRemaining !== 'number') {
      throw new Error('Please provide the balance remaining (in the server\'s' + ' currency) as a number.');
    }

    if (!options.paymentAddress) {
      throw new Error('Please provide the payment address.');
    }

    if (!options.orderId) {
      throw new Error('Please provide an orderId.');
    }

    if (typeof options.isModerated !== 'boolean') {
      throw new Error('Please provide a boolean indicating whether the order is moderated.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    _this._balanceRemaining = options.balanceRemaining;
    _this.paymentAddress = options.paymentAddress;
    _this.orderId = options.orderId;
    _this.isModerated = options.isModerated;

    var serverSocket = (0, _serverConnect.getSocket)();
    if (serverSocket) {
      _this.listenTo(serverSocket, 'message', function (e) {
        // listen for a payment socket message, to react to payments from all sources
        if (e.jsonData.notification && e.jsonData.notification.type === 'payment') {
          if (e.jsonData.notification.orderId === _this.orderId) {
            var amount = (0, _currency.integerToDecimal)(e.jsonData.notification.fundingTotal, _app2.default.serverConfig.cryptoCurrency);
            if (amount >= _this.balanceRemaining) {
              _this.getCachedEl('.js-payFromWallet').removeClass('processing');
              _this.trigger('walletPaymentComplete', e.jsonData.notification);
            } else {
              // Ensure the resulting balance has a maximum of 8 decimal places without any
              // trailing zeros.
              _this.balanceRemaining = parseFloat((_this.balanceRemaining - amount).toFixed(8));
            }
          }
        }
      });
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'pending';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-payFromWallet': 'clickPayFromWallet',
        'click .js-payFromAlt': 'clickPayFromAlt',
        'click .js-amountRow': 'copyAmount',
        'click .js-addressRow': 'copyAddress',
        'click .js-fundWallet': 'clickFundWallet'
      };
    }
  }, {
    key: 'clickPayFromWallet',
    value: function clickPayFromWallet(e) {
      var insufficientFunds = this.balanceRemaining > _app2.default.walletBalance.get('confirmed');

      if (insufficientFunds) {
        this.spendConfirmBox.setState({
          show: true,
          fetchFailed: true,
          fetchError: 'ERROR_INSUFFICIENT_FUNDS'
        });
        (0, _metrics.recordEvent)('Purchase_PayFromWallet', {
          currency: (0, _cryptoCurrencies.getServerCurrency)().code,
          sufficientFunds: false
        });
      } else {
        (0, _metrics.recordEvent)('Purchase_PayFromWallet', {
          currency: (0, _cryptoCurrencies.getServerCurrency)().code,
          sufficientFunds: true
        });
        this.spendConfirmBox.setState({ show: true });
        this.spendConfirmBox.fetchFeeEstimate(this.balanceRemaining);
      }

      e.stopPropagation();
    }
  }, {
    key: 'showSpendError',
    value: function showSpendError() {
      var error = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('purchase.errors.paymentFailed'), error);
    }
  }, {
    key: 'walletConfirm',
    value: function walletConfirm() {
      var _this2 = this;

      this.getCachedEl('.js-payFromWallet').addClass('processing');
      this.spendConfirmBox.setState({ show: false });
      var currency = (0, _cryptoCurrencies.getServerCurrency)().code;

      try {
        (0, _Spend.spend)({
          address: this.paymentAddress,
          amount: this.balanceRemaining,
          currency: currency
        }).done(function () {
          (0, _metrics.recordEvent)('Purchase_SpendFromWallet', {
            currency: currency,
            errors: 'none'
          });
        }).fail(function (jqXhr) {
          var err = jqXhr.responseJSON && jqXhr.responseJSON.reason || '';
          _this2.showSpendError(err);
          (0, _metrics.recordEvent)('Purchase_SpendFromWallet', {
            currency: currency,
            errors: err || 'unknown error'
          });
          if (_this2.isRemoved()) return;
          _this2.getCachedEl('.js-payFromWallet').removeClass('processing');
        });
      } catch (e) {
        // This is almost certainly a dev error if this happens, but it prevents the purchase and
        // is confusing and at least to make debugging easier, we'll display an error modal.
        this.showSpendError(e.message || '');
        this.getCachedEl('.js-payFromWallet').removeClass('processing');
      }
    }
  }, {
    key: 'clickPayFromAlt',
    value: function clickPayFromAlt() {
      var amount = this.balanceRemaining;
      var serverCur = (0, _cryptoCurrencies.getServerCurrency)().code;
      var shapeshiftURL = 'https://shapeshift.io/shifty.html?destination=' + this.paymentAddress + '&output=' + serverCur + '&apiKey=6e9fbc30b836f85d339b84f3b60cade3f946d2d49a14207d5546895ecca60233b47ec67304cdcfa06e019231a9d135a7965ae50de0a1e68d6ec01b8e57f2b812&amount=' + amount;
      var shapeshiftWin = new _electron.remote.BrowserWindow({ width: 700, height: 500, frame: true });
      shapeshiftWin.loadURL(shapeshiftURL);
    }
  }, {
    key: 'copyAmount',
    value: function copyAmount() {
      var _this3 = this;

      _electron.clipboard.writeText(String(this.balanceRemaining));

      this.getCachedEl('.js-copyAmount').addClass('active');
      if (this.hideCopyAmountTimer) {
        clearTimeout(this.hideCopyAmountTimer);
      }
      this.hideCopyAmountTimer = setTimeout(function () {
        return _this3.getCachedEl('.js-copyAmount').removeClass('active');
      }, 3000);
    }
  }, {
    key: 'copyAddress',
    value: function copyAddress() {
      var _this4 = this;

      _electron.clipboard.writeText(String(this.paymentAddress));

      this.getCachedEl('.js-copyAddress').addClass('active');
      if (this.hideCopyAddressTimer) {
        clearTimeout(this.hideCopyAddressTimer);
      }
      this.hideCopyAddressTimer = setTimeout(function () {
        return _this4.getCachedEl('.js-copyAddress').removeClass('active');
      }, 3000);
    }
  }, {
    key: 'clickFundWallet',
    value: function clickFundWallet() {
      (0, _modalManager.launchWallet)().sendModeOn = false;
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.hideCopyAmountTimer) {
        clearTimeout(this.hideCopyAmountTimer);
      }
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      var displayCurrency = _app2.default.settings.get('localCurrency');

      (0, _loadTemplate2.default)('modals/purchase/payment.html', function (t) {
        (0, _loadTemplate2.default)('walletIcon.svg', function (walletIconTmpl) {
          _this5.$el.html(t({
            displayCurrency: displayCurrency,
            amountDueLine: _this5.amountDueLine,
            paymentAddress: _this5.paymentAddress,
            qrDataUri: _this5.qrDataUri,
            walletIconTmpl: walletIconTmpl,
            isModerated: _this5.isModerated
          }));
        });

        _this5.spendConfirmBox = _this5.createChild(_SpendConfirmBox2.default, {
          initialState: {
            btnSendText: _app2.default.polyglot.t('purchase.pendingSection.btnConfirmedPay')
          }
        });
        _this5.listenTo(_this5.spendConfirmBox, 'clickSend', _this5.walletConfirm);
        _this5.getCachedEl('.js-confirmWalletContainer').html(_this5.spendConfirmBox.render().el);
      });

      return this;
    }
  }, {
    key: 'balanceRemaining',
    set: function set(amount) {
      if (amount !== this._balanceRemaining) {
        this._balanceRemaining = amount;
        this.getCachedEl('.js-amountDueLine').html(this.amountDueLine);
        this.getCachedEl('.js-qrCodeImg').attr('src', this.qrDataUri);
      }
    },
    get: function get() {
      return this._balanceRemaining;
    }
  }, {
    key: 'amountDueLine',
    get: function get() {
      return _app2.default.polyglot.t('purchase.pendingSection.pay', { amountBTC: (0, _currency.formatCurrency)(this.balanceRemaining, (0, _cryptoCurrencies.getServerCurrency)().code) });
    }
  }, {
    key: 'qrDataUri',
    get: function get() {
      var address = (0, _cryptoCurrencies.getServerCurrency)().qrCodeText(this.paymentAddress);
      var URL = address + '?amount=' + this.balanceRemaining;
      return (0, _qrEncode2.default)(URL, { type: 8, size: 5, level: 'Q' });
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;