'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

require('../../../lib/select2');

require('../../../utils/lib/velocity');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _modalManager = require('../../../utils/modalManager');

var _inventory = require('../../../utils/inventory');

var _number = require('../../../utils/number');

var _SimpleMessage = require('../SimpleMessage');

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _Order = require('../../../models/purchase/Order');

var _Order2 = _interopRequireDefault(_Order);

var _Item = require('../../../models/purchase/Item');

var _Item2 = _interopRequireDefault(_Item);

var _Listing = require('../../../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _Purchase = require('../../../models/purchase/Purchase');

var _Purchase2 = _interopRequireDefault(_Purchase);

var _PopInMessage = require('../../components/PopInMessage');

var _PopInMessage2 = _interopRequireDefault(_PopInMessage);

var _Moderators = require('../../components/Moderators');

var _Moderators2 = _interopRequireDefault(_Moderators);

var _Shipping = require('./Shipping');

var _Shipping2 = _interopRequireDefault(_Shipping);

var _Receipt = require('./Receipt');

var _Receipt2 = _interopRequireDefault(_Receipt);

var _Coupons = require('./Coupons');

var _Coupons2 = _interopRequireDefault(_Coupons);

var _ActionBtn = require('./ActionBtn');

var _ActionBtn2 = _interopRequireDefault(_ActionBtn);

var _Payment = require('./Payment');

var _Payment2 = _interopRequireDefault(_Payment);

var _Complete = require('./Complete');

var _Complete2 = _interopRequireDefault(_Complete);

var _FeeChange = require('../../components/FeeChange');

var _FeeChange2 = _interopRequireDefault(_FeeChange);

var _QuantityDisplay = require('../../components/QuantityDisplay');

var _QuantityDisplay2 = _interopRequireDefault(_QuantityDisplay);

var _metrics = require('../../../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.listing || !(options.listing instanceof _Listing2.default)) {
      throw new Error('Please provide a listing model');
    }

    if (!options.vendor) {
      throw new Error('Please provide a vendor object');
    }

    var opts = _extends({}, options, {
      initialState: _extends({
        phase: 'pay'
      }, options.initialState || {})
    });

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.listing = opts.listing;
    _this.variants = opts.variants;
    _this.vendor = opts.vendor;
    var shippingOptions = _this.listing.get('shippingOptions');
    var shippable = !!(shippingOptions && shippingOptions.length);

    var moderatorIDs = _this.listing.get('moderators') || [];
    var disallowedIDs = [_app2.default.profile.id, _this.listing.get('vendorID').peerID];
    _this.moderatorIDs = _underscore2.default.without.apply(_underscore2.default, [moderatorIDs].concat(disallowedIDs));
    _this.setState({
      showModerators: _this.moderatorIDs.length,
      showOnlyVerified: true
    }, { renderOnChange: false });

    _this.couponObj = [];

    _this.order = new _Order2.default({}, {
      shippable: shippable,
      moderated: _this.moderatorIDs.length && _app2.default.verifiedMods.matched(_this.moderatorIDs).length
    });

    /* to support multiple items in a purchase in the future, pass in listings in the options,
       and add them to the order as items here.
    */
    var item = new _Item2.default({
      listingHash: _this.listing.get('hash'),
      quantity: !_this.listing.isCrypto ? 1 : undefined,
      options: options.variants || []
    }, {
      isCrypto: _this.listing.isCrypto,
      inventory: function inventory() {
        return typeof _this.inventory === 'number' ? _this.inventory : 99999999999999999;
      }
    });
    // add the item to the order.
    _this.order.get('items').add(item);

    // create an empty purchase model
    _this.purchase = new _Purchase2.default();

    _this.actionBtn = _this.createChild(_ActionBtn2.default, {
      listing: _this.listing
    });
    _this.listenTo(_this.actionBtn, 'purchase', function () {
      return _this.purchaseListing();
    });
    _this.listenTo(_this.actionBtn, 'close', function () {
      return _this.close();
    });

    _this.receipt = _this.createChild(_Receipt2.default, {
      model: _this.order,
      listing: _this.listing,
      prices: _this.prices,
      couponObj: _this.couponObj
    });

    _this.coupons = _this.createChild(_Coupons2.default, {
      coupons: _this.listing.get('coupons'),
      listingPrice: _this.listing.price.amount
    });
    _this.listenTo(_this.coupons, 'changeCoupons', function (hashes, codes) {
      return _this.changeCoupons(hashes, codes);
    });

    _this.moderators = _this.createChild(_Moderators2.default, {
      moderatorIDs: _this.moderatorIDs,
      useCache: false,
      showVerifiedOnly: true,
      fetchErrorTitle: _app2.default.polyglot.t('purchase.errors.moderatorsTitle'),
      fetchErrorMsg: _app2.default.polyglot.t('purchase.errors.moderatorsMsg'),
      purchase: true,
      cardState: 'unselected',
      notSelected: 'unselected',
      singleSelect: true,
      selectFirst: true,
      radioStyle: true
    });
    // render the moderators so it can start fetching and adding moderator cards
    _this.moderators.render();
    _this.moderators.getModeratorsByID();
    _this.listenTo(_this.moderators, 'noValidModerators', function () {
      return _this.onNoValidModerators();
    });
    _this.listenTo(_this.moderators, 'clickShowUnverified', function () {
      return _this.togVerifiedModerators(false);
    });
    _this.listenTo(_this.moderators, 'cardSelect', function () {
      return _this.onCardSelect();
    });

    if (_this.listing.get('shippingOptions').length) {
      _this.shipping = _this.createChild(_Shipping2.default, {
        model: _this.listing
      });
      _this.listenTo(_this.shipping, 'shippingOptionSelected', function (sOpts) {
        _this.updateShippingOption(sOpts);
      });
    }

    _this.complete = _this.createChild(_Complete2.default, {
      listing: _this.listing,
      vendor: _this.vendor
    });

    // If the parent has the inventory, pass it in, otherwise we'll fetch it.
    _this.inventory = _this.options.inventory;
    if (_this.listing.isCrypto && typeof _this.inventory !== 'number') {
      _this.inventoryFetch = (0, _inventory.getInventory)(_this.listing.get('vendorID').peerID, {
        slug: _this.listing.get('slug'),
        coinDivisibility: _this.listing.get('metadata').get('coinDivisibility')
      }).done(function (e) {
        return _this.inventory = e.inventory;
      });
      _this.listenTo(_inventory.events, 'inventory-change', function (e) {
        return _this.inventory = e.inventory;
      });
    }

    _this.listenTo(_app2.default.settings, 'change:localCurrency', function () {
      return _this.showDataChangedMessage();
    });
    _this.listenTo(_app2.default.localSettings, 'change:bitcoinUnit', function () {
      return _this.showDataChangedMessage();
    });
    _this.listenTo(_this.order.get('items').at(0), 'someChange ', function () {
      return _this.refreshPrices();
    });
    _this.listenTo(_this.order.get('items').at(0).get('shipping'), 'change', function () {
      return _this.refreshPrices();
    });

    _this.hasVerifiedMods = _app2.default.verifiedMods.matched(_this.moderatorIDs).length > 0;

    _this.listenTo(_app2.default.verifiedMods, 'update', function () {
      var newHasVerifiedMods = _app2.default.verifiedMods.matched(moderatorIDs).length > 0;
      if (newHasVerifiedMods !== _this.hasVerifiedMods) {
        _this.hasVerifiedMods = newHasVerifiedMods;
        _this.showDataChangedMessage();
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' purchase modalScrollPage';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-goToListing': 'clickGoToListing',
        'click .js-close': 'clickClose',
        'click .js-retryFee': 'clickRetryFee',
        'click .js-directPayment': 'clickDirectPurchase',
        'change #purchaseQuantity': 'changeQuantityInput',
        'change #purchaseCryptoAddress': 'changeCryptoAddress',
        'click .js-newAddress': 'clickNewAddress',
        'click .js-applyCoupon': 'applyCoupon',
        'keyup #couponCode': 'onKeyUpCouponCode',
        'blur #emailAddress': 'blurEmailAddress',
        'blur #memo': 'blurMemo',
        'click .js-purchaseVerifiedOnly': 'onClickVerifiedOnly'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'showDataChangedMessage',
    value: function showDataChangedMessage() {
      var _this2 = this;

      if (this.dataChangePopIn && !this.dataChangePopIn.isRemoved()) {
        this.dataChangePopIn.$el.velocity('callout.shake', { duration: 500 });
      } else {
        this.dataChangePopIn = this.createChild(_PopInMessage2.default, {
          messageText: (0, _PopInMessage.buildRefreshAlertMessage)(_app2.default.polyglot.t('purchase.purchaseDataChangedPopin'))
        });

        this.listenTo(this.dataChangePopIn, 'clickRefresh', function () {
          _this2.render();
          _this2.moderators.render();
        });

        this.listenTo(this.dataChangePopIn, 'clickDismiss', function () {
          _this2.dataChangePopIn.remove();
          _this2.dataChangePopIn = null;
        });

        this.getCachedEl('.js-popInMessages').append(this.dataChangePopIn.render().el);
      }
    }
  }, {
    key: 'goToListing',
    value: function goToListing() {
      _app2.default.router.navigate(this.vendor.peerID + '/store/' + this.listing.get('slug'), { trigger: true });
      this.close();
    }
  }, {
    key: 'clickGoToListing',
    value: function clickGoToListing() {
      this.goToListing();
    }
  }, {
    key: 'clickClose',
    value: function clickClose() {
      this.trigger('closeBtnPressed');
      this.close();
    }
  }, {
    key: 'clickDirectPurchase',
    value: function clickDirectPurchase() {
      if (!this.order.moderated) return;

      this.order.moderated = false;
      this.moderators.deselectOthers();
      this.render();
    }
  }, {
    key: 'onNoValidModerators',
    value: function onNoValidModerators() {
      this.order.moderated = false;
      this.render();
    }
  }, {
    key: 'togVerifiedModerators',
    value: function togVerifiedModerators(bool) {
      this.moderators.togVerifiedShown(bool);
      this.setState({ showOnlyVerified: bool });
    }
  }, {
    key: 'onClickVerifiedOnly',
    value: function onClickVerifiedOnly(e) {
      this.togVerifiedModerators((0, _jquery2.default)(e.target).prop('checked'));
    }
  }, {
    key: 'onCardSelect',
    value: function onCardSelect() {
      this.order.moderated = true;
      var selected = this.moderators.selectedIDs;
      var unverifedSelected = selected.length && !_app2.default.verifiedMods.matched(selected).length;
      this.setState({ unverifedSelected: unverifedSelected }, { renderOnChange: false });
      this.render(); // always render even if the state didn't change
    }
  }, {
    key: 'changeQuantityInput',
    value: function changeQuantityInput(e) {
      this.order.get('items').at(0).set(this.getFormData((0, _jquery2.default)(e.target)));
    }
  }, {
    key: 'changeCryptoAddress',
    value: function changeCryptoAddress(e) {
      this.order.get('items').at(0).set('paymentAddress', e.target.value);
    }
  }, {
    key: 'clickNewAddress',
    value: function clickNewAddress() {
      (0, _modalManager.launchSettingsModal)({ initialTab: 'Addresses' });
    }
  }, {
    key: 'applyCoupon',
    value: function applyCoupon() {
      var _this3 = this;

      var code = this.coupons.addCode(this.$couponField.val());
      code.then(function (result) {
        // if the result is valid, clear the input field
        if (result.type === 'valid') {
          _this3.$couponField.val('');
        }
      });
    }
  }, {
    key: 'onKeyUpCouponCode',
    value: function onKeyUpCouponCode(e) {
      if (e.which === 13) {
        this.applyCoupon();
      }
    }
  }, {
    key: 'blurEmailAddress',
    value: function blurEmailAddress(e) {
      this.order.set('alternateContactInfo', (0, _jquery2.default)(e.target).val());
    }
  }, {
    key: 'blurMemo',
    value: function blurMemo(e) {
      this.order.get('items').at(0).set('memo', (0, _jquery2.default)(e.target).val());
    }
  }, {
    key: 'changeCoupons',
    value: function changeCoupons(hashes, codes) {
      // combine the codes and hashes so the receipt can check both.
      // if this is the user's own listing they will have codes instead of hashes
      var hashesAndCodes = hashes.concat(codes);
      var filteredCoupons = this.listing.get('coupons').filter(function (coupon) {
        return hashesAndCodes.indexOf(coupon.get('hash') || coupon.get('discountCode')) !== -1;
      });
      this.couponObj = filteredCoupons.map(function (coupon) {
        return coupon.toJSON();
      });
      this.receipt.coupons = this.couponObj;
      this.order.get('items').at(0).set('coupons', codes);
    }
  }, {
    key: 'updateShippingOption',
    value: function updateShippingOption(opts) {
      // set the shipping option
      this.order.get('items').at(0).get('shipping').set(opts);
    }
  }, {
    key: 'purchaseListing',
    value: function purchaseListing() {
      var _this4 = this;

      // clear any old errors
      var allErrContainers = this.$('div[class $="-errors"]');
      allErrContainers.each(function (i, container) {
        return (0, _jquery2.default)(container).html('');
      });

      // don't allow a zero or negative price purchase
      var priceObj = this.prices[0];
      if (priceObj.price + priceObj.vPrice + priceObj.sPrice <= 0) {
        this.insertErrors(this.getCachedEl('.js-errors'), [_app2.default.polyglot.t('purchase.errors.zeroPrice')]);
        this.setState({ phase: 'pay' });
        return;
      }

      // set the shipping address if the listing is shippable
      if (this.shipping && this.shipping.selectedAddress) {
        this.order.addAddress(this.shipping.selectedAddress);
      }

      // set the moderator
      var moderator = this.order.moderated ? this.moderators.selectedIDs[0] : '';
      this.order.set({ moderator: moderator });
      this.order.set({}, { validate: true });

      // cancel any existing order
      if (this.orderSubmit) this.orderSubmit.abort();

      this.setState({ phase: 'processing' });

      (0, _metrics.startEvent)('Purchase');

      if (!this.order.validationError) {
        if (this.listing.isOwnListing) {
          this.setState({ phase: 'pay' });
          // don't allow a seller to buy their own items
          var errTitle = _app2.default.polyglot.t('purchase.errors.ownIDTitle');
          var errMsg = _app2.default.polyglot.t('purchase.errors.ownIDMsg');
          (0, _SimpleMessage.openSimpleMessage)(errTitle, errMsg);
          (0, _metrics.endEvent)('Purchase', {
            errors: 'own listing'
          });
        } else {
          var coinDivisibility = this.listing.get('metadata').get('coinDivisibility');

          _jquery2.default.post({
            url: _app2.default.getServerUrl('ob/purchase'),
            data: JSON.stringify(_extends({}, this.order.toJSON(), {
              items: this.order.get('items').map(function (item) {
                return _extends({}, item.toJSON(), {
                  quantity: _this4.listing.isCrypto ?
                  // round to ensure integer
                  Math.round(item.get('quantity') * coinDivisibility) : item.get('quantity')
                });
              })
            })),
            dataType: 'json',
            contentType: 'application/json'
          }).done(function (data) {
            _this4.setState({ phase: 'pending' });
            _this4.purchase.set(_this4.purchase.parse(data));
            _this4.payment = _this4.createChild(_Payment2.default, {
              balanceRemaining: _this4.purchase.get('amount'),
              paymentAddress: _this4.purchase.get('paymentAddress'),
              orderId: _this4.purchase.get('orderId'),
              isModerated: !!_this4.order.get('moderator')
            });
            _this4.listenTo(_this4.payment, 'walletPaymentComplete', function (pmtCompleteData) {
              return _this4.completePurchase(pmtCompleteData);
            });
            _this4.$('.js-pending').append(_this4.payment.render().el);
            (0, _metrics.endEvent)('Purchase', {
              errors: 'none'
            });
          }).fail(function (jqXHR) {
            _this4.setState({ phase: 'pay' });
            if (jqXHR.statusText === 'abort') return;
            var errTitle = _app2.default.polyglot.t('purchase.errors.orderError');
            var errMsg = jqXHR.responseJSON && jqXHR.responseJSON.reason || '';

            if (jqXHR.responseJSON && jqXHR.responseJSON.code === 'ERR_INSUFFICIENT_INVENTORY' && typeof jqXHR.responseJSON.remainingInventory === 'number') {
              _this4.inventory = jqXHR.responseJSON.remainingInventory / _this4.listing.get('metadata').get('coinDivisibility');
              errTitle = _app2.default.polyglot.t('purchase.errors.insufficientInventoryTitle');
              errMsg = _app2.default.polyglot.t('purchase.errors.insufficientInventoryBody', {
                smart_count: _this4.inventory,
                remainingInventory: new Intl.NumberFormat(_app2.default.settings.get('localCurrency'), {
                  minimumFractionDigits: 0,
                  maximumFractionDigits: 8
                }).format(_this4.inventory)
              });
              if (_this4.inventoryFetch) _this4.inventoryFetch.abort();
            }

            (0, _SimpleMessage.openSimpleMessage)(errTitle, errMsg);
            (0, _metrics.endEvent)('Purchase', {
              errors: errMsg || 'unknown error'
            });
          });
        }
      } else {
        this.setState({ phase: 'pay' });
        var purchaseErrs = [];
        Object.keys(this.order.validationError).forEach(function (errKey) {
          var domKey = errKey.replace(/\[[^\[\]]*\]/g, '').replace('.', '-');
          purchaseErrs.push(domKey);
          var container = _this4.$('.js-' + domKey + '-errors');
          // if no container exists, use the generic container
          container = container.length ? container : _this4.getCachedEl('.js-errors');
          _this4.insertErrors(container, _this4.order.validationError[errKey]);
        });
        (0, _metrics.endEvent)('Purchase', {
          errors: 'Client errors ' + purchaseErrs.join()
        });
      }
    }
  }, {
    key: 'insertErrors',
    value: function insertErrors(container) {
      var errors = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      (0, _loadTemplate2.default)('formError.html', function (t) {
        container.html(t({
          errors: errors
        }));
      });
    }
  }, {
    key: 'completePurchase',
    value: function completePurchase(data) {
      this.complete.orderID = data.orderId;
      this.complete.render();
      this.setState({ phase: 'complete' });
    }
  }, {
    key: 'refreshPrices',
    value: function refreshPrices() {
      this.receipt.updatePrices(this.prices);
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.orderSubmit) this.orderSubmit.abort();
      if (this.inventoryFetch) this.inventoryFetch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      if (this.dataChangePopIn) this.dataChangePopIn.remove();
      var state = this.getState();
      var item = this.order.get('items').at(0);
      var quantity = item.get('quantity');

      (0, _loadTemplate2.default)('modals/purchase/purchase.html', function (t) {
        _this5.$el.html(t(_extends({}, _this5.order.toJSON(), state, {
          listing: _this5.listing.toJSON(),
          listingPrice: _this5.listing.price,
          itemConstraints: _this5.order.get('items').at(0).constraints,
          vendor: _this5.vendor,
          variants: _this5.variants,
          prices: _this5.prices,
          displayCurrency: _app2.default.settings.get('localCurrency'),
          moderated: _this5.order.moderated,
          quantity: _this5.listing.isCrypto && typeof quantity === 'number' ? (0, _number.toStandardNotation)(quantity) : quantity
        })));

        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this5).call(_this5);

        _this5._$couponField = null;

        _this5.actionBtn.delegateEvents();
        _this5.actionBtn.setState({ phase: state.phase });
        _this5.$('.js-actionBtn').append(_this5.actionBtn.render().el);

        _this5.receipt.delegateEvents();
        _this5.$('.js-receipt').append(_this5.receipt.render().el);

        _this5.coupons.delegateEvents();
        _this5.$('.js-couponsWrapper').html(_this5.coupons.render().el);

        _this5.moderators.delegateEvents();
        _this5.$('.js-moderatorsWrapper').append(_this5.moderators.el);

        if (_this5.shipping) {
          _this5.shipping.delegateEvents();
          _this5.$('.js-shippingWrapper').append(_this5.shipping.render().el);
        }

        // if this is a re-render, and the payment exists, render it
        if (_this5.payment) {
          _this5.payment.delegateEvents();
          _this5.$('.js-pending').append(_this5.payment.render().el);
        }

        _this5.complete.delegateEvents();
        _this5.$('.js-complete').append(_this5.complete.render().el);

        if (_this5.feeChange) _this5.feeChange.remove();
        _this5.feeChange = _this5.createChild(_FeeChange2.default);
        _this5.$('.js-feeChangeContainer').html(_this5.feeChange.render().el);

        if (_this5.listing.isCrypto) {
          var cryptoInventoryState = {};

          if (_this5.cryptoInventory) {
            cryptoInventoryState = _this5.cryptoInventory.getState();
            _this5.cryptoInventory.remove();
          }

          _this5.cryptoInventory = _this5.createChild(_QuantityDisplay2.default, {
            peerId: _this5.listing.get('vendorID').peerID,
            slug: _this5.listing.get('slug'),
            initialState: _extends({
              amount: _this5.inventory,
              contentClass: 'clrT2',
              coinDivisibility: _this5.listing.get('metadata').get('coinDivisibility')
            }, cryptoInventoryState)
          });

          _this5.getCachedEl('.js-cryptoInventory').html(_this5.cryptoInventory.render().el);
        }
      });

      return this;
    }
  }, {
    key: 'inventory',
    get: function get() {
      return this._inventory;
    },
    set: function set(inventory) {
      if (inventory !== this._inventory) {
        this._inventory = inventory;

        if (this.cryptoInventory) {
          this.cryptoInventory.setState({
            amount: inventory
          });
        }
      }
    }
  }, {
    key: 'prices',
    get: function get() {
      var _this6 = this;

      // return an array of price objects that matches the items in the order
      return this.order.get('items').map(function (item) {
        var shipping = item.get('shipping');
        var sName = shipping.get('name');
        var sService = shipping.get('service');
        var sOpt = _this6.listing.get('shippingOptions').findWhere({ name: sName });
        var sOptService = sOpt ? sOpt.get('services').findWhere({ name: sService }) : '';

        // determine which skus match the chosen options
        var variantCombo = [];
        item.get('options').forEach(function (option, i) {
          var variants = _this6.listing.get('item').get('options').at(i).get('variants').toJSON();
          var variantIndex = variants.findIndex(function (variant) {
            return variant.name === option.get('value');
          });
          variantCombo.push(variantIndex);
        });
        var sku = _this6.listing.get('item').get('skus').find(function (v) {
          return _underscore2.default.isEqual(v.get('variantCombo'), variantCombo);
        });

        return {
          price: _this6.listing.price.amount,
          sPrice: sOptService ? sOptService.get('price') : 0,
          aPrice: sOptService ? sOptService.get('additionalItemPrice') : 0,
          vPrice: sku ? sku.get('surcharge') : 0,
          quantity: item.get('quantity')
        };
      });
    }
  }, {
    key: 'total',
    get: function get() {
      var _this7 = this;

      var prices = this.prices;
      var priceTotal = 0;
      prices.forEach(function (priceObj) {
        var itemPrice = priceObj.price + priceObj.vPrice;
        _this7.couponObj.forEach(function (coupon) {
          if (coupon.percentDiscount) {
            itemPrice -= itemPrice * 0.01 * coupon.percentDiscount;
          } else if (coupon.priceDiscount) {
            itemPrice -= coupon.priceDiscount;
          }
        });
        priceTotal = itemPrice * priceObj.quantity;
        priceTotal += priceObj.sPrice + priceObj.aPrice * (priceObj.quantity - 1);
      });

      return priceTotal;
    }
  }, {
    key: '$couponField',
    get: function get() {
      return this._$couponField || (this._$couponField = this.$('#couponCode'));
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;