'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../../../lib/select2');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _Listing = require('../../../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _ShippingOptions = require('./ShippingOptions');

var _ShippingOptions2 = _interopRequireDefault(_ShippingOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseView) {
  _inherits(_class, _baseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    if (!_this.model || !(_this.model instanceof _Listing2.default)) {
      throw new Error('Please provide a listing model');
    }
    _this.shippingOptions = _this.createChild(_ShippingOptions2.default, {
      model: _this.model
    });

    _this.listenTo(_this.shippingOptions, 'shippingOptionSelected', function (opts) {
      _this.trigger('shippingOptionSelected', opts);
    });
    _this.listenTo(_app2.default.settings.get('shippingAddresses'), 'update', function (col) {
      // if all the addresses were deleted, update with blank values
      if (!col.models.length) _this.trigger('shippingOptionSelected', { name: '', service: '' });
      _this.render();
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'shipping';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'change #shippingAddress': 'changeShippingAddress'
      };
    }
  }, {
    key: 'changeShippingAddress',
    value: function changeShippingAddress(e) {
      var index = (0, _jquery2.default)(e.target).val();
      this.selectedAddress = _app2.default.settings.get('shippingAddresses').at(index);
      var code = this.selectedAddress.get('country');
      // if an address with the same country is chosen, don't re-render the options
      if (code !== this.countryCode) {
        this.countryCode = code;
        this.shippingOptions.countryCode = code;
        this.shippingOptions.render();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var userAddresses = _app2.default.settings.get('shippingAddresses');

      (0, _loadTemplate2.default)('modals/purchase/shipping.html', function (t) {
        _this2.$el.html(t({
          userAddresses: userAddresses.toJSON()
        }));
      });
      this.$('#shippingAddress').select2({
        // disables the search box
        minimumResultsForSearch: Infinity
      });

      if (userAddresses.length) {
        this.selectedAddress = userAddresses.at(0);
        this.shippingOptions.countryCode = this.selectedAddress.get('country');
        this.shippingOptions.delegateEvents();
        this.$('.js-shippingOptionsWrapper').html(this.shippingOptions.render().el);
      } else {
        this.selectedAddress = null;
      }

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;