'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

require('../../../lib/select2');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _Listing = require('../../../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseView) {
  _inherits(_class, _baseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    _this._countryCode = options.countryCode || '';

    if (!_this.model || !(_this.model instanceof _Listing2.default)) {
      throw new Error('Please provide a listing model');
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'shippingOptions';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-shippingOption': 'changeShippingOption'
      };
    }
  }, {
    key: 'changeShippingOption',
    value: function changeShippingOption(e) {
      var option = (0, _jquery2.default)(e.target);
      var sOpts = {};
      sOpts.name = option.attr('data-name');
      if (option.attr('data-type') !== 'LOCAL_PICKUP') {
        sOpts.service = option.attr('data-service');
      }
      this.trigger('shippingOptionSelected', sOpts);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var validShippingOptions = this.model.get('shippingOptions').toJSON().filter(function (option) {
        return option.regions.indexOf(_this2.countryCode) !== -1 || option.regions.indexOf('ALL') !== -1;
      });

      if (validShippingOptions.length) {
        validShippingOptions.forEach(function (option) {
          if (option.type === 'LOCAL_PICKUP') {
            // local pickup options need a name and price
            option.services[0] = { name: _app2.default.polyglot.t('purchase.localPickup'), price: 0 };
          }
          option.services = _underscore2.default.sortBy(option.services, 'price');
        });

        var sOpts = {};
        sOpts.name = validShippingOptions[0].name;
        if (validShippingOptions[0].type !== 'LOCAL_PICKUP') {
          sOpts.service = validShippingOptions[0].services[0].name;
        }
        this.trigger('shippingOptionSelected', sOpts);
      } else {
        // if no valid option is available, set it to blank
        this.trigger('shippingOptionSelected', { name: '', service: '' });
      }

      (0, _loadTemplate2.default)('modals/purchase/shippingOptions.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.model.toJSON(), {
          validShippingOptions: validShippingOptions,
          displayCurrency: _app2.default.settings.get('localCurrency')
        })));
      });

      return this;
    }
  }, {
    key: 'countryCode',
    get: function get() {
      return this._countryCode;
    },
    set: function set(code) {
      this._countryCode = code;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;