'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _electron = require('electron');

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _cryptoCurrencies = require('../../../data/cryptoCurrencies');

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _qrEncode = require('qr-encode');

var _qrEncode2 = _interopRequireDefault(_qrEncode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this._state = _extends({}, options.initialState || {});
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'receiveMoney';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-receiveAddress': 'onClickReceiveAddress',
        'click .js-receiveQrCode': 'onClickReceiveQrCode',
        'click .js-cancelReceiveBtn': 'onClickCancelReceive',
        'click .js-fundViaShapeshift': 'onClickFundViaShapshift'
      };
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'onClickReceiveAddress',
    value: function onClickReceiveAddress() {
      this.copyAddressToClipboard();
    }
  }, {
    key: 'onClickReceiveQrCode',
    value: function onClickReceiveQrCode() {
      this.copyAddressToClipboard();
    }
  }, {
    key: 'onClickCancelReceive',
    value: function onClickCancelReceive() {
      this.trigger('click-cancel');
    }
  }, {
    key: 'onClickFundViaShapshift',
    value: function onClickFundViaShapshift() {
      var serverCur = (0, _cryptoCurrencies.getServerCurrency)().code;
      var shapeshiftURL = 'https://shapeshift.io/shifty.html?destination=' + this.getState().address + '&output=' + serverCur + '&apiKey=6e9fbc30b836f85d339b84f3b60cade3f946d2d49a14207d5546895ecca60233b47ec67304cdcfa06e019231a9d135a7965ae50de0a1e68d6ec01b8e57f2b812';
      var shapeshiftWin = new _electron.remote.BrowserWindow({ width: 700, height: 500, frame: true });
      shapeshiftWin.loadURL(shapeshiftURL);
    }
  }, {
    key: 'copyAddressToClipboard',
    value: function copyAddressToClipboard() {
      var _this2 = this;

      _electron.clipboard.writeText(this.getState().address);
      clearTimeout(this.copyTextFadeoutTimeout);
      this.$copiedText.stop().fadeIn(600, function () {
        _this2.copyTextFadeoutTimeout = setTimeout(function () {
          _this2.$copiedText.fadeOut(600);
        }, 1000);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/wallet/receiveMoney.html', function (t) {
        // defaulting to an empty image - needed for proper spacing
        // when the spinner is showing
        var qrDataUri = 'data:image/gif;base64,R0lGODlhAQABAAAAACw=';
        var address = _this3.getState().address;

        if (address) {
          qrDataUri = (0, _qrEncode2.default)((0, _cryptoCurrencies.getServerCurrency)().qrCodeText(address), { type: 6, size: 5, level: 'Q' });
        }

        _this3.$el.html(t(_extends({}, _this3._state, {
          qrDataUri: qrDataUri,
          errors: {}
        })));

        _this3._$copiedText = null;
      });

      return this;
    }
  }, {
    key: '$copiedText',
    get: function get() {
      return this._$copiedText || (this._$copiedText = this.$('.js-copiedText'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;