'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

require('../../../lib/select2');

var _currencies = require('../../../data/currencies');

var _cryptoCurrencies = require('../../../data/cryptoCurrencies');

var _currency = require('../../../utils/currency');

var _SimpleMessage = require('../../modals/SimpleMessage');

var _Spend = require('../../../models/wallet/Spend');

var _Spend2 = _interopRequireDefault(_Spend);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _SpendConfirmBox = require('./SpendConfirmBox');

var _SpendConfirmBox2 = _interopRequireDefault(_SpendConfirmBox);

var _FeeChange = require('../../components/FeeChange');

var _FeeChange2 = _interopRequireDefault(_FeeChange);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this._saveInProgress = false;
    _this._sendConfirmOn = false;
    _this.model = new _Spend2.default();
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'sendMoney';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-btnSend': 'onClickSend',
        'click .js-sendMoneyClear': 'onClickClear'
      };
    }
  }, {
    key: 'onClickConfirmSend',
    value: function onClickConfirmSend() {
      var _this2 = this;

      this.sendConfirmBox.setState({ show: false });

      // POSTing payment to the server
      this.saveInProgress = true;

      (0, _Spend.spend)(_extends({}, this.model.toJSON(), {
        feeLevel: _app2.default.localSettings.get('defaultTransactionFee')
      })).fail(function (jqXhr) {
        var reason = jqXhr.responseJSON && jqXhr.responseJSON.reason || '';

        if (reason === 'ERROR_INVALID_ADDRESS') {
          reason = _app2.default.polyglot.t('wallet.sendMoney.errorInvalidAddress');
        }

        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('wallet.sendMoney.sendPaymentFailDialogTitle'), reason);
      }).always(function () {
        _this2.saveInProgress = false;
      }).done(function () {
        return _this2.clearForm();
      });
    }
  }, {
    key: 'onClickSend',
    value: function onClickSend(e) {
      var formData = this.getFormData(this.$formFields);
      this.model.set(formData);
      this.model.set({}, { validate: true });

      // render so errors are shown / cleared
      this.render();

      if (!this.model.validationError) {
        this.sendConfirmBox.setState({ show: true });
        this.fetchFeeEstimate();
      }

      var $firstErr = this.$('.errorList:first');
      if ($firstErr.length) $firstErr[0].scrollIntoViewIfNeeded();

      e.stopPropagation();
    }
  }, {
    key: 'onClickClear',
    value: function onClickClear() {
      this.clearForm();
    }
  }, {
    key: 'focusAddress',
    value: function focusAddress() {
      if (!this.saveInProgress) this.$addressInput.focus();
    }
  }, {
    key: 'setFormData',
    value: function setFormData() {
      var _this3 = this;

      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var focusAddressInput = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      this.clearForm();
      this.model.set(data);
      this.render();
      setTimeout(function () {
        if (focusAddressInput) _this3.focusAddress();
      });
    }
  }, {
    key: 'clearModel',
    value: function clearModel() {
      // this.model.clear();

      // for some reason model.clear is not working, so we'll go
      // with a manual approach
      this.model.unset('address');
      this.model.unset('amount');
      this.model.unset('memo');
      this.model.unset('currency');
      this.model.set(this.model.defaults || {});
      this.model.validationError = null;
    }
  }, {
    key: 'clearForm',
    value: function clearForm() {
      this.clearModel();
      this.render();
    }
  }, {
    key: 'fetchFeeEstimate',
    value: function fetchFeeEstimate() {
      var amount = (0, _currency.convertCurrency)(this.model.get('amount'), this.model.get('currency'), (0, _cryptoCurrencies.getServerCurrency)().code);
      this.sendConfirmBox.fetchFeeEstimate(amount);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      var defaultCur = typeof (0, _currency.getExchangeRate)(_app2.default.settings.get('localCurrency')) === 'number' ? _app2.default.settings.get('localCurrency') : (0, _cryptoCurrencies.getServerCurrency)().code;

      (0, _loadTemplate2.default)('modals/wallet/sendMoney.html', function (t) {
        _this4.$el.html(t(_extends({}, _this4.model.toJSON(), {
          errors: _this4.model.validationError || {},
          currencyCode: _this4.model.get('currency') || defaultCur,
          currencies: _this4.currencies || (0, _currencies.getCurrenciesSortedByCode)(),
          saveInProgress: _this4.saveInProgress
        })));

        _this4._$addressInput = null;
        _this4._$formFields = null;
        _this4._$btnSend = null;

        _this4.$('#walletSendCurrency').select2();

        var sendConfirmBoxState = _this4.sendConfirmBox && _this4.sendConfirmBox.getState();
        if (_this4.sendConfirmBox) _this4.sendConfirmBox.remove();

        _this4.sendConfirmBox = _this4.createChild(_SpendConfirmBox2.default, {
          initialState: _extends({}, sendConfirmBoxState || {})
        });
        _this4.listenTo(_this4.sendConfirmBox, 'clickSend', _this4.onClickConfirmSend);
        _this4.getCachedEl('.js-sendConfirmContainer').html(_this4.sendConfirmBox.render().el);

        if (_this4.feeChange) _this4.feeChange.remove();
        _this4.feeChange = _this4.createChild(_FeeChange2.default);
        _this4.$('.js-feeChangeContainer').html(_this4.feeChange.render().el);
      });

      return this;
    }
  }, {
    key: 'saveInProgress',
    set: function set(bool) {
      if (typeof bool !== 'boolean') {
        throw new Error('Please provide a boolean.');
      }

      if (bool !== this.saveInProgress) {
        this._saveInProgress = bool;
        this.render();
      }
    },
    get: function get() {
      return this._saveInProgress;
    }
  }, {
    key: '$addressInput',
    get: function get() {
      return this._$addressInput || (this._$addressInput = this.$('#walletSendTo'));
    }
  }, {
    key: '$formFields',
    get: function get() {
      return this._$formFields || (this._$formFields = this.$('select[name], input[name], \n        textarea[name]:not([class*="trumbowyg"]), \n        div[contenteditable][name]'));
    }
  }, {
    key: '$btnSend',
    get: function get() {
      return this._$btnSend || (this._$btnSend = this.$('.js-btnSend'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;