'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _fees = require('../../../utils/fees');

var _metrics = require('../../../utils/metrics');

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this._state = _extends({
      show: false,
      fetchingFee: false,
      fetchFailed: false,
      fetchError: '',
      fee: false,
      displayCurrency: _app2.default.settings.get('localCurrency') || 'BTC',
      btnSendText: _app2.default.polyglot.t('wallet.spendConfirmBox.btnConfirmSend')
    }, options.initialState || {});

    _this.lastFetchFeeEstimateArgs = {};
    _this.boundDocumentClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundDocumentClick);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'spendConfirmBox centeredBelow';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-btnConfirmSend': 'onClickSend',
        'click .js-sendConfirmCancel': 'onClickCancel',
        'click .js-sendConfirmRetry': 'onClickRetry',
        'click .js-sendConfirmClose': 'onClickCancel'
      };
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick(e) {
      if (this.getState().show && !(_jquery2.default.contains(this.el, e.target) || e.target === this.el)) {
        this.setState({ show: false });
      }
    }
  }, {
    key: 'onClickSend',
    value: function onClickSend(e) {
      this.trigger('clickSend');
      e.stopPropagation();
      (0, _metrics.recordEvent)('Purchase_ConfirmBoxSend');
    }
  }, {
    key: 'onClickCancel',
    value: function onClickCancel(e) {
      this.setState({ show: false });
      e.stopPropagation();
      (0, _metrics.recordEvent)('Purchase_ConfirmBoxCancel');
    }
  }, {
    key: 'onClickRetry',
    value: function onClickRetry(e) {
      var amount = this.lastFetchFeeEstimateArgs.amount;
      if (typeof amount === 'number') {
        this.fetchFeeEstimate(amount, this.lastFetchFeeEstimateArgs.feeLevel || null);
      }
      e.stopPropagation();
      (0, _metrics.recordEvent)('Purchase_ConfirmBoxRetry');
    }
  }, {
    key: 'fetchFeeEstimate',
    value: function fetchFeeEstimate(amount) {
      var _this2 = this;

      var feeLevel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _app2.default.localSettings.get('defaultTransactionFee');

      if (typeof amount !== 'number') {
        throw new Error('Please provide an amount as a number.');
      }

      this.lastFetchFeeEstimateArgs = {
        amount: amount,
        feeLevel: feeLevel
      };

      this.setState({
        fetchingFee: true,
        fetchError: '',
        fetchFailed: false
      });

      (0, _fees.estimateFee)(feeLevel, amount).done(function (fee) {
        var state = {
          fee: fee,
          fetchingFee: false
        };

        if (fee + amount > _app2.default.walletBalance.get('confirmed')) {
          state = _extends({
            // The fetch didn't actually fail, but since the server allows unconfirmed spends and
            // we don't want to allow that, we'll pretend it failed and simulate the server
            // ERROR_INSUFFICIENT_FUNDS error.
            fetchFailed: true,
            fetchError: 'ERROR_INSUFFICIENT_FUNDS'
          }, state);
          (0, _metrics.recordEvent)('Purchase_ConfirmBoxInsufficientFunds');
        }

        _this2.setState(state);
      }).fail(function (xhr) {
        var fetchError = xhr && xhr.responseJSON && xhr.responseJSON.reason || '';
        _this2.setState({
          fetchingFee: false,
          fetchFailed: true,
          fetchError: fetchError
        });
        (0, _metrics.recordEvent)('Purchase_ConfirmBoxEstimateFeeFailed', {
          errror: fetchError || 'unknown error'
        });
      });
    }
  }, {
    key: 'remove',
    value: function remove() {
      (0, _jquery2.default)(document).off('click', this.boundDocumentClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/wallet/spendConfirmBox.html', function (t) {
        _this3.$el.html(t(_extends({}, _this3._state)));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;