'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _electron = require('electron');

var _utils = require('../../../utils/');

var _fees = require('../../../utils/fees');

var _cryptoCurrencies = require('../../../data/cryptoCurrencies');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _SimpleMessage = require('../../modals/SimpleMessage');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    if (!_this.model) {
      throw new Error('Please provide a Transaction model.');
    }

    _this._state = _extends({}, options.initialState || {});

    _this.listenTo(_this.model, 'change', function () {
      return _this.render();
    });
    _this.timeAgoInterval = (0, _utils.setTimeagoInterval)(_this.model.get('timestamp'), function () {
      var timeAgo = (0, _moment2.default)(_this.model.get('timestamp')).fromNow();
      if (timeAgo !== _this.renderedTimeAgo) _this.render();
    });

    _this.boundDocClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundDocClick);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'transaction';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-retryPmt': 'onClickRetryPmt',
        'click .js-retryConfirmCancel': 'onClickRetryConfirmCancel',
        'click .js-btnConfirmRetrySend': 'onClickRetryConfirmed',
        'click .js-txidLink': 'onClickTxidLink',
        'click .js-retryFeeFetch': 'onClickRetryFeeFetch'
      };
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick(e) {
      if (this.getState().retryConfirmOn && !(_jquery2.default.contains(this.$retryPmtConfirmedBox[0], e.target) || e.target === this.$retryPmtConfirmedBox[0])) {
        this.setState({
          retryConfirmOn: false
        });
      }
    }
  }, {
    key: 'onClickRetryFeeFetch',
    value: function onClickRetryFeeFetch(e) {
      this.fetchFees();
      e.stopPropagation();
    }
  }, {
    key: 'onClickRetryConfirmed',
    value: function onClickRetryConfirmed() {
      var _this2 = this;

      this.setState({
        retryInProgress: true,
        retryConfirmOn: false
      });

      this.retryPost = _jquery2.default.post(_app2.default.getServerUrl('wallet/bumpfee/' + this.model.id)).always(function () {
        _this2.setState({
          retryInProgress: false
        });
      }).fail(function (xhr) {
        if (xhr.statusText === 'abort') return;
        var failReason = xhr.responseJSON && xhr.responseJSON.reason || '';
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('wallet.transactions.transaction.retryFailDialogTitle'), failReason);
      }).done(function (data) {
        _this2.trigger('retrySuccess', { data: data });
        _this2.model.set('feeBumped', true);
      });
    }
  }, {
    key: 'onClickRetryPmt',
    value: function onClickRetryPmt(e) {
      this.setState({
        retryConfirmOn: true
      });

      this.fetchFees();
      e.stopPropagation();
    }
  }, {
    key: 'onClickRetryConfirmCancel',
    value: function onClickRetryConfirmCancel() {
      this.closeRetryConfirmBox();
    }
  }, {
    key: 'onClickTxidLink',
    value: function onClickTxidLink(e) {
      var _this3 = this;

      this.setState({
        copiedIndicatorOn: true
      });

      _electron.clipboard.writeText((0, _jquery2.default)(e.target).text());
      clearTimeout(this.copiedIndicatorTimeout);

      this.copiedIndicatorTimeout = setTimeout(function () {
        _this3.setState({
          copiedIndicatorOn: false
        });
      }, 1000);
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'fetchFees',
    value: function fetchFees() {
      var _this4 = this;

      this.setState({
        retryConfirmOn: true,
        fetchingEstimatedFee: true,
        fetchError: '',
        fetchFailed: false
      });

      (0, _fees.getFees)().done(function (fees) {
        if (_this4.isRemoved()) return;
        _this4.setState({
          fetchingEstimatedFee: false,
          // server doubles the fee when bumping
          estimatedFee: (0, _cryptoCurrencies.getServerCurrency)().feeBumpTransactionSize * fees.priority * 2 / (0, _cryptoCurrencies.getServerCurrency)().baseUnit
        });
      }).fail(function (xhr) {
        if (_this4.isRemoved()) return;
        _this4.setState({
          fetchingEstimatedFee: false,
          fetchFailed: true,
          fetchError: xhr && xhr.responseJSON && xhr.responseJSON.reason || ''
        });
      });
    }
  }, {
    key: 'closeRetryConfirmBox',
    value: function closeRetryConfirmBox() {
      this.setState({
        retryConfirmOn: false,
        fetchingEstimatedFee: false
      });
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.retryPost) this.retryPost.abort();
      (0, _jquery2.default)(document).off('click', this.boundDocClick);
      this.timeAgoInterval.cancel();
      clearTimeout(this.copiedIndicatorTimeout);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      this.renderedTimeAgo = (0, _moment2.default)(this.model.get('timestamp')).fromNow();

      (0, _loadTemplate2.default)('modals/wallet/transaction.html', function (t) {
        _this5.$el.html(t(_extends({}, _this5.model.toJSON(), {
          userCurrency: _app2.default.settings.get('localCurrency'),
          timeAgo: _this5.renderedTimeAgo,
          isTestnet: !!_app2.default.serverConfig.testnet,
          walletBalance: _app2.default.walletBalance.toJSON()
        }, _this5._state)));
      });

      this._$retryPmtConfirmed = null;

      return this;
    }
  }, {
    key: '$retryPmtConfirmedBox',
    get: function get() {
      return this._$retryPmtConfirmed || (this._$retryPmtConfirmed = this.$('.js-retryPmtConfirmed'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;