'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _Notifications = require('../../collections/Notifications');

var _utils = require('../../utils/');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      initialState: _extends({}, options.initialState || {})
    }, options);

    if (!options.model) {
      throw new Error('Please provide a model.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.listenTo(_this.model, 'change', function () {
      return _this.render();
    });

    _this.timeAgoInterval = (0, _utils.setTimeagoInterval)(_this.model.get('timestamp'), function () {
      var timeAgo = (0, _moment2.default)(_this.model.get('timestamp')).fromNow();
      if (timeAgo !== _this.renderedTimeAgo) _this.render();
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'notification';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        click: 'onClick'
      };
    }
  }, {
    key: 'onClick',
    value: function onClick() {
      var route = this.getNotifDisplayData().route;
      if (route) {
        location.hash = route;
        this.trigger('navigate');
      }
    }
  }, {
    key: 'getNotifDisplayData',
    value: function getNotifDisplayData() {
      return (0, _Notifications.getNotifDisplayData)(this.model.toJSON().notification);
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.timeAgoInterval.cancel();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      this.renderedTimeAgo = (0, _moment2.default)(this.model.get('timestamp')).fromNow();

      (0, _loadTemplate2.default)('notifications/notification.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.getState(), _this2.model.toJSON(), {
          notifText: _this2.getNotifDisplayData().text,
          ownGuid: _app2.default.profile.id,
          renderedTimeAgo: _this2.renderedTimeAgo,
          moment: _moment2.default
        })));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;