'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _SearchProvider = require('../../models/search/SearchProvider');

var _SearchProvider2 = _interopRequireDefault(_SearchProvider);

var _SimpleMessage = require('../modals/SimpleMessage');

var _metrics = require('../../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    _this.model = new _SearchProvider2.default();

    _this.boundOnDocClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundOnDocClick);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'addProvider';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-addBtn': 'onClickAdd',
        'click .js-cancelBtn': 'onClickCancel',
        'keyup .js-addProviderInput': 'onKeyUpAddProviderInput'
      };
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick(e) {
      if (!(_jquery2.default.contains(this.el, e.target) || e.target === this.el)) {
        this.remove();
      }
    }
  }, {
    key: 'save',
    value: function save() {
      var _this2 = this;

      var URL = this.getCachedEl('.js-addProviderInput').val();
      // if the user doesn't type http:// or https://, add http:// for them
      if (!/^https?:\/\//i.test(URL)) {
        URL = 'http://' + URL;
      }

      var opts = {};
      var urlType = this.options.urlType;
      opts[urlType] = URL;

      // pass the type of url to validate to the model
      this.model.set(opts, { validate: true, urlTypes: [urlType] });
      var modelErrors = this.model.validationError && this.model.validationError[urlType];
      if (!modelErrors) {
        var save = this.model.save(opts, { urlTypes: [urlType] });
        if (save) {
          // when saved successfully this view will be removed when the search is rerendered
          save.done(function () {
            (0, _metrics.recordEvent)('Discover_AddProviderSaved', { error: 'none' });
            _app2.default.searchProviders.add(_this2.model);
            _this2.trigger('newProviderSaved', _this2.model);
          }).fail(function () {
            // this is saved to local storage, errors shouldn't normally happen
            (0, _SimpleMessage.openSimpleMessage)('This search provider could not be saved.');
          });
        }
      } else {
        (0, _metrics.recordEvent)('Discover_AddProviderSaved', { error: 'Invalid' });
        this.render();
      }
    }
  }, {
    key: 'onKeyUpAddProviderInput',
    value: function onKeyUpAddProviderInput(e) {
      if (e.which === 13) {
        this.save();
      }
    }
  }, {
    key: 'onClickAdd',
    value: function onClickAdd(e) {
      e.stopPropagation();
      this.save();
    }
  }, {
    key: 'onClickCancel',
    value: function onClickCancel() {
      this.remove();
      (0, _metrics.recordEvent)('Discover_AddProviderCancel');
    }
  }, {
    key: 'remove',
    value: function remove() {
      (0, _jquery2.default)(document).off('click', this.boundOnDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('search/addProvider.html', function (t) {
        _this3.$el.html(t(_extends({
          errors: _extends({}, _this3.model.validationError || {})
        }, _this3.options)));
      });
      setTimeout(function () {
        _this3.getCachedEl('.js-addProviderInput').focus();
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;