'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _string = require('../../utils/string');

var _ListingCard = require('../ListingCard');

var _ListingCard2 = _interopRequireDefault(_ListingCard);

var _UserCard = require('../UserCard');

var _UserCard2 = _interopRequireDefault(_UserCard);

var _PageControls = require('../components/PageControls');

var _PageControls2 = _interopRequireDefault(_PageControls);

var _ListingShort = require('../../models/listing/ListingShort');

var _ListingShort2 = _interopRequireDefault(_ListingShort);

var _Results = require('../../collections/Results');

var _Results2 = _interopRequireDefault(_Results);

var _metrics = require('../../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    _this.searchUrl = options.searchUrl;
    if (!_this.searchUrl) {
      throw new Error('Please provide a search provider URL.');
    }

    _this.serverPage = _this.options.serverPage || 0;
    _this.pageSize = _this.options.pageSize || 24;
    _this.reportsUrl = _this.options.reportsUrl || '';
    _this.viewType = _this.options.viewType || 'grid';

    _this.cardViews = [];
    _this.pageCollections = {};
    // if an initial collection was passed in, add it
    if (options.initCol) _this.pageCollections[_this.serverPage] = options.initCol;
    _this.firstRender = true;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'searchResults flexColRow gutterV';
    }
  }, {
    key: 'createCardView',
    value: function createCardView(model) {
      // models can be listings or nodes
      if (model instanceof _ListingShort2.default) {
        var vendor = model.get('vendor') || {};
        vendor.avatar = vendor.avatarHashes;
        var base = vendor.handle ? '@' + vendor.handle : vendor.peerID;

        var options = {
          listingBaseUrl: base + '/store/',
          reportsUrl: this.reportsUrl,
          model: model,
          vendor: vendor,
          onStore: false,
          viewType: this.viewType
        };

        return this.createChild(_ListingCard2.default, options);
      }

      return this.createChild(_UserCard2.default, { model: model });
    }
  }, {
    key: 'renderCards',
    value: function renderCards(models) {
      var _this2 = this;

      var resultsFrag = document.createDocumentFragment();
      var end = this.pageSize * (Number(this.serverPage) + 1) - (this.pageSize - models.length);
      var total = models.total;
      var start = 0;
      if (total) start = this.pageSize * Number(this.serverPage) + 1;
      var noResults = (0, _jquery2.default)('<h2 class=\'width100 padLg txCtr\'>' + _app2.default.polyglot.t('search.noResults') + '</h2>');

      models.forEach(function (model) {
        var cardVw = _this2.createCardView(model);

        if (cardVw) {
          _this2.cardViews.push(cardVw);
          cardVw.render().$el.appendTo(resultsFrag);
        }
      });

      // if there are no models, add the no models message instead
      if (total < 1) noResults.appendTo(resultsFrag);
      this.$el.toggleClass('noResults', total < 1);

      this.$resultsGrid.html(resultsFrag);
      // update the page controls
      // this.$displayText.html(app.polyglot.t('search.displaying', { start, end, total }));
      this.pageControls.setState({ start: start, end: end, total: total });
      // hide the loading spinner
      this.$el.removeClass('loading');
      /*
      // disabled until an enter handler to added to the listing card
      // move focus to the first result. The timeout orders it after other operations.
      setTimeout(() => {
        this.$resultsGrid.find('.listingCard').filter(':first').focus();
      });
      */
    }
  }, {
    key: 'loadPage',
    value: function loadPage() {
      var _this3 = this;

      var page = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.serverPage;
      var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.pageSize;

      this.removeCardViews();
      // get the new page
      var url = new URL(this.searchUrl);
      var params = new URLSearchParams(url.search);
      params.set('p', page);
      params.set('ps', size);
      var newURL = '' + url.origin + url.pathname + '?' + params.toString();
      this.trigger('loadingPage');

      // if page exists, reuse it
      if (this.pageCollections[page]) {
        this.renderCards(this.pageCollections[page]);
        // update the address bar
        _app2.default.router.navigate('search?providerQ=' + encodeURIComponent(newURL), { replace: this.firstRender });
      } else {
        // show the loading spinner
        this.$el.addClass('loading');

        var newPageCol = new _Results2.default();
        this.pageCollections[page] = newPageCol;

        if (this.newPageFetch) this.newPageFetch.abort();

        this.newPageFetch = newPageCol.fetch({
          url: newURL
        }).done(function () {
          _this3.renderCards(newPageCol);
          // update the address bar
          _app2.default.router.navigate('search?providerQ=' + encodeURIComponent(newURL), { replace: _this3.firstRender });
        }).fail(function (xhr) {
          if (xhr.statusText !== 'abort') _this3.trigger('searchError', xhr);
        });
      }
    }
  }, {
    key: 'clickPagePrev',
    value: function clickPagePrev() {
      this.serverPage--;
      this.loadPage(this.serverPage);
      (0, _metrics.recordEvent)('Discover_PrevPage');
    }
  }, {
    key: 'clickPageNext',
    value: function clickPageNext() {
      this.serverPage++;
      this.loadPage(this.serverPage);
      (0, _metrics.recordEvent)('Discover_NextPage');
    }
  }, {
    key: 'removeCardViews',
    value: function removeCardViews() {
      this.cardViews.forEach(function (vw) {
        return vw.remove();
      });
      this.cardViews = [];
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.removeCardViews();
      if (this.newPageFetch) this.newPageFetch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('search/results.html', function (t) {
        _this4.$el.html(t({
          viewTypeClass: _this4.viewType === 'grid' ? '' : 'listingsGrid' + (0, _string.capitalize)(_this4.viewType) + 'View',
          viewType: _this4.viewType
        }));

        _this4.$resultsGrid = _this4.$('.js-resultsGrid');
        _this4.$displayText = _this4.$('.js-displayingText');
        _this4.removeCardViews();

        if (_this4.pageControls) _this4.pageControls.remove();
        _this4.pageControls = _this4.createChild(_PageControls2.default);
        _this4.listenTo(_this4.pageControls, 'clickNext', _this4.clickPageNext);
        _this4.listenTo(_this4.pageControls, 'clickPrev', _this4.clickPagePrev);
        _this4.$('.js-pageControlsContainer').html(_this4.pageControls.render().el);

        _this4.loadPage();
      });
      this.firstRender = false;

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;