'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

require('../../lib/select2');

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Table = require('./table/Table');

var _Table2 = _interopRequireDefault(_Table);

var _string = require('../../utils/string');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      defaultFilter: {
        search: '',
        sortBy: 'UNREAD',
        states: []
      }
    }, options);

    opts.initialFilter = opts.initialFilter || _extends({}, opts.defaultFilter);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    if (!_this.collection) {
      throw new Error('Please provide a transactions collection.');
    }

    var types = ['sales', 'purchases', 'cases'];

    if (types.indexOf(opts.type) === -1) {
      throw new Error('Type needs to be one of ' + types + '.');
    }

    if (!opts.filterConfig) {
      throw new Error('Please provide a filter config object.');
    }

    if (typeof opts.openOrder !== 'function') {
      throw new Error('Please provide a function to open the order detail modal.');
    }

    _this.options = opts || {};
    _this.type = opts.type;
    _this.filterConfig = opts.filterConfig;
    _this._filter = _extends({}, opts.initialFilter);

    _this.listenTo(_this.collection, 'request', function (cl, xhr) {
      if (_this.table) {
        _this.$queryTotalWrapper.addClass('hide');
      }

      setTimeout(function () {
        if (_this.table) {
          xhr.done(function (data) {
            var count = '<span class="txB">\n                ' + _app2.default.polyglot.t('transactions.' + _this.type + '.countTransactions', { smart_count: data.queryCount }) + '\n               </span>';
            _this.$queryTotalWrapper.find('.js-queryTotalLine').html(_app2.default.polyglot.t('transactions.' + _this.type + '.countTransactionsFound', { countTransactions: count }));
            _this.$queryTotalWrapper.removeClass('hide');
          });
        }
      });
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return this.type + ' tx5';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'change .filter input': 'onChangeFilter',
        'keyup .js-searchInput': 'onKeyUpSearch',
        'change .js-sortBySelect': 'onChangeSortBy',
        'click .js-resetQuery': 'onClickResetQuery'
      };
    }
  }, {
    key: 'onChangeFilter',
    value: function onChangeFilter() {
      var states = [];
      this.$filterCheckboxes.filter(':checked').each(function (index, checkbox) {
        states = states.concat((0, _jquery2.default)(checkbox).data('state'));
      });

      this.filter = _extends({}, this.filter, {
        states: states
      });
    }
  }, {
    key: 'onKeyUpSearch',
    value: function onKeyUpSearch(e) {
      var _this2 = this;

      // wait until they stop typing
      clearTimeout(this.searchKeyUpTimer);

      this.searchKeyUpTimer = setTimeout(function () {
        _this2.filter = _extends({}, _this2.filter, {
          search: e.target.value
        });
      }, 200);
    }
  }, {
    key: 'onChangeSortBy',
    value: function onChangeSortBy(e) {
      this.filter = _extends({}, this.filter, {
        sortBy: e.target.value
      });
    }
  }, {
    key: 'onAttach',
    value: function onAttach() {
      if (typeof this.table.onAttach === 'function') {
        this.table.onAttach.call(this.table);
      }
    }
  }, {
    key: 'onClickResetQuery',
    value: function onClickResetQuery() {
      this.filter = _extends({}, this.options.defaultFilter);
      this.render();
    }

    /*
     * Based on the provided list of checkedStates, this function
     * will return a filterConfig list with the checked value set for each
     * filter.
     */

  }, {
    key: 'setCheckedFilters',
    value: function setCheckedFilters() {
      var filterConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var checkedStates = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      var checkedConfig = [];

      filterConfig.forEach(function (filter, index) {
        if (!filter.targetState || !filter.targetState.length) {
          throw new Error('Filter at index ' + index + ' needs a tragetState ' + 'provided as an array.');
        }

        filter.targetState.forEach(function (targetState) {
          checkedConfig[index] = _extends({}, filterConfig[index], {
            checked: checkedStates.indexOf(targetState) > -1
          });
        });
      });

      return checkedConfig;
    }
  }, {
    key: 'currentFilterIsDefault',
    value: function currentFilterIsDefault() {
      return _underscore2.default.isEqual(this.options.defaultFilter, _underscore2.default.omit(this.filter, 'orderId'));
    }
  }, {
    key: 'remove',
    value: function remove() {
      clearTimeout(this.searchKeyUpTimer);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('transactions/filters.html', function (filterT) {
        var filtersHtml = filterT({
          filters: _this3.setCheckedFilters(_this3.filterConfig, _this3.filter.states)
        });

        (0, _loadTemplate2.default)('transactions/tab.html', function (t) {
          _this3.$el.html(t({
            type: _this3.type,
            filtersHtml: filtersHtml,
            filter: _this3.filter,
            currentFilterIsDefault: _this3.currentFilterIsDefault(),
            capitalize: _string.capitalize
          }));

          _this3._$filterCheckboxes = null;
          _this3._$queryTotalWrapper = null;
          _this3._$resetQuery = null;

          _this3.$('.js-sortBySelect').select2({
            minimumResultsForSearch: -1,
            dropdownParent: _this3.$('.js-sortBySelectDropdownContainer')
          });

          if (_this3.table) _this3.table.remove();
          _this3.table = _this3.createChild(_Table2.default, {
            type: _this3.type,
            collection: _this3.collection,
            initialFilterParams: _this3.filter,
            getProfiles: _this3.options.getProfiles,
            openOrder: _this3.options.openOrder,
            openedOrderModal: _this3.options.openedOrderModal
          });
          _this3.$('.js-tableContainer').html(_this3.table.render().el);
        });
      });

      return this;
    }
  }, {
    key: 'filter',
    get: function get() {
      return this._filter;
    },
    set: function set() {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!_underscore2.default.isEqual(filter, this._filter)) {
        this._filter = _extends({}, filter);

        if (this.table) {
          this.table.filterParams = filter;
        }

        this.$resetQuery.toggleClass('hide', this.currentFilterIsDefault());
      }
    }
  }, {
    key: '$queryTotalWrapper',
    get: function get() {
      return this._$queryTotalWrapper || (this._$queryTotalWrapper = this.$('.js-queryTotalWrapper'));
    }
  }, {
    key: '$filterCheckboxes',
    get: function get() {
      return this._$filterCheckboxes || (this._$filterCheckboxes = this.$('.filter input'));
    }
  }, {
    key: '$resetQuery',
    get: function get() {
      return this._$resetQuery || (this._$resetQuery = this.$('.js-resetQuery'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;