'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _string = require('../../utils/string');

var _utils = require('../../utils/');

var _serverConnect = require('../../utils/serverConnect');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _metrics = require('../../utils/metrics');

var _Transactions = require('../../collections/Transactions');

var _Transactions2 = _interopRequireDefault(_Transactions);

var _Order = require('../../models/order/Order');

var _Order2 = _interopRequireDefault(_Order);

var _Case = require('../../models/order/Case');

var _Case2 = _interopRequireDefault(_Case);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _MiniProfile = require('../MiniProfile');

var _MiniProfile2 = _interopRequireDefault(_MiniProfile);

var _Tab = require('./Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _OrderDetail = require('../modals/orderDetail/OrderDetail');

var _OrderDetail2 = _interopRequireDefault(_OrderDetail);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      initialTab: 'purchases'
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this._tab = opts.initialTab;
    _this.tabViewCache = {};
    _this.profileDeferreds = {};
    _this.profilePosts = [];
    _this.openedOrderModal = null;

    var params = (0, _utils.deparam)(location.hash.split('?')[1] || '');
    var orderId = params.orderId;
    var caseId = params.caseId;

    if (orderId || caseId) {
      // cut off the trailing 's' from the tab
      var type = _this._tab.slice(0, _this._tab.length - 1);

      // If we're opening an order model on init, then we'll
      // need to pass it in to the Tab view. It may need to bind event
      // handlers to it.
      _this.openedOrderModal = _this.openOrder(orderId || caseId, type);
      _this.listenTo(_this.openedOrderModal, 'close', function () {
        return _this.openedOrderModal = null;
      });
    }

    _this.purchasesCol = new _Transactions2.default([], { type: 'purchases' });
    _this.syncTabHeadCount(_this.purchasesCol, function () {
      return _this.$purchasesTabCount;
    });
    // fetch so we get the count for the tabhead
    _this.purchasesCol.fetch();

    _this.salesCol = new _Transactions2.default([], { type: 'sales' });
    _this.syncTabHeadCount(_this.salesCol, function () {
      return _this.$salesTabCount;
    });
    // fetch so we get the count for the tabhead
    _this.salesCol.fetch();

    _this.casesCol = new _Transactions2.default([], { type: 'cases' });
    _this.syncTabHeadCount(_this.casesCol, function () {
      return _this.$casesTabCount;
    });
    // fetch so we get the count for the tabhead
    _this.casesCol.fetch();

    _this.socket = (0, _serverConnect.getSocket)();
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'transactions clrS';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-tab': 'onTabClick'
      };
    }
  }, {
    key: 'onTabClick',
    value: function onTabClick(e) {
      var tab = (0, _jquery2.default)(e.target).closest('.js-tab').attr('data-tab');
      this.selectTab(tab);
      (0, _metrics.recordEvent)('Transactions_TabChange', {
        tab: tab
      });
    }
  }, {
    key: 'syncTabHeadCount',
    value: function syncTabHeadCount(cl, getCountEl) {
      var _this2 = this;

      if (typeof getCountEl !== 'function') {
        throw new Error('Please provide a function that returns a jQuery element ' + 'containing the tab head count to update.');
      }

      var count = void 0;

      this.listenTo(cl, 'request', function (md, xhr) {
        xhr.done(function (data) {
          var updateCount = false;

          if (typeof count === 'number') {
            if (data.queryCount > count) {
              updateCount = true;
            }
          } else {
            updateCount = true;
          }

          if (updateCount) {
            count = data.queryCount;
            getCountEl.call(_this2).html((0, _utils.abbrNum)(data.queryCount));
          }
        });
      });
    }

    /**
     * This function is also passed into the Tab and Table views. They will
     * be affected should you change the signature or return value.
     */

  }, {
    key: 'openOrder',
    value: function openOrder(id) {
      var _this3 = this;

      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'sale';
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      var opts = {
        modalOptions: _extends({}, options.modalOptions || {}),
        addToRoute: true
      };

      var model = void 0;

      if (type !== 'case') {
        model = new _Order2.default({ orderId: id }, { type: type });
      } else {
        model = new _Case2.default({ caseId: id });
      }

      var orderDetail = new _OrderDetail2.default(_extends({
        model: model,
        removeOnClose: true,
        returnText: _app2.default.polyglot.t('transactions.' + type + 's.returnToFromOrder')
      }, opts.modalOptions));

      orderDetail.render().open();

      if (opts.addToRoute) {
        // add the order / case id to the url
        var params = (0, _utils.deparam)(location.hash.split('?')[1] || '');
        delete params.orderId;
        delete params.caseId;
        params[type === 'case' ? 'caseId' : 'orderId'] = id;
        _app2.default.router.navigate(location.hash.split('?')[0] + '?' + _jquery2.default.param(params));
      }

      // remove it from the url on close of the modal
      var onClose = function onClose() {
        var params = (0, _utils.deparam)(location.hash.split('?')[1] || '');
        delete params.orderId;
        delete params.caseId;
        _app2.default.router.navigate(location.hash.split('?')[0] + '?' + _jquery2.default.param(params));
      };

      this.listenTo(orderDetail, 'close', onClose);

      // Do not alter the url if the user is routing to a new route. The
      // user has already altered the url.
      this.listenTo(_app2.default.router, 'will-route', function () {
        _this3.stopListening(orderDetail, 'close', onClose);
      });

      // On any changes to the order / case detail model state, we'll update the
      // state in the correponding model in the respective collection driving
      // the transaction table.
      this.listenTo(model, 'change:state', function (md, state) {
        var col = _this3.purchasesCol;

        if (type === 'sale') {
          col = _this3.salesCol;
        } else if (type === 'case') {
          col = _this3.casesCol;
        }

        var collectionMd = col.get(model.id);
        if (collectionMd) {
          collectionMd.set('state', state);
        }
      });

      return orderDetail;
    }
  }, {
    key: 'getSalesPurchasesFilterConfig',
    value: function getSalesPurchasesFilterConfig(isSale) {
      var defaulFilterStates = isSale ? this.salesDefaultFilter.states : this.purchasesDefaultFilter.states;

      return [{
        id: 'filterUnfunded',
        text: _app2.default.polyglot.t('transactions.filters.unfunded'),
        checked: defaulFilterStates.includes(1),
        className: 'filter',
        targetState: [1]
      }, {
        id: 'filterPending',
        text: _app2.default.polyglot.t('transactions.filters.pending'),
        checked: defaulFilterStates.includes(0),
        className: 'filter',
        targetState: [0]
      }, {
        id: 'filterReady',
        text: _app2.default.polyglot.t('transactions.filters.ready'),
        checked: defaulFilterStates.includes(2) || defaulFilterStates.includes(3) || defaulFilterStates.includes(4),
        className: 'filter',
        targetState: [2, 3, 4]
      }, {
        id: 'filterFulfilled',
        text: _app2.default.polyglot.t('transactions.filters.fulfilled'),
        checked: defaulFilterStates.includes(5) || defaulFilterStates.includes(13),
        className: 'filter',
        targetState: [5, 13]
      }, {
        id: 'filterRefunded',
        text: _app2.default.polyglot.t('transactions.filters.refunded'),
        checked: defaulFilterStates.includes(9),
        className: 'filter',
        targetState: [9]
      }, {
        id: 'filterDisputes',
        text: _app2.default.polyglot.t('transactions.filters.disputes'),
        checked: defaulFilterStates.includes(10) || defaulFilterStates.includes(11) || defaulFilterStates.includes(12),
        className: 'filter',
        targetState: [10, 11, 12]
      }, {
        id: 'filterCompleted',
        text: _app2.default.polyglot.t('transactions.filters.completed'),
        checked: defaulFilterStates.includes(6) || defaulFilterStates.includes(7) || defaulFilterStates.includes(8),
        className: 'filter',
        targetState: [6, 7, 8]
      }, {
        id: 'filterError',
        text: _app2.default.polyglot.t('transactions.filters.error'),
        checked: defaulFilterStates.includes(14),
        className: 'filter',
        targetState: [14]
      }];
    }
  }, {
    key: 'selectTab',
    value: function selectTab(targ) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var opts = _extends({
        addTabToHistory: true
      }, options);

      if (!this['create' + (0, _string.capitalize)(targ) + 'TabView']) {
        throw new Error(targ + ' is not a valid tab.');
      }

      var tabView = this.tabViewCache[targ];

      if (!this.currentTabView || this.currentTabView !== tabView) {
        if (opts.addTabToHistory) {
          // add tab to history
          _app2.default.router.navigate('transactions/' + targ);
        }

        this.$('.js-tab').removeClass('clrT active');
        this.$('.js-tab[data-tab="' + targ + '"]').addClass('clrT active');

        if (this.currentTabView) this.currentTabView.$el.detach();

        if (!tabView) {
          tabView = this['create' + (0, _string.capitalize)(targ) + 'TabView']();
          this.tabViewCache[targ] = tabView;
          tabView.render();
        }

        this.$tabContent.append(tabView.$el);

        if (typeof tabView.onAttach === 'function') {
          tabView.onAttach.call(tabView);
        }

        this.currentTabView = tabView;
      }
    }
  }, {
    key: 'createPurchasesTabView',
    value: function createPurchasesTabView() {
      var view = this.createChild(_Tab2.default, {
        collection: this.purchasesCol,
        type: 'purchases',
        defaultFilter: _extends({}, this.purchasesDefaultFilter),
        initialFilter: _extends({}, this.purchasesDefaultFilter, this.filterUrlParams),
        filterConfig: this.getSalesPurchasesFilterConfig(false),
        openOrder: this.openOrder.bind(this),
        openedOrderModal: this.openedOrderModal
      });

      return view;
    }
  }, {
    key: 'createSalesTabView',
    value: function createSalesTabView() {
      var view = this.createChild(_Tab2.default, {
        collection: this.salesCol,
        type: 'sales',
        defaultFilter: _extends({}, this.salesDefaultFilter),
        initialFilter: _extends({}, this.salesDefaultFilter, this.filterUrlParams),
        filterConfig: this.getSalesPurchasesFilterConfig(true),
        openOrder: this.openOrder.bind(this),
        openedOrderModal: this.openedOrderModal
      });

      return view;
    }
  }, {
    key: 'createCasesTabView',
    value: function createCasesTabView() {
      var view = this.createChild(_Tab2.default, {
        collection: this.casesCol,
        type: 'cases',
        defaultFilter: _extends({}, this.casesDefaultFilter),
        initialFilter: _extends({}, this.casesDefaultFilter, this.filterUrlParams),
        filterConfig: this.casesFilterConfig,
        openOrder: this.openOrder.bind(this),
        openedOrderModal: this.openedOrderModal
      });

      return view;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('transactions/transactions.html', function (t) {
        _this4.$el.html(t({}));
      });

      this.$tabContent = this.$('.js-tabContent');
      this._$purchasesTabCount = null;
      this._$salesTabCount = null;
      this._$casesTabCount = null;

      if (this.miniProfile) this.miniProfile.remove();
      this.miniProfile = this.createChild(_MiniProfile2.default, {
        model: _app2.default.profile
      });
      this.$('.js-miniProfileContainer').html(this.miniProfile.render().el);

      this.selectTab(this._tab, {
        addTabToHistory: false
      });

      return this;
    }
  }, {
    key: 'salesDefaultFilter',
    get: function get() {
      return {
        search: '',
        sortBy: 'UNREAD',
        states: [0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
      };
    }
  }, {
    key: 'purchasesDefaultFilter',
    get: function get() {
      return {
        search: '',
        sortBy: 'UNREAD',
        states: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
      };
    }
  }, {
    key: 'casesDefaultFilter',
    get: function get() {
      return {
        search: '',
        sortBy: 'UNREAD',
        states: [10, 12]
      };
    }
  }, {
    key: 'casesFilterConfig',
    get: function get() {
      return [{
        id: 'filterDisputeOpen',
        text: _app2.default.polyglot.t('transactions.filters.disputeOpen'),
        checked: this.casesDefaultFilter.states.includes(10),
        className: 'filter',
        targetState: [10]
      }, {
        id: 'filterDisputeClosed',
        text: _app2.default.polyglot.t('transactions.filters.disputeClosed'),
        checked: this.casesDefaultFilter.states.includes(12),
        className: 'filter',
        targetState: [12]
      }];
    }
  }, {
    key: 'filterUrlParams',
    get: function get() {
      var params = (0, _utils.deparam)(location.hash.split('?')[1] || '');

      if (params.states) {
        params.states = params.states.split('-').map(function (strIndex) {
          return parseInt(strIndex, 10);
        }).filter(function (state) {
          return !isNaN(state);
        });
      } else {
        delete params.states;
      }

      return params;
    }
  }, {
    key: '$purchasesTabCount',
    get: function get() {
      return this._$purchasesTabCount || (this._$purchasesTabCount = this.$('.js-purchasesTabCount'));
    }
  }, {
    key: '$salesTabCount',
    get: function get() {
      return this._$salesTabCount || (this._$salesTabCount = this.$('.js-salesTabCount'));
    }
  }, {
    key: '$casesTabCount',
    get: function get() {
      return this._$casesTabCount || (this._$casesTabCount = this.$('.js-casesTabCount'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;