'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _selectors = require('../../../utils/selectors');

var _serverConnect = require('../../../utils/serverConnect');

var _order = require('../../../utils/order');

var _Profile = require('../../../models/profile/Profile');

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

var _PageControls = require('../../components/PageControls');

var _PageControls2 = _interopRequireDefault(_PageControls);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 This table is re-used for Sales, Purchases and Cases.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var types = ['sales', 'purchases', 'cases'];
    var opts = _extends({
      initialState: {
        isFetching: false,
        fetchError: ''
      },
      type: 'sales',
      initialFilterParams: {}
    }, options);

    if (types.indexOf(opts.type) === -1) {
      throw new Error('Please provide a valid type.');
    }

    if (typeof opts.openOrder !== 'function') {
      throw new Error('Please provide a function to open the order detail modal.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    if (!_this.collection) {
      throw new Error('Please provide a collection');
    }

    _this.options = opts;
    _this.type = opts.type;
    _this._state = _extends({}, opts.initialState || {});
    _this.views = [];
    _this.curPage = 1;
    _this.queryTotal = null;

    // This will kick off our initial fetch.
    _this.filterParams = opts.initialFilterParams;

    var socket = (0, _serverConnect.getSocket)();

    if (socket) {
      _this.listenTo(socket, 'message', _this.onSocketMessage);
    }

    if (_this.options.openedOrderModal) {
      _this.bindOrderDetailEvents(_this.options.openedOrderModal);
    }

    _this.listenTo(_order.events, 'rejectingOrder', _this.onRejectingOrder);
    _this.listenTo(_order.events, 'rejectOrderComplete, rejectOrderFail', _this.onRejectOrderAlways);
    _this.listenTo(_order.events, 'rejectOrderComplete', _this.onRejectOrderComplete);
    _this.listenTo(_order.events, 'acceptingOrder', _this.onAcceptingOrder);
    _this.listenTo(_order.events, 'acceptOrderComplete, acceptOrderFail', _this.onAcceptOrderAlways);
    _this.listenTo(_order.events, 'acceptOrderComplete', _this.onAcceptOrderComplete);
    _this.listenTo(_order.events, 'cancelingOrder', _this.onCancelingOrder);
    _this.listenTo(_order.events, 'cancelOrderComplete, cancelOrderFail', _this.onCancelOrderAlways);
    _this.listenTo(_order.events, 'cancelOrderComplete', _this.onCancelOrderComplete);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'transactionsTableWrap';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-retryFetch': 'onClickRetryFetch'
      };
    }
  }, {
    key: 'onSocketMessage',
    value: function onSocketMessage(e) {
      if (e.jsonData.message) {
        // If a chat message comes in for a transaction in our list,
        // we'll update the unread count.
        var transaction = this.collection.get(e.jsonData.message.subject);

        if (transaction) {
          var count = transaction.get('unreadChatMessages');
          transaction.set({
            unreadChatMessages: count + 1,
            read: false
          });
        }
      }
    }
  }, {
    key: 'onClickRetryFetch',
    value: function onClickRetryFetch() {
      this.fetchTransactions();
    }
  }, {
    key: 'onClickRejectOrder',
    value: function onClickRejectOrder(e) {
      (0, _order.rejectOrder)(e.view.model.id);
    }
  }, {
    key: 'onRejectingOrder',
    value: function onRejectingOrder(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.setState({
          rejectOrderInProgress: true
        });
      }
    }
  }, {
    key: 'onRejectOrderAlways',
    value: function onRejectOrderAlways(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.setState({
          rejectOrderInProgress: false
        });
      }
    }
  }, {
    key: 'onRejectOrderComplete',
    value: function onRejectOrderComplete(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.model.set('state', 'DECLINED');
      }
    }
  }, {
    key: 'onClickAcceptOrder',
    value: function onClickAcceptOrder(e) {
      (0, _order.acceptOrder)(e.view.model.id);
    }
  }, {
    key: 'onAcceptingOrder',
    value: function onAcceptingOrder(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.setState({
          acceptOrderInProgress: true
        });
      }
    }
  }, {
    key: 'onAcceptOrderAlways',
    value: function onAcceptOrderAlways(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.setState({
          acceptOrderInProgress: false
        });
      }
    }
  }, {
    key: 'onAcceptOrderComplete',
    value: function onAcceptOrderComplete(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.model.set('state', 'AWAITING_FULFILLMENT');
      }
    }
  }, {
    key: 'onClickCancelOrder',
    value: function onClickCancelOrder(e) {
      (0, _order.cancelOrder)(e.view.model.id);
    }
  }, {
    key: 'onCancelingOrder',
    value: function onCancelingOrder(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.setState({
          cancelOrderInProgress: true
        });
      }
    }
  }, {
    key: 'onCancelOrderAlways',
    value: function onCancelOrderAlways(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.setState({
          cancelOrderInProgress: false
        });
      }
    }
  }, {
    key: 'onCancelOrderComplete',
    value: function onCancelOrderComplete(e) {
      var view = this.indexedViews.byOrder[e.id];

      if (view) {
        view.model.set('state', 'CANCELED');
      }
    }
  }, {
    key: 'onClickRow',
    value: function onClickRow(e) {
      var type = 'sale';

      if (this.type === 'purchases') {
        type = 'purchase';
      } else if (this.type === 'cases') {
        type = 'case';
      }

      var orderDetail = this.options.openOrder(e.view.model.id, type);
      this.bindOrderDetailEvents(orderDetail);
    }
  }, {
    key: 'bindOrderDetailEvents',
    value: function bindOrderDetailEvents(orderDetail) {
      var _this2 = this;

      this.listenTo(orderDetail.model, 'sync', function () {
        var transaction = _this2.collection.get(orderDetail.model.id);

        if (transaction) {
          transaction.set('read', true);
        }
      });

      this.listenTo(orderDetail, 'convoMarkedAsRead', function () {
        var transaction = _this2.collection.get(orderDetail.model.id);

        if (transaction) {
          transaction.set({
            unreadChatMessages: 0,
            read: true
          });
        }
      });
    }
  }, {
    key: 'onClickNextPage',
    value: function onClickNextPage() {
      this.fetchTransactions(this.curPage += 1);
    }
  }, {
    key: 'onClickPrevPage',
    value: function onClickPrevPage() {
      this.fetchTransactions(this.curPage -= 1);
    }
  }, {
    key: 'onAttach',
    value: function onAttach() {
      this.setFilterOnRoute();
    }
  }, {
    key: 'getAvatars',
    value: function getAvatars() {
      var _this3 = this;

      var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var profilesToFetch = [];

      models.forEach(function (md) {
        var vendorId = md.get('vendorId');
        var buyerId = md.get('buyerId');

        if (vendorId) {
          profilesToFetch.push(vendorId);
        }

        if (buyerId) {
          profilesToFetch.push(buyerId);
        }
      });

      if (profilesToFetch.length) {
        (0, _Profile.getCachedProfiles)(profilesToFetch).forEach(function (profilePromise) {
          profilePromise.done(function (profile) {
            var flatProfile = profile.toJSON();
            var vendorViews = _this3.indexedViews.byVendor[flatProfile.peerID] || [];
            var buyerViews = _this3.indexedViews.byBuyer[flatProfile.peerID] || [];

            vendorViews.forEach(function (view) {
              view.setState({ vendorAvatarHashes: flatProfile.avatarHashes });
              view.model.set({ vendorHandle: flatProfile.handle });
            });

            buyerViews.forEach(function (view) {
              view.setState({ buyerAvatarHashes: flatProfile.avatarHashes });
              view.model.set({ buyerHandle: flatProfile.handle });
            });
          });
        });
      }
    }

    /*
     * Index the Row Views by Vendor and/or Buyer ID as well as orderID
     * so they could be easily retreived by the respective identifier.
     */

  }, {
    key: 'indexRowViews',
    value: function indexRowViews() {
      var _this4 = this;

      this.indexedViews = {
        byVendor: {},
        byBuyer: {},
        byOrder: {}
      };

      this.views.forEach(function (view) {
        var vendorId = view.model.get('vendorId');
        var buyerId = view.model.get('buyerId');

        if (vendorId) {
          _this4.indexedViews.byVendor[vendorId] = _this4.indexedViews.byVendor[vendorId] || [];
          _this4.indexedViews.byVendor[vendorId].push(view);
        }

        if (buyerId) {
          _this4.indexedViews.byBuyer[buyerId] = _this4.indexedViews.byBuyer[buyerId] || [];
          _this4.indexedViews.byBuyer[buyerId].push(view);
        }

        _this4.indexedViews.byOrder[view.model.id] = view;
      });
    }
  }, {
    key: 'setFilterOnRoute',
    value: function setFilterOnRoute() {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.filterParams;

      var queryFilter = _extends({}, filter, {
        // Joining with dashes instead of commas because commas
        // look really bizarre when encode in a query string.
        states: Array.isArray(filter.states) ? filter.states.join('-') : ''
      });

      if (!queryFilter.states) {
        delete queryFilter.states;
      }

      if (queryFilter.search === '') {
        delete queryFilter.search;
      }

      var baseRoute = location.hash.split('?')[0];
      baseRoute = baseRoute.startsWith('#ob://') ? baseRoute.slice(6) : baseRoute.slice(1);

      _app2.default.router.navigate(baseRoute + '?' + _jquery2.default.param(queryFilter), { replace: true });
    }
  }, {
    key: 'fetchTransactions',
    value: function fetchTransactions() {
      var _this5 = this;

      var page = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.curPage;
      var filterParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.filterParams;

      if (typeof page !== 'number') {
        throw new Error('Please provide a page number to fetch.');
      }

      if (page < 1) {
        throw new Error('Please provide a page number greater than zero.');
      }

      this.curPage = page;
      this.filterParams = filterParams;
      this.setFilterOnRoute();

      if (this.transactionsFetch) this.transactionsFetch.abort();

      var fetchParams = _extends({
        limit: this.transactionsPerPage
      }, filterParams, {
        sortByAscending: ['UNREAD', 'DATE_ASC'].indexOf(filterParams.sortBy) === -1,
        sortByRead: filterParams.sortBy === 'UNREAD',
        exclude: this.collection.map(function (md) {
          return md.id;
        })
      });

      delete fetchParams.sortBy;
      var havePage = false;

      if (this.collection.length > (page - 1) * this.transactionsPerPage) {
        // we already have the page
        havePage = true;
        (0, _selectors.getContentFrame)()[0].scrollTop = 0;
        this.render();
      } else {
        if (this.collection.length < (page - 1) * this.transactionsPerPage) {
          // You cannot fetch a page unless you have its previous page. The api
          // requires the ID of the last transaction in the previous page.
          throw new Error('Cannot fetch page. Do no have the previous pages.');
        } else if (this.collection.length) {
          fetchParams.offsetId = this.collection.at(this.collection.length - 1).id;
        }
      }

      if (havePage) return;

      this.transactionsFetch = this.collection.fetch({
        data: fetchParams,
        remove: false
      });

      this.transactionsFetch.fail(function (jqXhr) {
        if (jqXhr.statusText === 'abort') return;

        var fetchError = '';

        if (jqXhr.responseJSON && jqXhr.responseJSON.reason) {
          fetchError = jqXhr.responseJSON.reason;
        }

        _this5.setState({
          isFetching: false,
          fetchFailed: true,
          fetchError: fetchError
        });
      }).done(function (data, textStatus, jqXhr) {
        if (jqXhr.statusText === 'abort') return;

        _this5.queryTotal = data.queryCount;

        _this5.setState({
          isFetching: false
        });
      });

      this.setState({
        isFetching: true,
        fetchFailed: false,
        fetchError: ''
      });
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.avatarPost) this.avatarPost.abort();
      if (this.transactionsFetch) this.transactionsFetch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      (0, _loadTemplate2.default)('transactions/table/table.html', function (t) {
        _this6.$el.html(t(_extends({
          type: _this6.type,
          transactions: _this6.collection.toJSON()
        }, _this6._state)));
      });

      var startIndex = (this.curPage - 1) * this.transactionsPerPage;
      this.views.forEach(function (view) {
        return view.remove();
      });
      this.views = [];
      this.indexedViews = {};
      var transactionsFrag = document.createDocumentFragment();
      var transToRender = this.collection.slice(startIndex, startIndex + this.transactionsPerPage);
      // The collection contains all pages we've fetched, but we'll slice it and
      // only render the current page.
      transToRender.forEach(function (transaction) {
        var view = _this6.createChild(_Row2.default, {
          model: transaction,
          type: _this6.type,
          initialState: {
            acceptOrderInProgress: (0, _order.acceptingOrder)(transaction.id),
            rejectOrderInProgress: (0, _order.rejectingOrder)(transaction.id),
            cancelOrderInProgress: (0, _order.cancelingOrder)(transaction.id)
          }
        });

        _this6.listenTo(view, 'clickAcceptOrder', _this6.onClickAcceptOrder);
        _this6.listenTo(view, 'clickRejectOrder', _this6.onClickRejectOrder);
        _this6.listenTo(view, 'clickCancelOrder', _this6.onClickCancelOrder);
        _this6.listenTo(view, 'clickRow', _this6.onClickRow);

        (0, _jquery2.default)(transactionsFrag).append(view.render().el);
        _this6.views.push(view);
      });

      this.indexRowViews();
      this.getAvatars(transToRender); // be sure to get avatars *after* indexRowViews()
      this.$('.js-transactionsTable').append(transactionsFrag);

      var onLastPage = this.curPage > this.collection.length / this.transactionsPerPage;
      var end = this.curPage * this.transactionsPerPage;

      if (onLastPage) {
        end = this.collection.length;
      }

      if (this.pageControls) this.pageControls.remove();
      this.pageControls = this.createChild(_PageControls2.default, {
        initialState: {
          start: startIndex + 1,
          end: end,
          total: this.queryTotal
        }
      });
      this.listenTo(this.pageControls, 'clickNext', this.onClickNextPage);
      this.listenTo(this.pageControls, 'clickPrev', this.onClickPrevPage);
      this.$('.js-pageControlsContainer').html(this.pageControls.render().el);

      return this;
    }
  }, {
    key: 'transactionsPerPage',
    get: function get() {
      return 20;
    }
  }, {
    key: 'filterParams',
    get: function get() {
      return this._filterParams || {};
    },
    set: function set() {
      var filterParams = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!_underscore2.default.isEqual(filterParams, this._filterParams)) {
        this._filterParams = JSON.parse(JSON.stringify(filterParams)); // deep clone
        this.collection.reset();
        this.fetchTransactions(1, filterParams);
      }
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;