'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

require('../../lib/whenAll.jquery');

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _selectors = require('../../utils/selectors');

var _follow = require('../../utils/follow');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Followers = require('../../collections/Followers');

var _Followers2 = _interopRequireDefault(_Followers);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _FollowLoading = require('./FollowLoading');

var _FollowLoading2 = _interopRequireDefault(_FollowLoading);

var _UserCard = require('../UserCard');

var _UserCard2 = _interopRequireDefault(_UserCard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      followType: 'followers',
      fetchCollection: true
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    if (!opts.peerId) {
      throw new Error('Please provide a peerId of the user who this list is for.');
    }

    var types = ['followers', 'following'];
    if (types.indexOf(opts.followType) === -1) {
      throw new Error('followType must be one of ' + types.join(', '));
    }

    if (!opts.collection) {
      throw new Error('Please provide a followers collection.');
    }

    _this._origClParse = _this.collection.parse;
    _this.collection.parse = _this.collectionParse.bind(_this);

    _this.options = opts;
    _this.followType = opts.followType;
    _this.userCardViews = [];
    _this.indexedUserCardViews = {};
    _this.renderedCl = new _Followers2.default([], {
      peerId: opts.peerId,
      type: opts.followType
    });
    _this.listenTo(_this.renderedCl, 'update', _this.onCollectionUpdate);

    if (opts.fetchCollection) {
      _this.fetch();
    } else {
      setTimeout(function () {
        return _this.onCollectionFetched.call(_this);
      });
    }

    _this.listenTo(_app2.default.ownFollowing, 'update', _this.onOwnFollowingUpdate);
    _this.throttledOnScroll = _underscore2.default.throttle(_this.onScroll, 100).bind(_this);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'userPageFollow noResults';
    }
  }, {
    key: 'onScroll',
    value: function onScroll() {
      var _this2 = this;

      var cf = (0, _selectors.getContentFrame)()[0];
      var scrollNearBot = cf.scrollTop >= cf.scrollHeight - cf.offsetHeight - 100;
      if (this.renderedCl.length < this.collection.length && this.followLoading && !this.followLoading.getState().isFetching && scrollNearBot) {
        // Some fake latency so a user doesn't just scroll down and load
        // hundreds of userCards which would kick off hundreds of profile
        // fetches.
        this.followLoading.setState({ isFetching: true });

        setTimeout(function () {
          var start = _this2.renderedCl.length;
          var end = start + _this2.usersPerPage;
          _this2.followLoading.setState({ isFetching: false });
          _this2.renderedCl.add(_this2.collection.models.slice(start, end));
        }, 500);
      }
    }
  }, {
    key: 'onOwnFollowingUpdate',
    value: function onOwnFollowingUpdate(cl, opts) {
      var _this3 = this;

      if (opts.changes.added.length) {
        if (this.ownPage) {
          if (this.followType === 'following') this.collection.add(opts.changes.added);
        } else if (this.followType === 'followers') {
          var isUserNewlyFollowed = !!opts.changes.added.find(function (addMd) {
            return addMd.id === _this3.model.id;
          });

          if (isUserNewlyFollowed) {
            this.collection.add({ peerId: _app2.default.profile.id }, { at: 0 });
          }
        }
      }

      if (opts.changes.removed.length) {
        // If someone is looking at their own following list, we won't remove the user card of
        // users they've unfollowed. It's likely they're scrolling through their own followers
        // list and cleaning house and since the unfollow process takes a while, it could
        // be chaotic for the cards to just disappear at some later time. The follow button
        // state on the card will correctly reflect that the user is no longer followed.
        if (this.ownPage) return;

        if (this.followType === 'followers') {
          var isUserNewlyUnfollowed = !!opts.changes.removed.find(function (removedMd) {
            return removedMd.id === _this3.model.id;
          });
          if (isUserNewlyUnfollowed) {
            this.collection.remove(_app2.default.profile.id);
          }
        }
      }
    }
  }, {
    key: 'onCollectionUpdate',
    value: function onCollectionUpdate(cl, opts) {
      var _this4 = this;

      this.$el.toggleClass('noResults', !cl.length);

      if (this.followLoading) {
        this.followLoading.setState({ noResults: !cl.length });
      }

      if (opts.changes.added.length) {
        // Expecting either a single new user on the bottom (own node
        // must have followed in the UI) or a page of users at the bottom.
        if (opts.changes.added[opts.changes.added.length - 1] === this.renderedCl.at(this.renderedCl.length - 1)) {
          // It's a page of users at the bottom
          this.renderUsers(opts.changes.added, 'append');
        } else {
          // New user at top
          this.renderUsers(opts.changes.added, 'prepend');
        }
      }

      opts.changes.removed.forEach(function (md) {
        return _this4.removeUserCard(md.id);
      });
    }
  }, {
    key: 'onCollectionFetched',
    value: function onCollectionFetched() {
      var _this5 = this;

      var state = {
        isFetching: false,
        fetchFailed: false,
        noResults: false,
        fetchErrorMsg: ''
      };

      if (!this.collection.length) {
        state.noResults = true;
      }

      if (this.followLoading) this.followLoading.setState(state);
      this.renderedCl.add(this.collection.models.slice(0, this.usersPerPage));

      // If any additions / removal occur on the main collection (e.g. this view
      // is showing our own following list and we follow / unfollow someone; this view
      // is showing anothers followers list and our own node has followed / unfollowed
      // that user), we sync them over to the renderedCl.
      this.listenTo(this.collection, 'add', function (md) {
        _this5.renderedCl.add(md, { at: _this5.collection.models.indexOf(md) });
      });

      this.listenTo(this.collection, 'remove', function (md) {
        _this5.renderedCl.remove(md.id);
      });
    }

    /**
     * Other nodes followers lists are not up to date. Since we do have
     * up to date knowledge of our own following / followers data, if we
     * know some part of the other nodes followers lists are not accurate,
     * we'll adjust them.
     */

  }, {
    key: 'collectionParse',
    value: function collectionParse(response) {
      var users = [].concat(_toConsumableArray(response));

      if (!this.ownPage) {
        if (this.followType === 'followers') {
          var iFollow = (0, _follow.followedByYou)(this.model.id);
          if (iFollow) {
            if (users.indexOf(_app2.default.profile.id) === -1) {
              // I am not in their followers list but should be.
              users = [_app2.default.profile.id].concat(_toConsumableArray(users));
            }
          } else if (users.indexOf(_app2.default.profile.id) > -1) {
            // I am in their followers list when I shouldn't be.
            users.splice(users.indexOf(_app2.default.profile.id), 1);
          }
        } else if (typeof this.followsMe !== 'undefined') {
          if (this.followsMe) {
            if (users.indexOf(_app2.default.profile.id) === -1) {
              // I am not in their following list but should be.
              users = [_app2.default.profile.id].concat(_toConsumableArray(users));
            }
          } else if (users.indexOf(_app2.default.profile.id) > -1) {
            // I am in their following list when I shouldn't be.
            users.splice(users.indexOf(_app2.default.profile.id), 1);
          }
        }
      }

      return this._origClParse.call(this.collection, users);
    }
  }, {
    key: 'removeUserCard',
    value: function removeUserCard(peerId) {
      if (!peerId) {
        throw new Error('Please provide a peerId');
      }

      var view = this.indexedUserCardViews[peerId];
      if (view) {
        view.remove();
        this.userCardViews.splice(this.userCardViews.indexOf(view), 1);
        delete this.indexedUserCardViews[peerId];
      }
    }
  }, {
    key: 'renderUsers',
    value: function renderUsers() {
      var _this6 = this;

      var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var insertionType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'append';

      if (!models) {
        throw new Error('Please provide an array of Follower models.');
      }

      if (['append', 'prepend', 'replace'].indexOf(insertionType) === -1) {
        throw new Error('Please provide a valid insertion type.');
      }

      if (insertionType === 'replace') {
        this.userCardViews.forEach(function (user) {
          return user.remove();
        });
        this.userCardViews = [];
        this.indexedUserCardViews = {};
      }

      var usersFrag = document.createDocumentFragment();

      models.forEach(function (user) {
        var view = _this6.createChild(_UserCard2.default, { guid: user.id });
        _this6.userCardViews.push(view);
        _this6.indexedUserCardViews[user.id] = view;
        view.render().$el.appendTo(usersFrag);
      });

      if (insertionType === 'prepend') {
        this.getCachedEl('.js-userCardsContainer').prepend(usersFrag);
      } else {
        this.getCachedEl('.js-userCardsContainer').append(usersFrag);
      }
    }
  }, {
    key: 'fetch',
    value: function fetch() {
      var _this7 = this;

      if (this.followLoading) {
        this.followLoading.setState({
          isFetching: true,
          fetchFailed: false,
          fetchErrorMsg: ''
        });
      }

      var followsYouDeferred = _jquery2.default.Deferred();

      if (!this.ownPage && this.followType === 'following' && (!this.followsYouFetch || this.followsYouFetchFailed)) {
        this.followsYouFetch = (0, _follow.followsYou)(this.model.id).done(function (data) {
          _this7.followsMe = data.followsMe;
          followsYouDeferred.resolve();
        });
      } else {
        followsYouDeferred.resolve();
      }

      followsYouDeferred.always(function () {
        _this7.followFetch = _this7.collection.fetch().done(function () {
          return _this7.onCollectionFetched.call(_this7);
        }).fail(function (xhr) {
          if (xhr.statusText === 'abort') return;
          if (xhr === _this7.followFetch) {
            if (_this7.followLoading) {
              _this7.followLoading.setState({
                isFetching: false,
                fetchFailed: true,
                fetchErrorMsg: xhr.responseJSON && xhr.responseJSON.reason || ''
              });
            }
          }
        });
      });
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.followFetch) this.followFetch.abort();
      if (this.followsYouFetch && this.followsYouFetch.abort) {
        this.followsYouFetch.abort();
      }
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this8 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('userPage/follow.html', function (t) {
        _this8.$el.html(t({}));
      });

      if (this.followLoading) this.followLoading.remove();
      var noResultsMsg = void 0;
      var fetchErrorTitle = void 0;

      if (this.followType === 'followers') {
        fetchErrorTitle = _app2.default.polyglot.t('userPage.followTab.followersFetchError');
        noResultsMsg = this.ownPage ? _app2.default.polyglot.t('userPage.followTab.noOwnFollowers') : _app2.default.polyglot.t('userPage.followTab.noFollowers', {
          name: this.model.get('handle') || this.model.id.slice(0, 8) + '\u2026'
        });
      } else {
        fetchErrorTitle = _app2.default.polyglot.t('userPage.followTab.followingFetchError');
        noResultsMsg = this.ownPage ? _app2.default.polyglot.t('userPage.followTab.noOwnFollowing') : _app2.default.polyglot.t('userPage.followTab.noFollowing', {
          name: this.model.get('handle') || this.model.id.slice(0, 8) + '\u2026'
        });
      }

      var isFetching = this.followsYouFetch && this.followsYouFetch.state() === 'pending' || this.followFetch && this.followFetch.state() === 'pending';

      this.followLoading = this.createChild(_FollowLoading2.default, {
        initialState: {
          isFetching: isFetching,
          fetchFailed: this.followFetch && this.followFetch.state() === 'rejected',
          fetchErrorTitle: fetchErrorTitle,
          fetchErrorMsg: this.followFetch && this.followFetch.responseJSON && this.followFetch.responseJSON.reason || '',
          noResultsMsg: noResultsMsg,
          noResults: !this.collection.length
        }
      });

      this.listenTo(this.followLoading, 'retry-click', function () {
        return _this8.fetch();
      });
      this.getCachedEl('.js-followLoadingContainer').html(this.followLoading.render().el);

      (0, _selectors.getContentFrame)().off('scroll', this.throttledOnScroll).on('scroll', this.throttledOnScroll);

      return this;
    }
  }, {
    key: 'usersPerPage',
    get: function get() {
      return 12;
    }
  }, {
    key: 'ownPage',
    get: function get() {
      return this.options.peerId === _app2.default.profile.id;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;