'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../../lib/select2');

require('../../utils/lib/velocityUiPack.js');

var _countries = require('../../data/countries');

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _selectors = require('../../utils/selectors');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _currency = require('../../utils/currency');

var _modalManager = require('../../utils/modalManager');

var _Listing = require('../../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _Listings = require('../../collections/Listings');

var _Listings2 = _interopRequireDefault(_Listings);

var _listing = require('../../models/listing/');

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _Listing3 = require('../modals/listingDetail/Listing');

var _Listing4 = _interopRequireDefault(_Listing3);

var _ListingsGrid = require('./ListingsGrid');

var _ListingsGrid2 = _interopRequireDefault(_ListingsGrid);

var _CategoryFilter = require('./CategoryFilter');

var _CategoryFilter2 = _interopRequireDefault(_CategoryFilter);

var _PopInMessage = require('../components/PopInMessage');

var _PopInMessage2 = _interopRequireDefault(_PopInMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    if (!_this.collection) {
      throw new Error('Please provide a collection.');
    }

    if (!_this.model) {
      throw new Error('Please provide a model.');
    }

    _this.countryList = (0, _countries.getTranslatedCountries)();

    _this.defaultFilter = {
      category: 'all',
      shipsTo: 'any',
      searchTerm: '',
      sortBy: 'PRICE_ASC',
      freeShipping: false
    };

    _this.filter = _extends({}, _this.defaultFilter);

    _this.listingsViewType = _app2.default.localSettings.get('listingsGridViewType');

    _this.listenTo(_this.collection, 'request', _this.onRequest);
    _this.listenTo(_this.collection, 'update', _this.onUpdateCollection);

    if (_this.model.id === _app2.default.profile.id) {
      _this.listenTo(_listing.events, 'saved', function (md, opts) {
        // For now, we only know if the listing model has
        // changed in some way since the last save. We don't
        // know what specifically changed. So, this message
        // will show if some listing attribute changed, even
        // though it may not be one represented in the store.
        if (opts.hasChanged()) {
          _this.showDataChangedMessage();
        }
      });

      _this.listenTo(_listing.events, 'destroy', function () {
        return _this.showDataChangedMessage();
      });
      // if the user changes their vendor setting, toggle the warning
      _this.listenTo(_app2.default.profile, 'change:vendor', function () {
        return _this.toggleInactiveWarning();
      });
    }

    _this.listenTo(_app2.default.settings, 'change:country', function () {
      return _this.showShippingChangedMessage();
    });
    _this.listenTo(_app2.default.settings, 'change:localCurrency', function () {
      return _this.showDataChangedMessage();
    });
    _this.listenTo(_app2.default.localSettings, 'change:bitcoinUnit', function () {
      return _this.showDataChangedMessage();
    });

    _this.listenTo(_app2.default.settings.get('shippingAddresses'), 'update', function (cl, opts) {
      if (opts.changes.added.length || opts.changes.removed.length) {
        _this.showShippingChangedMessage();
      }
    });

    // this block should be last
    if (options.initialFetch) {
      _this.fetch = options.initialFetch;
      _this.onRequest(_this.collection, _this.fetch);
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'userPageStore';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-retryFetch': 'onClickRetryFetch',
        'change .js-filterFreeShipping': 'onFilterFreeShippingChange',
        'change .js-shipsToSelect': 'onShipsToSelectChange',
        'keyup .js-searchInput': 'onKeyupSearchInput',
        'change .js-sortBySelect': 'onChangeSortBy',
        'click .js-toggleListGridView': 'onClickToggleListGridView',
        'click .js-clearSearch': 'onClickClearSearch',
        'click .js-activateStore': 'onClickActivateStore'
      };
    }
  }, {
    key: 'onFilterFreeShippingChange',
    value: function onFilterFreeShippingChange(e) {
      this.filter.freeShipping = (0, _jquery2.default)(e.target).is(':checked');
      this.renderListings(this.filteredCollection());
    }
  }, {
    key: 'toggleInactiveWarning',
    value: function toggleInactiveWarning() {
      this.$inactiveWarning.toggleClass('hide', _app2.default.settings.get('vendor'));
    }
  }, {
    key: 'onShipsToSelectChange',
    value: function onShipsToSelectChange(e) {
      this.filter.shipsTo = e.target.value;
      this.renderListings(this.filteredCollection());
    }
  }, {
    key: 'onChangeSortBy',
    value: function onChangeSortBy(e) {
      this.filter.sortBy = (0, _jquery2.default)(e.target).val();
      this.renderListings();
    }
  }, {
    key: 'onUpdateCollection',
    value: function onUpdateCollection(cl, opts) {
      if (opts.changes.added) {
        opts.changes.added.forEach(function (md) {
          md.searchDescription = (0, _jquery2.default)('<div />').html(md.get('description')).text().toLocaleLowerCase();
          md.searchTitle = md.get('title').toLocaleLowerCase();
          var price = md.get('price');

          if (price.amount !== undefined) {
            // An undefined price means it was likely in an unrecognized currency that we
            // weren't able to convert from decimal/base units to integer/non-base units.
            try {
              md.convertedPrice = (0, _currency.convertCurrency)(price.amount, price.currencyCode, _app2.default.settings.get('localCurrency'));
            } catch (e) {
              if (e instanceof _currency.NoExchangeRateDataError) {
                // If no exchange rate data is available, we'll just use the unconverted price
                md.convertedPrice = price.amount;
              } else {
                throw e;
              }
            }
          }
        });
      }
    }
  }, {
    key: 'onKeyupSearchInput',
    value: function onKeyupSearchInput(e) {
      var _this2 = this;

      // make sure they're not still typing
      if (this.searchKeyUpTimer) {
        clearTimeout(this.searchKeyUpTimer);
      }

      this.searchKeyUpTimer = setTimeout(function () {
        return _this2.search((0, _jquery2.default)(e.target).val());
      }, 150);
    }
  }, {
    key: 'onRequest',
    value: function onRequest(cl, xhr) {
      var _this3 = this;

      // Ignore a request on the ListingShort model, which happens
      // if we delete it.
      if (!(cl instanceof _Listings2.default)) return;

      this.fetch = xhr;
      if (!this.retryPressed) this.render();

      var startTime = Date.now();

      xhr.always(function () {
        if (xhr.state() === 'rejected' && xhr.status !== 404) {
          // if fetch is triggered by retry button and
          // it immediately fails, it looks like nothing happend,
          // so, we'll make sure it takes a minimum time.
          var callTime = Date.now() - startTime;

          if (callTime < 250) {
            setTimeout(function () {
              _this3.retryPressed = false;
              _this3.render();
            }, 250 - callTime);
          } else {
            _this3.retryPressed = false;
            _this3.render();
          }
        } else {
          _this3.retryPressed = false;
          _this3.render();
        }
      });
    }
  }, {
    key: 'onClickRetryFetch',
    value: function onClickRetryFetch() {
      this.retryPressed = true;
      this.collection.fetch();
      this.$btnRetry.addClass('processing');
    }
  }, {
    key: 'onClickClearSearch',
    value: function onClickClearSearch() {
      // will reset filters / search text, but maintain sort
      this.filter = _extends({}, this.defaultFilter, {
        sortBy: this.filter.sortBy
      });

      this.render();
    }
  }, {
    key: 'onClickToggleListGridView',
    value: function onClickToggleListGridView() {
      this.listingsViewType = this.listingsViewType === 'list' ? 'grid' : 'list';
    }
  }, {
    key: 'onClickActivateStore',
    value: function onClickActivateStore() {
      (0, _modalManager.launchSettingsModal)({ initialTab: 'Store' });
    }
  }, {
    key: 'showDataChangedMessage',
    value: function showDataChangedMessage() {
      var _this4 = this;

      if (this.dataChangePopIn && !this.dataChangePopIn.isRemoved()) {
        this.dataChangePopIn.$el.velocity('callout.shake', { duration: 500 });
      } else {
        this.dataChangePopIn = this.createChild(_PopInMessage2.default, {
          messageText: (0, _PopInMessage.buildRefreshAlertMessage)(_app2.default.polyglot.t('userPage.store.listingDataChangedPopin'))
        });

        this.listenTo(this.dataChangePopIn, 'clickRefresh', function () {
          return _this4.collection.fetch();
        });

        this.listenTo(this.dataChangePopIn, 'clickDismiss', function () {
          _this4.dataChangePopIn.remove();
          _this4.dataChangePopIn = null;
        });

        this.$popInMessages.append(this.dataChangePopIn.render().el);
      }
    }
  }, {
    key: 'showShippingChangedMessage',
    value: function showShippingChangedMessage() {
      var _this5 = this;

      if (this.shippingChangePopIn && !this.shippingChangePopIn.isRemoved()) {
        this.shippingChangePopIn.$el.velocity('callout.shake', { duration: 500 });
      } else {
        this.shippingChangePopIn = this.createChild(_PopInMessage2.default, {
          messageText: (0, _PopInMessage.buildRefreshAlertMessage)(_app2.default.polyglot.t('userPage.store.shippingDataChangedPopin'))
        });

        this.listenTo(this.shippingChangePopIn, 'clickRefresh', function () {
          return _this5.collection.fetch();
        });

        this.listenTo(this.shippingChangePopIn, 'clickDismiss', function () {
          _this5.shippingChangePopIn.remove();
          _this5.shippingChangePopIn = null;
        });

        this.$popInMessages.append(this.shippingChangePopIn.render().el);
      }
    }
  }, {
    key: 'search',
    value: function search(term) {
      var searchTerm = term.toLocaleLowerCase().trim();

      if (searchTerm === this.filter.searchTerm) return;

      this.filter.searchTerm = searchTerm;
      this.renderListings(this.filteredCollection());
    }

    /**
     * When a listing card is clicked, the listingShort view will manage showing the
     * listing detail modal. This method is used when this view initially loads and a
     * listing was part of the url. Since we don't want to wait until the entire
     * (unpaginated) store is fetched before showing the listing, we are expecting the
     * the listing model to be passed in as an arg (currently the router is fetching it).
     * The store will continue to load in the background.
     */

  }, {
    key: 'showListing',
    value: function showListing(listing) {
      var _this6 = this;

      if (!listing instanceof _Listing2.default) {
        throw new Error('Please provide a listing model.');
      }

      var onListingDetailClose = function onListingDetailClose() {
        return _app2.default.router.navigate(_this6.model.id + '/store');
      };

      this.listingDetail = new _Listing4.default({
        profile: this.model,
        model: listing
      }).render().open();

      this.listenTo(this.listingDetail, 'close', onListingDetailClose);
      this.listenTo(this.listingDetail, 'modal-will-remove', function () {
        return _this6.stopListening(null, null, onListingDetailClose);
      });
    }
  }, {
    key: 'filteredCollection',
    value: function filteredCollection() {
      var _this7 = this;

      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.filter;
      var collection = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.collection;

      var models = collection.models.filter(function (md) {
        var passesFilter = true;

        if (_this7.filter.freeShipping && !md.shipsFreeToMe) {
          passesFilter = false;
        }

        if (_this7.filter.category !== 'all' && md.get('categories').indexOf(_this7.filter.category) === -1) {
          passesFilter = false;
        }

        var searchTerm = _this7.filter.searchTerm;

        if (searchTerm && md.searchTitle.indexOf(searchTerm) === -1 && md.searchDescription.indexOf(searchTerm) === -1) {
          passesFilter = false;
        }

        if (_this7.filter.shipsTo !== 'any' && !md.shipsTo(_this7.filter.shipsTo)) {
          passesFilter = false;
        }

        return passesFilter;
      });

      return new _Listings2.default(models, { guid: this.model.id });
    }

    /**
     * Based on the sortBy filter, will appropriatally set the
     * comparator value on the given collection.
     */

  }, {
    key: 'setSortFunction',
    value: function setSortFunction(col) {
      if (!col) {
        throw new Error('Please provide a collection.');
      }

      if (this.filter.sortBy) {
        if (this.filter.sortBy === 'PRICE_ASC') {
          col.comparator = function (a, b) {
            if (a.convertedPrice > b.convertedPrice) {
              return 1;
            } else if (a.convertedPrice < b.convertedPrice) {
              return -1;
            }

            return 0;
          };
        } else if (this.filter.sortBy === 'PRICE_DESC') {
          col.comparator = function (a, b) {
            if (a.convertedPrice < b.convertedPrice) {
              return 1;
            } else if (a.convertedPrice > b.convertedPrice) {
              return -1;
            }

            return 0;
          };
        } else if (this.filter.sortBy === 'NAME_ASC') {
          col.comparator = function (a, b) {
            if (a.get('title').toLocaleLowerCase() > b.get('title').toLocaleLowerCase()) {
              return 1;
            } else if (a.get('title').toLocaleLowerCase() < b.get('title').toLocaleLowerCase()) {
              return -1;
            }

            return 0;
          };
        } else if (this.filter.sortBy === 'NAME_DESC') {
          col.comparator = function (a, b) {
            if (a.get('title').toLocaleLowerCase() < b.get('title').toLocaleLowerCase()) {
              return 1;
            } else if (a.get('title').toLocaleLowerCase() > b.get('title').toLocaleLowerCase()) {
              return -1;
            }

            return 0;
          };
        }
      }
    }
  }, {
    key: 'storeListingsScroll',
    value: function storeListingsScroll(paginatedCol, e) {
      // Make sure we're in the DOM (i.e. the store tab is active).
      if (!this.el.parentElement) return;

      // if we've scrolled within a 150px of the bottom
      if (e.target.scrollTop + (0, _jquery2.default)(e.target).innerHeight() >= e.target.scrollHeight - 150) {
        paginatedCol.add(this.fullRenderedCollection.slice(this.storeListings.listingCount, this.storeListings.listingCount + _ListingsGrid.LISTINGS_PER_PAGE));
      }
    }
  }, {
    key: 'renderListings',
    value: function renderListings() {
      var _this8 = this;

      var col = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.fullRenderedCollection;

      if (!col) {
        throw new Error('Please provide a collection.');
      }

      // This collection will be loaded in batches as the
      // user scrolls.
      this.fullRenderedCollection = col;
      this.setSortFunction(col);
      col.sort();

      this.$listingsContainer.empty();
      var listingCount = '<span class="txB">' + _app2.default.polyglot.t('userPage.store.countListings', col.length) + '</span>';
      var fullListingCount = _app2.default.polyglot.t('userPage.store.countListingsFound', { countListings: listingCount });
      this.$listingCount.html(fullListingCount);

      if (col.length) {
        // todo: exceptionally tall screens may fit an entire page
        // with room to spare. Which means no scrollbar, which means subsequent
        // pages will not load. Handle that case.
        var storeListingsCol = new _Listings2.default(col.slice(0, _ListingsGrid.LISTINGS_PER_PAGE), { guid: this.model.id });

        if (this.storeListings) this.storeListings.remove();

        this.storeListings = new _ListingsGrid2.default({
          collection: storeListingsCol,
          storeOwnerProfile: this.model,
          viewType: this.listingsViewType
        });

        (0, _selectors.getContentFrame)().on('scroll', this.storeListingsScrollHandler);
        var scrollHandler = function scrollHandler(e) {
          return _this8.storeListingsScroll.call(_this8, storeListingsCol, e);
        };
        this.storeListingsScrollHandler = _underscore2.default.debounce(scrollHandler, 100);
        (0, _selectors.getContentFrame)().on('scroll', this.storeListingsScrollHandler);

        this.$noResults.addClass('hide');
        this.$listingsContainer.append(this.storeListings.render().el);
      } else {
        this.$noResults.removeClass('hide');
      }
    }
  }, {
    key: 'renderCategories',
    value: function renderCategories() {
      var _this9 = this;

      var cats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.collection.categories;

      if (!this.categoryFilter) {
        this.categoryFilter = new _CategoryFilter2.default({
          initialState: {
            categories: cats,
            selected: this.filter.category
          }
        });

        this.categoryFilter.render();

        this.listenTo(this.categoryFilter, 'category-change', function (e) {
          _this9.filter.category = e.value;
          _this9.renderListings(_this9.filteredCollection());
        });
      } else {
        if (cats.indexOf(this.filter.category) === -1) {
          this.filter.category = 'all';
        }

        this.categoryFilter.setState({
          categories: cats,
          selected: this.filter.category
        });
      }

      if (!this.$catFilterContainer[0].contains(this.categoryFilter.el)) {
        this.categoryFilter.delegateEvents();
        this.$catFilterContainer.empty().append(this.categoryFilter.el);
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      (0, _selectors.getContentFrame)().off('scroll', this.storeListingsScrollHandler);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this10 = this;

      if (this.dataChangePopIn) this.dataChangePopIn.remove();
      if (this.shippingChangePopIn) this.shippingChangePopIn.remove();

      var isFetching = this.fetch && this.fetch.state() === 'pending';
      var fetchFailed = this.fetch && this.fetch.state() === 'rejected' && this.fetch.status !== 404;

      (0, _loadTemplate2.default)('userPage/store.html', function (t) {
        _this10.$el.html(t(_extends({}, _this10.model.toJSON(), {
          isFetching: isFetching,
          fetchFailed: fetchFailed,
          fetchFailReason: fetchFailed && _this10.fetch.responseJSON && _this10.fetch.responseJSON.reason || '',
          filter: _this10.filter,
          countryList: _this10.countryList,
          shipsToSelected: _this10.filter.shipsTo || 'any',
          listingCount: _this10.collection.length
        })));
      });

      this.$sortBy = this.$('.js-sortBySelect');
      this.$shipsToSelect = this.$('.js-shipsToSelect');
      this._$btnRetry = null;
      this._$listingsContainer = null;
      this._$catFilterContainer = null;
      this._$listingCount = null;
      this._$popInMessages = null;
      this._$inactiveWarning = null;
      this._$noResults = null;

      this.$sortBy.select2({
        minimumResultsForSearch: -1,
        dropdownParent: this.$('.js-sortBySelectDropdownContainer')
      });

      this.$shipsToSelect.select2({
        dropdownParent: this.$('.js-shipsToSelectDropdownContainer')
      });

      if (!this.rendered) {
        if (this.options.listing) {
          // if first render, show a listing if it was
          // passed in as a view option
          this.showListing(this.options.listing);
        }

        this.rendered = true;
      }

      if (!isFetching && !fetchFailed) {
        this.renderCategories(this.collection.categories);

        if (this.collection.length) {
          this.renderListings(this.filteredCollection());
        }
      }

      return this;
    }
  }, {
    key: 'listingsViewType',
    get: function get() {
      return this._listingsViewType;
    },
    set: function set(type) {
      if (['list', 'grid'].indexOf(type) === '-1') {
        throw new Error('The type provided is not one of the available types.');
      }

      var prevType = this._listingsViewType;
      this._listingsViewType = type;

      if (prevType) {
        if (prevType !== this._listingsViewType) {
          this.$el.toggleClass('listView');

          if (this.storeListings) {
            this.renderListings(this.fullRenderedCollection);
          }
        }
      } else if (type === 'list') {
        this.$el.addClass('listView');
      }
    }
  }, {
    key: 'tabClass',
    get: function get() {
      return 'store';
    }
  }, {
    key: '$btnRetry',
    get: function get() {
      return this._$btnRetry || (this._$btnRetry = this.$('.js-retryFetch'));
    }
  }, {
    key: '$listingsContainer',
    get: function get() {
      return this._$listingsContainer || (this._$listingsContainer = this.$('.js-listingsContainer'));
    }
  }, {
    key: '$catFilterContainer',
    get: function get() {
      return this._$catFilterContainer || (this._$catFilterContainer = this.$('.js-catFilterContainer'));
    }
  }, {
    key: '$listingCount',
    get: function get() {
      return this._$listingCount || (this._$listingCount = this.$('.js-listingCount'));
    }
  }, {
    key: '$noResults',
    get: function get() {
      return this._$noResults || (this._$noResults = this.$('.js-noResults'));
    }
  }, {
    key: '$popInMessages',
    get: function get() {
      return this._$popInMessages || (this._$popInMessages = this.$('.js-popInMessages'));
    }
  }, {
    key: '$inactiveWarning',
    get: function get() {
      return this._$inactiveWarning || (this._$inactiveWarning = this.$('.js-inactiveWarning'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;