'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _block = require('../utils/block');

var _backbone = require('backbone');

var _ChatHead = require('../models/chat/ChatHead');

var _ChatHead2 = _interopRequireDefault(_ChatHead);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_Collection) {
  _inherits(_class, _Collection);

  function _class() {
    var _ref;

    _classCallCheck(this, _class);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref, [this].concat(args)));

    _this._blockedHeads = {};

    _this.listenTo(_block.events, 'unblocked', function (data) {
      data.peerIds.forEach(function (peerId) {
        if (_this._blockedHeads[peerId]) {
          _this.add(_this._blockedHeads[peerId], { parse: true });
          delete _this._blockedHeads[peerId];
        }
      });
    });

    _this.listenTo(_block.events, 'blocked', function (data) {
      data.peerIds.forEach(function (peerId) {
        var md = _this.get(peerId);

        if (md) {
          _this._blockedHeads[peerId] = md.toJSON();
        }
      });
      _this.remove(data.peerIds);
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/chatconversations');
    }
  }, {
    key: 'model',
    value: function model(attrs, options) {
      return new _ChatHead2.default(attrs, options);
    }
  }, {
    key: 'modelId',
    value: function modelId(attrs) {
      return attrs.peerId;
    }
  }, {
    key: 'comparator',
    value: function comparator(message) {
      return new Date(message.get('timestamp')).getTime() * -1;
    }

    /**
     * Returns an aggregrate count of all the unread count within each chat head.
     */

  }, {
    key: 'parse',
    value: function parse() {
      var _this2 = this;

      var response = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (Array.isArray(response)) {
        // Remove any items from blocked nodes, but keep track of them
        // in case the relevant nodes are unblocked.
        var parsedResponse = response.filter(function (head) {
          if ((0, _block.isBlocked)(head.peerId)) {
            _this2._blockedHeads[head.peerId] = head;
            return false;
          }

          return true;
        });

        return parsedResponse;
      }

      return response;
    }
  }, {
    key: 'totalUnreadCount',
    get: function get() {
      return this.reduce(function (total, md) {
        return total + md.get('unread');
      }, 0);
    }
  }]);

  return _class;
}(_backbone.Collection);

exports.default = _class;