'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _backbone = require('backbone');

var _ListingShort = require('../models/listing/ListingShort');

var _ListingShort2 = _interopRequireDefault(_ListingShort);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_Collection) {
  _inherits(_class, _Collection);

  function _class() {
    var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    if (!options.guid) {
      throw new Error('Please provide a guid.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, models, options));

    _this.guid = options.guid;
    return _this;
  }

  _createClass(_class, [{
    key: 'model',
    value: function model(attrs, options) {
      return new _ListingShort2.default(attrs, options);
    }
  }, {
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/listings/' + this.guid);
    }

    /**
     * Returns a list of the aggregate categories from all
     * the listing in the collection.
     */

  }, {
    key: 'categories',
    get: function get() {
      var cats = [];

      this.models.forEach(function (listing) {
        listing.get('categories').forEach(function (cat) {
          if (cats.indexOf(cat) === -1) cats.push(cat);
        });
      });

      // todo: For now sort will only be accurate for standard ascii
      // characters. In order to properly sort categories with
      // foreign characters, we will need to know what language
      // the listing is in and pass that into localeCompare().
      // https://github.com/OpenBazaar/openbazaar-go/issues/143
      return cats.sort();
    }
  }]);

  return _class;
}(_backbone.Collection);

exports.default = _class;