'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _backbone = require('backbone');

var _backboneLocalStorage = require('../utils/lib/backboneLocalStorage');

var _backboneLocalStorage2 = _interopRequireDefault(_backboneLocalStorage);

var _ServerConfig = require('../models/ServerConfig');

var _ServerConfig2 = _interopRequireDefault(_ServerConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_Collection) {
  _inherits(_class, _Collection);

  _createClass(_class, [{
    key: 'localStorage',
    value: function localStorage() {
      return new _backboneLocalStorage2.default('__serverConfigs');
    }
  }, {
    key: 'sync',
    value: function sync() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _backboneLocalStorage2.default.sync.apply(this, args);
    }
  }, {
    key: 'model',
    value: function model(attrs, options) {
      return new _ServerConfig2.default(attrs, options);
    }
  }]);

  function _class(models, options) {
    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, models, options));

    _this._activeId = localStorage.activeServerConfig;
    _this.on('sync', function () {
      return _this.bindActiveServerChangeHandler();
    });
    return _this;
  }

  /**
   * The "active" server is the server we are currently connected to or if we're not
   * connected to any server, it's the last server we were connected to. When the app is
   * re-started, a connection will automatically be attempted to this server.
   */


  _createClass(_class, [{
    key: 'onActiveServerChange',
    value: function onActiveServerChange(md) {
      this.trigger('activeServerChange', md);
    }
  }, {
    key: 'bindActiveServerChangeHandler',
    value: function bindActiveServerChangeHandler() {
      if (this.activeServer) {
        this.activeServer.off('change', this.onActiveServerChange).on('change', this.onActiveServerChange);
      }
    }
  }, {
    key: 'activeServer',
    get: function get() {
      return this.get(this._activeId);
    },
    set: function set(md) {
      if (!md instanceof _ServerConfig2.default) {
        throw new Error('Please provide a model as a ServerConfig instance.');
      }

      if (this.models.indexOf(md) === -1) {
        throw new Error('The provided model is not in this collection and must be to' + ' set it as the active config.');
      }

      if (!md.id) {
        throw new Error('The provided model must have an id in order to be set as the' + ' active config.');
      }

      if (this._active !== md.id) {
        this._activeId = md.id;
        localStorage.activeServerConfig = md.id;
        this.trigger('activeServerChange', md);
        this.bindActiveServerChangeHandler();
      }
    }
  }]);

  return _class;
}(_backbone.Collection);

exports.default = _class;