'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _backbone = require('backbone');

var _backboneLocalStorage = require('../../utils/lib/backboneLocalStorage');

var _backboneLocalStorage2 = _interopRequireDefault(_backboneLocalStorage);

var _SearchProvider = require('../../models/search/SearchProvider');

var _SearchProvider2 = _interopRequireDefault(_SearchProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_Collection) {
  _inherits(_class, _Collection);

  _createClass(_class, [{
    key: 'localStorage',
    value: function localStorage() {
      return new _backboneLocalStorage2.default('__searchProviders');
    }
  }]);

  function _class(models, options) {
    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, models, options));

    _this._defaultId = localStorage.defaultProvider;
    _this._defaultTorId = localStorage.defaultTorProvider;
    return _this;
  }

  _createClass(_class, [{
    key: 'model',
    value: function model(attrs, options) {
      return new _SearchProvider2.default(attrs, options);
    }
  }, {
    key: 'sync',
    value: function sync() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _backboneLocalStorage2.default.sync.apply(this, args);
    }
  }, {
    key: 'setProvider',
    value: function setProvider(md) {
      var tor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (!md instanceof _SearchProvider2.default) {
        throw new Error('Please provide a model as a Provider instance.');
      }

      if (this.models.indexOf(md) === -1) {
        throw new Error('Only a model in the collection can be set as a provider.');
      }

      var idString = '_default' + (tor ? 'Tor' : '') + 'Id';
      var storageString = 'default' + (tor ? 'Tor' : '') + 'Provider';

      if (this[idString] !== md.id) {
        this[idString] = md.id;
        localStorage[storageString] = md.id;
      }
    }
  }, {
    key: 'maxProviders',
    get: function get() {
      return 8;
    }
  }, {
    key: 'defaultProvider',
    get: function get() {
      return this.get(this._defaultId);
    },
    set: function set(md) {
      this.setProvider(md);
    }
  }, {
    key: 'defaultTorProvider',
    get: function get() {
      return this.get(this._defaultTorId);
    },
    set: function set(md) {
      this.setProvider(md, true);
    }
  }]);

  return _class;
}(_backbone.Collection);

exports.default = _class;