'use strict';

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var slice = [].slice; // https://gist.github.com/fearphage/4341799

_jquery2.default.whenAll = function (array) {
  var resolveValues = arguments.length == 1 && _jquery2.default.isArray(array) ? array : slice.call(arguments),
      length = resolveValues.length,
      remaining = length,
      deferred = _jquery2.default.Deferred(),
      i = 0,
      failed = 0,
      rejectContexts = Array(length),
      rejectValues = Array(length),
      resolveContexts = Array(length),
      value;

  function updateFunc(index, contexts, values) {
    return function () {
      !(values === resolveValues) && failed++;
      deferred.notifyWith(contexts[index] = this, values[index] = slice.call(arguments));
      if (! --remaining) {
        deferred[(!failed ? 'resolve' : 'reject') + 'With'](contexts, values);
      }
    };
  }

  for (; i < length; i++) {
    if ((value = resolveValues[i]) && _jquery2.default.isFunction(value.promise)) {
      value.promise().done(updateFunc(i, resolveContexts, resolveValues)).fail(updateFunc(i, rejectContexts, rejectValues));
    } else {
      deferred.notifyWith(this, value);
      --remaining;
    }
  }

  if (!remaining) {
    deferred.resolveWith(resolveContexts, resolveValues);
  }

  return deferred.promise();
};