'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _electron = require('electron');

var _backboneLocalStorage = require('../utils/lib/backboneLocalStorage');

var _backboneLocalStorage2 = _interopRequireDefault(_backboneLocalStorage);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _cryptoCurrencies = require('../data/cryptoCurrencies');

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('./BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'localStorage',
    value: function localStorage() {
      return new _backboneLocalStorage2.default('__serverConfigs');
    }
  }, {
    key: 'sync',
    value: function sync() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _backboneLocalStorage2.default.sync.apply(this, args);
    }
  }, {
    key: 'defaults',
    value: function defaults() {
      return {
        serverIp: 'localhost',
        port: 4002,
        SSL: false,
        builtIn: false,
        useTor: false,
        confirmedTor: false,
        torProxy: '127.0.0.1:9150',
        dontShowTorExternalLinkWarning: false,
        dismissedDiscoverCallout: false,
        dismissedStoreWelcome: false,
        backupWalletWarned: false,
        torPw: '',
        lastBlockchainResync: ''
      };
    }
  }, {
    key: 'set',
    value: function set(key, val) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      // Handle both `"key", value` and `{key: value}` -style arguments.
      var attrs = void 0;
      var opts = options;

      if ((typeof key === 'undefined' ? 'undefined' : _typeof(key)) === 'object') {
        attrs = key;
        opts = val || {};
      } else {
        (attrs = {})[key] = val;
      }

      var fullAttrs = _extends({}, this.toJSON(), attrs);

      if (fullAttrs.builtIn && typeof attrs.walletCurrency === 'string') {
        attrs.name = _app2.default.polyglot.t('connectionManagement.builtInServerName', { cur: attrs.walletCurrency });
      }

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'set', this).call(this, attrs, opts);
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (!_is_js2.default.existy(attrs.name) || _is_js2.default.empty(attrs.name)) {
        addError('name', _app2.default.polyglot.t('serverConfigModelErrors.provideValue'));
      } else {
        // Slight hack since backbone doesn't document Model.collection and
        // it will only refer to the first collection that a Model belongs.
        // http://stackoverflow.com/a/15962917/632806
        if (this.collection) {
          var models = this.collection.where({ name: attrs.name });
          if (models && models.length && (models.length > 1 || models[0].id !== attrs.id)) {
            addError('name', 'There is already a configuration with that name.');
          }
        }
      }

      if (!_is_js2.default.existy(attrs.serverIp) || _is_js2.default.empty(attrs.serverIp)) {
        addError('serverIp', _app2.default.polyglot.t('serverConfigModelErrors.provideValue'));
      } else {
        if (!_is_js2.default.ip(attrs.serverIp)) {
          addError('serverIp', _app2.default.polyglot.t('serverConfigModelErrors.invalidIp'));
        }
      }

      if (!this.isLocalServer()) {
        if (!attrs.username) {
          addError('username', _app2.default.polyglot.t('serverConfigModelErrors.provideValue'));
        }

        if (!attrs.password) {
          addError('password', _app2.default.polyglot.t('serverConfigModelErrors.provideValue'));
        }
      }

      if (attrs.useTor) {
        if (!attrs.torProxy) {
          addError('torProxy', _app2.default.polyglot.t('serverConfigModelErrors.provideValue'));
        } else if (typeof attrs.torProxy !== 'string') {
          addError('torProxy', 'Please provide the tor proxy configuration as a string.');
        } else {
          var valid = true;
          var split = attrs.torProxy.split(':');

          if (split.length !== 2) {
            valid = false;
          } else {
            if (!_is_js2.default.ip(split[0])) {
              valid = false;
            } else if (!_is_js2.default.within(parseInt(split[1], 10), -1, 65536)) {
              valid = false;
            }
          }

          if (!valid) {
            addError('torProxy', _app2.default.polyglot.t('serverConfigModelErrors.invalidTorProxy'));
          }
        }

        if (!attrs.torPassword && this.isTorPwRequired()) {
          addError('torPassword', _app2.default.polyglot.t('serverConfigModelErrors.provideValue'));
        }
      }

      if (!attrs.builtIn) {
        if (attrs.port === undefined || attrs.port === '') {
          addError('port', _app2.default.polyglot.t('serverConfigModelErrors.provideValue'));
        } else if (!_is_js2.default.number(attrs.port)) {
          addError('port', _app2.default.polyglot.t('serverConfigModelErrors.providePortAsNumber'));
        } else if (!_is_js2.default.within(attrs.port, -1, 65536)) {
          addError('port', _app2.default.polyglot.t('serverConfigModelErrors.provideValidPortRange'));
        }
      } else {
        if (_is_js2.default.existy(attrs.port) && attrs.port !== this.defaults().port) {
          // For now, not allowing the port to be changed on built in servers,
          // since there is currently no way to set the port as an option
          // on the command line, the local bundled server will always be started
          // with the default port.
          addError('port', 'On a built-in server, the port can only be ' + this.defaults().port + '.');
        }

        if (typeof attrs.walletCurrency === 'undefined') {
          addError('walletCurrency', _app2.default.polyglot.t('serverConfigModelErrors.provideWalletCurrency'));
        } else if (!(0, _cryptoCurrencies.getCurrencyByCode)(attrs.walletCurrency)) {
          addError('walletCurrency', attrs.walletCurrency + ' is not a currently supported crypto currency.');
        }

        if (attrs.walletCurrency === 'ZEC' && !attrs.zcashBinaryPath) {
          addError('zcashBinaryPath', _app2.default.polyglot.t('serverConfigModelErrors.provideZcashBinaryPath'));
        }

        if (attrs.zcashBinaryPath) {
          var fsStat = void 0;

          try {
            fsStat = _fs2.default.statSync(attrs.zcashBinaryPath);
          } catch (e) {
            // pass
          }

          if (!fsStat || !fsStat.isFile()) {
            addError('zcashBinaryPath', _app2.default.polyglot.t('serverConfigModelErrors.invalidZcashBinaryPath'));
          }
        }
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'needsAuthentication',


    /**
     * Indicates if we need to authenticate when connecting to this server.
     */
    value: function needsAuthentication() {
      var needsAuth = false;

      if (!this.isLocalServer()) {
        needsAuth = true;
      } else {
        if (this.get('username') || this.get('password')) {
          needsAuth = true;
        }
      }

      return needsAuth;
    }

    /**
     * Based on the ip, indicates whether this is a server running locally on
     * your machine. It may be the local bundled server or it may be a locally
     * run stand-alone server.
     */

  }, {
    key: 'isLocalServer',
    value: function isLocalServer() {
      var ip = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.get('serverIp');

      return ip === 'localhost' || ip === '127.0.0.1';
    }
  }, {
    key: 'isTorPwRequired',
    value: function isTorPwRequired() {
      return ['win', 'darwin'].indexOf(_electron.remote.process.platform) > -1 && this.isLocalServer() && _electron.remote.getGlobal('isBundledApp');
    }
  }, {
    key: 'httpUrl',
    get: function get() {
      var prefix = this.get('SSL') ? 'https' : 'http';
      return prefix + '://' + this.get('serverIp') + ':' + this.get('port') + '/';
    }
  }, {
    key: 'socketUrl',
    get: function get() {
      var prefix = this.get('SSL') ? 'wss' : 'ws';
      return prefix + '://' + this.get('serverIp') + ':' + this.get('port') + '/ws';
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;