'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        title: ''
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};

      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (attrs.title.length > this.max.titleLength) {
        addError('title', 'The title cannot exceed ' + this.max.titleLength + ' characters.');
      }

      if (!attrs.discountCode) {
        addError('discountCode', _app2.default.polyglot.t('couponModelErrors.provideDiscountCode'));
      } else {
        // model.collection is not documented and has at least one quirk, but should work
        // for this case (http://stackoverflow.com/a/15962917/632806)
        if (this.collection) {
          var modelsWithCode = this.collection.where({ discountCode: attrs.discountCode });

          // We'll ensure that the discountCode is unique across the collection and put the error on
          // all the dupes (i.e. not the initial occurence)
          if (modelsWithCode.length > 1 && modelsWithCode[0] !== this) {
            addError('discountCode', _app2.default.polyglot.t('couponModelErrors.needUniqueDiscountCode'));
          }
        }
      }

      if (typeof attrs.percentDiscount === 'undefined' && typeof attrs.priceDiscount === 'undefined') {
        addError('percentDiscount', _app2.default.polyglot.t('couponModelErrors.provideDiscountAmount'));
      } else if (attrs.percentDiscount && attrs.priceDiscount) {
        // This is an internal error. Assuming a reasonable UI, the user should never be able to
        // create such a case.
        addError('percentDiscount', 'Only one of percentDiscount & priceDiscount is allowed.');
      } else if (typeof attrs.percentDiscount !== 'undefined') {
        if (typeof attrs.percentDiscount !== 'number') {
          addError('percentDiscount', _app2.default.polyglot.t('couponModelErrors.provideNumericDiscountAmount'));
        } else if (attrs.percentDiscount <= 0) {
          addError('percentDiscount', _app2.default.polyglot.t('couponModelErrors.percentageLow'));
        } else if (attrs.percentDiscount >= 100) {
          addError('percentDiscount', _app2.default.polyglot.t('couponModelErrors.percentageHigh'));
        }
      } else if (typeof attrs.priceDiscount !== 'undefined') {
        if (typeof attrs.priceDiscount !== 'number') {
          addError('priceDiscount', _app2.default.polyglot.t('couponModelErrors.provideNumericDiscountAmount'));
        } else if (attrs.priceDiscount <= 0) {
          addError('priceDiscount', _app2.default.polyglot.t('couponModelErrors.priceLow'));
        }
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'idAttribute',
    get: function get() {
      return '_clientID';
    }
  }, {
    key: 'max',
    get: function get() {
      return {
        titleLength: 70
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;