'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _currencies = require('../../data/currencies');

var _cryptoListingCurrencies = require('../../data/cryptoListingCurrencies');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        contractType: 'PHYSICAL_GOOD',
        format: 'FIXED_PRICE', // this is not in the design at this time
        // by default, setting to "never" expire (due to a unix bug, the max is before 2038)
        expiry: new Date(2037, 11, 31, 0, 0, 0, 0).toISOString(),
        coinDivisibility: _cryptoListingCurrencies.defaultQuantityBaseUnit
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (!this.contractTypes.includes(attrs.contractType)) {
        addError('contractType', 'The contract type must be one of ' + this.contractTypes + '.');
      }

      if (!this.formats.includes(attrs.format)) {
        addError('format', 'The format must be one of ' + this.formats + '.');
      }

      var firstDayOf2038 = new Date(2038, 0, 1, 0, 0, 0, 0);

      // please provide data as ISO string (or possibly unix timestamp)
      // todo: validate date is provided in the the right format
      if (_is_js2.default.not.inDateRange(new Date(attrs.expiry), new Date(Date.now()), firstDayOf2038)) {
        addError('expiry', 'The expiration date must be between now and the year 2038.');
      }

      if (!attrs.pricingCurrency || !(0, _currencies.getCurrencyByCode)(attrs.pricingCurrency)) {
        addError('pricingCurrency', 'The currency is not one of the available ones.');
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'contractTypes',
    get: function get() {
      return ['PHYSICAL_GOOD', 'DIGITAL_GOOD', 'SERVICE', 'CRYPTOCURRENCY'];
    }
  }, {
    key: 'contractTypesVerbose',
    get: function get() {
      return this.contractTypes.map(function (contractType) {
        return {
          code: contractType,
          name: _app2.default.polyglot.t('formats.' + contractType)
        };
      });
    }
  }, {
    key: 'formats',
    get: function get() {
      return ['FIXED_PRICE', 'MARKET_PRICE'];
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;