'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _Listings = require('../../collections/order/Listings');

var _Listings2 = _interopRequireDefault(_Listings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'parse',
    value: function parse(response) {
      return _extends({}, response, {
        // The parse of the Listing model is expecting the listings to be in objects
        // with a key of 'listing' (e.g. listing: { slug: '', ... }, so we'll accomodate.
        vendorListings: response.vendorListings.map(function (listing) {
          return { listing: listing };
        })
      });
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        vendorListings: _Listings2.default
      };
    }
  }, {
    key: 'type',
    get: function get() {
      return this.get('vendorListings').at(0).get('metadata').get('contractType');
    }
  }, {
    key: 'isLocalPickup',
    get: function get() {
      var buyerOrder = this.get('buyerOrder');

      if (buyerOrder && buyerOrder.items && buyerOrder.items[0] && buyerOrder.items[0].shippingOption) {
        return buyerOrder.items[0].shippingOption.service === '';
      }

      return false;
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;