'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _currency = require('../../utils/currency');

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _Contract = require('./Contract');

var _Contract2 = _interopRequireDefault(_Contract);

var _Transactions = require('../../collections/order/Transactions');

var _Transactions2 = _interopRequireDefault(_Transactions);

var _Transaction = require('../../models/order/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class(attrs, options) {
    _classCallCheck(this, _class);

    var opts = _extends({
      type: 'sale'
    }, options);

    var types = ['sale', 'purchase'];

    if (types.indexOf(opts.type) === -1) {
      throw new Error('Type needs to be one of ' + types + '.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, attrs, opts));

    _this.type = opts.type;
    return _this;
  }

  _createClass(_class, [{
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/order/' + this.id);
    }
  }, {
    key: 'parse',
    value: function parse() {
      var response = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (response.contract) {
        // Since we modify the data on parse (particularly in some nested models),
        // we'll store the original contract here.
        response.rawContract = JSON.parse(JSON.stringify(response.contract)); // deep clone

        // convert price fields
        response.contract.buyerOrder.payment.amount = (0, _currency.integerToDecimal)(response.contract.buyerOrder.payment.amount, _app2.default.serverConfig.cryptoCurrency);

        // convert crypto listing quantities
        response.contract.buyerOrder.items.forEach(function (item, index) {
          var listing = response.contract.vendorListings[index];

          // standardize the quantity field
          item.quantity = item.quantity === 0 ? item.quantity64 : item.quantity;

          if (listing.metadata.contractType === 'CRYPTOCURRENCY') {
            var coinDivisibility = listing.metadata.coinDivisibility;

            item.quantity = item.quantity / coinDivisibility;
          }
        });

        if (response.contract.disputeResolution) {
          response.contract.disputeResolution.payout.buyerOutput = response.contract.disputeResolution.payout.buyerOutput || {};
          response.contract.disputeResolution.payout.vendorOutput = response.contract.disputeResolution.payout.vendorOutput || {};
          response.contract.disputeResolution.payout.moderatorOutput = response.contract.disputeResolution.payout.moderatorOutput || {};

          response.contract.disputeResolution.payout.buyerOutput.amount = (0, _currency.integerToDecimal)(response.contract.disputeResolution.payout.buyerOutput.amount || 0, _app2.default.serverConfig.cryptoCurrency);
          response.contract.disputeResolution.payout.vendorOutput.amount = (0, _currency.integerToDecimal)(response.contract.disputeResolution.payout.vendorOutput.amount || 0, _app2.default.serverConfig.cryptoCurrency);
          response.contract.disputeResolution.payout.moderatorOutput.amount = (0, _currency.integerToDecimal)(response.contract.disputeResolution.payout.moderatorOutput.amount || 0, _app2.default.serverConfig.cryptoCurrency);
        }
      }

      response.paymentAddressTransactions = response.paymentAddressTransactions || [];

      return response;
    }
  }, {
    key: 'idAttribute',
    get: function get() {
      return 'orderId';
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        contract: _Contract2.default,
        paymentAddressTransactions: _Transactions2.default,
        refundAddressTransaction: _Transaction2.default
      };
    }

    /**
     * Returns a boolean indicating whether the vendor had an error when processing
     * the order. This is different from just checking for the PROCESSING_ERROR state,
     * in that it will return true even after the order moves on from that state.
     */

  }, {
    key: 'vendorProcessingError',
    get: function get() {
      var contract = this.get('contract');
      return contract && Array.isArray(contract.get('errors'));
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;