'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    if (typeof options.buyerContractArrived !== 'function') {
      throw new Error('Please provide a function that returns a boolean indicating ' + 'whether the buyer\'s contract is available.');
    }

    if (typeof options.vendorContractArrived !== 'function') {
      throw new Error('Please provide a function that returns a boolean indicating ' + 'whether the vendor\'s contract is available.');
    }

    if (typeof options.vendorProcessingError !== 'function') {
      throw new Error('Please provide a function that returns a boolean indicating ' + 'whether the vendor had an error processing the order.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, attrs, options));

    _this.buyerContractArrived = options.buyerContractArrived;
    _this.vendorContractArrived = options.vendorContractArrived;
    _this.vendorProcessingError = options.vendorProcessingError;
    return _this;
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        resolution: ''
      };
    }
  }, {
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/closedispute/');
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};

      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      var vendorPercentageOk = false;
      var buyerPercentageOk = false;

      if (this.vendorContractArrived() && !this.vendorProcessingError()) {
        if (typeof attrs.vendorPercentage === 'undefined' || attrs.vendorPercentage === '') {
          addError('vendorPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.provideAmount'));
        } else if (typeof attrs.vendorPercentage !== 'number') {
          addError('vendorPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.providePercentageAsNumber'));
        } else if (attrs.vendorPercentage < 0 || attrs.vendorPercentage > 100) {
          addError('vendorPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.percentageOutOfRange'));
        } else if (!this.buyerContractArrived() && attrs.vendorPercentage !== 100) {
          addError('vendorPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.vendorPercentageMustBe100'));
        } else {
          vendorPercentageOk = true;
        }
      } else {
        if (attrs.vendorPercentage !== 0) {
          addError('vendorPercentage', 'The vendor amount must be zero if their contract is not available.');
        }
      }

      if (this.buyerContractArrived()) {
        if (typeof attrs.buyerPercentage === 'undefined' || attrs.buyerPercentage === '') {
          addError('buyerPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.provideAmount'));
        } else if (typeof attrs.buyerPercentage !== 'number') {
          addError('buyerPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.providePercentageAsNumber'));
        } else if (attrs.buyerPercentage < 0 || attrs.buyerPercentage > 100) {
          addError('buyerPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.percentageOutOfRange'));
        } else if (!this.vendorContractArrived() && attrs.buyerPercentage !== 100) {
          addError('buyerPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.buyerPercentageMustBe100'));
        } else {
          buyerPercentageOk = true;
        }
      } else {
        if (attrs.buyerPercentage !== 0) {
          addError('buyerPercentage', 'The buyer amount must be zero if their contract is not available.');
        }
      }

      if (vendorPercentageOk && buyerPercentageOk) {
        if (attrs.buyerPercentage + attrs.vendorPercentage > 100) {
          addError('buyerPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.totalPercentageOutOfRange'));
        } else if (attrs.buyerPercentage + attrs.vendorPercentage < 100) {
          addError('buyerPercentage', _app2.default.polyglot.t('resolveDisputeModelErrors.totalPercentageTooLow'));
        }
      }

      if (!attrs.resolution) {
        addError('resolution', _app2.default.polyglot.t('resolveDisputeModelErrors.provideResolution'));
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'sync',
    value: function sync(method, model, options) {
      if (method === 'create' || method === 'update') {
        options.type = 'POST';
      }

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'sync', this).call(this, method, model, options);
    }
  }, {
    key: 'idAttribute',
    get: function get() {
      return 'orderId';
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;