'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('../../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _PhysicalDelivery = require('./PhysicalDelivery');

var _PhysicalDelivery2 = _interopRequireDefault(_PhysicalDelivery);

var _DigitalDelivery = require('./DigitalDelivery');

var _DigitalDelivery2 = _interopRequireDefault(_DigitalDelivery);

var _CryptoDelivery = require('./CryptoDelivery');

var _CryptoDelivery2 = _interopRequireDefault(_CryptoDelivery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defaults() {
  var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (context.contractType === 'DIGITAL_GOOD') {
    attrs.digitalDelivery = new _DigitalDelivery2.default(attrs.digitalDelivery || {});
  } else if (context.contractType === 'CRYPTOCURRENCY') {
    attrs.cryptocurrencyDelivery = new _CryptoDelivery2.default(attrs.cryptocurrencyDelivery || {});
  } else if (context.contractType === 'PHYSICAL_GOOD' && !context.isLocalPickup) {
    attrs.physicalDelivery = new _PhysicalDelivery2.default(attrs.physicalDelivery || {});
  }

  return attrs;
}

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    if (!options.contractType) {
      throw new Error('Please provide the contract type.');
    }

    if (typeof options.isLocalPickup !== 'boolean') {
      throw new Error('Please provide a boolean indicating whether the item is to ' + 'be picked up locally.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, _defaults(attrs, options), options));

    _this.contractType = options.contractType;
    _this.isLocalPickup = options.isLocalPickup;
    return _this;
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return _defaults({}, this);
    }
  }, {
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/orderfulfillment/');
    }
  }, {
    key: 'validate',
    value: function validate() {
      var errObj = this.mergeInNestedErrors();
      if (Object.keys(errObj).length) return errObj;
      return undefined;
    }
  }, {
    key: 'sync',
    value: function sync(method, model, options) {
      options.attrs = options.attrs || this.toJSON();

      if (method === 'create' || method === 'update') {
        options.type = 'POST';

        // The server is expecting an array for the <type>Delivery object in
        // order to support multiple listings. Since the client and design aren't
        // supporting that at this time, we'll convert to an array here. Once we
        // support it, the nested models should be changed to nested collections.
        if (options.attrs.physicalDelivery) {
          options.attrs.physicalDelivery = [options.attrs.physicalDelivery];
        }

        if (options.attrs.digitalDelivery) {
          options.attrs.digitalDelivery = [options.attrs.digitalDelivery];
        }

        if (options.attrs.cryptocurrencyDelivery) {
          options.attrs.cryptocurrencyDelivery = [options.attrs.cryptocurrencyDelivery];
        }
      }

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'sync', this).call(this, method, model, options);
    }
  }, {
    key: 'idAttribute',
    get: function get() {
      return 'orderId';
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        physicalDelivery: _PhysicalDelivery2.default,
        digitalDelivery: _DigitalDelivery2.default,
        cryptocurrencyDelivery: _CryptoDelivery2.default
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;