'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _FixedFee = require('./FixedFee');

var _FixedFee2 = _interopRequireDefault(_FixedFee);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        feeType: 'PERCENTAGE',
        percentage: 0,
        fixedFee: new _FixedFee2.default()
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = this.mergeInNestedErrors({});
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      var feeTypes = ['PERCENTAGE', 'FIXED', 'FIXED_PLUS_PERCENTAGE'];

      if (attrs.feeType === 'PERCENTAGE') {
        // remove fixed fee errors if the fixed fee isn't needed
        errObj = _underscore2.default.omit(errObj, function (val, key) {
          return key.startsWith('fixedFee');
        });
      }

      // feeType must exist and be one of the valid values
      if (!attrs.feeType || feeTypes.indexOf(attrs.feeType) === -1) {
        addError('feeType', _app2.default.polyglot.t('feeModelErrors.noFeeType'));
      }

      if (attrs.feeType === 'PERCENTAGE' || attrs.feeType === 'FIXED_PLUS_PERCENTAGE') {
        // is the percentage a number?
        if (typeof attrs.percentage !== 'number') {
          addError('feeType', _app2.default.polyglot.t('feeModelErrors.noPercentage'));
        }

        // is the percentage too low?
        if (attrs.percentage < 0) {
          addError('feeType', _app2.default.polyglot.t('feeModelErrors.percentageLow'));
        }

        // is the percentage too high?
        if (attrs.percentage > 100) {
          addError('feeType', _app2.default.polyglot.t('feeModelErrors.percentageHigh'));
        }

        // are there too many decimals? There should be 2 decimal places maximum.
        // move the decimal 2 places, ie 1.01 = 101.0, check if any are after the decimal.
        var decimals = attrs.percentage * 100;
        var integers = Math.trunc(decimals);
        decimals = decimals - integers;

        if (decimals > 0) {
          addError('feeType', _app2.default.polyglot.t('feeModelErrors.percentageDecimals'));
        }
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        fixedFee: _FixedFee2.default
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;