'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _Options = require('../../collections/purchase/Options');

var _Options2 = _interopRequireDefault(_Options);

var _Shipping = require('./Shipping');

var _Shipping2 = _interopRequireDefault(_Shipping);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class(attrs) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, attrs, options));

    _this.shippable = options.shippable || false;
    _this.isCrypto = options.isCrypto || false;
    // If the inventory is for a crypto listing, be sure to convert it from base units
    // before sending it in.
    _this.getInventory = function () {
      return _underscore2.default.result(options, 'inventory', 99999999999999);
    };
    return _this;
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        // the options sub model is optional
        // if the listing is not physical, the shipping sub model should have blank values
        listingHash: '',
        options: new _Options2.default(),
        shipping: new _Shipping2.default(),
        memo: '',
        coupons: [] // just the coupon codes
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = this.mergeInNestedErrors({});
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (attrs.quantity === undefined) {
        addError('quantity', _app2.default.polyglot.t('purchaseItemModelErrors.provideQuantity'));
      }

      if (!this.isCrypto) {
        if (attrs.quantity !== undefined) {
          if (!Number.isInteger(attrs.quantity)) {
            addError('quantity', _app2.default.polyglot.t('purchaseItemModelErrors.quantityMustBeInteger'));
          } else if (attrs.quantity < 1) {
            addError('quantity', _app2.default.polyglot.t('purchaseItemModelErrors.mustHaveQuantity'));
          }
        }

        if (typeof attrs.paymentAddress !== 'undefined') {
          addError('paymentAddress', 'The payment address should only be provide on ' + 'crypto listings');
        }
      } else {
        var inventory = this.getInventory();

        if (attrs.quantity !== undefined) {
          if (typeof attrs.quantity !== 'number') {
            addError('quantity', _app2.default.polyglot.t('purchaseItemModelErrors.quantityMustBeNumeric'));
          } else if (attrs.quantity <= 0) {
            addError('quantity', _app2.default.polyglot.t('purchaseItemModelErrors.quantityMustBePositive'));
          } else if (typeof inventory === 'number' && attrs.quantity > inventory) {
            addError('quantity', _app2.default.polyglot.t('purchaseItemModelErrors.insufficientInventory'));
          }
        }

        if (typeof attrs.paymentAddress !== 'string' || !attrs.paymentAddress) {
          addError('paymentAddress', _app2.default.polyglot.t('purchaseItemModelErrors.providePaymentAddress'));
        } else if (attrs.paymentAddress.length < this.constraints.minPaymentAddressLength || attrs.paymentAddress.length > this.constraints.maxPaymentAddressLength) {
          addError('paymentAddress', _app2.default.polyglot.t('purchaseItemModelErrors.paymentAddressLength', {
            min: this.constraints.minPaymentAddressLength,
            max: this.constraints.maxPaymentAddressLength
          }));
        }
      }

      if (this.shippable && !attrs.shipping.get('name')) {
        addError('shipping', _app2.default.polyglot.t('purchaseItemModelErrors.missingShippingOption'));
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'idAttribute',
    get: function get() {
      return 'listingHash';
    }
  }, {
    key: 'nested',
    get: function get() {
      return {
        options: _Options2.default,
        shipping: _Shipping2.default
      };
    }
  }, {
    key: 'constraints',
    get: function get() {
      return {
        minPaymentAddressLength: 1,
        maxPaymentAddressLength: 256
      };
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;