'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _backboneLocalStorage = require('../../utils/lib/backboneLocalStorage');

var _backboneLocalStorage2 = _interopRequireDefault(_backboneLocalStorage);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        name: '',
        logo: '',
        search: '', // currently not used, this searches vendors and listings
        listings: '',
        torsearch: '', // currently not used, this searches vendors and listings
        torlistings: '',
        locked: false
      };
    }
  }, {
    key: 'localStorage',
    value: function localStorage() {
      return new _backboneLocalStorage2.default('__searchProviders');
    }
  }, {
    key: 'sync',
    value: function sync() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _backboneLocalStorage2.default.sync.apply(this, args);
    }
  }, {
    key: 'validate',
    value: function validate(attrs, options) {
      var errObj = {};
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };
      var urlTypes = options.urlTypes || ['search', 'listings', 'torsearch', 'torlistings'];

      if (attrs.name && _is_js2.default.not.string(attrs.name)) {
        addError('name', _app2.default.polyglot.t('searchProviderModelErrors.invalidName'));
      }

      if (attrs.logo && _is_js2.default.not.url(attrs.logo)) {
        addError('logo', _app2.default.polyglot.t('searchProviderModelErrors.invalidLogo'));
      }

      // a provider can be created with less than all of the urls. The view is expected to retrieve
      // and save the missing urls when the search api is called
      urlTypes.forEach(function (urlType) {
        if (_is_js2.default.not.url(attrs[urlType])) {
          addError(urlType, _app2.default.polyglot.t('searchProviderModelErrors.invalid' + urlType));
        }
      });

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;