'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        notifications: false,
        serverAddress: '',
        username: '',
        password: '',
        senderEmail: '',
        recipientEmail: ''
      };
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = {};
      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (attrs.notifications) {
        if (_is_js2.default.not.url(attrs.serverAddress)) {
          addError('serverAddress', _app2.default.polyglot.t('smtpModelErrors.serverAddress'));
        }
        if (_is_js2.default.empty(attrs.username)) {
          addError('username', _app2.default.polyglot.t('smtpModelErrors.username.caseEmpty'));
        } else if (/\s/.test(attrs.username)) {
          addError('username', _app2.default.polyglot.t('smtpModelErrors.username.noWhitespace'));
        }
        if (_is_js2.default.empty(attrs.password)) {
          addError('password', _app2.default.polyglot.t('smtpModelErrors.password'));
        }
        if (_is_js2.default.not.email(attrs.senderEmail)) {
          addError('senderEmail', _app2.default.polyglot.t('smtpModelErrors.senderEmail'));
        }
        if (_is_js2.default.not.email(attrs.recipientEmail)) {
          addError('recipientEmail', _app2.default.polyglot.t('smtpModelErrors.recipientEmail'));
        }
      } else {
        if (_is_js2.default.not.url(attrs.serverAddress) && _is_js2.default.not.empty(attrs.serverAddress)) {
          addError('serverAddress', _app2.default.polyglot.t('smtpModelErrors.serverAddress'));
        }
        if (/\s/.test(attrs.username) && _is_js2.default.not.empty(attrs.username)) {
          addError('username', _app2.default.polyglot.t('smtpModelErrors.username.noWhitespace'));
        }
        if (_is_js2.default.not.email(attrs.senderEmail) && _is_js2.default.not.empty(attrs.senderEmail)) {
          addError('senderEmail', _app2.default.polyglot.t('smtpModelErrors.senderEmail'));
        }
        if (_is_js2.default.not.email(attrs.recipientEmail) && _is_js2.default.not.empty(attrs.recipientEmail)) {
          addError('recipientEmail', _app2.default.polyglot.t('smtpModelErrors.recipientEmail'));
        }
      }

      if (Object.keys(errObj).length) {
        return errObj;
      }

      return undefined;
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;