'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModel2 = require('../BaseModel');

var _BaseModel3 = _interopRequireDefault(_BaseModel2);

var _ShippingAddresses = require('../../collections/ShippingAddresses');

var _ShippingAddresses2 = _interopRequireDefault(_ShippingAddresses);

var _SMTPSettings = require('./SMTPSettings');

var _SMTPSettings2 = _interopRequireDefault(_SMTPSettings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModel) {
  _inherits(_class, _BaseModel);

  function _class() {
    _classCallCheck(this, _class);

    return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
  }

  _createClass(_class, [{
    key: 'defaults',
    value: function defaults() {
      return {
        paymentDataInQR: false,
        showNotifications: true,
        showNsfw: false,
        localCurrency: 'USD',
        country: 'UNITED_STATES',
        termsAndConditions: '',
        refundPolicy: '',
        blockedNodes: [],
        storeModerators: [],
        shippingAddresses: new _ShippingAddresses2.default(),
        smtpSettings: new _SMTPSettings2.default()
      };
    }
  }, {
    key: 'url',
    value: function url() {
      return _app2.default.getServerUrl('ob/settings/');
    }
  }, {
    key: 'nested',
    value: function nested() {
      return {
        shippingAddresses: _ShippingAddresses2.default,
        smtpSettings: _SMTPSettings2.default
      };
    }
  }, {
    key: 'ownMod',
    value: function ownMod(guid) {
      if (!guid) {
        throw new Error('Please provide a guid.');
      }

      return this.get('storeModerators').indexOf(guid) !== -1;
    }
  }, {
    key: 'validate',
    value: function validate(attrs) {
      var errObj = this.mergeInNestedErrors({});

      var addError = function addError(fieldName, error) {
        errObj[fieldName] = errObj[fieldName] || [];
        errObj[fieldName].push(error);
      };

      if (!_underscore2.default.isArray(attrs.storeModerators)) {
        // this error should never be visible to the user
        addError('storeModerators', 'The storeModerators is invalid because it is not an array');
      }

      if (Object.keys(errObj).length) return errObj;

      return undefined;
    }
  }, {
    key: 'sync',
    value: function sync(method, model, options) {
      if (method === 'create' && typeof options.type === 'undefined') {
        // we will use PUT unless you explicitly save with POST,
        // e.g. model.save({}, { type: 'POST' })
        options.type = 'PUT';
      }

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'sync', this).call(this, method, model, options);
    }
  }, {
    key: 'parse',
    value: function parse() {
      var response = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (Array.isArray(response.blockedNodes)) {
        // de-dupe
        response.blockedNodes = Array.from(new Set(response.blockedNodes));

        // do not allow own node to be in the blocked list
        response.blockedNodes = response.blockedNodes.filter(function (peerId) {
          return peerId !== _app2.default.profile.id;
        });
      }

      return response;
    }
  }, {
    key: 'prettyServerVer',
    get: function get() {
      var sVer = this.get('version');
      return sVer.substring(sVer.lastIndexOf(':') + 1, sVer.lastIndexOf('/'));
    }
  }]);

  return _class;
}(_BaseModel3.default);

exports.default = _class;