'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _electron = require('electron');

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _backbone = require('backbone');

var _backbone2 = _interopRequireDefault(_backbone);

var _nodePolyglot = require('node-polyglot');

var _nodePolyglot2 = _interopRequireDefault(_nodePolyglot);

require('./lib/whenAll.jquery');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _app = require('./app');

var _app2 = _interopRequireDefault(_app);

var _currencies = require('./data/currencies');

var _cryptoCurrencies = require('./data/cryptoCurrencies');

var _ServerConfigs = require('./collections/ServerConfigs');

var _ServerConfigs2 = _interopRequireDefault(_ServerConfigs);

var _ServerConfig = require('./models/ServerConfig');

var _ServerConfig2 = _interopRequireDefault(_ServerConfig);

var _serverConnect = require('./utils/serverConnect');

var _serverConnect2 = _interopRequireDefault(_serverConnect);

var _LocalSettings = require('./models/LocalSettings');

var _LocalSettings2 = _interopRequireDefault(_LocalSettings);

var _router = require('./router');

var _router2 = _interopRequireDefault(_router);

var _selectors = require('./utils/selectors');

var _feedback = require('./utils/feedback');

var _metrics = require('./utils/metrics');

var _autoUpdate = require('./utils/autoUpdate');

var _dom = require('./utils/dom');

var _Chat = require('./views/chat/Chat.js');

var _Chat2 = _interopRequireDefault(_Chat);

var _ChatHeads = require('./collections/ChatHeads');

var _ChatHeads2 = _interopRequireDefault(_ChatHeads);

var _PageNav = require('./views/PageNav.js');

var _PageNav2 = _interopRequireDefault(_PageNav);

var _Loading = require('./views/modals/Loading');

var _Loading2 = _interopRequireDefault(_Loading);

var _StartupConnectMessaging = require('./views/StartupConnectMessaging');

var _StartupConnectMessaging2 = _interopRequireDefault(_StartupConnectMessaging);

var _SimpleMessage = require('./views/modals/SimpleMessage');

var _Dialog = require('./views/modals/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _StatusBar = require('./views/StatusBar');

var _StatusBar2 = _interopRequireDefault(_StatusBar);

var _languages = require('./data/languages');

var _Profile = require('./models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

var _Settings = require('./models/settings/Settings');

var _Settings2 = _interopRequireDefault(_Settings);

var _WalletBalance = require('./models/wallet/WalletBalance');

var _WalletBalance2 = _interopRequireDefault(_WalletBalance);

var _Followers = require('./collections/Followers');

var _Followers2 = _interopRequireDefault(_Followers);

var _currency = require('./utils/currency');

require('./utils/exchangeRateSyncer');

var _modalManager = require('./utils/modalManager');

var _listingDelete = require('./startup/listingDelete');

var _listingDelete2 = _interopRequireDefault(_listingDelete);

var _startup = require('./startup');

var _ConnectionManagement = require('./views/modals/connectionManagement/ConnectionManagement');

var _ConnectionManagement2 = _interopRequireDefault(_ConnectionManagement);

var _Onboarding = require('./views/modals/onboarding/Onboarding');

var _Onboarding2 = _interopRequireDefault(_Onboarding);

var _WalletSetup = require('./views/modals/WalletSetup');

var _WalletSetup2 = _interopRequireDefault(_WalletSetup);

var _SearchProviders = require('./collections/search/SearchProviders');

var _SearchProviders2 = _interopRequireDefault(_SearchProviders);

var _defaultSearchProviders = require('./data/defaultSearchProviders');

var _defaultSearchProviders2 = _interopRequireDefault(_defaultSearchProviders);

var _VerifiedMods = require('./collections/VerifiedMods');

var _VerifiedMods2 = _interopRequireDefault(_VerifiedMods);

var _VerifiedModsFetchError = require('./views/modals/VerifiedModsFetchError');

var _VerifiedModsFetchError2 = _interopRequireDefault(_VerifiedModsFetchError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _startup.fixLinuxZoomIssue)();
(0, _startup.handleServerShutdownRequests)();

_app2.default.localSettings = new _LocalSettings2.default({ id: 1 });
_app2.default.localSettings.fetch().fail(function () {
  return _app2.default.localSettings.save();
});

// initialize language functionality
function getValidLanguage(lang) {
  if ((0, _languages.getTranslationLangByCode)(lang)) {
    return lang;
  }

  return 'en_US';
}

var initialLang = getValidLanguage(_app2.default.localSettings.get('language'));
_app2.default.localSettings.set('language', initialLang);
_moment2.default.locale(initialLang);
_app2.default.polyglot = new _nodePolyglot2.default();
_app2.default.polyglot.extend(require('./languages/' + initialLang + '.json'));

_app2.default.localSettings.on('change:language', function (localSettings, lang) {
  _app2.default.polyglot.extend(require('./languages/' + lang + '.json')); // eslint-disable-line global-require

  _moment2.default.locale(lang);

  var restartLangChangeDialog = new _Dialog2.default({
    title: _app2.default.polyglot.t('langChangeRestartTitle'),
    message: _app2.default.polyglot.t('langChangeRestartMessage'),
    buttons: [{
      text: _app2.default.polyglot.t('restartNow'),
      fragment: 'restartNow'
    }, {
      text: _app2.default.polyglot.t('restartLater'),
      fragment: 'restartLater'
    }]
  }).on('click-restartNow', function () {
    return location.reload();
  }).on('click-restartLater', function () {
    return restartLangChangeDialog.close();
  }).render().open();
});

window.addEventListener('contextmenu', function (e) {
  e.preventDefault();
  _electron.ipcRenderer.send('contextmenu-click');
}, false);

// Instantiating our Server Configs collection now since the page nav
// utilizes it. We'll fetch it later on.
_app2.default.serverConfigs = new _ServerConfigs2.default();

_app2.default.pageNav = new _PageNav2.default({
  serverConfigs: _app2.default.serverConfigs
});
(0, _jquery2.default)('#pageNavContainer').append(_app2.default.pageNav.render().el);

var externalRoute = _electron.remote.getGlobal('externalRoute');

_app2.default.router = new _router2.default();

// Clear the external route flag as soon as it's used so it's not re-used
// on app refreshes.
_app2.default.router.on('route', function () {
  return externalRoute = null;
});

// create our status bar view
_app2.default.statusBar = new _StatusBar2.default();
(0, _jquery2.default)('#statusBar').html(_app2.default.statusBar.render().el);

var startupConnectMessaging = new _StartupConnectMessaging2.default();

// Create loading modal, which is a shared instance used throughout the app
_app2.default.loadingModal = new _Loading2.default({
  dismissOnOverlayClick: false,
  dismissOnEscPress: false,
  showCloseButton: false,
  removeOnRoute: false
}).render().open(startupConnectMessaging);

(0, _dom.handleLinks)(document);

// add the feedback mechanism
(0, _feedback.addFeedback)();

_app2.default.verifiedMods = new _VerifiedMods2.default();

var fetchConfigDeferred = _jquery2.default.Deferred();

function fetchConfig() {
  _jquery2.default.get(_app2.default.getServerUrl('ob/config')).done(function () {
    fetchConfigDeferred.resolve.apply(fetchConfigDeferred, arguments);
  }).fail(function (xhr) {
    var curConn = (0, _serverConnect.getCurrentConnection)();

    if (!curConn || curConn.status === 'disconnected') {
      // the connection management modal should be up with relevant info
      console.error('The server config fetch failed. Looks like the connection to the ' + 'server was lost.');
      return;
    }

    var retryConfigDialog = new _Dialog2.default({
      title: _app2.default.polyglot.t('startUp.dialogs.retryConfig.title'),
      message: xhr && xhr.responseJSON && xhr.responseJSON.reason || xhr.responseText || '',
      buttons: [{
        text: _app2.default.polyglot.t('startUp.dialogs.btnRetry'),
        fragment: 'retry'
      }, {
        text: _app2.default.polyglot.t('startUp.dialogs.btnManageConnections'),
        fragment: 'manageConnections'
      }],
      dismissOnOverlayClick: false,
      dismissOnEscPress: false,
      showCloseButton: false
    }).on('click-retry', function () {
      retryConfigDialog.close();

      // sleight of hand to ensure the loading modal has a chance to at
      // least briefly show before another potential failure
      setTimeout(function () {
        fetchConfig();
      }, 300);
    }).on('click-manageConnections', function () {
      return _app2.default.connectionManagmentModal.open();
    }).render().open();
  });

  return fetchConfigDeferred.promise();
}

var onboardingNeededDeferred = _jquery2.default.Deferred();
var profileFetch = void 0;
var settingsFetch = void 0;
var onboardProfile = false;
var onboardSettings = false;
var profileFailed = void 0;
var settingsFailed = void 0;

function isOnboardingNeeded() {
  profileFetch = !profileFetch || profileFailed ? _app2.default.profile.fetch() : profileFetch;
  settingsFetch = !settingsFetch || settingsFailed ? _app2.default.settings.fetch() : settingsFetch;

  var fetches = [profileFetch, settingsFetch];

  _jquery2.default.whenAll(fetches.slice()).progress(function () {
    var state = arguments.length <= 1 ? undefined : arguments[1];

    if (state !== 'success') {
      var jqXhr = arguments.length <= 0 ? undefined : arguments[0];

      if (jqXhr === profileFetch) {
        if (jqXhr.status === 404) {
          onboardProfile = true;
          profileFailed = false;
        } else {
          profileFailed = true;
        }
      } else if (jqXhr === settingsFetch) {
        if (jqXhr.status === 404) {
          onboardSettings = true;
          settingsFailed = false;
        } else {
          settingsFailed = true;
        }
      }
    }
  }).done(function () {
    onboardingNeededDeferred.resolve(false);
  }).fail(function () {
    var jqXhr = fetches.find(function (fetch) {
      return fetch.state() === 'rejected';
    });

    if (profileFailed || settingsFailed) {
      var retryOnboardingModelsDialog = new _Dialog2.default({
        title: _app2.default.polyglot.t('startUp.dialogs.retryOnboardingFetch.title'),
        message: jqXhr.responseJSON && jqXhr.responseJSON.reason || '',
        buttons: [{
          text: _app2.default.polyglot.t('startUp.dialogs.btnRetry'),
          fragment: 'retry'
        }, {
          text: _app2.default.polyglot.t('startUp.dialogs.btnManageConnections'),
          fragment: 'manageConnections'
        }],
        dismissOnOverlayClick: false,
        dismissOnEscPress: false,
        showCloseButton: false
      }).on('click-retry', function () {
        retryOnboardingModelsDialog.close();

        // slight of hand to ensure the loading modal has a chance to at
        // least briefly show before another potential failure
        setTimeout(function () {
          isOnboardingNeeded();
        }, 300);
      }).on('click-manageConnections', function () {
        return _app2.default.connectionManagmentModal.open();
      }).render().open();
    } else if (onboardProfile || onboardSettings) {
      onboardingNeededDeferred.resolve(true);
    }
  });

  return onboardingNeededDeferred.promise();
}

var onboardDeferred = _jquery2.default.Deferred();

function onboard() {
  var onboarding = new _Onboarding2.default().render().open();

  onboarding.on('onboarding-complete', function () {
    location.hash = '' + _app2.default.profile.id;
    onboardDeferred.resolve();
    onboarding.remove();
  });

  return onboardDeferred.promise();
}

var verifiedModsErrorDialog = void 0;

function fetchVerifiedMods() {
  return _app2.default.verifiedMods.fetch().done(function () {
    if (verifiedModsErrorDialog) verifiedModsErrorDialog.close();
  }).fail(function (jqXhr) {
    var state = {
      fetching: false,
      reason: jqXhr && jqXhr.responseJSON && jqXhr.responseJSON.reason || jqXhr.status
    };
    if (verifiedModsErrorDialog) {
      verifiedModsErrorDialog.setState(state).open();
    } else {
      verifiedModsErrorDialog = new _VerifiedModsFetchError2.default({ initialState: state });
      verifiedModsErrorDialog.on('modal-will-remove', function () {
        verifiedModsErrorDialog = null;
      });
      verifiedModsErrorDialog.on('retry', function () {
        verifiedModsErrorDialog.setState({ fetching: true });
        fetchVerifiedMods();
      });
      verifiedModsErrorDialog.render().open();
    }
  });
}

var fetchStartupDataDeferred = _jquery2.default.Deferred();
var ownFollowingFetch = void 0;
var exchangeRatesFetch = void 0;
var walletBalanceFetch = void 0;
var searchProvidersFetch = void 0;

function fetchStartupData() {
  ownFollowingFetch = !ownFollowingFetch || ownFollowingFetch.state() === 'rejected' ? _app2.default.ownFollowing.fetch() : ownFollowingFetch;
  exchangeRatesFetch = !exchangeRatesFetch || exchangeRatesFetch.state() === 'rejected' ? (0, _currency.fetchExchangeRates)() : exchangeRatesFetch;
  walletBalanceFetch = !walletBalanceFetch || walletBalanceFetch.state() === 'rejected' ? _app2.default.walletBalance.fetch() : walletBalanceFetch;
  searchProvidersFetch = !searchProvidersFetch || searchProvidersFetch.state() === 'rejected' ? _app2.default.searchProviders.fetch() : searchProvidersFetch;

  var fetches = [ownFollowingFetch, exchangeRatesFetch, walletBalanceFetch, searchProvidersFetch];

  _jquery2.default.whenAll(fetches.slice()).done(function () {
    fetchStartupDataDeferred.resolve();
  }).fail(function () {
    var curConn = (0, _serverConnect.getCurrentConnection)();

    if (!curConn || curConn.status !== 'connected') {
      // the connection management modal should be up with relevant info
      console.error('The startup data fetches failed. Looks like the connection to the ' + 'server was lost.');
      return;
    }

    // Find any that failed aside from the exchangeRateFetch. We don't care if the
    // exchange rate fetch failed, because the exchangeRateSyncer will display a
    // status message about it and the app will gracefully handle not having exchange
    // rates.
    var failed = fetches.filter(function (xhr) {
      return xhr.state() === 'rejected' && xhr !== exchangeRatesFetch;
    });

    if (failed.length) {
      var firstFailedXhr = failed[0];
      var title = '';
      var message = firstFailedXhr.responseJSON && firstFailedXhr.responseJSON.reason || firstFailedXhr.status || '';
      var btnText = _app2.default.polyglot.t('startUp.dialogs.btnManageConnections');
      var btnFrag = 'manageConnections';

      if (ownFollowingFetch.state() === 'rejected') {
        title = _app2.default.polyglot.t('startUp.dialogs.unableToGetFollowData.title');
      } else if (walletBalanceFetch.state() === 'rejected') {
        title = _app2.default.polyglot.t('startUp.dialogs.unableToGetWalletBalance.title');
      } else {
        title = _app2.default.polyglot.t('startUp.dialogs.unableToGetSearchProviders.title');
        btnText = _app2.default.polyglot.t('startUp.dialogs.unableToGetSearchProviders.btnClose');
        btnFrag = 'continue';
      }

      var retryFetchStartupDataDialog = new _Dialog2.default({
        title: title,
        message: message,
        buttons: [{
          text: _app2.default.polyglot.t('startUp.dialogs.btnRetry'),
          fragment: 'retry'
        }, {
          text: btnText,
          fragment: btnFrag
        }],
        dismissOnOverlayClick: false,
        dismissOnEscPress: false,
        showCloseButton: false
      }).on('click-retry', function () {
        retryFetchStartupDataDialog.close();

        // slight of hand to ensure the loading modal has a chance to at
        // least briefly show before another potential failure
        setTimeout(function () {
          return fetchStartupData();
        }, 300);
      }).on('click-manageConnections', function () {
        return _app2.default.connectionManagmentModal.open();
      }).on('click-continue', function () {
        retryFetchStartupDataDialog.close();
        fetchStartupDataDeferred.resolve();
      }).render().open();
    } else {
      fetchStartupDataDeferred.resolve();
    }
  });

  return fetchStartupDataDeferred.promise();
}

var onboardIfNeededDeferred = _jquery2.default.Deferred();

function onboardIfNeeded() {
  isOnboardingNeeded().done(function (onboardingNeeded) {
    if (onboardingNeeded) {
      // let's go onboard
      onboard().done(function () {
        return onboardIfNeededDeferred.resolve();
      });
    } else {
      onboardIfNeededDeferred.resolve();
    }
  });

  return onboardIfNeededDeferred.promise();
}

function isCryptoCurrencySupported(cryptoCurrency) {
  return !!(0, _currencies.getCurrencyByCode)(cryptoCurrency);
}

var ensureValidSettingsCurDeferred = void 0;

function ensureValidSettingsCurrency() {
  if (!ensureValidSettingsCurDeferred) {
    ensureValidSettingsCurDeferred = _jquery2.default.Deferred();
  } else {
    return ensureValidSettingsCurDeferred.promise();
  }

  var settingsCur = _app2.default.settings.get('localCurrency');
  var dialogTitle = _app2.default.polyglot.t('setValidCurDialog.title');
  var settingsLink = '<button class="btnAsLink js-setCurSettings clrTEm">' + ('' + _app2.default.polyglot.t('setValidCurDialog.settingsLink')) + '</button>';
  var dialogBody = function dialogBody(currency) {
    return _app2.default.polyglot.t('setValidCurDialog.body', {
      currency: currency,
      settingsLink: settingsLink
    });
  };

  if (!(0, _currencies.getCurrencyByCode)(settingsCur)) {
    var setValidCurDialog = (0, _SimpleMessage.openSimpleMessage)(dialogTitle, dialogBody(settingsCur), {
      dismissOnEscPress: false,
      showCloseButton: false
    });

    var settingsModal = void 0;

    var bindSetCurSettingsHandler = function bindSetCurSettingsHandler() {
      setValidCurDialog.$('.js-setCurSettings').on('click', function () {
        return settingsModal = (0, _modalManager.launchSettingsModal)({ initialTab: 'General' });
      });
    };

    bindSetCurSettingsHandler();

    var onCurChange = function onCurChange(md, cur) {
      if ((0, _currencies.getCurrencyByCode)(cur)) {
        settingsModal.close();
        setValidCurDialog.close();
        ensureValidSettingsCurDeferred.resolve();
      } else {
        setValidCurDialog.open(dialogTitle, dialogBody(cur));
        bindSetCurSettingsHandler();
        settingsModal.close();
      }
    };

    _app2.default.settings.on('change:localCurrency', onCurChange);
  } else {
    ensureValidSettingsCurDeferred.resolve();
  }

  return ensureValidSettingsCurDeferred.promise();
}

// let's start our flow - do we need onboarding?,
// fetching app-wide models...
function start() {
  fetchConfig().done(function (data) {
    // This is the server config as returned by ob/config. It has nothing to do with
    // app.serverConfigs which is a collection of server configuration data related
    // to connecting with a server. The latter is stored in local storage.
    _app2.default.serverConfig = data || {};

    if (!isCryptoCurrencySupported(_app2.default.serverConfig.cryptoCurrency)) {
      var connectLink = '<button class="btnAsLink js-connect clrTEm">' + ('' + _app2.default.polyglot.t('unsupportedCryptoCurDialog.connectLink')) + '</button>';

      var unsupportedCryptoCurDialog = (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('unsupportedCryptoCurDialog.title'), _app2.default.polyglot.t('unsupportedCryptoCurDialog.body', {
        curCode: _app2.default.serverConfig.cryptoCurrency,
        connectLink: connectLink
      }), {
        dismissOnEscPress: false,
        showCloseButton: false
      });

      unsupportedCryptoCurDialog.$('.js-connect').on('click', function () {
        return _app2.default.connectionManagmentModal.open();
      });

      _serverConnect.events.once('connected', function () {
        return unsupportedCryptoCurDialog.remove();
      });

      return;
    }

    _app2.default.profile = new _Profile2.default({ peerID: data.peerID });
    _app2.default.router.onProfileSet();
    _app2.default.settings = new _Settings2.default();

    var curConn = (0, _serverConnect.getCurrentConnection)();

    if (curConn && curConn.status !== 'disconnected') {
      _app2.default.pageNav.torIndicatorOn = _app2.default.serverConfig.tor && curConn.server.get('useTor');

      var serverCur = (0, _cryptoCurrencies.getServerCurrency)();

      if (serverCur.code === 'ZEC') {
        startupConnectMessaging.setState({
          msg: _app2.default.polyglot.t('startUp.connectMessaging.zecBinaryInit', {
            cancelLink: '<a class="js-cancel">' + (_app2.default.polyglot.t('startUp.connectMessaging.cancelLink') + '</a>')
          })
        });
      }
    }

    _app2.default.ownFollowing = new _Followers2.default([], {
      type: 'following',
      peerId: _app2.default.profile.id
    });

    _app2.default.walletBalance = new _WalletBalance2.default();
    _app2.default.searchProviders = new _SearchProviders2.default();

    onboardIfNeeded().done(function () {
      fetchStartupData().done(function () {
        ensureValidSettingsCurrency().done(function () {
          _app2.default.pageNav.navigable = true;
          _app2.default.pageNav.setAppProfile();
          _app2.default.loadingModal.close();

          // add the default search providers
          _app2.default.searchProviders.add(_defaultSearchProviders2.default, { at: 0 });

          if (_app2.default.localSettings.get('shareMetrics')) (0, _metrics.addMetrics)();

          if (externalRoute) {
            // handle opening the app from an an external ob link
            location.hash = '#' + externalRoute;
          } else if (!location.hash) {
            // If for some reason the route to start on is empty, we'll change it to be
            // the user's profile.
            var href = location.href.replace(/(javascript:|#).*$/, '');
            location.replace(href + '#' + _app2.default.profile.id);
          } else if (curConn.server && curConn.server.id !== localStorage.serverIdAtLastStart) {
            // When switching servers, we'll land on the user page of the new node
            location.hash = '#' + _app2.default.profile.id;
          }

          localStorage.serverIdAtLastStart = curConn && curConn.server && curConn.server.id;

          if (_app2.default.localSettings.get('shareMetrics') === undefined) {
            (0, _metrics.showMetricsModal)({
              showCloseButton: false,
              dismissOnEscPress: false,
              showUndecided: true
            }).on('close', function () {
              return _backbone2.default.history.start();
            });
          } else {
            _backbone2.default.history.start();
          }

          // load chat
          var chatConvos = new _ChatHeads2.default();

          chatConvos.once('request', function (cl, xhr) {
            xhr.always(function () {
              return _app2.default.chat.attach((0, _selectors.getChatContainer)());
            });
          });

          _app2.default.chat = new _Chat2.default({
            collection: chatConvos,
            $scrollContainer: (0, _selectors.getChatContainer)()
          });

          chatConvos.fetch();
          (0, _jquery2.default)('#chatCloseBtn').on('click', function () {
            return _app2.default.chat.close();
          });

          (0, _selectors.getChatContainer)().on('mouseenter', function () {
            return (0, _selectors.getBody)().addClass('chatHover');
          }).on('mouseleave', function () {
            return (0, _selectors.getBody)().removeClass('chatHover');
          });

          fetchVerifiedMods();
          setInterval(function () {
            return fetchVerifiedMods();
          }, 1000 * 60 * 60);

          // have our walletBalance model update from the walletUpdate socket event
          var serverSocket = (0, _serverConnect.getSocket)();

          if (serverSocket) {
            serverSocket.on('message', function () {
              var e = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

              if (e.jsonData.walletUpdate) {
                var parsedData = _app2.default.walletBalance.parse({
                  confirmed: e.jsonData.walletUpdate.confirmed,
                  unconfirmed: e.jsonData.walletUpdate.unconfirmed
                });

                _app2.default.walletBalance.set(parsedData);
              }
            });
          }
        });
      });
    });
  });
}

function connectToServer() {
  var server = _app2.default.serverConfigs.activeServer;
  var connectAttempt = null;

  startupConnectMessaging.setState({
    msg: _app2.default.polyglot.t('startUp.connectMessaging.connectAttemptMsg', {
      serverName: server.get('name'),
      cancelLink: '<a class="js-cancel">' + (_app2.default.polyglot.t('startUp.connectMessaging.cancelLink') + '</a>')
    })
  }).on('clickCancel', function () {
    connectAttempt.cancel();
    _app2.default.connectionManagmentModal.open();
    _app2.default.loadingModal.close();
  });

  connectAttempt = (0, _serverConnect2.default)(_app2.default.serverConfigs.activeServer).done(function () {
    return start();
  }).fail(function () {
    _app2.default.connectionManagmentModal.open();
    _app2.default.loadingModal.close();
    _serverConnect.events.once('connected', function () {
      startupConnectMessaging.setState({ msg: '' });
      _app2.default.loadingModal.open(startupConnectMessaging);
      start();
    });
  });
}

// Handle a server connection event.
var connectedAtLeastOnce = false;

_serverConnect.events.on('connected', function () {
  _app2.default.connectionManagmentModal.setModalOptions({
    dismissOnEscPress: true,
    showCloseButton: true
  });

  if (connectedAtLeastOnce) {
    location.reload();
  } else {
    connectedAtLeastOnce = true;
    _app2.default.connectionManagmentModal.close();
    if (_app2.default.chat) _app2.default.chat.show();
  }
});

// Handle a lost connection.
_serverConnect.events.on('disconnected', function () {
  _app2.default.connectionManagmentModal.setModalOptions({
    dismissOnOverlayClick: false,
    dismissOnEscPress: false,
    showCloseButton: false
  });

  if (_app2.default.chat) {
    _app2.default.chat.close();
    _app2.default.chat.hide();
  }

  _app2.default.pageNav.navigable = false;
  _app2.default.connectionManagmentModal.open();
});

// If we have a connection, close the Connection Management modal on a
// will-route event.
var onWillRouteCloseConnModal = function onWillRouteCloseConnModal() {
  return _app2.default.connectionManagmentModal.close();
};
_serverConnect.events.on('connected', function () {
  return _app2.default.router.on('will-route', onWillRouteCloseConnModal);
});
_serverConnect.events.on('disconnected', function () {
  return _app2.default.router.off('will-route', onWillRouteCloseConnModal);
});

var sendMainActiveServer = function sendMainActiveServer(activeServer) {
  _electron.ipcRenderer.send('active-server-set', _extends({}, activeServer.toJSON(), {
    httpUrl: activeServer.httpUrl,
    socketUrl: activeServer.socketUrl,
    authenticate: activeServer.needsAuthentication()
  }));
};

// Alert the main process if we are changing the active server.
_app2.default.serverConfigs.on('activeServerChange', function (activeServer) {
  return sendMainActiveServer(activeServer);
});

// Let's create our Connection Management modal so that it's
// available to show when needed.
_app2.default.connectionManagmentModal = new _ConnectionManagement2.default({
  removeOnRoute: false,
  dismissOnOverlayClick: false,
  dismissOnEscPress: false,
  showCloseButton: false
}).render();

/**
 * If the provided server requires a wallet setup, the Wallet Setup modal will be launched.
 * The function returns a promise that resolves when the process is complete.
 */
function setupWallet(server) {
  var deferred = _jquery2.default.Deferred();

  if (server && server.get('builtIn') && server.get('walletCurrency') === undefined) {
    new _WalletSetup2.default({ model: server }).render().open().on('walletSetupComplete', function () {
      return deferred.resolve();
    });
  } else {
    deferred.resolve();
  }

  return deferred.promise();
}

// get the saved server configurations
_app2.default.serverConfigs.fetch().done(function () {
  // Migrate any old "built in" configurations containing the 'default' flag to
  // use the new 'builtIn' flag.
  _app2.default.serverConfigs.forEach(function (serverConfig) {
    var isDefault = serverConfig.get('default');
    serverConfig.unset('default');
    var data = {};

    if (typeof isDefault === 'boolean') {
      data.walletCurrency = 'BTC';
      data.builtIn = !!isDefault;
    }

    var configSave = serverConfig.save(data);

    if (!configSave) {
      // developer error or wonky data
      console.error('There was an error migrating the server config, ' + (serverConfig.get('name') + ', from the \'default\' to the \'built-in\' style.'));
    }
  });

  var isBundled = _electron.remote.getGlobal('isBundledApp');
  if (!_app2.default.serverConfigs.length) {
    // no saved server configurations
    if (isBundled) {
      // for a bundled app, we'll create a
      // "default" one and try to connect
      var defaultConfig = new _ServerConfig2.default({
        builtIn: true
      });

      setupWallet(defaultConfig).done(function () {
        _app2.default.serverConfigs.add(defaultConfig);
        _app2.default.serverConfigs.activeServer = defaultConfig;
        connectToServer();
      });
    } else {
      _app2.default.connectionManagmentModal.open();
      _serverConnect.events.once('connected', function () {
        _app2.default.loadingModal.open();
        start();
      });
    }
  } else {
    var activeServer = _app2.default.serverConfigs.activeServer;

    if (activeServer) {
      sendMainActiveServer(activeServer);
    } else {
      activeServer = _app2.default.serverConfigs.activeServer = _app2.default.serverConfigs.at(0);
    }

    if (activeServer.get('builtIn') && !_electron.remote.getGlobal('isBundledApp')) {
      // Your active server is the locally bundled server, but you're
      // not running the bundled app. You have bad data!
      activeServer.set('builtIn', false);
    }

    setupWallet(activeServer).done(function () {
      return connectToServer();
    });
  }
});

// Clear localServer events on browser refresh.
(0, _jquery2.default)(window).on('beforeunload', function () {
  var localServer = _electron.remote.getGlobal('localServer');

  if (localServer) {
    // Since on a refresh any browser variables go away,
    // we need to unbind our handlers from the localServer instance.
    // Otherwise, since that instance lives in the main process
    // and continues to live beyond a refresg, the app would crash
    // when a localServer event is triggered for any of those handlers.
    localServer.off();

    // Let the main process know we've just blown away all the handlers,
    // since some of them may be main process callbacks that the main
    // process may want to revive.
    _electron.ipcRenderer.send('renderer-cleared-local-server-events');
  }
});

// Handle 'show debug log' requests from the main process.
_electron.ipcRenderer.on('show-server-log', function () {
  return (0, _modalManager.launchDebugLogModal)();
});

// Handle update events from main.js
_electron.ipcRenderer.on('updateChecking', function () {
  return (0, _autoUpdate.showUpdateStatus)(_app2.default.polyglot.t('update.checking'));
});
_electron.ipcRenderer.on('updateAvailable', function () {
  return (0, _autoUpdate.showUpdateStatus)(_app2.default.polyglot.t('update.available'));
});
_electron.ipcRenderer.on('updateNotAvailable', function () {
  return (0, _autoUpdate.showUpdateStatus)(_app2.default.polyglot.t('update.notAvailable'));
});
_electron.ipcRenderer.on('updateError', function (e, msg) {
  return (0, _autoUpdate.showUpdateStatus)(_app2.default.polyglot.t('update.error', { error: msg }), 'warning');
});
_electron.ipcRenderer.on('updateReadyForInstall', function (e, opts) {
  return (0, _autoUpdate.updateReady)(opts);
});

// Allow main.js to send messages to the console
_electron.ipcRenderer.on('consoleMsg', function (e, msg) {
  return console.log(msg);
});

// manage publishing sockets
var publishingStatusMsg = void 0;
var publishingStatusMsgRemoveTimer = void 0;
var retryPublishTimeout = void 0;

function setPublishingStatus(msg) {
  if (!msg && (typeof msg === 'undefined' ? 'undefined' : _typeof(msg)) !== 'object') {
    throw new Error('Please provide a msg as an object.');
  }

  msg.duration = 99999999999999;
  clearTimeout(retryPublishTimeout);

  if (!publishingStatusMsg) {
    publishingStatusMsg = _app2.default.statusBar.pushMessage(_extends({}, msg));
    publishingStatusMsg.on('clickRetry', function () {
      setPublishingStatus({
        msg: _app2.default.polyglot.t('publish.statusPublishing'),
        type: 'message'
      });

      // some fake latency so if the rety fails immediately, the UI has a chance
      // to update
      clearTimeout(retryPublishTimeout);
      retryPublishTimeout = setTimeout(function () {
        _jquery2.default.post(_app2.default.getServerUrl('ob/publish')).fail(function (jqXhr) {
          setPublishingStatus({
            msg: _app2.default.polyglot.t('publish.statusPublishFailed', {
              retryLink: '<a class="js-retry">' + _app2.default.polyglot.t('publish.retryLink') + '</a>'
            }),
            type: 'warning'
          });

          var failReason = jqXhr.responseJSON && jqXhr.responseJSON.reason || '';
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('publish.failedRetryTitle'), failReason);
        });
      }, 500);
    });
  } else {
    clearTimeout(publishingStatusMsgRemoveTimer);
    publishingStatusMsg.update(msg);
  }

  return publishingStatusMsg;
}

_serverConnect.events.on('connected', function (connectedEvent) {
  connectedEvent.socket.on('message', function (e) {
    if (e.jsonData) {
      if (e.jsonData.status === 'publishing') {
        setPublishingStatus({
          msg: _app2.default.polyglot.t('publish.statusPublishing'),
          type: 'message'
        });
      } else if (e.jsonData.status === 'error publishing') {
        setPublishingStatus({
          msg: _app2.default.polyglot.t('publish.statusPublishFailed', {
            retryLink: '<a class="js-retry">' + _app2.default.polyglot.t('publish.retryLink') + '</a>'
          }),
          type: 'warning'
        });
      } else if (e.jsonData.status === 'publish complete') {
        setPublishingStatus({
          msg: _app2.default.polyglot.t('publish.statusPublishComplete'),
          type: 'message'
        });

        publishingStatusMsgRemoveTimer = setTimeout(function () {
          publishingStatusMsg.remove();
          publishingStatusMsg = null;
        }, 3000);
      }
    }
  });
});

_electron.ipcRenderer.on('close-attempt', function (e) {
  var localServer = _electron.remote.getGlobal('localServer');

  if (localServer && localServer.isRunning) {
    localServer.once('exit', function () {
      return e.sender.send('close-confirmed');
    });
    localServer.stop();
  }

  if (localServer && localServer.isStopping) {
    _app2.default.pageNav.navigable = false;
    (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('localServerShutdownDialog.title'), _app2.default.polyglot.t('localServerShutdownDialog.body'), {
      showCloseButton: false,
      dismissOnEscPress: false
    }).$el.css('z-index', '9999999'); // always on tippity-top
  } else {
    e.sender.send('close-confirmed');
  }
});

// initialize our listing delete handler
(0, _listingDelete2.default)();

if (_electron.remote.getGlobal('isBundledApp')) {
  console.log('%c' + _app2.default.polyglot.t('consoleWarning.heading'), 'color: red; font-weight: bold; font-size: 50px;');
  console.log('%c' + _app2.default.polyglot.t('consoleWarning.line1'), 'color: red;');
  console.log('%c' + _app2.default.polyglot.t('consoleWarning.line2'), 'color: blue;');
}