'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.addFeedback = addFeedback;

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _package = require('../../package.json');

var _metrics = require('./metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Sets the options for the feedback tool
 */

function setFeedbackOptions() {
  var profile = _app2.default.profile ? _app2.default.profile.toJSON() : {};
  var contactInfo = profile.contactInfo || {};
  var sVer = _app2.default.settings && _app2.default.settings.get('version') || '';
  var serverVersion = sVer.substring(sVer.lastIndexOf(':') + 1, sVer.lastIndexOf('/'));

  window.doorbellOptions = {
    appKey: 'lscnduocsmcCDtvh4DCZ4iQhGuCXZy4iexy7bIRa6wa5MFocLkSSutFU3zOii5k8',
    name: profile.name || 'profile data missing',
    properties: _extends({
      settingsReadable: !!_app2.default.settings,
      profileReadable: !!_app2.default.profile,
      peerID: profile.peerID || 'profile data missing',
      clientVersion: _package.version,
      serverVersion: serverVersion,
      contactInfo: contactInfo
    }, (0, _metrics.userStats)())
  };
}

/*
 * Adds the feedback tool to the page.
 */
function addFeedback() {
  if (!window.doorbellOptions) setFeedbackOptions();

  (function (w, d, t) {
    var hasLoaded = false;
    function l() {
      if (hasLoaded) {
        return;
      }
      hasLoaded = true;
      window.doorbellOptions.windowLoaded = true;
      var g = d.createElement(t);
      g.id = 'doorbellScript';
      g.type = 'text/javascript';
      g.async = true;
      g.src = 'https://embed.doorbell.io/button/4990?t=' + new Date().getTime();
      (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(g);
    }
    if (w.attachEvent) {
      w.attachEvent('onload', l);
    } else if (w.addEventListener) {
      w.addEventListener('load', l, false);
    } else {
      l();
    }
    if (d.readyState === 'complete') {
      l();
    }
  })(window, document, 'script');
}