'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.launchEditListingModal = launchEditListingModal;
exports.launchAboutModal = launchAboutModal;
exports.launchSettingsModal = launchSettingsModal;
exports.launchDebugLogModal = launchDebugLogModal;
exports.launchModeratorDetailsModal = launchModeratorDetailsModal;
exports.launchWallet = launchWallet;
exports.getWallet = getWallet;

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _BaseModal = require('../views/modals/BaseModal');

var _Listing = require('../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _About = require('../views/modals/about/About');

var _About2 = _interopRequireDefault(_About);

var _EditListing = require('../views/modals/editListing/EditListing');

var _EditListing2 = _interopRequireDefault(_EditListing);

var _DebugLog = require('../views/modals/DebugLog');

var _DebugLog2 = _interopRequireDefault(_DebugLog);

var _moderatorDetails = require('../views/modals/moderatorDetails');

var _moderatorDetails2 = _interopRequireDefault(_moderatorDetails);

var _Wallet = require('../views/modals/wallet/Wallet');

var _Wallet2 = _interopRequireDefault(_Wallet);

var _Settings = require('../views/modals/Settings/Settings');

var _Settings2 = _interopRequireDefault(_Settings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var aboutModal = void 0;
var settingsModal = void 0;
var debugLogModal = void 0;
var moderatorDetailsModal = void 0;
var _wallet = void 0;

function launchEditListingModal() {
  var modalOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var model = modalOptions.model;
  var openModals = (0, _BaseModal.getOpenModals)();

  if (!(model instanceof _Listing2.default)) {
    throw new Error('In the modalOptions, please provide an instance of ' + 'a Listing model.');
  }

  if (model.isNew()) {
    var createModal = openModals.find(function (modal) {
      return modal instanceof _EditListing2.default && modal.model.isNew();
    });
    if (createModal) {
      createModal.bringToTop();
      return createModal;
    }
  }

  var editListingModal = new _EditListing2.default(modalOptions).render().open();

  return editListingModal;
}

function launchAboutModal() {
  var modalOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  if (aboutModal) {
    aboutModal.bringToTop();
    if (modalOptions.initialTab) aboutModal.selectTab(modalOptions.initialTab);
  } else {
    aboutModal = new _About2.default(_extends({
      removeOnClose: true
    }, modalOptions)).render().open();

    aboutModal.on('modal-will-remove', function () {
      return aboutModal = null;
    });
  }

  return aboutModal;
}

function launchSettingsModal() {
  var modalOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  if (settingsModal) {
    settingsModal.bringToTop();
  } else {
    settingsModal = new _Settings2.default(_extends({
      removeOnClose: true
    }, modalOptions)).render().open();

    settingsModal.on('modal-will-remove', function () {
      return settingsModal = null;
    });
  }

  return settingsModal;
}

function launchDebugLogModal() {
  var modalOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  if (debugLogModal) debugLogModal.remove();

  debugLogModal = new _DebugLog2.default(modalOptions).render().open();

  return debugLogModal;
}

function launchModeratorDetailsModal() {
  var modalOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  if (moderatorDetailsModal) moderatorDetailsModal.remove();

  moderatorDetailsModal = new _moderatorDetails2.default(modalOptions).render().open();

  return moderatorDetailsModal;
}

function launchWallet() {
  var modalOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  if (_wallet) {
    _wallet.open();
  } else {
    _wallet = new _Wallet2.default(_extends({
      removeOnRoute: false
    }, modalOptions)).render().open();

    _app2.default.router.on('will-route', function () {
      return _wallet.close();
    });
  }

  return _wallet;
}

function getWallet() {
  return _wallet;
}