'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _follow = require('../utils/follow');

var _block = require('../utils/block');

var _baseVw2 = require('./baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _loadTemplate = require('../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      fetchFollowsYou: true,
      onClickRating: function onClickRating() {
        return _app2.default.router.navigate('ob://' + options.model.id + '/reputation', { trigger: true });
      }
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    if (!_this.model) {
      throw new Error('Please provide a profile model.');
    }

    _this._state = _extends({
      followsYou: false
    }, options.initialState || {});

    _this._followsYou = false;

    if (_this.model.id === _app2.default.profile.id) {
      _this.listenTo(_app2.default.profile, 'change:name, change:location', function () {
        return _this.render();
      });
      _this.listenTo(_app2.default.profile.get('avatarHashes'), 'change', function () {
        return _this.render();
      });
    } else {
      if (opts.fetchFollowsYou) {
        (0, _follow.followsYou)(_this.model.id).done(function (data) {
          _this.setState({ followsYou: data.followsMe });
        });
      }

      _this.listenTo(_app2.default.ownFollowers, 'add', function (md) {
        if (md.id === _app2.default.profile.id) {
          _this.setState({ followsYou: true });
        }
      });

      _this.listenTo(_app2.default.ownFollowers, 'remove', function (md) {
        if (md.id === _app2.default.profile.id) {
          _this.setState({ followsYou: false });
        }
      });
    }

    _this.listenTo(_block.events, 'blocked unblocked', function (data) {
      if (data.peerIds.includes(_this.model.id)) {
        _this.setBlockedClass();
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'miniprofile';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-rating': 'onClickRating'
      };
    }
  }, {
    key: 'onClickRating',
    value: function onClickRating() {
      this.options.onClickRating();
    }
  }, {
    key: 'setBlockedClass',
    value: function setBlockedClass() {
      this.$el.toggleClass('isBlocked', (0, _block.isBlocked)(this.model.id));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('miniProfile.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2._state, _this2.model.toJSON())));

        _this2.setBlockedClass();
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;