'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _electron = require('electron');

var _utils = require('../utils');

var _serverConnect = require('../utils/serverConnect');

var _notification = require('../utils/notification');

var _backbone = require('backbone');

var _backbone2 = _interopRequireDefault(_backbone);

var _baseVw = require('./baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _loadTemplate = require('../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _modalManager = require('../utils/modalManager');

var _Listing = require('../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _responsive = require('../utils/responsive');

var _PageNavServersMenu = require('./PageNavServersMenu');

var _PageNavServersMenu2 = _interopRequireDefault(_PageNavServersMenu);

var _Notifications = require('../collections/Notifications');

var _Notificiations = require('./notifications/Notificiations');

var _Notificiations2 = _interopRequireDefault(_Notificiations);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class(options) {
    _classCallCheck(this, _class);

    var opts = _extends({
      events: {
        'click .js-navBack': 'navBackClick',
        'click .js-navFwd': 'navFwdClick',
        'click .js-navReload': 'navReload',
        'click .js-navClose': 'navCloseClick',
        'click .js-navMin': 'navMinClick',
        'click .js-navMax': 'navMaxClick',
        'keyup .js-addressBar': 'onKeyupAddressBar',
        'focusin .js-addressBar': 'onFocusInAddressBar',
        'click .js-navListBtn': 'navListBtnClick',
        'click .js-navSettings': 'navSettingsClick',
        'click .js-navHelp': 'navHelpClick',
        'click .js-navAboutModal': 'navAboutClick',
        'click .js-navWalletBtn': 'navWalletClick',
        'click .js-navCreateListing': 'navCreateListingClick',
        'click .js-navListItem': 'onNavListItemClick',
        'click .js-navList': 'onNavListClick',
        'mouseenter .js-connectedServerListItem': 'onMouseEnterConnectedServerListItem',
        'mouseleave .js-connectedServerListItem': 'onMouseLeaveConnectedServerListItem',
        'mouseenter .js-connManagementContainer': 'onMouseEnterConnManagementContainer',
        'mouseleave .js-connManagementContainer': 'onMouseLeaveConnManagementContainer',
        'click .js-navNotifBtn': 'onClickNavNotifBtn',
        'click .js-notifContainer': 'onClickNotifContainer',
        'click .js-notificationListItem a[href]': 'onClickNotificationLink'
      },
      navigable: false
    }, options);

    if (!opts.serverConfigs) {
      throw new Error('Please provide a Server Configs collection');
    }

    opts.className = 'pageNav';
    if (!opts.navigable) opts.className += ' notNavigable';
    if (opts.torIndicatorOn) opts.className += ' torIndicatorOn';

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.addressBarText = '';

    _this.boundOnDocClick = _this.onDocClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundOnDocClick);

    _this.listenTo(_app2.default.localSettings, 'change:windowControlStyle', function (_, style) {
      return _this.setWinControlsStyle(style);
    });
    _this.setWinControlsStyle(_app2.default.localSettings.get('windowControlStyle'));

    _this.listenTo(_serverConnect.events, 'connected', function (e) {
      _this.$connectedServerName.text(e.server.get('name')).addClass('txB');
      _this.listenTo(_app2.default.router, 'route:search', _this.onRouteSearch);
      _this.fetchUnreadNotifCount().done(function (data) {
        _this.unreadNotifCount = (_this.unreadNotifCount || 0) + data.unread;
      });
      _this.listenTo(e.socket, 'message', _this.onSocketMessage);
    });

    _this.listenTo(_serverConnect.events, 'disconnected', function (e) {
      _this.$connectedServerName.text(_app2.default.polyglot.t('pageNav.notConnectedMenuItem')).removeClass('txB');
      _this.torIndicatorOn = false;
      _this.stopListening(_app2.default.router, null, _this.onRouteSearch);
      _this.getCachedEl('.js-notifUnreadBadge').addClass('hide');
      _this.stopListening(e.socket, 'message', _this.onSocketMessage);
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'onSocketMessage',
    value: function onSocketMessage(e) {
      var notif = e.jsonData.notification;

      if (notif) {
        if (notif.type === 'unfollow') return;
        this.unreadNotifCount = (this.unreadNotifCount || 0) + 1;
        (0, _notification.setUnreadNotifCount)(this.unreadNotifCount);

        var notifDisplayData = (0, _Notifications.getNotifDisplayData)(notif, { native: true });
        var nativeNotifData = {
          silent: true,
          onclick: function onclick() {
            _electron.remote.getCurrentWindow().restore();

            if (notifDisplayData.route) {
              location.hash = notifDisplayData.route;
            }
          }
        };

        if (notif.thumbnail) {
          nativeNotifData.icon = _app2.default.getServerUrl('ob/images/' + notif.thumbnail.small);
        }

        (0, _notification.launchNativeNotification)(notifDisplayData.text, nativeNotifData);
      }
    }
  }, {
    key: 'navBackClick',
    value: function navBackClick() {
      window.history.back();
    }
  }, {
    key: 'navFwdClick',
    value: function navFwdClick() {
      window.history.forward();
    }
  }, {
    key: 'navReload',
    value: function navReload() {
      _app2.default.loadingModal.open();

      // Introducing some fake latency to ensure the loading modal has a chance
      // to appear. Otherwise, views that render quickly (e.g. have cached data)
      // load so fast it may look like pressing the refresh button did nothing.
      setTimeout(function () {
        _backbone2.default.history.loadUrl();
      }, 200);
    }
  }, {
    key: 'fetchUnreadNotifCount',
    value: function fetchUnreadNotifCount() {
      if (this.unreadNotifCountFetch) this.unreadNotifCountFetch.abort();

      // We'll send a bogus filter because all we want is the count - we don't
      // want to weight the returned payload down with any notifications. Those
      // will be lazy loaded in when the notif menu is opened.
      return _jquery2.default.get(_app2.default.getServerUrl('ob/notifications?filter=blah-blah'));
    }
  }, {
    key: 'renderUnreadNotifCount',
    value: function renderUnreadNotifCount() {
      this.getCachedEl('.js-notifUnreadBadge').toggleClass('hide', !this.unreadNotifCount).toggleClass('ellipsisShown', this.unreadNotifCount > 99).text(this.unreadNotifCount > 99 ? '…' : this.unreadNotifCount);
    }
  }, {
    key: 'setWinControlsStyle',
    value: function setWinControlsStyle(style) {
      if (style !== 'mac' && style !== 'win') {
        throw new Error('Style must be \'mac\' or \'win\'.');
      }

      this.$el.removeClass('winStyleWindowControls macStyleWindowControls');
      this.$el.addClass(style === 'mac' ? 'macStyleWindowControls' : 'winStyleWindowControls');
    }
  }, {
    key: 'setAppProfile',
    value: function setAppProfile() {
      // when this view is created, the app.profile doesn't exist
      this.listenTo(_app2.default.profile.get('avatarHashes'), 'change', this.updateAvatar);
      this.render();
    }
  }, {
    key: 'updateAvatar',
    value: function updateAvatar() {
      this.$('#AvatarBtn').attr('style', (0, _responsive.getAvatarBgImage)(_app2.default.profile.get('avatarHashes').toJSON()));
    }
  }, {
    key: 'navCloseClick',
    value: function navCloseClick() {
      if (_electron.remote.process.platform !== 'darwin') {
        _electron.remote.getCurrentWindow().close();
      } else {
        _electron.remote.getCurrentWindow().hide();
      }
    }
  }, {
    key: 'navMinClick',
    value: function navMinClick() {
      _electron.remote.getCurrentWindow().minimize();
    }
  }, {
    key: 'navMaxClick',
    value: function navMaxClick() {
      _electron.remote.getCurrentWindow().setFullScreen(!_electron.remote.getCurrentWindow().isFullScreen());
    }
  }, {
    key: 'onRouteSearch',
    value: function onRouteSearch() {
      var connectedServer = (0, _serverConnect.getCurrentConnection)();

      if (connectedServer && connectedServer.server) {
        connectedServer.server.save({ dismissedDiscoverCallout: true });
      }

      this.getCachedEl('.js-discoverCallout').remove();
    }
  }, {
    key: 'onMouseEnterConnectedServerListItem',
    value: function onMouseEnterConnectedServerListItem() {
      this.overConnectedServerListItem = true;
      this.$connManagementContainer.addClass('open');
    }
  }, {
    key: 'onMouseLeaveConnectedServerListItem',
    value: function onMouseLeaveConnectedServerListItem() {
      var _this2 = this;

      this.overConnectedServerListItem = false;

      setTimeout(function () {
        if (!_this2.overConnManagementContainer) {
          _this2.$connManagementContainer.removeClass('open');
        }
      }, 100);
    }
  }, {
    key: 'onMouseEnterConnManagementContainer',
    value: function onMouseEnterConnManagementContainer() {
      this.overConnManagementContainer = true;
    }
  }, {
    key: 'onMouseLeaveConnManagementContainer',
    value: function onMouseLeaveConnManagementContainer() {
      var _this3 = this;

      this.overConnManagementContainer = false;

      setTimeout(function () {
        if (!_this3.overConnectedServerListItem) {
          _this3.$connManagementContainer.removeClass('open');
        }
      }, 100);
    }
  }, {
    key: 'onNavListItemClick',
    value: function onNavListItemClick() {
      var _this4 = this;

      // Set timeout allows the new page to show before the overlay is removed. Otherwise,
      // there's a flicker frmo the old page to the new page.
      setTimeout(function () {
        _this4.closeNavMenu();
      });
    }
  }, {
    key: 'navListBtnClick',
    value: function navListBtnClick(e) {
      this.closeNotifications({
        closeOverlay: false,
        closeNavList: false
      });
      this.toggleNavMenu();
      // do not bubble to onDocClick
      e.stopPropagation();
    }
  }, {
    key: 'toggleNavMenu',
    value: function toggleNavMenu() {
      var isOpen = this.$navList.hasClass('open');
      this.$navList.toggleClass('open', !isOpen);
      this.$navOverlay.toggleClass('open', !isOpen);

      if (!isOpen) {
        this.$connManagementContainer.removeClass('open');
      }
    }
  }, {
    key: 'closeNavMenu',
    value: function closeNavMenu() {
      this.$navList.removeClass('open');
      this.$navOverlay.removeClass('open');
      this.$connManagementContainer.removeClass('open');
    }
  }, {
    key: 'onNavListClick',
    value: function onNavListClick(e) {
      // do not bubble to onDocClick
      e.stopPropagation();
    }
  }, {
    key: 'onClickNavNotifBtn',
    value: function onClickNavNotifBtn(e) {
      this.$navList.removeClass('open');
      this.$connManagementContainer.removeClass('open');
      this.toggleNotifications();
      // do not bubble to onDocClick
      e.stopPropagation();
    }
  }, {
    key: 'isNotificationsOpen',
    value: function isNotificationsOpen() {
      return this.getCachedEl('.js-notifContainer').hasClass('open');
    }
  }, {
    key: 'toggleNotifications',
    value: function toggleNotifications() {
      var _this5 = this;

      if (this.isNotificationsOpen()) {
        this.closeNotifications();
        this.$navOverlay.removeClass('open');
      } else {
        this.$navOverlay.addClass('open');

        // open notifications menu
        if (!this.notifications) {
          this.notifications = new _Notificiations2.default();
          this.getCachedEl('.js-notifContainer').html(this.notifications.render().el);
          this.listenTo(this.notifications, 'notifNavigate', function () {
            return _this5.closeNotifications();
          });
        }

        this.getCachedEl('.js-notifContainer').addClass('open');
      }
    }
  }, {
    key: 'onClickNotifContainer',
    value: function onClickNotifContainer(e) {
      // do not bubble to onDocClick
      e.stopPropagation();
    }
  }, {
    key: 'closeNotifications',
    value: function closeNotifications(options) {
      var _this6 = this;

      var opts = _extends({
        closeOverlay: true,
        closeNavList: true
      }, options);

      if (!this.isNotificationsOpen()) return;
      if (opts.closeNavList) this.$navList.removeClass('open');
      this.getCachedEl('.js-notifContainer').removeClass('open');
      if (opts.closeOverlay) this.$navOverlay.removeClass('open');

      if (this.notifications) {
        var count = this.unreadNotifCount;
        if (this.unreadNotifCount) {
          var markAsRead = this.notifications.markNotifsAsRead();
          if (markAsRead) {
            this.unreadNotifCount = 0;
            markAsRead.fail(function () {
              _this6.unreadNotifCount = (_this6.unreadNotifCount || 0) + count;
            });
          }
        }

        this.notifications.reset();
      }
    }
  }, {
    key: 'onClickNotificationLink',
    value: function onClickNotificationLink() {
      this.closeNotifications();
    }
  }, {
    key: 'onDocClick',
    value: function onDocClick() {
      this.closeNotifications();
      this.closeNavMenu();
    }
  }, {
    key: 'onFocusInAddressBar',
    value: function onFocusInAddressBar() {
      this.$addressBar.select();
    }
  }, {
    key: 'onKeyupAddressBar',
    value: function onKeyupAddressBar(e) {
      if (e.which === 13) {
        var text = this.$addressBar.val().trim();
        this.$addressBar.val(text);

        var firstTerm = text.startsWith('ob://') ? text.slice(5).split(' ')[0].split('/')[0] : text.split(' ')[0].split('/')[0];

        if ((0, _utils.isMultihash)(firstTerm)) {
          _app2.default.router.navigate(text.split(' ')[0], { trigger: true });
        } else if (firstTerm.charAt(0) === '@' && firstTerm.length > 1) {
          // a handle
          _app2.default.router.navigate(text.split(' ')[0], { trigger: true });
        } else if (text.startsWith('ob://')) {
          // trying to show a specific page
          _app2.default.router.navigate(text.split(' ')[0], { trigger: true });
        } else {
          // searching term
          _app2.default.router.navigate('search?q=' + encodeURIComponent(text), { trigger: true });
        }
      }
    }
  }, {
    key: 'setAddressBar',
    value: function setAddressBar() {
      var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      if (this.$addressBar) {
        this.addressBarText = text;
        this.$addressBar.val(text);
      }
    }
  }, {
    key: 'navSettingsClick',
    value: function navSettingsClick() {
      (0, _modalManager.launchSettingsModal)();
    }
  }, {
    key: 'navHelpClick',
    value: function navHelpClick() {
      (0, _modalManager.launchAboutModal)({ initialTab: 'Help' });
      this.closeNavMenu();
    }
  }, {
    key: 'navAboutClick',
    value: function navAboutClick() {
      (0, _modalManager.launchAboutModal)({ initialTab: 'Story' });
      this.closeNavMenu();
    }
  }, {
    key: 'navWalletClick',
    value: function navWalletClick() {
      (0, _modalManager.launchWallet)();
    }
  }, {
    key: 'navCreateListingClick',
    value: function navCreateListingClick() {
      var listingModel = new _Listing2.default({}, { guid: _app2.default.profile.id });

      (0, _modalManager.launchEditListingModal)({
        model: listingModel
      });
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.unreadNotifCountFetch) this.unreadNotifCountFetch.abort();
      (0, _jquery2.default)(document).off('click', this.boundOnDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this7 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      var connectedServer = (0, _serverConnect.getCurrentConnection)();

      if (connectedServer && connectedServer.status !== 'disconnected') {
        connectedServer = connectedServer.server.toJSON();
      } else {
        connectedServer = null;
      }

      var showDiscoverCallout = false;

      if (connectedServer && !connectedServer.dismissedDiscoverCallout) {
        showDiscoverCallout = true;
      }

      (0, _loadTemplate2.default)('pageNav.html', function (t) {
        (0, _loadTemplate2.default)('walletIcon.svg', function (walletIconTmpl) {
          _this7.$el.html(t(_extends({
            addressBarText: _this7.addressBarText,
            connectedServer: connectedServer,
            testnet: _app2.default.serverConfig.testnet,
            walletIconTmpl: walletIconTmpl,
            showDiscoverCallout: showDiscoverCallout
          }, _app2.default.profile && _app2.default.profile.toJSON() || {})));
        });
      });

      if (this.pageNavServersMenu) this.pageNavServersMenu.remove();
      this.pageNavServersMenu = new _PageNavServersMenu2.default({
        collection: _app2.default.serverConfigs
      });
      this.$('.js-connManagementContainer').append(this.pageNavServersMenu.render().el);

      this.$addressBar = this.$('.js-addressBar');
      this.$navList = this.$('.js-navList');
      this.$navOverlay = this.$('.js-navOverlay');
      this.$connectedServerName = this.$('.js-connectedServerName');
      this.$connManagementContainer = this.$('.js-connManagementContainer');

      this.renderUnreadNotifCount();

      return this;
    }
  }, {
    key: 'navigable',
    get: function get() {
      return this.options.navigable;
    },
    set: function set(navigable) {
      var prevNavigable = this.options.navigable;

      this.options.navigable = !!navigable;

      if (this.options.navigable !== prevNavigable) {
        if (this.options.navigable) {
          this.$el.removeClass('notNavigable');
        } else {
          this.$el.addClass('notNavigable');
        }
      }
    }
  }, {
    key: 'torIndicatorOn',
    get: function get() {
      return this.options.torIndicatorOn;
    },
    set: function set(bool) {
      if (this.options.torIndicatorOn !== bool) {
        this.options.torIndicatorOn = bool;
        this.$el.toggleClass('torIndicatorOn', bool);
      }
    }
  }, {
    key: 'unreadNotifCount',
    get: function get() {
      return this._unreadNotifCount;
    },
    set: function set(count) {
      if (typeof count !== 'number') {
        throw new Error('Please provide a count as a number.');
      }

      if (count === this._unreadNotifCount) return;
      this._unreadNotifCount = count;
      this.renderUnreadNotifCount();
      (0, _notification.setUnreadNotifCount)(this.unreadNotifCount);
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;