'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _serverConnect = require('../utils/serverConnect');

var _serverConnect2 = _interopRequireDefault(_serverConnect);

var _loadTemplate = require('../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('./baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a server configurations collection.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    var connectedServer = (0, _serverConnect.getCurrentConnection)();

    if (connectedServer && connectedServer.status !== 'disconnected') {
      connectedServer = connectedServer.server.id;
    } else {
      connectedServer = null;
    }

    _this._state = _extends({
      connectedServer: connectedServer
    }, options.initialState || {});

    _this.listenTo(_this.collection, 'update', _this.render);

    _this.listenTo(_serverConnect.events, 'disconnected', function () {
      return _this.setState({
        connectedServer: null
      });
    });

    _this.listenTo(_serverConnect.events, 'connected', function (e) {
      return _this.setState({
        connectedServer: e.server.id
      });
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'listBox clrBr clrP clrSh1';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-serverListItem': 'onServerClick',
        'click .js-newServer': 'onNewServerClick',
        'click .js-manageServers': 'onManageServersClick'
      };
    }
  }, {
    key: 'onServerClick',
    value: function onServerClick(e) {
      var serverId = (0, _jquery2.default)(e.target).closest('.js-serverListItem').data('server-id');

      var server = this.collection.get(serverId);

      (0, _serverConnect2.default)(server);
      _app2.default.connectionManagmentModal.open();
    }
  }, {
    key: 'onNewServerClick',
    value: function onNewServerClick() {
      _app2.default.connectionManagmentModal.selectTab('ConfigForm');
      _app2.default.connectionManagmentModal.open();
    }
  }, {
    key: 'onManageServersClick',
    value: function onManageServersClick() {
      _app2.default.connectionManagmentModal.open();
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('pageNavServersMenu.html', function (t) {
        _this2.$el.html(t(_extends({
          servers: _this2.collection.toJSON()
        }, _this2._state)));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;