'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _baseVw = require('./baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _loadTemplate = require('../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _app = require('../app');

var _app2 = _interopRequireDefault(_app);

var _follow = require('../utils/follow');

var _Profile = require('../models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

var _block = require('../utils/block');

var _modalManager = require('../utils/modalManager');

var _SimpleMessage = require('./modals/SimpleMessage');

var _VerifiedMod = require('./components/VerifiedMod');

var _VerifiedMod2 = _interopRequireDefault(_VerifiedMod);

var _BlockBtn = require('./components/BlockBtn');

var _BlockBtn2 = _interopRequireDefault(_BlockBtn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    if (_this.model instanceof _Profile2.default) {
      _this.guid = _this.model.id;
      _this.fetched = true;
    } else {
      _this.guid = options.guid;
      _this.fetched = false;
    }

    if (!_this.guid) {
      if (_this.model) {
        throw new Error('The guid must be provided in the model.');
      } else {
        throw new Error('The guid must be provided in the options.');
      }
    }

    _this.ownGuid = _this.guid === _app2.default.profile.id;
    _this.followedByYou = (0, _follow.followedByYou)(_this.guid);

    _this.loading = !_this.fetched;
    _this.settings = _app2.default.settings.clone();

    _this.listenTo(_this.settings, 'sync', function () {
      _app2.default.settings.set(_this.settings.toJSON());
    });

    _this.listenTo(_app2.default.settings, 'change:storeModerators', function () {
      _this.$modBtn.toggleClass('active', _this.ownMod);
      _this.$modBtn.attr('data-tip', _this.getModTip());
    });

    _this.listenTo(_app2.default.ownFollowing, 'update', function (cl, updateOpts) {
      var updatedModels = updateOpts.changes.added.concat(updateOpts.changes.removed);

      if (updatedModels.filter(function (md) {
        return md.id === _this.guid;
      }).length) {
        _this.followedByYou = (0, _follow.followedByYou)(_this.guid);
        _this.$followBtn.toggleClass('active', _this.followedByYou);
        _this.$followBtn.attr('data-tip', _this.getFollowTip());
      }
    });

    _this.listenTo(_block.events, 'blocked unblocked', function (data) {
      if (data.peerIds.includes(_this.guid)) {
        _this.setBlockedClass();
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'getModTip',
    value: function getModTip() {
      var ownMod = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.ownMod;

      return ownMod ? '' + _app2.default.polyglot.t('userShort.tipModRemove') : '' + _app2.default.polyglot.t('userShort.tipModAdd');
    }
  }, {
    key: 'getFollowTip',
    value: function getFollowTip() {
      var isFollowedByYou = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.followedByYou;

      return isFollowedByYou ? '' + _app2.default.polyglot.t('userShort.tipUnfollow') : '' + _app2.default.polyglot.t('userShort.tipFollow');
    }
  }, {
    key: 'loadUser',
    value: function loadUser() {
      var _this2 = this;

      var guid = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.guid;

      this.fetched = true;

      if (guid === _app2.default.profile.id) {
        // don't fetch this user's own profile, since we have it already
        this.profileFetch = _jquery2.default.Deferred().resolve(_app2.default.profile);
      } else {
        this.profileFetch = (0, _Profile.getCachedProfiles)([guid])[0];
      }

      this.profileFetch.done(function (profile) {
        if (_this2.isRemoved()) return;
        _this2.loading = false;
        _this2.notFound = false;
        _this2.model = profile;
        _this2.render();
      }).fail(function () {
        if (_this2.isRemoved()) return;
        _this2.loading = false;
        _this2.notFound = true;
        _this2.render();
      });
    }
  }, {
    key: 'className',
    value: function className() {
      return 'userCard';
    }
  }, {
    key: 'attributes',
    value: function attributes() {
      // make it possible to tab to this element
      return { tabIndex: 0 };
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-userName': 'nameClick',
        'click .js-follow': 'followClick',
        'click .js-mod': 'modClick',
        'click .js-imageHeader': 'nameClick',
        'click .js-rating': 'ratingClick'
      };
    }
  }, {
    key: 'nameClick',
    value: function nameClick() {
      this.navToUser();
    }
  }, {
    key: 'followClick',
    value: function followClick(e) {
      var _this3 = this;

      var type = this.followedByYou ? 'unfollow' : 'follow';

      this.$followBtn.addClass('processing');
      (0, _follow.followUnfollow)(this.guid, type).always(function () {
        return _this3.$followBtn.removeClass('processing');
      });

      e.stopPropagation();
    }
  }, {
    key: 'modClick',
    value: function modClick(e) {
      var _this4 = this;

      if (this.ownMod) {
        // remove this user from the moderator list
        this.$modBtn.addClass('processing');
        this.saveModeratorList(false);
      } else {
        // show the moderator details modal
        var modModal = (0, _modalManager.launchModeratorDetailsModal)({ model: this.model });
        this.listenTo(modModal, 'addAsModerator', function () {
          _this4.$modBtn.addClass('processing');
          _this4.saveModeratorList(true);
        });
      }

      e.stopPropagation();
    }
  }, {
    key: 'onClickImageHeader',
    value: function onClickImageHeader() {
      this.navToUser();
    }
  }, {
    key: 'ratingClick',
    value: function ratingClick() {
      this.navToUser('reputation');
    }
  }, {
    key: 'navToUser',
    value: function navToUser(tab) {
      var route = '' + this.guid + (tab ? '/' + tab : '');
      _app2.default.router.navigate(route, {
        trigger: true
      });
    }
  }, {
    key: 'saveModeratorList',
    value: function saveModeratorList() {
      var _this5 = this;

      var add = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      // clone the array, otherwise it is a reference
      var modList = _underscore2.default.clone(_app2.default.settings.get('storeModerators'));

      if (add && !this.ownMod) {
        modList.push(this.guid);
      } else {
        modList = _underscore2.default.without(modList, this.guid);
      }

      var formData = { storeModerators: modList };
      this.settings.set(formData);

      if (!this.settings.validationError) {
        this.settings.save(formData, {
          attrs: formData,
          type: 'PATCH'
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';
          var phrase = add ? 'userShort.modAddError' : 'userShort.modRemoveError';
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t(phrase), errMsg);
        }).always(function () {
          _this5.$modBtn.removeClass('processing');
        });
      }
    }
  }, {
    key: 'setBlockedClass',
    value: function setBlockedClass() {
      this.$el.toggleClass('isBlocked', (0, _block.isBlocked)(this.guid));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('userCard.html', function (t) {
        _this6.$el.html(t(_extends({
          loading: _this6.loading,
          notFound: _this6.notFound,
          guid: _this6.guid,
          ownGuid: _this6.ownGuid,
          followedByYou: _this6.followedByYou,
          ownMod: _this6.ownMod,
          getModTip: _this6.getModTip,
          getFollowTip: _this6.getFollowTip
        }, _this6.options, _this6.model && _this6.model.toJSON() || {})));

        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this6).call(_this6);

        _this6._$followBtn = null;
        _this6._$modBtn = null;

        if (_this6.guid !== _app2.default.profile.id) {
          _this6.getCachedEl('.js-blockBtnContainer').html(new _BlockBtn2.default({
            targetId: _this6.guid,
            initialState: {
              useIcon: true
            }
          }).render().el);
        }

        _this6.setBlockedClass();

        if (!_this6.fetched) _this6.loadUser();
        /* the view should be rendered when it is created and before it has data, so it can occupy
         space in the DOM while the data is being fetched. */

        if (_this6.verifiedMod) _this6.verifiedMod.remove();

        var verifiedMod = _app2.default.verifiedMods.get(_this6.guid);
        var createOptions = (0, _VerifiedMod.getModeratorOptions)({
          model: verifiedMod
        });
        if (verifiedMod) {
          _this6.verifiedMod = _this6.createChild(_VerifiedMod2.default, _extends({}, createOptions, {
            initialState: _extends({}, createOptions.initialState, {
              text: ''
            })
          }));
          _this6.getCachedEl('.js-verifiedMod').append(_this6.verifiedMod.render().el);
        }
      });

      return this;
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.profileFetch && this.profileFetch.abort) this.profileFetch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'ownMod',
    get: function get() {
      return _app2.default.settings.ownMod(this.guid);
    }
  }, {
    key: '$followBtn',
    get: function get() {
      return this._$followBtn || (this._$followBtn = this.$('.js-follow'));
    }
  }, {
    key: '$modBtn',
    get: function get() {
      return this._$modBtn || (this._$modBtn = this.$('.js-mod'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;