'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _ChatHead = require('./ChatHead');

var _ChatHead2 = _interopRequireDefault(_ChatHead);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a chat conversations collection.');
    }

    if (!options.$scrollContainer) {
      throw new Error('Please provide a jQuery object containing the scrollable element ' + 'this view is in.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this._chatHeadViews = [];
    _this.$scrollContainer = options.$scrollContainer;
    // If providing profiles, the expectation is that they will be an object
    // with the guid as the key and a Profile model instance as the value.
    _this.profiles = options.profiles || {};

    _this.listenTo(_this.collection, 'update', _this.onCollectionUpdate);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'chatHeads flexColRows gutterVSm';
    }
  }, {
    key: 'onCollectionUpdate',
    value: function onCollectionUpdate(cl, options) {
      // If a single model is added to the top of the list, we'll add it to the
      // UI and adjust the scroll position for the list doesn't jump.
      if (options.changes.added.length === 1 && this.collection.indexOf(options.changes.added[0]) === 0) {
        var prevScroll = {};

        prevScroll.height = this.$scrollContainer[0].scrollHeight;
        prevScroll.top = this.$scrollContainer[0].scrollTop;

        this.render();

        this.$scrollContainer[0].scrollTop = prevScroll.top + (this.$scrollContainer[0].scrollHeight - prevScroll.height);
      } else {
        this.render();
      }
    }
  }, {
    key: 'setProfile',
    value: function setProfile(profile) {
      if (!profile) {
        throw new Error('Please provide a Profile model.');
      }

      this.profiles[profile.id] = profile;
      this.render();
    }
  }, {
    key: 'createChatHead',
    value: function createChatHead(model) {
      var _this2 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!model) {
        throw new Error('Please provide a model.');
      }

      var viewData = _extends({}, options, {
        model: model
      });

      var profile = this.profiles[model.get('peerId')];

      if (profile) {
        viewData.profile = profile;
      }

      var chatHead = this.createChild(_ChatHead2.default, viewData);

      this._chatHeadViews.push(chatHead);
      this.listenTo(chatHead, 'click', function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _this2.trigger.apply(_this2, ['chatHeadClick'].concat(args));
      });

      return chatHead;
    }
  }, {
    key: 'clearChatHeadViews',
    value: function clearChatHeadViews() {
      this._chatHeadViews.forEach(function (vw) {
        return vw.remove();
      });
      this._chatHeadViews = [];
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      this.clearChatHeadViews();

      var headsContainer = document.createDocumentFragment();

      this.collection.forEach(function (chatHead) {
        var view = _this3.createChatHead(chatHead);
        (0, _jquery2.default)(headsContainer).append(view.render().el);
      });

      this.$el.empty().append(headsContainer);

      this.trigger('rendered');

      return this;
    }
  }, {
    key: 'views',
    get: function get() {
      return this._chatHeadViews;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;