'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

require('../../utils/lib/velocity');

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _selectors = require('../../utils/selectors');

var _serverConnect = require('../../utils/serverConnect');

var _SimpleMessage = require('../modals/SimpleMessage');

var _dom = require('../../utils/dom');

var _block = require('../../utils/block');

var _emojis = require('../../data/emojis');

var _emojis2 = _interopRequireDefault(_emojis);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _ChatMessages = require('../../collections/ChatMessages');

var _ChatMessages2 = _interopRequireDefault(_ChatMessages);

var _ChatMessage = require('../../models/chat/ChatMessage');

var _ChatMessage2 = _interopRequireDefault(_ChatMessage);

var _Profile = require('../../models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _ConvoProfileHeader = require('./ConvoProfileHeader');

var _ConvoProfileHeader2 = _interopRequireDefault(_ConvoProfileHeader);

var _ConvoMessages = require('./ConvoMessages');

var _ConvoMessages2 = _interopRequireDefault(_ConvoMessages);

var _EmojiMenu = require('./EmojiMenu');

var _EmojiMenu2 = _interopRequireDefault(_EmojiMenu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.profile || !(options.profile instanceof _Profile2.default) && !options.profile.then) {
      throw new Error('Please provide a profile model or a promise that provides' + ' one when it resolves.');
    }

    if (!options.guid) {
      throw new Error('Please provide the peer ID of the person you are conversing with.');
    }

    if (options.subject && options.subject.length > _ChatMessage2.default.max.subjectLength) {
      throw new Error('The subject cannot exceed ' + _ChatMessage2.default.max.subjectLength + ' characters');
    }

    var opts = _extends({
      subject: ''
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this._guid = _this.options.guid;
    _this._isOpen = false;
    _this._isEmojiMenuOpen = false;
    _this.subject = '';
    _this.showLoadMessagesError = false;
    _this.fetching = false;
    _this.fetchedAllMessages = false;
    _this.ignoreScroll = false;

    if (options.profile instanceof _Profile2.default) {
      _this.profile = _this.options.profile;
    } else {
      options.profile.done(function (model) {
        _this.profile = model;

        if (_this.convoProfileHeader) {
          _this.convoProfileHeader.setState({
            handle: model.get('handle'),
            avatarHashes: model.get('avatarHashes').toJSON(),
            location: model.get('location')
          });
        }

        if (_this.convoMessages) {
          _this.convoMessages.setProfile(model);
          var handle = model.get('handle');

          if (handle) {
            _this.setTypingIndicator(handle);
          }
        }
      });
    }

    _this.messages = new _ChatMessages2.default([], { guid: _this.guid });
    _this.listenTo(_this.messages, 'request', _this.onMessagesRequest);
    _this.listenTo(_this.messages, 'sync', _this.onMessagesSync);
    _this.listenTo(_this.messages, 'update', _this.onMessagesUpdate);
    _this.listenTo(_this.messages, 'error', _this.onMessagesFetchError);
    _this.fetchMessages();

    var socket = (0, _serverConnect.getSocket)();

    if (socket) {
      _this.listenTo(socket, 'message', _this.onSocketMessage);
    }

    _this.boundOnFocusin = _this.onFocusIn.bind(_this);
    _this.$el.on('focusin', _this.boundOnFocusin);

    _this.listenTo(_block.events, 'blocking', function (data) {
      if (!data.peerIds.includes(_this.guid)) return;
      _this.$el.addClass('isBlocking');
    });

    _this.listenTo(_block.events, 'blockFail blocked', function (data) {
      if (!data.peerIds.includes(_this.guid)) return;
      _this.$el.removeClass('isBlocking');
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'chatConversation flexColRows clrP noMessages';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        click: 'onViewClick',
        'click .js-closeConvo': 'onClickCloseConvo',
        'click .js-subMenuTrigger': 'onClickSubMenuTrigger',
        'click .js-blockUser': 'onClickBlockUser',
        'click .js-subMenu a': 'onClickSubMenuLink',
        'click .js-retryLoadMessage': 'onClickRetryLoadMessage',
        'click .js-deleteConversation': 'onClickDeleteConvo',
        'keyup .js-inputMessage': 'onKeyUpMessageInput',
        'keydown .js-inputMessage': 'onKeyDownMessageInput',
        'blur .js-inputMessage': 'onBlurMessageInput',
        'click .js-emojiMenuTrigger': 'onClickEmojiMenuTrigger'
      };
    }
  }, {
    key: 'onFocusIn',
    value: function onFocusIn() {
      if (this.markAsReadOnFocus) {
        this.markConvoAsRead();
        this.markAsReadOnFocus = false;
      }
    }
  }, {
    key: 'onClickCloseConvo',
    value: function onClickCloseConvo() {
      this.trigger('clickCloseConvo');
    }
  }, {
    key: 'onClickSubMenuTrigger',
    value: function onClickSubMenuTrigger() {
      if (this.isSubmenuOpen()) {
        this.hideSubMenu();
      } else {
        this.showSubMenu();
      }

      return false; // don't bubble to onViewClick
    }
  }, {
    key: 'onViewClick',
    value: function onViewClick(e) {
      if (!(0, _jquery2.default)(e.target).closest('.js-subMenu').length) {
        this.hideSubMenu();
      }
    }
  }, {
    key: 'onClickBlockUser',
    value: function onClickBlockUser() {
      (0, _block.block)(this.guid);
    }
  }, {
    key: 'onClickSubMenuLink',
    value: function onClickSubMenuLink() {
      this.hideSubMenu();
    }
  }, {
    key: 'onMessagesRequest',
    value: function onMessagesRequest(mdCl, xhr) {
      var _this2 = this;

      // Only interested in the collection sync (not any of its models).
      if (!(mdCl instanceof _ChatMessages2.default)) return;

      this.showLoadMessagesError = false;
      this.$loadMessagesError.addClass('hide');
      this.$el.addClass('loadingMessages');
      this.fetching = true;

      xhr.always(function () {
        return _this2.fetching = false;
      });
    }
  }, {
    key: 'onMessagesSync',
    value: function onMessagesSync(mdCl, response) {
      // Only interested in the collection sync (not any of its models).
      if (!(mdCl instanceof _ChatMessages2.default)) return;

      this.showLoadMessagesError = false;
      this.$loadMessagesError.addClass('hide');
      this.$el.removeClass('loadingMessages');

      if (response && !response.length) {
        this.fetchedAllMessages = true;
      }

      if (!this.firstSyncComplete) {
        this.firstSyncComplete = true;
        this.setScrollTop(this.$convoMessagesWindow[0].scrollHeight);

        if (this.isOpen) {
          if (document.hasFocus()) {
            this.markConvoAsRead();
          } else {
            this.markAsReadOnFocus = true;
          }
        }
      }
    }
  }, {
    key: 'onMessagesFetchError',
    value: function onMessagesFetchError() {
      this.showLoadMessagesError = true;
      this.$loadMessagesError.removeClass('hide');
      this.$el.removeClass('loadingMessages');
    }
  }, {
    key: 'onMessagesUpdate',
    value: function onMessagesUpdate(cl, opts) {
      if (this.messages.length) {
        this.$el.removeClass('noMessages');
      }

      var prevTopModel = this.topRenderedMessageMd;

      if (!this.convoMessages) return;

      // As appropriate, update the scroll position.
      var prevScroll = {};

      prevScroll.height = this.$convoMessagesWindow[0].scrollHeight;
      prevScroll.top = this.$convoMessagesWindow[0].scrollTop;

      this.convoMessages.render();
      this.topRenderedMessageMd = this.messages.at(0);

      // Expecting either a new page of messages at the beginning of the collection or
      // a new single message at the end of the collection. In either of those scenarios
      // we'll adjust the scroll position as appopriate.

      if (opts.changes.added.length === 1) {
        // Single new message added.

        var newMessage = opts.changes.added[0];

        if (cl.indexOf(newMessage) === cl.length - 1) {
          // It's the last message.

          if (newMessage.get('outgoing')) {
            // It's our own message, so we'll auto scroll to the bottom.
            this.setScrollTop(this.$convoMessagesWindow[0].scrollHeight);
          } else if (prevScroll.top >= prevScroll.height - this.$convoMessagesWindow[0].clientHeight - 10) {
            // For an incoming message, if we were scrolled within 10px of the bottom at the
            // time the message came, we'll auto-scroll. Otherwise, we'll leave you where you were.
            this.setScrollTop(this.$convoMessagesWindow[0].scrollHeight);
          }
        }
      } else if (opts.changes.added.length && cl.indexOf(opts.changes.added[opts.changes.added.length - 1]) !== prevTopModel) {
        // New page of messages added up top. We'll adjust the scroll position so there is no
        // jump as they are added in.
        this.setScrollTop(prevScroll.top + (this.$convoMessagesWindow[0].scrollHeight - prevScroll.height - 60));

        // the hardcode 60 is to account for the loading spinner that is going away
      }
    }
  }, {
    key: 'onClickRetryLoadMessage',
    value: function onClickRetryLoadMessage() {
      this.fetchMessages.apply(this, _toConsumableArray(this.lastFetchMessagesArgs));
    }
  }, {
    key: 'onKeyDownMessageInput',
    value: function onKeyDownMessageInput(e) {
      if (!e.shiftKey && e.which === 13) e.preventDefault();
    }

    /**
     * This handler should be called any time a chat message has been sent to the
     * server.
     */

  }, {
    key: 'onMessageSent',
    value: function onMessageSent(chatMessage) {
      this.messages.push(chatMessage);
      this.trigger('newOutgoingMessage', { model: chatMessage });
    }
  }, {
    key: 'sendMessage',
    value: function sendMessage(msg) {
      if (!msg) {
        throw new Error('Please provide a message to send.');
      }

      this.lastTypingSentAt = null;

      var chatMessage = new _ChatMessage2.default({
        peerId: this.guid,
        subject: this.subject,
        message: msg
      }, { parse: true });

      var save = chatMessage.save();

      if (save) {
        // At least for now, ignoring any server failures and optimistically adding the new
        // message to the UI. Odds are really low of server failure and repurcussions minimal.
        this.onMessageSent(chatMessage);
      } else {
        // Developer error - this shouldn't happen.
        console.error('There was an error saving the chat message.');
        console.dir(chatMessage.validationError);
      }
    }
  }, {
    key: 'onKeyUpMessageInput',
    value: function onKeyUpMessageInput(e) {
      // Send an empty message to indicate "typing...", but no more than 1 every
      // second.
      if (!this.lastTypingSentAt || Date.now() - this.lastTypingSentAt >= 1000) {
        var typingMessage = new _ChatMessage2.default({
          peerId: this.guid,
          subject: this.subject,
          message: ''
        });

        var saveTypingMessage = typingMessage.save();

        if (saveTypingMessage) {
          this.lastTypingSentAt = Date.now();
        } else {
          // Developer error - this shouldn't happen.
          console.error('There was an error saving the chat message.');
          console.dir(saveTypingMessage);
        }
      }

      // Send actual chat message if the Enter key was pressed
      if (e.shiftKey || e.which !== 13) return;

      var message = e.target.value.trim();
      if (message) this.sendMessage(message);
      (0, _jquery2.default)(e.target).val('');
    }
  }, {
    key: 'onBlurMessageInput',
    value: function onBlurMessageInput(e) {
      this.lastMessageInputCursorPos = e.target.selectionStart;
    }
  }, {
    key: 'onScroll',
    value: function onScroll(e) {
      if (this.ignoreScroll) {
        this.ignoreScroll = false;
        this.throttleScrollHandler();
        return;
      }

      if (this.fetching || this.fetchedAllMessages || this.showLoadMessagesError) {
        return;
      }

      // If we come close enough to the top, let's fetch a new page.
      if (e.target.scrollTop <= 100) {
        this.fetchMessages(this.messages.at(0).id);
      }
    }
  }, {
    key: 'onSocketMessage',
    value: function onSocketMessage(e) {
      if (e.jsonData.message && e.jsonData.message.subject === this.subject && e.jsonData.message.peerId === this.guid) {
        // incoming chat message
        var message = new _ChatMessage2.default(_extends({}, e.jsonData.message, {
          outgoing: false
        }));

        this.messages.push(message);

        if (this.isOpen) {
          if (document.hasFocus()) {
            this.markConvoAsRead();
          } else {
            this.markAsReadOnFocus = true;
          }
        }

        // We'll consider them to be done typing if an acutal message came
        // in. If they re-start typing, we'll get another socket messsage.
        this.hideTypingIndicator();
      } else if (e.jsonData.messageTyping && e.jsonData.messageTyping.subject === this.subject && e.jsonData.messageTyping.peerId === this.guid) {
        // Conversant is typing...
        this.showTypingIndicator();
      } else if (e.jsonData.messageRead && e.jsonData.messageRead.subject === this.subject && e.jsonData.messageRead.peerId === this.guid) {
        // Conversant read your message
        if (this.convoMessages) {
          var model = this.messages.get(e.jsonData.messageRead.messageId);

          if (model) {
            model.set('read', true);
          }

          this.convoMessages.markMessageAsRead(e.jsonData.messageRead.messageId);
        }
      }
    }
  }, {
    key: 'onClickDeleteConvo',
    value: function onClickDeleteConvo() {
      var _this3 = this;

      this.$el.addClass('isDeleting');

      var request = _jquery2.default.ajax({
        url: _app2.default.getServerUrl('ob/chatconversation/' + this.guid),
        type: 'DELETE'
      }).fail(function (xhr) {
        var failReason = xhr.responseJSON && xhr.responseJSON.reason || '';
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('chat.conversation.deleteConvoErrorTitle'), failReason);
      }).always(function () {
        return _this3.$el.removeClass('isDeleting');
      });

      this.trigger('deleting', {
        request: request,
        guid: this.guid
      });
    }
  }, {
    key: 'onClickEmojiMenuTrigger',
    value: function onClickEmojiMenuTrigger() {
      if (this.isEmojiMenuOpen) {
        this.closeEmojiMenu();
      } else {
        this.openEmojiMenu();
      }
    }
  }, {
    key: 'onEmojiSelected',
    value: function onEmojiSelected(e) {
      (0, _dom.insertAtCursor)(this.$messageInput[0], _emojis2.default[e.emoji].name);
      this.closeEmojiMenu();
      this.$messageInput.focus();
    }
  }, {
    key: 'showTypingIndicator',
    value: function showTypingIndicator() {
      var _this4 = this;

      clearTimeout(this.typingTimeout);
      this.$el.addClass('isTyping');
      this.typingTimeout = setTimeout(function () {
        return _this4.hideTypingIndicator();
      }, 3000);
    }
  }, {
    key: 'hideTypingIndicator',
    value: function hideTypingIndicator() {
      clearTimeout(this.typingTimeout);
      this.$el.removeClass('isTyping');
    }
  }, {
    key: 'fetchMessages',
    value: function fetchMessages(offsetId) {
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.messagesPerPage;

      var params = { limit: limit };

      this.lastFetchMessagesArgs = [offsetId, limit];
      if (offsetId) params.offsetId = offsetId;

      return this.messages.fetch({
        data: _jquery2.default.param(params),
        remove: false
      });
    }
  }, {
    key: 'setScrollTop',
    value: function setScrollTop(value) {
      var silent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      if (typeof value !== 'number') {
        throw new Error('Please provide a value as a number.');
      }

      if (this.$convoMessagesWindow[0].scrollTop === value) return;

      if (silent) {
        // Unthrottling the scroll handler so that our ignoreScoll flag won't
        // be lumped in with a user triggered scroll. The scroll handler will
        // reset the flag and re-throttle the handler.
        this.unthrottleScrollHandler();
        this.ignoreScroll = true;
      }

      this.$convoMessagesWindow[0].scrollTop = value;
    }
  }, {
    key: 'unthrottleScrollHandler',
    value: function unthrottleScrollHandler() {
      this.$convoMessagesWindow.off('scroll', this.boundScrollHandler);
      this.boundScrollHandler = this.onScroll.bind(this);
      this.$convoMessagesWindow.on('scroll', this.boundScrollHandler);
    }
  }, {
    key: 'throttleScrollHandler',
    value: function throttleScrollHandler() {
      this.$convoMessagesWindow.off('scroll', this.boundScrollHandler);
      this.boundScrollHandler = _underscore2.default.throttle(this.onScroll, 100).bind(this);
      this.$convoMessagesWindow.on('scroll', this.boundScrollHandler);
    }

    // Currently the convo is marked as read under the following scenarios.
    // - when this view is opened as long as the first batch of messages have already
    //   been fetched (don't want to mark as read if all the user has seen is
    //   a spinner)
    // - when the first batch of messages have been fetched as long as this view is open
    //   and the app is in focus.
    // - when this view (or a child element) gets focus as long as the messages would have
    //   otherwise been marked as read, but the call was held off because the app was
    //   not in focus.

  }, {
    key: 'markConvoAsRead',
    value: function markConvoAsRead() {
      var queryString = this.subject ? '/?subject=' + this.subject : '';
      _jquery2.default.post(_app2.default.getServerUrl('ob/markchatasread/' + this.guid + queryString));
      this.trigger('convoMarkedAsRead');
      this.markAsReadOnFocus = false;
    }
  }, {
    key: 'open',
    value: function open() {
      if (this._isOpen) return;
      this._isOpen = true;
      (0, _selectors.getBody)().addClass('chatConvoOpen');
      this.$messageInput.focus();

      if (this.firstSyncComplete) {
        this.markConvoAsRead();
      }
    }
  }, {
    key: 'close',
    value: function close() {
      if (!this._isOpen) return;
      this._isOpen = false;
      (0, _selectors.getBody)().removeClass('chatConvoOpen');
    }
  }, {
    key: 'isSubmenuOpen',
    value: function isSubmenuOpen() {
      return !this.$subMenu.hasClass('hide');
    }
  }, {
    key: 'showSubMenu',
    value: function showSubMenu() {
      this.$messagesOverlay.removeClass('hide');
      this.$subMenu.removeClass('hide');
    }
  }, {
    key: 'hideSubMenu',
    value: function hideSubMenu() {
      this.$messagesOverlay.addClass('hide');
      this.$subMenu.addClass('hide');
    }
  }, {
    key: 'openEmojiMenu',
    value: function openEmojiMenu() {
      if (this._isEmojiMenuOpen) return;

      this._isEmojiMenuOpen = true;
      this.$emojiMenuContainer.velocity('stop').velocity({
        top: [146, 266]
      });
    }
  }, {
    key: 'closeEmojiMenu',
    value: function closeEmojiMenu() {
      var _this5 = this;

      if (!this._isEmojiMenuOpen) return;

      this._isEmojiMenuOpen = false;
      this.$emojiMenuContainer.velocity('stop').velocity({
        top: 266
      }, {
        complete: function complete() {
          _this5.$emojiMenuContainer[0].scrollTop = 0;
        }
      });
    }
  }, {
    key: 'getTypingIndicatorContent',
    value: function getTypingIndicatorContent() {
      var name = this.guid;

      if (this.profile) {
        var handle = this.profile.get('handle');
        if (handle) name = '@' + handle;
      }

      var usernameHtml = '<span class="typingUsername noOverflow">' + name + '</span>';
      return _app2.default.polyglot.t('chat.conversation.typingIndicator', { user: usernameHtml });
    }
  }, {
    key: 'setTypingIndicator',
    value: function setTypingIndicator() {
      this.$typingIndicator.html(this.getTypingIndicatorContent());
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.$el.off(null, this.boundOnFocusin);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      (0, _loadTemplate2.default)('chat/conversation.html', function (t) {
        _this6.$el.html(t({
          guid: _this6.guid,
          profile: _this6.profile && _this6.profile.toJSON() || {},
          showLoadMessagesError: _this6.showLoadMessagesError,
          typingIndicator: _this6.getTypingIndicatorContent(),
          maxMessageLength: _ChatMessage2.default.max.messageLength
        }));

        _this6._$subMenu = null;
        _this6._$messagesOverlay = null;
        _this6._$loadMessagesError = null;
        _this6._$convoMessagesWindow = null;
        _this6._$typingIndicator = null;
        _this6._$emojiMenuContainer = null;
        _this6._$messageInput = null;

        if (_this6.convoProfileHeader) _this6.convoProfileHeader.remove();

        var convoProfileHeaderInitialState = {
          guid: _this6.guid
        };

        if (_this6.profile) {
          convoProfileHeaderInitialState.handle = _this6.profile.get('handle');
          convoProfileHeaderInitialState.avatarHashes = _this6.profile.get('avatarHashes').toJSON();
          convoProfileHeaderInitialState.location = _this6.profile.get('location');
        }

        _this6.convoProfileHeader = _this6.createChild(_ConvoProfileHeader2.default, {
          initialState: convoProfileHeaderInitialState
        });

        _this6.$('.js-convoProfileHeaderContainer').html(_this6.convoProfileHeader.render().el);

        if (_this6.emojiMenu) _this6.emojiMenu.remove();
        _this6.emojiMenu = _this6.createChild(_EmojiMenu2.default);
        _this6.listenTo(_this6.emojiMenu, 'emojiSelected', _this6.onEmojiSelected);

        _this6.$emojiMenuContainer.html(_this6.emojiMenu.render().el);

        if (_this6.ConvoMessages) _this6.ConvoMessages.remove();

        _this6.convoMessages = new _ConvoMessages2.default({
          collection: _this6.messages,
          $scrollContainer: _this6.$convoMessagesWindow,
          profile: _this6.profile
        });

        _this6.$el.toggleClass('isBlocking', (0, _block.isBlocking)(_this6.guid));
        _this6.$('.js-convoMessagesContainer').html(_this6.convoMessages.render().el);
        _this6.throttleScrollHandler();
      });

      return this;
    }
  }, {
    key: 'messagesPerPage',
    get: function get() {
      return 25;
    }
  }, {
    key: 'guid',
    get: function get() {
      return this._guid;
    }
  }, {
    key: 'isOpen',
    get: function get() {
      return this._isOpen;
    }
  }, {
    key: 'isEmojiMenuOpen',
    get: function get() {
      return this._isEmojiMenuOpen;
    }
  }, {
    key: '$typingIndicator',
    get: function get() {
      return this._$typingIndicator || (this._$typingIndicator = this.$('.js-typingIndicator'));
    }
  }, {
    key: '$subMenu',
    get: function get() {
      return this._$subMenu || (this._$subMenu = this.$('.js-subMenu'));
    }
  }, {
    key: '$messagesOverlay',
    get: function get() {
      return this._$messagesOverlay || (this._$messagesOverlay = this.$('.js-messagesOverlay'));
    }
  }, {
    key: '$loadMessagesError',
    get: function get() {
      var returnVal = void 0;

      if (this._$loadMessagesError && this._$loadMessagesError.length) {
        returnVal = this._$loadMessagesError;
      } else {
        returnVal = this._$loadMessagesError = this.$('.js-loadMessagesError');
      }

      return returnVal;
    }
  }, {
    key: '$convoMessagesWindow',
    get: function get() {
      return this._$convoMessagesWindow || (this._$convoMessagesWindow = this.$('.js-convoMessagesWindow'));
    }
  }, {
    key: '$emojiMenuContainer',
    get: function get() {
      return this._$emojiMenuContainer || (this._$emojiMenuContainer = this.$('.js-emojiMenuContainer'));
    }
  }, {
    key: '$messageInput',
    get: function get() {
      return this._$messageInput || (this._$messageInput = this.$('.js-inputMessage'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;