'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _block = require('../../utils/block');

var block = _interopRequireWildcard(_block);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _metrics = require('../../utils/metrics');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (typeof options.targetId !== 'string') {
      throw new Error('Please provide a targetId as a string.');
    }

    if (_app2.default.profile.id === options.targetId) {
      throw new Error('Blocking is not available on your own node.');
    }

    var opts = _extends({}, options, {
      initialState: _extends({
        useIcon: false,
        tooltipClass: options.initialState && options.initialState.useIcon ? 'toolTipNoWrap toolTipTop' : '',
        isBlocking: block.isBlocking(options.targetId) || block.isUnblocking(options.targetId),
        isBlocked: block.isBlocked(options.targetId)
      }, options && options.initialState || {})
    });

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.targetId = options.targetId;

    _this.listenTo(block.events, 'unblocking blocking', function (data) {
      if (!data.peerIds.includes(options.targetId)) return;
      _this.setState({ isBlocking: true });
    });

    _this.listenTo(block.events, 'blocked unblocked blockFail unblockFail', function (data) {
      if (!data.peerIds.includes(options.targetId)) return;
      _this.setState({ isBlocking: false });
    });

    _this.listenTo(block.events, 'blocked', function (data) {
      if (!data.peerIds.includes(options.targetId)) return;
      _this.setState({ isBlocked: true });
    });

    _this.listenTo(block.events, 'unblocked', function (data) {
      if (!data.peerIds.includes(options.targetId)) return;
      _this.setState({ isBlocked: false });
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-block': 'onClickBlock'
      };
    }
  }, {
    key: 'onClickBlock',
    value: function onClickBlock(e) {
      e.stopPropagation();

      if (this.getState().isBlocked) {
        block.unblock(this.targetId);
        (0, _metrics.recordEvent)('UnBlockUser');
      } else {
        block.block(this.targetId);
        (0, _metrics.recordEvent)('BlockUser');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('components/blockBtn.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.getState())));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;