'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _Profile = require('../../models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

var _VerifiedMod = require('./VerifiedMod');

var _VerifiedMod2 = _interopRequireDefault(_VerifiedMod);

var _dom = require('../../utils/dom');

var _modalManager = require('../../utils/modalManager');

var _languages = require('../../data/languages');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      cardState: 'unselected',
      notSelected: 'unselected',
      radioStyle: false,
      controlsOnInvalid: false
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.notSelected = opts.notSelected;
    _this.cardState = opts.cardState;

    /* There are 3 valid card states:
       selected: This mod is pre-selected, or was activated by the user.
       unselected: Neutral. No action has been taken by the user on this mod.
       deselected: The user has rejected or turned off this mod.
     */
    var validCardStates = ['selected', 'unselected', 'deselected'];

    if (!validCardStates.includes(_this.cardState)) {
      throw new Error('This card does not have a valid card state.');
    }

    if (!_this.model || !(_this.model instanceof _Profile2.default)) {
      throw new Error('Please provide a Profile model.');
    }

    (0, _dom.handleLinks)(_this.el);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'moderatorCard clrBr';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-viewBtn': 'clickModerator',
        click: 'click'
      };
    }
  }, {
    key: 'clickModerator',
    value: function clickModerator(e) {
      var _this2 = this;

      e.stopPropagation();
      var modModal = (0, _modalManager.launchModeratorDetailsModal)({
        model: this.model,
        purchase: this.options.purchase,
        cardState: this.cardState
      });
      this.listenTo(modModal, 'addAsModerator', function () {
        _this2.changeSelectState('selected');
      });
    }
  }, {
    key: 'click',
    value: function click(e) {
      e.stopPropagation();
      this.rotateSelectState();
    }
  }, {
    key: 'rotateSelectState',
    value: function rotateSelectState() {
      if (this.cardState === 'selected' && !this.options.radioStyle) {
        this.changeSelectState(this.notSelected);
      } else if (this.model.isModerator) {
        /* Only change to selected if this is a valid moderator. Moderators that have become invalid
           may be displayed, and can be de-selected to remove them. */
        this.changeSelectState('selected');
      }
    }
  }, {
    key: 'changeSelectState',
    value: function changeSelectState(cardState) {
      if (cardState !== this.cardState) {
        this.cardState = cardState;
        this.render();
        this.trigger('modSelectChange', {
          selected: cardState === 'selected',
          guid: this.model.id
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      var modLanguages = [];
      if (this.model.isModerator) {
        modLanguages = this.model.get('moderatorInfo').get('languages').map(function (lang) {
          var langData = (0, _languages.getLangByCode)(lang);
          return langData && langData.name || lang;
        });
      }

      var verifiedMod = _app2.default.verifiedMods.get(this.model.get('peerID'));

      (0, _loadTemplate2.default)('components/moderatorCard.html', function (t) {
        _this3.$el.html(t(_extends({
          cardState: _this3.cardState,
          displayCurrency: _app2.default.settings.get('localCurrency'),
          valid: _this3.model.isModerator,
          radioStyle: _this3.options.radioStyle,
          controlsOnInvalid: _this3.options.controlsOnInvalid,
          verified: !!verifiedMod,
          modLanguages: modLanguages
        }, _this3.model.toJSON())));

        if (_this3.verifiedMod) _this3.verifiedMod.remove();

        _this3.verifiedMod = _this3.createChild(_VerifiedMod2.default, (0, _VerifiedMod.getModeratorOptions)({
          model: verifiedMod
        }));
        _this3.getCachedEl('.js-verifiedMod').append(_this3.verifiedMod.render().el);
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;