'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.events = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.getOpenModals = getOpenModals;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _backbone = require('backbone');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _selectors = require('../../utils/selectors');

var _object = require('../../utils/object');

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var staticEvents = _extends({}, _backbone.Events);

exports.events = staticEvents;

var BaseModal = function (_baseVw) {
  _inherits(BaseModal, _baseVw);

  function BaseModal() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, BaseModal);

    var opts = _extends({
      // #259 - we've decided not have modals close on an overlay click, so you
      // probably should never be passing in true for this.
      dismissOnOverlayClick: false,
      dismissOnEscPress: true,
      showCloseButton: true,
      closeButtonClass: 'cornerTR iconBtn clrP clrBr clrSh3 toolTipNoWrap modalCloseBtn',
      innerButtonClass: 'ion-ios-close-empty',
      closeButtonTip: _app2.default.polyglot.t('pageNav.toolTip.close'),
      modelContentClass: 'modalContent',
      removeOnClose: false,
      removeOnRoute: true
    }, options);

    var _this = _possibleConstructorReturn(this, (BaseModal.__proto__ || Object.getPrototypeOf(BaseModal)).call(this, opts));

    _this.__options = opts;
    _this._open = false;

    if (typeof BaseModal.__openModals === 'undefined') {
      BaseModal.__openModals = [];
    }

    if (!BaseModal.__docKeyPressHandlerBound) {
      (0, _jquery2.default)(document).on('keyup', BaseModal.__onDocKeypress);
      BaseModal.__docKeyPressHandlerBound = true;
    }

    if (_this.__options.removeOnRoute) _this.listenTo(_app2.default.router, 'will-route', _this.remove);
    return _this;
  }

  _createClass(BaseModal, [{
    key: 'className',
    value: function className() {
      return 'modal';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        click: '__modalClick',
        'click .jsModalClose': '__closeClick'
      };
    }

    /**
     * Returns an array of HTMLElements and if any of these are directly clicked the modal
     * will be closed. By default, the only target will be this.el, which means any clicks
     * outside of the modal will close it. But... with the new modal design where everything
     * is in boxes, the waters are muddied because the overlay is visible inbetween boxes
     * and you may want a click on those regions to close the modal (e.g. left navigation
     * is much shorter than the right content exposing a large amount of the overlay).
     *
     * Anyhow, since the content inside a modal is very specific to the modal, it is up to
     * the specific child view to let this base view know what qualifies as a close target.
     * That should be done by overriding this method. You will very likely want to include
     * a call to super in the array you are returning, e.g:
     *
     *     return [myCustomEl, myCustomEl2, ...super.closeClickTargets];
     *
     * Also, the overridden method will be called on EVERY click in this modal, so it is
     * critical you are caching the elements returned (i.e. DO NOT go to the DOM every time
     * the method is called).
     */

  }, {
    key: '__modalClick',
    value: function __modalClick(e) {
      if (this.__options.dismissOnOverlayClick) {
        var closeTargets = this.closeClickTargets;

        if (!_underscore2.default.isArray(closeTargets)) {
          throw new Error('closeClickTargets must return an array.');
        }

        if (closeTargets.indexOf(e.target) !== -1) this.close();
      }
    }
  }, {
    key: '__closeClick',
    value: function __closeClick() {
      this.close();
    }
  }, {
    key: '__trigger',
    value: function __trigger(event) {
      if (typeof event !== 'string') {
        throw new Error('Please provide an event name as a string.');
      }

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      staticEvents.trigger.apply(staticEvents, [event, this].concat(args));
      this.trigger.apply(this, [event].concat(args));
    }
  }, {
    key: 'isOpen',
    value: function isOpen() {
      return this._open;
    }
  }, {
    key: 'open',
    value: function open() {
      if (!_jquery2.default.contains(document, this.el)) {
        (0, _selectors.getHtml)().addClass('modalOpen');
        (0, _selectors.getAppFrame)().append(this.el);
        BaseModal.__openModals.push(this);
        this._open = true;
        this.__trigger('open');
      } else {
        this.bringToTop();
      }

      return this;
    }
  }, {
    key: 'close',
    value: function close() {
      var _this2 = this;

      var bypassConfirmation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      var modalIndex = void 0;

      // Unless bypassConfirmation is true, if you implement a confirmClose function
      // in your modal, it will be called before potentially closing. If it returns a promise,
      // the modal will close when the promise resolves. If it returns a truthy (other than a
      // promise) the modal will close immediately.
      //
      // If you are returning a Promise, you almost certainly want to show some type of dialog
      // to indicate that something is happening (most likely a confirm close dialog).
      if (!bypassConfirmation && typeof this.confirmClose === 'function') {
        var closeConfirmed = this.confirmClose.call(this);
        if ((0, _object.isPromise)(closeConfirmed)) {
          // Routing to a new page while the confirm close process is active could produce
          // weird things, so we'll block page navigation.
          _app2.default.pageNav.navigable = false;
          closeConfirmed.done(function () {
            return _this2.close(true);
          }).always(function () {
            return _app2.default.pageNav.navigable = true;
          });
        } else {
          if (closeConfirmed) this.close(true);
        }

        return this;
      }

      if (_jquery2.default.contains(document, this.el)) {
        modalIndex = BaseModal.__openModals.indexOf(this);
        if (modalIndex >= 0) BaseModal.__openModals.splice(modalIndex, 1);
        if (!BaseModal.__openModals.length) (0, _selectors.getHtml)().removeClass('modalOpen');
        (0, _selectors.getAppFrame)()[0].removeChild(this.el);
        this._open = false;
        this.__trigger('close');
      }

      if (this.__options.removeOnClose) {
        this.remove();
      }

      return this;
    }
  }, {
    key: 'setModalOptions',
    value: function setModalOptions(options) {
      if (!options) return this;

      if (typeof options.showCloseButton !== 'undefined') {
        this.$modalClose[options.showCloseButton ? 'removeClass' : 'addClass']('hide');
      }

      if (typeof options.removeOnRoute !== 'undefined' && options.removeOnRoute !== this.__options.removeOnRoute) {
        if (options.removeOnRoute) {
          this.listenTo(_app2.default.router, 'will-route', this.remove);
        } else {
          this.stopListening(_app2.default.router, 'will-route');
        }
      }

      this.__options = _extends({}, this.__options, options);

      return this;
    }
  }, {
    key: 'getModalOptions',
    value: function getModalOptions() {
      return this.__options;
    }
  }, {
    key: 'bringToTop',
    value: function bringToTop() {
      if (this.isOpen()) {
        this.__trigger('brought-to-top');
        (0, _selectors.getAppFrame)()[0].removeChild(this.el);
        (0, _selectors.getAppFrame)().append(this.el);
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.__trigger('modal-will-remove');
      if (this.isOpen()) this.close(true);
      _get(BaseModal.prototype.__proto__ || Object.getPrototypeOf(BaseModal.prototype), 'remove', this).call(this);

      return this;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/baseModal.html', function (t) {
        _this3.$el.html(t(_underscore2.default.extend({}, _this3.__options, { innerContent: _this3.el.innerHTML })));
      });

      this.$modalClose = this.$('.jsModalClose');

      return _get(BaseModal.prototype.__proto__ || Object.getPrototypeOf(BaseModal.prototype), 'render', this).call(this);
    }
  }, {
    key: 'closeClickTargets',
    get: function get() {
      return [this.el];
    }
  }]);

  return BaseModal;
}(_baseVw3.default);

exports.default = BaseModal;


BaseModal.__onDocKeypress = function (e) {
  var topModal = BaseModal.__openModals[BaseModal.__openModals.length - 1];

  if (e.keyCode === 27 && topModal && topModal.__options.dismissOnEscPress) {
    topModal.close();
  }
};

function getOpenModals() {
  return BaseModal.__openModals || [];
}