'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _electron = require('electron');

require('../../utils/lib/velocity');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('./BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      debugLog: _electron.remote.getGlobal('serverLog'),
      autoUpdate: true
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.debugLog = opts.debugLog;

    _electron.ipcRenderer.on('server-log', _this.onServerConnectLog.bind(_this));
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' modalScrollPage';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-copy': 'onCopyClick'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onCopyClick',
    value: function onCopyClick() {
      _electron.clipboard.writeText(this.$debugLog.text());
      this.$copiedConfirm.velocity('stop').velocity('fadeIn').velocity('fadeOut', { delay: 1000 });
    }
  }, {
    key: 'onServerConnectLog',
    value: function onServerConnectLog(e, msg) {
      this.debugLog += msg;

      if (this.isOpen()) {
        // re-rendering while the modal is open might be too disruptive (e.g. scroll position would
        // be lost)
        this.$debugLog.append(msg);
      } else {
        // If the modal is not open, we'll re-render since that will use the updated debug log which
        // was truncated if too long.
        this.render();
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      _electron.ipcRenderer.removeListener('server-log', this.onServerConnectLog);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/debugLog.html', function (t) {
        _this2.$el.html(t({
          debugLog: _this2.debugLog
        }));

        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this2).call(_this2);

        _this2._$debugLog = null;
        _this2._$copiedConfirm = null;
      });

      return this;
    }
  }, {
    key: 'maxDebugLines',
    get: function get() {
      return 1000;
    }
  }, {
    key: 'debugLog',
    get: function get() {
      return this._debugLog;
    },
    set: function set(log) {
      if (typeof log !== 'string') {
        throw new Error('Please provide the log as a string.');
      }

      // If the debug log gets too long, the modal will take a long time to render because it's taking
      // the browser so long to paint the content. To be simple, for now, we'll just truncate it if
      // it's beyond a certain number of lines.
      var splitLog = log.replace('\r\n', '\n').split('\n');

      if (splitLog.length > this.maxDebugLines) {
        this._debugLog = '< Previous content has been truncated >\n\n' + ('' + log.slice(log.length - this.maxDebugLines).join('\n'));
      } else {
        this._debugLog = log;
      }
    }
  }, {
    key: '$debugLog',
    get: function get() {
      return this._$debugLog || (this._$debugLog = this.$('.js-debugLog'));
    }
  }, {
    key: '$copiedConfirm',
    get: function get() {
      return this._$copiedConfirm || (this._$copiedConfirm = this.$('.js-copiedConfirm'));
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;