'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('./BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
Used to show a dialog with optional buttons. By default, the dialog removes itself on close. In it's
simplest form a dialog can be launched as follows:

const myDialog = new Dialog({
  title: 'Houston, We Have A problem!',
  message: 'How can you eat your pudding, if you haven't eaten your meat!?'
}).render().open();

Additionally, you could specify an array of buttons which will be displayed at the bottom of the
dialog. The buttons should be provided in the following format:

{
  title: '...',
  ...
  buttons: [{
    text: 'Cancel', // displayed text of button
    fragment: 'cancel' // unique fragment to identify the button. Used internally, as well as
                       // used to determine the event that will be fire upon click of the button,
                       // e.g. the above fragment would result in 'click-cancel'.
  },{
    text: 'Ok',
    fragment: 'ok'
  }]
}

Please Note: This Dialog is designed for simple messages with optional classes or buttons on
the bottom. If you find that your situation needs custom markup, css (beyond the classes you
can optionally pass in) and/or behavior (e.g. tabs, etc.), you should write a custom view
and extend from the Base Modal.

Also, if it's just a super simple message you need, please check out the SimpleMessageModal.
*/

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      title: '',
      message: '',
      titleClass: '',
      messageClass: '',
      buttons: [],
      removeOnClose: true,
      defaultBtnClass: 'btn clrP clrBr clrSh2'
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    var events = {};

    if (opts.buttons && opts.buttons.length) {
      opts.buttons.forEach(function (btn) {
        var serializedBut = JSON.stringify(btn);

        if (!btn.text || !btn.fragment) {
          throw new Error('The button, \'' + serializedBut.slice(0, 10) + '\', is missing ' + 'either a text or fragment property. Both are required.');
        }

        btn.className = btn.className === undefined ? opts.defaultBtnClass : btn.className;

        events['click .js-' + btn.fragment] = 'onBtnClick';
      });

      _this.events = function () {
        return _extends({}, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', _this).call(_this) || {}, events);
      };
      _this.delegateEvents(_this.events);
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' messageModal dialog';
    }
  }, {
    key: 'onBtnClick',
    value: function onBtnClick(e) {
      this.trigger('click-' + (0, _jquery2.default)(e.target).data('event-name'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/dialog.html', function (t) {
        _this2.$el.html(t(_this2.options));

        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this2).call(_this2);
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;