'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('./BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _metrics = require('../../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    _this.listenTo(_app2.default.localSettings, 'change:shareMetrics', function () {
      return _this.render();
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' messageModal dialog';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-share': 'onShareClick',
        'click .js-decline': 'onDeclineClick'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onShareClick',
    value: function onShareClick() {
      var _this2 = this;

      (0, _metrics.changeMetrics)(true).done(function () {
        _this2.close();
      }).fail(function () {
        // the save is to local storage, this shouldn't happen
        console.log('Saving shareMetrics as true has failed.');
      });
    }
  }, {
    key: 'onDeclineClick',
    value: function onDeclineClick() {
      var _this3 = this;

      (0, _metrics.changeMetrics)(false).done(function () {
        _this3.close();
      }).fail(function () {
        // the save is to local storage, this shouldn't happen
        console.log('Saving shareMetrics as false has failed.');
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('modals/metricsModal.html', function (t) {
        _this4.$el.html(t({
          showUndecided: _this4.options.showUndecided,
          shareMetrics: _app2.default.localSettings.get('shareMetrics'),
          restartRequired: (0, _metrics.isMetricRestartNeeded)()
        }));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this4).call(_this4);
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;