'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../../../lib/select2');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _languages = require('../../../data/languages');

var _countries = require('../../../data/countries');

var _currencies = require('../../../data/currencies');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _SimpleMessage = require('../SimpleMessage');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, _extends({
      className: 'settingsGeneral'
    }, options)));

    _this.settings = _app2.default.settings.clone();

    // Sync our clone with any changes made to the global settings model.
    _this.listenTo(_app2.default.settings, 'someChange', function (md, opts) {
      return _this.settings.set(opts.setAttrs);
    });

    // Sync the global settings model with any changes we save via our clone.
    _this.listenTo(_this.settings, 'sync', function (md, resp, opts) {
      return _app2.default.settings.set(opts.attrs);
    });

    _this.localSettings = _app2.default.localSettings.clone();

    // Sync our clone with any changes made to the global local settings model.
    _this.listenTo(_this.localSettings, 'sync', function (md, resp, opts) {
      return _app2.default.localSettings.set(_this.localSettings.toJSON(opts.attrs));
    });

    // Sync the global local settings model with any changes we save via our clone.
    _this.listenTo(_this.localSettings, 'sync', function (md, resp, opts) {
      return _app2.default.localSettings.set(opts.attrs);
    });

    _this.countryList = (0, _countries.getTranslatedCountries)();
    _this.currencyList = (0, _currencies.getTranslatedCurrencies)();
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-save': 'save',
        'change #settingsCurrencySelect': 'onChangeCurrencySelect',
        'click .js-restoreDefaultVerifiedModProvider': 'clickRestoreDefaultVerifiedModProvider'
      };
    }
  }, {
    key: 'onChangeCurrencySelect',
    value: function onChangeCurrencySelect(e) {
      if (e.target.value === 'BTC') {
        this.$bitcoinUnitField.removeClass('hide');
      } else {
        this.$bitcoinUnitField.addClass('hide');
      }
    }
  }, {
    key: 'clickRestoreDefaultVerifiedModProvider',
    value: function clickRestoreDefaultVerifiedModProvider() {
      // this is currently hidden in the template because it was taken out of the design for now
      var defaultVal = this.localSettings.defaults().verifiedModsProvider;
      this.getCachedEl('.js-verifiedModsProvider').val(defaultVal);
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      var fields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.$settingsFields;

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, fields);
    }
  }, {
    key: 'save',
    value: function save() {
      var _this2 = this;

      this.localSettings.set(this.getFormData(this.$localSettingsFields));
      this.localSettings.set({}, { validate: true });

      var settingsFormData = this.getFormData();
      this.settings.set(settingsFormData);
      this.settings.set({}, { validate: true });

      if (!this.localSettings.validationError && !this.settings.validationError) {
        var msg = {
          msg: _app2.default.polyglot.t('settings.generalTab.statusSaving'),
          type: 'message'
        };

        var statusMessage = _app2.default.statusBar.pushMessage(_extends({}, msg, {
          duration: 9999999999999999
        }));

        // let's save and monitor both save processes
        var localSave = this.localSettings.save();
        var serverSave = this.settings.save(settingsFormData, {
          attrs: settingsFormData,
          type: 'PATCH'
        });

        _jquery2.default.when(localSave, serverSave).done(function () {
          // both succeeded!
          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.generalTab.statusSaveComplete'),
            type: 'confirmed'
          });
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          // One has failed, the other may have also failed or may
          // fail or may succeed. It doesn't matter, for our purposed one
          // failure is enough for us to consider the "save" to have failed
          var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';

          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.generalTab.saveErrorAlertTitle'), errMsg);

          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.generalTab.statusSaveFailed'),
            type: 'warning'
          });
        }).always(function () {
          _this2.$btnSave.removeClass('processing');
          setTimeout(function () {
            return statusMessage.remove();
          }, 3000);
        });
      }

      this.render();

      if (!this.localSettings.validationError && !this.settings.validationError) {
        this.$btnSave.addClass('processing');
      } else {
        var $firstErr = this.$('.errorList:first');

        if ($firstErr.length) {
          $firstErr[0].scrollIntoViewIfNeeded();
        } else {
          var models = [];
          if (this.localSettings.validationError) models.push(this.localSettings);
          if (this.settings.validationError) models.push(this.settings);
          this.trigger('unrecognizedModelError', this, models);
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/settings/general.html', function (t) {
        _this3.$el.html(t(_extends({
          languageList: _languages.translationLangs,
          countryList: _this3.countryList,
          currencyList: _this3.currencyList,
          errors: _extends({}, _this3.settings.validationError || {}, _this3.localSettings.validationError || {})
        }, _this3.localSettings.toJSON(), _this3.settings.toJSON(), {
          // local lang should be declared after the server model, so the local
          // lang takes precedence over the deprecated server one
          language: _this3.localSettings.get('language')
        })));

        _this3.$('#settingsLanguageSelect').select2();
        _this3.$('#settingsCountrySelect').select2();
        _this3.$('#settingsCurrencySelect').select2();

        _this3._$settingsFields = null;
        _this3._$localSettingsFields = null;
        _this3._$btnSave = null;
        _this3._$bitcoinUnitField = null;
      });

      return this;
    }
  }, {
    key: '$btnSave',
    get: function get() {
      return this._$btnSave || (this._$btnSave = this.$('.js-save'));
    }
  }, {
    key: '$bitcoinUnitField',
    get: function get() {
      return this._$bitcoinUnitField || (this._$bitcoinUnitField = this.$('.js-bitcoinUnitField'));
    }
  }, {
    key: '$settingsFields',
    get: function get() {
      return this._$settingsFields || (this._$settingsFields = this.$('select[name], input[name], textarea[name]').not('[data-persistence-location="local"]'));
    }
  }, {
    key: '$localSettingsFields',
    get: function get() {
      return this._$localSettingsFields || (this._$localSettingsFields = this.$('[data-persistence-location="local"]'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;