'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _SimpleMessage = require('../../modals/SimpleMessage');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _General = require('./General');

var _General2 = _interopRequireDefault(_General);

var _Page = require('./Page');

var _Page2 = _interopRequireDefault(_Page);

var _Store = require('./Store');

var _Store2 = _interopRequireDefault(_Store);

var _Addresses = require('./Addresses');

var _Addresses2 = _interopRequireDefault(_Addresses);

var _Advanced = require('./advanced/Advanced');

var _Advanced2 = _interopRequireDefault(_Advanced);

var _Moderation = require('./Moderation');

var _Moderation2 = _interopRequireDefault(_Moderation);

var _Blocked = require('./Blocked');

var _Blocked2 = _interopRequireDefault(_Blocked);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      removeOnClose: true,
      removeOnRoute: false,
      initialTab: 'General',
      scrollTo: ''
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this.tabViewCache = {};
    _this.tabViews = {
      General: _General2.default,
      Page: _Page2.default,
      Store: _Store2.default,
      Addresses: _Addresses2.default,
      Advanced: _Advanced2.default,
      Moderation: _Moderation2.default,
      Blocked: _Blocked2.default
    };

    _this.listenTo(_app2.default.router, 'will-route', function () {
      _this.close(true);
      _this.remove();
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' settings tabbedModal modalScrollPage';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-tab': 'tabClick'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'tabClick',
    value: function tabClick(e) {
      var targ = (0, _jquery2.default)(e.target).closest('.js-tab');

      this.selectTab(targ);
    }
  }, {
    key: 'onUnrecognizedModelError',
    value: function onUnrecognizedModelError(tabView) {
      var models = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      var errors = models.map(function (md) {
        var errObj = md.validationError || {};
        return Object.keys(errObj).map(function (key) {
          return key + ': ' + errObj[key];
        });
      });

      var body = _app2.default.polyglot.t('settings.unrecognizedModelErrsWarning.body') + (errors.length ? '<br><br>' + errors.join('<br> ') : '');

      (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.unrecognizedModelErrsWarning.title'), body);
    }
  }, {
    key: 'selectTab',
    value: function selectTab(targ) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var tabViewName = targ.data('tab');
      var tabView = this.tabViewCache[tabViewName];

      if (!this.currentTabView || this.currentTabView !== tabView) {
        this.$('.js-tab').removeClass('clrT active');
        targ.addClass('clrT active');
        if (this.currentTabView) this.currentTabView.$el.detach();

        if (!tabView) {
          tabView = this.createChild(this.tabViews[tabViewName]);
          this.tabViewCache[tabViewName] = tabView;
          tabView.render();
          this.listenTo(tabView, 'unrecognizedModelError', this.onUnrecognizedModelError);
        }

        this.$tabContent.append(tabView.$el);
        this.currentTabView = tabView;

        if (options.scrollTo && typeof tabView.scrollTo === 'function') {
          setTimeout(function () {
            return tabView.scrollTo(options.scrollTo);
          });
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/settings/settings.html', function (t) {
        _this2.$el.html(t(_this2.options));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this2).call(_this2);

        _this2.$tabContent = _this2.$('.js-tabContent');

        _this2.selectTab(_this2.$('.js-tab[data-tab="' + _this2.options.initialTab + '"]'), {
          scrollTo: _this2.options.scrollTo
        });
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;