'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _SocialAccount = require('./SocialAccount');

var _SocialAccount2 = _interopRequireDefault(_SocialAccount);

var _SocialAccount3 = require('../../../models/profile/SocialAccount');

var _SocialAccount4 = _interopRequireDefault(_SocialAccount3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a collection.');
    }

    if (!options.maxAccounts) {
      throw new Error('Please provide a maximum number of accounts.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    _this.accountViews = [];
    _this.maxAccounts = options.maxAccounts;

    _this.listenTo(_this.collection, 'add', function (md) {
      var view = _this.createAccountView(md);
      _this.accountViews.push(view);
      _this.getCachedEl('.js-socialWrapper').append(view.render().el);
      _this.showLimit();
    });

    _this.listenTo(_this.collection, 'remove', function (md, cl, removeOpts) {
      _this.accountViews.splice(removeOpts.index, 1)[0].remove();
      _this.showLimit();
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'socialAccounts gutterV';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-addAccount': 'onClickAddAccount'
      };
    }
  }, {
    key: 'addBlankAccount',
    value: function addBlankAccount() {
      var notEmpty = !!this.collection.length;
      var name = 'type';
      var blank = notEmpty ? this.accountViews[this.lastIndex].firstBlankField : '';
      // if the current last account isn't completely filled in, don't add a new one
      if (!blank) {
        this.collection.add(new _SocialAccount4.default());
      } else {
        name = blank;
      }
      this.accountViews[this.lastIndex].$('input[name=' + name + ']').focus();
    }
  }, {
    key: 'showLimit',
    value: function showLimit() {
      var show = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.accountViews.length >= this.maxAccounts;

      if (show !== this._showLimit) {
        this._showLimit = show;
        this.getCachedEl('.js-addAccount').toggleClass('hide', show);
      }
    }
  }, {
    key: 'onClickAddAccount',
    value: function onClickAddAccount() {
      this.addBlankAccount();
    }
  }, {
    key: 'setCollectionData',
    value: function setCollectionData() {
      var _this2 = this;

      this.accountViews.forEach(function (account) {
        account.setModelData();
        // remove blank accounts
        if (!account.model.get('type') && !account.model.get('username')) {
          _this2.collection.remove(account.model);
        }
      });
    }
  }, {
    key: 'createAccountView',
    value: function createAccountView(model) {
      var _this3 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var view = this.createChild(_SocialAccount2.default, _extends({
        model: model
      }, options));

      this.listenTo(view, 'remove-click', function () {
        _this3.collection.remove(view.model);
        // if the last account is removed, replace it with a blank one
        if (_this3.collection.length === 0) {
          _this3.addBlankAccount();
        }
      });

      return view;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/settings/socialAccounts.html', function (t) {
        _this4.$el.html(t({
          currentCount: _this4.collection.length,
          max: _this4.maxAccounts
        }));

        _this4.accountViews.forEach(function (account) {
          return account.remove();
        });
        _this4.accountViews = [];

        var accountFrag = document.createDocumentFragment();

        _this4.collection.forEach(function (account) {
          var view = _this4.createAccountView(account);
          _this4.accountViews.push(view);
          view.render().$el.appendTo(accountFrag);
        });

        _this4.getCachedEl('.js-socialWrapper').append(accountFrag);

        // if the collection is empty on render, add a blank account to the form
        if (_this4.collection.length === 0) {
          _this4.collection.add(new _SocialAccount4.default());
        }
      });

      return this;
    }
  }, {
    key: 'lastIndex',
    get: function get() {
      return this.collection.length ? this.collection.length - 1 : 0;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;