'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

require('../../../lib/select2');

require('../../../lib/whenAll.jquery');

var _utils = require('../../../utils');

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _Moderators = require('../../components/Moderators');

var _Moderators2 = _interopRequireDefault(_Moderators);

var _SimpleMessage = require('../SimpleMessage');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      className: 'settingsStore'
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this.profile = _app2.default.profile.clone();

    // Sync our clone with any changes made to the global profile.
    _this.listenTo(_app2.default.profile, 'someChange', function (md, pOpts) {
      return _this.profile.set(pOpts.setAttrs);
    });

    // Sync the global profile with any changes we save via our clone.
    _this.listenTo(_this.profile, 'sync', function (md, resp, pOpts) {
      return _app2.default.profile.set(_this.profile.toJSON(pOpts.attrs));
    });

    _this.settings = _app2.default.settings.clone();

    // Sync our clone with any changes made to the global settings model.
    _this.listenTo(_app2.default.settings, 'someChange', function (md, sOpts) {
      return _this.settings.set(sOpts.setAttrs);
    });

    // Sync the global settings model with any changes we save via our clone.
    _this.listenTo(_this.settings, 'sync', function (md, resp, sOpts) {
      return _app2.default.settings.set(_this.settings.toJSON(sOpts.attrs));
    });

    _this.currentMods = _this.settings.get('storeModerators');
    _this._showVerifiedOnly = true;

    _this.modsSelected = new _Moderators2.default({
      fetchErrorTitle: _app2.default.polyglot.t('settings.storeTab.errors.selectedModsTitle'),
      cardState: 'selected',
      notSelected: 'deselected',
      showInvalid: true,
      controlsOnInvalid: true,
      showSpinner: false
    });

    _this.modsByID = new _Moderators2.default({
      async: false,
      fetchErrorTitle: _app2.default.polyglot.t('settings.storeTab.errors.modNotFoundTitle'),
      excludeIDs: _this.currentMods,
      showInvalid: true,
      wrapperClasses: 'noMin',
      showSpinner: false
    });

    _this.listenTo(_this.modsByID, 'noModsFound', function (mOpts) {
      return _this.noModsByIDFound(mOpts.guids);
    });

    _this.modsAvailable = new _Moderators2.default({
      apiPath: 'moderators',
      excludeIDs: _this.currentMods,
      showVerifiedOnly: true,
      fetchErrorTitle: _app2.default.polyglot.t('settings.storeTab.errors.availableModsTitle'),
      showLoadBtn: true
    });

    var modsToCheckOnVerifiedUpdate = [{
      view: _this.modsSelected,
      hasVerifiedMods: _app2.default.verifiedMods.matched(_this.modsSelected.allIDs).length > 0
    }, {
      view: _this.modsByID,
      hasVerifiedMods: _app2.default.verifiedMods.matched(_this.modsByID.allIDs).length > 0
    }, {
      view: _this.modsAvailable,
      hasVerifiedMods: _app2.default.verifiedMods.matched(_this.modsAvailable.allIDs).length > 0
    }];

    _this.listenTo(_app2.default.verifiedMods, 'update', function () {
      modsToCheckOnVerifiedUpdate.forEach(function (obj) {
        var nowSelected = _app2.default.verifiedMods.matched(obj.view.allIDs).length > 0;
        if (nowSelected !== obj.hasVerifiedMods) {
          obj.hasVerifiedMods = nowSelected;
          obj.view.render();
        }
      });
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-browseMods': 'fetchAvailableModerators',
        'click .js-submitModByID': 'clickSubmitModByID',
        'click .js-save': 'save',
        'click .js-storeVerifiedOnly': 'onClickVerifiedOnly'
      };
    }
  }, {
    key: 'noModsByIDFound',
    value: function noModsByIDFound(guids) {
      var modsNotFound = _app2.default.polyglot.t('settings.storeTab.errors.modsNotFound', { guids: guids, smart_count: guids.length });
      this.showModByIDError(modsNotFound);
      if (this.modsByID.modCount === 0) {
        this.getCachedEl('.js-modListByID').addClass('hide');
      }
    }
  }, {
    key: 'fetchAvailableModerators',
    value: function fetchAvailableModerators() {
      // get the verified mods via POST
      this.modsAvailable.getModeratorsByID({
        moderatorIDs: _app2.default.verifiedMods.pluck('peerID'),
        useCache: true,
        method: 'POST',
        apiPath: 'fetchprofiles'
      });
      // get random mods via GET
      this.modsAvailable.getModeratorsByID();
      this.getCachedEl('.js-modListAvailable').removeClass('hide');
      this.getCachedEl('.js-noModsAdded').addClass('hide');
    }
  }, {
    key: 'showModByIDError',
    value: function showModByIDError(msg) {
      this.getCachedEl('.js-submitModByIDInputError').removeClass('hide');
      this.getCachedEl('.js-submitModByIDInputErrorText').text(msg);
    }
  }, {
    key: 'clickSubmitModByID',
    value: function clickSubmitModByID() {
      var modID = this.getCachedEl('.js-submitModByIDInput').val();

      this.getCachedEl('.js-submitModByIDInputError').addClass('hide');

      if (modID) {
        // trim unwanted copy and paste characters
        modID = modID.replace('ob://', '');
        modID = modID.split('/')[0];
        modID = modID.trim();

        if ((0, _utils.isMultihash)(modID)) {
          if (!this.currentMods.includes(modID)) {
            if (modID !== _app2.default.profile.id) {
              this.modsByID.getModeratorsByID({ moderatorIDs: [modID] });
              this.getCachedEl('.js-modListByID').removeClass('hide');
            } else {
              var ownGUID = _app2.default.polyglot.t('settings.storeTab.errors.ownGUID', { guid: modID });
              this.showModByIDError(ownGUID);
            }
          } else {
            var dupeGUID = _app2.default.polyglot.t('settings.storeTab.errors.dupeGUID', { guid: modID });
            this.showModByIDError(dupeGUID);
          }
        } else {
          var notGUID = _app2.default.polyglot.t('settings.storeTab.errors.notGUID', { guid: modID });
          this.showModByIDError(notGUID);
        }
      } else {
        var blankError = _app2.default.polyglot.t('settings.storeTab.errors.modIsBlank');
        this.showModByIDError(blankError);
      }
    }
  }, {
    key: 'onClickVerifiedOnly',
    value: function onClickVerifiedOnly(e) {
      this.showVerifiedOnly = (0, _jquery2.default)(e.target).prop('checked');
    }
  }, {
    key: 'getProfileFormData',
    value: function getProfileFormData() {
      var subset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.$profileFormFields;

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, subset);
    }
  }, {
    key: 'getSettingsData',
    value: function getSettingsData() {
      var selected = _app2.default.settings.get('storeModerators');
      // The mods may not have loaded in the interface yet. Subtract only explicitly de-selected ones.
      selected = _underscore2.default.without.apply(_underscore2.default, [selected].concat(_toConsumableArray(this.modsSelected.unselectedIDs)));
      var byID = this.modsByID.selectedIDs;
      var available = this.modsAvailable.selectedIDs;
      return { storeModerators: [].concat(_toConsumableArray(new Set([].concat(_toConsumableArray(selected), _toConsumableArray(byID), _toConsumableArray(available))))) };
    }
  }, {
    key: 'save',
    value: function save() {
      var _this2 = this;

      // this view saves to two different models
      var profileFormData = this.getProfileFormData();
      var settingsFormData = this.getSettingsData();

      this.profile.set(profileFormData);
      this.profile.set(profileFormData, { validate: true });
      this.settings.set(settingsFormData);
      this.settings.set(settingsFormData, { validate: true });

      if (!this.profile.validationError && !this.settings.validationError) {
        this.getCachedEl('.js-save').addClass('processing');

        var msg = {
          msg: _app2.default.polyglot.t('settings.storeTab.status.saving'),
          type: 'message'
        };

        var statusMessage = _app2.default.statusBar.pushMessage(_extends({}, msg, {
          duration: 9999999999999999
        }));

        var profileSave = this.profile.save(profileFormData, {
          attrs: profileFormData,
          type: 'PATCH'
        });

        var settingsSave = this.settings.save(settingsFormData, {
          attrs: settingsFormData,
          type: 'PATCH'
        });

        _jquery2.default.when(profileSave, settingsSave).done(function () {
          // both have saved
          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.storeTab.status.done'),
            type: 'confirmed'
          });

          // move the changed moderators
          _this2.currentMods = _this2.settings.get('storeModerators');
          var unSel = _this2.modsSelected.unselectedIDs;
          var remSel = _this2.modsSelected.removeModeratorsByID(unSel);
          var remByID = _this2.modsByID.removeModeratorsByID(_this2.modsByID.selectedIDs);
          var remAvail = _this2.modsAvailable.removeModeratorsByID(_this2.modsAvailable.selectedIDs);

          _this2.modsByID.excludeIDs = _this2.currentMods;
          _this2.modsByID.moderatorsStatus.setState({
            hidden: true
          });

          _this2.modsSelected.moderatorsCol.add([].concat(_toConsumableArray(remByID), _toConsumableArray(remAvail)));
          _this2.modsSelected.moderatorsStatus.setState({
            hidden: true
          });

          _this2.modsAvailable.excludeIDs = _this2.currentMods;
          _this2.modsAvailable.moderatorsCol.add(remSel);
          _this2.modsAvailable.moderatorsStatus.setState({
            hidden: false,
            total: _this2.modsAvailable.modCount,
            showSpinner: false
          });

          // If any of the mods moved to the available collect are unverified, show them
          if (_app2.default.verifiedMods.matched(unSel).length !== unSel.length) {
            // Don't render, the render is in the always handler
            _this2._showVerifiedOnly = false;
          }
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          // if at least one save fails, the save has failed.
          var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('settings.storeTab.status.error'), errMsg);

          statusMessage.update({
            msg: _app2.default.polyglot.t('settings.storeTab.status.fail'),
            type: 'warning'
          });
        }).always(function () {
          _this2.getCachedEl('.js-save').removeClass('processing');
          setTimeout(function () {
            return statusMessage.remove();
          }, 3000);
          _this2.render();
        });
      } else {
        var $firstErr = this.$('.errorList:first:not(.hide)');

        if ($firstErr.length) {
          $firstErr[0].scrollIntoViewIfNeeded();
        } else {
          var models = [];
          if (this.profile.validationError) models.push(this.profile);
          if (this.settings.validationError) models.push(this.settings);
          this.trigger('unrecognizedModelError', this, models);
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('modals/settings/store.html', function (t) {
        _this3.$el.html(t(_extends({
          modsAvailable: _this3.modsAvailable.allIDs,
          showVerifiedOnly: _this3._showVerifiedOnly,
          errors: _extends({}, _this3.profile.validationError || {}, _this3.settings.validationError || {})
        }, _this3.profile.toJSON(), _this3.settings.toJSON())));

        _this3.modsSelected.delegateEvents();
        _this3.$('.js-modListSelected').append(_this3.modsSelected.render().el);
        if (!_this3.modsSelected.modFetches.length) {
          _this3.modsSelected.getModeratorsByID({ moderatorIDs: _this3.currentMods });
        }

        _this3.modsByID.delegateEvents();
        _this3.getCachedEl('.js-modListByID').append(_this3.modsByID.render().el).toggleClass('hide', !_this3.modsByID.allIDs.length);

        _this3.modsAvailable.delegateEvents();
        _this3.modsAvailable.setState({ showVerifiedOnly: _this3._showVerifiedOnly });
        _this3.getCachedEl('.js-modListAvailable').append(_this3.modsAvailable.render().el).toggleClass('hide', !_this3.modsAvailable.allIDs.length);
      });

      return this;
    }
  }, {
    key: 'showVerifiedOnly',
    set: function set(bool) {
      this._showVerifiedOnly = bool;
      this.modsAvailable.setState({ showVerifiedOnly: bool });
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;