'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _app = require('../../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _TestSmtpStatus = require('./TestSmtpStatus');

var _TestSmtpStatus2 = _interopRequireDefault(_TestSmtpStatus);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    if (!_this.model) {
      throw new Error('Please provide a SMTPSettings model.');
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'box padMdKids padStack clrP clrBr';
    }
  }, {
    key: 'tagName',
    value: function tagName() {
      return 'form';
    }
  }, {
    key: 'onChangeShowSmtpNotifications',
    value: function onChangeShowSmtpNotifications() {
      this.setModelData();
      this.render();
    }
  }, {
    key: 'resetForm',
    value: function resetForm() {
      this.model.set(_extends({}, _underscore2.default.omit(this.model.defaults(), 'notifications')));
      if (this.testSmtpPost) this.testSmtpPost.abort();
      if (this.testSmtpStatus) {
        this.testSmtpStatus.setState({
          isFetching: false,
          msg: ''
        });
      }
      this.render();
    }
  }, {
    key: 'onClickTest',
    value: function onClickTest() {
      var _this2 = this;

      if (this.testSmtpPost) this.testSmtpPost.abort();
      this.setModelData();
      this.model.set({}, { validate: true });
      this.testSmtpStatus.setState({ msg: '' });

      if (this.model.validationError) {
        this.render();
        return;
      }

      this.testSmtpPost = _jquery2.default.post({
        url: _app2.default.getServerUrl('ob/testemailnotifications'),
        data: JSON.stringify(this.model.toJSON()),
        dataType: 'json',
        contentType: 'application/json'
      }).done(function () {
        _this2.testSmtpStatus.setState({
          success: true,
          msg: _app2.default.polyglot.t('settings.advancedTab.smtp.testSmtpSuccess')
        });
      }).fail(function (xhr) {
        if (xhr.statusText === 'abort') return;
        var err = xhr.responseJSON && xhr.responseJSON.reason || '';
        var msg = err ? _app2.default.polyglot.t('settings.advancedTab.smtp.testSmtpFailWithError', { err: err }) : _app2.default.polyglot.t('settings.advancedTab.smtp.testSmtpFail');

        _this2.testSmtpStatus.setState({
          success: false,
          msg: msg
        });
      }).always(function () {
        _this2.getCachedEl('.js-smtpTestButtonWrap').removeClass('testInProgress');
      });

      this.render();
    }
  }, {
    key: 'onClickCancelTest',
    value: function onClickCancelTest() {
      if (this.testSmtpPost) this.testSmtpPost.abort();
      this.getCachedEl('.js-smtpTestButtonWrap').removeClass('testInProgress');
    }

    // Sets the model based on the current data in the UI.

  }, {
    key: 'setModelData',
    value: function setModelData() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      this.model.set(this.getFormData(), options);
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.testSmtpPost) this.testSmtpPost.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('modals/settings/advanced/smtpSettings.html', function (t) {
        _this3.$el.html(t(_extends({
          errors: _this3.model.validationError || {},
          testingSmtp: _this3.testSmtpPost && _this3.testSmtpPost.state() === 'pending'
        }, _this3.model.toJSON())));

        var testSmtpStatusInitialState = _extends({}, _this3.testSmtpStatus && _this3.testSmtpStatus.getState() || {});

        if (_this3.testSmtpStatus) _this3.testSmtpStatus.remove();
        _this3.testSmtpStatus = _this3.createChild(_TestSmtpStatus2.default, {
          initialState: _extends({}, testSmtpStatusInitialState)
        });
        _this3.getCachedEl('.js-testSmtpStatusContainer').html(_this3.testSmtpStatus.render().el);
      });

      return this;
    }
  }, {
    key: 'events',
    get: function get() {
      return {
        'change [name=notifications]': 'onChangeShowSmtpNotifications',
        'click input[type=reset]': 'resetForm',
        'click .js-testSMTPSettings': 'onClickTest',
        'click .js-cancelSMTPSettings': 'onClickCancelTest'
      };
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;