'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.openSimpleMessage = openSimpleMessage;

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('./BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
  Please Note: This Modal is designed for a very simple message (containing a title and a
  message body). If you need something beyond that, check out the Dialog which will allow
  you to optionally pass in classes as well as buttons. If you need something beyond that,
  please create a custom modal extending from the baseModal.
*/

var SimpleMessage = function (_BaseModal) {
  _inherits(SimpleMessage, _BaseModal);

  function SimpleMessage() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, SimpleMessage);

    var opts = _extends({
      removeOnClose: true,
      removeOnRoute: true,
      title: '',
      message: ''
    }, options);

    var _this = _possibleConstructorReturn(this, (SimpleMessage.__proto__ || Object.getPrototypeOf(SimpleMessage)).call(this, opts));

    _this.options = opts;
    _this.title = options.title;
    _this.message = options.message;
    _this.messageHtml = options.messageHtml;
    return _this;
  }

  _createClass(SimpleMessage, [{
    key: 'className',
    value: function className() {
      return _get(SimpleMessage.prototype.__proto__ || Object.getPrototypeOf(SimpleMessage.prototype), 'className', this).call(this) + ' messageModal simpleMessage';
    }
  }, {
    key: 'open',
    value: function open() {
      var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.options.title;
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.options.message;

      if (!title && !message) {
        throw new Error('Please provide a title and / or message.');
      }

      if (title !== this.title || message !== this.message) {
        this.title = title;
        this.message = message;
        this.render();
      }

      _get(SimpleMessage.prototype.__proto__ || Object.getPrototypeOf(SimpleMessage.prototype), 'open', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/simpleMessage.html', function (t) {
        _this2.$el.html(t({
          title: _this2.title,
          message: _this2.message,
          messageHtml: _this2.messageHtml
        }));

        _get(SimpleMessage.prototype.__proto__ || Object.getPrototypeOf(SimpleMessage.prototype), 'render', _this2).call(_this2);
      });

      return this;
    }
  }]);

  return SimpleMessage;
}(_BaseModal3.default);

exports.default = SimpleMessage;

// Convenience method to create a SimpleMessage modal,
// render and open it.

function openSimpleMessage() {
  var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!title && !message) {
    throw new Error('Please provide a title and / or message.');
  }

  var dialog = new SimpleMessage(_extends({
    title: title,
    message: message
  }, options));

  dialog.render().open();

  return dialog;
}