'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model) {
      throw new Error('Please provide a server configuration model.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this._state = _extends({
      status: 'not-connected'
    }, options.initialState || {});

    _this.listenTo(_this.model, 'change', function () {
      return _this.render();
    });
    _this.boundOnDocClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundOnDocClick);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'configuration';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-btnConnect': 'onConnectClick',
        'click .js-btnDisconnect': 'onDisconnectClick',
        'click .js-btnCancel': 'onCancelClick',
        'click .js-btnEdit': 'onEditClick',
        'click .js-btnDelete': 'onDeleteClick',
        'click .js-deleteConfirmYes': 'onDeleteConfirm',
        'click .js-deleteConfirmCancel': 'onDeleteConfirmCancel'
      };
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick(e) {
      if (this.getState().deleteConfirmOn && !(_jquery2.default.contains(this.$deleteConfirm[0], e.target) || e.target === this.$deleteConfirm[0])) {
        this.setState({ deleteConfirmOn: false });
      }
    }
  }, {
    key: 'onConnectClick',
    value: function onConnectClick() {
      this.trigger('connectClick', { view: this });
    }
  }, {
    key: 'onDisconnectClick',
    value: function onDisconnectClick() {
      this.trigger('disconnectClick', { view: this });
    }
  }, {
    key: 'onCancelClick',
    value: function onCancelClick() {
      this.trigger('cancelClick', { view: this });
    }
  }, {
    key: 'onEditClick',
    value: function onEditClick() {
      this.trigger('editClick', { view: this });
    }
  }, {
    key: 'onDeleteClick',
    value: function onDeleteClick() {
      var isDeleteOn = this.getState().deleteConfirmOn;

      this.setState({ deleteConfirmOn: true });

      if (!isDeleteOn) {
        // If the delete confirm wasn't on, we will now show it
        // and we don't want this click event to bubble to our
        // document clieck handler, otherwise it will close the
        // confirm callout that we are showing here.
        return false;
      }

      return true;
    }
  }, {
    key: 'onDeleteConfirm',
    value: function onDeleteConfirm() {
      this.model.destroy();
      this.setState({ deleteConfirmOn: false });
    }
  }, {
    key: 'onDeleteConfirmCancel',
    value: function onDeleteConfirmCancel() {
      this.setState({ deleteConfirmOn: false });
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'remove',
    value: function remove() {
      (0, _jquery2.default)(document).off('click', this.boundOnDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/connectionManagement/configuration.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.model.toJSON(), _this2._state)));

        _this2._$deleteConfirm = null;
      });

      return this;
    }
  }, {
    key: '$deleteConfirm',
    get: function get() {
      return this._$deleteConfirm || (this._$deleteConfirm = this.$('.js-deleteConfirm'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;