'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _electron = require('electron');

var _os = require('os');

var _SimpleMessage = require('../SimpleMessage');

var _SimpleMessage2 = _interopRequireDefault(_SimpleMessage);

var _serverConnect = require('../../../utils/serverConnect');

var _cryptoCurrencies = require('../../../data/cryptoCurrencies');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({}, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    if (!opts.model) {
      throw new Error('Please provide a model.');
    }

    var curConn = (0, _serverConnect.getCurrentConnection)();
    _this.platform = (0, _os.platform)();
    _this.showConfigureTorMessage = false;
    _this.showTorUnavailableMessage = false;

    if (curConn && curConn.server && curConn.server.id === options.model.id) {
      if (curConn.reason === 'tor-not-configured') {
        _this.showConfigureTorMessage = true;
      } else if (curConn.reason === 'tor-not-available') {
        _this.showTorUnavailableMessage = true;
      }
    }

    _this._lastSavedAttrs = _this.model.toJSON();

    _this.title = _this.model.isNew() ? _app2.default.polyglot.t('connectionManagement.configurationForm.tabName') : _this.model.get('name');

    _this.cryptoCurs = (0, _cryptoCurrencies.getTranslatedCurrencies)();
    _this.inUseCryptos = _app2.default.serverConfigs.filter(function (config) {
      return config.get('builtIn');
    }).map(function (config) {
      return config.get('walletCurrency');
    });

    _this.isBundledApp = _electron.remote.getGlobal('isBundledApp');
    if (_this.model.isNew() && _this.isBundledApp) {
      _this.model.set('builtIn', true);
    }

    _this.listenTo(_this.model, 'change:name', function () {
      var newName = _this.model.get('name');
      if (newName) _this.title = newName;
    });

    _this.boundOnDocClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundOnDocClick);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'configurationForm';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-cancel': 'onCancelClick',
        'click .js-save': 'onSaveClick',
        'click .js-saveConfirmed': 'onSaveConfirmedClick',
        'click .js-saveConfirmBox': 'onClickSaveConfirmBox',
        'click .js-saveConfirmCancel': 'onClickSaveConfirmCancel',
        'change #serverConfigServerIp': 'onChangeServerIp',
        'change [name=useTor]': 'onChangeUseTor',
        'change [name=serverType]': 'onChangeServerType',
        'change [name=walletCurrency]': 'onWalletCurrencyChange',
        'click .js-browseZcashBinary': 'onClickBrowseZcashBinary',
        'click .js-inUseText': 'onClickInUseText'
      };
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick() {
      this.getCachedEl('.js-saveConfirmBox').addClass('hide');
    }
  }, {
    key: 'onClickSaveConfirmBox',
    value: function onClickSaveConfirmBox(e) {
      // Do not allow clicks to get to the doc handler and result in the
      // confirm box closing.
      e.stopPropagation();
    }
  }, {
    key: 'onClickSaveConfirmCancel',
    value: function onClickSaveConfirmCancel() {
      this.getCachedEl('.js-saveConfirmBox').addClass('hide');
    }
  }, {
    key: 'onCancelClick',
    value: function onCancelClick() {
      this.trigger('cancel', { view: this });
    }
  }, {
    key: 'onSaveClick',
    value: function onSaveClick(e) {
      this.setModelFromForm();
      this.model.set({}, { validate: true });

      if (this.model.validationError) {
        this.render();
        return;
      }

      if (!this.model.isLocalServer() && !this.model.get('SSL')) {
        this.getCachedEl('.js-saveConfirmBox').removeClass('hide');
      } else {
        this.save();
      }

      // don't bubble to the doc handler
      e.stopPropagation();
    }
  }, {
    key: 'onSaveConfirmedClick',
    value: function onSaveConfirmedClick() {
      this.save();
    }
  }, {
    key: 'onChangeServerIp',
    value: function onChangeServerIp(e) {
      this.model.set(this.getFormData(e.target));

      if (this.model.isLocalServer()) {
        // it's a local ip
        this.$usernameLabel.add(this.$passwordLabel).removeClass('required');
      } else {
        this.$usernameLabel.add(this.$passwordLabel).addClass('required');

        // If you switched from a local to a remote IP, we'll default SSL
        // to on.
        if (this.model.isLocalServer(this.model.previousAttributes().serverIp)) {
          this.getCachedEl('#serverConfigSSLOn')[0].checked = true;
        }
      }

      this.getCachedEl('.js-torPwLabel').toggleClass('required', this.model.isTorPwRequired());
    }
  }, {
    key: 'onChangeUseTor',
    value: function onChangeUseTor(e) {
      this.getCachedEl('form').toggleClass('useTor', e.target.checked);
    }
  }, {
    key: 'onChangeServerType',
    value: function onChangeServerType(e) {
      this.getCachedEl('.js-walletSetupForm').toggleClass('hide', e.target.value === 'STAND_ALONE');
      this.getCachedEl('.js-standAloneSection').toggleClass('hide', e.target.value === 'BUILT_IN');
    }
  }, {
    key: 'onWalletCurrencyChange',
    value: function onWalletCurrencyChange(e) {
      this.getCachedEl('.js-zcashSection').toggleClass('hide', e.target.value !== 'ZEC');
    }
  }, {
    key: 'onClickBrowseZcashBinary',
    value: function onClickBrowseZcashBinary() {
      var _this2 = this;

      _electron.remote.dialog.showOpenDialog({ properties: ['openFile'] }, function (e) {
        if (e) {
          _this2.getCachedEl('.js-inputZcashBinaryPath').val(e[0] || '');
        }
      });
    }
  }, {
    key: 'onClickInUseText',
    value: function onClickInUseText() {
      // prevents the click of the help icon from selecting the otherwise disabled radio
      return false;
    }
  }, {
    key: 'setModelFromForm',
    value: function setModelFromForm() {
      var serverType = this.getFormData(this.getCachedEl('[name=serverType]')).serverType;
      var builtIn = this.model.isNew() ? serverType === 'BUILT_IN' : this.model.get('builtIn');
      var formFieldsDataAttr = builtIn ? 'data-field-builtin' : 'data-field-standalone';
      var formData = this.getFormData(this.getCachedEl('select[' + formFieldsDataAttr + '], input[' + formFieldsDataAttr + '], ' + ('textarea[' + formFieldsDataAttr + ']')));
      delete formData.serverType;
      this.model.set(_extends({}, this.model.lastSyncedAttrs || {}, formData, {
        confirmedTor: this.model.get('confirmedTor') || formData.useTor || this.showConfigureTorMessage,
        builtIn: builtIn
      }));
    }

    /**
     * Save() assumes that you've previously called setModelFromForm to sync the model
     * from the UI.
     */

  }, {
    key: 'save',
    value: function save() {
      var _this3 = this;

      var save = this.model.save();

      if (save) {
        save.done(function () {
          _this3._lastSavedAttrs = _this3.model.toJSON();
          _this3.trigger('saved', { view: _this3 });
        }).fail(function () {
          // since we're saving to localStorage this really shouldn't happen
          (0, _SimpleMessage2.default)('Unable to save server configuration');
        });
      }

      this.render();
    }
  }, {
    key: 'remove',
    value: function remove() {
      (0, _jquery2.default)(document).off('click', this.boundOnDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/connectionManagement/configurationForm.html', function (t) {
        _this4.$el.html(t(_extends({}, _this4.model.toJSON(), {
          errors: _this4.model.validationError || {},
          isRemote: !_this4.model.isLocalServer(),
          title: _this4.title,
          showConfigureTorMessage: _this4.showConfigureTorMessage,
          showTorUnavailableMessage: _this4.showTorUnavailableMessage,
          isTorPwRequired: _this4.model.isTorPwRequired(),
          cryptoCurs: _this4.cryptoCurs,
          inUseCrypto: _this4.inUseCryptos,
          isNew: _this4.model.isNew(),
          isBundledApp: _this4.isBundledApp,
          zcashBinaryPlaceholder: _this4.platform === 'win32' ? 'C:\\path\\to\\zcashd.exe' : '/path/to/zcashd'
        })));

        _this4._$formFields = null;
        _this4._$usernameLabel = null;
        _this4._$passwordLabel = null;

        if (!_this4.rendered) {
          _this4.rendered = true;
          setTimeout(function () {
            if (!_this4.showConfigureTorMessage && !_this4.showTorUnavailableMessage) {
              _this4.getCachedEl('.js-inputName').focus();
            }
          });
        }
      });

      return this;
    }
  }, {
    key: '$formFields',
    get: function get() {
      return this._$formFields || (this._$formFields = this.$('select[name], input[name], textarea[name]'));
    }
  }, {
    key: '$usernameLabel',
    get: function get() {
      return this._$usernameLabel || (this._$usernameLabel = this.$('.js-usernameLabel'));
    }
  }, {
    key: '$passwordLabel',
    get: function get() {
      return this._$passwordLabel || (this._$passwordLabel = this.$('.js-passwordLabel'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;