'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _electron = require('electron');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _serverConnect = require('../../../utils/serverConnect');

var _serverConnect2 = _interopRequireDefault(_serverConnect);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _Configuration = require('./Configuration');

var _Configuration2 = _interopRequireDefault(_Configuration);

var _StatusBar = require('./StatusBar');

var _StatusBar2 = _interopRequireDefault(_StatusBar);

var _modalManager = require('../../../utils/modalManager');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var localServer = _electron.remote.getGlobal('localServer');

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a server configurations collection.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.configViews = [];
    _this.emptyConfigs = !!_this.collection.length;
    _this.pendingDisconnectServerId = null;

    _this.listenTo(_this.collection, 'update', function (cl) {
      var prevEmptyConfigs = _this.emptyConfigs;
      _this.emptyConfigs = !!cl.length;

      if (_this.emptyConfigs !== prevEmptyConfigs) {
        _this.render();
      }
    });

    _this.listenTo(_serverConnect.events, 'connecting local-server-stopped', function (e) {
      _this.$statusBarOuterWrap.removeClass('hide');
      _this.statusBarMessage.setState({
        status: 'connecting',
        msg: _app2.default.polyglot.t('connectionManagement.statusBar.connectAttemptMsg', {
          serverName: e.server.get('name'),
          cancelConnAttempt: '<a class="js-cancelLink">' + (_app2.default.polyglot.t('connectionManagement.statusBar.cancelConnAttempt') + '</a>')
        })
      });

      _this.configViews.forEach(function (configVw) {
        if (configVw.model.id === e.server.id) {
          configVw.setState({ status: 'connecting' });
        } else {
          configVw.setState({ status: 'not-connected' });
        }
      });
    });

    _this.listenTo(_serverConnect.events, 'waiting-for-local-server-stop', function (e) {
      _this.statusBarMessage.setState({
        status: 'connecting',
        msg: _app2.default.polyglot.t('connectionManagement.statusBar.waitForServerStopMsg', {
          serverName: e.stoppingServer.get('name')
        })
      });
    });

    _this.listenTo(_serverConnect.events, 'disconnected', function (e) {
      var curConn = (0, _serverConnect.getCurrentConnection)();

      // If the disconnect was at the users request (ie.
      // they pressed the Disconnect button), we'll just
      // change the button state.
      if (_this.pendingDisconnectServerId === e.server.id) {
        _this.pendingDisconnectServerId = null;
        var disconnectedServer = _this.configViews.filter(function (vw) {
          return vw.model.id === e.server.id;
        });
        disconnectedServer = disconnectedServer && disconnectedServer[0];
        if (disconnectedServer) disconnectedServer.setState({ status: 'not-connected' });
        return;
      }

      _this.pendingDisconnectServerId = null;

      // If the disconnect is from a removed configuration (e.g. the user
      // deleted the config), we'll do nothing.
      if (!_app2.default.serverConfigs.get(e.server.id)) return;

      // If we lost a connection, but another one is in progress,
      // we'll do nothing. Otherwise, we'll show a "lost connection"
      // state for the disconnected connection.
      if (!(curConn && curConn.socket !== e.socket)) {
        _this.handleFailedConnection('disconnected', e);
      }
    });

    _this.listenTo(_serverConnect.events, 'connect-attempt-failed', function (e) {
      return _this.handleFailedConnection('connect-attempt-failed', e);
    });

    _this.listenTo(_serverConnect.events, 'connected', function (e) {
      _this.$statusBarOuterWrap.addClass('hide');
      _this.getConfigVw(e.server.id).setState({ status: 'connected' });
    });

    _this.listenTo(_this.collection, 'remove', function (cl, md, opts) {
      _this.configViews[opts.index].remove();
      delete _this.configViews[opts.index];
    });

    _this.listenTo(_this.collection, 'add', function (md) {
      var configVw = _this.createConfigView({ model: md });
      _this.configViews.push(configVw);
      _this.$serverConfigsContainer.append(configVw.render().el);
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'configurations';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-btnNew': 'onNewClick',
        'click .js-editServer': 'onClickEditServer'
      };
    }
  }, {
    key: 'handleFailedConnection',
    value: function handleFailedConnection(eventName, e) {
      var links = '<a href="https://github.com/OpenBazaar/openbazaar-desktop/blob/master/docs/connectionIssues.md">' + _app2.default.polyglot.t('connectionManagement.statusBar.needHelpLink') + '</a>';
      var msg = '';

      if (localServer) {
        links = '<a class="js-viewDebugLog">' + ('' + _app2.default.polyglot.t('connectionManagement.statusBar.viewLocalServerDebugLogLink')) + ('</a>&nbsp;|&nbsp;<a>' + links + '</a>');
      }

      if (e.reason === 'authentication-failed') {
        if (e.server.get('default')) {
          // If the default server fails with an auth issue, it's because the cookie token is
          // invalid. This should never happen and must be a dev error.
          msg = _app2.default.polyglot.t('connectionManagement.statusBar.errorAuthFailedBuiltInServer', {
            serverName: e.server.get('name'),
            errorPreface: '<span class="txB">' + (_app2.default.polyglot.t('connectionManagement.statusBar.errorPreface') + '</span>'),
            links: links
          });
        } else {
          msg = _app2.default.polyglot.t('connectionManagement.statusBar.errorAuthFailed', {
            serverName: e.server.get('name'),
            errorPreface: '<span class="txB">' + (_app2.default.polyglot.t('connectionManagement.statusBar.errorPreface') + '</span>'),
            links: links
          });
        }
      } else if (e.reason === 'canceled') {
        this.$statusBarOuterWrap.addClass('hide');
        this.configViews.forEach(function (configVw) {
          return configVw.setState({ status: 'not-connected' });
        });
        return;
      } else if (e.reason === 'tor-not-configured') {
        msg = _app2.default.polyglot.t('connectionManagement.statusBar.errorTorNotConfigured', {
          serverName: e.server.get('name'),
          editLink: '<a class="js-editServer" data-server-id="' + e.server.id + '">' + (_app2.default.polyglot.t('connectionManagement.statusBar.editLink') + '</a>'),
          links: links
        });

        if (!this.$el.is(':visible')) {
          // If the connection modal is not open, we'll open up the configuration form. The modal
          // will be opened shortly upon the connection failure. If the user already had the modal
          // open, we won't auto send them to the config form, since it may interrupt something else
          // they may be doing.
          this.trigger('editConfig', {
            model: this.collection.activeServer
          });
        }
      } else if (e.reason === 'tor-not-available') {
        msg = _app2.default.polyglot.t('connectionManagement.statusBar.errorTorNotAvailable', {
          serverName: e.server.get('name'),
          editLink: '<a class="js-editServer" data-server-id="' + e.server.id + '">' + (_app2.default.polyglot.t('connectionManagement.statusBar.editLink') + '</a>'),
          links: links
        });

        if (!this.$el.is(':visible')) {
          // If the connection modal is not open, we'll open up the configuration form. The modal
          // will be opened shortly upon the connection failure. If the user already had the modal
          // open, we won't auto send them to the config form, since it may interrupt something else
          // they may be doing.
          this.trigger('editConfig', {
            model: this.collection.activeServer
          });
        }
      } else if (eventName === 'disconnected') {
        msg = _app2.default.polyglot.t('connectionManagement.statusBar.errorConnectionLost', {
          serverName: e.server.get('name'),
          errorPreface: '<span class="txB">' + (_app2.default.polyglot.t('connectionManagement.statusBar.errorPreface') + '</span>'),
          links: links
        });
      } else {
        // generic unable to reach server
        msg = _app2.default.polyglot.t('connectionManagement.statusBar.errorUnableToReachServer', {
          serverName: e.server.get('name'),
          errorPreface: '<span class="txB">' + (_app2.default.polyglot.t('connectionManagement.statusBar.errorPreface') + '</span>'),
          links: links
        });
      }

      this.statusBarMessage.setState({
        status: 'connect-attempt-failed',
        msg: msg
      });
      // this.$statusBarOuterWrap.removeClass('hide');

      this.getConfigVw(e.server.id).setState({ status: 'connect-attempt-failed' });
    }
  }, {
    key: 'onNewClick',
    value: function onNewClick() {
      this.trigger('newClick');
    }
  }, {
    key: 'onClickEditServer',
    value: function onClickEditServer(e) {
      var serverId = e.target.getAttribute('data-server-id');

      if (serverId !== null) {
        var model = this.collection.get(serverId);
        if (model) {
          this.trigger('editConfig', { model: model });
        }
      }
    }
  }, {
    key: 'onConfigConnectClick',
    value: function onConfigConnectClick(e) {
      var serverConfig = this.collection.at(this.configViews.indexOf(e.view));
      (0, _serverConnect2.default)(serverConfig);
    }
  }, {
    key: 'onConfigDisconnectClick',
    value: function onConfigDisconnectClick(e) {
      (0, _serverConnect.disconnect)();
      this.pendingDisconnectServerId = e.view.model.id;
    }
  }, {
    key: 'getConfigVw',
    value: function getConfigVw(id) {
      return this.configViews.filter(function (configVw) {
        return configVw.model.id === id;
      })[0];
    }
  }, {
    key: 'cancelConnAttempt',
    value: function cancelConnAttempt() {
      var curConn = (0, _serverConnect.getCurrentConnection)();

      if (curConn && curConn.cancel) curConn.cancel();
    }
  }, {
    key: 'createConfigView',
    value: function createConfigView() {
      var _this2 = this;

      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var opts = _extends({}, options);

      if (!opts.model) {
        throw new Error('Please provide a server config model in the options.');
      }

      var curConn = (0, _serverConnect.getCurrentConnection)();

      if (curConn && curConn.server.id === opts.model.id) {
        opts.initialState = _extends({
          status: curConn.status
        }, opts.initialState);
      }

      var configVw = this.createChild(_Configuration2.default, opts);
      this.listenTo(configVw, 'connectClick', this.onConfigConnectClick);
      this.listenTo(configVw, 'disconnectClick', this.onConfigDisconnectClick);
      this.listenTo(configVw, 'cancelClick', function () {
        return _this2.cancelConnAttempt();
      });
      this.listenTo(configVw, 'editClick', function (e) {
        return _this2.trigger('editConfig', { model: e.view.model });
      });

      return configVw;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/connectionManagement/configurations.html', function (t) {
        _this3.$el.html(t({
          configurations: _this3.collection.toJSON()
        }));

        _this3.$serverConfigsContainer = _this3.$('.js-serverConfigsContainer');
        _this3._$statusBarOuterWrap = null;

        _this3.configViews.forEach(function (configVw) {
          return configVw.remove();
        });
        _this3.configViews = [];

        var configContainer = document.createDocumentFragment();
        _this3.collection.forEach(function (md) {
          var configVw = _this3.createConfigView({ model: md });
          _this3.configViews.push(configVw);
          configContainer.appendChild(configVw.render().el);
        });

        _this3.$serverConfigsContainer.html(configContainer);

        if (_this3.statusBarMessage) _this3.statusBarMessage.remove();
        _this3.statusBarMessage = _this3.createChild(_StatusBar2.default);
        _this3.listenTo(_this3.statusBarMessage, 'closeClick', function () {
          return _this3.$statusBarOuterWrap.addClass('hide');
        });
        _this3.listenTo(_this3.statusBarMessage, 'clickViewDebugLog', function () {
          return (0, _modalManager.launchDebugLogModal)();
        });
        _this3.listenTo(_this3.statusBarMessage, 'clickCancelLink', function () {
          return _this3.cancelConnAttempt();
        });
        _this3.$('.js-statusBarMessageContainer').append(_this3.statusBarMessage.render().el);
      });

      return this;
    }
  }, {
    key: '$statusBarOuterWrap',
    get: function get() {
      return this._$statusBarOuterWrap || (this._$statusBarOuterWrap = this.$('.js-statusBarOuterWrap'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;