'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _serverConnect = require('../../../utils/serverConnect');

var _serverConnect2 = _interopRequireDefault(_serverConnect);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _ServerConfig = require('../../../models/ServerConfig');

var _ServerConfig2 = _interopRequireDefault(_ServerConfig);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _Configurations = require('./Configurations');

var _Configurations2 = _interopRequireDefault(_Configurations);

var _ConfigurationForm = require('./ConfigurationForm');

var _ConfigurationForm2 = _interopRequireDefault(_ConfigurationForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      initialTabView: 'Configurations'
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this.tabViewCache = {};
    _this.tabViews = {
      Configurations: _Configurations2.default,
      ConfigurationForm: _ConfigurationForm2.default
    };
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' connectionManagement tabbedModal modalScrollPage';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-tab': 'onTabClick'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onTabClick',
    value: function onTabClick(e) {
      var targ = (0, _jquery2.default)(e.target).closest('.js-tab');
      this.selectTab(targ.data('tab'), targ);
    }
  }, {
    key: 'createConfigurationsTabView',
    value: function createConfigurationsTabView() {
      var _this2 = this;

      var configTab = this.createChild(_Configurations2.default, {
        collection: _app2.default.serverConfigs
      });

      this.listenTo(configTab, 'editConfig', function (e) {
        return _this2.selectTab('ConfigForm', { viewOptions: e || {} });
      });
      this.listenTo(configTab, 'newClick', function () {
        return _this2.selectTab('ConfigForm');
      });

      return configTab;
    }
  }, {
    key: 'createConfigurationFormView',
    value: function createConfigurationFormView() {
      var _this3 = this;

      var viewOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!viewOptions.model) {
        throw new Error('Please provide a server config model.');
      }

      var configForm = new _ConfigurationForm2.default(_extends({}, viewOptions));
      this.listenTo(configForm, 'cancel', function () {
        return _this3.selectTab('Configurations');
      });
      this.listenTo(configForm, 'saved', function () {
        _this3.selectTab('Configurations');
        _app2.default.serverConfigs.add(configForm.model, { merge: true });
        (0, _serverConnect2.default)(configForm.model);
      });

      return configForm;
    }
  }, {
    key: 'selectTab',
    value: function selectTab(tabViewName) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var $tabTarg = data.targ;
      var $tabs = null;
      var tabView = this.tabViewCache[tabViewName];
      data.viewOptions = data.viewOptions || {};

      if (!$tabTarg && !(tabViewName === 'ConfigForm' && data.viewOptions.model)) {
        $tabs = this.$('.js-tab');
        $tabTarg = $tabs.filter('[data-tab=' + tabViewName + ']');
      }

      if (!this.currentTabView || this.currentTabView !== tabView) {
        $tabs = $tabs || this.$('.js-tab');
        $tabs.removeClass('clrT active');
        if ($tabTarg) $tabTarg.addClass('clrT active');
        if (this.currentTabView) this.currentTabView.$el.detach();

        if (tabViewName === 'ConfigForm') {
          // we won't cache the Config Form tab and we'll manage it ourselves
          this.currentTabView = this.createConfigurationFormView(_extends({}, data.viewOptions, {
            model: data.viewOptions.model || new _ServerConfig2.default()
          }));
          this.$tabContent.append(this.currentTabView.render().el);
        } else {
          if (!tabView) {
            if (this['create' + tabViewName + 'TabView']) {
              tabView = this['create' + tabViewName + 'TabView'].apply(this, [data.viewOptions || {}]);
            } else {
              tabView = this.createChild(this.tabViews[tabViewName]);
            }

            this.tabViewCache[tabViewName] = tabView;
            tabView.render();
          }

          this.$tabContent.append(tabView.$el);
          this.currentTabView = tabView;
        }
      }
    }
  }, {
    key: 'close',
    value: function close() {
      this.selectTab('Configurations');
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'close', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('modals/connectionManagement/connectionManagement.html', function (t) {
        _this4.$el.html(t());
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this4).call(_this4);

        _this4.$tabContent = _this4.$('.js-tabContent');
        _this4._$closeClickTargets = null;

        _this4.selectTab(_this4.options.initialTabView);
      });

      return this;
    }
  }, {
    key: 'closeClickTargets',
    get: function get() {
      return [].concat(_toConsumableArray(this.$closeClickTargets.get()), _toConsumableArray(_get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'closeClickTargets', this)));
    }
  }, {
    key: '$closeClickTargets',
    get: function get() {
      return this._$closeClickTargets || (this._$closeClickTargets = this.$('.js-closeClickTarget'));
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;