'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Coupon = require('../../../models/listing/Coupon');

var _Coupon2 = _interopRequireDefault(_Coupon);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _Coupon3 = require('./Coupon');

var _Coupon4 = _interopRequireDefault(_Coupon3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a collection.');
    }

    if (typeof options.maxCouponCount === 'undefined') {
      throw new Error('Please provide the maximum coupon count.');
    }

    // Certain coupon validations are not possible to do purely in the Coupon
    // model (e.g. validating the coupon price is not greater than the listing price).
    // In that case, any coupon related errors can be optionally passed in, in the
    // following format:
    // options.couponErrors = {
    //   coupons[<model.cid>].<fieldName> = ['error1', 'error2', ...],
    //   coupons[<model.cid>].<fieldName2> = ['error1', 'error2', ...],
    //   coupons[<model2.cid>].<fieldName> = ['error1', 'error2', ...]
    // }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    _this.couponViews = [];

    _this.listenTo(_this.collection, 'add', function (md, cl) {
      var index = cl.indexOf(md);
      var view = _this.createCouponView(md);

      if (index) {
        _this.$couponsWrap.find('> *').eq(index - 1).after(view.render().el);
      } else {
        _this.$couponsWrap.prepend(view.render().el);
      }

      _this.couponViews.splice(index, 0, view);

      if (_this.collection.length >= _this.options.maxCouponCount) {
        _this.$addCoupon.addClass('hide');
      }
    });

    _this.listenTo(_this.collection, 'remove', function (md, cl, removeOpts) {
      _this.couponViews.splice(removeOpts.index, 1)[0].remove();

      if (_this.collection.length < _this.options.maxCouponCount) {
        _this.$addCoupon.removeClass('hide');
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'events',
    value: function events() {
      return {
        'click .js-addCoupon': 'onClickAddCoupon'
      };
    }
  }, {
    key: 'onClickAddCoupon',
    value: function onClickAddCoupon() {
      this.collection.add(new _Coupon2.default());
      this.couponViews[this.couponViews.length - 1].$('input[name=title]').focus();
    }
  }, {
    key: 'setCollectionData',
    value: function setCollectionData() {
      this.couponViews.forEach(function (coupon) {
        return coupon.setModelData();
      });
    }
  }, {
    key: 'createCouponView',
    value: function createCouponView(model) {
      var _this2 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var couponErrors = {};

      if (this.options.couponErrors) {
        Object.keys(this.options.couponErrors).forEach(function (errKey) {
          if (errKey.startsWith('coupons[' + model.cid + ']')) {
            couponErrors[errKey.slice(errKey.indexOf('.') + 1)] = _this2.options.couponErrors[errKey];
          }
        });
      }

      var view = this.createChild(_Coupon4.default, _extends({
        model: model,
        getCurrency: function getCurrency() {
          return 'USD';
        },
        couponErrors: couponErrors
      }, options));

      this.listenTo(view, 'remove-click', function (e) {
        return _this2.collection.remove(e.view.model);
      });

      return view;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      (0, _loadTemplate2.default)('modals/editListing/coupons.html', function (t) {
        _this3.$el.html(t({
          coupons: _this3.collection.toJSON(),
          maxCouponCount: _this3.options.maxCouponCount
        }));

        _this3.$couponsWrap = _this3.$('.js-couponsWrap');
        _this3._$addCoupon = null;

        _this3.couponViews.forEach(function (coupon) {
          return coupon.remove();
        });
        _this3.couponViews = [];
        var couponsFrag = document.createDocumentFragment();

        _this3.collection.forEach(function (coupon) {
          var view = _this3.createCouponView(coupon);
          _this3.couponViews.push(view);
          view.render().$el.appendTo(couponsFrag);
        });

        _this3.$couponsWrap.append(couponsFrag);
      });

      return this;
    }
  }, {
    key: '$addCoupon',
    get: function get() {
      return this._$addCoupon || (this._$addCoupon = this.$('.js-addCoupon'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;