'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

require('../../../lib/select2');

var _currency = require('../../../utils/currency');

var _cryptoCurrencies = require('../../../data/cryptoCurrencies');

var _cryptoListingCurrencies = require('../../../data/cryptoListingCurrencies');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model) {
      throw new Error('Please provide a Listing model.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.listenTo(_app2.default.settings, 'change:localCurrency', function () {
      _this.getCachedEl('.js-marketValueWrap').html(_this.tmplMarketValue({ getDataFromUi: true }));
    });

    _this.listenTo(_currency.events, 'exchange-rate-change', function (e) {
      if (e.changed.includes(_app2.default.settings.get('localCurrency')) || e.changed.includes(_this.getCachedEl('#editListingCoinType').val())) {
        _this.getCachedEl('.js-marketValueWrap').html(_this.tmplMarketValue({ getDataFromUi: true }));
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'cryptoCurrencyType padSmKids padStackAll';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'change #editListingCoinType': 'onChangeCoinType',
        'keyup #editListingCryptoQuantity': 'onKeyupQuantity'
      };
    }
  }, {
    key: 'onChangeCoinType',
    value: function onChangeCoinType(e) {
      this.getCachedEl('.js-quantityCoinType').text(e.target.value);
      this.getCachedEl('.js-marketValueWrap').html(this.tmplMarketValue({ getDataFromUi: true }));
    }
  }, {
    key: 'onKeyupQuantity',
    value: function onKeyupQuantity() {
      var _this2 = this;

      clearTimeout(this.quantityKeyUpTimeout);
      this.quantityKeyUpTimeout = setTimeout(function () {
        _this2.getCachedEl('.js-marketValueWrap').html(_this2.tmplMarketValue({ getDataFromUi: true }));
      }, 200);
    }
  }, {
    key: 'tmplTypeHelper',
    value: function tmplTypeHelper() {
      return _app2.default.polyglot.t('editListing.cryptoCurrencyType.helperType', { curCode: (0, _cryptoCurrencies.getServerCurrency)().code });
    }
  }, {
    key: 'tmplMarketValue',
    value: function tmplMarketValue() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var opts = _extends({
        getDataFromUi: false,
        coinType: options.getDataFromUi ? this.getCachedEl('#editListingCoinType').val() : this.defaultCoinType,
        quantity: options.getDataFromUi ? this.getCachedEl('#editListingCryptoQuantity').val() : this.model.get('item').get('cryptoQuantity'),
        displayCur: _app2.default.settings.get('localCurrency')
      }, options);

      var displayCur = opts.displayCur,
          coinType = opts.coinType;

      var quantity = Number(opts.quantity);

      if (isNaN(quantity)) quantity = 0;

      var cryptoExchangeRate = (0, _currency.getExchangeRate)(coinType);
      var displayCurExchangeRate = (0, _currency.getExchangeRate)(displayCur);
      var cryptoFormattedPrice = _app2.default.polyglot.t('cryptoCurrencyFormat.curCodeAmount', { amount: quantity, code: coinType });

      if (typeof cryptoExchangeRate !== 'number') {
        var tip = _app2.default.polyglot.t('editListing.cryptoCurrencyType.tipMissingCryptoExchangeRate', { coinType: coinType });
        return '<span class="toolTip" data-tip="' + tip + '">' + ('<span class="clrTErr tx4 txB">' + cryptoFormattedPrice + '</span>&nbsp;') + '<span class="ion-alert-circled clrTErr"></span></span>';
      }

      if (coinType !== displayCur) {
        if (typeof displayCurExchangeRate === 'number') {
          var total = (0, _currency.convertAndFormatCurrency)(quantity, coinType, displayCur);
          var perCoin = (0, _currency.convertAndFormatCurrency)(1, coinType, displayCur);
          var perCoinText = _app2.default.polyglot.t('editListing.cryptoCurrencyType.marketValuePerCoin', { amount: perCoin, curCode: coinType });
          return '<span class="clrTEm tx4 txB">' + total + '</span> ' + perCoinText;
        }

        var _tip = _app2.default.polyglot.t('editListing.cryptoCurrencyType.tipMissingLocalExchangeRate', { coinType: coinType });
        return '<span class="toolTip" data-tip="' + _tip + '">' + ('<span class="clrTEm tx4 txB">' + quantity + ' ' + coinType + '</span>&nbsp;') + '<span class="ion-alert-circled clrTAlert"></span></span>';
      }

      return '<span class="clrTEm tx4 txB">' + cryptoFormattedPrice + '</span>';
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('modals/editListing/cryptoCurrencyType.html', function (t) {
        _this3.$el.html(t(_extends({
          contractTypes: _this3.model.get('metadata').contractTypesVerbose,
          coinTypes: _this3.currencies,
          helperType: _this3.tmplTypeHelper(),
          marketVal: _this3.tmplMarketValue(),
          errors: _this3.model.validationError || {}
        }, _this3.model.toJSON())));

        _this3.$('#editListingCryptoContractType').select2({
          minimumResultsForSearch: Infinity
        });

        _this3.$('#editListingCoinType').select2({
          minimumResultsForSearch: 5,
          matcher: function matcher(params, data) {
            if (!params.term || params.term.trim() === '') {
              return data;
            }

            var term = params.term.toUpperCase().trim();

            if (data.text.toUpperCase().includes(term) || data.id.includes(term)) {
              return data;
            }

            return null;
          }
        });
      });

      return this;
    }
  }, {
    key: 'currencies',
    get: function get() {
      var coinTypes = (0, _cryptoListingCurrencies.getCurrenciesSortedByName)().map(function (coin) {
        var translationKey = 'cryptoCurrencies.' + coin;

        return {
          code: coin,
          name: _app2.default.polyglot.t(translationKey) === translationKey ? coin : _app2.default.polyglot.t('cryptoCurrenciesNameCodePairing', {
            name: _app2.default.polyglot.t(translationKey),
            code: coin
          })
        };
      });

      var coinType = this.model.get('metadata').get('coinType');

      if (coinType && coinType.length && !coinTypes.find(function (coin) {
        return coin.code === coinType;
      })) {
        // If the listing has a coin type that's not in our crypto currency list,
        // we'll just plop it at the end of the list. It may be that our crypto cur list
        // needs to be updated and/or the exchange rate api is misbehaving. In either case, if the
        // exchange rate data is not available, a warning will be shown.
        coinTypes.push({
          code: coinType,
          name: coinType
        });
      }

      return coinTypes;
    }
  }, {
    key: 'defaultCoinType',
    get: function get() {
      return this.model.get('metadata').get('coinType') || this.currencies[0].code;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;