'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../../../utils/lib/velocity');

require('../../../lib/select2');

var _selectize = require('../../../utils/lib/selectize');

var _sortablejs = require('sortablejs');

var _sortablejs2 = _interopRequireDefault(_sortablejs);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

require('../../../utils/lib/velocityUiPack.js');

var _backbone = require('backbone');

var _backbone2 = _interopRequireDefault(_backbone);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _dom = require('../../../utils/dom');

var _trumbowyg = require('../../../utils/lib/trumbowyg');

var _currencies = require('../../../data/currencies');

var _currency = require('../../../utils/currency');

var _object = require('../../../utils/object');

var _SimpleMessage = require('../SimpleMessage');

var _SimpleMessage2 = _interopRequireDefault(_SimpleMessage);

var _Dialog = require('../Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _ShippingOption = require('../../../models/listing/ShippingOption');

var _ShippingOption2 = _interopRequireDefault(_ShippingOption);

var _Service = require('../../../models/listing/Service');

var _Service2 = _interopRequireDefault(_Service);

var _Image = require('../../../models/listing/Image');

var _Image2 = _interopRequireDefault(_Image);

var _Coupon = require('../../../models/listing/Coupon');

var _Coupon2 = _interopRequireDefault(_Coupon);

var _VariantOption = require('../../../models/listing/VariantOption');

var _VariantOption2 = _interopRequireDefault(_VariantOption);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _ShippingOption3 = require('./ShippingOption');

var _ShippingOption4 = _interopRequireDefault(_ShippingOption3);

var _Coupons = require('./Coupons');

var _Coupons2 = _interopRequireDefault(_Coupons);

var _Variants = require('./Variants');

var _Variants2 = _interopRequireDefault(_Variants);

var _VariantInventory = require('./VariantInventory');

var _VariantInventory2 = _interopRequireDefault(_VariantInventory);

var _InventoryManagement = require('./InventoryManagement');

var _InventoryManagement2 = _interopRequireDefault(_InventoryManagement);

var _SkuField = require('./SkuField');

var _SkuField2 = _interopRequireDefault(_SkuField);

var _UnsupportedCurrency = require('./UnsupportedCurrency');

var _UnsupportedCurrency2 = _interopRequireDefault(_UnsupportedCurrency);

var _CryptoCurrencyType = require('./CryptoCurrencyType');

var _CryptoCurrencyType2 = _interopRequireDefault(_CryptoCurrencyType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model) {
      throw new Error('Please provide a model.');
    }

    if (options.onClickViewListing !== undefined && typeof options.onClickViewListing !== 'function') {
      throw new Error('If providing an onClickViewListing option, it must be ' + 'provided as a function.');
    }

    var opts = _extends({
      removeOnClose: true
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    // So the passed in modal does not get any un-saved data,
    // we'll clone and update it on sync
    _this._origModel = _this.model;
    _this.model = _this._origModel.clone();

    _this.listenTo(_this.model, 'sync', function () {
      setTimeout(function () {
        if (_this.createMode && !_this.model.isNew()) {
          _this.createMode = false;
          _this.$('.js-listingHeading').text(_app2.default.polyglot.t('editListing.editListingLabel'));
          _this.getCachedEl('.js-viewListing').removeClass('hide');
        }

        var updatedData = _this.model.toJSON();

        // Will parse out some sku attributes that are specific to the variant
        // inventory view.
        updatedData.item.skus = updatedData.item.skus.map(function (sku) {
          return _underscore2.default.omit(sku, 'mappingId', 'choices');
        });

        if (updatedData.item.quantity === undefined) {
          _this._origModel.get('item').unset('quantity');
        }

        if (updatedData.item.productID === undefined) {
          _this._origModel.get('item').unset('productID');
        }

        _this._origModel.set(updatedData);
      });

      // A change event won't fire on a parent model if only nested attributes change.
      // The nested models would need to have change events manually bound to them
      // which is cumbersome with a model like this with so many levels of nesting.
      // If you are interested in any change on the model (as opposed to a sepcific
      // attribute), the simplest thing to do is use the 'saved' event from the
      // event emitter in models/listing/index.js.
    });

    _this.selectedNavTabIndex = 0;
    _this.createMode = !(_this.model.lastSyncedAttrs && _this.model.lastSyncedAttrs.slug);
    _this.photoUploads = [];
    _this.images = _this.model.get('item').get('images');
    _this.shippingOptions = _this.model.get('shippingOptions');
    _this.shippingOptionViews = [];

    (0, _loadTemplate2.default)('modals/editListing/uploadPhoto.html', function (uploadT) {
      return _this.uploadPhotoT = uploadT;
    });

    _this.listenTo(_this.images, 'add', _this.onAddImage);
    _this.listenTo(_this.images, 'remove', _this.onRemoveImage);

    _this.listenTo(_this.shippingOptions, 'add', function (shipOptMd) {
      var shipOptVw = _this.createShippingOptionView({
        listPosition: _this.shippingOptions.length,
        model: shipOptMd
      });

      _this.shippingOptionViews.push(shipOptVw);
      _this.$shippingOptionsWrap.append(shipOptVw.render().el);
    });

    _this.listenTo(_this.shippingOptions, 'remove', function (shipOptMd, shipOptCl, removeOpts) {
      var _this$shippingOptionV = _this.shippingOptionViews.splice(removeOpts.index, 1),
          _this$shippingOptionV2 = _slicedToArray(_this$shippingOptionV, 1),
          splicedVw = _this$shippingOptionV2[0];

      splicedVw.remove();
      _this.shippingOptionViews.slice(removeOpts.index).forEach(function (shipOptVw) {
        return shipOptVw.listPosition = shipOptVw.listPosition - 1;
      });
    });

    _this.listenTo(_this.shippingOptions, 'update', function (cl, updateOpts) {
      if (!(updateOpts.changes.added.length || updateOpts.changes.removed.length)) {
        return;
      }

      _this.$addShipOptSectionHeading.text(_app2.default.polyglot.t('editListing.shippingOptions.optionHeading', { listPosition: _this.shippingOptions.length + 1 }));
    });

    _this.coupons = _this.model.get('coupons');
    _this.listenTo(_this.coupons, 'update', function () {
      if (_this.coupons.length) {
        _this.$couponsSection.addClass('expandedCouponView');
      } else {
        _this.$couponsSection.removeClass('expandedCouponView');
      }
    });

    _this.variantOptionsCl = _this.model.get('item').get('options');

    _this.listenTo(_this.variantOptionsCl, 'update', _this.onUpdateVariantOptions);

    _this.$el.on('scroll', function () {
      if (_this.el.scrollTop > 57 && !_this.$el.hasClass('fixedNav')) {
        _this.$el.addClass('fixedNav');
      } else if (_this.el.scrollTop <= 57 && _this.$el.hasClass('fixedNav')) {
        _this.$el.removeClass('fixedNav');
      }
    });

    if (_this.trackInventoryBy === 'DO_NOT_TRACK') {
      _this.$el.addClass('notTrackingInventory');
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' editListing tabbedModal modalScrollPage';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-scrollLink': 'onScrollLinkClick',
        'click .js-return': 'onClickReturn',
        'click .js-save': 'onSaveClick',
        'change #editContractType': 'onChangeContractType',
        'change #editListingCryptoContractType': 'onChangeCryptoContractType',
        'change .js-price': 'onChangePrice',
        'change #inputPhotoUpload': 'onChangePhotoUploadInput',
        'click .js-addPhoto': 'onClickAddPhoto',
        'click .js-removeImage': 'onClickRemoveImage',
        'click .js-cancelPhotoUploads': 'onClickCancelPhotoUploads',
        'click .js-addReturnPolicy': 'onClickAddReturnPolicy',
        'click .js-addTermsAndConditions': 'onClickAddTermsAndConditions',
        'click .js-addShippingOption': 'onClickAddShippingOption',
        'click .js-btnAddCoupon': 'onClickAddCoupon',
        'click .js-addFirstVariant': 'onClickAddFirstVariant',
        'keyup .js-variantNameInput': 'onKeyUpVariantName',
        'click .js-scrollToVariantInventory': 'onClickScrollToVariantInventory',
        'click .js-viewListing': 'onClickViewListing'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onClickReturn',
    value: function onClickReturn() {
      this.trigger('click-return', { view: this });
    }
  }, {
    key: 'onClickViewListing',
    value: function onClickViewListing() {
      if (this.options.onClickViewListing) {
        this.options.onClickViewListing.call(this);
      } else {
        var slug = this.model.get('slug');
        if (slug) {
          _app2.default.router.navigate(_app2.default.profile.id + '/store/' + slug, { trigger: true });
        }
      }
    }
  }, {
    key: 'onAddImage',
    value: function onAddImage(image) {
      var imageHtml = this.uploadPhotoT(_extends({
        closeIconClass: 'js-removeImage'
      }, image.toJSON()));

      this.$photoUploadItems.append(imageHtml);
    }
  }, {
    key: 'onRemoveImage',
    value: function onRemoveImage(image, images, options) {
      // 1 is added to the index to account for the .addElement
      this.$photoUploadItems.find('li').eq(options.index + 1).remove();
    }
  }, {
    key: 'onClickRemoveImage',
    value: function onClickRemoveImage(e) {
      // since the first li is the .addElement, we need to subtract 1 from the index
      var removeIndex = (0, _jquery2.default)(e.target).parents('li').index() - 1;

      this.images.remove(this.images.at(removeIndex));
    }
  }, {
    key: 'onClickCancelPhotoUploads',
    value: function onClickCancelPhotoUploads() {
      this.inProgressPhotoUploads.forEach(function (photoUpload) {
        return photoUpload.abort();
      });
    }
  }, {
    key: 'onChangePrice',
    value: function onChangePrice(e) {
      var trimmedVal = (0, _jquery2.default)(e.target).val().trim();
      var numericVal = Number(trimmedVal);

      if (!isNaN(numericVal) && trimmedVal) {
        (0, _jquery2.default)(e.target).val((0, _currency.formatPrice)(numericVal, this.$currencySelect.val()));
      } else {
        (0, _jquery2.default)(e.target).val(trimmedVal);
      }

      this.variantInventory.render();
    }
  }, {
    key: 'setContractTypeClass',
    value: function setContractTypeClass(contractType) {
      var removeClasses = this.model.get('metadata').contractTypes.reduce(function (classes, type) {
        return classes + ' TYPE_' + type;
      }, '');

      this.$el.removeClass(removeClasses).addClass('TYPE_' + contractType);
    }
  }, {
    key: 'onChangeContractType',
    value: function onChangeContractType(e) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      this.setContractTypeClass(e.target.value);

      if (!data.fromCryptoTypeChange) {
        if (e.target.value === 'CRYPTOCURRENCY') {
          this.getCachedEl('#editListingCryptoContractType').val('CRYPTOCURRENCY');
          this.getCachedEl('#editListingCryptoContractType').trigger('change').focus();
        }
      }
    }
  }, {
    key: 'onChangeCryptoContractType',
    value: function onChangeCryptoContractType(e) {
      if (e.target.value === 'CRYPTOCURRENCY') return;

      this.getCachedEl('#editContractType').val(e.target.value);
      this.getCachedEl('#editContractType').trigger('change', { fromCryptoTypeChange: true }).focus();
    }
  }, {
    key: 'getOrientation',
    value: function getOrientation(file, callback) {
      var reader = new FileReader();

      reader.onload = function (e) {
        var dataView = new DataView(e.target.result); // eslint-disable-line no-undef
        var offset = 2;

        if (dataView.getUint16(0, false) !== 0xFFD8) return callback(-2);

        while (offset < dataView.byteLength) {
          var marker = dataView.getUint16(offset, false);
          offset += 2;
          if (marker === 0xFFE1) {
            offset += 2;
            if (dataView.getUint32(offset, false) !== 0x45786966) {
              return callback(-1);
            }
            var little = dataView.getUint16(offset += 6, false) === 0x4949;
            offset += dataView.getUint32(offset + 4, little);
            var tags = dataView.getUint16(offset, little);
            offset += 2;
            for (var i = 0; i < tags; i++) {
              if (dataView.getUint16(offset + i * 12, little) === 0x0112) {
                return callback(dataView.getUint16(offset + i * 12 + 8, little));
              }
            }
          } else if ((marker & 0xFF00) !== 0xFF00) {
            break;
          } else {
            offset += dataView.getUint16(offset, false);
          }
        }

        return callback(-1);
      };

      reader.readAsArrayBuffer(file.slice(0, 64 * 1024));
    }

    // todo: write a unit test for this

  }, {
    key: 'truncateImageFilename',
    value: function truncateImageFilename(filename) {
      if (!filename || typeof filename !== 'string') {
        throw new Error('Please provide a filename as a string.');
      }

      var truncated = filename;

      if (filename.length > _Image2.default.maxFilenameLength) {
        var parsed = _path2.default.parse(filename);
        var nameParseLen = _Image2.default.maxFilenameLength - parsed.ext.length;

        // acounting for rare edge case of the extension in and of itself
        // exceeding the max length
        return parsed.name.slice(0, nameParseLen < 0 ? 0 : nameParseLen) + parsed.ext.slice(0, _Image2.default.maxFilenameLength);
      }

      return truncated;
    }
  }, {
    key: 'onChangePhotoUploadInput',
    value: function onChangePhotoUploadInput() {
      var _this2 = this;

      var photoFiles = Array.prototype.slice.call(this.$inputPhotoUpload[0].files, 0);

      // prune out any non-image files
      photoFiles = photoFiles.filter(function (file) {
        return file.type.startsWith('image');
      });

      this.$inputPhotoUpload.val('');

      var currPhotoLength = this.model.get('item').get('images').length;

      if (currPhotoLength + photoFiles.length > this.MAX_PHOTOS) {
        photoFiles = photoFiles.slice(0, this.MAX_PHOTOS - currPhotoLength);

        new _SimpleMessage2.default({
          title: _app2.default.polyglot.t('editListing.errors.tooManyPhotosTitle'),
          message: _app2.default.polyglot.t('editListing.errors.tooManyPhotosBody')
        }).render().open();
      }

      if (!photoFiles.length) return;

      this.$photoUploadingLabel.removeClass('hide');

      var toUpload = [];
      var loaded = 0;
      var errored = 0;

      photoFiles.forEach(function (photoFile) {
        var newImage = document.createElement('img');

        newImage.src = photoFile.path;

        newImage.onload = function () {
          var imgW = newImage.width;
          var imgH = newImage.height;
          var canvas = document.createElement('canvas');
          var ctx = canvas.getContext('2d');

          canvas.width = imgW;
          canvas.height = imgH;

          _this2.getOrientation(photoFile, function (orientation) {
            if (orientation > 4) {
              canvas.width = imgH;
              canvas.height = imgW;
            }

            switch (orientation) {
              case 2:
                ctx.translate(imgW, 0);
                ctx.scale(-1, 1);break;
              case 3:
                ctx.translate(imgW, imgH);
                ctx.rotate(Math.PI);break;
              case 4:
                ctx.translate(0, imgH);
                ctx.scale(1, -1);break;
              case 5:
                ctx.rotate(0.5 * Math.PI);
                ctx.scale(1, -1);break;
              case 6:
                ctx.rotate(0.5 * Math.PI);
                ctx.translate(0, -imgH);break;
              case 7:
                ctx.rotate(0.5 * Math.PI);
                ctx.translate(imgW, -imgH);
                ctx.scale(-1, 1);break;
              case 8:
                ctx.rotate(-0.5 * Math.PI);
                ctx.translate(-imgW, 0);break;
              default: // do nothing
            }

            ctx.drawImage(newImage, 0, 0, imgW, imgH);
            toUpload.push({
              filename: _this2.truncateImageFilename(photoFile.name),
              image: canvas.toDataURL('image/jpeg', 0.9).replace(/^data:image\/(png|jpeg|webp);base64,/, '')
            });

            loaded += 1;

            if (loaded + errored === photoFiles.length) {
              _this2.uploadImages(toUpload);
            }
          });
        };

        newImage.onerror = function () {
          errored += 1;

          if (errored === photoFiles.length) {
            _this2.$photoUploadingLabel.addClass('hide');

            new _SimpleMessage2.default({
              title: _app2.default.polyglot.t('editListing.errors.unableToLoadImages', { smart_count: errored })
            }).render().open();
          } else if (loaded + errored === photoFiles.length) {
            _this2.uploadImages(toUpload);
          }
        };
      });
    }
  }, {
    key: 'onClickAddReturnPolicy',
    value: function onClickAddReturnPolicy(e) {
      (0, _jquery2.default)(e.target).addClass('hide');
      this.$editListingReturnPolicy.removeClass('hide').focus();
      this.expandedReturnPolicy = true;
    }
  }, {
    key: 'onClickAddTermsAndConditions',
    value: function onClickAddTermsAndConditions(e) {
      (0, _jquery2.default)(e.target).addClass('hide');
      this.$editListingTermsAndConditions.removeClass('hide').focus();
      this.expandedTermsAndConditions = true;
    }
  }, {
    key: 'onClickAddShippingOption',
    value: function onClickAddShippingOption() {
      this.shippingOptions.push(new _ShippingOption2.default({
        services: [new _Service2.default()]
      }));
    }
  }, {
    key: 'onClickAddCoupon',
    value: function onClickAddCoupon() {
      this.coupons.add(new _Coupon2.default());

      if (this.coupons.length === 1) {
        this.$couponsSection.find('.coupon input[name=title]').focus();
      }
    }
  }, {
    key: 'onClickAddFirstVariant',
    value: function onClickAddFirstVariant() {
      this.variantOptionsCl.add(new _VariantOption2.default());

      if (this.variantOptionsCl.length === 1) {
        this.$variantsSection.find('.variant input[name=name]').focus();
      }
    }
  }, {
    key: 'onKeyUpVariantName',
    value: function onKeyUpVariantName(e) {
      var _this3 = this;

      // wait until they stop typing
      if (this.variantNameKeyUpTimer) {
        clearTimeout(this.variantNameKeyUpTimer);
      }

      this.variantNameKeyUpTimer = setTimeout(function () {
        var index = (0, _jquery2.default)(e.target).closest('.variant').index();

        _this3.variantsView.setModelData(index);
      }, 150);
    }
  }, {
    key: 'onVariantChoiceChange',
    value: function onVariantChoiceChange(e) {
      var index = this.variantsView.views.indexOf(e.view);

      this.variantsView.setModelData(index);
    }
  }, {
    key: 'onUpdateVariantOptions',
    value: function onUpdateVariantOptions() {
      if (this.variantOptionsCl.length) {
        this.$variantsSection.addClass('expandedVariantsView');
        this.skuField.setState({ variantsPresent: true });

        if (this.inventoryManagement.getState().trackBy !== 'DO_NOT_TRACK') {
          this.inventoryManagement.setState({
            trackBy: 'TRACK_BY_VARIANT'
          });
        }
      } else {
        this.$variantsSection.removeClass('expandedVariantsView');
        this.skuField.setState({ variantsPresent: false });

        if (this.inventoryManagement.getState().trackBy !== 'DO_NOT_TRACK') {
          this.inventoryManagement.setState({
            trackBy: 'TRACK_BY_FIXED'
          });
        }
      }

      this.$variantInventorySection.toggleClass('hide', !this.shouldShowVariantInventorySection);
    }
  }, {
    key: 'onClickScrollToVariantInventory',
    value: function onClickScrollToVariantInventory() {
      this.scrollTo(this.$variantInventorySection);
    }
  }, {
    key: 'confirmClose',
    value: function confirmClose() {
      var _this4 = this;

      var deferred = _jquery2.default.Deferred();

      this.setModelData();
      var prevData = this.createMode ? this.attrsAtCreate : this.attrsAtLastSave;
      var curData = this.model.toJSON();

      if (!_underscore2.default.isEqual(prevData, curData)) {
        var messageKey = 'body' + (this.createMode ? 'Create' : 'Edit');
        this.bringToTop();
        this.closeConfirmDialog = this.createChild(_Dialog2.default, {
          removeOnClose: false,
          title: _app2.default.polyglot.t('editListing.confirmCloseDialog.title'),
          message: _app2.default.polyglot.t('editListing.confirmCloseDialog.' + messageKey),
          buttons: [{
            text: _app2.default.polyglot.t('editListing.confirmCloseDialog.btnYes'),
            fragment: 'yes'
          }, {
            text: _app2.default.polyglot.t('editListing.confirmCloseDialog.btnNo'),
            fragment: 'no'
          }]
        }).on('click-yes', function () {
          deferred.resolve();
          _this4.remove();
        }).on('click-no', function () {
          deferred.reject();
          _this4.closeConfirmDialog.close();
        }).on('close', function () {
          return deferred.reject();
        }).render().open();
      } else {
        deferred.resolve();
      }

      return deferred.promise();
    }
  }, {
    key: 'uploadImages',
    value: function uploadImages(images) {
      var _this5 = this;

      var imagesToUpload = images;

      if (!images) {
        throw new Error('Please provide a list of images to upload.');
      }

      if (typeof images === 'string') {
        imagesToUpload = [images];
      }

      var upload = _jquery2.default.ajax({
        url: _app2.default.getServerUrl('ob/images'),
        type: 'POST',
        data: JSON.stringify(imagesToUpload),
        dataType: 'json',
        contentType: 'application/json'
      }).always(function () {
        if (_this5.isRemoved()) return;
        if (!_this5.inProgressPhotoUploads.length) _this5.$photoUploadingLabel.addClass('hide');
      }).done(function (uploadedImages) {
        if (_this5.isRemoved()) return;

        _this5.images.add(uploadedImages.map(function (image) {
          return {
            filename: image.filename,
            original: image.hashes.original,
            large: image.hashes.large,
            medium: image.hashes.medium,
            small: image.hashes.small,
            tiny: image.hashes.tiny
          };
        }));
      }).fail(function (jqXhr) {
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('editListing.errors.uploadImageErrorTitle', { smart_count: imagesToUpload.length }), jqXhr.responseJSON && jqXhr.responseJSON.reason || '');
      });

      this.photoUploads.push(upload);
    }
  }, {
    key: 'onClickAddPhoto',
    value: function onClickAddPhoto() {
      this.$inputPhotoUpload.trigger('click');
    }
  }, {
    key: 'scrollTo',
    value: function scrollTo($el) {
      var _this6 = this;

      if (!$el) {
        throw new Error('Please provide a jQuery element to scroll to.');
      }

      // Had this initially in Velocity, but after markup re-factor, it
      // doesn't work consistently, so we'll go old-school for now.
      this.$el.animate({
        scrollTop: $el.position().top
      }, {
        complete: function complete() {
          setTimeout(function () {
            return _this6.$el.on('scroll', _this6.throttledOnScroll);
          }, 100);
        }
      }, 400);
    }
  }, {
    key: 'onScrollLinkClick',
    value: function onScrollLinkClick(e) {
      var index = (0, _jquery2.default)(e.target).index();
      this.selectedNavTabIndex = index;
      this.$scrollLinks.removeClass('active');
      (0, _jquery2.default)(e.target).addClass('active');
      this.$el.off('scroll', this.throttledOnScroll);
      this.scrollTo(this.$scrollToSections.eq(index));
    }
  }, {
    key: 'onScroll',
    value: function onScroll() {
      var index = 0;
      var keepLooping = true;

      while (keepLooping) {
        if ((0, _dom.isScrolledIntoView)(this.$scrollToSections[index])) {
          this.$scrollLinks.removeClass('active');
          this.$scrollLinks.eq(index).addClass('active');
          this.selectedNavTabIndex = index;
          keepLooping = false;
        } else {
          if (index === this.$scrollToSections.length - 1) {
            keepLooping = false;
          } else {
            index += 1;
          }
        }
      }
    }
  }, {
    key: 'onSaveClick',
    value: function onSaveClick() {
      var _this7 = this;

      this.$saveButton.addClass('disabled');
      this.setModelData();

      var serverData = this.model.toJSON();
      serverData.item.skus = serverData.item.skus.map(function (sku) {
        return (
          // The variant inventory view adds some stuff to the skus collection that
          // shouldn't go to the server. We'll ensure the extraneous stuff isn't sent
          // with the save while still allowing it to stay in the collection.
          _underscore2.default.omit(sku, 'mappingId', 'choices')
        );
      });

      var save = this.model.save({}, {
        attrs: serverData
      });

      if (save) {
        var savingStatusMsg = _app2.default.statusBar.pushMessage({
          msg: 'Saving listing...',
          type: 'message',
          duration: 99999999999999
        }).on('clickViewListing', function () {
          var guidUrl = '#' + _app2.default.profile.id + '/store/' + _this7.model.get('slug');
          var base = _app2.default.profile.get('handle') ? '@' + _app2.default.profile.get('handle') : _app2.default.profile.id;
          var url = base + '/store/' + _this7.model.get('slug');

          if (location.hash === guidUrl) {
            _backbone2.default.history.loadUrl();
          } else {
            _app2.default.router.navigateUser(url, _app2.default.profile.id, { trigger: true });
          }
        });

        save.always(function () {
          return _this7.$saveButton.removeClass('disabled');
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          savingStatusMsg.update({
            msg: 'Listing <em>' + _this7.model.toJSON().item.title + '</em> failed to save.',
            type: 'warning'
          });

          setTimeout(function () {
            return savingStatusMsg.remove();
          }, 3000);

          new _SimpleMessage2.default({
            title: _app2.default.polyglot.t('editListing.errors.saveErrorTitle'),
            message: args[0] && args[0].responseJSON && args[0].responseJSON.reason || ''
          }).render().open();
        }).done(function () {
          savingStatusMsg.update('Listing ' + _this7.model.toJSON().item.title + ' saved. <a class="js-viewListing">view</a>');
          _this7.attrsAtLastSave = _this7.model.toJSON();

          setTimeout(function () {
            return savingStatusMsg.remove();
          }, 6000);
        });
      } else {
        // client side validation failed
        this.$saveButton.removeClass('disabled');
      }

      // render so errrors are shown / cleared
      this.render(!!save);

      if (!save) {
        var $firstErr = this.$('.errorList:visible').eq(0);
        if ($firstErr.length) {
          $firstErr[0].scrollIntoViewIfNeeded();
        } else {
          // There's a model error that's not represented in the UI - likely
          // developer error.
          var msg = Object.keys(this.model.validationError).reduce(function (str, errKey) {
            return '' + str + errKey + ': ' + _this7.model.validationError[errKey].join(', ') + '<br>';
          }, '');
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('editListing.errors.saveErrorTitle'), msg);
        }
      }
    }
  }, {
    key: 'onChangeManagementType',
    value: function onChangeManagementType(e) {
      if (e.value === 'TRACK') {
        this.inventoryManagement.setState({
          trackBy: this.model.get('item').get('options').length ? 'TRACK_BY_VARIANT' : 'TRACK_BY_FIXED'
        });
        this.$el.removeClass('notTrackingInventory');
      } else {
        this.inventoryManagement.setState({
          trackBy: 'DO_NOT_TRACK'
        });
        this.$el.addClass('notTrackingInventory');
      }
    }

    /**
     * Will set the model with data from the form, including setting nested models
     * and collections which are managed by nested views.
     */

  }, {
    key: 'setModelData',
    value: function setModelData() {
      var formData = this.getFormData(this.$formFields);
      var item = this.model.get('item');
      var metadata = this.model.get('metadata');
      var isCrypto = this.getCachedEl('#editContractType').val() === 'CRYPTOCURRENCY';

      // set model / collection data for various child views
      this.shippingOptionViews.forEach(function (shipOptVw) {
        return shipOptVw.setModelData();
      });
      this.variantsView.setCollectionData();
      this.variantInventory.setCollectionData();
      this.couponsView.setCollectionData();

      if (!isCrypto) {
        if (item.get('options').length) {
          // If we have options, we shouldn't be providing a top-level quantity or
          // productID.
          item.unset('quantity');
          item.unset('productID');

          // If we have options and are not tracking inventory, we'll set the infiniteInventory
          // flag for any skus.
          if (this.trackInventoryBy === 'DO_NOT_TRACK') {
            item.get('skus').forEach(function (sku) {
              sku.set({
                infiniteInventory: true,
                quantity: -1
              });
            });
          }
        } else if (this.trackInventoryBy === 'DO_NOT_TRACK') {
          // If we're not tracking inventory and don't have any variants, we should provide
          // a top-level quantity as -1, so it's considered infinite.
          formData.item.quantity = -1;
        }

        formData.metadata = _extends({}, formData.metadata, {
          format: 'FIXED_PRICE'
        });
      } else {
        item.unset('condition');
        item.unset('productId');
        item.unset('price');
        metadata.unset('pricingCurrency');

        formData = _extends({}, formData, {
          coupons: [],
          item: _extends({}, formData.item, {
            options: [],
            skus: []
          }),
          metadata: _extends({}, formData.metadata, {
            format: 'MARKET_PRICE'
          }),
          shippingOptions: []
        });
      }

      this.model.set(_extends({}, formData, {
        item: _extends({}, formData.item, {
          tags: formData.item.tags.length ? formData.item.tags.split(_selectize.tagsDelimiter) : [],
          categories: formData.item.categories.length ? formData.item.categories.split(_selectize.tagsDelimiter) : []
        })
      }));

      // If the type is not 'PHYSICAL_GOOD', we'll clear out any shipping options.
      if (metadata.get('contractType') !== 'PHYSICAL_GOOD') {
        this.model.get('shippingOptions').reset();
      } else {
        // If any shipping options have a type of 'LOCAL_PICKUP', we'll
        // clear out any services that may be there.
        this.model.get('shippingOptions').forEach(function (shipOpt) {
          if (shipOpt.get('type') === 'LOCAL_PICKUP') {
            shipOpt.set('services', []);
          }
        });
      }
    }
  }, {
    key: 'open',
    value: function open() {
      var _this8 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'open', this).call(this);

      if (!this.openedBefore) {
        this.openedBefore = true;
        var cur = void 0;

        try {
          cur = this._origModel.unparsedResponse.listing.metadata.pricingCurrency;
        } catch (e) {
          return this;
        }

        if (!this.model.isCrypto && (0, _currency.getCurrencyValidity)(cur) === 'UNRECOGNIZED_CURRENCY') {
          var unsupportedCurrencyDialog = new _UnsupportedCurrency2.default({
            unsupportedCurrency: cur
          }).render().open();

          this.listenTo(unsupportedCurrencyDialog, 'close', function () {
            var response = JSON.parse(JSON.stringify(_this8._origModel.unparsedResponse));
            var newCur = unsupportedCurrencyDialog.getCurrency();
            (0, _object.setDeepValue)(response, 'listing.metadata.pricingCurrency', newCur);
            _this8.model.set(_this8.model.parse(response));
            _this8.$currencySelect.val(newCur);
            _this8.render();
          });
        }
      }
      return this;
    }
  }, {
    key: 'showMaxTagsWarning',
    value: function showMaxTagsWarning() {
      this.$maxTagsWarning.empty().append(this.maxTagsWarning);
    }
  }, {
    key: 'hideMaxTagsWarning',
    value: function hideMaxTagsWarning() {
      this.$maxTagsWarning.empty();
    }
  }, {
    key: 'showMaxCatsWarning',
    value: function showMaxCatsWarning() {
      this.$maxCatsWarning.empty().append(this.maxCatsWarning);
    }
  }, {
    key: 'hideMaxCatsWarning',
    value: function hideMaxCatsWarning() {
      this.$maxCatsWarning.empty();
    }

    // return the currency associated with this listing

  }, {
    key: 'createShippingOptionView',
    value: function createShippingOptionView(opts) {
      var _this9 = this;

      var options = _extends({
        getCurrency: function getCurrency() {
          return _this9.$currencySelect.length ? _this9.$currencySelect.val() : _this9.model.get('metadata').pricingCurrency;
        }
      }, opts || {});
      var view = this.createChild(_ShippingOption4.default, options);

      this.listenTo(view, 'click-remove', function (e) {
        _this9.shippingOptions.remove(_this9.shippingOptions.at(_this9.shippingOptionViews.indexOf(e.view)));
      });

      return view;
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.inProgressPhotoUploads.forEach(function (upload) {
        return upload.abort();
      });
      (0, _jquery2.default)(window).off('resize', this.throttledResizeWin);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this10 = this;

      var restoreScrollPos = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      var prevScrollPos = 0;
      var item = this.model.get('item');
      var metadata = this.model.get('metadata');

      if (restoreScrollPos) {
        prevScrollPos = this.el.scrollTop;
      }

      if (this.throttledOnScroll) this.$el.off('scroll', this.throttledOnScroll);
      this.currencies = this.currencies || (0, _currencies.getCurrenciesSortedByCode)();

      (0, _loadTemplate2.default)('modals/editListing/editListing.html', function (t) {
        _this10.$el.html(t(_extends({
          createMode: _this10.createMode,
          selectedNavTabIndex: _this10.selectedNavTabIndex,
          returnText: _this10.options.returnText,
          listingCurrency: _this10.currency,
          currencies: _this10.currencies,
          contractTypes: metadata.contractTypesVerbose,
          conditionTypes: _this10.model.get('item').conditionTypes.map(function (conditionType) {
            return { code: conditionType,
              name: _app2.default.polyglot.t('conditionTypes.' + conditionType) };
          }),
          errors: _this10.model.validationError || {},
          photoUploadInprogress: !!_this10.inProgressPhotoUploads.length,
          uploadPhotoT: _this10.uploadPhotoT,
          expandedReturnPolicy: _this10.expandedReturnPolicy || !!_this10.model.get('refundPolicy'),
          expandedTermsAndConditions: _this10.expandedTermsAndConditions || !!_this10.model.get('termsAndConditions'),
          formatPrice: _currency.formatPrice,
          maxCatsWarning: _this10.maxCatsWarning,
          maxTagsWarning: _this10.maxTagsWarning,
          max: {
            title: item.max.titleLength,
            cats: item.max.cats,
            tags: item.max.tags,
            photos: _this10.MAX_PHOTOS
          },
          shouldShowVariantInventorySection: _this10.shouldShowVariantInventorySection
        }, _this10.model.toJSON())));

        _this10.setContractTypeClass(metadata.get('contractType'));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this10).call(_this10);

        _this10._$scrollLinks = null;
        _this10._$scrollToSections = null;
        _this10._$currencySelect = null;
        _this10._$priceInput = null;
        _this10._$buttonSave = null;
        _this10._$inputPhotoUpload = null;
        _this10._$photoUploadingLabel = null;
        _this10._$editListingReturnPolicy = null;
        _this10._$editListingTermsAndConditions = null;
        _this10._$sectionShipping = null;
        _this10._$maxCatsWarning = null;
        _this10._$maxTagsWarning = null;
        _this10._$addShipOptSectionHeading = null;
        _this10._$variantInventorySection = null;
        _this10._$itemPrice = null;
        _this10.$photoUploadItems = _this10.$('.js-photoUploadItems');
        _this10.$modalContent = _this10.$('.modalContent');
        _this10.$tabControls = _this10.$('.tabControls');
        _this10.$titleInput = _this10.$('#editListingTitle');
        _this10.$editListingTags = _this10.$('#editListingTags');
        _this10.$editListingCategories = _this10.$('#editListingCategories');
        _this10.$shippingOptionsWrap = _this10.$('.js-shippingOptionsWrap');
        _this10.$couponsSection = _this10.$('.js-couponsSection');
        _this10.$variantsSection = _this10.$('.js-variantsSection');

        _this10.$('#editContractType, #editListingVisibility, #editListingCondition').select2({
          // disables the search box
          minimumResultsForSearch: Infinity
        });

        _this10.$('#editListingCurrency').select2().on('change', function () {
          return _this10.variantInventory.render();
        });

        _this10.$editListingTags.selectize({
          persist: false,
          maxItems: item.max.tags,
          create: function create(input) {
            // we'll make the tag all lowercase and
            // replace spaces with dashes.
            var term = input.toLowerCase().replace(/\s/g, '-').replace('#', '')
            // replace consecutive dashes with one
            .replace(/-{2,}/g, '-');
            return {
              value: term,
              text: term
            };
          },
          onChange: function onChange(value) {
            var tags = value.length ? value.split(',') : [];
            if (tags.length >= item.max.tags) {
              _this10.showMaxTagsWarning();
            } else {
              _this10.hideMaxTagsWarning();
            }
          }
        });

        _this10.$editListingCategories.selectize({
          persist: false,
          maxItems: item.max.cats,
          create: function create(input) {
            return {
              value: input,
              text: input
            };
          },
          onChange: function onChange(value) {
            var cats = value.length ? value.split(',') : [];
            if (cats.length >= item.max.cats) {
              _this10.showMaxCatsWarning();
            } else {
              _this10.hideMaxCatsWarning();
            }
          }
        });

        // render shipping options
        _this10.shippingOptionViews.forEach(function (shipOptVw) {
          return shipOptVw.remove();
        });
        _this10.shippingOptionViews = [];
        var shipOptsFrag = document.createDocumentFragment();

        _this10.model.get('shippingOptions').forEach(function (shipOpt, shipOptIndex) {
          var shipOptVw = _this10.createShippingOptionView({
            model: shipOpt,
            listPosition: shipOptIndex + 1
          });

          _this10.shippingOptionViews.push(shipOptVw);
          shipOptVw.render().$el.appendTo(shipOptsFrag);
        });

        _this10.$shippingOptionsWrap.append(shipOptsFrag);

        // render sku field
        if (_this10.skuField) _this10.skuField.remove();

        _this10.skuField = _this10.createChild(_SkuField2.default, {
          model: item,
          initialState: {
            variantsPresent: !!item.get('options').length
          }
        });

        _this10.$('.js-skuFieldContainer').html(_this10.skuField.render().el);

        // render variants
        if (_this10.variantsView) _this10.variantsView.remove();

        var variantErrors = {};

        Object.keys(item.validationError || {}).forEach(function (errKey) {
          if (errKey.startsWith('options[')) {
            variantErrors[errKey] = item.validationError[errKey];
          }
        });

        _this10.variantsView = _this10.createChild(_Variants2.default, {
          collection: _this10.variantOptionsCl,
          maxVariantCount: item.max.optionCount,
          errors: variantErrors
        });

        _this10.variantsView.listenTo(_this10.variantsView, 'variantChoiceChange', _this10.onVariantChoiceChange.bind(_this10));

        _this10.$variantsSection.find('.js-variantsContainer').append(_this10.variantsView.render().el);

        // render inventory management section
        if (_this10.inventoryManagement) _this10.inventoryManagement.remove();
        var inventoryManagementErrors = {};

        if (_this10.model.validationError && _this10.model.validationError['item.quantity']) {
          inventoryManagementErrors.quantity = _this10.model.validationError['item.quantity'];
        }

        _this10.inventoryManagement = _this10.createChild(_InventoryManagement2.default, {
          initialState: {
            trackBy: _this10.trackInventoryBy,
            quantity: item.get('quantity'),
            errors: inventoryManagementErrors
          }
        });

        _this10.$('.js-inventoryManagementSection').html(_this10.inventoryManagement.render().el);
        _this10.listenTo(_this10.inventoryManagement, 'changeManagementType', _this10.onChangeManagementType);

        // render variant inventory
        if (_this10.variantInventory) _this10.variantInventory.remove();

        _this10.variantInventory = _this10.createChild(_VariantInventory2.default, {
          collection: item.get('skus'),
          optionsCl: item.get('options'),
          getPrice: function getPrice() {
            return _this10.getFormData(_this10.$itemPrice).item.price;
          },
          getCurrency: function getCurrency() {
            return _this10.currency;
          }
        });

        _this10.$('.js-variantInventoryTableContainer').html(_this10.variantInventory.render().el);

        // render coupons
        if (_this10.couponsView) _this10.couponsView.remove();

        var couponErrors = {};

        Object.keys(_this10.model.validationError || {}).forEach(function (errKey) {
          if (errKey.startsWith('coupons[')) {
            couponErrors[errKey] = _this10.model.validationError[errKey];
          }
        });

        _this10.couponsView = _this10.createChild(_Coupons2.default, {
          collection: _this10.coupons,
          maxCouponCount: _this10.model.max.couponCount,
          couponErrors: couponErrors
        });

        _this10.$couponsSection.find('.js-couponsContainer').append(_this10.couponsView.render().el);

        (0, _trumbowyg.installRichEditor)(_this10.$('#editListingDescription'), {
          topLevelClass: 'clrBr'
        });

        if (_this10.sortablePhotos) _this10.sortablePhotos.destroy();
        _this10.sortablePhotos = _sortablejs2.default.create(_this10.$photoUploadItems[0], {
          filter: '.js-addPhotoWrap',
          onUpdate: function onUpdate(e) {
            var imageModels = _this10.model.get('item').get('images').models;

            var movingModel = imageModels[e.oldIndex - 1];
            imageModels.splice(e.oldIndex - 1, 1);
            imageModels.splice(e.newIndex - 1, 0, movingModel);
          },
          onMove: function onMove(e) {
            return (0, _jquery2.default)(e.related).hasClass('js-addPhotoWrap') ? false : undefined;
          }
        });

        if (_this10.cryptoCurrencyType) _this10.cryptoCurrencyType.remove();
        _this10.cryptoCurrencyType = _this10.createChild(_CryptoCurrencyType2.default, {
          model: _this10.model
        });
        _this10.getCachedEl('.js-cryptoTypeWrap').html(_this10.cryptoCurrencyType.render().el);

        setTimeout(function () {
          if (!_this10.rendered) {
            _this10.rendered = true;
            _this10.$titleInput.focus();
          }
        });

        setTimeout(function () {
          // restore the scroll position
          if (restoreScrollPos) {
            _this10.el.scrollTop = prevScrollPos;
          }

          _this10.throttledOnScroll = _underscore2.default.bind(_underscore2.default.throttle(_this10.onScroll, 100), _this10);
          setTimeout(function () {
            return _this10.$el.on('scroll', _this10.throttledOnScroll);
          }, 100);
        });

        // This block should be after any dom manipulation in render.
        if (_this10.createMode) {
          if (!_this10.attrsAtCreate) {
            _this10.setModelData();
            _this10.attrsAtCreate = _this10.model.toJSON();
          }
        } else {
          if (!_this10.attrsAtLastSave) {
            _this10.setModelData();
            _this10.attrsAtLastSave = _this10.model.toJSON();
          }
        }
      });

      return this;
    }
  }, {
    key: 'MAX_PHOTOS',
    get: function get() {
      return this.model.get('item').max.images;
    }
  }, {
    key: 'shouldShowVariantInventorySection',
    get: function get() {
      return !!this.variantOptionsCl.length;
    }

    /**
     * Will return true if we have at least one variant option with at least
     * one choice.
     */

  }, {
    key: 'haveVariantOptionsWithChoice',
    get: function get() {
      if (this.variantOptionsCl.length) {
        var atLeastOneHasChoice = this.variantOptionsCl.find(function (variantOption) {
          var choices = variantOption.get('variants');
          return choices && choices.length;
        });

        if (atLeastOneHasChoice) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: 'inProgressPhotoUploads',
    get: function get() {
      return this.photoUploads.filter(function (upload) {
        return upload.state() === 'pending';
      });
    }
  }, {
    key: 'trackInventoryBy',
    get: function get() {
      var trackBy = void 0;

      // If the inventoryManagement has been rendered, we'll let it's drop-down
      // determine whether we are tracking inventory. Otherwise, we'll get the info
      // from the model.
      if (this.inventoryManagement) {
        trackBy = this.inventoryManagement.getState().trackBy;
      } else {
        var item = this.model.get('item');

        if (item.isInventoryTracked) {
          trackBy = item.get('options').length ? 'TRACK_BY_VARIANT' : 'TRACK_BY_FIXED';
        } else {
          trackBy = 'DO_NOT_TRACK';
        }
      }

      return trackBy;
    }
  }, {
    key: '$scrollToSections',
    get: function get() {
      return this._$scrollToSections || (this._$scrollToSections = this.$('.js-scrollToSection'));
    }
  }, {
    key: '$scrollLinks',
    get: function get() {
      return this._$scrollLinks || (this._$scrollLinks = this.$('.js-scrollLink'));
    }
  }, {
    key: '$formFields',
    get: function get() {
      var _this11 = this;

      var isCrypto = this.getCachedEl('#editContractType').val() === 'CRYPTOCURRENCY';
      var cryptoExcludes = isCrypto ? ', .js-inventoryManagementSection' : '';
      var excludes = '.js-sectionShipping, .js-couponsSection, .js-variantsSection, ' + ('.js-variantInventorySection' + cryptoExcludes);

      var $fields = this.$('.js-formSectionsContainer > section:not(' + excludes + ') select[name],' + ('.js-formSectionsContainer > section:not(' + excludes + ') input[name],') + ('.js-formSectionsContainer > section:not(' + excludes + ') div[contenteditable][name],') + ('.js-formSectionsContainer > section:not(' + excludes + ') ') + 'textarea[name]:not([class*="trumbowyg"])');

      // Filter out hidden fields that are not applicable based on whether this is
      // a crypto currency listing.
      $fields = $fields.filter(function (index, el) {
        var $excludeContainers = isCrypto ? _this11.getCachedEl('.js-standardTypeWrap').add(_this11.getCachedEl('.js-skuMatureContentRow')) : _this11.getCachedEl('.js-cryptoTypeWrap');

        var keep = true;

        $excludeContainers.each(function (i, container) {
          if (_jquery2.default.contains(container, el)) {
            keep = false;
          }
        });

        return keep;
      });

      return $fields;
    }
  }, {
    key: '$currencySelect',
    get: function get() {
      return this._$currencySelect || (this._$currencySelect = this.$('#editListingCurrency'));
    }
  }, {
    key: '$priceInput',
    get: function get() {
      return this._$priceInput || (this._$priceInput = this.$('#editListingPrice'));
    }
  }, {
    key: '$saveButton',
    get: function get() {
      return this._$buttonSave || (this._$buttonSave = this.$('.js-save'));
    }
  }, {
    key: '$inputPhotoUpload',
    get: function get() {
      return this._$inputPhotoUpload || (this._$inputPhotoUpload = this.$('#inputPhotoUpload'));
    }
  }, {
    key: '$photoUploadingLabel',
    get: function get() {
      return this._$photoUploadingLabel || (this._$photoUploadingLabel = this.$('.js-photoUploadingLabel'));
    }
  }, {
    key: '$editListingReturnPolicy',
    get: function get() {
      return this._$editListingReturnPolicy || (this._$editListingReturnPolicy = this.$('#editListingReturnPolicy'));
    }
  }, {
    key: '$editListingTermsAndConditions',
    get: function get() {
      return this._$editListingTermsAndConditions || (this._$editListingTermsAndConditions = this.$('#editListingTermsAndConditions'));
    }
  }, {
    key: '$sectionShipping',
    get: function get() {
      return this._$sectionShipping || (this._$sectionShipping = this.$('.js-sectionShipping'));
    }
  }, {
    key: '$maxCatsWarning',
    get: function get() {
      return this._$maxCatsWarning || (this._$maxCatsWarning = this.$('.js-maxCatsWarning'));
    }
  }, {
    key: '$maxTagsWarning',
    get: function get() {
      return this._$maxTagsWarning || (this._$maxTagsWarning = this.$('.js-maxTagsWarning'));
    }
  }, {
    key: 'maxTagsWarning',
    get: function get() {
      return '<div class="clrT2 tx5 row">' + _app2.default.polyglot.t('editListing.maxTagsWarning') + '</div>';
    }
  }, {
    key: '$addShipOptSectionHeading',
    get: function get() {
      return this._$addShipOptSectionHeading || (this._$addShipOptSectionHeading = this.$('.js-addShipOptSectionHeading'));
    }
  }, {
    key: '$variantInventorySection',
    get: function get() {
      return this._$variantInventorySection || (this._$variantInventorySection = this.$('.js-variantInventorySection'));
    }
  }, {
    key: '$itemPrice',
    get: function get() {
      return this._$itemPrice || (this._$itemPrice = this.$('[name="item.price"]'));
    }
  }, {
    key: 'maxCatsWarning',
    get: function get() {
      return '<div class="clrT2 tx5 row">' + _app2.default.polyglot.t('editListing.maxCatsWarning') + '</div>';
    }
  }, {
    key: 'currency',
    get: function get() {
      return this.$currencySelect.length ? this.$currencySelect.val() : this.model.get('metadata').get('pricingCurrency') || _app2.default.settings.get('localCurrency');
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;