'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model) {
      throw new Error('Please provide a VariantOption model.');
    }

    // any parent level errors can be passed in options.errors, e.g.
    // options.errors = {
    //   <field-name>: ['err1', 'err2', 'err3']
    // }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'variant flexRow gutterH';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-btnRemoveVariant': 'onClickRemove'
      };
    }
  }, {
    key: 'onClickRemove',
    value: function onClickRemove() {
      this.trigger('removeClick', { view: this });
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      var fields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.$formFields;

      var formData = _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, fields);

      // Post process the vairants to seperate the clientID from the actual value.
      formData.variants = formData.variants.map(function (v) {
        if (v.includes('<===>')) {
          var split = v.split('<===>');
          return {
            _clientID: split[0],
            name: split[1]
          };
        }

        return { name: v };
      });

      return formData;
    }

    // Sets the model based on the current data in the UI.

  }, {
    key: 'setModelData',
    value: function setModelData() {
      var formData = this.getFormData();
      this.model.set(formData);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      var errors = _extends({}, this.model.validationError || {}, this.options.errors || {});

      this.$el.toggleClass('hasError', !!Object.keys(errors).length);

      (0, _loadTemplate2.default)('modals/editListing/variant.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.model.toJSON(), {
          max: _this2.model.max,
          errors: errors
        })));

        _this2._$formFields = null;

        var variantItems = [];
        var variantOptions = [];

        _this2.model.get('variants').toJSON().forEach(function (variant) {
          var value = variant._clientID + '<===>' + variant.name;
          variantOptions.push(_extends({}, variant, { value: value }));
          variantItems.push(value);
        });

        _this2.getCachedEl('select[name=variants]').selectize({
          persist: false,
          valueField: 'value',
          options: variantOptions,
          items: variantItems,
          create: function create(input) {
            return {
              name: input,
              value: input
            };
          },
          render: {
            option: function option(data) {
              return '<div>' + data.name + '</div>';
            },
            item: function item(data) {
              return '<div>' + data.name + '</div>';
            }
          }
        }).on('change', function () {
          return _this2.trigger('choiceChange', { view: _this2 });
        });
      });

      return this;
    }
  }, {
    key: '$formFields',
    get: function get() {
      return this._$formFields || (this._$formFields = this.$('select[name], input[name], textarea[name]'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;