'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Sku = require('../../../models/listing/Sku');

var _Sku2 = _interopRequireDefault(_Sku);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _VariantInventoryItem = require('./VariantInventoryItem');

var _VariantInventoryItem2 = _interopRequireDefault(_VariantInventoryItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a Skus collection.');
    }

    if (!options.optionsCl) {
      throw new Error('Please provide an options collection.');
    }

    if (typeof options.getPrice !== 'function') {
      throw new Error('Please provide a getPrice function that returns the product price.');
    }

    if (typeof options.getCurrency !== 'function') {
      throw new Error('Please provide a function for me to obtain the current currency.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options || {};
    _this.optionsCl = options.optionsCl;
    _this.itemViews = [];

    // Give each Sku a mappingId which links it to the option it originated from
    // in a more robust way than relying on order which can change.
    if (_this.optionsCl.length) {
      _this.collection.forEach(function (sku) {
        var variantCombo = sku.get('variantCombo');
        sku.set('mappingId', _this.buildIdFromVariantCombo(variantCombo));
      });
    }

    _this.listenTo(_this.optionsCl, 'change:name', function () {
      return _this.render();
    });
    _this.listenTo(_this.optionsCl, 'update', function (cl, opts) {
      if (opts.changes.added.length) {
        _this.bindOptionVariantsUpdate(opts.changes.added);
      }

      _this.render();
    });
    _this.bindOptionVariantsUpdate(_this.optionsCl.models);
    return _this;
  }

  _createClass(_class, [{
    key: 'bindOptionVariantsUpdate',
    value: function bindOptionVariantsUpdate() {
      var _this2 = this;

      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      options.forEach(function (option) {
        _this2.listenTo(option.get('variants'), 'update', function () {
          return _this2.render();
        });
      });
    }
  }, {
    key: 'setCollectionData',
    value: function setCollectionData() {
      this.itemViews.forEach(function (item) {
        return item.setModelData();
      });
    }
  }, {
    key: 'allPossibleCombos',


    // Inpsired by: http://stackoverflow.com/a/4331218/632806
    // TODO: would be nice to unit test this guy
    value: function allPossibleCombos(arr) {
      var returnVal = void 0;

      if (!arr.length) {
        return [];
      }

      if (arr.length === 1) {
        returnVal = arr[0].map(function (val, index) {
          return index;
        });
      } else {
        var result = [];
        var allCasesOfRest = this.allPossibleCombos(arr.slice(1)); // recur with the rest of array
        for (var i = 0; i < allCasesOfRest.length; i++) {
          for (var j = 0; j < arr[0].length; j++) {
            result.push(j + ', ' + allCasesOfRest[i]);
          }
        }
        return result;
      }

      return returnVal;
    }
  }, {
    key: 'buildIdFromVariantCombo',
    value: function buildIdFromVariantCombo(variantCombo) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.optionsCl;

      if (!_underscore2.default.isArray(variantCombo)) {
        throw new Error('Please provide a variantCombo as an array.');
      }

      var id = '';

      variantCombo.forEach(function (variantIndex, index) {
        var option = options.at(index);

        if (option) {
          var choice = option.get('variants').at(variantIndex);

          if (choice) {
            id += '' + (id.length ? '/' : '') + option.id + '-' + choice.get('name');
          }
        }
      });

      return id;
    }

    // todo: good unit test candidate

  }, {
    key: 'buildInventoryData',
    value: function buildInventoryData() {
      var _this3 = this;

      var options = this.optionsCl.toJSON()
      // only process options that have at least one variant
      .filter(function (option) {
        return option.variants && option.variants.length;
      });

      var columns = options.map(function (option) {
        return option.name;
      });
      var inventoryData = [];

      // ensure the Sku collection has the latest data from the UI
      this.setCollectionData();

      this.allPossibleCombos(options.map(function (option) {
        return option.variants;
      })).sort().map(function (strCombo) {
        return JSON.parse('[' + strCombo + ']');
      }).forEach(function (combo) {
        var choices = [];

        combo.forEach(function (comboIndex, index) {
          choices.push(options[index].variants[comboIndex].name);
        });

        var data = {
          choices: choices,
          variantCombo: combo
        };

        var id = _this3.buildIdFromVariantCombo(combo);

        // If there is an existing sku for this variantCombo, we'll
        // merge its data in
        var sku = _this3.collection.findWhere({ mappingId: id });

        if (sku) {
          data = _extends({}, data, sku.toJSON());
        } else {
          // If no sku, we'll merge in a new Sku model so the model's
          // defaults get into the data
          data = _extends({}, data, new _Sku2.default().toJSON(), {
            mappingId: id
          });
        }

        inventoryData.push(data);
      });

      return {
        columns: columns,
        inventory: inventoryData
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var inventoryData = this.buildInventoryData();
      this.collection.set(inventoryData.inventory);

      (0, _loadTemplate2.default)('modals/editListing/variantInventory.html', function (t) {
        _this4.$el.html(t({
          columns: inventoryData.columns,
          inventory: _this4.collection.toJSON(),
          getPrice: _this4.options.getPrice,
          getCurrency: _this4.options.getCurrency
        }));

        _this4.itemViews.forEach(function (item) {
          return item.remove();
        });
        _this4.itemViews = [];
        var itemsFrag = document.createDocumentFragment();

        _this4.collection.forEach(function (item) {
          var view = _this4.createChild(_VariantInventoryItem2.default, {
            model: item,
            getPrice: _this4.options.getPrice,
            getCurrency: _this4.options.getCurrency
          });

          _this4.itemViews.push(view);
          view.render().$el.appendTo(itemsFrag);
        });

        _this4.$('table').append(itemsFrag);
      });

      return this;
    }
  }, {
    key: '$formFields',
    get: function get() {
      return this._$formFields || (this._$formFields = this.$('select[name], input[name], textarea[name]'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;