'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../../../lib/select2');

var _currency = require('../../../utils/currency');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model) {
      throw new Error('Please provide a model.');
    }

    if (typeof options.getPrice !== 'function') {
      throw new Error('Please provide a getPrice function that returns the product price.');
    }

    if (typeof options.getCurrency !== 'function') {
      throw new Error('Please provide a function for me to obtain the current currency.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    return _this;
  }

  _createClass(_class, [{
    key: 'tagName',
    value: function tagName() {
      return 'tr';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'keyup .js-surcharge': 'onKeyupSurcharge',
        'focus .js-quantity': 'onFocusQuantity',
        'keyup .js-quantity': 'onKeyupQuantity',
        'change .js-infiniteInventoryCheckbox': 'onChangeInfiniteCheckbox'
      };
    }
  }, {
    key: 'onKeyupSurcharge',
    value: function onKeyupSurcharge(e) {
      this.$totalPrice.text(this.calculateTotalPrice(Number(e.target.value)));
    }
  }, {
    key: 'onFocusQuantity',
    value: function onFocusQuantity(e) {
      if (e.target.value === this.infiniteQuantityChar) {
        e.target.setSelectionRange(0, e.target.value.length);
      }
    }
  }, {
    key: 'onKeyupQuantity',
    value: function onKeyupQuantity(e) {
      if (e.target.value !== this.infiniteQuantityChar) {
        this.$infiniteInventoryCheckbox.prop('checked', false);
      } else {
        this.$infiniteInventoryCheckbox.prop('checked', true);
      }
    }
  }, {
    key: 'onChangeInfiniteCheckbox',
    value: function onChangeInfiniteCheckbox(e) {
      if ((0, _jquery2.default)(e.target).is(':checked')) {
        this.$quantity.val(this.infiniteQuantityChar);
      } else {
        this.$quantity.val('');
      }
    }
  }, {
    key: 'getFormData',
    value: function getFormData() {
      var fields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.$formFields;

      var formData = _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getFormData', this).call(this, fields);
      return formData;
    }

    // Sets the model based on the current data in the UI.

  }, {
    key: 'setModelData',
    value: function setModelData() {
      var formData = this.getFormData();

      if (formData.infiniteInventory) {
        formData.quantity = -1;
      }

      this.model.set(formData);
    }
  }, {
    key: 'calculateTotalPrice',
    value: function calculateTotalPrice(surcharge) {
      var listingPrice = this.options.getPrice();

      if (typeof listingPrice !== 'number' || isNaN(listingPrice) || typeof surcharge !== 'number' && isNaN(surcharge)) {
        return '';
      }

      return (0, _currency.formatCurrency)((this.options.getPrice() || 0) + surcharge, this.options.getCurrency());
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/editListing/variantInventoryItem.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.model.toJSON(), {
          errors: _extends({}, _this2.model.validationError || {}),
          getCurrency: _this2.options.getCurrency,
          getPrice: _this2.options.getPrice,
          calculateTotalPrice: _this2.calculateTotalPrice.bind(_this2),
          cid: _this2.cid,
          infiniteQuantityChar: _this2.infiniteQuantityChar,
          max: _this2.model.max
        })));

        _this2._$formFields = null;
        _this2._$totalPrice = null;
        _this2._$infiniteInventoryCheckbox = null;
        _this2._$quantity = null;
      });

      return this;
    }
  }, {
    key: 'infiniteQuantityChar',
    get: function get() {
      return '—';
    }
  }, {
    key: '$formFields',
    get: function get() {
      return this._$formFields || (this._$formFields = this.$('select[name], input[name], textarea[name]'));
    }
  }, {
    key: '$totalPrice',
    get: function get() {
      return this._$totalPrice || (this._$totalPrice = this.$('.js-totalPrice'));
    }
  }, {
    key: '$infiniteInventoryCheckbox',
    get: function get() {
      return this._$infiniteInventoryCheckbox || (this._$infiniteInventoryCheckbox = this.$('.js-infiniteInventoryCheckbox'));
    }
  }, {
    key: '$quantity',
    get: function get() {
      return this._$quantity || (this._$quantity = this.$('.js-quantity'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;