'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('cropit');

require('../../../lib/select2');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _serverConnect = require('../../../utils/serverConnect');

var _countries = require('../../../data/countries');

var _currencies = require('../../../data/currencies');

var _SimpleMessage = require('../SimpleMessage');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      dismissOnEscPress: false,
      showCloseButton: false,
      initialState: _extends({
        screen: 'intro',
        saveInProgress: false
      }, options.initialState)
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.screens = ['intro', 'info', 'tos'];
    _this.lastAvatarImageRotate = 0;
    _this.avatarChanged = false;
    _this.countryList = (0, _countries.getTranslatedCountries)();
    _this.currencyList = (0, _currencies.getTranslatedCurrencies)();
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' onboarding modalScrollPage modalMedium';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-changeServer': 'onClickChangeServer',
        'click .js-getStarted': 'onClickGetStarted',
        'click .js-navBack': 'onClickNavBack',
        'click .js-navNext': 'onClickNavNext',
        'click .js-avatarLeft': 'onAvatarLeftClick',
        'click .js-avatarRight': 'onAvatarRightClick',
        'click .js-changeAvatar': 'onClickChangeAvatar',
        'click .js-tosAgree': 'onClickTosAgree'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onClickChangeServer',
    value: function onClickChangeServer() {
      _app2.default.connectionManagmentModal.open();
    }
  }, {
    key: 'onClickGetStarted',
    value: function onClickGetStarted() {
      this.setState({ screen: 'info' });
    }
  }, {
    key: 'onClickNavBack',
    value: function onClickNavBack() {
      var curScreen = this.getState().screen;
      var newScreen = this.screens[this.screens.indexOf(curScreen) - 1];

      if (curScreen === 'info') {
        this.setModelsFromForm();
      }

      this.setState({
        screen: newScreen
      });
    }
  }, {
    key: 'onClickNavNext',
    value: function onClickNavNext() {
      var curScreen = this.getState().screen;
      var newScreen = this.screens[this.screens.indexOf(curScreen) + 1];

      if (curScreen === 'info') {
        this.setModelsFromForm();

        if (newScreen === 'tos') {
          _app2.default.profile.set({}, { validate: true });
          _app2.default.settings.set({}, { validate: true });

          if (_app2.default.settings.validationError || _app2.default.profile.validationError) {
            this.render();
            return;
          }
        }
      }

      this.setState({ screen: newScreen });
    }
  }, {
    key: 'onClickChangeAvatar',
    value: function onClickChangeAvatar() {
      this.getCachedEl('#avatarInput')[0].click();
    }
  }, {
    key: 'onAvatarLeftClick',
    value: function onAvatarLeftClick() {
      this.avatarRotate(-1);
    }
  }, {
    key: 'onAvatarRightClick',
    value: function onAvatarRightClick() {
      this.avatarRotate(1);
    }
  }, {
    key: 'onClickTosAgree',
    value: function onClickTosAgree() {
      var _this2 = this;

      this.setState({ saveInProgress: true });

      var profileSave = _app2.default.profile.save({}, {
        type: Object.keys(_app2.default.profile.lastSyncedAttrs).length ? 'PUT' : 'POST'
      });

      var settingsSave = _app2.default.settings.save({}, {
        type: Object.keys(_app2.default.settings.lastSyncedAttrs).length ? 'PUT' : 'POST'
      });

      var saves = [profileSave, settingsSave];

      if (this.avatarChanged) {
        var avatarSave = this.saveAvatar().done(function (avatarData) {
          return _app2.default.profile.set('avatarHashes', avatarData);
        });
        saves.push(avatarSave);
      }

      _jquery2.default.when.apply(_jquery2.default, saves).done(function () {
        _this2.trigger('onboarding-complete');
      }).fail(function (jqXhr) {
        var title = void 0;

        if (jqXhr === profileSave) {
          title = _app2.default.polyglot.t('onboarding.profileFailedSaveTitle');
        } else if (jqXhr === settingsSave) {
          title = _app2.default.polyglot.t('onboarding.settingsFailedSaveTitle');
        } else {
          title = _app2.default.polyglot.t('onboarding.settingsFailedSaveAvatar');
        }

        (0, _SimpleMessage.openSimpleMessage)(title, jqXhr.responseJSON && jqXhr.responseJSON.reason || '');
      }).always(function () {
        _this2.setState({ saveInProgress: false });
      });
    }
  }, {
    key: 'setModelsFromForm',
    value: function setModelsFromForm() {
      var $settingsFields = this.getCachedEl('select[data-model=settings], ' + 'input[data-model=settings], textarea[data-model=settings]');
      _app2.default.settings.set(this.getFormData($settingsFields));
      var $profileFields = this.getCachedEl('select[data-model=profile], ' + 'input[data-model=profile], textarea[data-model=profile]');
      _app2.default.profile.set(this.getFormData($profileFields));
    }
  }, {
    key: 'saveAvatar',
    value: function saveAvatar() {
      if (!this.avatarExport) {
        throw new Error('Unable to save the avatar because the export ' + 'data is not available');
      }

      var avatarData = JSON.stringify({ avatar: this.avatarExport.replace(/^data:image\/(png|jpeg|webp);base64,/, '') });

      return _jquery2.default.ajax({
        type: 'POST',
        url: _app2.default.getServerUrl('ob/avatar/'),
        contentType: 'application/json; charset=utf-8',
        data: avatarData,
        dataType: 'json'
      });
    }
  }, {
    key: 'avatarRotate',
    value: function avatarRotate(direction) {
      if (this.$avatarCropper.cropit('imageSrc')) {
        this.$avatarCropper.cropit(direction > 0 ? 'rotateCW' : 'rotateCCW');

        // normalize so this.lastAvatarImageRotate is a positive number between 0 and 3
        this.lastAvatarImageRotate = (this.lastAvatarImageRotate + direction) % 4;
        if (this.lastAvatarImageRotate === -1) {
          this.lastAvatarImageRotate = 3;
        } else if (this.lastAvatarImageRotate === -2) {
          this.lastAvatarImageRotate = 2;
        } else if (this.lastAvatarImageRotate === -3) {
          this.lastAvatarImageRotate = 1;
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      if (this.$avatarCropper) {
        this.lastAvatarZoom = this.$avatarCropper.cropit('zoom');
        this.lastAvatarImageSrc = this.$avatarCropper.cropit('imageSrc');
        this.avatarExport = this.$avatarCropper.cropit('export', {
          type: 'image/jpeg',
          quality: 1,
          originalSize: true
        });
        this.$avatarCropper = null;
      }

      this.clearCachedElementMap();

      (0, _loadTemplate2.default)('modals/onboarding/onboarding.html', function (t) {
        (0, _loadTemplate2.default)('brandingBox.html', function (brandingBoxT) {
          var state = _this3.getState();

          _this3.$el.html(t(_extends({
            brandingBoxT: brandingBoxT
          }, state, {
            curConn: (0, _serverConnect.getCurrentConnection)(),
            profile: _app2.default.profile.toJSON(),
            profileErrors: _app2.default.profile.validationError || {},
            profileConstraints: _app2.default.profile.max,
            settings: _app2.default.settings.toJSON(),
            settingsErrors: _app2.default.settings.validationError || {},
            countryList: _this3.countryList,
            currencyList: _this3.currencyList
          })));

          _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this3).call(_this3);

          if (state.screen === 'info') {
            setTimeout(function () {
              _this3.getCachedEl('#onboardingCountry').select2();
              _this3.getCachedEl('#onboardingCurrency').select2();

              _this3.$avatarCropper = _this3.getCachedEl('#avatarCropper').cropit({
                $preview: _this3.getCachedEl('.js-avatarPreview'),
                $fileInput: _this3.getCachedEl('#avatarInput'),
                smallImage: 'stretch',
                allowDragNDrop: false,
                maxZoom: 2,
                onImageLoaded: function onImageLoaded() {
                  _this3.getCachedEl('.js-avatarLeft').removeClass('disabled');
                  _this3.getCachedEl('.js-avatarRight').removeClass('disabled');
                  _this3.getCachedEl('.js-avatarZoom').removeClass('disabled');
                  _this3.$avatarCropper.cropit('zoom', _this3.lastAvatarZoom);

                  for (var i = 0; i < _this3.lastAvatarImageRotate; i++) {
                    _this3.$avatarCropper.cropit('rotateCW');
                  }
                },
                onFileChange: function onFileChange() {
                  _this3.lastAvatarImageRotate = 0;
                  _this3.lastAvatarImageSrc = '';
                  _this3.lastAvatarZoom = 0;
                  _this3.avatarChanged = true;
                },
                onFileReaderError: function onFileReaderError(data) {
                  console.log('file reader error');
                  console.log(data);
                },
                onImageError: function onImageError(errorObject) {
                  console.log(errorObject.code);
                  console.log(errorObject.message);
                },
                imageState: {
                  src: _this3.lastAvatarImageSrc || ''
                }
              });
            }, 0);
          }
        });
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;