'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _OrderDetail = require('./OrderDetail.js');

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _ConvoMessage = require('./ConvoMessage');

var _ConvoMessage2 = _interopRequireDefault(_ConvoMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.collection) {
      throw new Error('Please provide a chat messages collection.');
    }

    if (!options.$scrollContainer) {
      throw new Error('Please provide the DOM element that handles scrolling for this view.');
    }

    (0, _OrderDetail.checkValidParticipantObject)(options.buyer, 'buyer');
    (0, _OrderDetail.checkValidParticipantObject)(options.vendor, 'vendor');

    if (options.moderator) {
      (0, _OrderDetail.checkValidParticipantObject)(options.moderator, 'moderator');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    _this.buyer = options.buyer;
    _this.vendor = options.vendor;
    _this.moderator = options.moderator;

    _this.$scrollContainer = options.$scrollContainer;
    _this.convoMessages = [];

    _this.listenTo(_app2.default.profile.get('avatarHashes'), 'change', _this.render);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'chatConvoMessages';
    }
  }, {
    key: 'markMessageAsRead',
    value: function markMessageAsRead(id) {
      if (!id) {
        throw new Error('Please provide an id.');
      }

      var message = this.collection.get(id);

      if (message) {
        var messageIndex = this.collection.indexOf(message);

        this.convoMessages[messageIndex].setState({ showAsRead: true });

        // Only one message should be marked as read, so if there already was one,
        // we'll unmark it.
        if (this.messageMarkedAsRead) {
          var index = this.collection.indexOf(this.messageMarkedAsRead);

          if (index !== -1) {
            this.convoMessages[index].setState({ showAsRead: false });
          }
        }
      }
    }
  }, {
    key: 'createMessage',
    value: function createMessage(model) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!model) {
        throw new Error('Please provide a model.');
      }

      var initialState = {};

      var participant = this.buyer;
      initialState.role = 'buyer';
      var peerId = model.get('peerId');

      if (model.get('outgoing')) {
        initialState.avatarHashes = _app2.default.profile.get('avatarHashes').toJSON();
        peerId = _app2.default.profile.id;
      }

      if (peerId === this.vendor.id) {
        participant = this.vendor;
        initialState.role = 'vendor';
      } else if (this.moderator && peerId === this.moderator.id) {
        participant = this.moderator;
        initialState.role = 'moderator';
      }

      var convoMessage = this.createChild(_ConvoMessage2.default, _extends({}, options, {
        model: model,
        initialState: _extends({}, options.initialState, initialState)
      }));

      if (!model.get('outgoing')) {
        participant.getProfile().done(function (profileMd) {
          if (!convoMessage.isRemoved()) {
            convoMessage.setState({
              avatarHashes: profileMd.get('avatarHashes').toJSON()
            });
          }
        });
      }

      this.convoMessages.push(convoMessage);

      return convoMessage;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var messagesContainer = document.createDocumentFragment();

      this.convoMessages.forEach(function (convoMessage) {
        return convoMessage.remove();
      });
      this.convoMessages = [];

      this.collection.forEach(function (message) {
        var convoMessage = _this2.createMessage(message);
        (0, _jquery2.default)(messagesContainer).append(convoMessage.render().el);
      });

      // We only want to mark the last 'read' message as read.
      this.messageMarkedAsRead = this.collection.slice().reverse().find(function (message) {
        return message.get('read') && message.get('outgoing');
      });

      var lastReadIndex = this.collection.indexOf(this.messageMarkedAsRead);

      if (lastReadIndex !== -1) {
        this.convoMessages[lastReadIndex].setState({ showAsRead: true });
      }

      this.$el.empty().append(messagesContainer);

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;