'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _string = require('../../../utils/string');

var _serverConnect = require('../../../utils/serverConnect');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _ChatMessages = require('../../../collections/ChatMessages');

var _ChatMessages2 = _interopRequireDefault(_ChatMessages);

var _ChatMessage = require('../../../models/chat/ChatMessage');

var _ChatMessage2 = _interopRequireDefault(_ChatMessage);

var _OrderDetail = require('./OrderDetail.js');

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _ConvoMessages = require('./ConvoMessages');

var _ConvoMessages2 = _interopRequireDefault(_ConvoMessages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.orderId) {
      throw new Error('Please provide an orderId.');
    }

    if (!options.model) {
      throw new Error('Please provide an order / case model.');
    }

    if (typeof options.amActiveTab !== 'function') {
      throw new Error('Please provide an amActiveTab function that returns a boolean ' + 'indicating whether Discussion is the active tab.');
    }

    (0, _OrderDetail.checkValidParticipantObject)(options.buyer, 'buyer');
    (0, _OrderDetail.checkValidParticipantObject)(options.vendor, 'vendor');

    if (options.moderator) {
      (0, _OrderDetail.checkValidParticipantObject)(options.moderator, 'moderator');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    _this.showLoadMessagesError = false;
    _this.fetching = false;
    _this.fetchedAllMessages = false;
    _this.ignoreScroll = false;
    _this.buyer = options.buyer;
    _this.vendor = options.vendor;
    _this.moderator = options.moderator;
    _this.buyer.isTyping = false;
    _this.vendor.isTyping = false;
    if (_this.moderator) _this.moderator.isTyping = false;

    _this.messages = new _ChatMessages2.default([]);
    _this.listenTo(_this.messages, 'request', _this.onMessagesRequest);
    _this.listenTo(_this.messages, 'sync', _this.onMessagesSync);
    _this.listenTo(_this.messages, 'update', _this.onMessagesUpdate);
    _this.listenTo(_this.messages, 'error', _this.onMessagesFetchError);
    _this.fetchMessages();

    _this.listenTo(_this.model, 'change:state', function () {
      _this.checkIfModCanChat();
      _this.setMessageInputPlaceholder();
    });

    var socket = (0, _serverConnect.getSocket)();

    if (socket) {
      _this.listenTo(socket, 'message', _this.onSocketMessage);
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'discussionTab clrP noMessages';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-retryLoadMessage': 'onClickRetryLoadMessage',
        'keyup .js-inputMessage': 'onKeyUpMessageInput',
        'keydown .js-inputMessage': 'onKeyDownMessageInput',
        'click .js-btnSend': 'onClickSend'
      };
    }
  }, {
    key: 'onMessagesRequest',
    value: function onMessagesRequest(mdCl, xhr) {
      var _this2 = this;

      // Only interested in the collection sync (not any of its models).
      if (!(mdCl instanceof _ChatMessages2.default)) return;

      this.showLoadMessagesError = false;
      this.$loadMessagesError.addClass('hide');
      this.$el.addClass('loadingMessages');
      this.fetching = true;

      xhr.always(function () {
        return _this2.fetching = false;
      });
    }
  }, {
    key: 'onMessagesSync',
    value: function onMessagesSync(mdCl, response) {
      // Only interested in the collection sync (not any of its models).
      if (!(mdCl instanceof _ChatMessages2.default)) return;

      this.showLoadMessagesError = false;
      this.$loadMessagesError.addClass('hide');
      this.$el.removeClass('loadingMessages');

      if (response && !response.length) {
        this.fetchedAllMessages = true;
      }

      if (!this.firstSyncComplete) {
        this.firstSyncComplete = true;
        this.setScrollTop(this.$convoMessagesWindow[0].scrollHeight);

        if (this.options.amActiveTab()) this.markConvoAsRead();
      }
    }
  }, {
    key: 'onAttach',
    value: function onAttach() {
      if (this.firstSyncComplete) {
        this.markConvoAsRead();
      }
    }
  }, {
    key: 'onMessagesFetchError',
    value: function onMessagesFetchError() {
      this.showLoadMessagesError = true;
      this.$loadMessagesError.removeClass('hide');
      this.$el.removeClass('loadingMessages');
    }
  }, {
    key: 'onMessagesUpdate',
    value: function onMessagesUpdate(cl, opts) {
      if (this.messages.length) {
        this.$el.removeClass('noMessages');
      }

      var prevTopModel = this.topRenderedMessageMd;

      if (!this.convoMessages) return;

      // As appropriate, update the scroll position.
      var prevScroll = {};

      prevScroll.height = this.$convoMessagesWindow[0].scrollHeight;
      prevScroll.top = this.$convoMessagesWindow[0].scrollTop;

      this.convoMessages.render();
      this.topRenderedMessageMd = this.messages.at(0);

      // Expecting either a new page of messages at the beginning of the collection or
      // a new single message at the end of the collection. In either of those scenarios
      // we'll adjust the scroll position as appopriate.

      if (opts.changes.added.length === 1) {
        // Single new message added.

        var newMessage = opts.changes.added[0];

        if (cl.indexOf(newMessage) === cl.length - 1) {
          // It's the last message.

          if (newMessage.get('outgoing')) {
            // It's our own message, so we'll auto scroll to the bottom.
            this.setScrollTop(this.$convoMessagesWindow[0].scrollHeight);
          } else if (prevScroll.top >= prevScroll.height - this.$convoMessagesWindow[0].clientHeight - 10) {
            // For an incoming message, if we were scrolled within 10px of the bottom at the
            // time the message came, we'll auto-scroll. Otherwise, we'll leave you where you were.
            this.setScrollTop(this.$convoMessagesWindow[0].scrollHeight);
          }
        }
      } else if (opts.changes.added.length && cl.indexOf(opts.changes.added[opts.changes.added.length - 1]) !== prevTopModel) {
        // New page of messages added up top. We'll adjust the scroll position so there is no
        // jump as they are added in.
        this.setScrollTop(prevScroll.top + (this.$convoMessagesWindow[0].scrollHeight - prevScroll.height - 60));

        // the hardcode 60 is to account for the loading spinner that is going away
      }
    }
  }, {
    key: 'onClickRetryLoadMessage',
    value: function onClickRetryLoadMessage() {
      this.fetchMessages.apply(this, _toConsumableArray(this.lastFetchMessagesArgs));
    }
  }, {
    key: 'onKeyUpMessageInput',
    value: function onKeyUpMessageInput(e) {
      this.$btnSend.toggleClass('disabled', !e.target.value);

      // Send an empty message to indicate "typing...", but no more than 1 every
      // second.
      if (!this.lastTypingSentAt || Date.now() - this.lastTypingSentAt >= 1000) {
        var typingMessage = new _ChatMessage2.default({
          peerIds: this.sendToIds,
          subject: this.model.id,
          message: ''
        });

        var saveTypingMessage = typingMessage.save();

        if (saveTypingMessage) {
          this.lastTypingSentAt = Date.now();
        } else {
          // Developer error - this shouldn't happen.
          console.error('There was an error saving the chat message.');
          console.dir(typingMessage.validationError);
        }
      }

      // Send actual chat message if the Enter key was pressed
      if (e.shiftKey || e.which !== 13) return;

      var message = e.target.value.trim();
      if (message) this.sendMessage(message);
      e.preventDefault();
    }
  }, {
    key: 'onKeyDownMessageInput',
    value: function onKeyDownMessageInput(e) {
      if (!e.shiftKey && e.which === 13) e.preventDefault();
    }
  }, {
    key: 'onClickSend',
    value: function onClickSend() {
      var message = this.$inputMessage.val();
      if (message) this.sendMessage(message);
    }
  }, {
    key: 'onScroll',
    value: function onScroll(e) {
      if (this.ignoreScroll) {
        this.ignoreScroll = false;
        this.throttleScrollHandler();
        return;
      }

      if (this.fetching || this.fetchedAllMessages || this.showLoadMessagesError) {
        return;
      }

      // If we come close enough to the top, let's fetch a new page.
      if (e.target.scrollTop <= 100) {
        this.fetchMessages(this.messages.at(0).id);
      }
    }
  }, {
    key: 'onSocketMessage',
    value: function onSocketMessage(e) {
      if (e.jsonData.message && e.jsonData.message.subject !== this.model.id) return;
      if (e.jsonData.messageTyping && e.jsonData.messageTyping.subject !== this.model.id) return;
      if (e.jsonData.messageRead && e.jsonData.messageRead.subject !== this.model.id) return;

      if (e.jsonData.message) {
        // incoming chat message
        var message = new _ChatMessage2.default(_extends({}, e.jsonData.message, {
          outgoing: false
        }));

        this.messages.push(message);
        if (this.options.amActiveTab()) this.markConvoAsRead();

        // We'll consider them to be done typing if an acutal message came
        // in. If they re-start typing, we'll get another socket messsage.
        var messageSender = this.getChatters().find(function (chatter) {
          return chatter.id === e.jsonData.message.peerId;
        });

        if (messageSender) {
          messageSender.isTyping = false;

          // if no one else is typing, we'll hide the indicator
          var typers = this.getChatters().filter(function (chatter) {
            return chatter.isTyping;
          });

          if (!typers.length) {
            this.hideTypingIndicator();
          } else {
            // update it so it doesn show the message sender as typing
            this.setTypingIndicator();
          }
        }
      } else if (e.jsonData.messageTyping) {
        // Conversant is typing...
        this.setTyping(e.jsonData.messageTyping.peerId);
      } else if (e.jsonData.messageRead) {
        // Not using this for now since there are technical / UX complications for marking
        // a message as read when in a group chat (which user read it?).

        // Conversant read your message
        // if (this.convoMessages) {
        //   const model = this.messages.get(e.jsonData.messageRead.messageId);

        //   if (model) {
        //     model.set('read', true);
        //   }

        //   this.convoMessages.markMessageAsRead(e.jsonData.messageRead.messageId);
        // }
      }
    }
  }, {
    key: 'setTyping',
    value: function setTyping(id) {
      if (!id) {
        throw new Error('Please provide an id.');
      }

      var chatters = this.getChatters();
      var typer = chatters.find(function (chatter) {
        return chatter.id === id;
      });

      if (typer) {
        typer.isTyping = true;
        clearTimeout(typer.typingTimeout);
        typer.typingTimeout = setTimeout(function () {
          return typer.isTyping = false;
        }, this.typingExpires);
        this.showTypingIndicator();
      }
    }
  }, {
    key: 'showTypingIndicator',
    value: function showTypingIndicator() {
      var _this3 = this;

      clearTimeout(this.showTypingTimeout);
      this.setTypingIndicator();
      this.$el.addClass('isTyping');
      this.showTypingTimeout = setTimeout(function () {
        return _this3.hideTypingIndicator();
      }, this.typingExpires);
    }
  }, {
    key: 'hideTypingIndicator',
    value: function hideTypingIndicator() {
      clearTimeout(this.showTypingTimeout);
      this.$el.removeClass('isTyping');
    }

    /**
     * Returns the peerIds that chat messages should be sent to.
     */

  }, {
    key: 'sendMessage',
    value: function sendMessage(msg) {
      if (!msg) {
        throw new Error('Please provide a message to send.');
      }

      this.lastTypingSentAt = null;

      var chatMessage = new _ChatMessage2.default({
        peerIds: this.sendToIds,
        subject: this.model.id,
        message: msg
      });

      var save = chatMessage.save();
      var messageSent = true;

      if (save) {
        // At least for now, ignoring any server failures and optimistically adding the new
        // message to the UI. Odds are really low of server failure and repurcussions minimal.
        this.messages.push(chatMessage);
      } else {
        // Developer error - this shouldn't happen.
        console.error('There was an error saving the chat message.');
        console.dir(chatMessage.validationError);
        messageSent = false;
      }

      this.$inputMessage.val('');

      return messageSent;
    }
  }, {
    key: 'fetchMessages',
    value: function fetchMessages(offsetId) {
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.messagesPerPage;

      var params = {
        limit: limit,
        subject: this.model.id
      };

      this.lastFetchMessagesArgs = [offsetId, limit];
      if (offsetId) params.offsetId = offsetId;

      return this.messages.fetch({
        data: _jquery2.default.param(params),
        remove: false
      });
    }
  }, {
    key: 'setScrollTop',
    value: function setScrollTop(value) {
      var silent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      if (typeof value !== 'number') {
        throw new Error('Please provide a value as a number.');
      }

      if (this.$convoMessagesWindow[0].scrollTop === value) return;

      if (silent) {
        // Unthrottling the scroll handler so that our ignoreScoll flag won't
        // be lumped in with a user triggered scroll. The scroll handler will
        // reset the flag and re-throttle the handler.
        this.unthrottleScrollHandler();
        this.ignoreScroll = true;
      }

      this.$convoMessagesWindow[0].scrollTop = value;
    }
  }, {
    key: 'unthrottleScrollHandler',
    value: function unthrottleScrollHandler() {
      this.$convoMessagesWindow.off('scroll', this.boundScrollHandler);
      this.boundScrollHandler = this.onScroll.bind(this);
      this.$convoMessagesWindow.on('scroll', this.boundScrollHandler);
    }
  }, {
    key: 'throttleScrollHandler',
    value: function throttleScrollHandler() {
      this.$convoMessagesWindow.off('scroll', this.boundScrollHandler);
      this.boundScrollHandler = _underscore2.default.throttle(this.onScroll, 100).bind(this);
      this.$convoMessagesWindow.on('scroll', this.boundScrollHandler);
    }
  }, {
    key: 'markConvoAsRead',
    value: function markConvoAsRead() {
      _jquery2.default.post(_app2.default.getServerUrl('ob/markchatasread?subject=' + this.model.id));
      this.trigger('convoMarkedAsRead');
    }
  }, {
    key: 'getChatters',
    value: function getChatters() {
      var includeSelf = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!this._chatters) {
        this._chatters = [_extends({}, this.buyer, {
          role: 'buyer'
        }), _extends({}, this.vendor, {
          role: 'vendor'
        })];

        if (this.moderator) {
          this._chatters.push(_extends({}, this.moderator, {
            role: 'moderator'
          }));
        }
      }

      var chatters = this._chatters;

      if (!includeSelf) {
        chatters = this._chatters.filter(function (chatter) {
          return chatter.id !== _app2.default.profile.id;
        });
      }

      return chatters;
    }
  }, {
    key: 'getTypingIndicatorContent',
    value: function getTypingIndicatorContent() {
      var typingText = '';
      var typers = this.getChatters().filter(function (chatter) {
        return chatter.isTyping;
      });
      var names = typers.map(function (typer) {
        return _app2.default.polyglot.t('orderDetail.discussionTab.role' + (0, _string.capitalize)(typer.role));
      });

      if (names.length === 1) {
        typingText = _app2.default.polyglot.t('orderDetail.discussionTab.isTyping', { userRole: names[0] });
      } else if (names.length === 2) {
        typingText = _app2.default.polyglot.t('orderDetail.discussionTab.areTyping', {
          userRole1: names[0],
          userRole2: names[1]
        });
      }

      return typingText;
    }
  }, {
    key: 'setTypingIndicator',
    value: function setTypingIndicator() {
      this.$typingIndicator.html(this.getTypingIndicatorContent());
    }
  }, {
    key: 'checkIfModCanChat',
    value: function checkIfModCanChat() {
      if (this.moderator && this.moderator.id === _app2.default.profile.id && this.model.get('state') === 'RESOLVED') {
        // If this is the moderator looking at the order and the mod has
        // already made a decision, the mod cannot send any more chat messages.
        this.$convoFooter.addClass('preventModChat');
      }
    }
  }, {
    key: 'setMessageInputPlaceholder',
    value: function setMessageInputPlaceholder() {
      if (this.moderator && this.moderator.id === _app2.default.profile.id) return;

      if (this.model.get('state') === 'DECIDED' || this.model.get('state') === 'RESOLVED') {
        // If the mod has made a decision, indicator to the vendor / buyer
        // that they will no longer recieve new chat message.
        this.$inputMessage[0].placeholder = _app2.default.polyglot.t('orderDetail.discussionTab.enterMessageNoMoreModPlaceholder');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('modals/orderDetail/discussion.html', function (t) {
        _this4.$el.html(t({
          showLoadMessagesError: _this4.showLoadMessagesError,
          typingIndicator: _this4.getTypingIndicatorContent(),
          maxMessageLength: _ChatMessage2.default.max.messageLength,
          ownProfile: _app2.default.profile.toJSON(),
          canModChat: _this4.footerClass
        }));

        _this4._$subMenu = null;
        _this4._$messagesOverlay = null;
        _this4._$loadMessagesError = null;
        _this4._$convoMessagesWindow = null;
        _this4._$typingIndicator = null;
        _this4._$btnSend = null;
        _this4._$msgInput = null;
        _this4._$convoFooter = null;

        if (_this4.convoMessages) _this4.ConvoMessages.remove();
        _this4.convoMessages = new _ConvoMessages2.default({
          collection: _this4.messages,
          $scrollContainer: _this4.$convoMessagesWindow,
          buyer: _this4.buyer,
          vendor: _this4.vendor,
          moderator: _this4.moderator
        });
        _this4.$('.js-convoMessagesContainer').html(_this4.convoMessages.render().el);

        _this4.throttleScrollHandler();
        _this4.checkIfModCanChat();
        _this4.setMessageInputPlaceholder();
      });

      return this;
    }
  }, {
    key: 'messagesPerPage',
    get: function get() {
      return 20;
    }
  }, {
    key: 'typingExpires',
    get: function get() {
      return 3000;
    }
  }, {
    key: 'sendToIds',
    get: function get() {
      var _this5 = this;

      return this.getChatters().filter(function (chatter) {
        // only include the moderator if the order is under
        // an active dispute
        var include = true;

        if (chatter.role === 'moderator' && _this5.model.get('state') !== 'DISPUTED') {
          include = false;
        }

        return include;
      }).map(function (chatter) {
        return chatter.id;
      });
    }
  }, {
    key: '$typingIndicator',
    get: function get() {
      return this._$typingIndicator || (this._$typingIndicator = this.$('.js-typingIndicator'));
    }
  }, {
    key: '$messagesOverlay',
    get: function get() {
      return this._$messagesOverlay || (this._$messagesOverlay = this.$('.js-messagesOverlay'));
    }
  }, {
    key: '$loadMessagesError',
    get: function get() {
      var returnVal = void 0;

      if (this._$loadMessagesError && this._$loadMessagesError.length) {
        returnVal = this._$loadMessagesError;
      } else {
        returnVal = this._$loadMessagesError = this.$('.js-loadMessagesError');
      }

      return returnVal;
    }
  }, {
    key: '$convoMessagesWindow',
    get: function get() {
      return this._$convoMessagesWindow || (this._$convoMessagesWindow = this.$('.js-convoMessagesWindow'));
    }
  }, {
    key: '$btnSend',
    get: function get() {
      return this._$btnSend || (this._$btnSend = this.$('.js-btnSend'));
    }
  }, {
    key: '$inputMessage',
    get: function get() {
      return this._$inputMessage || (this._$inputMessage = this.$('.js-inputMessage'));
    }
  }, {
    key: '$convoFooter',
    get: function get() {
      return this._$convoFooter || (this._$convoFooter = this.$('.js-convoFooter'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;