'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _order = require('../../../utils/order');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _OrderDetail = require('./OrderDetail.js');

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _ModFragment = require('./ModFragment');

var _ModFragment2 = _interopRequireDefault(_ModFragment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!_this.model) {
      throw new Error('Please provide an DisputeOrder model.');
    }

    (0, _OrderDetail.checkValidParticipantObject)(options.moderator, 'moderator');

    options.moderator.getProfile().done(function (modProfile) {
      _this.modProfile = modProfile;
      if (_this.moderatorVw) _this.moderatorVw.setState(_extends({}, modProfile.toJSON()));
    });

    _this.options = options;

    _this.listenTo(_order.events, 'openingDispute', _this.onOpeningDispute);
    _this.listenTo(_order.events, 'openDisputeComplete, openDisputeFail', _this.onOpenDisputeAlways);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'disputeOrderTab';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-backToSummary': 'onClickBackToSummary',
        'click .js-cancel': 'onClickCancel',
        'click .js-submit': 'onClickSubmit'
      };
    }
  }, {
    key: 'onClickBackToSummary',
    value: function onClickBackToSummary() {
      this.trigger('clickBackToSummary');
    }
  }, {
    key: 'onClickCancel',
    value: function onClickCancel() {
      var id = this.model.id;
      this.model.reset();
      // restore the id reset blew away
      this.model.set({ orderId: id });
      this.render();
      this.trigger('clickCancel');
    }
  }, {
    key: 'onClickSubmit',
    value: function onClickSubmit() {
      var formData = this.getFormData();
      this.model.set(formData);
      this.model.set({}, { validate: true });

      if (!this.model.validationError) {
        (0, _order.openDispute)(this.model.id, this.model.toJSON());
      }

      this.render();
      var $firstErr = this.$('.errorList:first');
      if ($firstErr.length) $firstErr[0].scrollIntoViewIfNeeded();
    }
  }, {
    key: 'onOpeningDisputeOrder',
    value: function onOpeningDisputeOrder(e) {
      if (e.id === this.model.id) {
        this.getCachedEl('.js-submit').addClass('processing');
        this.getCachedEl('.js-cancel').addClass('disabled');
      }
    }
  }, {
    key: 'onOpenDisputeAlways',
    value: function onOpenDisputeAlways(e) {
      if (e.id === this.model.id) {
        this.getCachedEl('.js-submit').removeClass('processing');
        this.getCachedEl('.js-cancel').removeClass('disabled');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/orderDetail/disputeOrder.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.model.toJSON(), {
          errors: _this2.model.validationError || {},
          openingDispute: !!(0, _order.openingDispute)(_this2.model.id)
        })));

        var moderatorState = _extends({
          peerId: _this2.options.moderator.id,
          showAvatar: true
        }, _this2.modProfile && _this2.modProfile.toJSON() || {});

        if (_this2.moderatorVw) _this2.moderatorVw.remove();
        _this2.moderatorVw = _this2.createChild(_ModFragment2.default, {
          initialState: moderatorState
        });

        _this2.$('.js-modContainer').html(_this2.moderatorVw.render().el);
      });

      return this;
    }
  }, {
    key: 'autoFocusFirstField',
    get: function get() {
      return true;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;