'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _order = require('../../../utils/order');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!_this.model) {
      throw new Error('Please provide an OrderFulfillment model.');
    }

    if (!options.contractType) {
      throw new Error('Please provide the contract type.');
    }

    if (typeof options.isLocalPickup !== 'boolean') {
      throw new Error('Please provide a boolean indicating whether the item is to ' + 'be picked up locally.');
    }

    _this.contractType = options.contractType;
    _this.isLocalPickup = options.isLocalPickup;
    _this.listenTo(_order.events, 'fulfillingOrder', _this.onFulfillingOrder);
    _this.listenTo(_order.events, 'fulfillOrderComplete, fulfillOrderFail', _this.onFulfillOrderAlways);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'fulfillOrderTab';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-backToSummary': 'onClickBackToSummary',
        'click .js-cancel': 'onClickCancel',
        'click .js-submit': 'onClickSubmit'
      };
    }
  }, {
    key: 'onClickBackToSummary',
    value: function onClickBackToSummary() {
      this.trigger('clickBackToSummary');
    }
  }, {
    key: 'onClickCancel',
    value: function onClickCancel() {
      var id = this.model.id;
      this.model.reset();
      // restore the id reset blew away
      this.model.set({ orderId: id });
      this.render();
      this.trigger('clickCancel');
    }
  }, {
    key: 'onClickSubmit',
    value: function onClickSubmit() {
      var formData = this.getFormData();
      this.model.set(formData);
      this.model.set({}, { validate: true });

      if (!this.model.validationError) {
        (0, _order.fulfillOrder)(this.contractType, this.isLocalPickup, this.model.toJSON());
      }

      this.render();
      var $firstErr = this.$('.errorList:first');
      if ($firstErr.length) $firstErr[0].scrollIntoViewIfNeeded();
    }
  }, {
    key: 'onFulfillingOrder',
    value: function onFulfillingOrder(e) {
      if (e.id === this.model.id) {
        this.$btnSubmit.addClass('processing');
        this.$btnCancel.addClass('disabled');
      }
    }
  }, {
    key: 'onFulfillOrderAlways',
    value: function onFulfillOrderAlways(e) {
      if (e.id === this.model.id) {
        this.$btnSubmit.removeClass('processing');
        this.$btnCancel.removeClass('disabled');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/orderDetail/fulfillOrder.html', function (t) {
        _this2.$el.html(t(_extends({
          contractType: _this2.contractType,
          isLocalPickup: _this2.isLocalPickup
        }, _this2.model.toJSON(), {
          errors: _this2.model.validationError || {},
          fulfillingOrder: (0, _order.fulfillingOrder)(_this2.model.id)
        })));

        _this2._$btnCancel = null;
        _this2._$btnSubmit = null;
      });

      return this;
    }
  }, {
    key: 'autoFocusFirstField',
    get: function get() {
      return true;
    }
  }, {
    key: '$btnCancel',
    get: function get() {
      return this._$btnCancel || (this._$btnCancel = this.$('.js-cancel'));
    }
  }, {
    key: '$btnSubmit',
    get: function get() {
      return this._$btnSubmit || (this._$btnSubmit = this.$('.js-submit'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;