'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _VerifiedMod = require('../../components/VerifiedMod');

var _VerifiedMod2 = _interopRequireDefault(_VerifiedMod);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    _this._state = _extends({
      maxPeerIdLength: 8,
      showAvatar: false
    }, options.initialState || {});

    _this.verifiedModModel = _app2.default.verifiedMods.get(_this._state.peerID);

    _this.listenTo(_app2.default.verifiedMods, 'update', function () {
      var newVerifiedModModel = _app2.default.verifiedMods.get(_this._state.peerID);
      if (newVerifiedModModel !== _this.verifiedModModel) {
        _this.verifiedModModel = newVerifiedModModel;
        _this.render();
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('modals/orderDetail/modFragment.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2._state)));

        var verifiedMod = _app2.default.verifiedMods.get(_this2._state.peerID);
        var createOptions = (0, _VerifiedMod.getModeratorOptions)({
          model: verifiedMod
        });

        if (!verifiedMod) {
          createOptions.initialState.tipBody = _app2.default.polyglot.t('verifiedMod.modUnverified.tipBodyOrderDetail', {
            not: '<b>' + _app2.default.polyglot.t('verifiedMod.modUnverified.not') + '</b>',
            name: '<b>' + _app2.default.verifiedMods.data.name + '</b>'
          });
        }

        if (_this2.verifiedMod) _this2.verifiedMod.remove();
        _this2.verifiedMod = _this2.createChild(_VerifiedMod2.default, createOptions);
        _this2.getCachedEl('.js-verifiedMod').append(_this2.verifiedMod.render().el);
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;