'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.checkValidParticipantObject = checkValidParticipantObject;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _string = require('../../../utils/string');

var _serverConnect = require('../../../utils/serverConnect');

var _order = require('../../../utils/order');

var _Profile = require('../../../models/profile/Profile');

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _metrics = require('../../../utils/metrics');

var _Case = require('../../../models/order/Case');

var _Case2 = _interopRequireDefault(_Case);

var _OrderFulfillment = require('../../../models/order/orderFulfillment/OrderFulfillment');

var _OrderFulfillment2 = _interopRequireDefault(_OrderFulfillment);

var _OrderDispute = require('../../../models/order/OrderDispute');

var _OrderDispute2 = _interopRequireDefault(_OrderDispute);

var _ResolveDispute = require('../../../models/order/ResolveDispute');

var _ResolveDispute2 = _interopRequireDefault(_ResolveDispute);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _ProfileBox = require('./ProfileBox');

var _ProfileBox2 = _interopRequireDefault(_ProfileBox);

var _Summary = require('./summaryTab/Summary');

var _Summary2 = _interopRequireDefault(_Summary);

var _Discussion = require('./Discussion');

var _Discussion2 = _interopRequireDefault(_Discussion);

var _ContractTab = require('./contractTab/ContractTab');

var _ContractTab2 = _interopRequireDefault(_ContractTab);

var _FulfillOrder = require('./FulfillOrder');

var _FulfillOrder2 = _interopRequireDefault(_FulfillOrder);

var _DisputeOrder = require('./DisputeOrder');

var _DisputeOrder2 = _interopRequireDefault(_DisputeOrder);

var _ResolveDispute3 = require('./ResolveDispute');

var _ResolveDispute4 = _interopRequireDefault(_ResolveDispute3);

var _ActionBar = require('./ActionBar');

var _ActionBar2 = _interopRequireDefault(_ActionBar);

var _ContractMenuItem = require('./ContractMenuItem');

var _ContractMenuItem2 = _interopRequireDefault(_ContractMenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      initialState: {
        isFetching: false,
        fetchFailed: false,
        fetchError: ''
      },
      initialTab: 'summary'
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this._tab = opts.initialTab;
    _this.options = opts;
    _this.tabViewCache = {};

    if (!_this.model) {
      throw new Error('Please provide an Order model.');
    }

    _this._state = _extends({}, opts.initialState || {});

    _this.listenTo(_this.model, 'request', _this.onOrderRequest);
    _this.listenToOnce(_this.model, 'sync', _this.onFirstOrderSync);
    _this.listenTo(_this.model, 'change:unreadChatMessages', function () {
      return _this.setUnreadChatMessagesBadge();
    });

    _this.listenTo(_order.events, 'fulfillOrderComplete', function () {
      if (_this.activeTab === 'fulfillOrder') _this.selectTab('summary');
    });

    _this.listenTo(_this.model, 'change:state', function (md) {
      if (_this.actionBar) {
        _this.actionBar.setState(_this.actionBarButtonState);
      }
      (0, _metrics.recordEvent)('OrderDetails_LiveStateChange', {
        state: md.get('state'),
        moderated: !!_this.moderatorId // collect only a boolean
      });
    });

    _this.listenTo(_order.events, 'openDisputeComplete', function () {
      if (_this.activeTab === 'disputeOrder') _this.selectTab('summary');
    });

    _this.listenTo(_order.events, 'resolveDisputeComplete', function () {
      if (_this.activeTab === 'resolveDispute') _this.selectTab('summary');
    });

    _this.listenTo(_this.model, 'otherContractArrived', function () {
      if (_this.contractMenuItem) {
        _this.contractMenuItem.setState(_this.contractMenuItemState);
      }
    });

    var socket = (0, _serverConnect.getSocket)();

    if (socket) {
      _this.listenTo(socket, 'message', _this.onSocketMessage);
    }

    _this.model.fetch();
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' modalScrollPage tabbedModal orderDetail';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-toggleSendReceive': 'onClickToggleSendReceive',
        'click .js-retryFetch': 'onClickRetryFetch',
        'click .js-returnBox': 'onClickReturnBox',
        'click .js-tab': 'onTabClick'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onOrderRequest',
    value: function onOrderRequest(md, xhr) {
      var _this2 = this;

      this.setState({
        isFetching: true,
        fetchError: '',
        fetchFailed: false
      });

      xhr.done(function () {
        _this2.setState({
          isFetching: false,
          fetchFailed: false
        });
      }).fail(function (jqXhr) {
        if (jqXhr.statusText === 'abort') return;

        var fetchError = '';

        if (jqXhr.responseJSON && jqXhr.responseJSON.reason) {
          fetchError = jqXhr.responseJSON.reason;
        }

        _this2.setState({
          isFetching: false,
          fetchFailed: true,
          fetchError: fetchError
        });
      });
    }
  }, {
    key: 'onFirstOrderSync',
    value: function onFirstOrderSync() {
      var _this3 = this;

      this.stopListening(this.model, null, this.onOrderRequest);
      var featuredProfileState = { isFetching: false };
      var featuredProfileFetch = void 0;

      if (this.type === 'case') {
        if (this.model.get('buyerOpened')) {
          featuredProfileFetch = this.getBuyerProfile();
          this.featuredProfilePeerId = featuredProfileState.peerID = this.buyerId;
        } else {
          featuredProfileFetch = this.getVendorProfile();
          this.featuredProfilePeerId = featuredProfileState.peerID = this.vendorId;
        }
      } else if (this.type === 'sale') {
        featuredProfileFetch = this.getBuyerProfile();
        this.featuredProfilePeerId = featuredProfileState.peerID = this.buyerId;
      } else {
        featuredProfileFetch = this.getVendorProfile();
        this.featuredProfilePeerId = featuredProfileState.peerID = this.vendorId;
      }

      featuredProfileFetch.done(function (profile) {
        _this3.featuredProfileMd = profile;
        if (_this3.featuredProfile) _this3.featuredProfile.setModel(_this3.featuredProfileMd);
      });

      if (this.featuredProfile) this.featuredProfile.setState(featuredProfileState);
    }
  }, {
    key: 'onClickRetryFetch',
    value: function onClickRetryFetch() {
      this.model.fetch();
    }
  }, {
    key: 'onClickReturnBox',
    value: function onClickReturnBox() {
      this.close();
    }
  }, {
    key: 'onTabClick',
    value: function onTabClick(e) {
      var targ = (0, _jquery2.default)(e.target).closest('.js-tab');
      this.selectTab(targ.attr('data-tab'));
    }
  }, {
    key: 'onSocketMessage',
    value: function onSocketMessage(e) {
      var notificationTypes = [
      // A notification for the buyer that a payment has come in for the order. Let's refetch
      // our model so we have the data for the new transaction and can show it in the UI.
      // As of now, the buyer only gets these notifications and this is the only way to be
      // aware of partial payments in realtime.
      'payment',
      // A notification the vendor will get when an offline order has been canceled
      'cancel',
      // A notification the vendor will get when an order has been fully funded
      'order',
      // A notification the buyer will get when the vendor has rejected an offline order.
      'declined',
      // A notification the buyer will get when the vendor has accepted an offline order.
      'orderConfirmation',
      // A notification the buyer will get when the vendor has refunded their order.
      'refund',
      // A notification the buyer will get when the vendor has fulfilled their order.
      'fulfillment',
      // A notification the vendor will get when the buyer has completed an order.
      'orderComplete',
      // When a party opens a dispute the mod and the other party will get this notification
      'disputeOpen',
      // Sent to the moderator when the other party (the one that didn't open the dispute) sends
      // their copy of the contract (which would occur if they were onffline when the dispute was
      // opened and have since come online).
      'disputeUpdate',
      // Notification to the vendor and buyer when a mod has made a decision on an open dispute.
      'disputeClose',
      // Notification the other party will receive when a dispute payout is accepted (e.g. if vendor
      // accepts, the buyer will get this and vice versa).
      'disputeAccepted',
      // Socket received by buyer when the vendor has an error processing an offline order.
      'processingError'];

      if (e.jsonData.notification && e.jsonData.notification.orderId === this.model.id) {
        if (notificationTypes.indexOf(e.jsonData.notification.type) > -1) {
          this.model.fetch();
        }
      }

      if (e.jsonData.message && e.jsonData.message.subject === this.model.id && this.activeTab !== 'discussion') {
        var count = this.model.get('unreadChatMessages');
        this.model.set('unreadChatMessages', count + 1);
      }
    }
  }, {
    key: '_getParticipantProfile',
    value: function _getParticipantProfile(participantType) {
      var idKey = participantType + 'Id';
      var profileKey = '_' + participantType + 'Profile';

      if (!this[profileKey]) {
        if (this[idKey] === _app2.default.profile.id) {
          var deferred = _jquery2.default.Deferred();
          deferred.resolve(_app2.default.profile);
          this[profileKey] = deferred.promise();
        } else {
          this[profileKey] = (0, _Profile.getCachedProfiles)([this[idKey]])[0];
        }
      }

      return this[profileKey];
    }

    /**
     * Returns a promise that resolves with the buyer's Profile model.
     */

  }, {
    key: 'getBuyerProfile',
    value: function getBuyerProfile() {
      return this._getParticipantProfile('buyer');
    }

    /**
     * Returns a promise that resolves with the vendor's Profile model.
     */

  }, {
    key: 'getVendorProfile',
    value: function getVendorProfile() {
      return this._getParticipantProfile('vendor');
    }

    /**
     * Returns a promise that resolves with the moderator's Profile model.
     */

  }, {
    key: 'getModeratorProfile',
    value: function getModeratorProfile() {
      return this._getParticipantProfile('moderator');
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'selectTab',
    value: function selectTab(targ) {
      if (!this['create' + (0, _string.capitalize)(targ) + 'TabView']) {
        throw new Error(targ + ' is not a valid tab.');
      }

      this._tab = targ;
      var tabView = this.tabViewCache[targ];

      if (!this.currentTabView || this.currentTabView !== tabView) {
        this.$('.js-tab').removeClass('clrT active');
        this.$('.js-tab[data-tab="' + targ + '"]').addClass('clrT active');

        if (this.currentTabView) this.currentTabView.$el.detach();

        if (!tabView) {
          tabView = this['create' + (0, _string.capitalize)(targ) + 'TabView']();
          this.tabViewCache[targ] = tabView;
          tabView.render();
        }

        this.$tabContent.append(tabView.$el);

        if (typeof tabView.onAttach === 'function') {
          tabView.onAttach.call(tabView);
        }

        if (tabView.autoFocusFirstField) {
          tabView.$el.find('select, input, textarea')[0].focus();
        }

        this.currentTabView = tabView;
      }
    }
  }, {
    key: 'createSummaryTabView',
    value: function createSummaryTabView() {
      var _this4 = this;

      var viewData = {
        model: this.model,
        vendor: {
          id: this.vendorId,
          getProfile: this.getVendorProfile.bind(this)
        },
        buyer: {
          id: this.buyerId,
          getProfile: this.getBuyerProfile.bind(this)
        }
      };

      if (this.moderatorId) {
        viewData.moderator = {
          id: this.moderatorId,
          getProfile: this.getModeratorProfile.bind(this)
        };
      }

      var view = this.createChild(_Summary2.default, viewData);
      this.listenTo(view, 'clickFulfillOrder', function () {
        return _this4.selectTab('fulfillOrder');
      });
      this.listenTo(view, 'clickResolveDispute', function () {
        return _this4.selectTab('resolveDispute');
      });

      return view;
    }
  }, {
    key: 'createDiscussionTabView',
    value: function createDiscussionTabView() {
      var _this5 = this;

      var amActiveTab = function amActiveTab() {
        return _this5.activeTab === 'discussion';
      };
      var viewData = {
        orderId: this.model.id,
        buyer: {
          id: this.buyerId,
          getProfile: this.getBuyerProfile.bind(this)
        },
        vendor: {
          id: this.vendorId,
          getProfile: this.getVendorProfile.bind(this)
        },
        model: this.model,
        amActiveTab: amActiveTab.bind(this)
      };

      if (this.moderatorId) {
        viewData.moderator = {
          id: this.moderatorId,
          getProfile: this.getModeratorProfile.bind(this)
        };
      }

      var view = this.createChild(_Discussion2.default, viewData);
      this.listenTo(view, 'convoMarkedAsRead', function () {
        _this5.model.set('unreadChatMessages', 0);
        _this5.trigger('convoMarkedAsRead');
      });

      return view;
    }
  }, {
    key: 'createContractTabView',
    value: function createContractTabView() {
      var _this6 = this;

      var view = this.createChild(_ContractTab2.default, {
        model: this.model
      });

      this.listenTo(view, 'clickBackToSummary', function () {
        return _this6.selectTab('summary');
      });
      return view;
    }

    // This should not be called on a Case.

  }, {
    key: 'createFulfillOrderTabView',
    value: function createFulfillOrderTabView() {
      var _this7 = this;

      var contract = this.model.get('contract');

      var model = new _OrderFulfillment2.default({ orderId: this.model.id }, {
        contractType: contract.type,
        isLocalPickup: contract.isLocalPickup
      });

      var view = this.createChild(_FulfillOrder2.default, {
        model: model,
        contractType: contract.type,
        isLocalPickup: contract.isLocalPickup
      });

      this.listenTo(view, 'clickBackToSummary clickCancel', function () {
        return _this7.selectTab('summary');
      });

      return view;
    }
  }, {
    key: 'createDisputeOrderTabView',
    value: function createDisputeOrderTabView() {
      var _this8 = this;

      var contractType = this.model.get('contract').type;

      var model = new _OrderDispute2.default({ orderId: this.model.id });

      var view = this.createChild(_DisputeOrder2.default, {
        model: model,
        contractType: contractType,
        moderator: {
          id: this.moderatorId,
          getProfile: this.getModeratorProfile.bind(this)
        }
      });

      this.listenTo(view, 'clickBackToSummary clickCancel', function () {
        return _this8.selectTab('summary');
      });

      return view;
    }
  }, {
    key: 'createResolveDisputeTabView',
    value: function createResolveDisputeTabView() {
      var _this9 = this;

      var modelAttrs = { orderId: this.model.id };
      var isResolvingDispute = (0, _order.resolvingDispute)(this.model.id);

      // If this order is in the process of the dispute being resolved, we'll
      // populate the model with the data that was posted to the server.
      if (isResolvingDispute) {
        modelAttrs = _extends({}, modelAttrs, isResolvingDispute.data);
      }

      var model = new _ResolveDispute2.default(modelAttrs, {
        buyerContractArrived: function buyerContractArrived() {
          return !!_this9.model.get('buyerContract');
        },
        vendorContractArrived: function vendorContractArrived() {
          return !!_this9.model.get('vendorContract');
        },
        vendorProcessingError: function vendorProcessingError() {
          return _this9.model.vendorProcessingError;
        }
      });

      var view = this.createChild(_ResolveDispute4.default, {
        model: model,
        case: this.model,
        vendor: {
          id: this.vendorId,
          getProfile: this.getVendorProfile.bind(this)
        },
        buyer: {
          id: this.buyerId,
          getProfile: this.getBuyerProfile.bind(this)
        }
      });

      this.listenTo(view, 'clickBackToSummary clickCancel', function () {
        return _this9.selectTab('summary');
      });

      return view;
    }
  }, {
    key: 'setUnreadChatMessagesBadge',
    value: function setUnreadChatMessagesBadge() {
      this.$unreadChatMessagesBadge.text(this.getUnreadChatMessagesText());
    }
  }, {
    key: 'getUnreadChatMessagesText',
    value: function getUnreadChatMessagesText() {
      var count = this.model.get('unreadChatMessages');
      count = count > 0 ? count : '';
      count = count > 99 ? '…' : count;
      return count;
    }

    /**
     * Returns whether different action bar buttons should be displayed or not
     * based upon the order state.
     */

  }, {
    key: 'render',
    value: function render() {
      var _this10 = this;

      (0, _loadTemplate2.default)('modals/orderDetail/orderDetail.html', function (t) {
        var state = _this10.getState();

        _this10.$el.html(t(_extends({}, state, _this10.model.toJSON(), {
          returnText: _this10.options.returnText,
          type: _this10.type,
          getUnreadChatMessagesText: _this10.getUnreadChatMessagesText.bind(_this10)
        })));
        _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this10).call(_this10);

        _this10.$tabContent = _this10.$('.js-tabContent');
        _this10._$unreadChatMessagesBadge = null;

        if (_this10.featuredProfile) _this10.featuredProfile.remove();
        _this10.featuredProfile = _this10.createChild(_ProfileBox2.default, {
          model: _this10.featuredProfileMd || null,
          initialState: {
            isFetching: !_this10.featuredProfilePeerId,
            peerID: _this10.featuredProfilePeerId
          }
        });
        _this10.$('.js-featuredProfile').html(_this10.featuredProfile.render().el);

        if (!state.isFetching && !state.fetchError) {
          _this10.selectTab(_this10.activeTab);

          if (_this10.actionBar) _this10.actionBar.remove();
          _this10.actionBar = _this10.createChild(_ActionBar2.default, {
            orderId: _this10.model.id,
            initialState: _this10.actionBarButtonState
          });
          _this10.$('.js-actionBarContainer').html(_this10.actionBar.render().el);
          _this10.listenTo(_this10.actionBar, 'clickOpenDispute', function () {
            return _this10.selectTab('disputeOrder');
          });

          if (_this10.contractMenuItem) _this10.contractMenuItem.remove();
          _this10.contractMenuItem = _this10.createChild(_ContractMenuItem2.default, {
            initialState: _extends({}, _this10.contractMenuItemState)
          });
          _this10.getCachedEl('[data-tab="contract"]').replaceWith(_this10.contractMenuItem.render().el);
        }
      });

      return this;
    }
  }, {
    key: 'type',
    get: function get() {
      return this.model instanceof _Case2.default ? 'case' : this.model.type;
    }
  }, {
    key: 'participantIds',
    get: function get() {
      if (!this._participantIds) {
        var contract = this.model.get('contract');

        if (this.type === 'case') {
          contract = this.model.get('buyerOpened') ? this.model.get('buyerContract') : this.model.get('vendorContract');
        }

        if (!contract) {
          throw new Error('Unable to determine the participant IDs. The contract is not ' + 'available. The order model has likely not been synced yet.');
        }

        var contractJSON = contract.toJSON();

        this._participantIds = {
          buyer: contractJSON.buyerOrder.buyerID.peerID,
          vendor: contractJSON.vendorListings[0].vendorID.peerID,
          moderator: contractJSON.buyerOrder.payment.moderator
        };
      }

      return this._participantIds;
    }
  }, {
    key: 'buyerId',
    get: function get() {
      return this.participantIds.buyer;
    }
  }, {
    key: 'vendorId',
    get: function get() {
      return this.participantIds.vendor;
    }
  }, {
    key: 'moderatorId',
    get: function get() {
      return this.participantIds.moderator;
    }
  }, {
    key: 'activeTab',
    get: function get() {
      return this._tab;
    }
  }, {
    key: 'actionBarButtonState',
    get: function get() {
      var orderState = this.model.get('state');
      var showDisputeOrderButton = false;

      if (this.buyerId === _app2.default.profile.id) {
        // TODO todo ToDo !!! TODO todo ToDo !!! TODO todo ToDo !!!
        // todo: when escrow timeout code is ready, include this in the timeoutInfoView
        // also ensure order is funded if processing error
        showDisputeOrderButton = this.moderatorId && ['AWAITING_FULFILLMENT', 'PENDING', 'FULFILLED', 'PROCESSING_ERROR'].indexOf(orderState) > -1;
      } else if (this.vendorId === _app2.default.profile.id) {
        showDisputeOrderButton = this.moderatorId && ['AWAITING_FULFILLMENT', 'FULFILLED'].indexOf(orderState) > -1;
      }

      return {
        showDisputeOrderButton: showDisputeOrderButton
      };
    }
  }, {
    key: 'contractMenuItemState',
    get: function get() {
      var isCase = typeof this.model.get('buyerOpened') !== 'undefined';
      var tip = '';

      if (isCase && !this.model.bothContractsValid) {
        var buyerContractAvailableAndInvalid = this.model.get('buyerContract') && !this.model.isBuyerContractValid;
        var vendorContractAvailableAndInvalid = this.model.get('vendorContract') && !this.model.isVendorContractValid;

        if (buyerContractAvailableAndInvalid && vendorContractAvailableAndInvalid) {
          tip = _app2.default.polyglot.t('orderDetail.contractMenuItem.tipBothContractsHaveError');
        } else {
          // "contract" here means the contract we're guaranteed to have
          var isContractValid = this.model.get('buyerOpened') ? this.model.isBuyerContractValid : this.model.isVendorContractValid;
          var otherContract = this.model.get('buyerOpened') ? this.model.get('vendorContract') : this.model.get('buyerContract');
          var type = this.model.get('buyerOpened') ? 'Buyer' : 'Vendor';
          var otherType = this.model.get('buyerOpened') ? 'Vendor' : 'Buyer';

          if (!isContractValid) {
            tip = _app2.default.polyglot.t('orderDetail.contractMenuItem.tip' + type + 'ContractHasError');
          }

          if (!otherContract) {
            tip += '' + (tip ? ' ' : '') + ('' + _app2.default.polyglot.t('orderDetail.contractMenuItem.tip' + otherType + 'ContractNotArrived'));
          } else if (!this.model.isContractValid(!this.model.get('buyerOpened'))) {
            tip += '' + (tip ? ' ' : '') + ('' + _app2.default.polyglot.t('orderDetail.contractMenuItem.tip' + type + 'ContractHasError'));
          }
        }
      }

      return { tip: tip };
    }
  }, {
    key: '$unreadChatMessagesBadge',
    get: function get() {
      return this._$unreadChatMessagesBadge || (this._$unreadChatMessagesBadge = this.$('.js-unreadChatMessagesBadge'));
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;
function checkValidParticipantObject(participant, type) {
  if ((typeof participant === 'undefined' ? 'undefined' : _typeof(participant)) !== 'object') {
    throw new Error('Please provide a participant object for the ' + type + '.');
  }

  if (typeof type !== 'string') {
    throw new Error('Please provide the participant type as a string.');
  }

  if (!participant.id || typeof participant.getProfile !== 'function') {
    throw new Error('The ' + type + ' object is not valid. It should have an id ' + 'as well as a getProfile function that returns a promise that ' + 'resolves with a profile model.');
  }
}