'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _order = require('../../../../utils/order');

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Rating = require('../../../../models/order/orderCompletion/Rating');

var _Rating2 = _interopRequireDefault(_Rating);

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _RatingsStrip = require('../../../RatingsStrip');

var _RatingsStrip2 = _interopRequireDefault(_RatingsStrip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!options.model) {
      throw new Error('Please provide an OrderCompletion model.');
    }

    if (!options.slug) {
      throw new Error('Please provide the listing slug.');
    }

    _this.ratingStrips = {};
    _this.slug = options.slug;

    var ratings = _this.model.get('ratings');

    if (ratings.length) {
      _this.rating = ratings.at(0);
    } else {
      _this.rating = new _Rating2.default();
      ratings.push(_this.rating);
    }

    _this.listenTo(_order.events, 'completingOrder', function () {
      _this.getCachedEl('.js-completeOrder').addClass('processing');
    });

    _this.listenTo(_order.events, 'completeOrderComplete completeOrderFail', function () {
      _this.getCachedEl('.js-completeOrder').removeClass('processing');
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'completeOrderForm rowLg';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-completeOrder': 'onClickCompleteOrder'
      };
    }
  }, {
    key: 'onClickCompleteOrder',
    value: function onClickCompleteOrder() {
      var formData = this.getFormData();

      var data = _extends({}, formData, {
        anonymous: !formData.anonymous,
        // If a rating is not set, the RatingStrip view will return 0. We'll
        // send undefined in that case since it gives us the error message we
        // prefer.
        overall: this.ratingStrips.overall.rating || undefined,
        quality: this.ratingStrips.quality.rating || undefined,
        description: this.ratingStrips.description.rating || undefined,
        deliverySpeed: this.ratingStrips.deliverySpeed.rating || undefined,
        customerService: this.ratingStrips.customerService.rating || undefined,
        slug: this.slug
      });

      this.rating.set(data);
      this.rating.set(data, { validate: true });

      if (!this.rating.validationError) {
        (0, _order.completeOrder)(this.model.id, this.model.toJSON());
      }

      this.render();
      var $firstErr = this.$('.errorList:first');
      if ($firstErr.length) $firstErr[0].scrollIntoViewIfNeeded();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/orderDetail/summaryTab/completeOrderForm.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.rating.toJSON(), {
          errors: _this2.rating.validationError || {},
          isCompleting: !!(0, _order.completingOrder)(_this2.model.id),
          constraints: _this2.rating.constraints || {}
        })));

        _this2.$('.ratingsContainer').each(function (index, element) {
          var $el = (0, _jquery2.default)(element);
          var type = $el.data('ratingType');

          if (!type) {
            throw new Error('Unable to render a ratings strips because it\'s container does not ' + 'specify a type.');
          }

          if (_this2.ratingStrips[type]) _this2.ratingStrips[type].remove();
          _this2.ratingStrips[type] = _this2.createChild(_RatingsStrip2.default, {
            initialState: {
              curRating: _this2.rating.get(type) || 0,
              clickable: true
            }
          });

          $el.append(_this2.ratingStrips[type].render().el);
        });
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;