'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../../app');

var _app2 = _interopRequireDefault(_app);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _order = require('../../../../utils/order');

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!options.orderId) {
      throw new Error('Please provide the orderId');
    }

    _this.orderId = options.orderId;

    _this._state = _extends({
      userCurrency: _app2.default.settings.get('localCurrency') || 'USD',
      showAcceptButton: false,
      acceptConfirmOn: false
    }, options.initialState || {});

    _this.boundOnDocClick = _this.onDocumentClick.bind(_this);
    (0, _jquery2.default)(document).on('click', _this.boundOnDocClick);

    _this.listenTo(_order.events, 'acceptingPayout', function (e) {
      if (e.id === _this.orderId) {
        _this.setState({ acceptInProgress: true });
      }
    });

    _this.listenTo(_order.events, 'acceptPayoutComplete acceptPayoutFail', function (e) {
      if (e.id === _this.orderId) {
        _this.setState({ acceptInProgress: false });
      }
    });

    _this.listenTo(_order.events, 'acceptPayoutComplete', function (e) {
      if (e.id === _this.orderId) {
        _this.setState({ showAcceptButton: false });
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'disputePayoutEvent rowLg';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-acceptPayout': 'onClickAcceptPayout',
        'click .js-acceptPayoutConfirmBox': 'onClickAcceptPayoutConfirmedBox',
        'click .js-acceptPayoutConfirmed': 'onClickAcceptPayoutConfirmed',
        'click .js-acceptPayoutConfirmCancel': 'onClickAcceptPayoutConfirmCancel'
      };
    }
  }, {
    key: 'onDocumentClick',
    value: function onDocumentClick() {
      this.setState({ acceptConfirmOn: false });
    }
  }, {
    key: 'onClickAcceptPayout',
    value: function onClickAcceptPayout() {
      this.setState({ acceptConfirmOn: true });
      return false;
    }
  }, {
    key: 'onClickAcceptPayoutConfirmedBox',
    value: function onClickAcceptPayoutConfirmedBox() {
      // ensure event doesn't bubble so onDocumentClick doesn't
      // close the confirmBox.
      return false;
    }
  }, {
    key: 'onClickAcceptPayoutConfirmCancel',
    value: function onClickAcceptPayoutConfirmCancel() {
      this.setState({ acceptConfirmOn: false });
    }
  }, {
    key: 'onClickAcceptPayoutConfirmed',
    value: function onClickAcceptPayoutConfirmed() {
      this.setState({ acceptConfirmOn: false });
      (0, _order.acceptPayout)(this.orderId);
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var renderOnChange = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (renderOnChange && !_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'remove',
    value: function remove() {
      (0, _jquery2.default)(document).off('click', this.boundOnDocClick);
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/orderDetail/summaryTab/disputePayout.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2._state, {
          moment: _moment2.default,
          acceptInProgress: (0, _order.acceptingPayout)(_this2.orderId)
        })));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;