'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../../../app');

var _app2 = _interopRequireDefault(_app);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _countries = require('../../../../data/countries');

var _currency = require('../../../../utils/currency');

var _electron = require('electron');

require('../../../../utils/lib/velocity');

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _ModFragment = require('../ModFragment');

var _ModFragment2 = _interopRequireDefault(_ModFragment);

var _OrderDetail = require('../OrderDetail.js');

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!_this.model) {
      throw new Error('Please provide a Contract model.');
    }

    if (_this.isModerated()) {
      (0, _OrderDetail.checkValidParticipantObject)(options.moderator, 'moderator');

      options.moderator.getProfile().done(function (modProfile) {
        _this.modProfile = modProfile;
        if (_this.moderatorVw) _this.moderatorVw.setState(_extends({}, modProfile.toJSON()));
      });
    }

    _this.options = options;
    _this.listing = _this.model.get('vendorListings').at(0);
    _this.order = _this.model.get('buyerOrder');
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'orderDetails';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-copyAddress': 'onClickCopyAddress',
        'click .js-copyCryptoAddress': 'onClickCopyCryptoAddress'
      };
    }
  }, {
    key: 'onClickCopyAddress',
    value: function onClickCopyAddress(e) {
      var _this2 = this;

      _electron.clipboard.writeText((0, _jquery2.default)(e.target).data('address') || '');
      this.$copiedToClipboard.velocity('stop').velocity('fadeIn', {
        complete: function complete() {
          _this2.$copiedToClipboard.velocity('fadeOut', { delay: 1000 });
        }
      });
    }
  }, {
    key: 'onClickCopyCryptoAddress',
    value: function onClickCopyCryptoAddress(e) {
      var _this3 = this;

      _electron.clipboard.writeText((0, _jquery2.default)(e.target).data('address') || '');
      this.getCachedEl('.js-cryptoAddressCopiedToClipboard').velocity('stop').velocity('fadeIn', {
        complete: function complete() {
          _this3.getCachedEl('.js-cryptoAddressCopiedToClipboard').velocity('fadeOut', { delay: 1000 });
        }
      });
    }
  }, {
    key: 'isModerated',
    value: function isModerated() {
      return !!this.model.get('buyerOrder').payment.moderator;
    }

    /**
     * If the product purchased has a sku, it will be returned, otherwise an empty string
     * will be returned.
     */

  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('modals/orderDetail/summaryTab/orderDetails.html', function (t) {
        _this4.$el.html(t({
          listing: _this4.listing.toJSON(),
          order: _this4.order,
          getCountryByDataName: _countries.getCountryByDataName,
          convertAndFormatCurrency: _currency.convertAndFormatCurrency,
          userCurrency: _app2.default.settings.get('localCurrency'),
          moment: _moment2.default,
          isModerated: _this4.isModerated(),
          sku: _this4.sku,
          locale: _app2.default && _app2.default.localSettings && _app2.default.localSettings.standardizedTranslatedLang() || 'en-US'
        }));

        _this4._$copiedToClipboard = null;

        if (_this4.isModerated()) {
          var moderatorState = _extends({
            peerId: _this4.options.moderator.id
          }, _this4.modProfile && _this4.modProfile.toJSON() || {});

          if (_this4.moderatorVw) _this4.moderatorVw.remove();
          _this4.moderatorVw = _this4.createChild(_ModFragment2.default, {
            initialState: moderatorState
          });

          _this4.$('.js-moderatorContainer').html(_this4.moderatorVw.render().el);
        }
      });

      return this;
    }
  }, {
    key: 'sku',
    get: function get() {
      var orderOptions = void 0;
      var options = void 0;
      var skus = void 0;
      var listing = this.listing.toJSON();

      try {
        orderOptions = this.order.items[0].options;
        options = listing.item.options;
        skus = listing.item.skus;
      } catch (e) {
        return '';
      }

      if (orderOptions && orderOptions.length && orderOptions.length === options.length) {
        // variants are present
        var indexes = [];

        orderOptions.forEach(function (orderOpt) {
          var matchingOpt = options.find(function (opt) {
            return opt.name === orderOpt.name;
          });

          if (matchingOpt && matchingOpt.variants && matchingOpt.variants.length) {
            var matchingVariant = matchingOpt.variants.find(function (variant) {
              return variant.name === orderOpt.value;
            });
            if (matchingVariant) indexes.push(matchingOpt.variants.indexOf(matchingVariant));
          }
        });

        if (Array.isArray(skus)) {
          var matchingSku = skus.find(function (sku) {
            return _underscore2.default.isEqual(sku.variantCombo, indexes);
          });
          return matchingSku && matchingSku.productID || '';
        }
      } else {
        // no variants
        return listing.item.productID || '';
      }

      return '';
    }
  }, {
    key: '$copiedToClipboard',
    get: function get() {
      return this._$copiedToClipboard || (this._$copiedToClipboard = this.$('.js-orderDetailsCopiedToClipboard'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;