'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _order = require('../../../../utils/order');

var _cryptoCurrencies = require('../../../../data/cryptoCurrencies');

var _OrderDetail = require('../OrderDetail.js');

var _baseVw2 = require('../../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _Payment = require('./Payment');

var _Payment2 = _interopRequireDefault(_Payment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({}, options);

    if (!options.orderId) {
      throw new Error('Please provide the order id.');
    }

    if (!options.collection) {
      throw new Error('Please provide a transactions collection.');
    }

    if (typeof options.orderPrice !== 'number') {
      throw new Error('Please provide the price of the order.');
    }

    if (typeof options.isOrderCancelable !== 'function') {
      throw new Error('Please provide a function that returns whether this order can be canceled ' + 'by the current user.');
    }

    if (typeof options.isOrderConfirmable !== 'function') {
      throw new Error('Please provide a function that returns whether this order can be ' + 'confirmed by the current user.');
    }

    (0, _OrderDetail.checkValidParticipantObject)(options.vendor, 'vendor');

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.orderId = _this.options.orderId;
    _this.payments = [];

    _this.listenTo(_this.collection, 'update', function () {
      return _this.render();
    });
    _this.listenTo(_order.events, 'cancelingOrder', _this.onCancelingOrder);
    _this.listenTo(_order.events, 'cancelOrderComplete, cancelOrderFail', _this.onCancelOrderAlways);
    _this.listenTo(_order.events, 'cancelOrderComplete', _this.onAcceptOrderComplete);
    _this.listenTo(_order.events, 'acceptingOrder', _this.onAcceptingOrder);
    _this.listenTo(_order.events, 'acceptOrderComplete acceptOrderFail', _this.onAcceptOrderAlways);
    _this.listenTo(_order.events, 'acceptOrderComplete', _this.onAcceptOrderComplete);
    _this.listenTo(_order.events, 'rejectingOrder', _this.onRejectingOrder);
    _this.listenTo(_order.events, 'rejectOrderComplete rejectOrderFail', _this.onRejectOrderAlways);
    _this.listenTo(_order.events, 'rejectOrderComplete', _this.onRejectOrderComplete);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'payments';
    }
  }, {
    key: 'onCancelClick',
    value: function onCancelClick() {
      (0, _order.cancelOrder)(this.orderId);
    }
  }, {
    key: 'onCancelingOrder',
    value: function onCancelingOrder(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ cancelInProgress: true });
      }
    }
  }, {
    key: 'onCancelOrderAlways',
    value: function onCancelOrderAlways(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ cancelInProgress: false });
      }
    }
  }, {
    key: 'onCancelOrderComplete',
    value: function onCancelOrderComplete(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ showCancelButton: false });
      }
    }
  }, {
    key: 'onAcceptClick',
    value: function onAcceptClick() {
      (0, _order.acceptOrder)(this.orderId);
    }
  }, {
    key: 'onAcceptingOrder',
    value: function onAcceptingOrder(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ acceptInProgress: true });
      }
    }
  }, {
    key: 'onAcceptOrderAlways',
    value: function onAcceptOrderAlways(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ acceptInProgress: false });
      }
    }
  }, {
    key: 'onAcceptOrderComplete',
    value: function onAcceptOrderComplete(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ showAcceptButton: false });
      }
    }
  }, {
    key: 'onRejectClick',
    value: function onRejectClick() {
      (0, _order.rejectOrder)(this.orderId);
    }
  }, {
    key: 'onRejectingOrder',
    value: function onRejectingOrder(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ rejectInProgress: true });
      }
    }
  }, {
    key: 'onRejectOrderAlways',
    value: function onRejectOrderAlways(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ rejectInProgress: false });
      }
    }
  }, {
    key: 'onRejectOrderComplete',
    value: function onRejectOrderComplete(e) {
      if (e.id === this.orderId) {
        this.payments[this.payments.length - 1].setState({ showRejectButton: false });
      }
    }
  }, {
    key: 'createPayment',
    value: function createPayment(model) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!model) {
        throw new Error('Please provide a model.');
      }

      var payment = this.createChild(_Payment2.default, _extends({}, options, {
        model: model,
        initialState: _extends({}, options.initialState)
      }));

      this.listenTo(payment, 'cancelClick', this.onCancelClick);
      this.listenTo(payment, 'acceptClick', this.onAcceptClick);
      this.listenTo(payment, 'confirmedRejectClick', this.onRejectClick);
      this.payments.push(payment);

      return payment;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var paymentsContainer = document.createDocumentFragment();

      this.payments.forEach(function (payment) {
        return payment.remove();
      });
      this.payments = [];

      this.collection.models.forEach(function (payment, index) {
        var paidSoFar = _this2.collection.models.slice(0, index + 1).reduce(function (total, model) {
          return total + model.get('value');
        }, 0);
        // round based on the coins base units
        var cryptoBaseUnit = (0, _cryptoCurrencies.getServerCurrency)().baseUnit;
        paidSoFar = Math.round(paidSoFar * cryptoBaseUnit) / cryptoBaseUnit;
        var isMostRecentPayment = index === _this2.collection.length - 1;
        var paymentView = _this2.createPayment(payment, {
          initialState: {
            paymentNumber: index + 1,
            amountShort: _this2.options.orderPrice - paidSoFar,
            showAcceptRejectButtons: isMostRecentPayment && _this2.options.isOrderConfirmable(),
            showCancelButton: isMostRecentPayment && _this2.options.isOrderCancelable(),
            cancelInProgress: (0, _order.cancelingOrder)(_this2.orderId),
            acceptInProgress: (0, _order.acceptingOrder)(_this2.orderId),
            rejectInProgress: (0, _order.rejectingOrder)(_this2.orderId)
          }
        });

        (0, _jquery2.default)(paymentsContainer).prepend(paymentView.render().el);
      });

      if (this.payments.length) {
        this.options.vendor.getProfile().done(function (profile) {
          _this2.payments.forEach(function (payment) {
            return payment.setState({ payee: profile.get('name') || '' });
          });
        });
      }

      this.$el.empty().append(paymentsContainer);

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;