'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../../app');

var _app2 = _interopRequireDefault(_app);

var _electron = require('electron');

require('../../../../utils/lib/velocity');

var _loadTemplate = require('../../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _cryptoCurrencies = require('../../../../data/cryptoCurrencies');

var _order = require('../../../../utils/order');

var _Transactions = require('../../../../collections/Transactions');

var _Transactions2 = _interopRequireDefault(_Transactions);

var _OrderCompletion = require('../../../../models/order/orderCompletion/OrderCompletion');

var _OrderCompletion2 = _interopRequireDefault(_OrderCompletion);

var _OrderDetail = require('../OrderDetail.js');

var _baseVw = require('../../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _StateProgressBar = require('./StateProgressBar');

var _StateProgressBar2 = _interopRequireDefault(_StateProgressBar);

var _Payments = require('./Payments');

var _Payments2 = _interopRequireDefault(_Payments);

var _Accepted = require('./Accepted');

var _Accepted2 = _interopRequireDefault(_Accepted);

var _Fulfilled = require('./Fulfilled');

var _Fulfilled2 = _interopRequireDefault(_Fulfilled);

var _Refunded = require('./Refunded');

var _Refunded2 = _interopRequireDefault(_Refunded);

var _OrderDetails = require('./OrderDetails');

var _OrderDetails2 = _interopRequireDefault(_OrderDetails);

var _CompleteOrderForm = require('./CompleteOrderForm');

var _CompleteOrderForm2 = _interopRequireDefault(_CompleteOrderForm);

var _OrderComplete = require('./OrderComplete');

var _OrderComplete2 = _interopRequireDefault(_OrderComplete);

var _DisputeStarted = require('./DisputeStarted');

var _DisputeStarted2 = _interopRequireDefault(_DisputeStarted);

var _DisputePayout = require('./DisputePayout');

var _DisputePayout2 = _interopRequireDefault(_DisputePayout);

var _DisputeAcceptance = require('./DisputeAcceptance');

var _DisputeAcceptance2 = _interopRequireDefault(_DisputeAcceptance);

var _Payment = require('../../../modals/purchase/Payment');

var _Payment2 = _interopRequireDefault(_Payment);

var _ProcessingError = require('./ProcessingError');

var _ProcessingError2 = _interopRequireDefault(_ProcessingError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!_this.model) {
      throw new Error('Please provide a model.');
    }

    var contract = void 0;

    if (!_this.isCase()) {
      contract = _this.model.get('contract');
    } else {
      contract = _this.model.get('buyerOpened') ? _this.model.get('buyerContract') : _this.model.get('vendorContract');
    }

    _this.contract = contract;
    _this._totalPaid = null;

    (0, _OrderDetail.checkValidParticipantObject)(options.buyer, 'buyer');
    (0, _OrderDetail.checkValidParticipantObject)(options.vendor, 'vendor');

    if (_this.contract.get('buyerOrder').payment.moderator) {
      (0, _OrderDetail.checkValidParticipantObject)(options.moderator, 'moderator');
    }

    _this.options = options || {};
    _this.vendor = options.vendor;
    _this.buyer = options.buyer;
    _this.moderator = options.moderator;

    _this.listenTo(_this.model, 'change:state', function (md, state) {
      _this.stateProgressBar.setState(_this.progressBarState);
      if (_this.payments) _this.payments.render();
      if (_this.shouldShowAcceptedSection()) {
        if (!_this.accepted) _this.renderAcceptedView();
      } else {
        if (_this.accepted) _this.accepted.remove();
      }

      if (['REFUNDED', 'FULFILLED', 'DISPUTED', 'DECIDED', 'RESOLVED', 'COMPLETED'].indexOf(state) > -1 && _this.accepted) {
        var acceptedState = {
          showFulfillButton: false,
          infoText: _app2.default.polyglot.t('orderDetail.summaryTab.accepted.vendorReceived'),
          showRefundButton: false
        };

        _this.accepted.setState(acceptedState);
      }

      if (_this.completeOrderForm && ['FULFILLED', 'RESOLVED'].indexOf(state) === -1) {
        _this.completeOrderForm.remove();
        _this.completeOrderForm = null;
      }

      if (['PAYMENT_FINALIZED', 'COMPLETED'].indexOf(state) !== -1) {
        _this.renderPaymentFinalized();
      }

      if (state === 'PROCESSING_ERROR') {
        if (_this.payForOrder && !_this.shouldShowPayForOrderSection()) {
          _this.payForOrder.remove();
          _this.payForOrder = null;
        }
      }

      _this.renderProcessingError();
    });

    if (!_this.isCase()) {
      _this.listenTo(_this.model.get('paymentAddressTransactions'), 'update', function () {
        _this._totalPaid = null;

        if (_this.payForOrder && !_this.shouldShowPayForOrderSection()) {
          _this.payForOrder.remove();
          _this.payForOrder = null;
        }

        if (_this.payments) {
          _this.payments.collection.set(_this.paymentsCollection.models);
        }
      });

      _this.listenTo(_this.model, 'change:refundAddressTransaction', function () {
        return _this.renderRefundView();
      });
    }

    _this.listenTo(_order.events, 'cancelOrderComplete', function () {
      _this.model.set('state', 'CANCELED');
      // we'll refetch so our transaction list is updated with
      // the money returned to the buyer
      _this.model.fetch();
    });

    _this.listenTo(_order.events, 'acceptOrderComplete', function () {
      // todo: factor in AWAITING_PICKUP
      _this.model.set('state', 'AWAITING_FULFILLMENT');

      // we'll refetch so we get our vendorOrderConfirmation object
      _this.model.fetch();
    });

    _this.listenTo(_order.events, 'rejectOrderComplete', function () {
      _this.model.set('state', 'DECLINED');

      // We'll refetch so our transaction list is updated with
      // the money returned to the buyer (if they're online). If they're
      // not online the refund shows up when the buyer comes back online.
      _this.model.fetch();
    });

    _this.listenTo(_this.contract, 'change:vendorOrderConfirmation', function () {
      return _this.renderAcceptedView();
    });

    _this.listenTo(_order.events, 'fulfillOrderComplete', function (e) {
      if (e.id === _this.model.id) {
        _this.model.set('state', 'FULFILLED');
        _this.model.fetch();
      }
    });

    _this.listenTo(_order.events, 'refundOrderComplete', function (e) {
      if (e.id === _this.model.id) {
        _this.model.set('state', 'REFUNDED');
        _this.model.fetch();
      }
    });

    _this.listenTo(_this.contract, 'change:vendorOrderFulfillment', function () {
      // For some reason the order state still reflects the order state at the
      // time this event handler is called even though it is triggered by fetch
      // which brings the updated order state in its payload. Weird... maybe
      // backbone doesn't update the model until the field specific change handlers
      // are called...? Anyways... the timeout below fixeds the issue.
      setTimeout(function () {
        _this.renderFulfilledView();
      });
    });

    _this.listenTo(_this.contract, 'change:buyerOrderCompletion', function () {
      return _this.renderOrderCompleteView();
    });

    _this.listenTo(_order.events, 'completeOrderComplete', function (e) {
      if (e.id === _this.model.id && _this.accepted) {
        _this.model.set('state', 'COMPLETED');
        _this.model.fetch();
      }
    });

    _this.listenTo(_order.events, 'openDisputeComplete', function (e) {
      if (e.id === _this.model.id) {
        _this.model.set('state', 'DISPUTED');
        _this.model.fetch();
      }
    });

    if (!_this.isCase()) {
      _this.listenTo(_this.contract, 'change:dispute', function () {
        return _this.renderDisputeStartedView();
      });

      _this.listenTo(_this.contract, 'change:disputeResolution', function () {
        // Only render the dispute payout the first time we receive it
        // (it changes from undefined to an object with data). It shouldn't
        // be changing after that, but for some reason it is.
        if (!_this.contract.previous('disputeResolution')) {
          // The timeout is needed in the handler so the updated
          // order state is available.
          setTimeout(function () {
            return _this.renderDisputePayoutView();
          });
        }
      });

      _this.listenTo(_order.events, 'acceptPayoutComplete', function (e) {
        if (e.id === _this.model.id) {
          _this.model.set('state', 'RESOLVED');
          _this.model.fetch();
        }
      });

      _this.listenTo(_this.contract, 'change:disputeAcceptance', function () {
        _this.renderDisputeAcceptanceView();

        if (_this.disputePayout) {
          _this.disputePayout.setState({ showAcceptButton: false });
        }
      });
    } else {
      _this.listenTo(_order.events, 'resolveDisputeComplete', function (e) {
        if (e.id === _this.model.id) {
          _this.model.set('state', 'RESOLVED');
          _this.model.fetch();
        }
      });

      _this.listenTo(_this.model, 'change:resolution', function () {
        return _this.renderDisputePayoutView();
      });
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'summaryTab';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-copyOrderId': 'onClickCopyOrderId'
      };
    }
  }, {
    key: 'onClickCopyOrderId',
    value: function onClickCopyOrderId() {
      var _this2 = this;

      _electron.clipboard.writeText(this.model.id);
      this.copiedToClipboardAnimatingIn = true;
      this.$copiedToClipboard.velocity('stop').velocity('fadeIn', {
        complete: function complete() {
          _this2.$copiedToClipboard.velocity('fadeOut', { delay: 1000 });
        }
      });
    }
  }, {
    key: 'isCase',
    value: function isCase() {
      return typeof this.model.get('buyerOpened') !== 'undefined';
    }
  }, {
    key: 'getBalanceRemaining',
    value: function getBalanceRemaining() {
      if (this.isCase()) {
        throw new Error('Cases do not have any transaction data.');
      }

      var balanceRemaining = this.orderPriceBtc - this.totalPaid;

      // round based on the coins base units
      var cryptoBaseUnit = (0, _cryptoCurrencies.getServerCurrency)().baseUnit;
      return Math.round(balanceRemaining * cryptoBaseUnit) / cryptoBaseUnit;
    }
  }, {
    key: 'shouldShowPayForOrderSection',
    value: function shouldShowPayForOrderSection() {
      return this.buyer.id === _app2.default.profile.id && this.getBalanceRemaining() > 0 && !this.model.vendorProcessingError;
    }
  }, {
    key: 'shouldShowAcceptedSection',
    value: function shouldShowAcceptedSection() {
      var bool = false;

      // Show the accepted section if the order has been accepted and its fully funded.
      if (this.contract.get('vendorOrderConfirmation') && (this.isCase() || this.getBalanceRemaining() <= 0)) {
        bool = true;
      }

      return bool;
    }
  }, {
    key: 'renderAcceptedView',
    value: function renderAcceptedView() {
      var _this3 = this;

      var vendorOrderConfirmation = this.contract.get('vendorOrderConfirmation');

      if (!vendorOrderConfirmation) {
        throw new Error('Unable to create the accepted view because the vendorOrderConfirmation ' + 'data object has not been set.');
      }

      var orderState = this.model.get('state');
      var isVendor = this.vendor.id === _app2.default.profile.id;
      var canFulfill = isVendor && ['AWAITING_FULFILLMENT', 'PARTIALLY_FULFILLED'].indexOf(orderState) > -1;
      var initialState = {
        timestamp: vendorOrderConfirmation.timestamp,
        showRefundButton: isVendor && ['AWAITING_FULFILLMENT', 'PARTIALLY_FULFILLED'].indexOf(orderState) > -1,
        showFulfillButton: canFulfill
      };

      if (!this.isCase()) {
        if (isVendor) {
          // vendor looking at the order
          if (canFulfill) {
            initialState.infoText = _app2.default.polyglot.t('orderDetail.summaryTab.accepted.vendorCanFulfill');
          } else {
            initialState.infoText = _app2.default.polyglot.t('orderDetail.summaryTab.accepted.vendorReceived');
          }
        } else {
          // buyer looking at the order
          initialState.infoText = _app2.default.polyglot.t('orderDetail.summaryTab.accepted.buyerOrderAccepted');
        }
      } else {
        // mod looking at the order
        initialState.infoText = _app2.default.polyglot.t('orderDetail.summaryTab.accepted.modOrderAccepted');
      }

      if (this.accepted) this.accepted.remove();
      this.accepted = this.createChild(_Accepted2.default, {
        orderId: this.model.id,
        initialState: initialState
      });
      this.listenTo(this.accepted, 'clickFulfillOrder', function () {
        return _this3.trigger('clickFulfillOrder');
      });

      this.vendor.getProfile().done(function (profile) {
        _this3.accepted.setState({
          avatarHashes: profile.get('avatarHashes').toJSON()
        });
      });

      this.$subSections.prepend(this.accepted.render().el);
    }
  }, {
    key: 'renderRefundView',
    value: function renderRefundView() {
      var _this4 = this;

      var refundMd = this.model.get('refundAddressTransaction');

      if (!refundMd) {
        throw new Error('Unable to create the refunded view because the refundAddressTransaction ' + 'data object has not been set.');
      }

      if (this.refunded) this.refunded.remove();
      this.refunded = this.createChild(_Refunded2.default, { model: refundMd });
      this.buyer.getProfile().done(function (profile) {
        return _this4.refunded.setState({ buyerName: profile.get('name') });
      });
      this.$subSections.prepend(this.refunded.render().el);
    }
  }, {
    key: 'renderCompleteOrderForm',
    value: function renderCompleteOrderForm() {
      var completingObject = (0, _order.completingOrder)(this.model.id);
      var model = new _OrderCompletion2.default(completingObject ? completingObject.data : { orderId: this.model.id });
      if (this.completeOrderForm) this.completeOrderForm.remove();
      this.completeOrderForm = this.createChild(_CompleteOrderForm2.default, {
        model: model,
        slug: this.contract.get('vendorListings').at(0).get('slug')
      });

      this.$subSections.prepend(this.completeOrderForm.render().el);
    }
  }, {
    key: 'renderFulfilledView',
    value: function renderFulfilledView() {
      var _this5 = this;

      var data = this.contract.get('vendorOrderFulfillment');

      if (!data) {
        throw new Error('Unable to create the fulfilled view because the vendorOrderFulfillment ' + 'data object has not been set.');
      }

      var fulfilledState = {
        contractType: this.contract.type,
        showPassword: this.moderator && this.moderator.id !== _app2.default.profile.id || true,
        isLocalPickup: this.contract.isLocalPickup
      };

      if (this.contract.type === 'CRYPTOCURRENCY') {
        fulfilledState.coinType = this.contract.get('vendorListings').at(0).get('metadata').get('coinType');
      }

      if (this.fulfilled) this.fulfilled.remove();
      this.fulfilled = this.createChild(_Fulfilled2.default, {
        dataObject: data[0],
        initialState: fulfilledState
      });

      if (_app2.default.profile.id === this.vendor.id) {
        this.fulfilled.setState({ noteFromLabel: _app2.default.polyglot.t('orderDetail.summaryTab.fulfilled.yourNoteLabel') });
      } else {
        this.vendor.getProfile().done(function (profile) {
          _this5.fulfilled.setState({
            noteFromLabel: _app2.default.polyglot.t('orderDetail.summaryTab.fulfilled.noteFromStoreLabel', { store: profile.get('name') })
          });
        });
      }

      this.$subSections.prepend(this.fulfilled.render().el);

      if (this.model.get('state') === 'FULFILLED' && this.buyer.id === _app2.default.profile.id) {
        this.renderCompleteOrderForm();
      }
    }
  }, {
    key: 'renderOrderCompleteView',
    value: function renderOrderCompleteView() {
      var _this6 = this;

      var data = this.contract.get('buyerOrderCompletion');

      if (!data) {
        throw new Error('Unable to create the Order Complete view because the buyerOrderCompletion ' + 'data object has not been set.');
      }

      if (this.orderComplete) this.orderComplete.remove();
      this.orderComplete = this.createChild(_OrderComplete2.default, {
        dataObject: data
      });

      this.buyer.getProfile().done(function (profile) {
        return _this6.orderComplete.setState({ buyerName: profile.get('name') });
      });
      this.$subSections.prepend(this.orderComplete.render().el);
    }
  }, {
    key: 'renderDisputeStartedView',
    value: function renderDisputeStartedView() {
      var _this7 = this;

      var data = this.isCase() ? {
        timestamp: this.model.get('timestamp'),
        claim: this.model.get('claim')
      } : this.contract.get('dispute');

      if (!data) {
        throw new Error('Unable to create the Dispute Started view because the dispute ' + 'data object has not been set.');
      }

      if (this.disputeStarted) this.disputeStarted.remove();
      this.disputeStarted = this.createChild(_DisputeStarted2.default, {
        initialState: _extends({}, data, {
          showResolveButton: this.model.get('state') === 'DISPUTED' && this.moderator.id === _app2.default.profile.id
        })
      });

      // this is only set on the Case.
      var buyerOpened = this.model.get('buyerOpened');
      if (typeof buyerOpened !== 'undefined') {
        var disputeOpener = buyerOpened ? this.buyer : this.vendor;
        disputeOpener.getProfile().done(function (profile) {
          return _this7.disputeStarted.setState({ disputerName: profile.get('name') });
        });
      }

      this.listenTo(this.disputeStarted, 'clickResolveDispute', function () {
        return _this7.trigger('clickResolveDispute');
      });

      this.$subSections.prepend(this.disputeStarted.render().el);
    }
  }, {
    key: 'renderDisputePayoutView',
    value: function renderDisputePayoutView() {
      var _this8 = this;

      var data = this.isCase() ? this.model.get('resolution') : this.contract.get('disputeResolution');

      if (!data) {
        throw new Error('Unable to create the Dispute Payout view because the resolution ' + 'data object has not been set.');
      }

      if (this.disputePayout) this.disputePayout.remove();
      this.disputePayout = this.createChild(_DisputePayout2.default, {
        orderId: this.model.id,
        initialState: _extends({}, data, {
          showAcceptButton: !this.isCase() && this.model.get('state') === 'DECIDED'
        })
      });

      ['buyer', 'vendor', 'moderator'].forEach(function (type) {
        _this8[type].getProfile().done(function (profile) {
          var state = {};
          state[type + 'Name'] = profile.get('name');
          state[type + 'AvatarHashes'] = profile.get('avatarHashes').toJSON();
          _this8.disputePayout.setState(state);
        });
      });

      this.listenTo(this.disputeStarted, 'clickResolveDispute', function () {
        return _this8.trigger('clickResolveDispute');
      });

      this.$subSections.prepend(this.disputePayout.render().el);
    }
  }, {
    key: 'renderPayForOrder',
    value: function renderPayForOrder() {
      if (this.payForOrder) this.payForOrder.remove();

      this.payForOrder = this.createChild(_Payment2.default, {
        balanceRemaining: this.getBalanceRemaining(),
        paymentAddress: this.paymentAddress,
        orderId: this.model.id,
        isModerated: !!this.moderator
      });

      this.getCachedEl('.js-payForOrderWrap').html(this.payForOrder.render().el);
    }
  }, {
    key: 'renderDisputeAcceptanceView',
    value: function renderDisputeAcceptanceView() {
      var _this9 = this;

      var data = this.contract.get('disputeAcceptance');

      if (!data) {
        throw new Error('Unable to create the Dispute Acceptance view because the ' + 'disputeAcceptance data object has not been set.');
      }

      var closer = data.closedBy === this.buyer.id ? this.buyer : this.vendor;

      if (this.disputeAcceptance) this.disputeAcceptance.remove();
      this.disputeAcceptance = this.createChild(_DisputeAcceptance2.default, {
        initialState: {
          timestamp: data.timestamp,
          acceptedByBuyer: closer.id === this.buyer.id,
          buyerViewing: _app2.default.profile.id === this.buyer.id,
          vendorProcessingError: this.model.vendorProcessingError
        }
      });

      closer.getProfile().done(function (profile) {
        return _this9.disputeAcceptance.setState({
          closerName: profile.get('name'),
          closerAvatarHashes: profile.get('avatarHashes').toJSON()
        });
      });

      this.$subSections.prepend(this.disputeAcceptance.render().el);

      if (this.model.get('state') === 'RESOLVED' && this.buyer.id === _app2.default.profile.id && !this.model.vendorProcessingError) {
        this.renderCompleteOrderForm();
      }
    }

    /**
     * Will render sub-sections in order based on their timestamp. Exempt from
     * this are the Order Details, Payment Details and Accepted sections which
     * are always first and in a specific order.
     */

  }, {
    key: 'renderSubSections',
    value: function renderSubSections() {
      var _this10 = this;

      var sections = [];

      if (this.model.get('refundAddressTransaction')) {
        sections.push({
          function: this.renderRefundView,
          timestamp: new Date(this.model.get('refundAddressTransaction').timestamp)
        });
      }

      if (this.contract.get('vendorOrderFulfillment')) {
        sections.push({
          function: this.renderFulfilledView,
          timestamp: new Date(this.contract.get('vendorOrderFulfillment')[0].timestamp)
        });
      }

      if (this.contract.get('buyerOrderCompletion')) {
        sections.push({
          function: this.renderOrderCompleteView,
          timestamp: new Date(this.contract.get('buyerOrderCompletion').timestamp)
        });
      }

      if (this.contract.get('dispute') || this.isCase()) {
        var timestamp = this.isCase() ? this.model.get('timestamp') : this.contract.get('dispute').timestamp;

        sections.push({
          function: this.renderDisputeStartedView,
          timestamp: new Date(timestamp)
        });
      }

      if (this.contract.get('disputeResolution') || this.isCase() && this.model.get('resolution')) {
        var _timestamp = this.isCase() ? this.model.get('resolution').timestamp : this.contract.get('disputeResolution').timestamp;

        sections.push({
          function: this.renderDisputePayoutView,
          timestamp: new Date(_timestamp)
        });
      }

      if (this.contract.get('disputeAcceptance')) {
        sections.push({
          function: this.renderDisputeAcceptanceView,
          timestamp: new Date(this.contract.get('disputeAcceptance').timestamp)
        });
      }

      sections.sort(function (a, b) {
        return a.timestamp - b.timestamp;
      }).forEach(function (section) {
        if (typeof section.function === 'function') {
          section.function.call(_this10);
        } else {
          throw new Error('Unable to add sub section. It doesn\'t have a creation function.');
        }
      });
    }
  }, {
    key: 'renderPaymentFinalized',
    value: function renderPaymentFinalized() {
      this.getCachedEl('.js-paymentFinalizedMsg').toggleClass('hide', this.model.get('state') !== 'PAYMENT_FINALIZED');
    }
  }, {
    key: 'renderProcessingError',
    value: function renderProcessingError() {
      if (!this.model.vendorProcessingError) {
        if (this.processingError) {
          this.processingError.remove();
          this.processingError = null;
        }

        return;
      }

      var isBuyer = this.buyer.id === _app2.default.profile.id;
      var state = {
        isBuyer: isBuyer,
        isModerator: !!(this.moderator && this.moderator.id),
        isOrderCancelable: this.isOrderCancelable,
        isModerated: !!this.moderator,
        isCase: this.isCase,
        // TODO todo ToDo !!! TODO todo ToDo !!! TODO todo ToDo !!!
        // TODO todo ToDo !!! TODO todo ToDo !!! TODO todo ToDo !!!
        // TODO todo ToDo !!! TODO todo ToDo !!! TODO todo ToDo !!!
        // TODO: factor in escrow timeout
        isDisputable: isBuyer && this.moderator && this.model.get('state') === 'PROCESSING_ERROR' && this.isFunded,
        errors: this.contract.get('errors') || []
      };

      if (!this.processingError) {
        this.processingError = this.createChild(_ProcessingError2.default, {
          orderId: this.model.id,
          initialState: state
        });
        this.getCachedEl('.js-processingErrorContainer').html(this.processingError.render().el);
      } else {
        this.processingError.setState(state);
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this11 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('modals/orderDetail/summaryTab/summary.html', function (t) {
        _this11.$el.html(t(_extends({
          id: _this11.model.id,
          isCase: _this11.isCase(),
          isTestnet: _app2.default.serverConfig.testnet,
          paymentAddress: _this11.paymentAddress
        }, _this11.model.toJSON())));
        _this11._$copiedToClipboard = null;

        if (_this11.stateProgressBar) _this11.stateProgressBar.remove();
        _this11.stateProgressBar = _this11.createChild(_StateProgressBar2.default, {
          initialState: _this11.progressBarState
        });
        _this11.$('.js-statusProgressBarContainer').html(_this11.stateProgressBar.render().el);

        _this11.renderPaymentFinalized();

        if (_this11.orderDetails) _this11.orderDetails.remove();
        _this11.orderDetails = _this11.createChild(_OrderDetails2.default, {
          model: _this11.contract,
          moderator: _this11.moderator
        });
        _this11.$('.js-orderDetailsWrap').html(_this11.orderDetails.render().el);

        if (_this11.shouldShowPayForOrderSection()) {
          _this11.renderPayForOrder();
        }

        if (!_this11.isCase()) {
          if (_this11.payments) _this11.payments.remove();
          _this11.payments = _this11.createChild(_Payments2.default, {
            orderId: _this11.model.id,
            collection: _this11.paymentsCollection,
            orderPrice: _this11.orderPriceBtc,
            vendor: _this11.vendor,
            isOrderCancelable: function isOrderCancelable() {
              return _this11.isOrderCancelable;
            },
            isOrderConfirmable: function isOrderConfirmable() {
              return _this11.model.get('state') === 'PENDING' && _this11.vendor.id === _app2.default.profile.id && !_this11.contract.get('vendorOrderConfirmation');
            }
          });
          _this11.$('.js-paymentsWrap').html(_this11.payments.render().el);
        }

        if (_this11.shouldShowAcceptedSection()) _this11.renderAcceptedView();
        _this11.renderSubSections();
        _this11.renderProcessingError();
      });

      return this;
    }
  }, {
    key: '$copiedToClipboard',
    get: function get() {
      return this._$copiedToClipboard || (this._$copiedToClipboard = this.$('.js-copiedToClipboard'));
    }
  }, {
    key: 'progressBarState',
    get: function get() {
      var orderState = this.model.get('state');
      var state = {
        states: [_app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.paid'), _app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.accepted'), _app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.fulfilled'), _app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.complete')]
      };

      if (orderState === 'DISPUTED' || orderState === 'DECIDED' || orderState === 'RESOLVED' || orderState === 'COMPLETED' && this.contract.get('dispute') !== undefined || orderState === 'PAYMENT_FINALIZED' && this.contract.get('dispute') !== undefined) {
        if (!this.isCase()) {
          state.states = [_app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.disputed'), _app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.decided'), _app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.resolved')];

          if (!this.model.vendorProcessingError) {
            // You can't complete an order and leave a review when the vendor had a processing error.
            // In that case the flow ends at resolved.
            state.states.push(_app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.complete'));
          }

          switch (orderState) {
            case 'DECIDED':
              state.currentState = 2;
              state.disputeState = 0;
              break;
            case 'RESOLVED':
              state.currentState = 3;
              state.disputeState = 0;
              break;
            case 'COMPLETED':
              state.currentState = 4;
              state.disputeState = 0;
              break;
            case 'PAYMENT_FINALIZED':
              state.currentState = 1;
              state.disputeState = 0;
              break;
            default:
              state.currentState = 1;
              state.disputeState = 1;
          }
        } else {
          state.states = [_app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.disputed'), _app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.complete')];

          switch (orderState) {
            case 'RESOLVED':
              state.currentState = 2;
              break;
            default:
              state.currentState = 1;
          }
        }
      } else if (orderState === 'DECLINED' || orderState === 'CANCELED' || orderState === 'REFUNDED') {
        state.states = [_app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.paid'), _app2.default.polyglot.t('orderDetail.summaryTab.orderDetails.progressBarStates.' + orderState.toLowerCase())];
        state.currentState = 2;
        state.disputeState = 0;
      } else {
        switch (orderState) {
          case 'PENDING':
            state.currentState = 1;
            break;
          case 'PARTIALLY_FULFILLED':
          case 'AWAITING_FULFILLMENT':
            state.currentState = 2;
            break;
          case 'FULFILLED':
          case 'AWAITING_PICKUP':
            state.currentState = 3;
            break;
          case 'COMPLETED':
            state.currentState = 4;
            break;
          case 'PAYMENT_FINALIZED':
            state.currentState = 1;
            break;
          default:
            state.currentState = 0;
        }
      }

      return state;
    }
  }, {
    key: 'orderPriceBtc',
    get: function get() {
      return this.contract.get('buyerOrder').payment.amount;
    }
  }, {
    key: 'totalPaid',
    get: function get() {
      if (this._totalPaid === null) {
        this._totalPaid = this.paymentsCollection.reduce(function (total, transaction) {
          return total + transaction.get('value');
        }, 0);
      }

      return this._totalPaid;
    }
  }, {
    key: 'isPartiallyFunded',
    get: function get() {
      var balanceRemaining = this.getBalanceRemaining();
      return balanceRemaining > 0 && balanceRemaining < this.orderPriceBtc;
    }

    /**
     * Returns a boolean indicating whether the order has been partially or fully
     * funded.
     */

  }, {
    key: 'isFunded',
    get: function get() {
      return this.isPartiallyFunded || this.getBalanceRemaining() === 0;
    }
  }, {
    key: 'paymentAddress',
    get: function get() {
      var vendorOrderConfirmation = this.contract.get('vendorOrderConfirmation');

      return vendorOrderConfirmation && vendorOrderConfirmation.paymentAddress || this.contract.get('buyerOrder').payment.address;
    }

    /**
     * Returns a modified version of the transactions from the Order model by filtering out
     * any negative payments (money moving from the multisig to the vendor).
     */

  }, {
    key: 'paymentsCollection',
    get: function get() {
      if (this.isCase()) {
        throw new Error('Transaction data is not available for cases.');
      }

      return new _Transactions2.default(this.model.get('paymentAddressTransactions').filter(function (payment) {
        return payment.get('value') > 0;
      }));
    }
  }, {
    key: 'isOrderCancelable',
    get: function get() {
      return this.buyer.id === _app2.default.profile.id && !this.moderator && ['PROCESSING_ERROR', 'PENDING'].includes(this.model.get('state')) && this.isFunded;
    }
  }, {
    key: '$subSections',
    get: function get() {
      return this._$subSections || (this._$subSections = this.$('.js-subSections'));
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;