'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _ChatMessage = require('../../../models/chat/ChatMessage');

var _ChatMessage2 = _interopRequireDefault(_ChatMessage);

var _Listing = require('../../../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.listing || !(options.listing instanceof _Listing2.default)) {
      throw new Error('Please provide a listing model');
    }

    if (!options.vendor) {
      throw new Error('Please provide a vendor object');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    _this.processingTime = _this.options.listing.get('item').processingTime || _app2.default.polyglot.t('purchase.completeSection.noData');
    _this.vendorPeerID = _this.options.listing.get('vendorID').peerID;
    _this._orderID = '';
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'complete';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-goToListing': 'close',
        'keydown #messageInput': 'keyDownMessageInput',
        'click .js-send': 'sendMessageInput'
      };
    }
  }, {
    key: 'sendMessage',
    value: function sendMessage(msg) {
      if (!msg) {
        throw new Error('Please provide a message to send.');
      }

      var chatMessage = new _ChatMessage2.default({
        peerId: this.vendorPeerID,
        subject: this.orderID,
        message: msg
      });

      var save = chatMessage.save();
      var messageSent = true;

      if (save) {
        this.getCachedEl('.js-send').addClass('disabled');
        this.getCachedEl('.js-messageSent').removeClass('hide');
      } else {
        // Developer error - this shouldn't happen.
        console.error('There was an error saving the chat message.');
        console.dir(chatMessage.validationError);
        messageSent = false;
      }

      return messageSent;
    }
  }, {
    key: 'sendMessageInput',
    value: function sendMessageInput() {
      var $messageInput = this.getCachedEl('#messageInput');
      var message = $messageInput.val().trim();
      if (message) this.sendMessage(message);
      $messageInput.val('');
    }
  }, {
    key: 'keyDownMessageInput',
    value: function keyDownMessageInput(e) {
      this.getCachedEl('.js-send').toggleClass('disabled', !e.target.value);
      this.getCachedEl('.js-messageSent').addClass('hide');

      // if the key pressed is not enter, do nothing
      if (e.shiftKey || e.which !== 13) return;
      e.preventDefault();
      this.sendMessageInput();
      e.preventDefault();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('modals/purchase/complete.html', function (t) {
        _this2.$el.html(t({
          displayCurrency: _app2.default.settings.get('localCurrency'),
          processingTime: _this2.processingTime,
          maxMessageLength: _ChatMessage2.default.max.messageLength,
          ownProfile: _app2.default.profile.toJSON(),
          orderID: _this2.orderID,
          vendorName: _this2.options.vendor.name
        }));
      });

      return this;
    }
  }, {
    key: 'orderID',
    get: function get() {
      return this._orderID;
    },
    set: function set(orderID) {
      if (orderID !== this._orderID) this._orderID = orderID;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;