'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _multihashes = require('multihashes');

var _multihashes2 = _interopRequireDefault(_multihashes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    if (typeof options.listingPrice !== 'number') {
      throw new Error('Please provide a numerical price for the listing.');
    }

    _this.couponCodes = [];
    _this.couponHashes = [];
    _this.listingPrice = options.listingPrice;
    _this.totalDiscount = 0;
    _this.coupons = options.coupons;
    _this.codeResult = {};
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'coupons';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-remove': 'clickRemove'
      };
    }
  }, {
    key: 'sha256',
    value: function sha256(str) {
      var _this2 = this;

      // adapted from https://developer.mozilla.org/en-US/docs/Web/API/SubtleCrypto/digest
      var buffer = new TextEncoder('utf-8').encode(str);
      return crypto.subtle.digest('SHA-256', buffer).then(function (hash) {
        return _this2.hex(hash);
      });
    }
  }, {
    key: 'hex',
    value: function hex(buffer) {
      // adapted from https://developer.mozilla.org/en-US/docs/Web/API/SubtleCrypto/digest
      var hexCodes = [];
      var view = new DataView(buffer);
      for (var i = 0; i < view.byteLength; i += 4) {
        var value = view.getUint32(i);
        var stringValue = value.toString(16);
        var padding = '00000000';
        var paddedValue = (padding + stringValue).slice(-padding.length);
        hexCodes.push(paddedValue);
      }

      return hexCodes.join('');
    }
  }, {
    key: 'addCode',
    value: function addCode(code) {
      var _this3 = this;

      return this.sha256(code).then(function (hash) {
        var buf = new Buffer(hash, 'hex');
        var encoded = _multihashes2.default.encode(buf, 'sha2-256');
        var hashedCode = _multihashes2.default.toB58String(encoded);
        var coupon = _this3.findCoupon(hashedCode, code);
        var discount = _this3.couponDiscount(coupon);
        _this3.codeResult = { type: 'valid', code: code };

        if (coupon) {
          // don't add duplicate coupons
          if (_this3.couponCodes.indexOf(code) !== -1) {
            _this3.codeResult = { type: 'duplicate', code: code };
            // don't add if the total discount is more than the price of the listing
          } else if (_this3.totalDiscount + discount < _this3.listingPrice) {
            _this3.totalDiscount += discount;
            _this3.couponCodes.push(code);
            _this3.couponHashes.push(hashedCode);
            _this3.trigger('changeCoupons', _this3.couponHashes, _this3.couponCodes);
          } else {
            _this3.codeResult = { type: 'excessive', code: code };
          }
        } else {
          _this3.codeResult = { type: 'invalid', code: code };
        }
        _this3.render();
        return _this3.codeResult;
      });
    }
  }, {
    key: 'findCoupon',
    value: function findCoupon(hashedCode, code) {
      return this.coupons.findWhere({ hash: hashedCode }) || this.coupons.findWhere({ discountCode: code });
    }
  }, {
    key: 'couponDiscount',
    value: function couponDiscount(coupon) {
      var percDis = coupon && coupon.get('percentDiscount') || 0;
      var pricDis = coupon && coupon.get('priceDiscount') || 0;
      return this.listingPrice * percDis * 0.01 + pricDis;
    }
  }, {
    key: 'removeCode',
    value: function removeCode(code) {
      var index = this.couponCodes.indexOf(code);
      this.couponCodes.splice(index, 1);
      this.couponHashes.splice(index, 1);
      this.totalDiscount -= this.couponDiscount(this.findCoupon('', code));
      this.trigger('changeCoupons', this.couponHashes, this.couponCodes);
      this.codeResult = { type: 'valid', code: code };
      this.render();
    }
  }, {
    key: 'clickRemove',
    value: function clickRemove(e) {
      this.removeCode((0, _jquery2.default)(e.target).attr('data-code'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('modals/purchase/coupons.html', function (t) {
        _this4.$el.html(t({
          couponCodes: _this4.couponCodes,
          codeResult: _this4.codeResult
        }));
      });

      return this;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;