'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _Order = require('../../../models/purchase/Order');

var _Order2 = _interopRequireDefault(_Order);

var _Listing = require('../../../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseView) {
  _inherits(_class, _BaseView);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!_this.model || !(_this.model instanceof _Order2.default)) {
      throw new Error('Please provide an order model');
    }

    if (!options.listing || !(options.listing instanceof _Listing2.default)) {
      throw new Error('Please provide a listing model');
    }

    if (!options.prices) {
      throw new Error('Please provide the prices array');
    }

    _this.options = options;
    _this._coupons = options.couponObj || [];
    _this.listing = options.listing;
    _this.prices = options.prices;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'receipt flexColRows gutterVSm tx5b';
    }
  }, {
    key: 'updatePrices',
    value: function updatePrices(prices) {
      if (prices !== this.prices) {
        this.prices = prices;
        this.render();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('modals/purchase/receipt.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.model.toJSON(), {
          listing: _this2.listing.toJSON(),
          listingCurrency: _this2.listing.price.currencyCode,
          coupons: _this2.coupons,
          displayCurrency: _app2.default.settings.get('localCurrency'),
          prices: _this2.prices,
          isCrypto: _this2.listing.isCrypto
        })));
      });

      return this;
    }
  }, {
    key: 'coupons',
    get: function get() {
      return this._coupons;
    },
    set: function set(coupons) {
      this._coupons = coupons;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;