'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _dom = require('../../../utils/dom');

var _serverConnect = require('../../../utils/serverConnect');

var _SimpleMessage = require('../SimpleMessage');

var _modalManager = require('../../../utils/modalManager');

var _Transaction = require('../../../models/wallet/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _Transaction3 = require('./Transaction');

var _Transaction4 = _interopRequireDefault(_Transaction3);

var _TransactionFetchState = require('./TransactionFetchState');

var _TransactionFetchState2 = _interopRequireDefault(_TransactionFetchState);

var _PopInMessage = require('../../components/PopInMessage');

var _PopInMessage2 = _interopRequireDefault(_PopInMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    if (!_this.collection) {
      throw new Error('Please provide a Transactions collection.');
    }

    if (!options.$scrollContainer || !options.$scrollContainer.length) {
      throw new Error('Please provide a jQuery object containing the scrollable element ' + 'this view is in.');
    }

    _this.transactionViews = [];
    _this.fetchFailed = false;
    _this.fetchErrorMessage = '';
    _this.newTransactionCount = 0;
    _this.popInTimeouts = [];

    _this.listenTo(_this.collection, 'update', function (cl, opts) {
      if (opts.changes.added.length) {
        // Expecting either a single new transactions on top or a page
        // of transactions on the bottom.
        if (opts.changes.added.length === _this.collection.length || opts.changes.added[opts.changes.added.length - 1] === _this.collection.at(_this.collection.length - 1)) {
          // It's a page of transactions at the bottom
          _this.renderTransactions(opts.changes.added, 'append');
        } else {
          // New transaction at top
          _this.renderTransactions(opts.changes.added, 'prepend');
        }
      }
    });

    _this.listenTo(_app2.default.settings, 'change:localCurrency', function () {
      _this.renderTransactions(_this.collection.models, 'replace');
    });

    _this.listenTo(_app2.default.localSettings, 'change:bitcoinUnit', function () {
      _this.renderTransactions(_this.collection.models, 'replace');
    });

    var serverSocket = (0, _serverConnect.getSocket)();

    if (serverSocket) {
      _this.listenTo(serverSocket, 'message', function (e) {
        // "wallet" sockets come for new transactions and when a transaction gets it's
        // first confirmation.
        if (e.jsonData.wallet) {
          var transaction = _this.collection.get(e.jsonData.wallet.txid);

          if (transaction) {
            // existing transaction has been confirmed
            transaction.set(transaction.parse(_extends({}, _underscore2.default.omit(e.jsonData.wallet, 'timestamp'))));
          } else {
            // new transaction
            _this.newTransactionCount += 1;

            // This is a bit ugly... but most incoming transactions (ones sent via our UI)
            // are immediately added to the list when their respective APIs succeeds and
            // therefore should not be included in the "new transactions" pop in count.
            // But, at this point we don't know if these are such transactions, so we'll
            // check back in a bit and see if they've already been added or not. It's a matter
            // of the socket coming in before the AJAX call returns.
            var timeout = setTimeout(function () {
              if (_this.collection.get(e.jsonData.wallet.txid)) {
                _this.newTransactionCount -= 1;
              } else {
                _this.showNewTransactionPopup();
              }
            }, 1500);

            _this.popInTimeouts.push(timeout);
          }
        }

        // The "walletUpdate" socket comes on a regular interval and gives us the current block
        // height which we can use to update the confirmations on a transaction.
        if (e.jsonData.walletUpdate) {
          _this.collection.models.filter(function (transaction) {
            return transaction.get('height') > 0;
          }).forEach(function (transaction) {
            var txHeight = transaction.get('height');
            var confirmations = 0;

            if (txHeight > 0) {
              confirmations = e.jsonData.walletUpdate.height - txHeight + 1;
            }

            transaction.set('confirmations', confirmations);
          });
        }
      });
    }

    _this.$scrollContainer = options.$scrollContainer;
    _this.throttledOnScroll = _underscore2.default.throttle(_this.onScroll, 100).bind(_this);

    _this.fetchTransactions();
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'walletTransactions';
    }
  }, {
    key: 'onScroll',
    value: function onScroll() {
      if (this.collection.length && !this.allLoaded) {
        // fetch next batch of transactions
        var lastTransaction = this.transactionViews[this.transactionViews.length - 1];

        if (!this.isFetching && (0, _dom.isScrolledIntoView)(lastTransaction.el)) {
          this.fetchTransactions();
        }
      }

      if (this.newTransactionPopIn) {
        this.setPopInMessageHolderPositioning();
      }
    }
  }, {
    key: 'fetchTransactions',
    value: function fetchTransactions() {
      var _this2 = this;

      if (this.transactionsFetch) this.transactionsFetch.abort();

      var fetchParams = {
        limit: this.transactionsPerFetch
      };

      if (this.collection.length) {
        fetchParams.offsetId = this.collection.at(this.collection.length - 1).id;
      }

      this.transactionsFetch = this.collection.fetch({
        data: fetchParams,
        remove: false
      });

      this.transactionsFetch.always(function () {
        if (_this2.isRemoved()) return;

        if (_this2.transactionFetchState) {
          if (!_this2.collection.length) {
            _this2.render();
          } else {
            _this2.transactionFetchState.setState({
              isFetching: false
            });
          }
        }
      }).fail(function (jqXhr) {
        if (jqXhr.statusText === 'abort') return;

        _this2.fetchFailed = true;

        if (jqXhr.responseJSON && jqXhr.responseJSON.reason) {
          _this2.fetchErrorMessage = jqXhr.responseJSON.reason;
        }

        if (_this2.transactionFetchState) {
          _this2.transactionFetchState.setState({
            fetchFailed: _this2.fetchFailed,
            fetchErrorMessage: _this2.fetchErrorMessage
          });
        }
      }).done(function (data) {
        if (_this2.isRemoved()) return;

        if (typeof _this2.countAtFirstFetch === 'undefined') {
          _this2.countAtFirstFetch = data.count;
        }

        if (_this2.collection.length) {
          var curConn = (0, _serverConnect.getCurrentConnection)();

          if (curConn && curConn.server && !curConn.server.get('backupWalletWarned')) {
            var warning = (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('wallet.transactions.backupWalletWarningTitle'), _app2.default.polyglot.t('wallet.transactions.backupWalletWarningBody', {
              link: '<a class="js-recoverWalletSeed">' + (_app2.default.polyglot.t('wallet.transactions.recoverySeedLink') + '</a>')
            }));

            warning.$el.on('click', '.js-recoverWalletSeed', function () {
              (0, _modalManager.launchSettingsModal)({
                initialTab: 'Advanced',
                scrollTo: '.js-backupWalletSection'
              });
              warning.remove();
            });

            curConn.server.save({ backupWalletWarned: true });
          }
        }
      });

      if (this.transactionFetchState) {
        this.transactionFetchState.setState({
          isFetching: true,
          transactionsPresent: !!this.collection.length
        });
      }

      this.fetchFailed = false;
      this.fetchErrorMessage = '';
    }
  }, {
    key: 'setPopInMessageHolderPositioning',
    value: function setPopInMessageHolderPositioning() {
      this.$popInMessages.toggleClass('notFixed', this.$scrollContainer[0].scrollTop < 338);
    }
  }, {
    key: 'showNewTransactionPopup',
    value: function showNewTransactionPopup() {
      var _this3 = this;

      if (this.newTransactionPopIn && !this.newTransactionPopIn.isRemoved()) {
        this.newTransactionPopIn.setState({
          messageText: (0, _PopInMessage.buildRefreshAlertMessage)(_app2.default.polyglot.t('wallet.transactions.newTransactionsPopin', { smart_count: this.newTransactionCount }))
        });
      } else {
        this.newTransactionPopIn = this.createChild(_PopInMessage2.default, {
          messageText: (0, _PopInMessage.buildRefreshAlertMessage)(_app2.default.polyglot.t('wallet.transactions.newTransactionsPopin', { smart_count: this.newTransactionCount }))
        });

        this.listenTo(this.newTransactionPopIn, 'clickRefresh', function () {
          _this3.collection.reset();
          _this3.fetchTransactions();
          _this3.render();
        });

        this.listenTo(this.newTransactionPopIn, 'clickDismiss', function () {
          _this3.newTransactionPopIn.remove();
          _this3.newTransactionPopIn = null;
        });

        this.$popInMessages.append(this.newTransactionPopIn.render().el);
        this.setPopInMessageHolderPositioning();
      }
    }
  }, {
    key: 'createTransactionView',
    value: function createTransactionView(model) {
      var _this4 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var view = this.createChild(_Transaction4.default, _extends({
        model: model
      }, options));

      this.listenTo(view, 'retrySuccess', function (e) {
        _app2.default.walletBalance.set({
          confirmed: e.data.confirmed,
          unconfirmed: e.data.unconfirmed
        });

        var transaction = new _Transaction2.default({
          value: e.data.amount * -1,
          txid: e.data.txid,
          timestamp: e.data.timestamp,
          address: e.data.address,
          memo: e.data.memo
        }, { parse: true });

        _this4.collection.unshift(transaction);
      });

      return view;
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.transactionsFetch) this.transactionsFetch.abort();
      this.popInTimeouts.forEach(function (timeout) {
        return clearTimeout(timeout);
      });
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'renderTransactions',
    value: function renderTransactions() {
      var _this5 = this;

      var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var insertionType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'append';

      if (!models) {
        throw new Error('Please provide an array of transactions models.');
      }

      if (['append', 'prepend', 'replace'].indexOf(insertionType) === -1) {
        throw new Error('Please provide a valid insertion type.');
      }

      if (insertionType === 'replace') {
        this.transactionViews.forEach(function (transaction) {
          return transaction.remove();
        });
        this.transactionViews = [];
      }

      var transactionsFrag = document.createDocumentFragment();

      models.forEach(function (transaction) {
        var view = _this5.createTransactionView(transaction);
        _this5.transactionViews.push(view);
        view.render().$el.appendTo(transactionsFrag);
      });

      if (insertionType === 'prepend') {
        this.$transactionsContainer.prepend(transactionsFrag);
      } else {
        this.$transactionsContainer.append(transactionsFrag);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      this.newTransactionCount = 0;
      this.popInTimeouts.forEach(function (timeout) {
        return clearTimeout(timeout);
      });
      this.popInTimeouts = [];
      if (this.newTransactionPopIn) {
        this.newTransactionPopIn.remove();
        this.newTransactionPopIn = null;
      }

      (0, _loadTemplate2.default)('modals/wallet/transactions.html', function (t) {
        _this6.$el.html(t({
          transactions: _this6.collection.toJSON(),
          isFetching: _this6.isFetching
        }));
      });

      this.$transactionsContainer = this.$('.js-transactionListContainer');
      this._$popInMessages = null;
      this._$noTransactions = null;

      this.renderTransactions(this.collection.models, 'replace');

      this.$scrollContainer.off('scroll', this.throttledOnScroll).on('scroll', this.throttledOnScroll);

      if (this.transactionFetchState) this.transactionFetchState.remove();
      this.transactionFetchState = this.createChild(_TransactionFetchState2.default, {
        initialState: {
          isFetching: this.isFetching,
          fetchFailed: this.fetchFailed,
          fetchErrorMessage: this.fetchErrorMessage,
          transactionsPresent: !!this.collection.length
        }
      });
      this.$('.js-transactionFetchStateWrap').html(this.transactionFetchState.render().el);

      return this;
    }
  }, {
    key: 'transactionsPerFetch',
    get: function get() {
      return 25;
    }
  }, {
    key: 'isFetching',
    get: function get() {
      return this.transactionsFetch && this.transactionsFetch.state() === 'pending';
    }
  }, {
    key: 'allLoaded',
    get: function get() {
      return this.collection.length >= this.countAtFirstFetch;
    }
  }, {
    key: '$popInMessages',
    get: function get() {
      return this._$popInMessages || (this._$popInMessages = this.$('.js-popInMessages'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;