'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _serverConnect = require('../../../utils/serverConnect');

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Transaction = require('../../../models/wallet/Transaction');

var _Transaction2 = _interopRequireDefault(_Transaction);

var _WalletTransactions = require('../../../collections/WalletTransactions');

var _WalletTransactions2 = _interopRequireDefault(_WalletTransactions);

var _BaseModal2 = require('../BaseModal');

var _BaseModal3 = _interopRequireDefault(_BaseModal2);

var _BTCTicker = require('../../BTCTicker');

var _BTCTicker2 = _interopRequireDefault(_BTCTicker);

var _Stats = require('./Stats');

var _Stats2 = _interopRequireDefault(_Stats);

var _SendMoney = require('./SendMoney');

var _SendMoney2 = _interopRequireDefault(_SendMoney);

var _ReceiveMoney = require('./ReceiveMoney');

var _ReceiveMoney2 = _interopRequireDefault(_ReceiveMoney);

var _Transactions = require('./Transactions');

var _Transactions2 = _interopRequireDefault(_Transactions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseModal) {
  _inherits(_class, _BaseModal);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({}, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.sendModeOn = true;
    _this.addressFetches = [];
    _this.needAddressFetch = true;

    _this.transactions = new _WalletTransactions2.default();

    _this.listenTo(_this.transactions, 'sync', function (md, response) {
      if (_this.stats) {
        _this.stats.setState({ transactionCount: response.count });
      }
    });

    _this.listenTo(_app2.default.walletBalance, 'change:confirmed', function (md, confirmedAmount) {
      if (_this.stats) {
        _this.stats.setState({
          balance: confirmedAmount
        });
      }
    });

    _this.listenTo(_app2.default.settings, 'change:localCurrency', function (md, curr) {
      if (_this.stats) {
        _this.stats.setState({
          userCurrency: curr
        });
      }
    });

    var serverSocket = (0, _serverConnect.getSocket)();

    if (serverSocket) {
      _this.listenTo(serverSocket, 'message', function (e) {
        // "wallet" sockets come for new transactions and when a transaction gets it's
        // first confirmation. We're only interested in new transactions (i.e. the height will be 0)
        if (e.jsonData.wallet && !e.jsonData.wallet.height) {
          if (_this.stats) {
            _this.stats.setState({
              transactionCount: _this.stats.getState().transactionCount + 1
            });
          }

          if (_this.sendModeOn) {
            // we'll fetch the next time we show the receive money section
            _this.needAddressFetch = true;
          } else {
            _this.fetchAddress();
          }
        }
      });
    }
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'className', this).call(this) + ' wallet modalScrollPage modalMedium';
    }
  }, {
    key: 'events',
    value: function events() {
      return _extends({
        'click .js-toggleSendReceive': 'onClickToggleSendReceive'
      }, _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'events', this).call(this));
    }
  }, {
    key: 'onClickToggleSendReceive',
    value: function onClickToggleSendReceive() {
      this.sendModeOn = !this.sendModeOn;
    }
  }, {
    key: 'onSpendSuccess',
    value: function onSpendSuccess(data) {
      if (this.transactionsVw) {
        var transaction = new _Transaction2.default({
          value: data.amount * -1,
          txid: data.txid,
          timestamp: data.timestamp,
          address: data.address,
          memo: data.memo
        }, { parse: true });

        this.transactionsVw.collection.unshift(transaction);
      }
    }
  }, {
    key: 'setSendFormData',


    /**
     * Set the contents of the Send Money form. Will return
     * true if able to set the form or false otherwise. The most
     * common reason for not being able to set the form is that a
     * send is already in progress.
     */
    value: function setSendFormData() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!this.sendMoney) return false;

      if (this.sendMoney.saveInProgress) {
        return false;
      }

      var opts = _extends({
        showSendMode: true,
        // focus will only happen if you showSendMode
        focusAddressInput: true
      }, options);

      if (opts.showSendMode) this.sendModeOn = true;
      this.sendMoney.setFormData(data, !!opts.focusAddressInput);
      return true;
    }
  }, {
    key: 'fetchAddress',
    value: function fetchAddress() {
      var _this2 = this;

      if (this.receiveMoney) {
        this.receiveMoney.setState({
          fetching: true
        });
      }

      this.needAddressFetch = false;

      var address = '';

      var fetch = _jquery2.default.get(_app2.default.getServerUrl('wallet/address/')).done(function (data) {
        address = data.address;
      }).always(function () {
        if (_this2.isRemoved()) return;

        if (_this2.receiveMoney && !_this2.isAdressFetching()) {
          _this2.receiveMoney.setState({
            fetching: false,
            address: address
          });
        }
      });

      this.addressFetches.push(fetch);

      return fetch;
    }
  }, {
    key: 'isAdressFetching',
    value: function isAdressFetching() {
      if (this.addressFetches) {
        return this.addressFetches.some(function (fetch) {
          return fetch.state() === 'pending';
        });
      }

      return false;
    }
  }, {
    key: 'open',
    value: function open() {
      var _this3 = this;

      var clearSendForm = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.sendMoney && !this.sendMoney.saveInProgress;

      this.sendModeOn = true;

      if (this.sendMoney) {
        if (clearSendForm) this.sendMoney.clearForm();

        setTimeout(function () {
          _this3.sendMoney.focusAddress();
        });
      }

      return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'open', this).call(this);
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.addressFetches.forEach(function (fetch) {
        return fetch.abort();
      });
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      (0, _loadTemplate2.default)('modals/wallet/wallet.html', function (t) {
        (0, _loadTemplate2.default)('walletIcon.svg', function (walletIconTmpl) {
          _this4.$el.html(t({
            walletIconTmpl: walletIconTmpl
          }));

          _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', _this4).call(_this4);

          if (_this4.btcTicker) _this4.btcTicker.remove();
          _this4.btcTicker = _this4.createChild(_BTCTicker2.default);
          _this4.$('.js-btcTickerContainer').append(_this4.btcTicker.render().$el);

          // render the wallet stats
          if (_this4.stats) _this4.stats.remove();

          _this4.stats = _this4.createChild(_Stats2.default, {
            initialState: {
              balance: _app2.default.walletBalance.get('confirmed'),
              userCurrency: _app2.default.settings.get('localCurrency')
            }
          });

          _this4.$('.js-walletStatsContainer').html(_this4.stats.render().el);

          // render the send money view
          if (_this4.sendMoney) _this4.sendMoney.remove();
          _this4.sendMoney = _this4.createChild(_SendMoney2.default);
          _this4.$('.js-sendReceiveContainer').html(_this4.sendMoney.render().el);

          // render the receive money view
          if (_this4.receiveMoney) _this4.receiveMoney.remove();

          _this4.receiveMoney = _this4.createChild(_ReceiveMoney2.default, {
            initialState: {
              fetching: _this4.isAdressFetching()
            }
          });

          _this4.listenTo(_this4.receiveMoney, 'click-cancel', function () {
            return _this4.sendModeOn = true;
          });
          _this4.$('.js-sendReceiveContainer').append(_this4.receiveMoney.render().el);

          if (_this4.transactions) _this4.transactions.remove();

          _this4.transactionsVw = new _Transactions2.default({
            collection: _this4.transactions,
            $scrollContainer: _this4.$el
          });

          _this4.$('.js-transactionContainer').html(_this4.transactionsVw.render().el);
        });
      });

      return this;
    }
  }, {
    key: 'sendModeOn',
    set: function set(bool) {
      if (typeof bool !== 'boolean') {
        throw new Error('Please provide a boolean.');
      }

      if (bool !== this._sendModeOn) {
        this.$el.toggleClass('receiveModeOn', !bool);
        this._sendModeOn = bool;

        if (bool && this.sendMoney) {
          this.sendMoney.focusAddress();
        }

        if (!bool && this.needAddressFetch) {
          this.fetchAddress();
        }
      }
    },
    get: function get() {
      return this._sendModeOn;
    }
  }]);

  return _class;
}(_BaseModal3.default);

exports.default = _class;