'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _serverConnect = require('../../utils/serverConnect');

var _Profile = require('../../models/profile/Profile');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _ListFetcher = require('./ListFetcher');

var _ListFetcher2 = _interopRequireDefault(_ListFetcher);

var _Notification = require('./Notification');

var _Notification2 = _interopRequireDefault(_Notification);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      filter: ''
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    if (!_this.collection) {
      throw new Error('Please provide a collection.');
    }

    _this.options = opts;
    _this.notifViews = [];

    // This count represents the total number of notifications that this list
    // is to show. It's used to know when all pages have been loaded. It's determined
    // based off of the returned total from the fetch of the first page + any new
    // notifications that come over the socket.
    _this.totalNotifs = 0;

    if (!_this.collection.length) _this.$el.addClass('noNotifications');
    _this.listenTo(_this.collection, 'update', function (cl, updateOpts) {
      _this.$el.toggleClass('noNotifications', !_this.collection.length);

      if (updateOpts.changes.added.length) {
        // Expecting either a single new notifcation on the bottom (will
        // be rendered on top) or a page of notifications on top (will be
        // rendered on the bottom).
        if (updateOpts.changes.added[updateOpts.changes.added.length - 1] === _this.collection.at(0)) {
          // It's a page of notifcations at the bottom
          _this.renderNotifications(updateOpts.changes.added, 'append');
        } else {
          // New notification at top
          _this.renderNotifications(updateOpts.changes.added, 'prepend');
        }

        updateOpts.changes.added.forEach(function (notif) {
          var innerNotif = notif.get('notification');
          var types = ['follow', 'moderatorAdd', 'moderatorRemove'];

          if (types.indexOf(innerNotif.type) > -1) {
            (0, _Profile.getCachedProfiles)([innerNotif.peerId])[0].done(function (profile) {
              notif.set('notification', _extends({}, innerNotif, {
                handle: profile.get('handle') || '',
                avatarHashes: profile.get('avatarHashes') && profile.get('avatarHashes').toJSON() || {}
              }));
            });
          }
        });

        _this.listFetcher.setState({ noResults: false });
      }
    });

    _this.throttledOnScroll = _underscore2.default.throttle(_this.onScroll, 100).bind(_this);

    var serverSocket = (0, _serverConnect.getSocket)();

    if (serverSocket) {
      serverSocket.on('message', function (e) {
        if (e.jsonData.notification && e.jsonData.notification.type !== 'unfollow') {
          var type = e.jsonData.notification.type;
          var filters = (_this.options.filter || '').split(',').filter(function (filter) {
            return filter.trim().length;
          }).map(function (filter) {
            return filter.trim();
          });

          if (!filters.length || filters.indexOf(type) > -1) {
            _this.totalNotifs += 1;
            _this.collection.add({
              id: e.jsonData.notification.notificationId,
              read: false,
              timestamp: new Date().toISOString(),
              notification: _extends({}, _underscore2.default.omit(e.jsonData.notification, 'notificationId'))
            });
          }
        }
      });
    }

    _this.fetchNotifications();
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'notificationsList navList listBox';
    }
  }, {
    key: 'onScroll',
    value: function onScroll() {
      if (this.collection.length && !this.allLoaded && !this.isFetching && !this.fetchFailed) {
        // fetch next batch of notifications
        var lastNotif = this.notifViews[this.notifViews.length - 1];

        if (this.isNotifScrolledIntoView(lastNotif.el)) {
          this.fetchNotifications();
        }
      }
    }

    /*
     * isScrolledIntoView from util/dom.js is not accurataly returning a result for
     * a notification because the notifications menu markup is inside the very narrow
     * pageNav bar. Since the notification is outside the pageNav's "viewport", it thinks
     * nothing within the notif menu is ever in view. It's a unique enough case that we'll
     * create a custom function here.
     */

  }, {
    key: 'isNotifScrolledIntoView',
    value: function isNotifScrolledIntoView(notifEl) {
      var notifRect = notifEl.getBoundingClientRect();
      var scrollRect = this.$scrollContainer[0].getBoundingClientRect();

      return notifRect.top <= scrollRect.top + this.$scrollContainer[0].clientHeight;
    }
  }, {
    key: 'fetchNotifications',
    value: function fetchNotifications() {
      var _this2 = this;

      if (this.notifFetch) this.notifFetch.abort();

      var fetchParams = {
        limit: this.notifsPerFetch
      };

      if (this.collection.length) {
        fetchParams.offsetId = this.collection.at(0).id;
      }

      if (this.options.filter) {
        fetchParams.filter = this.options.filter;
      }

      this.notifFetch = this.collection.fetch({
        data: fetchParams,
        remove: false
      });

      if (this.listFetcher) {
        this.listFetcher.setState({
          isFetching: true,
          fetchFailed: false,
          fetchError: ''
        });
      }

      this.notifFetch.done(function (data, txtStatus, xhr) {
        if (xhr.statusText === 'abort') return;

        var state = {
          isFetching: false,
          fetchFailed: false,
          noResults: false,
          fetchError: ''
        };

        if (!fetchParams.offsetId) {
          _this2.totalNotifs += data.total;

          if (!data.notifications.length) {
            state.noResults = true;
          }
        }

        _this2.listFetcher.setState(state);
      }).fail(function (xhr) {
        _this2.listFetcher.setState({
          isFetching: false,
          fetchFailed: true,
          fetchError: xhr.responseJSON && xhr.responseJSON.reason || ''
        });
      });
    }
  }, {
    key: 'renderNotifications',
    value: function renderNotifications() {
      var _this3 = this;

      var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var insertionType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'append';

      if (!models) {
        throw new Error('Please provide an array of notification models.');
      }

      if (['append', 'prepend', 'replace'].indexOf(insertionType) === -1) {
        throw new Error('Please provide a valid insertion type.');
      }

      if (insertionType === 'replace') {
        this.notifViews.forEach(function (notif) {
          return notif.remove();
        });
        this.notifViews = [];
      }

      var notifsFrag = document.createDocumentFragment();

      models.forEach(function (notif) {
        var view = _this3.createNotifView(notif);
        _this3.notifViews.push(view);
        view.render().$el.appendTo(notifsFrag);
      });

      if (insertionType === 'prepend') {
        this.getCachedEl('.js-notifsContainer').prepend(notifsFrag);
      } else {
        this.getCachedEl('.js-notifsContainer').append(notifsFrag);
      }
    }
  }, {
    key: 'createNotifView',
    value: function createNotifView(model) {
      var _this4 = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var view = this.createChild(_Notification2.default, _extends({
        model: model
      }, options));

      this.listenTo(view, 'navigate', function () {
        return _this4.trigger('notifNavigate', { view: view });
      });

      return view;
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.notifFetch) this.notifFetch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);

      (0, _loadTemplate2.default)('notifications/notificationsList.html', function (t) {
        _this5.$el.html(t({
          notifications: _this5.collection.toJSON()
        }));
      });

      if (this.listFetcher) this.listFetcher.remove();

      this.listFetcher = this.createChild(_ListFetcher2.default, {
        initialState: {
          isFetching: this.notifFetch && this.notifFetch.state() === 'pending',
          fetchFailed: this.notifFetch && this.notifFetch.state() === 'rejected',
          fetchError: this.notifFetch && this.notifFetch.responseJSON && this.notifFetch.responseJSON.reason || ''
        }
      });

      this.listenTo(this.listFetcher, 'retry-click', function () {
        // Timeout is needed because otherwise when the listFetcher state changes and
        // the retry button is no longer in the dom, the doc click handler in pagenav
        // closes the menu. The notifContainer stops bubbling, so it shouldn't make it
        // to the doc handler, but something gets wonky if it's ripped out of the dom.
        setTimeout(function () {
          _this5.fetchNotifications();
        });
      });
      this.getCachedEl('.js-fetcherContainer').html(this.listFetcher.render().el);

      this.renderNotifications(this.collection.models, 'replace');

      return this;
    }
  }, {
    key: '$scrollContainer',
    set: function set($el) {
      if (!($el instanceof _jquery2.default)) {
        throw new Error('Please provide a jQuery element containing the scrollable element ' + ' this view is in.');
      }

      if ($el !== this._$scrollContainer) {
        if (this._$scrollContainer) {
          this._$scrollContainer.off('scroll', this.throttledOnScroll);
        }
        this._$scrollContainer = $el;
        this._$scrollContainer.on('scroll', this.throttledOnScroll);
      }
    },
    get: function get() {
      return this._$scrollContainer;
    }
  }, {
    key: 'notifsPerFetch',
    get: function get() {
      // return 20;
      return 4;
    }
  }, {
    key: 'isFetching',
    get: function get() {
      return this.notifFetch && this.notifFetch.state() === 'pending';
    }
  }, {
    key: 'fetchFailed',
    get: function get() {
      return this.notifFetch && this.notifFetch.state() === 'rejected';
    }
  }, {
    key: 'allLoaded',
    get: function get() {
      return this.collection.length >= this.totalNotifs;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;