'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _string = require('../../utils/string');

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _Notifications = require('../../collections/Notifications');

var _Notifications2 = _interopRequireDefault(_Notifications);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _NotificationsList = require('./NotificationsList');

var _NotificationsList2 = _interopRequireDefault(_NotificationsList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      initialState: {
        tab: 'all'
      }
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this.notifListsCache = {};
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'notifications clrBr border clrP clrSh1';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-tab[data-tab]': 'onClickTab'
      };
    }
  }, {
    key: 'onClickTab',
    value: function onClickTab(e) {
      var _this2 = this;

      // Timeout needed so event can bubble to a page nav handler before the view is re-rendered
      // and the target element is ripped out of the dom.
      setTimeout(function () {
        _this2.setState({ tab: e.target.getAttribute('data-tab') });
      });
    }

    /**
     * If there are any loaded notifications, this method will kick off a server
     * call that will mark all notifications (seen and unseen) as read. If there
     * are no loaded notifications (possibly because a initial page is being fetched),
     * it will return false and not kick off any server call.
     * @return {boolean|object} False if no notifications have been loaded, otherwise
     *   the xhr of the call to the server
     */

  }, {
    key: 'markNotifsAsRead',
    value: function markNotifsAsRead() {
      var _this3 = this;

      // Going to optimistically mark all as read and switch back if the call fails.
      var notifs = [];

      Object.keys(this.notifListsCache).forEach(function (listType) {
        _this3.notifListsCache[listType].collection.forEach(function (notif) {
          notif.set('read', true);
          notifs.push(notif);
        });
      });

      if (!notifs.length) return false;

      return _jquery2.default.post(_app2.default.getServerUrl('ob/marknotificationsasread')).fail(function () {
        return notifs.forEach(function (notif) {
          return notif.set('read', false);
        });
      });
    }

    /**
     * Will set the tab to 'All' and set the scroll position to the top - useful
     * when hiding the menu so that it resets to a standard initial position. It will
     * leave the collections in tact, so the user won't need to fetch notifications
     * already fetched.
     */

  }, {
    key: 'reset',
    value: function reset() {
      this.setState({ tab: 'all' });
      this.getCachedEl('.js-tabContainer')[0].scrollTop = 0;
    }
  }, {
    key: 'createAllNotifList',
    value: function createAllNotifList() {
      var _this4 = this;

      var notifList = this.createChild(_NotificationsList2.default, {
        collection: new _Notifications2.default()
      });

      this.listenTo(notifList, 'notifNavigate', function () {
        return _this4.trigger('notifNavigate', { list: 'all' });
      });

      return notifList;
    }
  }, {
    key: 'createOrdersNotifList',
    value: function createOrdersNotifList() {
      var _this5 = this;

      var notifList = this.createChild(_NotificationsList2.default, {
        collection: new _Notifications2.default(),
        filter: 'order,declined,cancel,refund,fulfillment,orderComplete,disputeOpen,' + 'disputeUpdate,disputeClose,disputeAccepted'
      });

      this.listenTo(notifList, 'notifNavigate', function () {
        return _this5.trigger('notifNavigate', { list: 'order' });
      });

      return notifList;
    }
  }, {
    key: 'createFollowersNotifList',
    value: function createFollowersNotifList() {
      var _this6 = this;

      var notifList = this.createChild(_NotificationsList2.default, {
        collection: new _Notifications2.default(),
        filter: 'follow'
      });

      this.listenTo(notifList, 'notifNavigate', function () {
        return _this6.trigger('notifNavigate', { list: 'follow' });
      });

      return notifList;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this7 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      var state = this.getState();

      (0, _loadTemplate2.default)('notifications/notifications.html', function (t) {
        _this7.$el.html(t(_extends({}, _this7.getState())));
      });

      var notifList = this.notifListsCache[state.tab];

      if (!notifList) {
        var createMethodName = 'create' + (0, _string.capitalize)(state.tab) + 'NotifList';
        if (this[createMethodName]) {
          notifList = this[createMethodName].call(this);
          notifList.render();
          this.notifListsCache[state.tab] = notifList;
        } else {
          throw new Error('Unable to populate the ' + state.tab + ' tab, because I was unable to ' + ('find the ' + createMethodName + ' function'));
        }
      }

      // If the tab we want is already the active one, do nothing.
      if (notifList !== this.activeNotifList) {
        notifList.delegateEvents();
        this.getCachedEl('.js-tabContainer').html(notifList.el);
        notifList.$scrollContainer = this.getCachedEl('.js-tabContainer');
        this.activeNotifList = notifList;
      }

      return this;
    }
  }, {
    key: 'tagName',
    get: function get() {
      return 'section';
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;