'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _RatingsStrip = require('../RatingsStrip');

var _RatingsStrip2 = _interopRequireDefault(_RatingsStrip);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

require('trunk8');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;

    _this.ratingStrips = {};
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'review clrBr';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-showMore': 'clickShowMore',
        'click .js-showLess': 'clickShowLess'
      };
    }
  }, {
    key: 'clickShowMore',
    value: function clickShowMore(e) {
      // the show more button is added by the parent view when it applies trunk8 to the text
      var btnTxt = _app2.default.polyglot.t('listingDetail.review.showLess');
      (0, _jquery2.default)(e.target).parent().trunk8('revert').append('&nbsp; <button class="btnTxtOnly trunkLink js-showLess">' + btnTxt + '</button>');
    }
  }, {
    key: 'clickShowLess',
    value: function clickShowLess(e) {
      (0, _jquery2.default)(e.target).parent().trunk8();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('reviews/review.html', function (t) {
        _this2.$el.html(t(_extends({
          moment: _moment2.default,
          showListingData: _this2.options.showListingData
        }, _this2.model.toJSON())));

        _this2.$('.ratingsContainer').each(function (index, element) {
          var $el = (0, _jquery2.default)(element);
          var type = $el.data('ratingType');

          if (!type) {
            throw new Error('Unable to render the ratings strips because it\'s container does not ' + 'specify a type.');
          }

          if (_this2.ratingStrips[type]) _this2.ratingStrips[type].remove();
          _this2.ratingStrips[type] = _this2.createChild(_RatingsStrip2.default, {
            initialState: {
              curRating: _this2.model.get(type) || 0
            }
          });

          $el.append(_this2.ratingStrips[type].render().el);
        });
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;