'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _serverConnect = require('../../utils/serverConnect');

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _Reviews = require('../../collections/Reviews');

var _Reviews2 = _interopRequireDefault(_Reviews);

var _Review = require('./Review');

var _Review2 = _interopRequireDefault(_Review);

require('trunk8');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({}, options, {
      initialState: _extends({
        isFetchingRatings: false }, options.initialState || {})
    });

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this.startIndex = _this.options.startIndex || 0;
    _this.initialPageSize = _this.options.pageSize || 3;
    _this.pageSize = _this.options.pageSize || 10;
    _this._reviewIDs = _this.options.ratings || [];
    _this.showListingData = _this.options.showListingData;
    _this.collection = new _Reviews2.default();
    _this.listenTo(_this.collection, 'add', function (model) {
      return _this.addReview(model);
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'reviews';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-loadMoreBtn': 'clickLoadMore'
      };
    }
  }, {
    key: 'onSocketMessage',
    value: function onSocketMessage(event) {
      var eventData = event.jsonData || {};
      if (this.reviewIDs && this.reviewIDs.indexOf(eventData.ratingId) !== -1) {
        if (!eventData.error) {
          this.collection.add(eventData.rating.ratingData);
        } else {
          // add the error to the collection so it can be shown in place of the review
          this.collection.add(eventData);
        }
        if (this.collection.length >= this.startIndex) {
          this.getCachedEl('.js-loadMoreBtn').removeClass('processing');
        }
      }
    }
  }, {
    key: 'listenForReviews',
    value: function listenForReviews() {
      if (!this.reviewIDs.length) return;

      var serverSocket = (0, _serverConnect.getSocket)();

      if (serverSocket) {
        this.stopListening(serverSocket, null, this.onSocketMessage);
        this.listenTo(serverSocket, 'message', this.onSocketMessage);
      } else {
        throw new Error('There is no connection to the server to listen to.');
      }
    }
  }, {
    key: 'hideMoreBtn',
    value: function hideMoreBtn() {
      if (this.startIndex >= this.reviewIDs.length) {
        this.getCachedEl('.js-loadMore').addClass('hide');
      }
    }
  }, {
    key: 'appendError',
    value: function appendError(error) {
      var msg = _app2.default.polyglot.t('listingDetail.errors.fetchReviews', { error: error });
      this.getCachedEl('.js-errors').append('<p><i class="ion-alert-circled"> ' + msg + '</p>');
    }
  }, {
    key: 'loadReviews',
    value: function loadReviews() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.startIndex;

      var _this2 = this;

      var pageSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.pageSize;
      var async = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : !!this.options.async;

      var revLength = this.reviewIDs.length;
      // if on the last page, only fetch the number of reviews that remain
      var ps = start + pageSize <= revLength ? pageSize : revLength - start;

      if (start < revLength) {
        this.getCachedEl('.js-loadMoreBtn').addClass('processing');
        this.getCachedEl('.js-errors').html('');
        _jquery2.default.ajax({
          url: _app2.default.getServerUrl('ob/fetchratings?async=' + async),
          data: JSON.stringify(this.reviewIDs.slice(start, start + ps)),
          dataType: 'json',
          contentType: 'application/json',
          type: 'POST'
        }).done(function (data) {
          _this2.startIndex = start + ps;
          if (!async) {
            _this2.collection.add(_underscore2.default.pluck(data, 'ratingData'));
            _this2.getCachedEl('.js-loadMoreBtn').removeClass('processing');
          }
          _this2.hideMoreBtn();
        }).fail(function (xhr) {
          var failReason = xhr.responseJSON && xhr.responseJSON.reason || '';
          _this2.appendError(failReason);
          _this2.getCachedEl('.js-errors').append('<p>' + failReason + '</p>');
          _this2.hideMoreBtn();
          _this2.getCachedEl('.js-loadMoreBtn').removeClass('processing');
        });
      }
    }
  }, {
    key: 'addReview',
    value: function addReview(model) {
      var newReview = new _Review2.default({
        model: model,
        showListingData: this.showListingData
      });
      var newRevieEl = newReview.render().$el;
      var btnTxt = _app2.default.polyglot.t('listingDetail.review.showMore');
      var truncLines = model.get('buyerID') !== undefined ? 5 : 6;

      this.getCachedEl('.js-reviewWrapper').append(newRevieEl);
      this.getCachedEl('.js-reviewWrapper').removeClass('hide');
      this.getCachedEl('.js-reviewsSpinner').addClass('hide');
      if (this.startIndex < this.reviewIDs.length) {
        this.getCachedEl('.js-loadMore').removeClass('hide');
      }

      // truncate any review text that is too long
      newRevieEl.find('.js-reviewText').trunk8({
        fill: '\u2026 <button class="btnTxtOnly trunkLink js-showMore">' + btnTxt + '</button>',
        lines: truncLines
      });
    }
  }, {
    key: 'clickLoadMore',
    value: function clickLoadMore() {
      this.loadReviews(this.startIndex);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('reviews/reviews.html', function (t) {
        _this3.$el.html(t(_extends({
          reviewsLength: _this3.reviewIDs.length,
          collectionLength: _this3.collection.length
        }, _this3.getState())));

        // render any reviews that have already loaded
        _this3.collection.each(function (review) {
          return _this3.addReview(review);
        });

        // load the reviews when data is available and the collection is empty
        if (_this3.reviewIDs.length && !_this3.collection.length) {
          _this3.loadReviews(_this3.startIndex, _this3.initialPageSize);
        }
      });

      return this;
    }
  }, {
    key: 'reviewIDs',
    get: function get() {
      return this._reviewIDs;
    },
    set: function set(ids) {
      if (!Array.isArray(ids)) throw new Error('The Review ids must be an array.');

      this._reviewIDs = ids;
      if (this.options.async) {
        this.listenForReviews();
      }
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;