'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _sanitizeHtml = require('sanitize-html');

var _sanitizeHtml2 = _interopRequireDefault(_sanitizeHtml);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _SimpleMessage = require('../modals/SimpleMessage');

var _Dialog = require('../modals/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _Results = require('./Results');

var _Results2 = _interopRequireDefault(_Results);

var _Results3 = require('../../collections/Results');

var _Results4 = _interopRequireDefault(_Results3);

var _SearchProviders = require('./SearchProviders');

var _SearchProviders2 = _interopRequireDefault(_SearchProviders);

var _SearchProvider = require('../../models/search/SearchProvider');

var _SearchProvider2 = _interopRequireDefault(_SearchProvider);

var _Suggestions = require('./Suggestions');

var _Suggestions2 = _interopRequireDefault(_Suggestions);

var _defaultSearchProviders = require('../../data/defaultSearchProviders');

var _defaultSearchProviders2 = _interopRequireDefault(_defaultSearchProviders);

require('../../lib/select2');

var _utils = require('../../utils');

var _serverConnect = require('../../utils/serverConnect');

var _cryptoCurrencies = require('../../data/cryptoCurrencies');

var _metrics = require('../../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({
      initialState: _extends({
        fetching: false
      }, options.initialState)
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    _this.defaultSuggestions = _this.options.defaultSuggestions || ['books', 'clothing', 'electronics', 'food', 'games', 'health', 'movies', 'music', 'sports', 'toys'];

    // in the future there may be more possible types
    _this.urlType = _this.usingTor ? 'torlistings' : 'listings';

    _this.sProvider = _app2.default.searchProviders['default' + _this.torString + 'Provider'];
    _this.queryProvider = false;

    // if the  provider returns a bad URL, the user must select a provider
    if (_is_js2.default.not.url(_this.providerUrl)) {
      // use the first default temporarily to construct the tempUrl below
      _this.sProvider = _app2.default.searchProviders.get(_defaultSearchProviders2.default[0].id);
      _this.mustSelectDefault = true;
    }

    var tempUrl = new URL(_this.providerUrl + '?' + (options.query || ''));
    var queryParams = tempUrl.searchParams;

    // if a url with parameters was in the query in, use the parameters in it instead.
    if (queryParams.get('providerQ')) {
      var subURL = new URL(queryParams.get('providerQ'));
      queryParams = subURL.searchParams;
      var base = '' + subURL.origin + subURL.pathname;
      var matchedProvider = _app2.default.searchProviders.filter(function (p) {
        return base === p.get('listings') || base === p.get('torlistings');
      });
      /* if the query provider doesn't exist, create a temporary provider model for it.
         One quirk to note: if a tor url is passed in while the user is in clear mode, and an
         existing provider has that tor url, that provider will be activated but will use its
         clear url if it has one. The opposite is also true.
       */
      if (!matchedProvider.length) {
        var queryOpts = {};
        queryOpts[(_this.usingTor ? 'tor' : '') + 'listings'] = '' + subURL.origin + subURL.pathname;
        _this.queryProvider = true;
        _this.sProvider = new _SearchProvider2.default(queryOpts);
      } else {
        _this.sProvider = matchedProvider[0];
      }
    }

    var params = {};

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = queryParams.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var key = _step.value;

        // checkbox params are represented by the same key multiple times. Convert them into a
        // single key with an array of values
        var val = queryParams.getAll(key);
        params[key] = val.length === 1 ? val[0] : val;
      }

      // use the parameters from the query unless they were overridden in the options
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    _this.serverPage = options.serverPage || params.p || 0;
    _this.pageSize = options.pageSize || params.ps || 24;
    _this.term = options.term || params.q || '';
    _this.sortBySelected = options.sortBySelected || params.sortBy || '';

    // all parameters not specified above are assumed to be filters
    var filterParams = _underscore2.default.omit(params, ['q', 'p', 'ps', 'sortBy', 'providerQ', 'network']);

    // set an initial set of filters for the first query
    // if not passed in, set the user's values for nsfw and the currency
    _this.defaultParams = {
      nsfw: String(_app2.default.settings.get('showNsfw')),
      acceptedCurrencies: (0, _cryptoCurrencies.getServerCurrency)().code
    };

    _this.filterParams = _extends({}, _this.defaultParams, filterParams);

    _this.processTerm(_this.term);
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'search';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-searchBtn': 'clickSearchBtn',
        'change .js-sortBy': 'changeSortBy',
        'change .js-filterWrapper select': 'changeFilter',
        'change .js-filterWrapper input': 'changeFilter',
        'keyup .js-searchInput': 'onKeyupSearchInput',
        'click .js-deleteProvider': 'clickDeleteProvider',
        'click .js-makeDefaultProvider': 'clickMakeDefaultProvider',
        'click .js-addQueryProvider': 'clickAddQueryProvider'
      };
    }
  }, {
    key: 'getCurrentProviderID',
    value: function getCurrentProviderID() {
      // if the user must select a default, or the provider is from the query, return no id
      return this.queryProvider || this.mustSelectDefault ? '' : this.sProvider.id;
    }

    /**
     * This will create a url with the term and other query parameters
     * @param {string} term
     */

  }, {
    key: 'processTerm',
    value: function processTerm(term) {
      this.term = term || '';
      // if term is false, search for *
      var query = 'q=' + encodeURIComponent(term || '*');
      var page = '&p=' + this.serverPage + '&ps=' + this.pageSize;
      var sortBy = this.sortBySelected ? '&sortBy=' + encodeURIComponent(this.sortBySelected) : '';
      var network = '&network=' + (!!_app2.default.serverConfig.testnet ? 'testnet' : 'mainnet');
      var formData = this.getFormData(this.$filters);
      // keep any parameters that aren't present in the form on the page
      var filters = _jquery2.default.param(_extends({}, this.defaultParams, this.filterParams, formData));
      filters = filters ? '&' + filters : '';
      var newURL = new URL(this.providerUrl + '?' + query + network + sortBy + page + filters);
      this.callSearchProvider(newURL);
    }

    /**
     * This will activate a provider. If no default is set, the activated provider will be set as the
     * the default. If the user is currently in Tor mode, the default Tor provider will be set.
     * @param md the search provider model
     */

  }, {
    key: 'activateProvider',
    value: function activateProvider(md) {
      if (!md || !(md instanceof _SearchProvider2.default)) {
        throw new Error('Please provide a search provider model.');
      }
      if (_app2.default.searchProviders.indexOf(md) === -1) {
        throw new Error('The provider must be in the collection.');
      }
      this.sProvider = md;
      this.queryProvider = false;
      this.serverPage = 0;
      if (this.mustSelectDefault) {
        this.mustSelectDefault = false;
        this.makeDefaultProvider();
      }
      this.filterParams = '';
      this.processTerm(this.term);
    }
  }, {
    key: 'deleteProvider',
    value: function deleteProvider() {
      var md = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.sProvider;

      if (md.get('locked')) {
        (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('search.errors.locked'));
      } else {
        md.destroy();
        if (_app2.default.searchProviders.length) this.activateProvider(_app2.default.searchProviders.at(0));
      }
    }
  }, {
    key: 'clickDeleteProvider',
    value: function clickDeleteProvider() {
      this.deleteProvider();
      (0, _metrics.recordEvent)('Discover_DeleteProvider');
    }
  }, {
    key: 'makeDefaultProvider',
    value: function makeDefaultProvider() {
      if (_app2.default.searchProviders.indexOf(this.sProvider) === -1) {
        throw new Error('The provider to be made the default must be in the collection.');
      }

      _app2.default.searchProviders['default' + this.torString + 'Provider'] = this.sProvider;
      this.getCachedEl('.js-makeDefaultProvider').addClass('hide');
    }
  }, {
    key: 'clickMakeDefaultProvider',
    value: function clickMakeDefaultProvider() {
      this.makeDefaultProvider();
      (0, _metrics.recordEvent)('Discover_MakeDefaultProvider');
    }
  }, {
    key: 'addQueryProvider',
    value: function addQueryProvider() {
      if (this.queryProvider) _app2.default.searchProviders.add(this.sProvider);
      this.activateProvider(this.sProvider);
    }
  }, {
    key: 'clickAddQueryProvider',
    value: function clickAddQueryProvider() {
      this.addQueryProvider();
      (0, _metrics.recordEvent)('Discover_AddQueryProvider');
    }
  }, {
    key: 'callSearchProvider',
    value: function callSearchProvider(searchUrl) {
      var _this2 = this;

      // remove a pending search if it exists
      if (this.callSearch) this.callSearch.abort();

      this.setState({
        fetching: true,
        selecting: this.mustSelectDefault,
        data: '',
        searchUrl: searchUrl,
        xhr: ''
      });

      if (!this.mustSelectDefault) {
        // query the search provider
        this.callSearch = _jquery2.default.get({
          url: searchUrl,
          dataType: 'json'
        }).done(function (pData, status, xhr) {
          var data = JSON.stringify(pData, function (key, val) {
            // sanitize the data from any dangerous characters
            if (typeof val === 'string') {
              return (0, _sanitizeHtml2.default)(val, {
                allowedTags: [],
                allowedAttributes: []
              });
            }
            return val;
          });
          data = JSON.parse(data);
          // make sure minimal data is present
          if (data.name && data.links) {
            // if data about the provider is recieved, update the model
            var update = { name: data.name };
            var urlTypes = [];
            if (data.logo && _is_js2.default.url(data.logo)) update.logo = data.logo;
            if (data.links) {
              if (_is_js2.default.url(data.links.search)) {
                update.search = data.links.search;
                urlTypes.push('search');
              }
              if (_is_js2.default.url(data.links.listings)) {
                update.listings = data.links.listings;
                urlTypes.push('listings');
              }
              if (_is_js2.default.url(data.links.reports)) {
                update.reports = data.links.reports;
                urlTypes.push('reports');
              }
              if (data.links.tor) {
                if (_is_js2.default.url(data.links.tor.search)) {
                  update.torsearch = data.links.tor.search;
                  urlTypes.push('torsearch');
                }
                if (_is_js2.default.url(data.links.tor.listings)) {
                  update.torlistings = data.links.tor.listings;
                  urlTypes.push('torlistings');
                }
              }
            }
            // update the defaults but do not save them
            if (!_underscore2.default.findWhere(_defaultSearchProviders2.default, { id: _this2.sProvider.id })) {
              _this2.sProvider.save(update, { urlTypes: urlTypes });
            } else {
              _this2.sProvider.set(update, { urlTypes: urlTypes });
            }
            _this2.setState({
              fetching: false,
              selecting: false,
              data: data,
              searchUrl: searchUrl,
              xhr: ''
            });
          } else {
            _this2.setState({
              fetching: false,
              selecting: false,
              data: '',
              searchUrl: searchUrl,
              xhr: xhr
            });
          }
        }).fail(function (xhr) {
          if (xhr.statusText !== 'abort') {
            _this2.setState({
              fetching: false,
              selecting: false,
              data: '',
              searchUrl: searchUrl,
              xhr: xhr
            });
          }
        });
      }
    }
  }, {
    key: 'showSearchError',
    value: function showSearchError() {
      var _this3 = this;

      var xhr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var title = _app2.default.polyglot.t('search.errors.searchFailTitle', { provider: this.sProvider });
      var failReason = xhr.responseJSON ? xhr.responseJSON.reason : '';
      var msg = failReason ? _app2.default.polyglot.t('search.errors.searchFailReason', { error: failReason }) : '';
      var buttons = [];
      if (this.usingOriginal) {
        buttons.push({
          text: _app2.default.polyglot.t('search.changeProvider'),
          fragment: 'changeProvider'
        });
      } else {
        buttons.push({
          text: _app2.default.polyglot.t('search.useDefault', {
            term: this.term,
            defaultProvider: _app2.default.searchProviders['default' + this.torString + 'Provider']
          }),
          fragment: 'useDefault'
        });
      }

      var errorDialog = new _Dialog2.default({
        title: title,
        msg: msg,
        buttons: buttons,
        showCloseButton: false,
        removeOnClose: true
      }).render().open();
      this.listenTo(errorDialog, 'click-changeProvider', function () {
        errorDialog.close();
      });
      this.listenTo(errorDialog, 'click-useDefault', function () {
        _this3.activateProvider(_app2.default.searchProviders.at(0));
        errorDialog.close();
      });

      (0, _metrics.recordEvent)('Discover_SearchError', {
        error: msg || 'unknown error'
      });
    }
  }, {
    key: 'createResults',
    value: function createResults(data, searchUrl) {
      var _this4 = this;

      this.resultsCol = new _Results4.default();
      this.resultsCol.add(this.resultsCol.parse(data));

      var viewType = 'grid';

      if (data && data.options && data.options.type && data.options.type.options && data.options.type.options.length) {
        if (data.options.type.options.find(function (op) {
          return op.value === 'cryptocurrency' && op.checked;
        })) {
          viewType = 'cryptoList';
        }
      }

      var resultsView = this.createChild(_Results2.default, {
        searchUrl: searchUrl,
        reportsUrl: this.sProvider.get('reports') || '',
        total: data.results ? data.results.total : 0,
        morePages: data.results ? data.results.morePages : false,
        serverPage: this.serverPage,
        pageSize: this.pageSize,
        initCol: this.resultsCol,
        viewType: viewType
      });

      this.$resultsWrapper.html(resultsView.render().el);

      this.listenTo(resultsView, 'searchError', function (xhr) {
        return _this4.showSearchError(xhr);
      });
      this.listenTo(resultsView, 'loadingPage', function () {
        return _this4.scrollToTop();
      });
    }
  }, {
    key: 'clickSearchBtn',
    value: function clickSearchBtn() {
      this.serverPage = 0;
      this.processTerm(this.$searchInput.val());
      (0, _metrics.recordEvent)('Discover_ClickSearch');
    }
  }, {
    key: 'onKeyupSearchInput',
    value: function onKeyupSearchInput(e) {
      if (e.which === 13) {
        this.serverPage = 0;
        this.processTerm(this.$searchInput.val());
        (0, _metrics.recordEvent)('Discover_EnterKeySearch');
      }
    }
  }, {
    key: 'changeSortBy',
    value: function changeSortBy(e) {
      this.sortBySelected = (0, _jquery2.default)(e.target).val();
      this.serverPage = 0;
      this.processTerm(this.term);
      (0, _metrics.recordEvent)('Discover_ChangeSortBy');
    }
  }, {
    key: 'changeFilter',
    value: function changeFilter() {
      this.serverPage = 0;
      this.processTerm(this.term);
      (0, _metrics.recordEvent)('Discover_ChangeFilter');
    }
  }, {
    key: 'onClickSuggestion',
    value: function onClickSuggestion(opts) {
      this.processTerm(opts.suggestion);
      (0, _metrics.recordEvent)('Discover_ClickSuggestion');
    }
  }, {
    key: 'scrollToTop',
    value: function scrollToTop() {
      this.$el[0].scrollIntoView();
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.callSearch) this.callSearch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      var state = this.getState();
      var data = state.data;

      if (data && !state.searchUrl) {
        throw new Error('Please provide the search URL along with the data.');
      }

      var errTitle = void 0;
      var errMsg = void 0;

      // check to see if the call to the provider failed, or returned an empty result
      var emptyData = _jquery2.default.isEmptyObject(data);

      if (state.xhr) {
        errTitle = _app2.default.polyglot.t('search.errors.searchFailTitle', { provider: state.searchUrl });
        var failReason = state.xhr.responseJSON ? state.xhr.responseJSON.reason : '';
        errMsg = failReason ? _app2.default.polyglot.t('search.errors.searchFailReason', { error: failReason }) : '';
      }

      var isDefaultProvider = this.sProvider === _app2.default.searchProviders['default' + this.torString + 'Provider'];

      (0, _loadTemplate2.default)('search/search.html', function (t) {
        _this5.$el.html(t(_extends({
          term: _this5.term === '*' ? '' : _this5.term,
          sortBySelected: _this5.sortBySelected,
          filterParams: _this5.filterParams,
          errTitle: errTitle,
          errMsg: errMsg,
          providerLocked: _this5.sProvider.get('locked'),
          isQueryProvider: _this5.queryProvider,
          isDefaultProvider: isDefaultProvider,
          emptyData: emptyData
        }, state, _this5.sProvider, data)));
      });
      this.$sortBy = this.$('#sortBy');
      this.$sortBy.select2({
        // disables the search box
        minimumResultsForSearch: Infinity,
        templateResult: _utils.selectEmojis,
        templateSelection: _utils.selectEmojis
      });
      var filterWrapper = this.$('.js-filterWrapper');
      filterWrapper.find('select').select2({
        minimumResultsForSearch: 10,
        templateResult: _utils.selectEmojis,
        templateSelection: _utils.selectEmojis
      });
      this.$filters = filterWrapper.find('select, input');
      this.$resultsWrapper = this.$('.js-resultsWrapper');
      this.$searchInput = this.$('.js-searchInput');
      this.$searchLogo = this.$('.js-searchLogo');

      this.$searchLogo.find('img').on('error', function () {
        _this5.$searchLogo.addClass('loadError');
      });

      if (this.searchProviders) this.searchProviders.remove();
      this.searchProviders = this.createChild(_SearchProviders2.default, {
        urlType: this.urlType,
        currentID: this.getCurrentProviderID(),
        selecting: this.mustSelectDefault
      });
      this.listenTo(this.searchProviders, 'activateProvider', function (pOpts) {
        return _this5.activateProvider(pOpts);
      });
      this.$('.js-searchProviders').append(this.searchProviders.render().el);

      if (this.suggestions) this.suggestions.remove();
      this.suggestions = this.createChild(_Suggestions2.default, {
        initialState: {
          suggestions: Array.isArray(data.suggestions) ? data.suggestions : this.defaultSuggestions
        }
      });
      this.listenTo(this.suggestions, 'clickSuggestion', function (opts) {
        return _this5.onClickSuggestion(opts);
      });
      this.$('.js-suggestions').append(this.suggestions.render().el);

      // use the initial set of results data to create the results view
      if (data) this.createResults(data, state.searchUrl);

      return this;
    }
  }, {
    key: 'usingOriginal',
    get: function get() {
      return this.sProvider.id === _defaultSearchProviders2.default[0].id;
    }
  }, {
    key: 'usingTor',
    get: function get() {
      return _app2.default.serverConfig.tor && (0, _serverConnect.getCurrentConnection)().server.get('useTor');
    }
  }, {
    key: 'torString',
    get: function get() {
      return this.usingTor ? 'Tor' : '';
    }
  }, {
    key: 'providerUrl',
    get: function get() {
      // if a provider was created by the address bar query, use it instead.
      // return false if no provider is available
      var currentProvider = this.sProvider;
      return currentProvider && currentProvider.get(this.urlType);
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;