'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../../app');

var _app2 = _interopRequireDefault(_app);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _baseVw2 = require('../../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _loadTemplate = require('../../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _metrics = require('../../../utils/metrics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 This table is re-used for Sales, Purchases and Cases.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var types = ['sales', 'purchases', 'cases'];
    var opts = _extends({
      initialState: {
        acceptOrderInProgress: false,
        rejectOrderInProgress: false,
        cancelOrderInProgress: false
      },
      type: 'sales'
    }, options);

    if (types.indexOf(opts.type) === -1) {
      throw new Error('Please provide a valid type.');
    }

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    if (!_this.model) {
      throw new Error('Please provide a model');
    }

    _this.type = opts.type;
    _this._state = _extends({}, opts.initialState || {});

    _this.$el.toggleClass('unread', !_this.model.get('read'));
    _this.listenTo(_this.model, 'change:read', function (md, read) {
      _this.$el.toggleClass('unread', !read);
    });
    _this.listenTo(_this.model, 'change', function (md) {
      if (md.hasChanged('read') && Object.keys(md.changedAttributes).length === 1) {
        // if the only thing that has changed is the read flag,
        // we'll do nothing since that has it's own handler
        return;
      }

      _this.render();
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'tagName',
    value: function tagName() {
      return 'tr';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-acceptOrder': 'onClickAcceptOrder',
        'click .js-rejectOrder': 'onClickRejectOrder',
        'click .js-cancelOrder': 'onClickCancelOrder',
        'click .js-userCol a': 'onClickUserColLink',
        'click .js-listingCol a': 'onClickListingColLink',
        click: 'onRowClick'
      };
    }
  }, {
    key: 'onClickAcceptOrder',
    value: function onClickAcceptOrder(e) {
      this.trigger('clickAcceptOrder', { view: this });
      e.stopPropagation();
      (0, _metrics.recordEvent)('Transactions_AcceptOrder');
    }
  }, {
    key: 'onClickRejectOrder',
    value: function onClickRejectOrder(e) {
      this.trigger('clickRejectOrder', { view: this });
      e.stopPropagation();
      (0, _metrics.recordEvent)('Transactions_RejectOrder');
    }
  }, {
    key: 'onClickCancelOrder',
    value: function onClickCancelOrder(e) {
      this.trigger('clickCancelOrder', { view: this });
      e.stopPropagation();
      (0, _metrics.recordEvent)('Transactions_CancelOrder');
    }
  }, {
    key: 'onClickUserColLink',
    value: function onClickUserColLink(e) {
      e.stopPropagation();
      (0, _metrics.recordEvent)('Transactions_ClickUser');
    }
  }, {
    key: 'onClickListingColLink',
    value: function onClickListingColLink(e) {
      e.stopPropagation();
      (0, _metrics.recordEvent)('Transactions_ClickListing');
    }
  }, {
    key: 'onRowClick',
    value: function onRowClick() {
      this.trigger('clickRow', { view: this });
      (0, _metrics.recordEvent)('Transactions_ClickOrder');
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var replace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var newState = void 0;

      if (replace) {
        this._state = {};
      } else {
        newState = _underscore2.default.extend({}, this._state, state);
      }

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        this.render();
      }

      return this;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('transactions/table/row.html', function (t) {
        _this2.$el.html(t(_extends({
          type: _this2.type
        }, _this2._state, _this2.model.toJSON(), {
          userCurrency: _app2.default.settings.get('localCurrency'),
          moment: _moment2.default,
          vendorId: _this2.type === 'sales' ? _app2.default.profile.id : _this2.model.get('vendorId')
        })));
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;