'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var opts = _extends({}, options);

    opts.initialState = _extends({
      categories: [],
      selected: 'all',
      expanded: false,
      maxInitiallyVisibleCats: 6
    }, options.initialState || {});

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;
    _this._state = opts.initialState;
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'clrP clrBr padMd clrT contentBox clrSh2 form veryCompact categoryFilter';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-showMoreLess': 'onClickShowMoreLess',
        'change input[type="radio"]': 'onChangeCategory'
      };
    }
  }, {
    key: 'onClickShowMoreLess',
    value: function onClickShowMoreLess() {
      this.setState({ expanded: !this.getState().expanded });
    }
  }, {
    key: 'onChangeCategory',
    value: function onChangeCategory(e) {
      this._state.selected = e.target.value;
      this.trigger('category-change', { value: (0, _jquery2.default)(e.target).val() });
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this._state;
    }
  }, {
    key: 'setState',
    value: function setState() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var newState = _extends({}, this._state, state);

      if (!_underscore2.default.isEqual(this._state, newState)) {
        this._state = newState;
        if (this.rendered) this.render();
      }
    }
  }, {
    key: 'replaceState',
    value: function replaceState() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!_underscore2.default.isEqual(this._state, state)) {
        this._state = state;
        if (this.rendered) this.render();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      (0, _loadTemplate2.default)('userPage/categoryFilter.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2._state)));
      });

      this.rendered = true;

      return this;
    }
  }, {
    key: 'selectedCat',
    get: function get() {
      return this._selected;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;