'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _electron = require('electron');

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _UserCard = require('../UserCard');

var _UserCard2 = _interopRequireDefault(_UserCard);

var _modalManager = require('../../utils/modalManager');

var _SimpleMessage = require('../modals/SimpleMessage');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    _this.options = options;
    _this.ownPage = options.ownPage;
    _this.userCard = _this.createChild(_UserCard2.default, { model: _this.model });
    _this.settings = _app2.default.settings.clone();

    _this.listenTo(_this.settings, 'sync', function () {
      _app2.default.settings.set(_this.settings.toJSON());
    });

    _this.listenTo(_app2.default.settings, 'change:storeModerators', function () {
      _this.$addModerator.toggleClass('hide', _this.ownMod);
      _this.$removeModerator.toggleClass('hide', !_this.ownMod);
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'userPageHome';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-termsLink': 'termsClick',
        'click .js-addModerator': 'addModeratorClick',
        'click .js-removeModerator': 'removeModeratorClick',
        'click .js-guid': 'guidClick',
        'mouseleave .js-guid': 'guidLeave'
      };
    }
  }, {
    key: 'termsClick',
    value: function termsClick() {
      var _this2 = this;

      // show the moderator details modal
      var modModal = (0, _modalManager.launchModeratorDetailsModal)({ model: this.model });
      this.listenTo(modModal, 'addAsModerator', function () {
        _this2.$addModerator.addClass('processing');
        _this2.saveModeratorList(true);
      });
    }
  }, {
    key: 'addModeratorClick',
    value: function addModeratorClick() {
      var _this3 = this;

      // show the moderator details modal
      var modModal = (0, _modalManager.launchModeratorDetailsModal)({ model: this.model });
      this.listenTo(modModal, 'addAsModerator', function () {
        _this3.$addModerator.addClass('processing');
        _this3.saveModeratorList(true);
      });
    }
  }, {
    key: 'removeModeratorClick',
    value: function removeModeratorClick() {
      this.$removeModerator.addClass('processing');
      this.saveModeratorList(false);
    }
  }, {
    key: 'saveModeratorList',
    value: function saveModeratorList() {
      var _this4 = this;

      var add = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      // clone the array, otherwise it is a reference
      var modList = _underscore2.default.clone(_app2.default.settings.get('storeModerators'));

      if (add && !this.ownMod) {
        modList.push(this.model.id);
      } else {
        modList = _underscore2.default.without(modList, this.model.id);
      }

      var formData = { storeModerators: modList };
      this.settings.set(formData);

      if (!this.settings.validationError) {
        this.settings.save(formData, {
          attrs: formData,
          type: 'PATCH'
        }).fail(function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var errMsg = args[0] && args[0].responseJSON && args[0].responseJSON.reason || '';
          var phrase = add ? 'userPage.modAddError' : 'userPage.modRemoveError';
          (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t(phrase), { errMsg: errMsg });
        }).always(function () {
          _this4.$modBtn.removeClass('processing');
        });
      }
    }
  }, {
    key: 'guidClick',
    value: function guidClick(e) {
      var guid = (0, _jquery2.default)(e.target).data('guid');
      _electron.clipboard.writeText(guid);
      this.$('.js-guidCopied').fadeIn(600);
    }
  }, {
    key: 'guidLeave',
    value: function guidLeave() {
      this.$('.js-guidCopied').fadeOut(600);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      (0, _loadTemplate2.default)('userPage/home.html', function (t) {
        _this5.$el.html(t(_extends({
          currentModerator: _this5.ownMod,
          displayCurrency: _app2.default.settings.get('localCurrency')
        }, _this5.model.toJSON())));

        _this5.$('.js-userCard').append(_this5.userCard.render().$el);

        _this5.$modBtn = _this5.$('.js-addModerator, .js-removeModerator');
        _this5.$addModerator = _this5.$('.js-addModerator');
        _this5.$removeModerator = _this5.$('.js-removeModerator');
      });

      return this;
    }
  }, {
    key: 'ownMod',
    get: function get() {
      return _app2.default.settings.ownMod(this.model.id);
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;