'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LISTINGS_PER_PAGE = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _ListingCard = require('../ListingCard');

var _ListingCard2 = _interopRequireDefault(_ListingCard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    // If this grid is for a Store, pass in a storeOwnerProfile option
    // with the Profile model of the store owner.
    var opts = _extends({
      viewType: _app2.default.localSettings.get('listingsGridViewType')
    }, options);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    if (!_this.collection) {
      throw new Error('Please provide a collection.');
    }

    if (!_this.options.listingBaseUrl && !_this.options.storeOwnerProfile) {
      var allHaveVendor = true;

      try {
        _this.collection.forEach(function (md) {
          if (!md.get('vendor')) throw new Error();
        });
      } catch (e) {
        allHaveVendor = false;
      }

      if (!allHaveVendor) {
        throw new Error('I am unable to determine a listingBaseUrl for one or more of the ' + 'provided listings. Please either pass in a listingBaseUrl option or it can be ' + 'derived if you provid a storeOwnerProfile option or every model has an embedded ' + ' Vendor object.');
      }
    }

    _this.viewType = opts.viewType;
    _this.listingCardViews = [];

    _this.listenTo(_this.collection, 'update', function (updatedCl, updateOpts) {
      // The only updates we're expecting are a new "page" of
      // listings being added to the end of the collection.
      if (updateOpts.add) {
        _this.renderListingCards(updateOpts.changes.added);
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'listingsGrid flex';
    }
  }, {
    key: 'createListingCardView',
    value: function createListingCardView(model) {
      var listingBaseUrl = void 0;

      // The listingBaseUrl can be directly provided as an option or we
      // will attempt to derive it from a passed in Profile model or
      // Vendor information in the listing short models.
      if (this.options.listingBaseUrl) {
        listingBaseUrl = this.options.listingBaseUrl;
      } else if (model.get('vendor')) {
        var base = model.get('vendor').handle ? '@' + model.get('vendor').handle : model.get('vendor').peerID;
        listingBaseUrl = base + '/store/';
      } else if (this.options.storeOwnerProfile) {
        var _base = this.options.storeOwnerProfile.get('handle') ? '@' + this.options.storeOwnerProfile.get('handle') : this.options.storeOwnerProfile.id;
        listingBaseUrl = _base + '/store/';
      }

      var options = {
        listingBaseUrl: listingBaseUrl,
        viewType: this.viewType,
        model: model
      };

      if (this.options.storeOwnerProfile) {
        options.profile = this.options.storeOwnerProfile;
        // Flag so the listing card knows it's on a store. This is useful to
        // the listing detail modal and will be passed into there.
        options.onStore = true;
      }

      return this.createChild(_ListingCard2.default, options);
    }
  }, {
    key: 'renderListingCards',
    value: function renderListingCards() {
      var _this2 = this;

      var models = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var listingsFrag = document.createDocumentFragment();

      models.forEach(function (model) {
        // In the proposed search API, vendor info will be provided in the
        // search results. If that's the case we'll pass it to the listing
        // card view.
        var listingCardVw = _this2.createListingCardView(model);

        _this2.listingCardViews.push(listingCardVw);
        listingCardVw.render().$el.appendTo(listingsFrag);
      });

      this.$el.append(listingsFrag);
    }
  }, {
    key: 'render',
    value: function render() {
      this.$el[this.viewType === 'list' ? 'addClass' : 'removeClass']('listingsGridListView');
      this.listingCardViews.forEach(function (vw) {
        return vw.remove();
      });
      this.listingCardViews = [];
      this.$el.empty();
      this.renderListingCards(this.collection);

      return this;
    }
  }, {
    key: 'viewType',
    get: function get() {
      return this._viewType;
    },
    set: function set(type) {
      if (['list', 'grid'].indexOf(type) === '-1') {
        throw new Error('The type provided is not one of the available types.');
      }

      // This just sets the flag. It's up to you to re-render to update the UI.
      this._viewType = type;
      _app2.default.localSettings.save('listingsGridViewType', type);
    }
  }, {
    key: 'listingCount',
    get: function get() {
      return this.listingCardViews ? this.listingCardViews.length : 0;
    }
  }]);

  return _class;
}(_baseVw2.default);

// Standard width grid has 3 columns, so best to leave this
// as a multiple of 3.


exports.default = _class;
var LISTINGS_PER_PAGE = exports.LISTINGS_PER_PAGE = 24;