'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _baseVw = require('../baseVw');

var _baseVw2 = _interopRequireDefault(_baseVw);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _Reviews = require('../reviews/Reviews');

var _Reviews2 = _interopRequireDefault(_Reviews);

var _SimpleMessage = require('../modals/SimpleMessage');

var _Profile = require('../../models/profile/Profile');

var _Profile2 = _interopRequireDefault(_Profile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_BaseVw) {
  _inherits(_class, _BaseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    if (!options.model || !(options.model instanceof _Profile2.default)) {
      throw new Error('Please provide a valid profile model.');
    }
    var opts = _extends({}, options, {
      initialState: _extends({
        isFetching: true
      }, options.initialState || {})
    });

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, opts));

    _this.options = opts;

    // create the reviews here, so they're available for the fetch
    _this.reviews = _this.createChild(_Reviews2.default, {
      async: true,
      initialPageSize: 5,
      pageSize: 5,
      initialState: {
        isFetchingRatings: true
      }
    });

    // fetch the ratings immediately. They are asyncronous, and should not be refetched
    // if the view re-renders.
    _this.ratingsFetch = _jquery2.default.get(_app2.default.getServerUrl('ob/ratings/' + _this.options.model.get('peerID'))).done(function (data) {
      return _this.onRatings(data);
    }).fail(function (jqXhr) {
      if (jqXhr.statusText === 'abort') return;
      var failReason = jqXhr.responseJSON && jqXhr.responseJSON.reason || '';
      (0, _SimpleMessage.openSimpleMessage)(_app2.default.polyglot.t('listingDetail.errors.fetchRatings'), failReason);
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'userPageReputation';
    }
  }, {
    key: 'onRatings',
    value: function onRatings(data) {
      var pData = data || {};
      this.setState(_extends({
        isFetching: false
      }, pData));
      this.reviews.reviewIDs = pData.ratings || [];
      this.reviews.setState({ isFetchingRatings: false });
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.ratingsFetch) this.ratingsFetch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('userPage/reputation.html', function (t) {
        _this2.$el.html(t(_extends({}, _this2.getState())));
        _this2.delegateEvents(_this2.reviews);
        _this2.getCachedEl('.js-reviews').append(_this2.reviews.render().$el);
      });

      return this;
    }
  }]);

  return _class;
}(_baseVw2.default);

exports.default = _class;