'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _baseVw2 = require('../baseVw');

var _baseVw3 = _interopRequireDefault(_baseVw2);

var _loadTemplate = require('../../utils/loadTemplate');

var _loadTemplate2 = _interopRequireDefault(_loadTemplate);

var _app = require('../../app');

var _app2 = _interopRequireDefault(_app);

var _follow = require('../../utils/follow');

var _utils = require('../../utils');

var _string = require('../../utils/string');

var _responsive = require('../../utils/responsive');

var _modalManager = require('../../utils/modalManager');

var _block = require('../../utils/block');

var _serverConnect = require('../../utils/serverConnect');

var _Listing = require('../../models/listing/Listing');

var _Listing2 = _interopRequireDefault(_Listing);

var _Listings = require('../../collections/Listings');

var _Listings2 = _interopRequireDefault(_Listings);

var _Followers = require('../../collections/Followers');

var _Followers2 = _interopRequireDefault(_Followers);

var _MiniProfile = require('../MiniProfile');

var _MiniProfile2 = _interopRequireDefault(_MiniProfile);

var _SocialBtns = require('../components/SocialBtns');

var _SocialBtns2 = _interopRequireDefault(_SocialBtns);

var _Home = require('./Home');

var _Home2 = _interopRequireDefault(_Home);

var _Store = require('./Store');

var _Store2 = _interopRequireDefault(_Store);

var _Follow = require('./Follow');

var _Follow2 = _interopRequireDefault(_Follow);

var _Reputation = require('./Reputation');

var _Reputation2 = _interopRequireDefault(_Reputation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_baseVw) {
  _inherits(_class, _baseVw);

  function _class() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, options));

    if (!options.model) {
      throw new Error('Please provide a user model.');
    }

    _this.options = options;
    _this.ownPage = _this.model.id === _app2.default.profile.id;
    _this.state = options.state || 'store';
    _this.tabViewCache = {};
    _this.tabViews = { Home: _Home2.default, Store: _Store2.default, Follow: _Follow2.default, Reputation: _Reputation2.default };

    var stats = _this.model.get('stats');
    _this._followingCount = stats.get('followingCount');
    _this._followerCount = stats.get('followerCount');

    if (!_this.ownPage) {
      if (_this._followerCount === 0 && _app2.default.ownFollowing.indexOf(_this.model.id) > -1) {
        _this._followerCount = 1;
      }
    } else {
      _this._followingCount = _app2.default.ownFollowing.length;
    }

    _this.listenTo(_this.model.get('headerHashes'), 'change', function () {
      return _this.updateHeader();
    });

    _this.curConn = (0, _serverConnect.getCurrentConnection)();

    if (_this.curConn && _this.curConn.server) {
      _this.showStoreWelcomeCallout = !_this.curConn.server.get('dismissedStoreWelcome');
    }

    _this.listenTo(_app2.default.ownFollowing, 'add', _this.onOwnFollowingAdd);
    _this.listenTo(_app2.default.ownFollowing, 'remove', _this.onOwnFollowingRemove);

    _this.followsYou = false;
    (0, _follow.followsYou)(_this.model.id).done(function (data) {
      if (_this.miniProfile) {
        _this.miniProfile.setState({ followsYou: data.followsMe });
      }

      if (_this.followingCount === 0 && !_this.ownPage) _this.followingCount = 1;
    });

    _this.listenTo(_block.events, 'blocked unblocked', function (data) {
      if (data.peerIds.includes(_this.model.id)) {
        _this.setBlockedClass();
      }
    });
    return _this;
  }

  _createClass(_class, [{
    key: 'className',
    value: function className() {
      return 'userPage clrS';
    }
  }, {
    key: 'events',
    value: function events() {
      return {
        'click .js-tab': 'clickTab',
        'click .js-moreBtn': 'clickMore',
        'click .js-customize': 'clickCustomize',
        'click .js-createListing': 'clickCreateListing',
        'click .js-closeStoreWelcomeCallout': 'clickCloseStoreWelcomeCallout'
      };
    }
  }, {
    key: 'onOwnFollowingAdd',
    value: function onOwnFollowingAdd(md) {
      if (this.ownPage) {
        this.followingCount += 1;
      } else if (md.id === this.model.id) {
        this.followerCount += 1;
      }
    }
  }, {
    key: 'onOwnFollowingRemove',
    value: function onOwnFollowingRemove(md) {
      if (this.ownPage) {
        this.followingCount -= 1;
      } else if (md.id === this.model.id) {
        this.followerCount -= 1;
      }
    }
  }, {
    key: 'clickTab',
    value: function clickTab(e) {
      var targ = (0, _jquery2.default)(e.target).closest('.js-tab');
      this.setState(targ.attr('data-tab'));
    }
  }, {
    key: 'clickMore',
    value: function clickMore() {
      this.$moreableBtns.toggleClass('hide');
    }
  }, {
    key: 'clickCustomize',
    value: function clickCustomize() {
      (0, _modalManager.launchSettingsModal)({ initialTab: 'Page' });
    }
  }, {
    key: 'clickCreateListing',
    value: function clickCreateListing() {
      var listingModel = new _Listing2.default({}, { guid: _app2.default.profile.id });

      (0, _modalManager.launchEditListingModal)({
        model: listingModel
      });
    }
  }, {
    key: 'clickCloseStoreWelcomeCallout',
    value: function clickCloseStoreWelcomeCallout() {
      if (this.curConn && this.curConn.server) {
        this.curConn.server.save({ dismissedStoreWelcome: true });
        this.getCachedEl('.js-storeWelcomeCallout').remove();
      }
    }
  }, {
    key: 'clickRating',
    value: function clickRating() {
      this.setState('reputation');
    }
  }, {
    key: 'setBlockedClass',
    value: function setBlockedClass() {
      this.$el.toggleClass('isBlocked', (0, _block.isBlocked)(this.model.id));
    }
  }, {
    key: 'updateHeader',
    value: function updateHeader() {
      var headerHashes = this.model.get('headerHashes').toJSON();
      var headerHash = (0, _responsive.isHiRez)() ? headerHashes.large : headerHashes.medium;

      if (headerHash) {
        this.$('.js-header').attr('style', 'background-image: url(' + _app2.default.getServerUrl('ob/images/' + headerHash) + '), \n      url(\'../imgs/defaultHeader.png\')');
      }
    }
  }, {
    key: 'createFollowersTabView',
    value: function createFollowersTabView() {
      var _this2 = this;

      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var collection = new _Followers2.default([], {
        peerId: this.model.id,
        type: 'followers'
      });

      this.listenTo(collection, 'sync', function () {
        return _this2.followerCount = collection.length;
      });

      return this.createChild(this.tabViews.Follow, _extends({}, opts, {
        followType: 'followers',
        peerId: this.model.id,
        collection: collection
      }));
    }
  }, {
    key: 'createFollowingTabView',
    value: function createFollowingTabView() {
      var _this3 = this;

      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var models = _app2.default.profile.id === this.model.id ? _app2.default.ownFollowing.models : [];
      var collection = new _Followers2.default(models, {
        peerId: this.model.id,
        type: 'following',
        fetchCollection: _app2.default.profile.id !== this.model.id
      });

      this.listenTo(collection, 'sync', function () {
        return _this3.followingCount = collection.length;
      });

      return this.createChild(this.tabViews.Follow, _extends({}, opts, {
        followType: 'following',
        peerId: this.model.id,
        collection: collection
      }));
    }
  }, {
    key: 'createStoreTabView',
    value: function createStoreTabView() {
      var _this4 = this;

      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      this.listings = new _Listings2.default([], { guid: this.model.id });

      var listingsCount = this.model.get('listingCount');

      this.listings.on('update', function () {
        if (_this4.listings.length !== listingsCount) {
          listingsCount = _this4.listings.length;
          _this4.$listingsCount.html((0, _utils.abbrNum)(listingsCount));
        }
      });

      return this.createChild(this.tabViews.Store, _extends({}, opts, {
        initialFetch: this.listings.fetch(),
        collection: this.listings,
        model: this.model
      }));
    }
  }, {
    key: 'setState',
    value: function setState(state) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!state) {
        throw new Error('Please provide a state.');
      }

      this.state = state;
      this.selectTab(state, options);
    }
  }, {
    key: 'selectTab',
    value: function selectTab(targ) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var opts = _extends({
        addTabToHistory: true
      }, options);

      if (!this.tabViews[(0, _string.capitalize)(targ)] && targ !== 'following' && targ !== 'followers') {
        throw new Error(targ + ' is not a valid tab.');
      }

      var tabView = this.tabViewCache[targ];
      var tabOptions = _extends({
        ownPage: this.ownPage,
        model: this.model
      }, opts);

      // delete any opts that the tab view(s) wouldn't need
      delete tabOptions.addTabToHistory;

      if (!this.currentTabView || this.currentTabView !== tabView) {
        var tabName = _app2.default.polyglot.t('userPage.tabTitles.' + targ);
        this.$tabTitle.text(tabName);

        if (opts.addTabToHistory) {
          var listingBaseUrl = this.model.get('handle') ? '@' + this.model.get('handle') : this.model.id;

          // add tab to history
          _app2.default.router.navigateUser(listingBaseUrl + '/' + targ.toLowerCase(), this.model.id);
        }

        this.$('.js-tab').removeClass('clrT active');
        this.$('.js-tab[data-tab="' + targ + '"]').addClass('clrT active');

        if (this.currentTabView) this.currentTabView.$el.detach();

        if (!tabView) {
          if (this['create' + (0, _string.capitalize)(targ) + 'TabView']) {
            tabView = this['create' + (0, _string.capitalize)(targ) + 'TabView'](tabOptions);
          } else {
            tabView = this.createChild(this.tabViews[(0, _string.capitalize)(targ)], tabOptions);
          }

          this.tabViewCache[targ] = tabView;
          tabView.render();
        }

        this.$tabContent.append(tabView.$el);
        this.currentTabView = tabView;
      }
    }
  }, {
    key: 'remove',
    value: function remove() {
      if (this.followingFetch) this.followingFetch.abort();
      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'remove', this).call(this);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this);
      (0, _loadTemplate2.default)('userPage/userPage.html', function (t) {
        _this5.$el.html(t(_extends({}, _this5.model.toJSON(), {
          ownPage: _this5.ownPage,
          showStoreWelcomeCallout: _this5.showStoreWelcomeCallout,
          followingCount: _this5.followingCount,
          followerCount: _this5.followerCount
        })));

        _this5.$tabContent = _this5.$('.js-tabContent');
        _this5.$tabTitle = _this5.$('.js-tabTitle');
        _this5.$moreableBtns = _this5.$('.js-moreableBtn');
        _this5._$pageContent = null;
        _this5._$listingsCount = null;

        if (_this5.miniProfile) _this5.miniProfile.remove();
        _this5.miniProfile = _this5.createChild(_MiniProfile2.default, {
          model: _this5.model,
          fetchFollowsYou: false,
          onClickRating: function onClickRating() {
            return _this5.setState('reputation');
          },
          initialState: {
            followsYou: _this5.followsYou
          }
        });
        _this5.listenTo(_this5.miniProfile, 'clickRating', _this5.clickRating);
        _this5.$('.js-miniProfileContainer').html(_this5.miniProfile.render().el);

        if (!_this5.ownPage) {
          if (_this5.socialBtns) _this5.socialBtns.remove();
          _this5.socialBtns = _this5.createChild(_SocialBtns2.default, {
            targetID: _this5.model.id
          });
          _this5.$('.js-socialBtns').append(_this5.socialBtns.render().$el);
        }

        _this5.tabViewCache = {}; // clear for re-renders
        _this5.setState(_this5.state, {
          addTabToHistory: false,
          listing: _this5.options.listing
        });

        _this5.setBlockedClass();
      });

      return this;
    }
  }, {
    key: 'followingCount',
    get: function get() {
      return this._followingCount;
    },
    set: function set(count) {
      if (typeof count !== 'number') {
        throw new Error('Please provide a numeric count.');
      }

      if (count !== this._followingCount) {
        this._followingCount = count;
        this.getCachedEl('.js-followingCount').text(count);
      }
    }
  }, {
    key: 'followerCount',
    get: function get() {
      return this._followerCount;
    },
    set: function set(count) {
      if (typeof count !== 'number') {
        throw new Error('Please provide a numeric count.');
      }

      if (count !== this._followerCount) {
        this._followerCount = count;
        this.getCachedEl('.js-followerCount').text(count);
      }
    }
  }, {
    key: '$pageContent',
    get: function get() {
      return this._$pageContent || (this._$pageContent = this.$('.js-pageContent'));
    }
  }, {
    key: '$listingsCount',
    get: function get() {
      return this._$listingsCount || (this._$listingsCount = this.$('.js-listingsCount'));
    }
  }]);

  return _class;
}(_baseVw3.default);

exports.default = _class;